/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],Z=function(q){for(var e=[],w=0,t=q.length;w<t;w++)e[w]=J[q[w]];return e};define(J[120],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function w(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=w;function t(k,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(J[121],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(D){return D?D.replace(/\$\((.*?)\)/g,(y,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=w;class t{constructor(y,u,m){this.id=y,this.definition=u,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,y){const u=["codicon","codicon-"+D];return y&&u.push("codicon-modifier-"+y),u}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(I){if(I instanceof t)return["codicon","codicon-"+I.id];const v=y.exec(I.id);if(!v)return u(t.error);const[,g,d]=v,E=["codicon","codicon-"+g];return d&&E.push("codicon-modifier-"+d.substr(1)),E}D.asClassNameArray=u;function m(I){return u(I).join(" ")}D.asClassName=m;function C(I){return"."+u(I).join(".")}D.asCSSSelector=C})(R=e.CSSIcon||(e.CSSIcon={}))}),define(J[122],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function w(y,u){const m=Math.pow(10,u);return Math.round(y*m)/m}class t{constructor(u,m,C,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=w(Math.max(Math.min(1,I),0),3)}static equals(u,m){return u.r===m.r&&u.g===m.g&&u.b===m.b&&u.a===m.a}}e.RGBA=t;class k{constructor(u,m,C,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.l=w(Math.max(Math.min(1,C),0),3),this.a=w(Math.max(Math.min(1,I),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.l===m.l&&u.a===m.a}static fromRGBA(u){const m=u.r/255,C=u.g/255,I=u.b/255,v=u.a,g=Math.max(m,C,I),d=Math.min(m,C,I);let E=0,b=0;const p=(d+g)/2,S=g-d;if(S>0){switch(b=Math.min(p<=.5?S/(2*p):S/(2-2*p),1),g){case m:E=(C-I)/S+(C<I?6:0);break;case C:E=(I-m)/S+2;break;case I:E=(m-C)/S+4;break}E*=60,E=Math.round(E)}return new k(E,b,p,v)}static _hue2rgb(u,m,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?u+(m-u)*6*C:C<1/2?m:C<2/3?u+(m-u)*(2/3-C)*6:u}static toRGBA(u){const m=u.h/360,{s:C,l:I,a:v}=u;let g,d,E;if(C===0)g=d=E=I;else{const b=I<.5?I*(1+C):I+C-I*C,p=2*I-b;g=k._hue2rgb(p,b,m+1/3),d=k._hue2rgb(p,b,m),E=k._hue2rgb(p,b,m-1/3)}return new t(Math.round(g*255),Math.round(d*255),Math.round(E*255),v)}}e.HSLA=k;class R{constructor(u,m,C,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.v=w(Math.max(Math.min(1,C),0),3),this.a=w(Math.max(Math.min(1,I),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.v===m.v&&u.a===m.a}static fromRGBA(u){const m=u.r/255,C=u.g/255,I=u.b/255,v=Math.max(m,C,I),g=Math.min(m,C,I),d=v-g,E=v===0?0:d/v;let b;return d===0?b=0:v===m?b=((C-I)/d%6+6)%6:v===C?b=(I-m)/d+2:b=(m-C)/d+4,new R(Math.round(b*60),E,v,u.a)}static toRGBA(u){const{h:m,s:C,v:I,a:v}=u,g=I*C,d=g*(1-Math.abs(m/60%2-1)),E=I-g;let[b,p,S]=[0,0,0];return m<60?(b=g,p=d):m<120?(b=d,p=g):m<180?(p=g,S=d):m<240?(p=d,S=g):m<300?(b=d,S=g):m<=360&&(b=g,S=d),b=Math.round((b+E)*255),p=Math.round((p+E)*255),S=Math.round((S+E)*255),new t(b,p,S,v)}}e.HSVA=R;class D{constructor(u){if(u)if(u instanceof t)this.rgba=u;else if(u instanceof k)this._hsla=u,this.rgba=k.toRGBA(u);else if(u instanceof R)this._hsva=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(u){return!!u&&t.equals(this.rgba,u.rgba)&&k.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),m=D._relativeLuminanceForComponent(this.rgba.g),C=D._relativeLuminanceForComponent(this.rgba.b),I=.2126*u+.7152*m+.0722*C;return w(I,4)}static _relativeLuminanceForComponent(u){const m=u/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(u){const m=this.getRelativeLuminance(),C=u.getRelativeLuminance();return m>C?(m+.05)/(C+.05):(C+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const m=this.getRelativeLuminance(),C=u.getRelativeLuminance();return m>C}isDarkerThan(u){const m=this.getRelativeLuminance(),C=u.getRelativeLuminance();return m<C}lighten(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:m,g:C,b:I,a:v}=this.rgba;return new D(new t(m,C,I,v*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const m=u.rgba,C=this.rgba.a,I=m.a,v=C+I*(1-C);if(v<1e-6)return D.transparent;const g=this.rgba.r*C/v+m.r*I*(1-C)/v,d=this.rgba.g*C/v+m.g*I*(1-C)/v,E=this.rgba.b*C/v+m.b*I*(1-C)/v;return new D(new t(g,d,E,v))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:m,g:C,b:I,a:v}=this.rgba;return new D(new t(u.rgba.r-v*(u.rgba.r-m),u.rgba.g-v*(u.rgba.g-C),u.rgba.b-v*(u.rgba.b-I),1))}flatten(...u){const m=u.reduceRight((C,I)=>D._flatten(I,C));return D._flatten(this,m)}static _flatten(u,m){const C=1-u.rgba.a;return new D(new t(C*m.rgba.r+u.rgba.a*u.rgba.r,C*m.rgba.g+u.rgba.a*u.rgba.g,C*m.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,m,C){if(u.isLighterThan(m))return u;C=C||.5;const I=u.getRelativeLuminance(),v=m.getRelativeLuminance();return C=C*(v-I)/v,u.lighten(C)}static getDarkerColor(u,m,C){if(u.isDarkerThan(m))return u;C=C||.5;const I=u.getRelativeLuminance(),v=m.getRelativeLuminance();return C=C*(I-v)/I,u.darken(C)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(y){let u;(function(m){let C;(function(I){function v(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:y.Format.CSS.formatRGBA(i)}I.formatRGB=v;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}I.formatRGBA=g;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(i)}I.formatHSL=d;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}I.formatHSLA=E;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function p(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}I.formatHex=p;function S(i,o=!1){return o&&i.rgba.a===1?y.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}I.formatHexA=S;function f(i){return i.isOpaque()?y.Format.CSS.formatHex(i):y.Format.CSS.formatRGBA(i)}I.format=f;function h(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const n=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),r=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),s=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new y(new t(n,r,s,1))}if(o===9){const n=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),r=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),s=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),a=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new y(new t(n,r,s,a/255))}if(o===4){const n=c(i.charCodeAt(1)),r=c(i.charCodeAt(2)),s=c(i.charCodeAt(3));return new y(new t(16*n+n,16*r+r,16*s+s))}if(o===5){const n=c(i.charCodeAt(1)),r=c(i.charCodeAt(2)),s=c(i.charCodeAt(3)),a=c(i.charCodeAt(4));return new y(new t(16*n+n,16*r+r,16*s+s,(16*a+a)/255))}return null}I.parseHex=h;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=m.CSS||(m.CSS={}))})(u=y.Format||(y.Format={}))}(D=e.Color||(e.Color={}))}),define(J[52],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(D){return(y,u,m)=>{let C=null,I=null;if(typeof m.value=="function"?(C="value",I=m.value):typeof m.get=="function"&&(C="get",I=m.get),!I)throw new Error("not supported");m[C]=D(I,u)}}e.createDecorator=w;function t(D,y,u){let m=null,C=null;if(typeof u.value=="function"?(m="value",C=u.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(m="get",C=u.get),!C)throw new Error("not supported");const I=`$memoize$${y}`;u[m]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[I]}}e.memoize=t;function k(D,y,u){return w((m,C)=>{const I=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...g){this[v]||(this[v]=u?u():void 0),clearTimeout(this[I]),y&&(this[v]=y(this[v],...g),g=[this[v]]),this[I]=setTimeout(()=>{m.apply(this,g),this[v]=u?u():void 0},D)}})}e.debounce=k;function R(D,y,u){return w((m,C)=>{const I=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,g=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...E){if(this[v]||(this[v]=u?u():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),y&&(this[v]=y(this[v],...E)),this[d])return;const b=this[g]+D;b<=Date.now()?(this[g]=Date.now(),m.apply(this,[this[v]]),this[v]=u?u():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),m.apply(this,[this[v]]),this[v]=u?u():void 0},b-Date.now()))}})}e.throttle=R}),define(J[18],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?f.isErrorNoTelemetry(i)?new f(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=w,e.errorHandler=new w;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){u(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){u(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:i,message:o}=c,n=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const y="Canceled";function u(c){return c instanceof m?!0:c instanceof Error&&c.name===y&&c.message===y}e.isCancellationError=u;class m extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=m;function C(){const c=new Error(y);return c.name=c.message,c}e.canceled=C;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=v;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=E;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class f extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof f)return i;const o=new f;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class h extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(J[24],Z([0,1,18]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,te=0){return j[j.length-(1+te)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,te,ie=(ce,fe)=>ce===fe){if(j===te)return!0;if(!j||!te||j.length!==te.length)return!1;for(let ce=0,fe=j.length;ce<fe;ce++)if(!ie(j[ce],te[ce]))return!1;return!0}e.equals=R;function D(j,te){const ie=j.length-1;te<ie&&(j[te]=j[ie]),j.pop()}e.removeFastWithoutKeepingOrder=D;function y(j,te,ie){return u(j.length,ce=>ie(j[ce],te))}e.binarySearch=y;function u(j,te){let ie=0,ce=j-1;for(;ie<=ce;){const fe=(ie+ce)/2|0,ke=te(fe);if(ke<0)ie=fe+1;else if(ke>0)ce=fe-1;else return fe}return-(ie+1)}e.binarySearch2=u;function m(j,te){let ie=0,ce=j.length;if(ce===0)return 0;for(;ie<ce;){const fe=Math.floor((ie+ce)/2);te(j[fe])?ce=fe:ie=fe+1}return ie}e.findFirstInSorted=m;function C(j,te,ie){if(j=j|0,j>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],fe=[],ke=[],Le=[];for(const Pe of te){const Ae=ie(Pe,ce);Ae<0?fe.push(Pe):Ae>0?ke.push(Pe):Le.push(Pe)}return j<fe.length?C(j,fe,ie):j<fe.length+Le.length?Le[0]:C(j-(fe.length+Le.length),ke,ie)}e.quickSelect=C;function I(j,te){const ie=[];let ce;for(const fe of j.slice(0).sort(te))!ce||te(ce[0],fe)!==0?(ce=[fe],ie.push(ce)):ce.push(fe);return ie}e.groupBy=I;function v(j,te,ie){const ce=[];function fe(Pe,Ae,Ke){if(Ae===0&&Ke.length===0)return;const me=ce[ce.length-1];me&&me.start+me.deleteCount===Pe?(me.deleteCount+=Ae,me.toInsert.push(...Ke)):ce.push({start:Pe,deleteCount:Ae,toInsert:Ke})}let ke=0,Le=0;for(;;){if(ke===j.length){fe(ke,0,te.slice(Le));break}if(Le===te.length){fe(ke,j.length-ke,[]);break}const Pe=j[ke],Ae=te[Le],Ke=ie(Pe,Ae);Ke===0?(ke+=1,Le+=1):Ke<0?(fe(ke,1,[]),ke+=1):Ke>0&&(fe(ke,0,[Ae]),Le+=1)}return ce}e.sortedDiff=v;function g(j,te,ie){const ce=v(j,te,ie),fe=[],ke=[];for(const Le of ce)fe.push(...j.slice(Le.start,Le.start+Le.deleteCount)),ke.push(...Le.toInsert);return{removed:fe,added:ke}}e.delta=g;function d(j,te,ie){if(ie===0)return[];const ce=j.slice(0,ie).sort(te);return b(j,te,ce,ie,j.length),ce}e.top=d;function E(j,te,ie,ce,fe){return ie===0?Promise.resolve([]):new Promise((ke,Le)=>{(async()=>{const Pe=j.length,Ae=j.slice(0,ie).sort(te);for(let Ke=ie,me=Math.min(ie+ce,Pe);Ke<Pe;Ke=me,me=Math.min(me+ce,Pe)){if(Ke>ie&&await new Promise(we=>setTimeout(we)),fe&&fe.isCancellationRequested)throw new w.CancellationError;b(j,te,Ae,Ke,me)}return Ae})().then(ke,Le)})}e.topAsync=E;function b(j,te,ie,ce,fe){for(const ke=ie.length;ce<fe;ce++){const Le=j[ce];if(te(Le,ie[ke-1])<0){ie.pop();const Pe=m(ie,Ae=>te(Le,Ae)<0);ie.splice(Pe,0,Le)}}}function p(j){return j.filter(te=>!!te)}e.coalesce=p;function S(j){let te=0;for(let ie=0;ie<j.length;ie++)j[ie]&&(j[te]=j[ie],te+=1);j.length=te}e.coalesceInPlace=S;function f(j,te,ie){j.splice(ie,0,j.splice(te,1)[0])}e.move=f;function h(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=h;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function i(j,te=ie=>ie){const ie=new Set;return j.filter(ce=>{const fe=te(ce);return ie.has(fe)?!1:(ie.add(fe),!0)})}e.distinct=i;function o(j){const te=new Set;return ie=>{const ce=j(ie);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=o;function n(j,te){const ie=r(j,te);if(ie!==-1)return j[ie]}e.findLast=n;function r(j,te){for(let ie=j.length-1;ie>=0;ie--){const ce=j[ie];if(te(ce))return ie}return-1}e.lastIndex=r;function s(j,te){return j.length>0?j[0]:te}e.firstOrDefault=s;function a(j,te){return j.length>0?j[j.length-1]:te}e.lastOrDefault=a;function l(j,te,ie=(ce,fe)=>ce===fe){let ce=0;for(let fe=0,ke=Math.min(j.length,te.length);fe<ke&&ie(j[fe],te[fe]);fe++)ce++;return ce}e.commonPrefixLength=l;function P(j){return[].concat(...j)}e.flatten=P;function M(j,te){let ie=typeof te=="number"?j:0;typeof te=="number"?ie=j:(ie=0,te=j);const ce=[];if(ie<=te)for(let fe=ie;fe<te;fe++)ce.push(fe);else for(let fe=ie;fe>te;fe--)ce.push(fe);return ce}e.range=M;function T(j,te,ie){return j.reduce((ce,fe)=>(ce[te(fe)]=ie?ie(fe):fe,ce),Object.create(null))}e.index=T;function F(j,te){return j.push(te),()=>U(j,te)}e.insert=F;function U(j,te){const ie=j.indexOf(te);if(ie>-1)return j.splice(ie,1),te}e.remove=U;function x(j,te,ie){const ce=j.slice(0,te),fe=j.slice(te);return ce.concat(ie,fe)}e.arrayInsert=x;function re(j,te){let ie;if(typeof te=="number"){let ce=te;ie=()=>{const fe=Math.sin(ce++)*179426549;return fe-Math.floor(fe)}}else ie=Math.random;for(let ce=j.length-1;ce>0;ce-=1){const fe=Math.floor(ie()*(ce+1)),ke=j[ce];j[ce]=j[fe],j[fe]=ke}}e.shuffle=re;function le(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.unshift(te))}e.pushToStart=le;function ue(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.push(te))}e.pushToEnd=ue;function se(j,te){for(const ie of te)j.push(ie)}e.pushMany=se;function de(j,te){return Array.isArray(j)?j.map(te):te(j)}e.mapArrayOrNot=de;function K(j){return Array.isArray(j)?j:[j]}e.asArray=K;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function _(j,te){for(const ie of j){const ce=te(ie);if(ce!==void 0)return ce}}e.mapFind=_;function A(j,te,ie){const ce=z(j,te),fe=j.length,ke=ie.length;j.length=fe+ke;for(let Le=fe-1;Le>=ce;Le--)j[Le+ke]=j[Le];for(let Le=0;Le<ke;Le++)j[Le+ce]=ie[Le]}e.insertInto=A;function W(j,te,ie,ce){const fe=z(j,te),ke=j.splice(fe,ie);return A(j,fe,ce),ke}e.splice=W;function z(j,te){return te<0?Math.max(te+j.length,0):Math.min(te,j.length)}var ee;(function(j){function te(fe){return fe<0}j.isLessThan=te;function ie(fe){return fe>0}j.isGreaterThan=ie;function ce(fe){return fe===0}j.isNeitherLessOrGreaterThan=ce,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function B(j,te){return(ie,ce)=>te(j(ie),j(ce))}e.compareBy=B;function H(...j){return(te,ie)=>{for(const ce of j){const fe=ce(te,ie);if(!ee.isNeitherLessOrGreaterThan(fe))return fe}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const L=(j,te)=>j-te;e.numberComparator=L;function O(j,te){if(j.length===0)return;let ie=j[0];for(let ce=1;ce<j.length;ce++){const fe=j[ce];te(fe,ie)>0&&(ie=fe)}return ie}e.findMaxBy=O;function N(j,te){if(j.length===0)return;let ie=j[0];for(let ce=1;ce<j.length;ce++){const fe=j[ce];te(fe,ie)>=0&&(ie=fe)}return ie}e.findLastMaxBy=N;function V(j,te){return O(j,(ie,ce)=>-te(ie,ce))}e.findMinBy=V;class Q{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ie=this.firstIdx;for(;ie<this.items.length&&te(this.items[ie]);)ie++;const ce=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,ce}takeFromEndWhile(te){let ie=this.lastIdx;for(;ie>=0&&te(this.items[ie]);)ie--;const ce=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ie=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ie}}e.ArrayQueue=Q;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(ie=>(te(ie),!0))}toArray(){const te=[];return this.iterate(ie=>(te.push(ie),!0)),te}filter(te){return new ne(ie=>this.iterate(ce=>te(ce)?ie(ce):!0))}map(te){return new ne(ie=>this.iterate(ce=>ie(te(ce))))}some(te){let ie=!1;return this.iterate(ce=>(ie=te(ce),!ie)),ie}findFirst(te){let ie;return this.iterate(ce=>te(ce)?(ie=ce,!1):!0),ie}findLast(te){let ie;return this.iterate(ce=>(te(ce)&&(ie=ce),!0)),ie}findLastMaxBy(te){let ie,ce=!0;return this.iterate(fe=>((ce||ee.isGreaterThan(te(fe,ie)))&&(ce=!1,ie=fe),!0)),ie}}e.CallbackIterable=ne,ne.empty=new ne(j=>{})}),define(J[49],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=w}),define(J[57],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*y(o){yield o}t.single=y;function u(o){return o||R}t.from=u;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function C(o){return o[Symbol.iterator]().next().value}t.first=C;function I(o,n){for(const r of o)if(n(r))return!0;return!1}t.some=I;function v(o,n){for(const r of o)if(n(r))return r}t.find=v;function*g(o,n){for(const r of o)n(r)&&(yield r)}t.filter=g;function*d(o,n){let r=0;for(const s of o)yield n(s,r++)}t.map=d;function*E(...o){for(const n of o)for(const r of n)yield r}t.concat=E;function*b(o){for(const n of o)for(const r of n)yield r}t.concatNested=b;function p(o,n,r){let s=r;for(const a of o)s=n(s,a);return s}t.reduce=p;function S(o,n){let r=0;for(const s of o)n(s,r++)}t.forEach=S;function*f(o,n,r=o.length){for(n<0&&(n+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);n<r;n++)yield o[n]}t.slice=f;function h(o,n=Number.POSITIVE_INFINITY){const r=[];if(n===0)return[r,o];const s=o[Symbol.iterator]();for(let a=0;a<n;a++){const l=s.next();if(l.done)return[r,t.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=h;function c(o){return h(o)[0]}t.collect=c;function i(o,n,r=(s,a)=>s===a){const s=o[Symbol.iterator](),a=n[Symbol.iterator]();for(;;){const l=s.next(),P=a.next();if(l.done!==P.done)return!1;if(l.done)return!0;if(!r(l.value,P.value))return!1}}t.equals=i})(w=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(i,o=!1){let n=0;const r=i.length;let s="",a=0,l=16,P=0;function M(ue){let se=0,de=0;for(;se<ue;){const K=i.charCodeAt(n);if(K>=48&&K<=57)de=de*16+K-48;else if(K>=65&&K<=70)de=de*16+K-65+10;else if(K>=97&&K<=102)de=de*16+K-97+10;else break;n++,se++}return se<ue&&(de=-1),de}function T(ue){n=ue,s="",a=0,l=16,P=0}function F(){const ue=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return P=3,i.substring(ue,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;se=n}else P=3;return i.substring(ue,se)}function U(){let ue="",se=n;for(;;){if(n>=r){ue+=i.substring(se,n),P=2;break}const de=i.charCodeAt(n);if(de===34){ue+=i.substring(se,n),n++;break}if(de===92){if(ue+=i.substring(se,n),n++,n>=r){P=2;break}switch(i.charCodeAt(n++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const $=M(4);$>=0?ue+=String.fromCharCode($):P=4;break}default:P=5}se=n;continue}if(de>=0&&de<=31)if(u(de)){ue+=i.substring(se,n),P=2;break}else P=6;n++}return ue}function x(){if(s="",P=0,a=n,n>=r)return a=r,l=17;let ue=i.charCodeAt(n);if(y(ue)){do n++,s+=String.fromCharCode(ue),ue=i.charCodeAt(n);while(y(ue));return l=15}if(u(ue))return n++,s+=String.fromCharCode(ue),ue===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(ue){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=U(),l=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<r&&!u(i.charCodeAt(n));)n++;return s=i.substring(se,n),l=12}if(i.charCodeAt(n+1)===42){n+=2;const de=r-1;let K=!1;for(;n<de;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,K=!0;break}n++}return K||(n++,P=1),s=i.substring(se,n),l=13}return s+=String.fromCharCode(ue),n++,l=16}case 45:if(s+=String.fromCharCode(ue),n++,n===r||!m(i.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),l=11;default:for(;n<r&&re(ue);)n++,ue=i.charCodeAt(n);if(a!==n){switch(s=i.substring(a,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(ue),n++,l=16}}function re(ue){if(y(ue)||u(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ue;do ue=x();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>n,scan:o?le:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>P}}e.createScanner=D;function y(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function I(i,o){const n=[],r=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(M,T,F,U){a.value=M,a.offset=T,a.length=F,a.type=U,a.colonOffset=void 0,s=a}try{f(i,{onObjectBegin:(M,T)=>{if(o<=M)throw r;s=void 0,l=o>M,n.push("")},onObjectProperty:(M,T,F)=>{if(o<T||(P(M,T,F,"property"),n[n.length-1]=M,o<=T+F))throw r},onObjectEnd:(M,T)=>{if(o<=M)throw r;s=void 0,n.pop()},onArrayBegin:(M,T)=>{if(o<=M)throw r;s=void 0,n.push(0)},onArrayEnd:(M,T)=>{if(o<=M)throw r;s=void 0,n.pop()},onLiteralValue:(M,T,F)=>{if(o<T||(P(M,T,F,c(M)),o<=T+F))throw r},onSeparator:(M,T,F)=>{if(o<=T)throw r;if(M===":"&&s&&s.type==="property")s.colonOffset=T,l=!1,s=void 0;else if(M===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(M){if(M!==r)throw M}return{path:n,previousNode:s,isAtPropertyKey:l,matches:M=>{let T=0;for(let F=0;T<M.length&&F<n.length;F++)if(M[T]===n[F]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=I;function v(i,o=[],n=R.DEFAULT){let r=null,s=[];const a=[];function l(M){Array.isArray(s)?s.push(M):r!==null&&(s[r]=M)}return f(i,{onObjectBegin:()=>{const M={};l(M),a.push(s),s=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const M=[];l(M),a.push(s),s=M,r=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(M,T,F)=>{o.push({error:M,offset:T,length:F})}},n),s[0]}e.parse=v;function g(i,o=[],n=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){r.type==="property"&&(r.length=M-r.offset,r=r.parent)}function a(M){return r.children.push(M),M}f(i,{onObjectBegin:M=>{r=a({type:"object",offset:M,length:-1,parent:r,children:[]})},onObjectProperty:(M,T,F)=>{r=a({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:M,offset:T,length:F,parent:r})},onObjectEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onArrayBegin:(M,T)=>{r=a({type:"array",offset:M,length:-1,parent:r,children:[]})},onArrayEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onLiteralValue:(M,T,F)=>{a({type:c(M),offset:T,length:F,parent:r,value:M}),s(T+F)},onSeparator:(M,T,F)=>{r.type==="property"&&(M===":"?r.colonOffset=T:M===","&&s(T))},onError:(M,T,F)=>{o.push({error:M,offset:T,length:F})}},n);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=g;function d(i,o){if(!i)return;let n=i;for(const r of o)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===r){n=a.children[1],s=!0;break}if(!s)return}else{const s=r;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=d;function E(i){if(!i.parent||!i.parent.children)return[];const o=E(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=E;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const o=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(o[n.children[0].value]=b(r))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function p(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=p;function S(i,o,n=!1){if(p(i,o,n)){const r=i.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const a=S(r[s],o,n);if(a)return a}return i}}e.findNodeAtOffset=S;function f(i,o,n=R.DEFAULT){const r=D(i,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function a(B){return B?H=>B(H,r.getTokenOffset(),r.getTokenLength()):()=>!0}const l=s(o.onObjectBegin),P=a(o.onObjectProperty),M=s(o.onObjectEnd),T=s(o.onArrayBegin),F=s(o.onArrayEnd),U=a(o.onLiteralValue),x=a(o.onSeparator),re=s(o.onComment),le=a(o.onError),ue=n&&n.disallowComments,se=n&&n.allowTrailingComma;function de(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:ue||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(B){case 12:case 13:ue?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return B}}}function K(B,H=[],L=[]){if(le(B),H.length+L.length>0){let O=r.getToken();for(;O!==17;){if(H.indexOf(O)!==-1){de();break}else if(L.indexOf(O)!==-1)break;O=de()}}}function $(B){const H=r.getTokenValue();return B?U(H):P(H),de(),!0}function _(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(K(2),B=0)}catch{K(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return de(),!0}function A(){return r.getToken()!==10?(K(3,[],[2,5]),!1):($(!1),r.getToken()===6?(x(":"),de(),ee()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function W(){l(),de();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||K(4,[],[]),x(","),de(),r.getToken()===2&&se)break}else B&&K(6,[],[]);A()||K(4,[],[2,5]),B=!0}return M(),r.getToken()!==2?K(7,[2],[]):de(),!0}function z(){T(),de();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||K(4,[],[]),x(","),de(),r.getToken()===4&&se)break}else B&&K(6,[],[]);ee()||K(4,[],[4,5]),B=!0}return F(),r.getToken()!==4?K(8,[4],[]):de(),!0}function ee(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return $(!0);default:return _()}}return de(),r.getToken()===17?n.allowEmptyContent?!0:(K(4,[],[]),!1):ee()?(r.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=f;function h(i,o){const n=D(i),r=[];let s,a=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==l&&r.push(i.substring(a,l)),o!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return r.join("")}e.stripComments=h;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[123],Z([0,1,43]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,C,I){let v,g,d,E,b;if(C){for(E=C.offset,b=E+C.length,d=E;d>0&&!u(m,d-1);)d--;let l=b;for(;l<m.length&&!u(m,l);)l++;g=m.substring(d,l),v=D(g,I)}else g=m,v=0,d=0,E=0,b=m.length;const p=y(I,m);let S=!1,f=0,h;I.insertSpaces?h=R(" ",I.tabSize||4):h="	";const c=(0,w.createScanner)(g,!1);let i=!1;function o(){return p+R(h,v+f)}function n(){let l=c.scan();for(S=!1;l===15||l===14;)S=S||l===14,l=c.scan();return i=l===16||c.getTokenError()!==0,l}const r=[];function s(l,P,M){!i&&P<b&&M>E&&m.substring(P,M)!==l&&r.push({offset:P,length:M-P,content:l})}let a=n();if(a!==17){const l=c.getTokenOffset()+d,P=R(h,v);s(P,d,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,P=n(),M="";for(;!S&&(P===12||P===13);){const F=c.getTokenOffset()+d;s(" ",l,F),l=c.getTokenOffset()+c.getTokenLength()+d,M=P===12?o():"",P=n()}if(P===2)a!==1&&(f--,M=o());else if(P===4)a!==3&&(f--,M=o());else{switch(a){case 3:case 1:f++,M=o();break;case 5:case 12:M=o();break;case 13:S?M=o():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}S&&(P===12||P===13)&&(M=o())}const T=c.getTokenOffset()+d;s(M,l,T),a=P}return r}e.format=t;function k(m,C){const I=JSON.stringify(m,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?I.replace(/\r\n|\r|\n/g,C.eol):I}e.toFormattedString=k;function R(m,C){let I="";for(let v=0;v<C;v++)I+=m;return I}function D(m,C){let I=0,v=0;const g=C.tabSize||4;for(;I<m.length;){const d=m.charAt(I);if(d===" ")v++;else if(d==="	")v+=g;else break;I++}return Math.floor(v/g)}function y(m,C){for(let I=0;I<C.length;I++){const v=C.charAt(I);if(v==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=y;function u(m,C){return`\r
`.indexOf(m.charAt(C))!==-1}e.isEOL=u}),define(J[124],Z([0,1,43,123]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,C,I){return R(m,C,void 0,I)}e.removeProperty=k;function R(m,C,I,v,g){const d=C.slice(),E=[],b=(0,w.parseTree)(m,E);let p,S;for(;d.length>0&&(S=d.pop(),p=(0,w.findNodeAtLocation)(b,d),p===void 0&&I!==void 0);)typeof S=="string"?I={[S]:I}:I=[I];if(p)if(p.type==="object"&&typeof S=="string"&&Array.isArray(p.children)){const f=(0,w.findNodeAtLocation)(p,[S]);if(f!==void 0)if(I===void 0){if(!f.parent)throw new Error("Malformed AST");const h=p.children.indexOf(f.parent);let c,i=f.parent.offset+f.parent.length;if(h>0){const o=p.children[h-1];c=o.offset+o.length}else c=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return D(m,{offset:c,length:i-c,content:""},v)}else return D(m,{offset:f.offset,length:f.length,content:JSON.stringify(I)},v);else{if(I===void 0)return[];const h=`${JSON.stringify(S)}: ${JSON.stringify(I)}`,c=g?g(p.children.map(o=>o.children[0].value)):p.children.length;let i;if(c>0){const o=p.children[c-1];i={offset:o.offset+o.length,length:0,content:","+h}}else p.children.length===0?i={offset:p.offset+1,length:0,content:h}:i={offset:p.offset+1,length:0,content:h+","};return D(m,i,v)}}else if(p.type==="array"&&typeof S=="number"&&Array.isArray(p.children))if(I!==void 0){const f=`${JSON.stringify(I)}`;let h;if(p.children.length===0||S===0)h={offset:p.offset+1,length:0,content:p.children.length===0?f:f+","};else{const c=S===-1||S>p.children.length?p.children.length:S,i=p.children[c-1];h={offset:i.offset+i.length,length:0,content:","+f}}return D(m,h,v)}else{const f=S,h=p.children[f];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===f){const i=p.children[f-1],o=i.offset+i.length,n=p.offset+p.length;c={offset:o,length:n-2-o,content:""}}else c={offset:h.offset,length:p.children[f+1].offset-h.offset,content:""};return D(m,c,v)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return D(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},v)}}e.setProperty=R;function D(m,C,I){let v=y(m,C),g=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;g>0&&!(0,t.isEOL)(v,g-1);)g--;for(;d<v.length&&!(0,t.isEOL)(v,d);)d++}const E=(0,t.format)(v,{offset:g,length:d-g},I);for(let p=E.length-1;p>=0;p--){const S=E[p];v=y(v,S),g=Math.min(g,S.offset),d=Math.max(d,S.offset+S.length),d+=S.content.length-S.length}const b=m.length-(v.length-d)-g;return[{offset:g,length:b,content:v.substring(g,d)}]}e.withFormatting=D;function y(m,C){return m.substring(0,C.offset)+C.content+m.substring(C.offset+C.length)}e.applyEdit=y;function u(m,C){const I=C.slice(0).sort((g,d)=>{const E=g.offset-d.offset;return E===0?g.length-d.length:E});let v=m.length;for(let g=I.length-1;g>=0;g--){const d=I[g];if(d.offset+d.length<=v)m=y(m,d);else throw new Error("Overlapping edit");v=d.offset}return m}e.applyEdits=u}),define(J[125],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new w(()=>k(this.getValue()))}}e.Lazy=w}),define(J[2],Z([0,1,49,57]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(s){R=s}if(e.setDisposableTracker=D,k){const s="__is_disposable_tracked__";D(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==S.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==S.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function y(s){return R?.trackDisposable(s),s}function u(s){R?.markAsDisposed(s)}function m(s,a){R?.setParent(s,a)}function C(s,a){if(!!R)for(const l of s)R.setParent(l,a)}function I(s){return R?.markAsSingleton(s),s}e.markAsSingleton=I;function v(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=v;function g(s){if(t.Iterable.is(s)){const a=[];for(const l of s)if(l)try{l.dispose()}catch(P){a.push(P)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=g;function d(s){for(const a of s)v(a)&&a.dispose();return[]}e.disposeIfDisposable=d;function E(...s){const a=b(()=>g(s));return C(s,a),a}e.combinedDisposable=E;function b(s){const a=y({dispose:(0,w.once)(()=>{u(a),s()})});return a}e.toDisposable=b;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return m(a,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new p,y(this),m(this._store,this)}dispose(){u(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&m(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&m(a,null),a}}e.MutableDisposable=f;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(a){let l=a;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,u(this))},this}}e.SafeDisposable=c;class i{constructor(){this.references=new Map}acquire(a,...l){let P=this.references.get(a);P||(P={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,P));const{object:M}=P,T=(0,w.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(a,P.object),this.references.delete(a))});return P.counter++,{object:M,dispose:T}}}e.ReferenceCollection=i;class o{constructor(a){this.referenceCollection=a}async acquire(a,...l){const P=this.referenceCollection.acquire(a,...l);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(M){throw P.dispose(),M}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function r(s){const a=new p;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(J[126],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(R){this.element=R,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class t{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let R=this._first;for(;R!==w.Undefined;){const D=R.next;R.prev=w.Undefined,R.next=w.Undefined,R=D}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const y=new w(R);if(this._first===w.Undefined)this._first=y,this._last=y;else if(D){const m=this._last;this._last=y,y.prev=m,m.next=y}else{const m=this._first;this._first=y,y.next=m,m.prev=y}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(y))}}shift(){if(this._first!==w.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==w.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==w.Undefined&&R.next!==w.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===w.Undefined&&R.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):R.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):R.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==w.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(u){R.push(u,Date.now())}function y(){const u=[];for(let m=0;m<R.length;m+=2)u.push({name:R[m],startTime:R[m+1]});return u}return{mark:D,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=w(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var t in w)(typeof exports=="object"?exports:q)[t]=w[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function w(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=q,w.c=e,w.d=function(t,k,R){w.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},w.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},w.t=function(t,k){if(1&k&&(t=w(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(w.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)w.d(R,D,function(y){return t[y]}.bind(null,D));return R},w.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return w.d(k,"a",k),k},w.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},w.p="",w(w.s=0)}([function(q,e,w){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],u=e.src=[],m=0,C=m++;u[C]="0|[1-9]\\d*";var I=m++;u[I]="[0-9]+";var v=m++;u[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=m++;u[g]="("+u[C]+")\\.("+u[C]+")\\.("+u[C]+")";var d=m++;u[d]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var E=m++;u[E]="(?:"+u[C]+"|"+u[v]+")";var b=m++;u[b]="(?:"+u[I]+"|"+u[v]+")";var p=m++;u[p]="(?:-("+u[E]+"(?:\\."+u[E]+")*))";var S=m++;u[S]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var f=m++;u[f]="[0-9A-Za-z-]+";var h=m++;u[h]="(?:\\+("+u[f]+"(?:\\."+u[f]+")*))";var c=m++,i="v?"+u[g]+u[p]+"?"+u[h]+"?";u[c]="^"+i+"$";var o="[v=\\s]*"+u[d]+u[S]+"?"+u[h]+"?",n=m++;u[n]="^"+o+"$";var r=m++;u[r]="((?:<|>)?=?)";var s=m++;u[s]=u[I]+"|x|X|\\*";var a=m++;u[a]=u[C]+"|x|X|\\*";var l=m++;u[l]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[p]+")?"+u[h]+"?)?)?";var P=m++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[S]+")?"+u[h]+"?)?)?";var M=m++;u[M]="^"+u[r]+"\\s*"+u[l]+"$";var T=m++;u[T]="^"+u[r]+"\\s*"+u[P]+"$";var F=m++;u[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;u[U]="(?:~>?)";var x=m++;u[x]="(\\s*)"+u[U]+"\\s+",y[x]=new RegExp(u[x],"g");var re=m++;u[re]="^"+u[U]+u[l]+"$";var le=m++;u[le]="^"+u[U]+u[P]+"$";var ue=m++;u[ue]="(?:\\^)";var se=m++;u[se]="(\\s*)"+u[ue]+"\\s+",y[se]=new RegExp(u[se],"g");var de=m++;u[de]="^"+u[ue]+u[l]+"$";var K=m++;u[K]="^"+u[ue]+u[P]+"$";var $=m++;u[$]="^"+u[r]+"\\s*("+o+")$|^$";var _=m++;u[_]="^"+u[r]+"\\s*("+i+")$|^$";var A=m++;u[A]="(\\s*)"+u[r]+"\\s*("+o+"|"+u[l]+")",y[A]=new RegExp(u[A],"g");var W=m++;u[W]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var z=m++;u[z]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var ee=m++;u[ee]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,u[B]),y[B]||(y[B]=new RegExp(u[B]));function H(X,oe){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(oe?y[n]:y[c]).test(X))return null;try{return new L(X,oe)}catch{return null}}function L(X,oe){if(X instanceof L){if(X.loose===oe)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,oe);k("SemVer",X,oe),this.loose=oe;var he=X.trim().match(oe?y[n]:y[c]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(X,oe){var he=H(X,oe);return he?he.version:null},e.clean=function(X,oe){var he=H(X.trim().replace(/^[=v]+/,""),oe);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),N(this.major,X.major)||N(this.minor,X.minor)||N(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var oe=0;do{var he=this.prerelease[oe],ye=X.prerelease[oe];if(k("prerelease compare",oe,he,ye),he===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(he===void 0)return-1;if(he!==ye)return N(he,ye)}while(++oe)},L.prototype.inc=function(X,oe){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,oe,he,ye){typeof he=="string"&&(ye=he,he=void 0);try{return new L(X,he).inc(oe,ye).version}catch{return null}},e.diff=function(X,oe){if(j(X,oe))return null;var he=H(X),ye=H(oe);if(he.prerelease.length||ye.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=N;var O=/^[0-9]+$/;function N(X,oe){var he=O.test(X),ye=O.test(oe);return he&&ye&&(X=+X,oe=+oe),he&&!ye?-1:ye&&!he?1:X<oe?-1:X>oe?1:0}function V(X,oe,he){return new L(X,he).compare(new L(oe,he))}function Q(X,oe,he){return V(X,oe,he)>0}function ne(X,oe,he){return V(X,oe,he)<0}function j(X,oe,he){return V(X,oe,he)===0}function te(X,oe,he){return V(X,oe,he)!==0}function ie(X,oe,he){return V(X,oe,he)>=0}function ce(X,oe,he){return V(X,oe,he)<=0}function fe(X,oe,he,ye){var Ce;switch(oe){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X!==he;break;case"":case"=":case"==":Ce=j(X,he,ye);break;case"!=":Ce=te(X,he,ye);break;case">":Ce=Q(X,he,ye);break;case">=":Ce=ie(X,he,ye);break;case"<":Ce=ne(X,he,ye);break;case"<=":Ce=ce(X,he,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return Ce}function ke(X,oe){if(X instanceof ke){if(X.loose===oe)return X;X=X.value}if(!(this instanceof ke))return new ke(X,oe);k("comparator",X,oe),this.loose=oe,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,oe){return N(oe,X)},e.major=function(X,oe){return new L(X,oe).major},e.minor=function(X,oe){return new L(X,oe).minor},e.patch=function(X,oe){return new L(X,oe).patch},e.compare=V,e.compareLoose=function(X,oe){return V(X,oe,!0)},e.rcompare=function(X,oe,he){return V(oe,X,he)},e.sort=function(X,oe){return X.sort(function(he,ye){return e.compare(he,ye,oe)})},e.rsort=function(X,oe){return X.sort(function(he,ye){return e.rcompare(he,ye,oe)})},e.gt=Q,e.lt=ne,e.eq=j,e.neq=te,e.gte=ie,e.lte=ce,e.cmp=fe,e.Comparator=ke;var Le={};function Pe(X,oe){if(X instanceof Pe)return X.loose===oe?X:new Pe(X.raw,oe);if(X instanceof ke)return new Pe(X.value,oe);if(!(this instanceof Pe))return new Pe(X,oe);if(this.loose=oe,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ke(X,oe,he,ye,Ce,Te,Oe,Ne,ze,$e,Be,qe,G){return((oe=Ae(he)?"":Ae(ye)?">="+he+".0.0":Ae(Ce)?">="+he+"."+ye+".0":">="+oe)+" "+(Ne=Ae(ze)?"":Ae($e)?"<"+(+ze+1)+".0.0":Ae(Be)?"<"+ze+"."+(+$e+1)+".0":qe?"<="+ze+"."+$e+"."+Be+"-"+qe:"<="+Ne)).trim()}function me(X,oe){for(var he=0;he<X.length;he++)if(!X[he].test(oe))return!1;if(oe.prerelease.length){for(he=0;he<X.length;he++)if(k(X[he].semver),X[he].semver!==Le&&X[he].semver.prerelease.length>0){var ye=X[he].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function we(X,oe,he){try{oe=new Pe(oe,he)}catch{return!1}return oe.test(X)}function be(X,oe,he,ye){var Ce,Te,Oe,Ne,ze;switch(X=new L(X,ye),oe=new Pe(oe,ye),he){case">":Ce=Q,Te=ce,Oe=ne,Ne=">",ze=">=";break;case"<":Ce=ne,Te=ie,Oe=Q,Ne="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(X,oe,ye))return!1;for(var $e=0;$e<oe.set.length;++$e){var Be=oe.set[$e],qe=null,G=null;if(Be.forEach(function(ae){ae.semver===Le&&(ae=new ke(">=0.0.0")),qe=qe||ae,G=G||ae,Ce(ae.semver,qe.semver,ye)?qe=ae:Oe(ae.semver,G.semver,ye)&&(G=ae)}),qe.operator===Ne||qe.operator===ze||(!G.operator||G.operator===Ne)&&Te(X,G.semver)||G.operator===ze&&Oe(X,G.semver))return!1}return!0}ke.prototype.parse=function(X){var oe=this.loose?y[$]:y[_],he=X.match(oe);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Le},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),fe(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,oe){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Pe(X.value,oe),we(this.value,he,oe);if(X.operator==="")return he=new Pe(this.value,oe),we(X.semver,he,oe);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Te=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Ne=fe(this.semver,"<",X.semver,oe)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),ze=fe(this.semver,">",X.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||Ce||Te&&Oe||Ne||ze},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(X){var oe=this.loose;X=X.trim(),k("range",X,oe);var he=oe?y[z]:y[W];X=X.replace(he,Ke),k("hyphen replace",X),X=X.replace(y[A],"$1$2$3"),k("comparator trim",X,y[A]),X=(X=(X=X.replace(y[x],"$1~")).replace(y[se],"$1^")).split(/\s+/).join(" ");var ye=oe?y[$]:y[_],Ce=X.split(" ").map(function(Te){return function(Oe,Ne){return k("comp",Oe),Oe=function(ze,$e){return ze.trim().split(/\s+/).map(function(Be){return function(qe,G){k("caret",qe,G);var ae=G?y[K]:y[de];return qe.replace(ae,function(pe,ge,Se,De,We){var Qe;return k("caret",qe,pe,ge,Se,De,We),Ae(ge)?Qe="":Ae(Se)?Qe=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ae(De)?Qe=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":We?(k("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+De+We+" <"+ge+"."+Se+"."+(+De+1):">="+ge+"."+Se+"."+De+We+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+De+We+" <"+(+ge+1)+".0.0"):(k("no pr"),Qe=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+De+" <"+ge+"."+Se+"."+(+De+1):">="+ge+"."+Se+"."+De+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+De+" <"+(+ge+1)+".0.0"),k("caret return",Qe),Qe})}(Be,$e)}).join(" ")}(Oe,Ne),k("caret",Oe),Oe=function(ze,$e){return ze.trim().split(/\s+/).map(function(Be){return function(qe,G){var ae=G?y[le]:y[re];return qe.replace(ae,function(pe,ge,Se,De,We){var Qe;return k("tilde",qe,pe,ge,Se,De,We),Ae(ge)?Qe="":Ae(Se)?Qe=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ae(De)?Qe=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":We?(k("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=">="+ge+"."+Se+"."+De+We+" <"+ge+"."+(+Se+1)+".0"):Qe=">="+ge+"."+Se+"."+De+" <"+ge+"."+(+Se+1)+".0",k("tilde return",Qe),Qe})}(Be,$e)}).join(" ")}(Oe,Ne),k("tildes",Oe),Oe=function(ze,$e){return k("replaceXRanges",ze,$e),ze.split(/\s+/).map(function(Be){return function(qe,G){qe=qe.trim();var ae=G?y[T]:y[M];return qe.replace(ae,function(pe,ge,Se,De,We,Qe){k("xRange",qe,pe,ge,Se,De,We,Qe);var tt=Ae(Se),Ge=tt||Ae(De),Ye=Ge||Ae(We);return ge==="="&&Ye&&(ge=""),tt?pe=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ye?(Ge&&(De=0),Ye&&(We=0),ge===">"?(ge=">=",Ge?(Se=+Se+1,De=0,We=0):Ye&&(De=+De+1,We=0)):ge==="<="&&(ge="<",Ge?Se=+Se+1:De=+De+1),pe=ge+Se+"."+De+"."+We):Ge?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ye&&(pe=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0"),k("xRange return",pe),pe})}(Be,$e)}).join(" ")}(Oe,Ne),k("xrange",Oe),Oe=function(ze,$e){return k("replaceStars",ze,$e),ze.trim().replace(y[ee],"")}(Oe,Ne),k("stars",Oe),Oe}(Te,oe)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Te){return!!Te.match(ye)})),Ce=Ce.map(function(Te){return new ke(Te,oe)})},Pe.prototype.intersects=function(X,oe){if(!(X instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ye){return X.set.some(function(Ce){return Ce.every(function(Te){return ye.intersects(Te,oe)})})})})},e.toComparators=function(X,oe){return new Pe(X,oe).set.map(function(he){return he.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var oe=0;oe<this.set.length;oe++)if(me(this.set[oe],X))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(X,oe,he){var ye=null,Ce=null;try{var Te=new Pe(oe,he)}catch{return null}return X.forEach(function(Oe){Te.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,he)))}),ye},e.minSatisfying=function(X,oe,he){var ye=null,Ce=null;try{var Te=new Pe(oe,he)}catch{return null}return X.forEach(function(Oe){Te.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,he)))}),ye},e.validRange=function(X,oe){try{return new Pe(X,oe).range||"*"}catch{return null}},e.ltr=function(X,oe,he){return be(X,oe,"<",he)},e.gtr=function(X,oe,he){return be(X,oe,">",he)},e.outside=be,e.prerelease=function(X,oe){var he=H(X,oe);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,oe,he){return X=new Pe(X,he),oe=new Pe(oe,he),X.intersects(oe)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var oe=X.match(y[F]);return oe==null?null:H((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,w(1))},function(q,e){var w,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function y(b){if(w===setTimeout)return setTimeout(b,0);if((w===R||!w)&&setTimeout)return w=setTimeout,setTimeout(b,0);try{return w(b,0)}catch{try{return w.call(null,b,0)}catch{return w.call(this,b,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:R}catch{w=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var u,m=[],C=!1,I=-1;function v(){C&&u&&(C=!1,u.length?m=u.concat(m):I=-1,m.length&&g())}function g(){if(!C){var b=y(v);C=!0;for(var p=m.length;p;){for(u=m,m=[];++I<p;)u&&u[I].run();I=-1,p=m.length}u=null,C=!1,function(S){if(t===clearTimeout)return clearTimeout(S);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(S);try{t(S)}catch{try{return t.call(null,S)}catch{return t.call(this,S)}}}(b)}}function d(b,p){this.fun=b,this.array=p}function E(){}k.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];m.push(new d(b,p)),m.length!==1||C||y(g)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=E,k.addListener=E,k.once=E,k.off=E,k.removeListener=E,k.removeAllListeners=E,k.emit=E,k.prependListener=E,k.prependOnceListener=E,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(J[127],Z([0,1]),function(q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(y,u,m){this.level=y,this.key=u,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(y,u=2**16){this.comparator=y,this[w]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(y){return Boolean(R._search(this,y,this.comparator))}get(y){return R._search(this,y,this.comparator)?.value}set(y,u){return R._insert(this,y,u,this.comparator)&&(this._size+=1),this}delete(y){const u=R._delete(this,y,this.comparator);return u&&(this._size-=1),u}forEach(y,u){let m=this._header.forward[0];for(;m;)y.call(u,m.value,m.key,this),m=m.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",u=this._header.forward[0];for(;u;)y+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return y}static _search(y,u,m){let C=y._header;for(let I=y._level-1;I>=0;I--)for(;C.forward[I]&&m(C.forward[I].key,u)<0;)C=C.forward[I];if(C=C.forward[0],C&&m(C.key,u)===0)return C}static _insert(y,u,m,C){const I=[];let v=y._header;for(let g=y._level-1;g>=0;g--){for(;v.forward[g]&&C(v.forward[g].key,u)<0;)v=v.forward[g];I[g]=v}if(v=v.forward[0],v&&C(v.key,u)===0)return v.value=m,!1;{const g=R._randomLevel(y);if(g>y._level){for(let d=y._level;d<g;d++)I[d]=y._header;y._level=g}v=new t(g,u,m);for(let d=0;d<g;d++)v.forward[d]=I[d].forward[d],I[d].forward[d]=v;return!0}}static _randomLevel(y,u=.5){let m=1;for(;Math.random()<u&&m<y._maxLevel;)m+=1;return m}static _delete(y,u,m){const C=[];let I=y._header;for(let v=y._level-1;v>=0;v--){for(;I.forward[v]&&m(I.forward[v].key,u)<0;)I=I.forward[v];C[v]=I}if(I=I.forward[0],!I||m(I.key,u)!==0)return!1;for(let v=0;v<y._level&&C[v].forward[v]===I;v++)C[v].forward[v]=I.forward[v];for(;y._level>0&&y._header.forward[y._level-1]===k;)y._level-=1;return!0}}e.SkipList=R}),define(J[58],Z([0,1,18,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const c=h;return c?typeof c.read=="function":!1}e.isReadable=k;function R(h){const c=h;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function D(h){const c=h;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function y(h,c){return new u(h,c)}e.newWriteableStream=y;class u{constructor(c,i){this.reducer=c,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(i=>i(c))}emitError(c){this.listeners.error.length===0?(0,w.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(i=>i(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,i){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(c,i){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(h,c){const i=[];let o;for(;(o=h.read())!==null;)i.push(o);return c(i)}e.consumeReadable=m;function C(h,c,i){const o=[];let n;for(;(n=h.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return h.read()}}}e.peekReadable=C;function I(h,c){return new Promise((i,o)=>{const n=[];v(h,{onData:r=>{c&&n.push(r)},onError:r=>{c?o(r):i(void 0)},onEnd:()=>{i(c?c(n):void 0)}})})}e.consumeStream=I;function v(h,c){let i=!1;return h.on("error",o=>{i||c.onError(o)}),h.on("end",()=>{i||c.onEnd()}),h.on("data",o=>{i||c.onData(o)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function g(h,c){return new Promise((i,o)=>{const n=new t.DisposableStore,r=[],s=P=>{if(r.push(P),r.length>c)return n.dispose(),h.pause(),i({stream:h,buffer:r,ended:!1})},a=P=>o(P),l=()=>i({stream:h,buffer:r,ended:!0});n.add((0,t.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),n.add((0,t.toDisposable)(()=>h.removeListener("end",l))),h.on("end",l),n.add((0,t.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=g;function d(h,c){const i=y(c);return i.end(h),i}e.toStream=d;function E(){const h=y(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=E;function b(h){let c=!1;return{read:()=>c?null:(c=!0,h)}}e.toReadable=b;function p(h,c,i){const o=y(i);return v(h,{onData:n=>o.write(c.data(n)),onError:n=>o.error(c.error?c.error(n):n),onEnd:()=>o.end()}),o}e.transform=p;function S(h,c,i){let o=!1;return{read:()=>{const n=c.read();return o?n:(o=!0,n!==null?i([h,n]):h)}}}e.prefixedReadable=S;function f(h,c,i){let o=!1;const n=y(i);return v(c,{onData:r=>o?n.write(r):(o=!0,n.write(i([h,r]))),onError:r=>n.error(r),onEnd:()=>{o||(o=!0,n.write(h)),n.end()}}),n}e.prefixedStream=f}),define(J[17],Z([0,1,58]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let T=0,F=P.length;T<F;T++)M.buffer[T]=P[T];return M}static concat(P,M){if(typeof M>"u"){M=0;for(let U=0,x=P.length;U<x;U++)M+=P[U].byteLength}const T=D.alloc(M);let F=0;for(let U=0,x=P.length;U<x;U++){const re=P[U];T.set(re,F),F+=re.byteLength}return T}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,M){C(this.buffer,P,M)}readUInt32LE(P){return I(this.buffer,P)}writeUInt32LE(P,M){v(this.buffer,P,M)}readUInt8(P){return g(this.buffer,P)}writeUInt8(P,M){d(this.buffer,P,M)}}e.VSBuffer=D;function y(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0}e.readUInt16LE=y;function u(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255}e.writeUInt16LE=u;function m(l,P){return l[P]*2**24+l[P+1]*2**16+l[P+2]*2**8+l[P+3]}e.readUInt32BE=m;function C(l,P,M){l[M+3]=P,P=P>>>8,l[M+2]=P,P=P>>>8,l[M+1]=P,P=P>>>8,l[M]=P}e.writeUInt32BE=C;function I(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0|l[P+2]<<16>>>0|l[P+3]<<24>>>0}e.readUInt32LE=I;function v(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255,P=P>>>8,l[M+2]=P&255,P=P>>>8,l[M+3]=P&255}e.writeUInt32LE=v;function g(l,P){return l[P]}e.readUInt8=g;function d(l,P,M){l[M]=P}e.writeUInt8=d;function E(l){return w.consumeReadable(l,P=>D.concat(P))}e.readableToBuffer=E;function b(l){return w.toReadable(l)}e.bufferToReadable=b;function p(l){return w.consumeStream(l,P=>D.concat(P))}e.streamToBuffer=p;async function S(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await p(l.stream)])}e.bufferedStreamToBuffer=S;function f(l){return w.toStream(l,P=>D.concat(P))}e.bufferToStream=f;function h(l){return w.transform(l,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=h;function c(l){return w.newWriteableStream(P=>D.concat(P),l)}e.newWriteableBufferStream=c;function i(l,P){return w.prefixedReadable(l,P,M=>D.concat(M))}e.prefixedBufferReadable=i;function o(l,P){return w.prefixedStream(l,P,M=>D.concat(M))}e.prefixedBufferStream=o;function n(l){let P=0,M=0,T=0;const F=new Uint8Array(Math.floor(l.length/4*3)),U=re=>{switch(M){case 3:F[T++]=P|re,M=0;break;case 2:F[T++]=P|re>>>2,P=re<<6,M=3;break;case 1:F[T++]=P|re>>>4,P=re<<4,M=2;break;default:P=re<<2,M=1}};for(let re=0;re<l.length;re++){const le=l.charCodeAt(re);if(le>=65&&le<=90)U(le-65);else if(le>=97&&le<=122)U(le-97+26);else if(le>=48&&le<=57)U(le-48+52);else if(le===43||le===45)U(62);else if(le===47||le===95)U(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${l[re]}`)}}const x=T;for(;M>0;)U(0);return D.wrap(F).slice(0,x)}e.decodeBase64=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},P=!0,M=!1){const T=M?s:r;let F="";const U=l.byteLength%3;let x=0;for(;x<l.byteLength-U;x+=3){const re=l[x+0],le=l[x+1],ue=l[x+2];F+=T[re>>>2],F+=T[(re<<4|le>>>4)&63],F+=T[(le<<2|ue>>>6)&63],F+=T[ue&63]}if(U===1){const re=l[x+0];F+=T[re>>>2],F+=T[re<<4&63],P&&(F+="==")}else if(U===2){const re=l[x+0],le=l[x+1];F+=T[re>>>2],F+=T[(re<<4|le>>>4)&63],F+=T[le<<2&63],P&&(F+="=")}return F}e.encodeBase64=a}),define(J[12],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(o){return typeof o=="string"}e.isString=w;function t(o){return Array.isArray(o)&&o.every(n=>w(n))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function y(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=y;function u(o){return o===!0||o===!1}e.isBoolean=u;function m(o){return typeof o>"u"}e.isUndefined=m;function C(o){return!I(o)}e.isDefined=C;function I(o){return m(o)||o===null}e.isUndefinedOrNull=I;function v(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=v;function g(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=g;function d(...o){const n=[];for(let r=0;r<o.length;r++){const s=o[r];if(I(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);n.push(s)}return n}e.assertAllDefined=d;const E=Object.prototype.hasOwnProperty;function b(o){if(!k(o))return!1;for(const n in o)if(E.call(o,n))return!1;return!0}e.isEmptyObject=b;function p(o){return typeof o=="function"}e.isFunction=p;function S(...o){return o.length>0&&o.every(p)}e.areFunctions=S;function f(o,n){const r=Math.min(o.length,n.length);for(let s=0;s<r;s++)h(o[s],n[s])}e.validateConstraints=f;function h(o,n){if(w(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(o instanceof n)return}catch{}if(!I(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(J[50],Z([0,1,12]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const S=Array.isArray(p)?[]:{};return Object.keys(p).forEach(f=>{p[f]&&typeof p[f]=="object"?S[f]=t(p[f]):S[f]=p[f]}),S}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const S=[p];for(;S.length>0;){const f=S.shift();Object.freeze(f);for(const h in f)if(R.call(f,h)){const c=f[h];typeof c=="object"&&!Object.isFrozen(c)&&!(0,w.isTypedArray)(c)&&S.push(c)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(p,S){return y(p,S,new Set)}e.cloneAndChange=D;function y(p,S,f){if((0,w.isUndefinedOrNull)(p))return p;const h=S(p);if(typeof h<"u")return h;if(Array.isArray(p)){const c=[];for(const i of p)c.push(y(i,S,f));return c}if((0,w.isObject)(p)){if(f.has(p))throw new Error("Cannot clone recursive data-structure");f.add(p);const c={};for(const i in p)R.call(p,i)&&(c[i]=y(p[i],S,f));return f.delete(p),c}return p}function u(p,S,f=!0){return(0,w.isObject)(p)?((0,w.isObject)(S)&&Object.keys(S).forEach(h=>{h in p?f&&((0,w.isObject)(p[h])&&(0,w.isObject)(S[h])?u(p[h],S[h],f):p[h]=S[h]):p[h]=S[h]}),p):S}e.mixin=u;function m(p,S){if(p===S)return!0;if(p==null||S===null||S===void 0||typeof p!=typeof S||typeof p!="object"||Array.isArray(p)!==Array.isArray(S))return!1;let f,h;if(Array.isArray(p)){if(p.length!==S.length)return!1;for(f=0;f<p.length;f++)if(!m(p[f],S[f]))return!1}else{const c=[];for(h in p)c.push(h);c.sort();const i=[];for(h in S)i.push(h);if(i.sort(),!m(c,i))return!1;for(f=0;f<c.length;f++)if(!m(p[c[f]],S[c[f]]))return!1}return!0}e.equals=m;function C(p){const S=new Set;return JSON.stringify(p,(f,h)=>{if((0,w.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}e.safeStringify=C;function I(p,S){const f=Object.create(null);return!p||!S||Object.keys(S).forEach(c=>{const i=p[c],o=S[c];m(i,o)||(f[c]=o)}),f}e.distinct=I;function v(p,S){const f=S.toLowerCase(),h=Object.keys(p).find(c=>c.toLowerCase()===f);return h?p[h]:p[S]}e.getCaseInsensitive=v;function g(p,S){const f=Object.create(null);for(const[h,c]of Object.entries(p))S(h,c)&&(f[h]=c);return f}e.filter=g;function d(p){let S=[],f=Object.getPrototypeOf(p);for(;Object.prototype!==f;)S=S.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return S}e.getAllPropertyNames=d;function E(p){const S=[];for(const f of d(p))typeof p[f]=="function"&&S.push(f);return S}e.getAllMethodNames=E;function b(p,S){const f=c=>function(){const i=Array.prototype.slice.call(arguments,0);return S(c,i)},h={};for(const c of p)h[c]=f(c);return h}e.createProxyObject=b}),define(J[28],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return w.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let u=0;u<y.length;u++)y[u]=Math.floor(Math.random()*256);return y};const R=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,m="";return m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m}}()}),define(J[128],Z([0,1,76,29,49]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,y){if(await new Promise((C,I)=>{const v=t.createReadStream(D),g=w.createHash("sha1");v.pipe(g);const d=(0,k.once)((E,b)=>{v.removeAllListeners(),g.removeAllListeners(),E?I(E):C(b)});v.once("error",d),v.once("end",d),g.once("error",d),g.once("data",E=>d(void 0,E.toString("hex")))})!==y)throw new Error("Hash mismatch")}e.checksum=R}),define(J[129],Z([0,1,30]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const y=D.replace(/\-/g,":").toLowerCase();return!t.has(y)}function R(){const D=(0,w.networkInterfaces)();for(const y in D){const u=D[y];if(u){for(const{mac:m}of u)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(J[92],Z([0,1,77]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(y,u,m,C=1){let I=!1;return new Promise(v=>{const g=setTimeout(()=>{if(!I)return I=!0,v(0)},m);k(y,u,C,d=>{if(!I)return I=!0,clearTimeout(g),v(d)})})}e.findFreePort=t;function k(y,u,m,C){if(u===0)return C(0);const I=new w.Socket;I.once("connect",()=>(D(I),k(y+m,u-1,m,C))),I.once("data",()=>{}),I.once("error",v=>(D(I),v.code!=="ECONNREFUSED"?k(y+m,u-1,m,C):C(y))),I.connect(y,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(y,u,m){let C=!1,I,v=1;const g=w.createServer({pauseOnConnect:!0});function d(E,b){C||(C=!0,g.removeAllListeners(),g.close(),I&&clearTimeout(I),b(E))}return new Promise(E=>{I=setTimeout(()=>{d(0,E)},m),g.on("listening",()=>{d(y,E)}),g.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&v<u?(y++,v++,g.listen(y,"127.0.0.1")):d(0,E)}),g.on("close",()=>{d(0,E)}),g.listen(y,"127.0.0.1")})}e.findFreePortFaster=R;function D(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(u){console.error(u)}}}),define(J[130],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[131],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(J[40],Z([0,1,15,18]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,y){const u=(m,...C)=>{this.validateEvent(D,m)&&y(m,...C)};return this.mapListenerToWrapper.set(y,u),w.ipcMain.on(D,u),this}once(D,y){return w.ipcMain.once(D,(u,...m)=>{this.validateEvent(D,u)&&y(u,...m)}),this}handle(D,y){return w.ipcMain.handle(D,(u,...m)=>this.validateEvent(D,u)?y(u,...m):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return w.ipcMain.removeHandler(D),this}removeListener(D,y){const u=this.mapListenerToWrapper.get(y);return u&&(w.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(y)),this}validateEvent(D,y){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=y.senderFrame,m=u.url;if(!m)return!0;let C="unknown";try{C=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${m}'.`),!1}return C!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${C}'.`),!1):u.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${C}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(J[132],Z([0,1,15,40,12,130]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(u,m,C,I,v)=>{const g=y(u,I,C);g.popup({window:(0,k.withNullAsUndefined)(w.BrowserWindow.fromWebContents(u.sender)),x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{g&&u.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=D;function y(u,m,C){const I=new w.Menu;return C.forEach(v=>{let g;v.type==="separator"?g=new w.MenuItem({type:v.type}):Array.isArray(v.submenu)?g=new w.MenuItem({submenu:y(u,m,v.submenu),label:v.label}):g=new w.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(d,E,b)=>u.sender.send(m,v.id,b)}),I.append(g)}),I}}),define(J[133],Z([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[134],Z([0,1,133]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,y=R*30,u=R*365;function m(I,v,g){typeof I!="number"&&(I=I.getTime());const d=Math.round((new Date().getTime()-I)/1e3);if(d<-30)return(0,w.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,w.localize)(1,null);let E;return d<t?(E=d,v?E===1?g?(0,w.localize)(2,null,E):(0,w.localize)(3,null,E):g?(0,w.localize)(4,null,E):(0,w.localize)(5,null,E):E===1?g?(0,w.localize)(6,null,E):(0,w.localize)(7,null,E):g?(0,w.localize)(8,null,E):(0,w.localize)(9,null,E)):d<k?(E=Math.floor(d/t),v?E===1?g?(0,w.localize)(10,null,E):(0,w.localize)(11,null,E):g?(0,w.localize)(12,null,E):(0,w.localize)(13,null,E):E===1?g?(0,w.localize)(14,null,E):(0,w.localize)(15,null,E):g?(0,w.localize)(16,null,E):(0,w.localize)(17,null,E)):d<R?(E=Math.floor(d/k),v?E===1?g?(0,w.localize)(18,null,E):(0,w.localize)(19,null,E):g?(0,w.localize)(20,null,E):(0,w.localize)(21,null,E):E===1?g?(0,w.localize)(22,null,E):(0,w.localize)(23,null,E):g?(0,w.localize)(24,null,E):(0,w.localize)(25,null,E)):d<D?(E=Math.floor(d/R),v?E===1?(0,w.localize)(26,null,E):(0,w.localize)(27,null,E):E===1?(0,w.localize)(28,null,E):(0,w.localize)(29,null,E)):d<y?(E=Math.floor(d/D),v?E===1?g?(0,w.localize)(30,null,E):(0,w.localize)(31,null,E):g?(0,w.localize)(32,null,E):(0,w.localize)(33,null,E):E===1?g?(0,w.localize)(34,null,E):(0,w.localize)(35,null,E):g?(0,w.localize)(36,null,E):(0,w.localize)(37,null,E)):d<u?(E=Math.floor(d/y),v?E===1?g?(0,w.localize)(38,null,E):(0,w.localize)(39,null,E):g?(0,w.localize)(40,null,E):(0,w.localize)(41,null,E):E===1?g?(0,w.localize)(42,null,E):(0,w.localize)(43,null,E):g?(0,w.localize)(44,null,E):(0,w.localize)(45,null,E)):(E=Math.floor(d/u),v?E===1?g?(0,w.localize)(46,null,E):(0,w.localize)(47,null,E):g?(0,w.localize)(48,null,E):(0,w.localize)(49,null,E):E===1?g?(0,w.localize)(50,null,E):(0,w.localize)(51,null,E):g?(0,w.localize)(52,null,E):(0,w.localize)(53,null,E))}e.fromNow=m;function C(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(J[135],Z([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[44],Z([0,1,24,12,135]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,v){return v&&(I.stack||I.stacktrace)?k.localize(0,null,y(I),D(I.stack)||D(I.stacktrace)):y(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function y(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function u(I=null,v=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const g=w.coalesce(I),d=u(g[0],v);return g.length>1?k.localize(4,null,d,g.length):d}if(t.isString(I))return I;if(I.detail){const g=I.detail;if(g.error)return R(g.error,v);if(g.exception)return R(g.exception,v)}return I.stack?R(I,v):I.message?I.message:k.localize(5,null)}e.toErrorMessage=u;function m(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=m;function C(I,v){let g;return typeof I=="string"?g=new Error(I):g=I,g.actions=v,g}e.createErrorWithActions=C}),define(J[136],Z([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(J[137],Z([0,1,136]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(J[138],Z([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(J[4],Z([0,1,138]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,D=!1,y=!1,u=!1,m=!1,C=!1,I=!1,v=!1,g,d=t,E,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const S=typeof p?.versions?.electron=="string",f=S&&p?.type==="renderer";if(typeof navigator=="object"&&!f)b=navigator.userAgent,k=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,I=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=b.indexOf("Linux")>=0,m=!0,g=w.getConfiguredDefaultLocale(w.localize(0,null))||t,d=g;else if(typeof p=="object"){k=p.platform==="win32",R=p.platform==="darwin",D=p.platform==="linux",y=D&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,C=S,v=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,d=t;const l=p.env.VSCODE_NLS_CONFIG;if(l)try{const P=JSON.parse(l),M=P.availableLanguages["*"];g=P.locale,d=M||t,E=P._translationsConfigFile}catch{}u=!0}else console.error("Unable to resolve platform.");var h;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let i=0;R?i=1:k?i=3:D&&(i=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=y,e.isNative=u,e.isElectron=C,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isCI=v,e.platform=i,e.userAgent=b,e.language=d;var o;(function(l){function P(){return e.language}l.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=M;function T(){return e.language==="en"}l.isDefault=T})(o=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,F=l.length;T<F;T++){const U=l[T];if(U.id===M.data.vscodeScheduleAsyncWork){l.splice(T,1),U.callback();return}}});let P=0;return M=>{const T=++P;l.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return l=>setTimeout(l)})();var n;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:k?1:3;let r=!0,s=!1;function a(){if(!s){s=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,r=new Uint16Array(l.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[34],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const k=w.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(J[9],Z([0,1,34]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,y=46,u=47,m=92,C=58,I=63;class v extends Error{constructor(h,c,i){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const n=h.indexOf(".")!==-1?"property":"argument";let r=`The "${h}" ${n} ${o} of type ${c}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(f,h){if(typeof f!="string")throw new v(h,"string",f)}function d(f){return f===u||f===m}function E(f){return f===u}function b(f){return f>=t&&f<=R||f>=k&&f<=D}function p(f,h,c,i){let o="",n=0,r=-1,s=0,a=0;for(let l=0;l<=f.length;++l){if(l<f.length)a=f.charCodeAt(l);else{if(i(a))break;a=u}if(i(a)){if(!(r===l-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==y||o.charCodeAt(o.length-2)!==y){if(o.length>2){const P=o.lastIndexOf(c);P===-1?(o="",n=0):(o=o.slice(0,P),n=o.length-1-o.lastIndexOf(c)),r=l,s=0;continue}else if(o.length!==0){o="",n=0,r=l,s=0;continue}}h&&(o+=o.length>0?`${c}..`:"..",n=2)}else o.length>0?o+=`${c}${f.slice(r+1,l)}`:o=f.slice(r+1,l),n=l-r-1;r=l,s=0}else a===y&&s!==-1?++s:s=-1}return o}function S(f,h){if(h===null||typeof h!="object")throw new v("pathObject","Object",h);const c=h.dir||h.root,i=h.base||`${h.name||""}${h.ext||""}`;return c?c===h.root?`${c}${i}`:`${c}${f}${i}`:i}e.win32={resolve(...f){let h="",c="",i=!1;for(let o=f.length-1;o>=-1;o--){let n;if(o>=0){if(n=f[o],g(n,"path"),n.length===0)continue}else h.length===0?n=w.cwd():(n=w.env[`=${h}`]||w.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==h.toLowerCase()&&n.charCodeAt(2)===m)&&(n=`${h}\\`));const r=n.length;let s=0,a="",l=!1;const P=n.charCodeAt(0);if(r===1)d(P)&&(s=1,l=!0);else if(d(P))if(l=!0,d(n.charCodeAt(1))){let M=2,T=M;for(;M<r&&!d(n.charCodeAt(M));)M++;if(M<r&&M!==T){const F=n.slice(T,M);for(T=M;M<r&&d(n.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&!d(n.charCodeAt(M));)M++;(M===r||M!==T)&&(a=`\\\\${F}\\${n.slice(T,M)}`,s=M)}}}else s=1;else b(P)&&n.charCodeAt(1)===C&&(a=n.slice(0,2),s=2,r>2&&d(n.charCodeAt(2))&&(l=!0,s=3));if(a.length>0)if(h.length>0){if(a.toLowerCase()!==h.toLowerCase())continue}else h=a;if(i){if(h.length>0)break}else if(c=`${n.slice(s)}\\${c}`,i=l,l&&h.length>0)break}return c=p(c,!i,"\\",d),i?`${h}\\${c}`:`${h}${c}`||"."},normalize(f){g(f,"path");const h=f.length;if(h===0)return".";let c=0,i,o=!1;const n=f.charCodeAt(0);if(h===1)return E(n)?"\\":f;if(d(n))if(o=!0,d(f.charCodeAt(1))){let s=2,a=s;for(;s<h&&!d(f.charCodeAt(s));)s++;if(s<h&&s!==a){const l=f.slice(a,s);for(a=s;s<h&&d(f.charCodeAt(s));)s++;if(s<h&&s!==a){for(a=s;s<h&&!d(f.charCodeAt(s));)s++;if(s===h)return`\\\\${l}\\${f.slice(a)}\\`;s!==a&&(i=`\\\\${l}\\${f.slice(a,s)}`,c=s)}}}else c=1;else b(n)&&f.charCodeAt(1)===C&&(i=f.slice(0,2),c=2,h>2&&d(f.charCodeAt(2))&&(o=!0,c=3));let r=c<h?p(f.slice(c),!o,"\\",d):"";return r.length===0&&!o&&(r="."),r.length>0&&d(f.charCodeAt(h-1))&&(r+="\\"),i===void 0?o?`\\${r}`:r:o?`${i}\\${r}`:`${i}${r}`},isAbsolute(f){g(f,"path");const h=f.length;if(h===0)return!1;const c=f.charCodeAt(0);return d(c)||h>2&&b(c)&&f.charCodeAt(1)===C&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let h,c;for(let n=0;n<f.length;++n){const r=f[n];g(r,"path"),r.length>0&&(h===void 0?h=c=r:h+=`\\${r}`)}if(h===void 0)return".";let i=!0,o=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++o;const n=c.length;n>1&&d(c.charCodeAt(1))&&(++o,n>2&&(d(c.charCodeAt(2))?++o:i=!1))}if(i){for(;o<h.length&&d(h.charCodeAt(o));)o++;o>=2&&(h=`\\${h.slice(o)}`)}return e.win32.normalize(h)},relative(f,h){if(g(f,"from"),g(h,"to"),f===h)return"";const c=e.win32.resolve(f),i=e.win32.resolve(h);if(c===i||(f=c.toLowerCase(),h=i.toLowerCase(),f===h))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===m;)o++;let n=f.length;for(;n-1>o&&f.charCodeAt(n-1)===m;)n--;const r=n-o;let s=0;for(;s<h.length&&h.charCodeAt(s)===m;)s++;let a=h.length;for(;a-1>s&&h.charCodeAt(a-1)===m;)a--;const l=a-s,P=r<l?r:l;let M=-1,T=0;for(;T<P;T++){const U=f.charCodeAt(o+T);if(U!==h.charCodeAt(s+T))break;U===m&&(M=T)}if(T!==P){if(M===-1)return i}else{if(l>P){if(h.charCodeAt(s+T)===m)return i.slice(s+T+1);if(T===2)return i.slice(s+T)}r>P&&(f.charCodeAt(o+T)===m?M=T:T===2&&(M=3)),M===-1&&(M=0)}let F="";for(T=o+M+1;T<=n;++T)(T===n||f.charCodeAt(T)===m)&&(F+=F.length===0?"..":"\\..");return s+=M,F.length>0?`${F}${i.slice(s,a)}`:(i.charCodeAt(s)===m&&++s,i.slice(s,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const h=e.win32.resolve(f);if(h.length<=2)return f;if(h.charCodeAt(0)===m){if(h.charCodeAt(1)===m){const c=h.charCodeAt(2);if(c!==I&&c!==y)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(b(h.charCodeAt(0))&&h.charCodeAt(1)===C&&h.charCodeAt(2)===m)return`\\\\?\\${h}`;return f},dirname(f){g(f,"path");const h=f.length;if(h===0)return".";let c=-1,i=0;const o=f.charCodeAt(0);if(h===1)return d(o)?f:".";if(d(o)){if(c=i=1,d(f.charCodeAt(1))){let s=2,a=s;for(;s<h&&!d(f.charCodeAt(s));)s++;if(s<h&&s!==a){for(a=s;s<h&&d(f.charCodeAt(s));)s++;if(s<h&&s!==a){for(a=s;s<h&&!d(f.charCodeAt(s));)s++;if(s===h)return f;s!==a&&(c=i=s+1)}}}}else b(o)&&f.charCodeAt(1)===C&&(c=h>2&&d(f.charCodeAt(2))?3:2,i=c);let n=-1,r=!0;for(let s=h-1;s>=i;--s)if(d(f.charCodeAt(s))){if(!r){n=s;break}}else r=!1;if(n===-1){if(c===-1)return".";n=c}return f.slice(0,n)},basename(f,h){h!==void 0&&g(h,"ext"),g(f,"path");let c=0,i=-1,o=!0,n;if(f.length>=2&&b(f.charCodeAt(0))&&f.charCodeAt(1)===C&&(c=2),h!==void 0&&h.length>0&&h.length<=f.length){if(h===f)return"";let r=h.length-1,s=-1;for(n=f.length-1;n>=c;--n){const a=f.charCodeAt(n);if(d(a)){if(!o){c=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(a===h.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return c===i?i=s:i===-1&&(i=f.length),f.slice(c,i)}for(n=f.length-1;n>=c;--n)if(d(f.charCodeAt(n))){if(!o){c=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":f.slice(c,i)},extname(f){g(f,"path");let h=0,c=-1,i=0,o=-1,n=!0,r=0;f.length>=2&&f.charCodeAt(1)===C&&b(f.charCodeAt(0))&&(h=i=2);for(let s=f.length-1;s>=h;--s){const a=f.charCodeAt(s);if(d(a)){if(!n){i=s+1;break}continue}o===-1&&(n=!1,o=s+1),a===y?c===-1?c=s:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||o===-1||r===0||r===1&&c===o-1&&c===i+1?"":f.slice(c,o)},format:S.bind(null,"\\"),parse(f){g(f,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return h;const c=f.length;let i=0,o=f.charCodeAt(0);if(c===1)return d(o)?(h.root=h.dir=f,h):(h.base=h.name=f,h);if(d(o)){if(i=1,d(f.charCodeAt(1))){let M=2,T=M;for(;M<c&&!d(f.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&d(f.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!d(f.charCodeAt(M));)M++;M===c?i=M:M!==T&&(i=M+1)}}}}else if(b(o)&&f.charCodeAt(1)===C){if(c<=2)return h.root=h.dir=f,h;if(i=2,d(f.charCodeAt(2))){if(c===3)return h.root=h.dir=f,h;i=3}}i>0&&(h.root=f.slice(0,i));let n=-1,r=i,s=-1,a=!0,l=f.length-1,P=0;for(;l>=i;--l){if(o=f.charCodeAt(l),d(o)){if(!a){r=l+1;break}continue}s===-1&&(a=!1,s=l+1),o===y?n===-1?n=l:P!==1&&(P=1):n!==-1&&(P=-1)}return s!==-1&&(n===-1||P===0||P===1&&n===s-1&&n===r+1?h.base=h.name=f.slice(r,s):(h.name=f.slice(r,n),h.base=f.slice(r,s),h.ext=f.slice(n,s))),r>0&&r!==i?h.dir=f.slice(0,r-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let h="",c=!1;for(let i=f.length-1;i>=-1&&!c;i--){const o=i>=0?f[i]:w.cwd();g(o,"path"),o.length!==0&&(h=`${o}/${h}`,c=o.charCodeAt(0)===u)}return h=p(h,!c,"/",E),c?`/${h}`:h.length>0?h:"."},normalize(f){if(g(f,"path"),f.length===0)return".";const h=f.charCodeAt(0)===u,c=f.charCodeAt(f.length-1)===u;return f=p(f,!h,"/",E),f.length===0?h?"/":c?"./":".":(c&&(f+="/"),h?`/${f}`:f)},isAbsolute(f){return g(f,"path"),f.length>0&&f.charCodeAt(0)===u},join(...f){if(f.length===0)return".";let h;for(let c=0;c<f.length;++c){const i=f[c];g(i,"path"),i.length>0&&(h===void 0?h=i:h+=`/${i}`)}return h===void 0?".":e.posix.normalize(h)},relative(f,h){if(g(f,"from"),g(h,"to"),f===h||(f=e.posix.resolve(f),h=e.posix.resolve(h),f===h))return"";const c=1,i=f.length,o=i-c,n=1,r=h.length-n,s=o<r?o:r;let a=-1,l=0;for(;l<s;l++){const M=f.charCodeAt(c+l);if(M!==h.charCodeAt(n+l))break;M===u&&(a=l)}if(l===s)if(r>s){if(h.charCodeAt(n+l)===u)return h.slice(n+l+1);if(l===0)return h.slice(n+l)}else o>s&&(f.charCodeAt(c+l)===u?a=l:l===0&&(a=0));let P="";for(l=c+a+1;l<=i;++l)(l===i||f.charCodeAt(l)===u)&&(P+=P.length===0?"..":"/..");return`${P}${h.slice(n+a)}`},toNamespacedPath(f){return f},dirname(f){if(g(f,"path"),f.length===0)return".";const h=f.charCodeAt(0)===u;let c=-1,i=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===u){if(!i){c=o;break}}else i=!1;return c===-1?h?"/":".":h&&c===1?"//":f.slice(0,c)},basename(f,h){h!==void 0&&g(h,"ext"),g(f,"path");let c=0,i=-1,o=!0,n;if(h!==void 0&&h.length>0&&h.length<=f.length){if(h===f)return"";let r=h.length-1,s=-1;for(n=f.length-1;n>=0;--n){const a=f.charCodeAt(n);if(a===u){if(!o){c=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(a===h.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return c===i?i=s:i===-1&&(i=f.length),f.slice(c,i)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===u){if(!o){c=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":f.slice(c,i)},extname(f){g(f,"path");let h=-1,c=0,i=-1,o=!0,n=0;for(let r=f.length-1;r>=0;--r){const s=f.charCodeAt(r);if(s===u){if(!o){c=r+1;break}continue}i===-1&&(o=!1,i=r+1),s===y?h===-1?h=r:n!==1&&(n=1):h!==-1&&(n=-1)}return h===-1||i===-1||n===0||n===1&&h===i-1&&h===c+1?"":f.slice(h,i)},format:S.bind(null,"/"),parse(f){g(f,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return h;const c=f.charCodeAt(0)===u;let i;c?(h.root="/",i=1):i=0;let o=-1,n=0,r=-1,s=!0,a=f.length-1,l=0;for(;a>=i;--a){const P=f.charCodeAt(a);if(P===u){if(!s){n=a+1;break}continue}r===-1&&(s=!1,r=a+1),P===y?o===-1?o=a:l!==1&&(l=1):o!==-1&&(l=-1)}if(r!==-1){const P=n===0&&c?1:n;o===-1||l===0||l===1&&o===r-1&&o===n+1?h.base=h.name=f.slice(P,r):(h.name=f.slice(P,o),h.base=f.slice(P,r),h.ext=f.slice(o,r))}return n>0?h.dir=f.slice(0,n-1):c&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[78],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(y,...u){const m=u.reduce((v,g)=>(v[g]=!0,v),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(v=>!m[v]).forEach(v=>{for(let g=0;g<C.length;g++)if(v.search(C[g])!==-1){delete y[v];break}})}e.sanitizeProcessEnvironment=R;function D(y){!y||(delete y.DEBUG,w.isMacintosh&&delete y.DYLD_LIBRARY_PATH,w.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(J[79],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=w.globals.performance&&typeof w.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[3],Z([0,1,18,49,2,126,79]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,u=!1;var m;(function(a){a.None=()=>k.Disposable.None;function l(O){if(u){const{onListenerDidAdd:N}=O,V=d.create();let Q=0;O.onListenerDidAdd=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),N?.()}}}function P(O){return(N,V=null,Q)=>{let ne=!1,j;return j=O(te=>{if(!ne)return j?j.dispose():ne=!0,N.call(V,te)},null,Q),ne&&j.dispose(),j}}a.once=P;function M(O,N,V){return le((Q,ne=null,j)=>O(te=>Q.call(ne,N(te)),null,j),V)}a.map=M;function T(O,N,V){return le((Q,ne=null,j)=>O(te=>{N(te),Q.call(ne,te)},null,j),V)}a.forEach=T;function F(O,N,V){return le((Q,ne=null,j)=>O(te=>N(te)&&Q.call(ne,te),null,j),V)}a.filter=F;function U(O){return O}a.signal=U;function x(...O){return(N,V=null,Q)=>(0,k.combinedDisposable)(...O.map(ne=>ne(j=>N.call(V,j),null,Q)))}a.any=x;function re(O,N,V,Q){let ne=V;return M(O,j=>(ne=N(ne,j),ne),Q)}a.reduce=re;function le(O,N){let V;const Q={onFirstListenerAdd(){V=O(ne.fire,ne)},onLastListenerRemove(){V?.dispose()}};N||l(Q);const ne=new b(Q);return N?.add(ne),ne.event}function ue(O,N,V=100,Q=!1,ne,j){let te,ie,ce,fe=0;const ke={leakWarningThreshold:ne,onFirstListenerAdd(){te=O(Pe=>{fe++,ie=N(ie,Pe),Q&&!ce&&(Le.fire(ie),ie=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ie;ie=void 0,ce=void 0,(!Q||fe>1)&&Le.fire(Ae),fe=0},V)})},onLastListenerRemove(){te.dispose()}};j||l(ke);const Le=new b(ke);return j?.add(Le),Le.event}a.debounce=ue;function se(O,N=(Q,ne)=>Q===ne,V){let Q=!0,ne;return F(O,j=>{const te=Q||!N(j,ne);return Q=!1,ne=j,te},V)}a.latch=se;function de(O,N,V){return[a.filter(O,N,V),a.filter(O,Q=>!N(Q),V)]}a.split=de;function K(O,N=!1,V=[]){let Q=V.slice(),ne=O(ie=>{Q?Q.push(ie):te.fire(ie)});const j=()=>{Q?.forEach(ie=>te.fire(ie)),Q=null},te=new b({onFirstListenerAdd(){ne||(ne=O(ie=>te.fire(ie)))},onFirstListenerDidAdd(){Q&&(N?setTimeout(j):j())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return te.event}a.buffer=K;class ${constructor(N){this.event=N,this.disposables=new k.DisposableStore}map(N){return new $(M(this.event,N,this.disposables))}forEach(N){return new $(T(this.event,N,this.disposables))}filter(N){return new $(F(this.event,N,this.disposables))}reduce(N,V){return new $(re(this.event,N,V,this.disposables))}latch(){return new $(se(this.event,void 0,this.disposables))}debounce(N,V=100,Q=!1,ne){return new $(ue(this.event,N,V,Q,ne,this.disposables))}on(N,V,Q){return this.event(N,V,Q)}once(N,V,Q){return P(this.event)(N,V,Q)}dispose(){this.disposables.dispose()}}function _(O){return new $(O)}a.chain=_;function A(O,N,V=Q=>Q){const Q=(...ie)=>te.fire(V(...ie)),ne=()=>O.on(N,Q),j=()=>O.removeListener(N,Q),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}a.fromNodeEventEmitter=A;function W(O,N,V=Q=>Q){const Q=(...ie)=>te.fire(V(...ie)),ne=()=>O.addEventListener(N,Q),j=()=>O.removeEventListener(N,Q),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}a.fromDOMEventEmitter=W;function z(O){return new Promise(N=>P(O)(N))}a.toPromise=z;function ee(O,N){return N(void 0),O(V=>N(V))}a.runAndSubscribe=ee;function B(O,N){let V=null;function Q(j){V?.dispose(),V=new k.DisposableStore,N(j,V)}Q(void 0);const ne=O(j=>Q(j));return(0,k.toDisposable)(()=>{ne.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=B;class H{constructor(N,V){this.obs=N,this._counter=0,this._hasChanged=!1;const Q={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};V||l(Q),this.emitter=new b(Q),V&&V.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,V){this._hasChanged=!0}endUpdate(N){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,N){return new H(O,N).emitter.event}a.fromObservable=L})(m=e.Event||(e.Event={}));class C{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${C._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let I=-1;function v(a){const l=I;return I=a,{dispose(){I=l}}}e.setGlobalLeakWarningThreshold=v;class g{constructor(l,P=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,P){let M=I;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let F,U=0;for(const[x,re]of this._stacks)(!F||U<re)&&(F=x,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(F)}return()=>{const F=this._stacks.get(l.value)||0;this._stacks.set(l.value,F-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(l,P,M){this.callback=l,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class b{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=I>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const P of l)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let F,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),F=this._leakageMon.check(U,this._listeners.size+1)),y&&(U=U??d.create());const x=new E(l,P,U),re=this._listeners.push(x);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,P);const le=x.subscription.set(()=>{F?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(le):Array.isArray(M)&&M.push(le),le}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const P of this._listeners)this._deliveryQueue.push(this,P,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,P,M){this._queue.push(new f(l,P,M))}clear(l){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==l&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(P){(0,w.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=p;class S extends p{clear(l){this._queue.clear()}}class f{constructor(l,P,M){this.emitter=l,this.listener=P,this.event=M}}class h extends b{async fireAsync(l,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,l]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,F]=this._asyncDeliveryQueue.shift(),U=[],x={...F,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(re=M(re,T.callback)),U.push(re)}};try{T.invoke(x)}catch(re){(0,w.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const le of re)le.status==="rejected"&&(0,w.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=h;class c extends b{constructor(l){super(l),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class i extends c{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=i;class o extends b{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]})}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const P={event:l,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(P=>this.emitter.fire(P))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class r{constructor(){this.buffers=[]}wrapEvent(l){return(P,M,T)=>l(F=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(M,F)):P.call(M,F)},void 0,T)}bufferEvents(l){const P=[];this.buffers.push(P);const M=l();return this.buffers.pop(),P.forEach(T=>T()),M}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(J[22],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,u){const m=setTimeout(y.bind(u),0);return{dispose(){clearTimeout(m)}}});var k;(function(y){function u(m){return m===y.None||m===y.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}y.isCancellationToken=u,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(J[139],Z([0,1,22]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new w.CancellationTokenSource,u=this.task(y.token);return this.result={promise:u,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class k{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const u=JSON.stringify(y);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const u=this.fn(y);return this._map.set(y,u),u}}e.CachedFunction=R}),define(J[93],Z([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:w.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{constructor(y){super(),this._value=y,this.changeEmitter=this._register(new w.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=R}),define(J[25],Z([0,1,139,125]),function(q,e,w,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function y(G,...ae){return ae.length===0?G:G.replace(D,function(pe,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=ae.length?pe:ae[Se]})}e.format=y;const u=/{([^}]+)}/g;function m(G,ae){return G.replace(u,(pe,ge)=>ae[ge]??pe)}e.format2=m;function C(G){return G.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=C;function I(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function v(G,ae){let pe=0;const ge=ae.charCodeAt(0);for(let Se=G.length-1;Se>=0;Se--)G.charCodeAt(Se)===ge&&pe++;return pe}e.count=v;function g(G,ae,pe="\u2026"){return G.length<=ae?G:`${G.substr(0,ae)}${pe}`}e.truncate=g;function d(G,ae=" "){const pe=E(G,ae);return b(pe,ae)}e.trim=d;function E(G,ae){if(!G||!ae)return G;const pe=ae.length;if(pe===0||G.length===0)return G;let ge=0;for(;G.indexOf(ae,ge)===ge;)ge=ge+pe;return G.substring(ge)}e.ltrim=E;function b(G,ae){if(!G||!ae)return G;const pe=ae.length,ge=G.length;if(pe===0||ge===0)return G;let Se=ge,De=-1;for(;De=G.lastIndexOf(ae,Se-1),!(De===-1||De+pe!==Se);){if(De===0)return"";Se=De}return G.substring(0,Se)}e.rtrim=b;function p(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function S(G){return G.replace(/\*/g,"")}e.stripWildcards=S;function f(G,ae,pe={}){if(!G)throw new Error("Cannot create regex from empty string");ae||(G=I(G)),pe.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let ge="";return pe.global&&(ge+="g"),pe.matchCase||(ge+="i"),pe.multiline&&(ge+="m"),pe.unicode&&(ge+="u"),new RegExp(G,ge)}e.createRegExp=f;function h(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function i(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=i;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function n(G){for(let ae=0,pe=G.length;ae<pe;ae++){const ge=G.charCodeAt(ae);if(ge!==32&&ge!==9)return ae}return-1}e.firstNonWhitespaceIndex=n;function r(G,ae=0,pe=G.length){for(let ge=ae;ge<pe;ge++){const Se=G.charCodeAt(ge);if(Se!==32&&Se!==9)return G.substring(ae,ge)}return G.substring(ae,pe)}e.getLeadingWhitespace=r;function s(G,ae=G.length-1){for(let pe=ae;pe>=0;pe--){const ge=G.charCodeAt(pe);if(ge!==32&&ge!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function a(G,ae,pe){const ge=[];let Se=0;for(const De of G.matchAll(ae)){if(ge.push(G.slice(Se,De.index)),De.index===void 0)throw new Error("match.index should be defined");Se=De.index+De[0].length,ge.push(pe(De[0],...De.slice(1),De.index,G,De.groups))}return ge.push(G.slice(Se)),Promise.all(ge).then(De=>De.join(""))}e.replaceAsync=a;function l(G,ae){return G<ae?-1:G>ae?1:0}e.compare=l;function P(G,ae,pe=0,ge=G.length,Se=0,De=ae.length){for(;pe<ge&&Se<De;pe++,Se++){const tt=G.charCodeAt(pe),Ge=ae.charCodeAt(Se);if(tt<Ge)return-1;if(tt>Ge)return 1}const We=ge-pe,Qe=De-Se;return We<Qe?-1:We>Qe?1:0}e.compareSubstring=P;function M(G,ae){return T(G,ae,0,G.length,0,ae.length)}e.compareIgnoreCase=M;function T(G,ae,pe=0,ge=G.length,Se=0,De=ae.length){for(;pe<ge&&Se<De;pe++,Se++){let tt=G.charCodeAt(pe),Ge=ae.charCodeAt(Se);if(tt===Ge)continue;if(tt>=128||Ge>=128)return P(G.toLowerCase(),ae.toLowerCase(),pe,ge,Se,De);U(tt)&&(tt-=32),U(Ge)&&(Ge-=32);const Ye=tt-Ge;if(Ye!==0)return Ye}const We=ge-pe,Qe=De-Se;return We<Qe?-1:We>Qe?1:0}e.compareSubstringIgnoreCase=T;function F(G){return G>=48&&G<=57}e.isAsciiDigit=F;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function x(G){return G>=65&&G<=90}e.isUpperAsciiLetter=x;function re(G,ae){return G.length===ae.length&&T(G,ae)===0}e.equalsIgnoreCase=re;function le(G,ae){const pe=ae.length;return ae.length>G.length?!1:T(G,ae,0,pe)===0}e.startsWithIgnoreCase=le;function ue(G,ae){const pe=Math.min(G.length,ae.length);let ge;for(ge=0;ge<pe;ge++)if(G.charCodeAt(ge)!==ae.charCodeAt(ge))return ge;return pe}e.commonPrefixLength=ue;function se(G,ae){const pe=Math.min(G.length,ae.length);let ge;const Se=G.length-1,De=ae.length-1;for(ge=0;ge<pe;ge++)if(G.charCodeAt(Se-ge)!==ae.charCodeAt(De-ge))return ge;return pe}e.commonSuffixLength=se;function de(G){return 55296<=G&&G<=56319}e.isHighSurrogate=de;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function $(G,ae){return(G-55296<<10)+(ae-56320)+65536}e.computeCodePoint=$;function _(G,ae,pe){const ge=G.charCodeAt(pe);if(de(ge)&&pe+1<ae){const Se=G.charCodeAt(pe+1);if(K(Se))return $(ge,Se)}return ge}e.getNextCodePoint=_;function A(G,ae){const pe=G.charCodeAt(ae-1);if(K(pe)&&ae>1){const ge=G.charCodeAt(ae-2);if(de(ge))return $(ge,pe)}return pe}class W{constructor(ae,pe=0){this._str=ae,this._len=ae.length,this._offset=pe}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=A(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=_(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class z{constructor(ae,pe=0){this._iterator=new W(ae,pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=Ce.getInstance(),pe=this._iterator,ge=pe.offset;let Se=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const De=pe.offset,We=ae.getGraphemeBreakType(pe.nextCodePoint());if(he(Se,We)){pe.setOffset(De);break}Se=We}return pe.offset-ge}prevGraphemeLength(){const ae=Ce.getInstance(),pe=this._iterator,ge=pe.offset;let Se=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const De=pe.offset,We=ae.getGraphemeBreakType(pe.prevCodePoint());if(he(We,Se)){pe.setOffset(De);break}Se=We}return ge-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function ee(G,ae){return new z(G,ae).nextGraphemeLength()}e.nextCharLength=ee;function B(G,ae){return new z(G,ae).prevGraphemeLength()}e.prevCharLength=B;function H(G,ae){ae>0&&K(G.charCodeAt(ae))&&ae--;const pe=ae+ee(G,ae);return[pe-B(G,pe),pe]}e.getCharContainingOffset=H;let L;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(G){return L||(L=O()),L.test(G)}e.containsRTL=N;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(G){return V.test(G)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=ne;function j(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=j;function te(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=te;function ie(G,ae){if(G.length<ae)return G;const pe=/\b/g;let ge=0;for(;pe.test(G)&&!(G.length-pe.lastIndex<ae);)ge=pe.lastIndex,pe.lastIndex+=1;return G.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function Le(G){return G&&(G=G.replace(ce,""),G=G.replace(fe,""),G=G.replace(ke,"")),G}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Ae(G){return Pe(G)?G.substr(1):G}e.stripUTF8BOM=Ae;function Ke(G,ae){if(!G||!ae||G.length<ae.length)return!1;const pe=ae.length,ge=G.toLowerCase();let Se=0,De=-1;for(;Se<pe;){const We=ge.indexOf(ae[Se],De+1);if(We<0)return!1;De=We,Se++}return!0}e.fuzzyContains=Ke;function me(G,ae=!1){return G?(ae&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=me;function we(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=we;function be(G,ae=1){if(ae===0)return"";let pe=-1;do pe=G.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?G:(G[pe-1]==="\r"&&pe--,G.substr(0,pe))}e.getNLines=be;function X(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=X;function oe(G){return Ce.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=oe;function he(G,ae){return G===0?ae!==5&&ae!==7:G===2&&ae===3?!1:G===4||G===2||G===3||ae===4||ae===2||ae===3?!0:!(G===8&&(ae===8||ae===9||ae===11||ae===12)||(G===11||G===9)&&(ae===9||ae===10)||(G===12||G===10)&&ae===10||ae===5||ae===13||ae===7||G===1||G===13&&ae===14||G===6&&ae===6)}var ye;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=Te()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this._data,ge=pe.length/3;let Se=1;for(;Se<=ge;)if(ae<pe[3*Se])Se=2*Se;else if(ae>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}Ce._INSTANCE=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(G,ae){if(G===0)return 0;const pe=Ne(G,ae);if(pe!==void 0)return pe;const ge=new W(ae,G);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=Oe;function Ne(G,ae){const pe=new W(ae,G);let ge=pe.prevCodePoint();for(;ze(ge)||ge===65039||ge===8419;){if(pe.offset===0)return;ge=pe.prevCodePoint()}if(!te(ge))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function ze(G){return 127995<=G&&G<=127999}var $e;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class Be{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return Be.cache.get(Array.from(ae))}static getLocales(){return Be._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new w.LRUCachedFunction(G=>{function ae(Ge){const Ye=new Map;for(let it=0;it<Ge.length;it+=2)Ye.set(Ge[it],Ge[it+1]);return Ye}function pe(Ge,Ye){const it=new Map(Ge);for(const[ot,ht]of Ye)it.set(ot,ht);return it}function ge(Ge,Ye){if(!Ge)return Ye;const it=new Map;for(const[ot,ht]of Ge)Ye.has(ot)&&it.set(ot,ht);return it}const Se=k.ambiguousCharacterData.getValue();let De=G.filter(Ge=>!Ge.startsWith("_")&&Ge in Se);De.length===0&&(De=["_default"]);let We;for(const Ge of De){const Ye=ae(Se[Ge]);We=ge(We,Ye)}const Qe=ae(Se._common),tt=pe(Qe,We);return new Be(tt)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(ae){return qe.getData().has(ae)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(J[31],Z([0,1,9,4,25,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function y(s){return s.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=y;function u(s){return s.indexOf("/")===-1&&(s=y(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=u;function m(s,a=w.posix.sep){if(!s)return"";const l=s.length,P=s.charCodeAt(0);if(D(P)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const F=T;for(;T<l&&!D(s.charCodeAt(T));T++);if(F!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<l;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(p(P)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<l;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=m;function C(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let l=2;const P=l;for(;l<s.length&&(a=s.charCodeAt(l),a!==92);l++);return!(P===l||(a=s.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=C;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=t.isWindows){const l=a?I:v;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||a&&g.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function E(s,a,l){const P=s===a;return!l||P?P:!s||!a?!1:(0,k.equalsIgnoreCase)(s,a)}e.isEqual=E;function b(s,a,l,P=w.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let T=a.length;return a.charAt(a.length-1)===P&&T--,s.charAt(T)===P}return a.charAt(a.length-1)!==P&&(a+=P),s.indexOf(a)===0}e.isEqualOrParent=b;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function S(s,a){return t.isWindows&&s.endsWith(":")&&(s+=w.sep),(0,w.isAbsolute)(s)||(s=(0,w.join)(a,s)),s=(0,w.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,w.sep),s.endsWith(":")&&(s+=w.sep)):(s=(0,k.rtrim)(s,w.sep),s||(s=w.sep)),s}e.sanitizeFilePath=S;function f(s){const a=(0,w.normalize)(s);return t.isWindows?s.length>3?!1:h(a)&&(s.length===2||a.charCodeAt(2)===92):a===w.posix.sep}e.isRootOrDriveLetter=f;function h(s,a=t.isWindows){return a?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function c(s){return h(s)?s[0]:void 0}e.getDriveLetter=c;function i(s,a,l){return a.length>s.length?-1:s===a?0:(l&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function o(s){const a=s.split(":");let l,P,M;for(const T of a){const F=Number(T);(0,R.isNumber)(F)?P===void 0?P=F:M===void 0&&(M=F):l=l?[l,T].join(":"):T}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,a,l=8){let P="";for(let T=0;T<l;T++)P+=n.charAt(Math.floor(Math.random()*n.length));let M;return a?M=`${a}-${P}`:M=P,s?(0,w.join)(s,M):M}e.randomPath=r}),define(J[66],Z([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,S){switch(typeof p){case"object":return p===null?R(349,S):Array.isArray(p)?u(p,S):m(p,S);case"string":return y(p,S);case"boolean":return D(p,S);case"number":return R(p,S);case"undefined":return R(937,S);default:return R(617,S)}}e.doHash=k;function R(p,S){return(S<<5)-S+p|0}e.numberHash=R;function D(p,S){return R(p?433:863,S)}function y(p,S){S=R(149417,S);for(let f=0,h=p.length;f<h;f++)S=R(p.charCodeAt(f),S);return S}e.stringHash=y;function u(p,S){return S=R(104579,S),p.reduce((f,h)=>k(h,f),S)}function m(p,S){return S=R(181387,S),Object.keys(p).sort().reduce((f,h)=>(f=y(h,f),k(p[h],f)),S)}class C{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=C;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(p,S,f=32){const h=f-S,c=~((1<<h)-1);return(p<<S|(c&p)>>>h)>>>0}function g(p,S=0,f=p.byteLength,h=0){for(let c=0;c<f;c++)p[S+c]=h}function d(p,S,f="0"){for(;p.length<S;)p=f+p;return p}function E(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),S/4)}e.toHexString=E;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f===0)return;const h=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=S.charCodeAt(0),n=0);;){let r=o;if(w.isHighSurrogate(o))if(n+1<f){const s=S.charCodeAt(n+1);w.isLowSurrogate(s)?(n++,r=w.computeCodePoint(o,s)):r=65533}else{i=o;break}else w.isLowSurrogate(o)&&(r=65533);if(c=this._push(h,c,r),n++,n<f)o=S.charCodeAt(n);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(S,f,h){return h<128?S[f++]=h:h<2048?(S[f++]=192|(h&1984)>>>6,S[f++]=128|(h&63)>>>0):h<65536?(S[f++]=224|(h&61440)>>>12,S[f++]=128|(h&4032)>>>6,S[f++]=128|(h&63)>>>0):(S[f++]=240|(h&1835008)>>>18,S[f++]=128|(h&258048)>>>12,S[f++]=128|(h&4032)>>>6,S[f++]=128|(h&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=b._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)S.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)S.setUint32(l,v(S.getUint32(l-12,!1)^S.getUint32(l-32,!1)^S.getUint32(l-56,!1)^S.getUint32(l-64,!1),1),!1);let h=this._h0,c=this._h1,i=this._h2,o=this._h3,n=this._h4,r,s,a;for(let l=0;l<80;l++)l<20?(r=c&i|~c&o,s=1518500249):l<40?(r=c^i^o,s=1859775393):l<60?(r=c&i|c&o|i&o,s=2400959708):(r=c^i^o,s=3395469782),a=v(h,5)+r+n+s+S.getUint32(l*4,!1)&4294967295,n=o,o=i,i=v(c,30),c=h,h=a;this._h0=this._h0+h&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[32],Z([0,1,24,25]),function(q,e,w,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(n,r,s){let a=n.get(r);return a===void 0&&(a=s,n.set(r,a)),a}e.getOrSet=y;function u(n){const r=[];return n.forEach((s,a)=>{r.push(`${a} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=u;function m(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=m;class C{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=C;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class v{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var g;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(g||(g={}));class d{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(b||(b={}));class p{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new p(new d(r,s))}static forPaths(r=!1){return new p(new v(void 0,!r))}static forStrings(){return new p(new C)}static forConfigKeys(){return new p(new I)}clear(){this._root=void 0}fill(r,s){if(s){const a=s.slice(0);(0,w.shuffle)(a);for(const l of a)this.set(l,r)}else{const a=r.slice(0);(0,w.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(r,s){const a=this._iter.reset(r);let l;this._root||(this._root=new E,this._root.segment=a.value());const P=[];for(l=this._root;;){const T=a.cmp(l.segment);if(T>0)l.left||(l.left=new E,l.left.segment=a.value()),P.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new E,l.right.segment=a.value()),P.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new E,l.mid.segment=a.value()),P.push([0,l]),l=l.mid;else break}const M=l.value;l.value=s,l.key=r;for(let T=P.length-1;T>=0;T--){const F=P[T][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const x=P[T][0],re=P[T+1][0];if(x===1&&re===1)P[T][1]=F.rotateLeft();else if(x===-1&&re===-1)P[T][1]=F.rotateRight();else if(x===1&&re===-1)F.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=F.rotateLeft();else if(x===-1&&re===1)F.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=F.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return M}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const a=this._iter.reset(r),l=[];let P=this._root;for(;P;){const M=a.cmp(P.segment);if(M>0)l.push([-1,P]),P=P.left;else if(M<0)l.push([1,P]),P=P.right;else if(a.hasNext())a.next(),l.push([0,P]),P=P.mid;else break}if(!!P){if(s?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right),{key:T,value:F,segment:U}=M;this._delete(M.key,!1),P.key=T,P.value=F,P.segment=U}else{const M=P.left??P.right;if(l.length>0){const[T,F]=l[l.length-1];switch(T){case-1:F.left=M;break;case 0:F.mid=M;break;case 1:F.right=M;break}}else this._root=M}for(let M=l.length-1;M>=0;M--){const T=l[M][1];T.updateHeight();const F=T.balanceFactor();if(F>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),l[M][1]=T.rotateLeft()):F<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),l[M][1]=T.rotateRight()),M>0)switch(l[M-1][0]){case-1:l[M-1][1].left=l[M][1];break;case 1:l[M-1][1].right=l[M][1];break;case 0:l[M-1][1].mid=l[M][1];break}else this._root=l[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let a=this._root,l;for(;a;){const P=s.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(s.hasNext())s.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[s,a]of this)r(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=p;class S{constructor(r,s){this.uri=r,this.value=s}}class f{constructor(r,s){this[k]="ResourceMap",r instanceof f?(this.map=new Map(r.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=r??f.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new S(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[a,l]of this.map)r(l.value,l.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();class h{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new f(r):(this._map=new f(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((a,l)=>r.call(s,l,l,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class i{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const a=this._map.get(r);if(!!a)return s!==0&&this.touch(a,s),a.value}set(r,s,a=0){let l=this._map.get(r);if(l)l.value=s,a!==0&&this.touch(l,a);else{switch(l={key:r,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const a=this._state;let l=this._head;for(;l;){if(s?r.bind(s)(l.value,l.key,this):r(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}values(){const r=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}entries(){const r=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>r;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,a=r.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const a=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const a=r.next,l=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,a)=>{r.push([a,s])}),r}fromJSON(r){this.clear();for(const[s,a]of r)this.set(s,a)}}e.LinkedMap=i;class o extends i{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(J[80],Z([0,1,32]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new w.LRUCache(1e4);function k(m){return u(m,"NFC",t)}e.normalizeNFC=k;const R=new w.LRUCache(1e4);function D(m){return u(m,"NFD",R)}e.normalizeNFD=D;const y=/[^\u0000-\u0080]/;function u(m,C,I){if(!m)return m;const v=I.get(m);if(v)return v;let g;return y.test(m)?g=m.normalize(C):g=m,I.set(m,g),g}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(C){return D(C).replace(m,"")}}()}),define(J[94],Z([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",y="warn",u="info",m="ignore";function C(v){return v?w.equalsIgnoreCase(R,v)?k.Error:w.equalsIgnoreCase(D,v)||w.equalsIgnoreCase(y,v)?k.Warning:w.equalsIgnoreCase(u,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=C;function I(v){switch(v){case k.Error:return R;case k.Warning:return D;case k.Info:return u;default:return m}}k.toString=I}(t||(t={})),e.default=t}),define(J[7],Z([0,1,9,4]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function y(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(n,r){return!n&&!r?"file":n}function m(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const C="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,s,a,l,P,M=!1){typeof r=="object"?(this.scheme=r.scheme||C,this.authority=r.authority||C,this.path=r.path||C,this.query=r.query||C,this.fragment=r.fragment||C):(this.scheme=u(r,M),this.authority=s||C,this.path=m(this.scheme,a||C),this.query=l||C,this.fragment=P||C,y(this,M))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:a,path:l,query:P,fragment:M}=r;return s===void 0?s=this.scheme:s===null&&(s=C),a===void 0?a=this.authority:a===null&&(a=C),l===void 0?l=this.path:l===null&&(l=C),P===void 0?P=this.query:P===null&&(P=C),M===void 0?M=this.fragment:M===null&&(M=C),s===this.scheme&&a===this.authority&&l===this.path&&P===this.query&&M===this.fragment?this:new E(s,a,l,P,M)}static parse(r,s=!1){const a=v.exec(r);return a?new E(a[2]||C,o(a[4]||C),o(a[5]||C),o(a[7]||C),o(a[9]||C),s):new E(C,C,C,C,C)}static file(r){let s=C;if(t.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const a=r.indexOf(I,2);a===-1?(s=r.substring(2),r=I):(s=r.substring(2,a),r=r.substring(a)||I)}return new E("file",s,r,C,C)}static from(r){const s=new E(r.scheme,r.authority,r.path,r.query,r.fragment);return y(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&r.scheme==="file"?a=g.file(w.win32.join(f(r,!0),...s)).path:a=w.posix.join(r.path,...s),r.with({path:a})}toString(r=!1){return h(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const s=new E(r);return s._formatted=r.external,s._fsPath=r._sep===d?r.fsPath:null,s}}else return r}}e.URI=g;const d=t.isWindows?1:void 0;class E extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(n,r){let s,a=-1;for(let l=0;l<n.length;l++){const P=n.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)a!==-1&&(s+=encodeURIComponent(n.substring(a,l)),a=-1),s!==void 0&&(s+=n.charAt(l));else{s===void 0&&(s=n.substr(0,l));const M=b[P];M!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,l)),a=-1),s+=M):a===-1&&(a=l)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function S(n){let r;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(r===void 0&&(r=n.substr(0,s)),r+=b[a]):r!==void 0&&(r+=n[s])}return r!==void 0?r:n}function f(n,r){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function h(n,r){const s=r?S:p;let a="",{scheme:l,authority:P,path:M,query:T,fragment:F}=n;if(l&&(a+=l,a+=":"),(P||l==="file")&&(a+=I,a+=I),P){let U=P.indexOf("@");if(U!==-1){const x=P.substr(0,U);P=P.substr(U+1),U=x.indexOf(":"),U===-1?a+=s(x,!1):(a+=s(x.substr(0,U),!1),a+=":",a+=s(x.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=s(P,!1):(a+=s(P.substr(0,U),!1),a+=P.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}a+=s(M,!0)}return T&&(a+="?",a+=s(T,!1)),F&&(a+="#",a+=r?F:p(F,!1)),a}function c(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+c(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(i)?n.replace(i,r=>c(r)):n}}),define(J[140],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const C=m;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const C=[];let I;try{const v=JSON.parse(m.arguments),g=v[v.length-1];g&&g.__$stack&&(v.pop(),I=g.__$stack),C.push(...v)}catch{C.push("Unable to log remote console arguments",m.arguments)}return{args:C,stack:I}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const C=m;if(C){const I=D(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:w.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=R;function D(m){if(!m)return m;const C=m.indexOf(`
`);return C===-1?m:m.substring(0,C)}function y(m,C){const{args:I,stack:v}=k(m),g=typeof I[0]=="string"&&I.length===1;let d=D(v);d&&(d=`(${d.trim()})`);let E=[];if(typeof I[0]=="string"?d&&g?E=[`%c[${C}] %c${I[0]} %c${d}`,u("blue"),u(""),u("grey")]:E=[`%c[${C}] %c${I[0]}`,u("blue"),u(""),...I.slice(1)]:E=[`%c[${C}]%`,u("blue"),...I],d&&!g&&E.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,E)}e.log=y;function u(m){return`color: ${m}`}}),define(J[67],Z([0,1,17,25,7]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,y)}e.stringify=R;function D(m){let C=JSON.parse(m);return C=u(C),C}e.parse=D;function y(m,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function u(m,C=0){if(!m||C>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof w.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=u(m[I],C+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=u(m[I],C+1))}return m}e.revive=u}),define(J[13],Z([0,1,4,7]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u){this._remoteResourcesPath=`${u}/${k.vscodeRemoteResource}`}set(u,m,C){this._hosts[u]=m,this._ports[u]=C}setConnectionToken(u,m){this._connectionTokens[u]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)return this._delegate(u);const m=u.authority;let C=this._hosts[m];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const I=this._ports[m],v=this._connectionTokens[m];let g=`path=${encodeURIComponent(u.path)}`;return typeof v=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),t.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${I}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class D{asBrowserUri(u,m){const C=this.toUri(u,m);return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(u,m){const C=this.toUri(u,m);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==D.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(u,m){return t.URI.isUri(u)?u:t.URI.parse(m.toUrl(u))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(J[16],Z([0,1,31,13,9,4,25,7]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(g){return(0,y.uriToFsPath)(g,!0)}e.originalFSPath=u;class m{constructor(d){this._ignorePathCasing=d}compare(d,E,b=!1){return d===E?0:(0,D.compare)(this.getComparisonKey(d,b),this.getComparisonKey(E,b))}isEqual(d,E,b=!1){return d===E?!0:!d||!E?!1:this.getComparisonKey(d,b)===this.getComparisonKey(E,b)}getComparisonKey(d,E=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,E,b=!1){if(d.scheme===E.scheme){if(d.scheme===t.Schemas.file)return w.isEqualOrParent(u(d),u(E),this._ignorePathCasing(d))&&d.query===E.query&&(b||d.fragment===E.fragment);if((0,e.isEqualAuthority)(d.authority,E.authority))return w.isEqualOrParent(d.path,E.path,this._ignorePathCasing(d),"/")&&d.query===E.query&&(b||d.fragment===E.fragment)}return!1}joinPath(d,...E){return y.URI.joinPath(d,...E)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let E;return d.scheme===t.Schemas.file?E=y.URI.file(k.dirname(u(d))).path:(E=k.posix.dirname(d.path),d.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),E="/")),d.with({path:E})}normalizePath(d){if(!d.path.length)return d;let E;return d.scheme===t.Schemas.file?E=y.URI.file(k.normalize(u(d))).path:E=k.posix.normalize(d.path),d.with({path:E})}relativePath(d,E){if(d.scheme!==E.scheme||!(0,e.isEqualAuthority)(d.authority,E.authority))return;if(d.scheme===t.Schemas.file){const S=k.relative(u(d),u(E));return R.isWindows?w.toSlashes(S):S}let b=d.path||"/";const p=E.path||"/";if(this._ignorePathCasing(d)){let S=0;for(const f=Math.min(b.length,p.length);S<f&&!(b.charCodeAt(S)!==p.charCodeAt(S)&&b.charAt(S).toLowerCase()!==p.charAt(S).toLowerCase());S++);b=p.substr(0,S)+b.substr(S)}return k.posix.relative(b,p)}resolvePath(d,E){if(d.scheme===t.Schemas.file){const b=y.URI.file(k.resolve(u(d),E));return d.with({authority:b.authority,path:b.path})}return E=w.toPosixPath(E),d.with({path:k.posix.resolve(d.path,E)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,E){return d===E||d!==void 0&&E!==void 0&&(0,D.equalsIgnoreCase)(d,E)}hasTrailingPathSeparator(d,E=k.sep){if(d.scheme===t.Schemas.file){const b=u(d);return b.length>w.getRoot(b).length&&b[b.length-1]===E}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,E=k.sep){return(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,E=k.sep){let b=!1;if(d.scheme===t.Schemas.file){const p=u(d);b=p!==void 0&&p.length===w.getRoot(p).length&&p[p.length-1]===E}else{E="/";const p=d.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(g,d){const E=[];for(let b=0;b<g.length;b++){const p=d(g[b]);g.some((S,f)=>f===b?!1:(0,e.isEqualOrParent)(p,d(S)))||E.push(g[b])}return E}e.distinctParents=C;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(E){const b=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(f=>{const[h,c]=f.split(":");h&&c&&b.set(h,c)});const S=E.path.substring(0,E.path.indexOf(";"));return S&&b.set(g.META_DATA_MIME,S),b}g.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function v(g,d,E){if(d){let b=g.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),g.with({scheme:E,authority:d,path:b})}return g.with({scheme:E})}e.toLocalResource=v}),define(J[8],Z([0,1,22,18,3,2,16,4]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u(H){return!!H&&typeof H.then=="function"}e.isThenable=u;function m(H){const L=new w.CancellationTokenSource,O=H(L.token),N=new Promise((V,Q)=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),Q(new t.CancellationError)});Promise.resolve(O).then(j=>{ne.dispose(),L.dispose(),V(j)},j=>{ne.dispose(),L.dispose(),Q(j)})});return new class{cancel(){L.cancel()}then(V,Q){return N.then(V,Q)}catch(V){return this.then(void 0,V)}finally(V){return N.finally(V)}}}e.createCancelablePromise=m;function C(H,L,O){return new Promise((N,V)=>{const Q=L.onCancellationRequested(()=>{Q.dispose(),N(O)});H.then(N,V).finally(()=>Q.dispose())})}e.raceCancellation=C;function I(H,L){return new Promise((O,N)=>{const V=L.onCancellationRequested(()=>{V.dispose(),N(new t.CancellationError)});H.then(O,N).finally(()=>V.dispose())})}e.raceCancellationError=I;async function v(H){let L=-1;const O=H.map((V,Q)=>V.then(ne=>(L=Q,ne))),N=await Promise.race(O);return H.forEach((V,Q)=>{Q!==L&&V.cancel()}),N}e.raceCancellablePromises=v;function g(H,L,O){let N;const V=setTimeout(()=>{N?.(void 0),O?.()},L);return Promise.race([H.finally(()=>clearTimeout(V)),new Promise(Q=>N=Q)])}e.raceTimeout=g;function d(H){return new Promise((L,O)=>{const N=H();u(N)?N.then(L,O):L(N)})}e.asPromise=d;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=L(),new Promise((O,N)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,N(V)})})}}e.Throttler=E;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class p{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=p;const S=(H,L)=>{let O=!0;const N=setTimeout(()=>{O=!1,L()},H);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},f=H=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,H())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,Q)=>{this.doResolve=V,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?f(N):S(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class c{constructor(L){this.delayer=new h(L),this.throttler=new E}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class i{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n(H,L){return L?new Promise((O,N)=>{const V=setTimeout(()=>{Q.dispose(),O()},H),Q=L.onCancellationRequested(()=>{clearTimeout(V),Q.dispose(),N(new t.CancellationError)})}):m(O=>n(H,O))}e.timeout=n;function r(H,L=0){const O=setTimeout(H,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s(H){const L=[];let O=0;const N=H.length;function V(){return O<N?H[O++]():null}function Q(ne){ne!=null&&L.push(ne);const j=V();return j?j.then(Q):Promise.resolve(L)}return Promise.resolve(null).then(Q)}e.sequence=s;function a(H,L=N=>!!N,O=null){let N=0;const V=H.length,Q=()=>{if(N>=V)return Promise.resolve(O);const ne=H[N++];return Promise.resolve(ne()).then(te=>L(te)?Promise.resolve(te):Q())};return Q()}e.first=a;function l(H,L=N=>!!N,O=null){if(H.length===0)return Promise.resolve(O);let N=H.length;const V=()=>{N=-1;for(const Q of H)Q.cancel?.()};return new Promise((Q,ne)=>{for(const j of H)j.then(te=>{--N>=0&&L(te)?(V(),Q(te)):N===0&&Q(O)}).catch(te=>{--N>=0&&(V(),ne(te))})})}e.firstParallel=l;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:L,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new _;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const N=O.getComparisonKey(L);let V=this.queues.get(N);return V||(V=new M,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class F{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class x{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class re{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends x{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class ue extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,y.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(H,L)=>{const O=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function de(H,L,O){let N;for(let V=0;V<O;V++)try{return await H()}catch(Q){N=Q,await n(L)}throw N}e.retry=de;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,O,N){return this._pending={taskId:L,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,N;const V=new Promise((Q,ne)=>{O=Q,N=ne});this._next={run:L,promise:V,promiseResolve:O,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=K;class ${constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=_;var A;(function(H){async function L(N){let V;const Q=await Promise.all(N.map(ne=>ne.then(j=>j,j=>{V||(V=j)})));if(typeof V<"u")throw V;return Q}H.settled=L;function O(N){return new Promise(async(V,Q)=>{try{await N(V,Q)}catch(ne){Q(ne)}})}H.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(L(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async N=>O.emitOne(await N)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async N=>{for await(const V of N)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async N=>{for await(const V of L)N.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async N=>{for await(const V of L)O(V)&&N.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const N of L)O.push(N);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class ee extends z{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ee;function B(H){const L=new w.CancellationTokenSource,O=H(L.token);return new ee(L,async N=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),N.reject(new t.CancellationError)});try{for await(const Q of O){if(L.token.isCancellationRequested)return;N.emitOne(Q)}V.dispose(),L.dispose()}catch(Q){V.dispose(),L.dispose(),N.reject(Q)}})}e.createCancelableAsyncIterable=B}),define(J[95],Z([0,1,24,8,31,32,9,4,25]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",I="[^/\\\\]",v=/\//g;function g(_,A){switch(_){case 0:return"";case 1:return`${I}*?`;default:return`(?:${C}|${I}+${C}${A?`|${C}${I}+`:""})*?`}}function d(_,A){if(!_)return[];const W=[];let z=!1,ee=!1,B="";for(const H of _){switch(H){case A:if(!z&&!ee){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}B+=H}return B&&W.push(B),W}e.splitGlobAware=d;function E(_){if(!_)return"";let A="";const W=d(_,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;W.forEach((ee,B)=>{if(ee===e.GLOBSTAR){if(z)return;A+=g(2,B===W.length-1)}else{let H=!1,L="",O=!1,N="";for(const V of ee){if(V!=="}"&&H){L+=V;continue}if(O&&(V!=="]"||!N)){let Q;V==="-"?Q=V:(V==="^"||V==="!")&&!N?Q="^":V===e.GLOB_SPLIT?Q="":Q=(0,u.escapeRegExpCharacters)(V),N+=Q;continue}switch(V){case"{":H=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${d(L,",").map(j=>E(j)).join("|")})`,H=!1,L="";break}case"]":{A+="["+N+"]",O=!1,N="";break}case"?":A+=I;continue;case"*":A+=g(1);continue;default:A+=(0,u.escapeRegExpCharacters)(V)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=C)}z=ee===e.GLOBSTAR})}return A}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},n=function(){return null};function r(_,A){if(!_)return n;let W;typeof _!="string"?W=_.pattern:W=_,W=W.trim();const z=`${W}_${!!A.trimForExclusions}`;let ee=i.get(z);if(ee)return s(ee,_);let B;return b.test(W)?ee=l(W.substr(4),W):(B=p.exec(a(W,A)))?ee=P(B[1],W):(A.trimForExclusions?f:S).test(W)?ee=M(W,A):(B=h.exec(a(W,A)))?ee=T(B[1].substr(1),W,!0):(B=c.exec(a(W,A)))?ee=T(B[1],W,!1):ee=F(W),i.set(z,ee),s(ee,_)}function s(_,A){if(typeof A=="string")return _;const W=function(z,ee){return(0,k.isEqualOrParent)(z,A.base,!y.isLinux)?_(z.substr(A.base.length+1),ee):null};return W.allBasenames=_.allBasenames,W.allPaths=_.allPaths,W.basenames=_.basenames,W.patterns=_.patterns,W}function a(_,A){return A.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function l(_,A){return function(W,z){return typeof W=="string"&&W.endsWith(_)?A:null}}function P(_,A){const W=`/${_}`,z=`\\${_}`,ee=function(H,L){return typeof H!="string"?null:L?L===_?A:null:H===_||H.endsWith(W)||H.endsWith(z)?A:null},B=[_];return ee.basenames=B,ee.patterns=[A],ee.allBasenames=B,ee}function M(_,A){const W=K(_.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==n),_),z=W.length;if(!z)return n;if(z===1)return W[0];const ee=function(L,O){for(let N=0,V=W.length;N<V;N++)if(W[N](L,O))return _;return null},B=W.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(ee.allPaths=H),ee}function T(_,A,W){const z=D.sep===D.posix.sep,ee=z?_:_.replace(v,D.sep),B=D.sep+ee,H=D.posix.sep+_;let L;return W?L=function(O,N){return typeof O=="string"&&(O===ee||O.endsWith(B)||!z&&(O===_||O.endsWith(H)))?A:null}:L=function(O,N){return typeof O=="string"&&(O===ee||!z&&O===_)?A:null},L.allPaths=[(W?"*/":"./")+_],L}function F(_){try{const A=new RegExp(`^${E(_)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?_:null}}catch{return n}}function U(_,A,W){return!_||typeof A!="string"?!1:x(_)(A,void 0,W)}e.match=U;function x(_,A={}){if(!_)return o;if(typeof _=="string"||re(_)){const W=r(_,A);if(W===n)return o;const z=function(ee,B){return!!W(ee,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return se(_,A)}e.parse=x;function re(_){const A=_;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=re;function le(_){return _.allBasenames||[]}e.getBasenameTerms=le;function ue(_){return _.allPaths||[]}e.getPathTerms=ue;function se(_,A){const W=K(Object.getOwnPropertyNames(_).map(L=>de(L,_[L],A)).filter(L=>L!==n)),z=W.length;if(!z)return n;if(!W.some(L=>!!L.requiresSiblings)){if(z===1)return W[0];const L=function(V,Q){let ne;for(let j=0,te=W.length;j<te;j++){const ie=W[j](V,Q);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ne||(ne=[]),ne.push(ie))}return ne?(async()=>{for(const j of ne){const te=await j;if(typeof te=="string")return te}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const N=W.reduce((V,Q)=>Q.allPaths?V.concat(Q.allPaths):V,[]);return N.length&&(L.allPaths=N),L}const ee=function(L,O,N){let V,Q;for(let ne=0,j=W.length;ne<j;ne++){const te=W[ne];te.requiresSiblings&&N&&(O||(O=(0,D.basename)(L)),V||(V=O.substr(0,O.length-(0,D.extname)(L).length)));const ie=te(L,O,V,N);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(Q||(Q=[]),Q.push(ie))}return Q?(async()=>{for(const ne of Q){const j=await ne;if(typeof j=="string")return j}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(ee.allPaths=H),ee}function de(_,A,W){if(A===!1)return n;const z=r(_,W);if(z===n)return n;if(typeof A=="boolean")return z;if(A){const ee=A.when;if(typeof ee=="string"){const B=(H,L,O,N)=>{if(!N||!z(H,L))return null;const V=ee.replace("$(basename)",O),Q=N(V);return(0,t.isThenable)(Q)?Q.then(ne=>ne?_:null):Q?_:null};return B.requiresSiblings=!0,B}}return z}function K(_,A){const W=_.filter(L=>!!L.basenames);if(W.length<2)return _;const z=W.reduce((L,O)=>{const N=O.basenames;return N?L.concat(N):L},[]);let ee;if(A){ee=[];for(let L=0,O=z.length;L<O;L++)ee.push(A)}else ee=W.reduce((L,O)=>{const N=O.patterns;return N?L.concat(N):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const Q=L.charCodeAt(V-1);if(Q===47||Q===92)break}O=L.substr(V)}const N=z.indexOf(O);return N!==-1?ee[N]:null};B.basenames=z,B.patterns=ee,B.allBasenames=z;const H=_.filter(L=>!L.basenames);return H.push(B),H}function $(_,A){return(0,w.equals)(_,A,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=$}),define(J[35],Z([0,1,24,31,9,4,16,25]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(n,r){const{os:s,tildify:a,relative:l}=r;if(l){const T=m(n,l,s);if(typeof T=="string")return T}let P=n.fsPath;if(s===1&&!R.isWindows?P=P.replace(/\//g,"\\"):s!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),s!==1&&a?.userHome){const T=a.userHome.fsPath;let F;n.scheme!==a.userHome.scheme&&n.path.startsWith(k.posix.sep)?F=a.userHome.with({path:n.path}).fsPath:F=n.fsPath,P=v(F,T,s)}return(s===1?k.win32:k.posix).normalize(C(P,s===1))}e.getPathLabel=u;function m(n,r,s){const a=s===1?k.win32:k.posix,l=s===3?D.extUri:D.extUriIgnorePathCase,P=r.getWorkspace(),M=(0,w.firstOrDefault)(P.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=M.uri.with({path:n.path}));const T=r.getWorkspaceFolder(n);if(!T)return;let F;if(l.isEqual(T.uri,n)?F="":F=l.relativePath(T.uri,n)??"",F&&(F=a.normalize(F)),P.folders.length>1&&!r.noPrefix){const U=T.name?T.name:l.basenameOrAuthority(T.uri);F=F?`${U} \u2022 ${F}`:U}return F}function C(n,r=R.isWindows){return(0,t.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=C;let I=Object.create(null);function v(n,r,s=R.OS){if(s===1||!n||!r)return n;let a=I.original===r?I.normalized:void 0;a||(a=r,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,y.rtrim)(a,k.posix.sep)}${k.posix.sep}`,I={original:r,normalized:a});let l=n;return R.isWindows&&(l=(0,t.toSlashes)(l)),(s===3?l.startsWith(a):(0,y.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:n}e.tildify=v;function g(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const d="\u2026",E="\\\\",b="~";function p(n,r=k.sep){const s=new Array(n.length);let a=!1;for(let l=0;l<n.length;l++){const P=n[l];if(P===""){s[l]=`.${r}`;continue}if(!P){s[l]=P;continue}a=!0;let M="",T=P;T.indexOf(E)===0?(M=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length)):T.indexOf(r)===0?(M=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(b)===0&&(M=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const F=T.split(r);for(let U=1;a&&U<=F.length;U++)for(let x=F.length-U;a&&x>=0;x--){a=!1;let re=F.slice(x,x+U).join(r);for(let le=0;!a&&le<n.length;le++)if(le!==l&&n[le]&&n[le].indexOf(re)>-1){const ue=x+U===F.length,se=x>0&&n[le].indexOf(r)>-1?r+re:re,de=n[le].endsWith(se);a=!ue||de}if(!a){let le="";(F[0].endsWith(":")||M!=="")&&(x===1&&(x=0,U++,re=F[0]+r+re),x>0&&(le=F[0]+r),le=M+le),x>0&&(le=le+d+r),le=le+re,x+U<F.length&&(le=le+r+d),s[l]=le}}a&&(s[l]=P)}return s}e.shorten=p;var S;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function f(n,r=Object.create(null)){const s=[];let a=!1,l="";for(const P of n)if(P==="$"||a&&P==="{")l&&s.push({value:l,type:S.TEXT}),l="",a=!0;else if(P==="}"&&a){const M=r[l];if(typeof M=="string")M.length&&s.push({value:M,type:S.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==S.SEPARATOR)&&s.push({value:M.label,type:S.SEPARATOR})}l="",a=!1}else l+=P;return l&&!a&&s.push({value:l,type:S.TEXT}),s.filter((P,M)=>{if(P.type===S.SEPARATOR){const T=s[M-1],F=s[M+1];return[T,F].every(U=>U&&(U.type===S.VARIABLE||U.type===S.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function h(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function c(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(n){const r=n.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(n),a=r.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(J[141],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const v=this._uriTransformer.transformIncoming(I);return v===I?I:t(w.URI.from(v))}transformOutgoing(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:t(w.URI.from(v))}transformOutgoingURI(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:w.URI.from(v)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,I,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof w.URI)return I.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const d=R(C[g],I,v+1);d!==null&&(C[g]=d)}}return null}function D(C,I){const v=R(C,I,0);return v===null?C:v}e.transformOutgoingURIs=D;function y(C,I,v,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?w.URI.revive(I.transformIncoming(C)):I.transformIncoming(C);for(const d in C)if(Object.hasOwnProperty.call(C,d)){const E=y(C[d],I,v,g+1);E!==null&&(C[d]=E)}}return null}function u(C,I){const v=y(C,I,!1,0);return v===null?C:v}e.transformIncomingURIs=u;function m(C,I){const v=y(C,I,!0,0);return v===null?C:v}e.transformAndReviveIncomingURIs=m}),define(J[81],Z([0,1,30,18,32,28,129]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,I=0;const v=(0,w.networkInterfaces)();for(const g in v){const d=v[g];if(d)for(const{mac:E,internal:b}of d)b||(I+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(C+=1))}this._value=I>0?C/I:0}return this._value}};let y;async function u(){return y||(y=(async()=>await m()||R.generateUuid())()),y}e.getMachineId=u;async function m(){try{const C=await new Promise((v,g)=>{q(["crypto"],v,g)}),I=(0,D.getMac)();return C.createHash("sha256").update(I,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(J[23],Z([0,1,29,30,142,8,31,80,9,4,16,7]),function(q,e,w,t,k,R,D,y,u,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function g(se,de=v.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return de===v.UNLINK?E(se):d(se)}async function d(se){try{const de=(0,D.randomPath)((0,t.tmpdir)());try{await w.promises.rename(se,de)}catch{return E(se)}E(de).catch(K=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function E(se){return(0,k.promisify)(w.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function b(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function p(se,de){return h(await(de?S(se):(0,k.promisify)(w.readdir)(se)))}async function S(se){try{return await(0,k.promisify)(w.readdir)(se,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const de=[],K=await p(se);for(const $ of K){let _=!1,A=!1,W=!1;try{const z=await e.Promises.lstat((0,u.join)(se,$));_=z.isFile(),A=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}de.push({name:$,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>W})}return de}function f(se){return h(w.readdirSync(se))}e.readdirSync=f;function h(se){return se.map(de=>typeof de=="string"?m.isMacintosh?(0,y.normalizeNFC)(de):de:(de.name=m.isMacintosh?(0,y.normalizeNFC)(de.name):de.name,de))}async function c(se){const de=await p(se),K=[];for(const $ of de)await o.existsDirectory((0,u.join)(se,$))&&K.push($);return K}function i(se,de=1e3){return new Promise(K=>{let $=!1;const _=setInterval(()=>{$||($=!0,w.access(se,A=>{$=!1,A&&(clearInterval(_),K(void 0))}))},de)})}e.whenDeleted=i;var o;(function(se){async function de(_){let A;try{if(A=await e.Promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw W}}se.stat=de;async function K(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=K;async function $(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=$})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function r(se,de,K){return n.queueFor(I.URI.file(se),C.extUriBiasedIgnorePathCase).queue(()=>{const $=M(K);return new Promise((_,A)=>l(se,de,$,W=>W?A(W):_()))})}let s=!0;function a(se){s=se}e.configureFlushOnWrite=a;function l(se,de,K,$){if(!s)return w.writeFile(se,de,{mode:K.mode,flag:K.flag},$);w.open(se,K.flag,K.mode,(_,A)=>{if(_)return $(_);w.writeFile(A,de,W=>{if(W)return w.close(A,()=>$(W));w.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),a(!1)),w.close(A,ee=>$(ee))))})})}function P(se,de,K){const $=M(K);if(!s)return w.writeFileSync(se,de,{mode:$.mode,flag:$.flag});const _=w.openSync(se,$.flag,$.mode);try{w.writeFileSync(_,de);try{w.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),a(!1)}}finally{w.closeSync(_)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,de){if(se!==de)try{await e.Promises.rename(se,de)}catch(K){if(se.toLowerCase()!==de.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await F(se,de,{preserveSymlinks:!1}),await g(se,v.MOVE);else throw K}}async function F(se,de,K){return x(se,de,{root:{source:se,target:de},options:K,handledSourcePaths:new Set})}const U=511;async function x(se,de,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:$,symbolicLink:_}=await o.stat(se);if(_){if(K.options.preserveSymlinks)try{return await ue(se,de,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return $.isDirectory()?re(se,de,$.mode&U,K):le(se,de,$.mode&U)}async function re(se,de,K,$){await e.Promises.mkdir(de,{recursive:!0,mode:K});const _=await p(se);for(const A of _)await x((0,u.join)(se,A),(0,u.join)(de,A),$)}async function le(se,de,K){await e.Promises.copyFile(se,de),await e.Promises.chmod(de,K)}async function ue(se,de,K){let $=await e.Promises.readlink(se);(0,D.isEqualOrParent)($,K.root.source,!m.isLinux)&&($=(0,u.join)(K.root.target,$.substr(K.root.source.length+1))),await e.Promises.symlink($,de)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(se,de,K,$,_)=>new Promise((A,W)=>{w.read(se,de,K,$,_,(z,ee,B)=>z?W(z):A({bytesRead:ee,buffer:B}))})}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(se,de,K,$,_)=>new Promise((A,W)=>{w.write(se,de,K,$,_,(z,ee,B)=>z?W(z):A({bytesWritten:ee,buffer:B}))})}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return r}get rm(){return g}get move(){return T}get copy(){return F}}}),define(J[96],Z([0,1,29,9,4,25,23]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(v){if(k.isLinux)return v;const g=(0,t.dirname)(v);if(v===g)return v;const d=((0,t.basename)(v)||v).toLowerCase();try{const b=(0,D.readdirSync)(g).filter(p=>p.toLowerCase()===d);if(b.length===1){const p=y(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(d);if(p>=0){const S=y(g);if(S)return(0,t.join)(S,b[p])}}}catch{}return null}e.realcaseSync=y;async function u(v){if(k.isLinux)return v;const g=(0,t.dirname)(v);if(v===g)return v;const d=((0,t.basename)(v)||v).toLowerCase();try{const b=(await D.Promises.readdir(g)).filter(p=>p.toLowerCase()===d);if(b.length===1){const p=await u(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(d);if(p>=0){const S=await u(g);if(S)return(0,t.join)(S,b[p])}}}catch{}return null}e.realcase=u;async function m(v){try{return await D.Promises.realpath(v)}catch{const d=I(v);return await D.Promises.access(d,w.constants.R_OK),d}}e.realpath=m;function C(v){try{return w.realpathSync(v)}catch{const d=I(v);return w.accessSync(d,w.constants.R_OK),d}}e.realpathSync=C;function I(v){return(0,R.rtrim)((0,t.normalize)(v),t.sep)}}),define(J[143],Z([0,1,30,9,23]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class I{constructor(c,i,o){this.exePath=c,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:h=!1}={}){return h?m===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:h=!1,findPreview:c=!1}={}){const i=v({useAlternateBitness:h});if(!i)return null;const o=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let n=-1,r=null;for(const l of await k.Promises.readdir(o)){let P=-1;if(c){const T=l.indexOf("-");if(T<0)continue;const F=l.substring(0,T);if(!R.test(F)||l.substring(T+1)!=="preview")continue;P=parseInt(F,10)}else{if(!R.test(l))continue;P=parseInt(l,10)}if(P<=n)continue;const M=t.join(o,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(r=M,n=P)}if(!r)return null;const s=i.includes("x86")?" (x86)":"",a=c?" Preview":"";return new I(r,`PowerShell${a}${s}`,!0)}async function d({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=h?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(c))if(i.test(n)){const r=t.join(c,n,"pwsh.exe");return new I(r,o)}return null}function E(){const h=t.join(w.homedir(),".dotnet","tools","pwsh.exe");return new I(h,".NET Core PowerShell Global Tool")}function b(){const h=t.join(process.env.windir,m===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(h,"Windows PowerShell",!0)}async function*p(){let h=await g();h&&(yield h),h=await g({useAlternateBitness:!0}),h&&(yield h),h=await d(),h&&(yield h),h=E(),h&&(yield h),h=await g({findPreview:!0}),h&&(yield h),h=await d({findPreview:!0}),h&&(yield h),h=await g({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=b(),h&&(yield h)}async function*S(){for await(const h of p())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=S;async function f(){for await(const h of S())return h;return null}e.getFirstAvailablePowerShellInstallation=f}),define(J[82],Z([0,1,9,4,34,78,12,23]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(I=k.env){return I.comspec||"cmd.exe"}e.getWindowsShell=u;function m(I){let v=[],g=!1;const d=function(E){if(g){v.push(E);return}(!I.send(E,p=>{if(p&&console.error(p),g=!1,v.length>0){const S=v.slice(0);v=[],S.forEach(f=>d(f))}})||t.isWindows)&&(g=!0)};return{send:d}}e.createQueuedSender=m;var C;(function(I){async function v(g,d,E){if(w.isAbsolute(g))return g;if(d===void 0&&(d=k.cwd()),w.dirname(g)!=="."||(E===void 0&&D.isString(k.env.PATH)&&(E=k.env.PATH.split(w.delimiter)),E===void 0||E.length===0))return w.join(d,g);async function p(S){if(await y.Promises.exists(S)){let f;try{f=await y.Promises.stat(S)}catch(h){h.message.startsWith("EACCES")&&(f=await y.Promises.lstat(S))}return f?!f.isDirectory():!1}return!1}for(const S of E){let f;if(w.isAbsolute(S)?f=w.join(S,g):f=w.join(d,S,g),await p(f))return f;let h=f+".com";if(await p(h)||(h=f+".exe",await p(h)))return h}return w.join(d,g)}I.findExecutable=v})(C=e.win32||(e.win32={}))}),define(J[97],Z([0,1,51,13]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((y,u)=>{let m;const C=new Map;function I(g,d,E,b,p){const S=C.get(d);if(g===D||S){const f={name:v(E),cmd:E,pid:g,ppid:d,load:b,mem:p};C.set(g,f),g===D&&(m=f),S&&(S.children||(S.children=[]),S.children.push(f),S.children.length>1&&(S.children=S.children.sort((h,c)=>h.pid-c.pid)))}}function v(g){const d=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,h=/\\pipe\\winpty-control/,c=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(f.exec(g))return"electron-crash-reporter";if(h.exec(g))return"winpty-process";if(c.exec(g))return"console-window-host (Windows internal process)";let o=i.exec(g);if(o&&o.length===2){if(o[1]==="renderer")return d.exec(g)?"shared-process":E.exec(g)?"issue-reporter":b.exec(g)?"process-explorer":"window";if(o[1]==="utility"){if(p.exec(g))return"utility-network-service";if(S.exec(g))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let r="";do o=n.exec(g),o&&(r+=o+" ");while(o);return r&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${r}`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,E)=>{q(["windows-process-tree"],d,E)}).then(d=>{d.getProcessList(D,E=>{if(!E){u(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(E,b=>{const p=new Map;b.forEach(S=>{const f=g(S.commandLine||"");p.set(S.pid,{name:v(f),cmd:f,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),m=p.get(D),m?(p.forEach(S=>{const f=p.get(S.ppid);f&&(f.children||(f.children=[]),f.children.push(S))}),p.forEach(S=>{S.children&&(S.children=S.children.sort((f,h)=>f.pid-h.pid))}),y(m)):u(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[m];const E=[];for(;d.length;){const p=d.shift();p&&(E.push(p.pid),p.children&&(d=d.concat(p.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);b+=" "+E.join(" "),(0,w.exec)(b,{},(p,S,f)=>{if(p||f)u(p||new Error(f.toString()));else{const h=S.toString().split(`
`);for(let c=0;c<E.length;c++){const i=C.get(E[c]);i.load=parseFloat(h[c])}if(!m){u(new Error(`Root process ${D} not found`));return}y(m)}})};(0,w.exec)("which ps",{},(d,E,b)=>{if(d||b)if(process.platform!=="linux")u(d||new Error(b.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(p,{},(S,f,h)=>{S||h?u(S||new Error(h.toString())):(R(f,I),g())})}else{const p=E.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${p} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,h,c)=>{f||c&&!c.includes("screen size is bogus")?u(f||new Error(c.toString())):(R(h,I),process.platform==="linux"?g():m?y(m):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,y){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=D.toString().split(`
`);for(const C of m){const I=u.exec(C.trim());I&&I.length===6&&y(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[144],Z([0,1,30,4,143,82]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,d){return g===1?t.isWindows?I():R.getWindowsShell(d):m(g,d)}e.getSystemShell=D;function y(g,d){return g===1?t.isWindows?v(d):R.getWindowsShell(d):m(g,d)}e.getSystemShellSync=y;let u=null;function m(g,d){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!u){let E;if(t.isWindows)E="/bin/bash";else{if(E=d.SHELL,!E)try{E=(0,w.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}u=E}return u}let C=null;async function I(){return C||(C=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),C}function v(g){if(C)return C;const d=t.isWindows&&parseFloat((0,w.release)())>=10,E=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${g.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:R.getWindowsShell(g)}});var ve=this&&this.__decorate||function(q,e,w,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,w):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,w,t);else for(var y=q.length-1;y>=0;y--)(D=q[y])&&(R=(k<3?D(R):k>3?D(e,w,R):D(e,w))||R);return k>3&&R&&Object.defineProperty(e,w,R),R};define(J[45],Z([0,1,24,8,17,22,52,18,3,2,67,25,12]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function d(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function b(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(p||(p={}));class S{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var h;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(h||(h={}));function c(_){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function i(_){return _.read(4).readUInt32BE(0)}function o(_){const A=k.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const n={Undefined:o(h.Undefined),String:o(h.String),Buffer:o(h.Buffer),VSBuffer:o(h.VSBuffer),Array:o(h.Array),Object:o(h.Object)},r=typeof Buffer<"u";function s(_,A){if(typeof A>"u")_.write(n.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);_.write(n.String),_.write(c(W.byteLength)),_.write(W)}else if(r&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);_.write(n.Buffer),_.write(c(W.byteLength)),_.write(W)}else if(A instanceof k.VSBuffer)_.write(n.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(n.Array),_.write(c(A.length));for(const W of A)s(_,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));_.write(n.Object),_.write(c(W.byteLength)),_.write(W)}}function a(_){switch(_.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return _.read(i(_)).toString();case h.Buffer:return _.read(i(_)).buffer;case h.VSBuffer:return _.read(i(_));case h.Array:{const W=i(_),z=[];for(let ee=0;ee<W;ee++)z.push(a(_));return z}case h.Object:return JSON.parse(_.read(i(_)).toString())}}class l{constructor(A,W,z=null,ee=1e3){this.protocol=A,this.ctx=W,this.logger=z,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,b(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,b(A.type),A.data);return}}}send(A,W=void 0){const z=new f;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new S(A),z=a(W),ee=a(W),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,ee),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,ee),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let ee;try{ee=W.call(this.ctx,A.name,A.arg,z.token)}catch(L){ee=Promise.reject(L)}const B=A.id;ee.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const H=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,H)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=A.id,B=W.listen(this.ctx,A.name,A.arg)(H=>this.sendResponse({id:z,data:H,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var P;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(A){const W=this;return{call(z,ee,B){return W.isDisposed?Promise.reject(new y.CancellationError):W.requestPromise(A,z,ee,B)},listen(z,ee){return W.isDisposed?u.Event.None:W.requestEvent(A,z,ee)}}}requestPromise(A,W,z,ee=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:z};if(ee.isCancellationRequested)return Promise.reject(new y.CancellationError);let O;return new Promise((V,Q)=>{if(ee.isCancellationRequested)return Q(new y.CancellationError);const ne=()=>{const ce=fe=>{switch(fe.type){case 201:this.handlers.delete(B),V(fe.data);break;case 202:{this.handlers.delete(B);const ke=new Error(fe.data.message);ke.stack=fe.data.stack,ke.name=fe.data.name,Q(ke);break}case 203:this.handlers.delete(B),Q(fe.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let j=null;this.state===p.Idle?ne():(j=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),j.then(()=>{j=null,ne()}));const te=()=>{j?(j.cancel(),j=null):this.sendRequest({id:B,type:101}),Q(new y.CancellationError)},ie=ee.onCancellationRequested(te);O=(0,m.combinedDisposable)((0,m.toDisposable)(te),ie),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,z){const ee=this.lastRequestId++,H={id:ee,type:102,channelName:A,name:W,arg:z};let L=null;const O=new u.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(H)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:ee,type:103}))}}),N=V=>O.fire(V.data);return this.handlers.set(ee,N),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,d(A.type));return}}}send(A,W=void 0){const z=new f;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new S(A),z=a(W),ee=a(W),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,b(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,b(B),ee),this.onResponse({type:z[0],id:z[1],data:ee})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:z})=>{u.Event.once(W.onMessage)(B=>{const H=new S(B),L=a(H),O=new l(W,L),N=new M(W);this.channels.forEach((Q,ne)=>O.registerChannel(ne,Q));const V={channelServer:O,channelClient:N,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),N.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const z=this;return{call(ee,B,H){let L;if((0,v.isFunction)(W)){const N=(0,w.getRandomElement)(z.connections.filter(W));L=N?Promise.resolve(N):u.Event.toPromise(u.Event.filter(z.onDidAddConnection,W))}else L=W.routeCall(z,ee,B);const O=L.then(N=>N.channelClient.getChannel(A));return U(O).call(ee,B,H)},listen(ee,B){if((0,v.isFunction)(W))return z.getMulticastEvent(A,W,ee,B);const H=W.routeEvent(z,ee,B).then(L=>L.channelClient.getChannel(A));return U(H).listen(ee,B)}}}getMulticastEvent(A,W,z,ee){const B=this;let H=new m.DisposableStore;const L=new u.Emitter({onFirstListenerAdd:()=>{H=new m.DisposableStore;const O=new u.EventMultiplexer,N=new Map,V=ne=>{const te=ne.channelClient.getChannel(A).listen(z,ee),ie=O.add(te);N.set(ne,ie)},Q=ne=>{const j=N.get(ne);!j||(j.dispose(),N.delete(ne))};B.connections.filter(W).forEach(V),u.Event.filter(B.onDidAddConnection,W)(V,void 0,H),B.onDidRemoveConnection(Q,void 0,H),O.event(L.fire,L,H),H.add(O)},onLastListenerRemove:()=>{H.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(z=>{z.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class F{constructor(A,W,z=null){const ee=new f;s(ee,W),A.send(ee.buffer),this.channelClient=new M(A,z),this.channelServer=new l(A,W,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(_){return{call(A,W,z){return _.then(ee=>ee.call(A,W,z))},listen(A,W){const z=new u.Relay;return _.then(ee=>z.input=ee.listen(A,W)),z.event}}}e.getDelayedChannel=U;function x(_){let A=!1;return{call(W,z,ee){return A?_.call(W,z,ee):(0,t.timeout)(0).then(()=>A=!0).then(()=>_.call(W,z,ee))},listen(W,z){if(A)return _.listen(W,z);const ee=new u.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>ee.input=_.listen(W,z)),ee.event}}}e.getNextTickChannel=x;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=re;var le;(function(_){function A(B,H){const L=B,O=H&&H.disableMarshalling,N=new Map;for(const V in L)z(V)&&N.set(V,u.Event.buffer(L[V],!0));return new class{listen(V,Q,ne){const j=N.get(Q);if(j)return j;if(ee(Q)){const te=L[Q];if(typeof te=="function")return te.call(L,ne)}throw new Error(`Event not found: ${Q}`)}call(V,Q,ne){const j=L[Q];if(typeof j=="function"){if(!O&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,C.revive)(ne[te]);return j.apply(L,ne)}throw new Error(`Method not found: ${Q}`)}}}_.fromService=A;function W(B,H){const L=H&&H.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return H?.properties?.has(N)?H.properties.get(N):ee(N)?function(V){return B.listen(N,V)}:z(N)?B.listen(N):async function(...V){let Q;H&&!(0,v.isUndefinedOrNull)(H.context)?Q=[H.context,...V]:Q=V;const ne=await B.call(N,Q);return L?ne:(0,C.revive)(ne)};throw new Error(`Property not found: ${String(N)}`)}})}_.toService=W;function z(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function ee(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const A=_.toString();if(A!=="[object Object]")return A}return _}function de(_){return Array.isArray(_)?_.map(se):se(_)}function K(_,A,W,z,ee,B,H){H=de(H);const L=ue[ee],O=L[z%L.length];let N=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(N=N.concat(H),N.push(")")):N.push(H),console.log.apply(console,N)}e.logWithColors=K;class ${constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,z,ee,B){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,W,z,ee,B)}logIncoming(A,W,z,ee,B){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,W,z,ee,B)}}e.IPCLogger=$}),define(J[145],Z([0,1,17,3,45]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(u){this.port=u,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(u,m){const C=new R(u);super(C,m),this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=D}),define(J[98],Z([0,1,17,3,2,45]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let a=0;function l(M,T){if(!s.has(M)){const F=String(++a);s.set(M,F)}return s.get(M)}function P(M,T,F,U){if(!r.enableDiagnostics)return;const x=l(M,T);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=w.VSBuffer.alloc(U.byteLength);re.set(U),r.records.push({timestamp:Date.now(),id:x,label:T,type:F,buff:re})}else r.records.push({timestamp:Date.now(),id:x,label:T,type:F,data:U})}r.traceSocketEvent=P})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function C(){return m||(m=w.VSBuffer.alloc(0)),m}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return C();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const l=w.VSBuffer.alloc(s);let P=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const F=T.slice(0,s);l.set(F,P),P+=s,a&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else l.set(T,P),P+=T.byteLength,a?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return l}}e.ChunkStream=I;var v;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(v||(v={}));function g(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class E{constructor(s,a,l,P){this.type=s,this.id=a,this.ack=l,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new E(l,P,M,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=w.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const l=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,l}_bufferTake(){const s=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new E(1,0,0,s))}}e.Protocol=S;class f extends R.IPCClient{constructor(s,a,l=null){super(s,a,l),this.protocol=s}static fromSocket(s,a){return new f(new S(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class c{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,l=this._first;for(;l;)s[a++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new c(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let l=0;for(let P=0;P<o._HISTORY_LENGTH;P++)s-this.lastRuns[P]<=a&&l++;return 1-l/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{constructor(s,a=null,l=o.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new E(5,0,0,C());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new E(7,0,0,C());this._socketWriter.write(s)}sendResume(){const s=new E(8,0,0,C());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new E(3,0,this._incomingAckId,C());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new E(6,0,0,C())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new E(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const a=new E(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const M=Math.max(2e4-a,2e4-l,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new E(3,0,this._incomingAckId,C());this._socketWriter.write(s)}_sendKeepAlive(){const s=new E(9,0,0,C());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(J[146],Z([0,1,40,17,3,2,45,131]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(C,I){const v=k.Event.fromNodeEventEmitter(w.validatedIpcMain,I,(d,E)=>({event:d,message:E})),g=k.Event.filter(v,({event:d})=>d.sender.id===C);return k.Event.map(g,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends D.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const I=k.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:hello",({sender:v})=>v);return k.Event.map(I,v=>{const g=v.id;m.Clients.get(g)?.dispose();const E=new k.Emitter;m.Clients.set(g,(0,R.toDisposable)(()=>E.fire()));const b=u(g,"vscode:message"),p=k.Event.any(k.Event.signal(u(g,"vscode:disconnect")),E.event);return{protocol:new y.Protocol(v,b),onDidClientDisconnect:p}})}}e.Server=m,m.Clients=new Map}),define(J[99],Z([0,1,40,3,28,145]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(m,C){super({addEventListener:(I,v)=>m.addListener(I,v),removeEventListener:(I,v)=>m.removeListener(I,v),postMessage:I=>m.postMessage(I),start:()=>m.start(),close:()=>m.close()},C)}}e.Client=D;async function y(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();u.webContents.send("vscode:createMessageChannel",m);const C=t.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:createMessageChannelResult",(v,g)=>({nonce:g,port:v.ports[0]})),{port:I}=await t.Event.toPromise(t.Event.once(t.Event.filter(C,v=>v.nonce===m)));return I}e.connect=y}),define(J[147],Z([0,1,51,8,17,22,140,18,3,2,50,82,78,45]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends g.ChannelServer{constructor(p){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=d;class E{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(p){const S=this;return{call(f,h,c){return S.requestPromise(p,f,h,c)},listen(f,h){return S.requestEvent(p,f,h)}}}requestPromise(p,S,f,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),i=(0,t.createCancelablePromise)(r=>c.call(S,f,r)),o=h.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,S,f){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let h;const c=new u.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(p).listen(S,f)(c.fire,c),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,v.removeDangerousEnvVariables)(S.env),this.child=(0,w.fork)(this.modulePath,p,S);const f=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}f.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),o=f.event,n={send:i,onMessage:o};this._client=new g.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(l=>(0,m.dispose)(l)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(J[83],Z([0,1,17,18,3,2,9,4,28,45,98]),function(q,e,w,t,k,R,D,y,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class v{constructor(l,P=""){this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,P){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const P=M=>{this.traceSocketEvent("read",M),l(w.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=M=>{this.traceSocketEvent("close",{hadError:M}),l({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=v;var g;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class E extends R.Disposable{constructor(l,P,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new b(this,P,M,T,this._onData,(F,U)=>this._write(F,U))),this._register(this._flowManager.onError(F=>{console.error(F),(0,t.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let M=2;l.byteLength<126?M+=0:l.byteLength<2**16?M+=2:M+=8;const T=w.VSBuffer.alloc(M);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let F=1;T.writeUInt8(l.byteLength>>>8&255,++F),T.writeUInt8(l.byteLength>>>0&255,++F)}else{T.writeUInt8(127,1);let F=1;T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(l.byteLength>>>24&255,++F),T.writeUInt8(l.byteLength>>>16&255,++F),T.writeUInt8(l.byteLength>>>8&255,++F),T.writeUInt8(l.byteLength>>>0&255,++F)}this.socket.write(w.VSBuffer.concat([T,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),T=(M&128)>>>7,F=(M&64)>>>6,U=P.readUInt8(1),x=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),T=(M&128)>>>7;let F=M&127,U=1;F===126?F=P.readUInt8(++U)*2**8+P.readUInt8(++U):F===127&&(F=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let x=0;T&&(x=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=F,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),f(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class b extends R.Disposable{constructor(l,P,M,T,F,U){super(),this._tracer=l,this._onData=F,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new p(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:w.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(P,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,P){return new Promise((M,T)=>{l.write(P),l.flush(F=>M(F))})}acceptFrame(l,P,M){this._readQueue.push({data:l,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,P,M){return new Promise((T,F)=>{l.write(P),M&&l.write(w.VSBuffer.fromByteArray([0,0,255,255])),l.flush(U=>T(U))})}}class p extends R.Disposable{constructor(l,P,M,T){super(),this._tracer=l,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(T),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(w.VSBuffer.wrap(F))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?w.VSBuffer.concat(this._recordedInflateBytes):w.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=w.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(P)})}}class S extends R.Disposable{constructor(l,P){super(),this._tracer=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(w.VSBuffer.wrap(M))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=w.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function f(a,l){if(l===0)return;const P=a.byteLength>>>2;for(let re=0;re<P;re++){const le=a.readUInt32BE(re*4);a.writeUInt32BE(le^l,re*4)}const M=P*4,T=a.byteLength-M,F=l>>>24&255,U=l>>>16&255,x=l>>>8&255;T>=1&&a.writeUInt8(a.readUInt8(M)^F,M),T>=2&&a.writeUInt8(a.readUInt8(M+1)^U,M+1),T>=3&&a.writeUInt8(a.readUInt8(M+2)^x,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function c(){const a=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)(I().os.tmpdir(),`vscode-ipc-${a}.sock`),o(l),l}e.createRandomIPCHandle=c;function i(a,l,P){const M=I().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${l}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${l}.sock`):T=(0,D.join)(a,`${P}-${l}.sock`),o(T),T}e.createStaticIPCHandle=i;function o(a){const l=h[y.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{constructor(l){super(n.toClientConnectionEvent(l)),this.server=l}static toClientConnectionEvent(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,M=>({protocol:new C.Protocol(new v(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(a){return new Promise((l,P)=>{const M=I().net.createServer();M.on("error",P),M.listen(a,()=>{M.removeListener("error",P),l(new n(M))})})}e.serve=r;function s(a,l){return new Promise((P,M)=>{const T=I().net.createConnection(a,()=>{T.removeListener("error",M),P(C.Client.fromSocket(new v(T,`ipc-client${l}`),l))});T.once("error",M)})}e.connect=s}),define(J[100],Z([0,1,8,3,2,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function y(I){const v=I;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var u;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(u=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(v,g=Object.create(null)){super(),this.database=v,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((g,d)=>this.accept(d,g)),v.deleted?.forEach(g=>this.accept(g,void 0))}accept(v,g){if(this.state===u.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(g)?d=this.cache.delete(v):this.cache.get(v)!==g&&(this.cache.set(v,g),d=!0),d&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,g){const d=this.cache.get(v);return(0,R.isUndefinedOrNull)(d)?g:d}getBoolean(v,g){const d=this.get(v);return(0,R.isUndefinedOrNull)(d)?g:d==="true"}getNumber(v,g){const d=this.get(v);return(0,R.isUndefinedOrNull)(d)?g:parseInt(d,10)}async set(v,g){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(v);const d=String(g);if(this.cache.get(v)!==d)return this.cache.set(v,d),this.pendingInserts.set(v,d),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===u.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((g,d)=>this.items.set(d,g)),v.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=C}),define(J[148],Z([0,1,8,3,32,9,23]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(C,I=Object.create(null)){this.path=C,this.options=I,this.name=(0,R.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const C=await this.whenConnected,I=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(g=>I.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(C){const I=await this.whenConnected;return this.doUpdateItems(I,C)}doUpdateItems(C,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,k.mapToString)(I.insert):"0"}), delete(${I.delete?(0,k.setToString)(I.delete):"0"})`),this.transaction(C,()=>{const v=I.insert,g=I.delete;if(v&&v.size>0){const d=[];d.push([]);let E=0;v.forEach((b,p)=>{let S=d[E];S.length>y.MAX_HOST_PARAMETERS&&(E++,S=[],d.push(S)),S.push(p,b)}),d.forEach(b=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let S=0;return v.forEach((f,h)=>{p.push(h),S+=f.length}),`Keys: ${p.join(", ")} Length: ${S}`})})}if(g&&g.size){const d=[];d.push([]);let E=0;g.forEach(b=>{let p=d[E];p.length>y.MAX_HOST_PARAMETERS&&(E++,p=[],d.push(p)),p.push(b)}),d.forEach(b=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return g.forEach(S=>{p.push(S)}),`Keys: ${p.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,C)}doClose(C,I){return new Promise((v,g)=>{C.db.close(d=>(d&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${d}`),this.path===y.IN_MEMORY_PATH?v():!C.isErroneous&&!C.isInMemory?this.backup().then(v,E=>(this.logger.error(`[storage ${this.name}] backup(): ${E}`),v())):typeof I=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(E=>{const b=()=>this.doClose(E,void 0);return this.doUpdateItems(E,{insert:I()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(v,g):g(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return D.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const I=await this.whenConnected,v=await this.get(I,C?"PRAGMA integrity_check":"PRAGMA quick_check"),g=C?v.integrity_check:v.quick_check;return I.isErroneous?`${g} (last error: ${I.lastError})`:I.isInMemory?`${g} (in-memory!)`:g}async connect(C,I=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${I})`);try{return await this.doConnect(C)}catch(v){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&I)return await(0,w.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await D.Promises.unlink(C);try{await D.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(C,I){C.isErroneous=!0,C.lastError=I,this.logger.error(I)}doConnect(C){return new Promise((I,v)=>{new Promise((g,d)=>{q(["@vscode/sqlite3"],g,d)}).then(g=>{const d={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(C,E=>E?d.db&&E.code!=="SQLITE_CANTOPEN"?d.db.close(()=>v(E)):v(E):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(d),b=>d.db.close(()=>v(b)))),isInMemory:C===y.IN_MEMORY_PATH};d.db.on("error",E=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${E}`)),this.logger.isTracing&&d.db.on("trace",E=>this.logger.trace(`[storage ${this.name}] Trace (event): ${E}`))},v)})}exec(C,I){return new Promise((v,g)=>{C.db.exec(I,d=>d?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${d}`),g(d)):v())})}get(C,I){return new Promise((v,g)=>{C.db.get(I,(d,E)=>d?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${d}`),g(d)):v(E))})}all(C,I){return new Promise((v,g)=>{C.db.all(I,(d,E)=>d?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${d}`),g(d)):v(E))})}transaction(C,I){return new Promise((v,g)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),I(),C.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${d}`),g(d)):v())})})}prepare(C,I,v,g){const d=C.db.prepare(I),E=b=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${b} (${I}). Details: ${g()}`)};d.on("error",E),v(d),d.finalize(b=>{b&&E(b),d.removeListener("error",E)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class u{constructor(C){C&&typeof C.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace?.(C)}error(C){this.logError?.(C)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[149],Z([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[150],Z([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[151],Z([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[152],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[153],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[154],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[155],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(J[156],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(J[157],Z([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[158],Z([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[159],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[160],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[161],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[162],Z([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[163],Z([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[164],Z([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[165],Z([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[166],Z([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[167],Z([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[168],Z([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(J[169],Z([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[170],Z([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[171],Z([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(J[172],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(J[173],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[174],Z([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(J[175],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[176],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[177],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(J[178],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(J[179],Z([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(y,u,m){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(y,u,m){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(y){super(),this.channel=y}reload(y){this.channel.call("reload",[y])}get onReload(){return this.channel.listen("reload")}close(y){this.channel.call("close",[y])}get onClose(){return this.channel.listen("close")}attachSession(y,u,m){this.channel.call("attach",[y,u,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(y,u){this.channel.call("terminate",[y,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(y,u){return this.channel.call("openExtensionDevelopmentHostWindow",[y,u])}}e.ExtensionHostDebugChannelClient=R}),define(J[180],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=w}),define(J[181],Z([0,1,134,52,13,9,34,16,7]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(E,b,p){this._args=E,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return u.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=D.env.VSCODE_PORTABLE;return E?u.URI.file((0,R.join)(E,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,R.resolve)(E):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,R.resolve)(E):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,R.resolve)(E);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?u.URI.parse(E):u.URI.file((0,R.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=D.env.VSCODE_PORTABLE;return E?u.URI.file((0,R.join)(E,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function C(d,E){return g(d["inspect-extensions"],d["inspect-brk-extensions"],5870,E,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=C;function I(d,E){return g(d["inspect-search"],d["inspect-brk-search"],5876,E,d.extensionEnvironment)}e.parseSearchPort=I;function v(d,E){return g(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,E,d.extensionEnvironment)}e.parsePtyHostPort=v;function g(d,E,b,p,S,f){const c=Number(E||d)||(p?null:b),i=c?Boolean(!!E):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:c,break:i,debugId:S,env:o}}}),define(J[101],Z([0,1,272,4,152]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function y(d,E,b=D){const p={},S=["_"],f=[];for(const o in E){const n=E[o];n.alias&&(p[o]=n.alias),n.type==="string"||n.type==="string[]"?(S.push(o),n.deprecates&&S.push(...n.deprecates)):n.type==="boolean"&&(f.push(o),n.deprecates&&f.push(...n.deprecates))}const h=w(d,{string:S,boolean:f,alias:p}),c={},i=h;c._=h._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in E){const n=E[o];n.alias&&delete i[n.alias];let r=i[o];if(n.deprecates)for(const s of n.deprecates)i.hasOwnProperty(s)&&(r||(r=i[s],r&&b.onDeprecatedOption(s,n.deprecationMessage||(0,k.localize)(35,null,o))),delete i[s]);if(typeof r<"u"){if(n.type==="string[]"){if(Array.isArray(r)||(r=[r]),!n.allowEmptyValue){const s=r.filter(a=>a.length>0);s.length!==r.length&&(b.onEmptyValue(o),r=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(r)?(r=r.pop(),b.onMultipleValues(o,r)):!r&&!n.allowEmptyValue&&(b.onEmptyValue(o),r=void 0));c[o]=r,n.deprecationMessage&&b.onDeprecatedOption(o,n.deprecationMessage)}delete i[o]}for(const o in i)b.onUnknownOption(o);return c}e.parseArgs=y;function u(d,E){let b="";return E.args&&(Array.isArray(E.args)?b=` <${E.args.join("> <")}>`:b=` <${E.args}>`),E.alias?`-${E.alias} --${d}${b}`:`--${d}${b}`}function m(d,E){let b=0;const p=[];for(const c in d){const i=d[c],o=u(c,i);b=Math.max(b,o.length),p.push([o,i.description])}const S=b+2+1;if(E-S<25)return p.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const f=E-S-1,h=[];for(const c of p){const i=c[0],o=I(c[1],f),n=C(S-i.length-2);h.push("  "+i+n+o[0]);for(let r=1;r<o.length;r++)h.push(C(S)+o[r])}return h}e.formatOptions=m;function C(d){return" ".repeat(d)}function I(d,E){const b=[];for(;d.length;){const p=d.length<E?d.length:d.lastIndexOf(" ",E),S=d.slice(0,p).trim();d=d.slice(p),b.push(S)}return b}function v(d,E,b,p,S){const f=process.stdout.isTTY&&process.stdout.columns||80,h=S?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${d} ${b}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${E} [${(0,k.localize)(38,null)}]${h}`),c.push(""),S?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,E)):c.push((0,k.localize)(40,null,E)),c.push(""));const i={};for(const o in p){const n=p[o];if(n.description&&n.cat){let r=i[n.cat];r||(i[n.cat]=r={}),r[o]=n}}for(const o in i){const n=o,r=i[n];r&&(c.push(R[n]),c.push(...m(r,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=v;function g(d,E){return`${d||(0,k.localize)(41,null)}
${E||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=g}),define(J[182],Z([0,1,77,179,101]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(y,u){super(),this.windowsMainService=y,this.userDataProfilesMainService=u}call(y,u,m){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(y,u,m)}async openExtensionDevelopmentHostWindow(y,u){const m=(0,k.parseArgs)(y,k.OPTIONS);m.debugRenderer=u;const C=m.extensionDevelopmentPath;if(!C)return{success:!1};const I=this.userDataProfilesMainService.checkAndCreateProfileFromCli(m);I&&await I;const[v]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:m});if(!u)return{success:!0};const g=v.win;if(!g)return{success:!0};const d=g.webContents.debugger;let E=d.isAttached()?1/0:0;const b=(0,w.createServer)(p=>{E++===0&&d.attach();let S=!1;const f=i=>{S||p.write(JSON.stringify(i)+"\0")},h=(i,o,n,r)=>f({method:o,params:n,sessionId:r});g.on("close",()=>{d.removeListener("message",h),p.end(),S=!0}),d.addListener("message",h);let c=Buffer.alloc(0);p.on("data",i=>{c=Buffer.concat([c,i]);for(let o=c.indexOf(0);o!==-1;o=c.indexOf(0)){let n;try{const r=c.slice(0,o).toString("utf8");c=c.slice(o+1),n=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(n.method,n.params,n.sessionId).then(r=>f({id:n.id,sessionId:n.sessionId,result:r})).catch(r=>f({id:n.id,sessionId:n.sessionId,error:{code:0,message:r.message}}))}}),p.on("error",i=>{console.error("error on cdp pipe:",i)}),p.on("close",()=>{S=!0,--E===0&&d.detach()})});return await new Promise(p=>b.listen(0,p)),g.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(J[59],Z([0,1,273,153,101]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(v,g){const d={onUnknownOption:b=>{console.warn((0,t.localize)(0,null,b))},onMultipleValues:(b,p)=>{console.warn((0,t.localize)(1,null,b,p))},onEmptyValue:b=>{console.warn((0,t.localize)(2,null,b))},onDeprecatedOption:(b,p)=>{console.warn((0,t.localize)(3,null,b,p))}},E=(0,k.parseArgs)(v,k.OPTIONS,g?d:void 0);return E.goto&&E._.forEach(b=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,t.localize)(4,null))),E["max-memory"]&&w(parseInt(E["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),E}function y(v){const g=v.findIndex(d=>!/^-/.test(d));if(g>-1)return[...v.slice(0,g),...v.slice(g+1)]}function u(v){let[,...g]=v;process.env.VSCODE_DEV&&(g=y(g)||[]);const d=!I(process.env);return D(g,d)}e.parseMainProcessArgv=u;function m(v){const[,,...g]=v;return D(g,!0)}e.parseCLIProcessArgv=m;function C(v,...g){const d=v.indexOf("--");return d===-1?v.push(...g):v.splice(d,0,...g),v}e.addArg=C;function I(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function q(e,w,t,k){function R(y){const u=D(y),m=[u];return e.isAbsolute(u)||m.unshift(k),e.resolve(...m)}function D(y){const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const C=y["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(I,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(J[183],Z([0,274,30,13,16,34]),function(e,w,t,k,R,D){const y=R.dirname(k.FileAccess.asFileUri("",e)),u=e.__$__nodeRequire(R.joinPath(y,"package.json").fsPath);return q(w,t,u.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),t=require("os");module.exports=q(w,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[184],Z([0,1,30,181,183]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(y,u){super(y,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(y)},u)}}e.NativeEnvironmentService=R}),define(J[185],Z([0,1,29,30,31]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const y=(0,k.randomPath)((0,t.tmpdir)());try{return(0,w.writeFileSync)(y,""),D&&console.log(`Marker file for --wait created: ${y}`),y}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFile=R}),define(J[186],Z([0,1,12,155]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,y,u){try{R(D,y,u)}catch{}return D}e.localizeManifest=k;function R(D,y,u){const m=(C,I,v)=>{const g=C[I];if((0,w.isString)(g)){const d=g,E=d.length;if(E>1&&d[0]==="%"&&d[E-1]==="%"){const b=d.substr(1,E-2);let p=y[b];p===void 0&&u&&(p=u[b]);const S=typeof p=="string"?p:p.message;if(S!==void 0){const f=u?.[b],h=typeof f=="string"?f:f?.message;if(v&&(I==="title"||I==="category")&&h&&h!==S){const c={value:S,original:h};C[I]=c}else C[I]=S}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,b)}`)}}else if((0,w.isObject)(g))for(const d in g)g.hasOwnProperty(d)&&(d==="commands"?m(g,d,!0):m(g,d,v));else if(Array.isArray(g))for(let d=0;d<g.length;d++)m(g,d,v)};for(const C in D)D.hasOwnProperty(C)&&m(D,C)}}),define(J[187],Z([0,1,16,94,157,188]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function u(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=u;function m(p){if(!u(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=p.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=m;function C(p){if(!p)return null;const S=p.majorBase,f=p.majorMustEqual,h=p.minorBase;let c=p.minorMustEqual;const i=p.patchBase;let o=p.patchMustEqual;p.hasCaret&&(S===0||(c=!1),o=!1);let n=0;if(p.preRelease){const r=y.exec(p.preRelease);if(r){const[,s,a,l]=r;n=Date.UTC(Number(s),Number(a)-1,Number(l))}}return{majorBase:S,majorMustEqual:f,minorBase:h,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:n}}e.normalizeVersion=C;function I(p,S,f){let h;typeof p=="string"?h=C(m(p)):h=p;let c;S instanceof Date?c=S.getTime():typeof S=="string"&&(c=new Date(S).getTime());let i;if(typeof f=="string"?i=C(m(f)):i=f,!h||!i)return!1;const o=h.majorBase,n=h.minorBase,r=h.patchBase;let s=i.majorBase,a=i.minorBase,l=i.patchBase;const P=i.notBefore;let M=i.majorMustEqual,T=i.minorMustEqual,F=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:n>a?!0:n<a||c&&c<P?!1:r>=l:(o===1&&s===0&&(!M||!T||!F)&&(s=1,a=0,l=0,M=!0,T=!1,F=!1),o<s?!1:o>s?!M:n<a?!1:n>a?!T:r<l?!1:r>l?!F:!(c&&c<P))}e.isValidVersion=I;function v(p,S,f,h,c){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!b(h.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!b(h.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const r=(0,w.joinPath)(f,h.main);(0,w.isEqualOrParent)(r,f)||i.push([t.default.Warning,k.localize(10,null,r.path,f.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,w.joinPath)(f,h.browser);(0,w.isEqualOrParent)(r,f)||i.push([t.default.Warning,k.localize(13,null,r.path,f.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(h.version))return i.push([t.default.Error,k.localize(15,null)]),i;const o=[];if(!g(p,S,h,c,o))for(const r of o)i.push([t.default.Error,r]);return i}e.validateExtensionManifest=v;function g(p,S,f,h,c){return h||typeof f.main>"u"&&typeof f.browser>"u"?!0:E(p,S,f.engines.vscode,c)}e.isValidExtensionVersion=g;function d(p,S,f){return p==="*"||E(S,f,p)}e.isEngineValid=d;function E(p,S,f,h=[]){const c=C(m(f));if(!c)return h.push(k.localize(16,null,f)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return h.push(k.localize(17,null,f)),!1}else if(!c.majorMustEqual)return h.push(k.localize(18,null,f)),!1;return I(p,S,c)?!0:(h.push(k.localize(19,null,p,f)),!1)}function b(p){if(!Array.isArray(p))return!1;for(let S=0,f=p.length;S<f;S++)if(typeof p[S]!="string")return!1;return!0}}),define(J[189],Z([0,1,17,28]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,y){let u=y&&y.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const C=(await D.readFile(R.serviceMachineIdResource)).value.toString();u=(0,t.isUUID)(C)?C:null}catch{u=null}if(!u){u=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,w.VSBuffer.fromString(u))}catch{}}return y?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(J[68],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w}),define(J[190],Z([0,1,68]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(D,y,u){y instanceof w.SyncDescriptor||(y=new w.SyncDescriptor(y,[],u)),t.push([D,y])}e.registerSingleton=k;function R(){return t}e.getSingletonServiceDescriptors=R}),define(J[191],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=w;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const y=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(D);y.outgoing.set(this._hashFn(D),u),u.incoming.set(this._hashFn(R),y)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const y of this._nodes.values())y.outgoing.delete(D),y.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let y=this._nodes.get(D);return y||(y=new w(R),this._nodes.set(D,y)),y}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,y]of this._nodes)R.push(`${D}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const y=new Set([R]),u=this._findCycle(D,y);if(u)return u}}_findCycle(R,D){for(const[y,u]of R.outgoing){if(D.has(y))return[...D,y].join(" -> ");D.add(y);const m=this._findCycle(u,D);if(m)return m;D.delete(y)}}}e.Graph=t}),define(J[5],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,y,u){y[w.DI_TARGET]===y?y[w.DI_DEPENDENCIES].push({id:D,index:u}):(y[w.DI_DEPENDENCIES]=[{id:D,index:u}],y[w.DI_TARGET]=y)}function k(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const y=function(u,m,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,u,C)};return y.toString=()=>D,w.serviceIds.set(D,y),y}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(J[60],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(J[19],Z([0,1,12,7,5]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var y;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function u(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function m(p,S){const f=Object.create(null);for(const h in p)C(f,h,p[h],S);return f}e.toValuesTree=m;function C(p,S,f,h){const c=S.split("."),i=c.pop();let o=p;for(let n=0;n<c.length;n++){const r=c[n];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${S} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=f}catch{h(`Ignoring ${S} as ${c.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${S} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=C;function I(p,S){const f=S.split(".");v(p,f)}e.removeFromValueTree=I;function v(p,S){const f=S.shift();if(S.length===0){delete p[f];return}if(Object.keys(p).indexOf(f)!==-1){const h=p[f];typeof h=="object"&&!Array.isArray(h)&&(v(h,S),Object.keys(h).length===0&&delete p[f])}}function g(p,S,f){function h(o,n){let r=o;for(const s of n){if(typeof r!="object"||r===null)return;r=r[s]}return r}const c=S.split("."),i=h(p,c);return typeof i>"u"?f:i}e.getConfigurationValue=g;function d(p,S,f){Object.keys(S).forEach(h=>{h!=="__proto__"&&(h in p?w.isObject(p[h])&&w.isObject(S[h])?d(p[h],S[h],f):f&&(p[h]=S[h]):p[h]=S[h])})}e.merge=d;function E(p,S,f){const h=p.inspect(S),c=p.inspect(f);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:h.defaultValue}e.getMigratedSettingValue=E;function b(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(J[69],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,y){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=y}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const y of Object.keys(this.secretVault[R]||{}))D.push({account:y,password:this.secretVault[R][y]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(J[84],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(J[102],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(J[36],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(J[26],Z([0,1,52,9,83,36,184,5]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(R.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([w.memoize],u.prototype,"cachedLanguagesPath",null),ve([w.memoize],u.prototype,"backupHome",null),ve([w.memoize],u.prototype,"backupWorkspacesPath",null),ve([w.memoize],u.prototype,"mainIPCHandle",null),ve([w.memoize],u.prototype,"mainLockfile",null),ve([w.memoize],u.prototype,"disableUpdates",null),ve([w.memoize],u.prototype,"disableKeytar",null),ve([w.memoize],u.prototype,"codeCachePath",null),ve([w.memoize],u.prototype,"useCodeCache",null),e.EnvironmentMainService=u}),define(J[192],Z([0,1,154,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,S){switch(p){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function y(p,S){return S==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function u(p,S,f){return y(S,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f?!0:m(f).includes(p)}e.isTargetPlatformCompatible=u;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function C(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=C;var I;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var v;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var g;(function(p){p.Install="install",p.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var E;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(S,f){super(S),this.code=f,this.name=f}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(J[193],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(J[194],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[103],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(J[195],Z([0,1,51,13,9,4,78,23,82,158,103]),function(q,e,w,t,k,R,D,y,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=m.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends v{openTerminal(h,c){return this.spawnTerminal(w,h,u.getWindowsShell(),c)}spawnTerminal(h,c,i,o){const n=c.windowsExec||g.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(n).toLowerCase();if(r==="cmder"||r==="cmder.exe")return h.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((a,l)=>{const P=b(process),M=h.spawn(i,s,{cwd:o,env:P});M.on("error",l),M.on("exit",()=>a())})}runInTerminal(h,c,i,o,n){const r="windowsExec"in n&&n.windowsExec?n.windowsExec:g.getDefaultTerminalWindows();return new Promise((s,a)=>{const l=`"${c} - ${I}"`,P=`""${i.join('" "')}" & pause"`,M=["/c","start",l,"/wait",r,"/c",P],T=Object.assign({},b(process),o);Object.keys(T).filter(x=>T[x]===null).forEach(x=>delete T[x]);const F={cwd:c,env:T,windowsVerbatimArguments:!0};w.spawn(g.CMD,M,F).on("error",x=>{a(p(x))}),s(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class d extends v{openTerminal(h,c){return this.spawnTerminal(w,h,c)}runInTerminal(h,c,i,o,n){const r=n.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(r===C.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const l=r===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,q).fsPath,"-t",h||I,"-w",c];for(const U of i)M.push("-a"),M.push(U);if(o){const U=Object.assign({},b(process),o);for(const x in U){const re=U[x];re===null?(M.push("-u"),M.push(x)):(M.push("-e"),M.push(`${x}=${re}`))}}let T="";const F=w.spawn(d.OSASCRIPT,M);F.on("error",U=>{a(p(U))}),F.stderr.on("data",U=>{T+=U.toString()}),F.on("exit",U=>{if(U===0)s(void 0);else if(T){const x=T.split(`
`,1);a(new Error(x[0]))}else a(new Error(m.localize(1,null,l,U)))})}else a(new Error(m.localize(2,null,r)))})}spawnTerminal(h,c,i){const o=c.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((n,r)=>{const s=["-a",o];i&&s.push(i);const a=b(process),l=h.spawn("/usr/bin/open",s,{cwd:i,env:a});l.on("error",r),l.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class E extends v{openTerminal(h,c){return this.spawnTerminal(w,h,c)}runInTerminal(h,c,i,o,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{const l=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const M=`${S(i)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;l.push(`''${M}''`);const T=Object.assign({},b(process),o);Object.keys(T).filter(re=>T[re]===null).forEach(re=>delete T[re]);const F={cwd:c,env:T};let U="";const x=w.spawn(P,l,F);x.on("error",re=>{a(p(re))}),x.stderr.on("data",re=>{U+=re.toString()}),x.on("exit",re=>{if(re===0)s(void 0);else if(U){const le=U.split(`
`,1);a(new Error(le[0]))}else a(new Error(m.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await y.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{h?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,c,i){const o=c.linuxExec?Promise.resolve(c.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{o.then(s=>{const a=b(process),l=h.spawn(s,[],{cwd:i,env:a});l.on("error",r),l.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=E,E.WAIT_MESSAGE=m.localize(3,null);function b(f){const h={...f.env};return(0,D.sanitizeProcessEnvironment)(h),h}function p(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(m.localize(5,null,f.path)):f}function S(f){let h="";for(const c of f)c.indexOf(" ")>=0?h+='"'+c+'"':h+=c,h+=" ";return h}}),define(J[14],Z([0,1,32,9,25,12,7,160,5]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function m(K){return K.create===!0}e.isFileOpenForWriteOptions=m;var C;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var I;(function(K){K[K.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var v;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=g;function d(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=d;function E(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=E;function b(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function p(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=p;function S(K){return g(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var f;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor($,_){super($),this.code=_}}e.FileSystemProviderError=h;function c(K,$){const _=new h(K.toString(),$);return o(_,$),_}e.createFileSystemProviderError=c;function i(K){return K||c((0,y.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=i;function o(K,$){return K.name=$?`${$} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=o;function n(K){if(!K)return f.Unknown;if(K instanceof h)return K.code;const $=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!$)return f.Unknown;switch($[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=n;function r(K){if(K instanceof T)return K.fileOperationResult;switch(n(K)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor($,_,A){this.resource=$,this.operation=_,this.target=A}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var l;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class P{constructor($,_){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const A=new Map;for(const W of $){const z=A.get(W.type);switch(z?z.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,z]of A)switch(W){case 1:this.added=w.TernarySearchTree.forUris(()=>_),this.added.fill(z);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>_),this.updated.fill(z);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>_),this.deleted.fill(z);break}}contains($,..._){return this.doContains($,{includeChildren:!1},..._)}affects($,..._){return this.doContains($,{includeChildren:!0},..._)}doContains($,_,...A){if(!$)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get($)||_.includeChildren&&this.added?.findSuperstr($))||(!W||A.includes(0))&&(this.updated?.get($)||_.includeChildren&&this.updated?.findSuperstr($))||(!W||A.includes(2))&&(this.deleted?.findSubstr($)||_.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function M(K,$,_){return!K||!$||K===$||$.length>K.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),_?(0,k.startsWithIgnoreCase)(K,$):K.indexOf($)===0)}e.isParent=M;class T extends Error{constructor($,_,A){super($),this.fileOperationResult=_,this.options=A}}e.FileOperationError=T;class F extends T{constructor($,_,A){super($,2,A),this.stat=_}}e.NotModifiedSinceFileOperationError=F;var U;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=re;async function le(K,$){if(!$.hasProvider(D.URI.from({scheme:K.scheme})))return new Promise(_=>{const A=$.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===K.scheme&&W.added&&(A.dispose(),_())})})}e.whenProviderRegistered=le,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize($){return(0,R.isNumber)($)||($=0),$<ue.KB?(0,y.localize)(1,null,$.toFixed(0)):$<ue.MB?(0,y.localize)(2,null,($/ue.KB).toFixed(2)):$<ue.GB?(0,y.localize)(3,null,($/ue.MB).toFixed(2)):$<ue.TB?(0,y.localize)(4,null,($/ue.GB).toFixed(2)):(0,y.localize)(5,null,($/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function de(K){return{maxFileSize:K===0?300*ue.MB:16*ue.GB,maxHeapSize:K===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=de}),define(J[196],Z([0,1,17,44,18,3,2,58,7,28,14]),function(q,e,w,t,k,R,D,y,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends D.Disposable{constructor(g,d){super(),this.channel=g,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,d){const{buffer:E}=await this.channel.call("readFile",[g,d]);return E}readFileStream(g,d,E){const b=(0,y.newWriteableStream)(S=>w.VSBuffer.concat(S.map(f=>w.VSBuffer.wrap(f))).buffer),p=this.channel.listen("readFileStream",[g,d])(S=>{if(S instanceof w.VSBuffer)b.write(S.buffer);else{if(S==="end")b.end();else{let f=S;f instanceof Error||(f=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(f),C.FileSystemProviderErrorCode.Unknown)),b.error(f),b.end()}p.dispose()}});return E.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),p.dispose()}),b}writeFile(g,d,E){return this.channel.call("writeFile",[g,w.VSBuffer.wrap(d),E])}open(g,d){return this.channel.call("open",[g,d])}close(g){return this.channel.call("close",[g])}async read(g,d,E,b,p){const[S,f]=await this.channel.call("read",[g,d,p]);return E.set(S.buffer.slice(0,f),b),f}write(g,d,E,b,p){return this.channel.call("write",[g,d,w.VSBuffer.wrap(E),b,p])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,d){return this.channel.call("delete",[g,d])}rename(g,d,E){return this.channel.call("rename",[g,d,E])}copy(g,d,E){return this.channel.call("copy",[g,d,E])}cloneFile(g,d){return this.channel.call("cloneFile",[g,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const d=g;this._onDidChange.fire(d.map(E=>({resource:u.URI.revive(E.resource),type:E.type})))}else{const d=g;this._onDidWatchError.fire(d)}}))}watch(g,d){const E=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,E,g,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=I}),define(J[104],Z([0,1,17,18,161,14]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(C,I,v,g,d,E){let b;try{await y(C,I,v,g,d,E)}catch(p){b=p}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b<"u"&&v.error(b),v.end()}}e.readFileIntoStream=D;async function y(C,I,v,g,d,E){u(E);const b=await C.open(I,{create:!1});try{u(E);let p=0,S=0,f=d&&typeof d.length=="number"?d.length:void 0,h=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,i=0;do S=await C.read(b,c,h.buffer,i,h.byteLength-i),c+=S,i+=S,p+=S,typeof f=="number"&&(f-=S),i===h.byteLength&&(await v.write(g(h)),h=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),i=0);while(S>0&&(typeof f!="number"||f>0)&&u(E)&&m(p,d));if(i>0){let o=i;typeof f=="number"&&(o=Math.min(i,f)),v.write(g(h.slice(0,o)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await C.close(b)}}function u(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function m(C,I){if(I?.limits){if(typeof I.limits.memory=="number"&&C>I.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&C>I.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[70],Z([0,1,95,2,9,4,7,14]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(p){return p.recursive===!0}e.isRecursiveWatchRequest=u;class m extends t.Disposable{constructor(S,f,h,c){super(),this.onFileChanges=S,this.onLogMessage=f,this.verboseLogging=h,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),S.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),S.add(this.watcher.onDidError(f=>this.onError(f)))}onError(S){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class C extends m{constructor(S,f,h){super(S,f,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class I extends m{constructor(S,f,h){super(S,f,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function v(p){return p.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=v;function g(p){const S=new b;for(const f of p)S.processEvent(f);return S.coalesce()}e.coalesceEvents=g;function d(p,S){return typeof S=="string"&&!S.startsWith(w.GLOBSTAR)&&!(0,k.isAbsolute)(S)?{base:p,pattern:S}:S}e.normalizeWatcherPattern=d;function E(p,S){const f=[];for(const h of S)f.push((0,w.parse)(d(p,h)));return f}e.parseWatcherPatterns=E;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return R.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const f=this.mapPathToChange.get(this.toKey(S));let h=!1;if(f){const c=f.type,i=S.type;f.path!==S.path&&(S.type===2||S.type===1)?h=!0:c===1&&i===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(f)):c===2&&i===1?f.type=0:c===1&&i===0||(f.type=i)}else h=!0;h&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],f=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(S.push(h),!1):!0).sort((h,c)=>h.path.length-c.path.length).filter(h=>f.some(c=>(0,y.isParent)(h.path,c,!R.isLinux))?!1:(f.push(h.path),!0)).concat(S)}}}),define(J[197],Z([0,1,29,8,22,31,2,80,9,4,96,23,70]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(b,p,S,f){super(),this.request=b,this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await I.Promises.stat(b);this._register(await this.doWatch(b,p.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let p=b.path;try{p=await I.Promises.realpath(b.path),b.path===p&&(p=await(0,C.realcase)(b.path)??b.path),b.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${p})`)}catch{}return p}async doWatch(b,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token),f=new D.DisposableStore;try{const h=(0,u.basename)(b),c=(0,w.watch)(b);f.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${b}'`);const i=new Set;if(p)try{for(const n of await I.Promises.readdir(b))i.add(n)}catch(n){this.error(n)}const o=new Map;f.add((0,D.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),c.on("error",(n,r)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),c.on("change",(n,r)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let s="";if(r&&(s=r.toString(),m.isMacintosh&&(s=(0,y.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(p)if(n==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===h&&!await I.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,u.join)(b,s));if(S.token.isCancellationRequested)return;let P;l?i.has(s)?P=0:(P=1,i.add(s)):(i.delete(s),P=2),this.onFileChange({path:(0,u.join)(this.request.path,s),type:P})},g.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(s)?a=0:(a=1,i.add(s)),this.onFileChange({path:(0,u.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==h){const a=setTimeout(async()=>{const l=await I.Promises.exists(b);S.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await I.Promises.exists(b)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${h.toString()})`)}return(0,D.toDisposable)(()=>{S.dispose(!0),f.dispose()})}async onFileChange(b,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!p&&this.excludes.some(S=>S(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,v.coalesceEvents)(S);if(f.length>0){if(this.verboseLogging)for(const c of f)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(m.isLinux)return I.Promises.exists(b);try{const p=(0,u.basename)(b);return(await I.Promises.readdir((0,u.dirname)(b))).some(f=>f===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function d(E,b,p,S,f=512){const h=await I.Promises.open(E,"r"),c=Buffer.allocUnsafe(f),i=new k.CancellationTokenSource(S);let o,n=!1;const r={path:E,excludes:[],recursive:!1},s=new g(r,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:P}=await I.Promises.read(h,c,0,f,null);if(!P||i.token.isCancellationRequested)break;b(c.slice(0,P))}}catch(P){o=new Error(P),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,p(),new Promise((a,l)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await I.Promises.close(h)}catch(P){o=new Error(P)}o?l(o):a()})})}e.watchFileContents=d}),define(J[198],Z([0,1,3,95,2,4,197]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new w.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=w.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const C=this.normalizeRequests(m),I=C.filter(g=>{const d=this.watchers.get(g.path);return d?!(0,t.patternsEquals)(d.request.excludes,g.excludes)||!(0,t.patternsEquals)(d.request.includes,g.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:g})=>!C.find(d=>d.path===g.path&&(0,t.patternsEquals)(d.excludes,g.excludes)&&(0,t.patternsEquals)(d.includes,g.includes))).map(({request:g})=>g.path);I.length&&this.trace(`Request to start watching: ${I.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const g of v)this.stopWatching(g);for(const g of I)this.startWatching(g)}startWatching(m){const C=new D.NodeJSFileWatcherLibrary(m,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),I={request:m,instance:C};this.watchers.set(m.path,I)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const C=this.watchers.get(m);C&&(this.watchers.delete(m),C.instance.dispose())}normalizeRequests(m){const C=new Map;for(const I of m){const v=R.isLinux?I.path:I.path.toLowerCase();C.set(v,I)}return Array.from(C.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,C]of this.watchers)C.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,C){return C?`[File Watcher (node.js)] ${m} (path: ${C.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=y}),define(J[199],Z([0,1,70,198]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends w.AbstractNonRecursiveWatcherClient{constructor(D,y,u){super(D,y,u),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(J[200],Z([0,1,13,45,147,70]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(u,m,C){super(u,m,C),this.init()}createWatcher(u){const m=u.add(new k.Client(w.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(m.onDidProcessExit(({code:C,signal:I})=>this.onError(`terminated by itself with code ${C}, signal: ${I}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(J[85],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(J[201],Z([0,1,8,18,68,191,5,85]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const u=!1;class m extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class C{constructor(d=new y.ServiceCollection,E=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=E,this._parent=b,this._services.set(D.IInstantiationService,this)}createChild(d){return new C(d,this._strict,this)}invokeFunction(d,...E){const b=v.traceInvocation(d);let p=!1;try{return d({get:f=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(f,b);if(!h)throw new Error(`[invokeFunction] unknown service '${f}'`);return h}},...E)}finally{p=!0,b.stop()}}createInstance(d,...E){let b,p;return d instanceof k.SyncDescriptor?(b=v.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(E),b)):(b=v.traceCreation(d),p=this._createInstance(d,E,b)),b.stop(),p}_createInstance(d,E=[],b){const p=D._util.getServiceDependencies(d).sort((h,c)=>h.index-c.index),S=[];for(const h of p){const c=this._getOrCreateServiceInstance(h.id,b);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${h.id}.`,!1),S.push(c)}const f=p.length>0?p[0].index:E.length;if(E.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${E.length} static arguments`);const h=f-E.length;h>0?E=E.concat(new Array(h)):E=E.slice(0,f)}return new d(...E,...S)}_setServiceInstance(d,E){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,E);else if(this._parent)this._parent._setServiceInstance(d,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const E=this._services.get(d);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):E}_getOrCreateServiceInstance(d,E){const b=this._getServiceInstanceOrDescriptor(d);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,E.branch(d,!0)):(E.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,E,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,E,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,E,b){const p=new R.Graph(h=>h.id.toString());let S=0;const f=[{id:d,desc:E,_trace:b}];for(;f.length;){const h=f.pop();if(p.lookupOrInsertNode(h),S++>1e3)throw new m(p);for(const c of D._util.getServiceDependencies(h.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(c.id);if(i||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),i instanceof k.SyncDescriptor){const o={id:c.id,desc:i,_trace:h._trace.branch(c.id,!0)};p.insertEdge(h,o),f.push(o)}}}for(;;){const h=p.roots();if(h.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:c}of h){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,E,b=[],p,S){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(E,b,p,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,E,b,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(d,E=[],b,p){if(b){const S=new w.IdleValue(()=>this._createInstance(d,E,p));return new Proxy(Object.create(null),{get(f,h){if(h in f)return f[h];const c=S.value;let i=c[h];return typeof i!="function"||(i=i.bind(c),f[h]=i),i},set(f,h,c){return S.value[h]=c,!0}})}else return this._createInstance(d,E,p)}_throwIfStrict(d,E){if(E&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=C;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class v{constructor(d,E){this.type=d,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return u?new v(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(d){return u?new v(0,d.name):v._None}branch(d,E){const b=new v(2,d.toString());return this._dep.push([d,E,b]),b}stop(){const d=Date.now()-this._start;v._totals+=d;let E=!1;function b(S,f){const h=[],c=new Array(S+1).join("	");for(const[i,o,n]of f._dep)if(o&&n){E=!0,h.push(`${c}CREATES -> ${i}`);const r=b(S+1,n);r&&h.push(r)}else h.push(`${c}uses -> ${i}`);return h.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(d>2||E)&&console.log(p.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(J[6],Z([0,1,44,3,2,4,5]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function y(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=u.Info;function m(o,n,r){switch(n){case u.Trace:o.trace(r);break;case u.Debug:o.debug(r);break;case u.Info:o.info(r);break;case u.Warning:o.warn(r);break;case u.Error:o.error(r);break;case u.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=m;function C(o){let n="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(r>0?" ":"")+s}return n}e.format=C;class I extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class v extends I{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(u.Trace)&&this.log(u.Trace,C([n,...r]))}debug(n,...r){this.checkLogLevel(u.Debug)&&this.log(u.Debug,C([n,...r]))}info(n,...r){this.checkLogLevel(u.Info)&&this.log(u.Info,C([n,...r]))}warn(n,...r){this.checkLogLevel(u.Warning)&&this.log(u.Warning,C([n,...r]))}error(n,...r){if(this.checkLogLevel(u.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(u.Error,C(s))}else this.log(u.Error,C([n,...r]))}critical(n,...r){this.checkLogLevel(u.Critical)&&this.log(u.Critical,C([n,...r]))}flush(){}}e.AbstractMessageLogger=v;class g extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!R.isWindows}trace(n,...r){this.getLevel()<=u.Trace&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.log(`[main ${y()}]`,n,...r))}debug(n,...r){this.getLevel()<=u.Debug&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.log(`[main ${y()}]`,n,...r))}info(n,...r){this.getLevel()<=u.Info&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.log(`[main ${y()}]`,n,...r))}warn(n,...r){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,n,...r):console.warn(`[main ${y()}]`,n,...r))}error(n,...r){this.getLevel()<=u.Error&&(this.useColors?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,n,...r):console.error(`[main ${y()}]`,n,...r))}critical(n,...r){this.getLevel()<=u.Critical&&(this.useColors?console.error(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.error(`[main ${y()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class d extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class E extends I{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,w.toErrorMessage)(n,this.getLevel()<=u.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class b extends I{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const s of this.logServices)s.trace(n,...r)}debug(n,...r){for(const s of this.logServices)s.debug(n,...r)}info(n,...r){for(const s of this.logServices)s.info(n,...r)}warn(n,...r){for(const s of this.logServices)s.warn(n,...r)}error(n,...r){for(const s of this.logServices)s.error(n,...r)}critical(n,...r){for(const s of this.logServices)s.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=b;class p extends k.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=p;class S extends k.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,r?.always?u.Trace:this.logLevel,r),this.loggers.set(n.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return u.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogService=f;function h(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const n=c(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function c(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}e.parseLogLevel=c;function i(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}e.LogLevelToString=i});var Y=this&&this.__param||function(q,e){return function(w,t){e(w,t,q)}};define(J[202],Z([0,1,69,3,2,6,4]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class bt extends k.Disposable{constructor(m){super(),this.logService=m,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(m,C){let I;try{I=await this.withKeytar()}catch{return null}const v=await I.getPassword(m,C);if(v)try{let{content:g,hasNextChunk:d}=JSON.parse(v);if(!g||!d)return v;let E=1;for(;d;){const b=await I.getPassword(m,`${C}-${E}`),p=JSON.parse(b);g+=p.content,d=p.hasNextChunk,E++}return g}catch{return v}return v}async setPassword(m,C,I){let v;try{v=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}const g=3,d=async(E,b,p)=>{let S=0,f;for(;S<g;)try{await v.setPassword(E,b,p);return}catch(h){f=h,this.logService.warn("Error attempting to set a password: ",h?.message??h),S++,await new Promise(c=>setTimeout(c,200))}throw f};if(D.isWindows&&I.length>bt.MAX_PASSWORD_LENGTH){let E=0,b=0,p=!0;for(;p;){const S=I.substring(E,E+bt.PASSWORD_CHUNK_SIZE);E+=bt.PASSWORD_CHUNK_SIZE,p=I.length-E>0;const f={content:S,hasNextChunk:p};await d(m,b?`${C}-${b}`:C,JSON.stringify(f)),b++}}else await d(m,C,I);this._onDidChangePassword.fire({service:m,account:C})}async deletePassword(m,C){let I;try{I=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const v=await I.getPassword(m,C);if(!v)return!1;const g=await I.deletePassword(m,C);try{let{content:d,hasNextChunk:E}=JSON.parse(v);if(d&&E){let b=1;for(;E;){const p=`${C}-${b}`,S=await I.getPassword(m,p);await I.deletePassword(m,p),E=JSON.parse(S).hasNextChunk,b++}}}catch{}return g&&this._onDidChangePassword.fire({service:m,account:C}),g}async findPassword(m){let C;try{C=await this.withKeytar()}catch{return null}return C.findPassword(m)}async findCredentials(m){let C;try{C=await this.withKeytar()}catch{return[]}return C.findCredentials(m)}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ve([Y(0,R.ILogService)],y),e.BaseCredentialsMainService=y}),define(J[203],Z([0,1,24,8,18,3,2,9,70,6]),function(q,e,w,t,k,R,D,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends D.Disposable{constructor(v,g){super(),this.logService=v,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(v,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,g):this.watchNonRecursive(v,g)}watchUniversal(v,g){const d={path:this.toFilePath(v),excludes:g.excludes,includes:g.includes,recursive:g.recursive},E=(0,w.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,u.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const g of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const g of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(g)&&v.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,g){const d={path:this.toFilePath(v),excludes:g.excludes,includes:g.includes,recursive:!1},E=(0,w.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,u.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,y.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(J[204],Z([0,1,24,8,17,22,3,66,57,2,32,13,71,16,58,159,14,104,6]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends m.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,i){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${c}`);const o=new m.DisposableStore;return this.provider.set(c,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:i}),o.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new b.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:c}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:i}),this.provider.delete(c),(0,m.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){i.push(o)}}),!this.provider.has(c)&&await t.Promises.settled(i)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,i){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return u.Iterable.map(this.provider,([c,i])=>({scheme:c,capabilities:i.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new b.FileOperationError((0,E.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const i=this.provider.get(c.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,E.localize)(1,null,c.toString()),o}return i}async withReadProvider(c){const i=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)||(0,b.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const i=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,i){try{return await this.doResolveFile(c,i)}catch(o){throw(0,b.toFileSystemProviderErrorCode)(o)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,E.localize)(2,null,this.resourceForError(c)),1):(0,b.ensureFileSystemProviderError)(o)}}async doResolveFile(c,i){const o=await this.withProvider(c),n=this.isPathCaseSensitive(o),r=i?.resolveTo,s=i?.resolveSingleChildDescendants,a=i?.resolveMetadata,l=await o.stat(c);let P;return this.toFileStat(o,c,l,void 0,!!a,(M,T)=>(P||(P=C.TernarySearchTree.forUris(()=>!n),P.set(c,!0),r&&P.fill(!0,r)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(c,i,o,n,r,s){const{providerExtUri:a}=this.getExtUri(c),l={resource:i,name:a.basename(i),isFile:(o.type&b.FileType.File)!==0,isDirectory:(o.type&b.FileType.Directory)!==0,isSymbolicLink:(o.type&b.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(l.isDirectory&&s(l,n)){try{const P=await c.readdir(i),M=await t.Promises.settled(P.map(async([T,F])=>{try{const U=a.joinPath(i,T),x=r?await c.stat(U):{type:F};return await this.toFileStat(c,U,x,P.length,r,s)}catch(U){return this.logService.trace(U),null}}));l.children=(0,w.coalesce)(M)}catch(P){this.logService.trace(P),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const i=await this.withProvider(c),o=await i.stat(c);return this.toFileStat(i,c,o,void 0,!0,()=>!1)}async exists(c){const i=await this.withProvider(c);try{return!!await i.stat(c)}catch{return!1}}async canCreateFile(c,i){try{await this.doValidateCreateFile(c,i)}catch(o){return o}return!0}async doValidateCreateFile(c,i){if(!i?.overwrite&&await this.exists(c))throw new b.FileOperationError((0,E.localize)(3,null,this.resourceForError(c)),3,i)}async createFile(c,i=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const n=await this.writeFile(c,i);return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,n)),n}async writeFile(c,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,c,o)||await this.mkdirp(n,r.dirname(c));let a;if((0,b.hasReadWriteCapability)(n)&&!(i instanceof k.VSBuffer))if((0,d.isReadableStream)(i)){const l=await(0,d.peekStream)(i,3);l.ended?a=k.VSBuffer.concat(l.buffer):a=l}else a=(0,d.peekReadable)(i,l=>k.VSBuffer.concat(l),3);else a=i;!(0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(n,c,o,a):await this.doWriteBuffered(n,c,o,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new b.FileOperationEvent(c,4))}catch(s){throw new b.FileOperationError((0,E.localize)(4,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,i,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(i)));let r;try{r=await c.stat(i)}catch{return}if((r.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,E.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==b.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,b.etag)({mtime:o.mtime,size:r.size}))throw new b.FileOperationError((0,E.localize)(7,null),3,o);return r}async readFile(c,i,o){const n=await this.withReadProvider(c);return i?.atomic?this.doReadFileAtomic(n,c,i,o):this.doReadFile(n,c,i,o)}async doReadFileAtomic(c,i,o,n){return new Promise((r,s)=>{this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,i,o,n);r(a)}catch(a){s(a)}})})}async doReadFile(c,i,o,n){const r=await this.doReadFileStream(c,i,{...o,preferUnbuffered:!0},n);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(c,i,o){const n=await this.withReadProvider(c);return this.doReadFileStream(n,c,i,o)}async doReadFileStream(c,i,o,n){const r=new R.CancellationTokenSource(n),s=this.validateReadFile(i,o).then(l=>l,l=>{throw r.cancel(),l});let a;try{return typeof o?.etag=="string"&&o.etag!==b.ETAG_DISABLED&&await s,o?.atomic&&(0,b.hasFileAtomicReadCapability)(c)||!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&o?.preferUnbuffered?a=this.readFileUnbuffered(c,i,o):(0,b.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,i,r.token,o):a=this.readFileBuffered(c,i,r.token,o),{...await s,value:a}}catch(l){a&&await(0,d.consumeStream)(a);const P=(0,E.localize)(8,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(l).toString());throw l instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(P,l.stat,o):new b.FileOperationError(P,(0,b.toFileOperationResult)(l),o)}}readFileStreamed(c,i,o,n=Object.create(null)){const r=c.readFileStream(i,n,o);return(0,d.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new b.FileOperationError((0,E.localize)(9,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),n)},s=>k.VSBuffer.concat(s))}readFileBuffered(c,i,o,n=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,i,r,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new b.FileOperationError((0,E.localize)(10,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),n)},o),r}readFileUnbuffered(c,i,o){const n=(0,d.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,b.hasFileAtomicReadCapability)(c)?r=await c.readFile(i,{atomic:!0}):r=await c.readFile(i),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(i,r.byteLength,o),n.end(k.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(c,i){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new b.FileOperationError((0,E.localize)(11,null,this.resourceForError(c)),0,i);if(typeof i?.etag=="string"&&i.etag!==b.ETAG_DISABLED&&i.etag===o.etag)throw new b.NotModifiedSinceFileOperationError((0,E.localize)(12,null),o,i);return this.validateReadFileLimits(c,o.size,i),o}validateReadFileLimits(c,i,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&i>o.limits.size&&(n=7),typeof n=="number")throw new b.FileOperationError((0,E.localize)(13,null,this.resourceForError(c)),n)}}async canMove(c,i,o){return this.doCanMoveCopy(c,i,"move",o)}async canCopy(c,i,o){return this.doCanMoveCopy(c,i,"copy",o)}async doCanMoveCopy(c,i,o,n){if(c.toString()!==i.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,c,s,i,o,n)}catch(r){return r}return!0}async move(c,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,c,r,i,"move",!!o),a=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,s==="move"?2:3,a)),a}async copy(c,i,o){const n=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,c,r,i,"copy",!!o),a=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,s==="copy"?3:2,a)),a}async doMoveCopy(c,i,o,n,r,s){if(i.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,i,o,n,r,s);if(a&&!l&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),r==="copy"){if(c===o&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(i,n,{overwrite:s});else{const P=await this.resolve(i);P.isDirectory?await this.doCopyFolder(c,P,o,n):await this.doCopyFile(c,i,o,n)}return r}else return c===o?(await c.rename(i,n,{overwrite:s}),r):(await this.doMoveCopy(c,i,o,n,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(c,i,o,n){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,i,o,n);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,i,o,n);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,i,o,n);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,i,o,n)}async doCopyFolder(c,i,o,n){await o.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),o,s):this.doCopyFile(c,r.resource,o,s)}))}async doValidateMoveCopy(c,i,o,n,r,s){let a=!1;if(c===o){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(a=P.isEqual(i,n)),a&&r==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!a&&P.isEqualOrParent(n,i))throw new Error((0,E.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!a){if(!s)throw new b.FileOperationError((0,E.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(c===o){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(i,n))throw new Error((0,E.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const i=this.isPathCaseSensitive(c);return{providerExtUri:i?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(i,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,o)),o}async mkdirp(c,i){const o=[],{providerExtUri:n}=this.getExtUri(c);for(;!n.isEqual(i,n.dirname(i));)try{if(((await c.stat(i)).type&b.FileType.Directory)===0)throw new Error((0,E.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,b.toFileSystemProviderErrorCode)(r)!==b.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(n.basename(i)),i=n.dirname(i)}for(let r=o.length-1;r>=0;r--){i=n.joinPath(i,o[r]);try{await c.mkdir(i)}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,i){try{await this.doValidateDelete(c,i)}catch(o){return o}return!0}async doValidateDelete(c,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch{}if(r)this.throwIfFileIsReadonly(c,r);else throw new b.FileOperationError((0,E.localize)(20,null,this.resourceForError(c)),1);if(!!!i?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(c)))}return o}async del(c,i){const o=await this.doValidateDelete(c,i),n=!!i?.useTrash,r=!!i?.recursive;await o.delete(c,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new b.FileOperationEvent(c,1))}async cloneFile(c,i){const o=await this.withProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(c,i))return;if(o===n&&(0,b.hasFileCloneCapability)(o))return o.cloneFile(c,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===n&&(0,b.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(c,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,c,n,i))}watch(c,i={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let n=!1,r=()=>{n=!0};return o.add((0,m.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(c,i);n?(0,m.dispose)(s):r=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(c,i){const o=await this.withProvider(c),n=(0,y.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),i]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:o.watch(c,i)},this.activeWatchers.set(n,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,m.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(c,r,n):await this.doWriteReadableBufferedQueued(c,r,n)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,i,o){let n=0,r;if((0,d.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,i,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,a)=>{(0,d.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(c,i,l,l.byteLength,n,0)}catch(P){return a(P)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>a(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,i,o){let n=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(c,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(c,i,o,n,r,s){let a=0;for(;a<n;)a+=await c.write(i,r+a,o.buffer,s+a,n-a)}async doWriteUnbuffered(c,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,i,o,n))}async doWriteUnbufferedQueued(c,i,o,n){let r;n instanceof k.VSBuffer?r=n:(0,d.isReadableStream)(n)?r=await(0,k.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?r=await(0,k.bufferedStreamToBuffer)(n):r=(0,k.readableToBuffer)(n),await c.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,i,o,n))}async doPipeBufferedQueued(c,i,o,n){let r,s;try{r=await c.open(i,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,P=0,M=0;do M=await c.read(r,l,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(o,s,a,M,l,P),l+=M,P+=M,P===a.byteLength&&(P=0);while(M>0)}catch(a){throw(0,b.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,i,o,n))}async doPipeUnbufferedQueued(c,i,o,n){return o.writeFile(n,await c.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,i,o,n))}async doPipeUnbufferedToBufferedQueued(c,i,o,n){const r=await o.open(n,{create:!0,unlock:!1});try{const s=await c.readFile(i);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(c,i,o,n){const r=await(0,k.streamToBuffer)(this.readFileBuffered(c,i,R.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,r)}throwIfFileSystemIsReadonly(c,i){if(c.capabilities&2048)throw new b.FileOperationError((0,E.localize)(22,null,this.resourceForError(i)),6);return c}throwIfFileIsReadonly(c,i){if((i.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,E.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};f=ve([Y(0,S.ILogService)],f),e.FileService=f}),define(J[86],Z([0,1,29,275,8,32,17,3,31,2,9,4,16,58,23,163,14,104,203,44,200,199]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(w)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class i extends S.AbstractDiskFileSystemProvider{constructor(n,r){super(n,r),this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new R.ResourceMap(s=>v.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await d.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,v.joinPath)(n,a.name))).type:l=this.toType(a),s.push([a.name,l])}catch(l){this.logService.trace(l)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let s;return r?.dangling?s=b.FileType.Unknown:n.isFile()?s=b.FileType.File:n.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,r&&(s|=b.FileType.SymbolicLink),s}async createResourceLock(n){const r=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const a=new k.Barrier;return this.resourceLocks.set(n,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(n)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(n,r){let s;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const a=this.toFilePath(n);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(n,r,s){const a=(0,g.newWriteableStream)(l=>D.VSBuffer.concat(l.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,p.readFileIntoStream)(this,n,a,l=>l.buffer,{...r,bufferSize:256*1024},s),a}async writeFile(n,r,s){let a;try{const l=this.toFilePath(n);if(!s.create||!s.overwrite){if(await d.Promises.exists(l)){if(!s.overwrite)throw(0,b.createFileSystemProviderError)((0,E.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.createFileSystemProviderError)((0,E.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,r,0,r.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(n,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,r){const s=this.toFilePath(n);let a;(0,b.isFileOpenForWriteOptions)(r)&&(a=await this.createResourceLock(n));let l;try{if((0,b.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(s);M.mode&128||await d.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,b.isFileOpenForWriteOptions)(r)){if(I.isWindows)try{await d.Promises.truncate(s,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";l=await d.Promises.open(s,P)}catch(P){throw a?.dispose(),(0,b.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,b.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(l,n),a){const P=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),P.dispose())}return l}async close(n){const r=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await d.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await d.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(n)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,s,a,l){const P=this.normalizePos(n,r);let M=null;try{M=(await d.Promises.read(n,s,a,l,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,P,M)}return M}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,s){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,a+s):this.mapHandleToPos.delete(n)))}async write(n,r,s,a,l){return(0,k.retry)(()=>this.doWrite(n,r,s,a,l),100,3)}async doWrite(n,r,s,a,l){const P=this.normalizePos(n,r);let M=null;try{M=(await d.Promises.write(n,s,a,l,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,P,M)}return M}async mkdir(n){try{await d.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const s=this.toFilePath(n);r.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,r,s){const a=this.toFilePath(n),l=this.toFilePath(r);if(a!==l)try{await this.validateTargetDeleted(n,r,"move",s.overwrite),await d.Promises.move(a,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(n,r,s){const a=this.toFilePath(n),l=this.toFilePath(r);if(a!==l)try{await this.validateTargetDeleted(n,r,"copy",s.overwrite),await d.Promises.copy(a,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(n,r,s,a){const l=this.toFilePath(n),P=this.toFilePath(r);let M=!1;if(!!(this.capabilities&1024)||(M=(0,u.isEqual)(l,P,!0)),M&&s==="copy")throw(0,b.createFileSystemProviderError)((0,E.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(P)){if(!a)throw(0,b.createFileSystemProviderError)((0,E.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(n,r){return this.doCloneFile(n,r,!1)}async doCloneFile(n,r,s){const a=this.toFilePath(n),l=this.toFilePath(r),P=!!(this.capabilities&1024);if((0,u.isEqual)(a,l,!P))return;const M=new m.DisposableStore;try{const[T,F]=await Promise.all([this.createResourceLock(n),this.createResourceLock(r)]);M.add(T),M.add(F),s&&await d.Promises.mkdir((0,C.dirname)(l),{recursive:!0}),await d.Promises.copyFile(a,l)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(n,r,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(n,r,s){return new h.UniversalWatcherClient(a=>n(a),a=>r(a),s)}createNonRecursiveWatcher(n,r,s){return new c.NodeJSWatcherClient(a=>n(a),a=>r(a),s)}toFileSystemProviderError(n){if(n instanceof b.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=b.FileSystemProviderErrorCode.NoPermissions;break;default:r=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let s=this.toFileSystemProviderError(r);if(n&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(s=(0,b.createFileSystemProviderError)(r,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(J[205],Z([0,1,3,86,2,17,58,22]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends k.Disposable{constructor(I,v){super(),this.provider=I,this.logService=v,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(I,v,g){const d=this.getUriTransformer(I);switch(v){case"stat":return this.stat(d,g[0]);case"readdir":return this.readdir(d,g[0]);case"open":return this.open(d,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(d,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(d,g[0],g[1],g[2]);case"rename":return this.rename(d,g[0],g[1],g[2]);case"copy":return this.copy(d,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(d,g[0],g[1]);case"mkdir":return this.mkdir(d,g[0]);case"delete":return this.delete(d,g[0],g[1]);case"watch":return this.watch(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${v} not found`)}listen(I,v,g){const d=this.getUriTransformer(I);switch(v){case"fileChange":return this.onFileChange(d,g[0]);case"readFileStream":return this.onReadFileStream(d,g[0],g[1])}throw new Error(`Unknown event ${v}`)}stat(I,v){const g=this.transformIncoming(I,v,!0);return this.provider.stat(g)}readdir(I,v){const g=this.transformIncoming(I,v);return this.provider.readdir(g)}async readFile(I,v,g){const d=this.transformIncoming(I,v,!0),E=await this.provider.readFile(d,g);return R.VSBuffer.wrap(E)}onReadFileStream(I,v,g){const d=this.transformIncoming(I,v,!0),E=new y.CancellationTokenSource,b=new w.Emitter({onLastListenerRemove:()=>{E.cancel()}}),p=this.provider.readFileStream(d,g,E.token);return(0,D.listenStream)(p,{onData:S=>b.fire(R.VSBuffer.wrap(S)),onError:S=>b.fire(S),onEnd:()=>{b.fire("end"),b.dispose(),E.dispose()}}),b.event}writeFile(I,v,g,d){const E=this.transformIncoming(I,v);return this.provider.writeFile(E,g.buffer,d)}open(I,v,g){const d=this.transformIncoming(I,v,!0);return this.provider.open(d,g)}close(I){return this.provider.close(I)}async read(I,v,g){const d=R.VSBuffer.alloc(g),E=0,b=await this.provider.read(I,v,d.buffer,E,g);return[d,b]}write(I,v,g,d,E){return this.provider.write(I,v,g.buffer,d,E)}mkdir(I,v){const g=this.transformIncoming(I,v);return this.provider.mkdir(g)}delete(I,v,g){const d=this.transformIncoming(I,v);return this.provider.delete(d,g)}rename(I,v,g,d){const E=this.transformIncoming(I,v),b=this.transformIncoming(I,g);return this.provider.rename(E,b,d)}copy(I,v,g,d){const E=this.transformIncoming(I,v),b=this.transformIncoming(I,g);return this.provider.copy(E,b,d)}cloneFile(I,v,g){const d=this.transformIncoming(I,v),E=this.transformIncoming(I,g);return this.provider.cloneFile(d,E)}onFileChange(I,v){const g=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(v,this.createSessionFileWatcher(I,g))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(v)),this.sessionToWatcher.delete(v)}});return g.event}async watch(I,v,g,d,E){const b=this.sessionToWatcher.get(v);if(b){const p=this.transformIncoming(I,d),S=b.watch(g,p,E);this.watchRequests.set(v+g,S)}}async unwatch(I,v){const g=I+v,d=this.watchRequests.get(g);d&&((0,k.dispose)(d),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,I]of this.watchRequests)I.dispose();this.watchRequests.clear();for(const[,I]of this.sessionToWatcher)I.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class m extends k.Disposable{constructor(I,v,g,d){super(),this.uriTransformer=I,this.logService=g,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(v)}registerListeners(I){const v=this._register(new w.Emitter);this._register(v.event(g=>{I.fire(g.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>v.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>I.fire(g)))}getRecursiveWatcherOptions(I){}getExtraExcludes(I){}watch(I,v,g){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.watcherRequests.set(I,this.fileWatcher.watch(v,g)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(I)),this.watcherRequests.delete(I)})}dispose(){super.dispose();for(const[,I]of this.watcherRequests)I.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(J[206],Z([0,1,15,162,4,7,14,9,205,141]),function(q,e,w,t,k,R,D,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends u.AbstractDiskFileSystemProviderChannel{constructor(g,d,E){super(g,d),this.environmentService=E}getUriTransformer(g){return m.DefaultURITransformer}transformIncoming(g,d){return R.URI.revive(d)}async delete(g,d,E){if(!E.useTrash)return super.delete(g,d,E);const b=this.transformIncoming(g,d),p=(0,y.normalize)(b.fsPath);try{await w.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,y.basename)(p)):(0,t.localize)(1,null,(0,y.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,d){return new I(g,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class I extends u.AbstractSessionFileWatcher{watch(g,d,E){if(E.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,d,E)}}}),define(J[105],Z([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case w.LogLevel.Trace:return R.trace;case w.LogLevel.Debug:return R.debug;case w.LogLevel.Info:return R.info;case w.LogLevel.Warning:return R.warn;case w.LogLevel.Error:return R.error;case w.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(D=w.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}set logger(D){this._logger=D;for(const{level:y,args:u}of this.buffer)t(D,y).apply(D,u);this.buffer=[]}_log(D,...y){this._logger?t(this._logger,D).apply(this._logger,y):this.getLevel()<=D&&this.buffer.push({level:D,args:y})}trace(D,...y){this._log(w.LogLevel.Trace,D,...y)}debug(D,...y){this._log(w.LogLevel.Debug,D,...y)}info(D,...y){this._log(w.LogLevel.Info,D,...y)}warn(D,...y){this._log(w.LogLevel.Warning,D,...y)}error(D,...y){this._log(w.LogLevel.Error,D,...y)}critical(D,...y){this._log(w.LogLevel.Critical,D,...y)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(J[207],Z([0,1,8,17,16,14,5,105,6]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let C=class extends u.AbstractLogger{constructor(g,d,E,b,p){super(),this.name=g,this.resource=d,this.donotUseFormatters=b,this.fileService=p,this.backupIndex=1,this.setLevel(E),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=u.LogLevel.Trace&&this._log(u.LogLevel.Trace,(0,u.format)(arguments))}debug(){this.getLevel()<=u.LogLevel.Debug&&this._log(u.LogLevel.Debug,(0,u.format)(arguments))}info(){this.getLevel()<=u.LogLevel.Info&&this._log(u.LogLevel.Info,(0,u.format)(arguments))}warn(){this.getLevel()<=u.LogLevel.Warning&&this._log(u.LogLevel.Warning,(0,u.format)(arguments))}error(){if(this.getLevel()<=u.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=g.stack,this._log(u.LogLevel.Error,(0,u.format)(d))}else this._log(u.LogLevel.Error,(0,u.format)(arguments))}}critical(){this.getLevel()<=u.LogLevel.Critical&&this._log(u.LogLevel.Critical,(0,u.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,d){this.queue.queue(async()=>{await this.initializePromise;let E=await this.loadContent();E.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(E)),E=""),this.donotUseFormatters?E+=d:E+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(E))})}getCurrentTimestamp(){const g=b=>b<10?`0${b}`:b,d=b=>b<10?`00${b}`:b<100?`0${b}`:b,E=new Date;return`${E.getFullYear()}-${g(E.getMonth()+1)}-${g(E.getDate())} ${g(E.getHours())}:${g(E.getMinutes())}:${g(E.getSeconds())}.${d(E.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case u.LogLevel.Critical:return"critical";case u.LogLevel.Debug:return"debug";case u.LogLevel.Error:return"error";case u.LogLevel.Info:return"info";case u.LogLevel.Trace:return"trace";case u.LogLevel.Warning:return"warning"}return""}};C=ve([Y(4,R.IFileService)],C),e.FileLogger=C;let I=class extends u.AbstractLoggerService{constructor(g,d,E){super(g.getLevel(),g.onDidChangeLogLevel),this.instantiationService=d,this.fileService=E}doCreateLogger(g,d,E){const b=new y.BufferLogService(d);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(C,E?.name||(0,k.basename)(g),g,b.getLevel(),!!E?.donotUseFormatters)),b}};I=ve([Y(0,u.ILogService),Y(1,D.IInstantiationService),Y(2,R.IFileService)],I),e.FileLoggerService=I}),define(J[208],Z([0,1,3,7,6]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(v){this.service=v,this.onDidChangeLogLevel=w.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(v,g,d){switch(g){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class D{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){D.setLevel(this.channel,v)}static setLevel(v,g){return v.call("setLevel",g)}}e.LogLevelChannelClient=D;class y{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,g){throw new Error(`Event not found: ${g}`)}async call(v,g,d){switch(g){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${g}`)}createLogger(v,g){this.loggers.set(v.toString(),this.loggerService.createLogger(v,g))}consoleLog(v,g){let d=console.log;switch(v){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...g)}log(v,g){const d=this.loggers.get(v.toString());if(!d)throw new Error("Create the logger before logging");for(const[E,b]of g)(0,k.log)(d,E,b)}}e.LoggerChannel=y;class u extends k.AbstractLoggerService{constructor(v,g,d){super(v,g),this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(v,g)=>{this.channel.call("consoleLog",[v,g])}})}doCreateLogger(v,g,d){return new m(this.channel,v,g,d)}}e.LoggerChannelClient=u;class m extends k.AbstractMessageLogger{constructor(v,g,d,E){super(E?.always),this.channel=v,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[g,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,g){const d=[[v,g]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(v){this.channel.call("log",[this.file,v])}}class C extends k.LogService{constructor(v,g){super(g),this.parent=v,this._register(v.onDidChangeLogLevel(d=>g.setLevel(d)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=C}),define(J[106],Z([0,1,14,6]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(y,u,m,C,I){try{const v=await new Promise((d,E)=>{q(["spdlog"],d,E)});v.setFlushOn(t.LogLevel.Trace);const g=await v.createAsyncRotatingLogger(y,u,m,C);return I&&g.clearFormatters(),g}catch(v){console.error(v)}return null}function R(y,u,m){switch(u){case t.LogLevel.Trace:y.trace(m);break;case t.LogLevel.Debug:y.debug(m);break;case t.LogLevel.Info:y.info(m);break;case t.LogLevel.Warning:y.warn(m);break;case t.LogLevel.Error:y.error(m);break;case t.LogLevel.Critical:y.critical(m);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(u,m,C,I,v){super(),this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(u,m,C,I),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(u,m,C,I){const v=C?6:1,g=30/v*w.ByteSize.MB,d=await k(u,m,g,v,I);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:E,message:b}of this.buffer)R(this._logger,E,b);this.buffer=[]}}log(u,m){this._logger?R(this._logger,u,m):this.getLevel()<=u&&this.buffer.push({level:u,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(J[209],Z([0,1,13,16,28,14,207,6,106]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends y.AbstractLoggerService{constructor(I,v){super(I.getLevel(),I.onDidChangeLogLevel),this.fileService=v}doCreateLogger(I,v,g){return I.scheme===w.Schemas.file?new u.SpdLogLogger(g?.name||(0,k.generateUuid)(),I.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,v):new D.FileLogger(g?.name??(0,t.basename)(I),I,v,!!g?.donotUseFormatters,this.fileService)}};m=ve([Y(0,y.ILogService),Y(1,R.IFileService)],m),e.LoggerService=m}),define(J[210],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!w(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(J[38],Z([0,1,3,57,2,5]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(I,[v,g])=>({...I,[v]:g}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[C,I])=>({...m,[C]:{definition:I,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=D;class y{constructor(){this.onDidChange=w.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(J[211],Z([0,1,8,3,57,12,14,6,38]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(I,v){const g=[];for(const d of k.Iterable.concat(I.keys(),v.keys()))I.get(d)!==v.get(d)&&g.push(d);return g}let C=class extends u.AbstractPolicyService{constructor(v,g,d){super(),this.file=v,this.fileService=g,this.logService=d,this.throttledDelayer=this._register(new w.ThrottledDelayer(500));const E=t.Event.filter(g.onDidFilesChange,b=>b.affects(v));this._register(g.watch(v)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(v){await this.refresh()}async read(){const v=new Map;try{const g=await this.fileService.readFile(this.file),d=JSON.parse(g.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(d))this.policyDefinitions[E]&&v.set(E,d[E])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return v}async refresh(){const v=await this.read(),g=m(this.policies,v);this.policies=v,g.length>0&&this._onDidChange.fire(g)}};C=ve([Y(1,D.IFileService),Y(2,y.ILogService)],C),e.FilePolicyService=C}),define(J[212],Z([0,1,3,2,38]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(u){this.service=u,this.disposables=new t.DisposableStore}listen(u,m){switch(m){case"onDidChange":return w.Event.map(this.service.onDidChange,C=>C.reduce((I,v)=>({...I,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(u,m,C){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(u,m){super(),this.channel=m;for(const C in u){const{definition:I,value:v}=u[C];this.policyDefinitions[C]=I,v!==void 0&&this.policies.set(C,v)}this.channel.listen("onDidChange")(C=>{for(const I in C){const v=C[I];v===null?this.policies.delete(I):this.policies.set(I,v)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(u){const m=await this.channel.call("registerPolicyDefinitions",u);for(const C in m)this.policies.set(C,m[C])}}e.PolicyChannelClient=D}),define(J[53],Z([0,1,13,4,34,16]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const y=t.globals.vscode.context.configuration();if(y)D=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const y=(0,R.dirname)(w.FileAccess.asFileUri("",q));D=q.__$__nodeRequire((0,R.joinPath)(y,"product.json").fsPath);const u=q.__$__nodeRequire((0,R.joinPath)(y,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:u.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(J[20],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[213],Z([0,1,76,6,20]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(y,u){this.productService=y,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(y,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(u);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,C,I]=m;let v=this.trustedExtensionUrlPublicKeys.get(y);if(!v){if(v=this.productService.trustedExtensionUrlPublicKeys[y],!v||v.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",y),!1;this.trustedExtensionUrlPublicKeys.set(y,[...v])}const g=Buffer.from(decodeURIComponent(I),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const d=g.slice(0,6),E=g.readUIntBE(0,6),b=Date.now()-E;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const p=g.slice(6),S=w.createVerify("SHA256");S.write(d),S.write(Buffer.from(C)),S.end();for(let f=0;f<v.length;f++){let h=v[f];if(h!==null){if(typeof h=="string")try{h=w.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),v[f]=h}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${y}:`,c),v[f]=null;continue}if(S.verify(h,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};R=ve([Y(0,k.IProductService),Y(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(J[61],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(J[46],Z([0,1,120,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,y){w.ok(t.isString(D)),w.ok(t.isObject(y)),w.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,y)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(J[214],Z([0,1,3,46]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class R{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,m){this.schemasById[k(u)]=m,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(J[62],Z([0,1,24,3,12,150,19,214,46]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=u.Registry.as(y.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=this.doRegisterConfigurations(i,o);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(i,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(n)})}registerDefaultConfigurations(i){const o=[],n=[];for(const{overrides:r,source:s}of i)for(const a in r)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),P=l?.valuesSources??new Map;if(s)for(const U of Object.keys(r[a]))P.set(U,s);const M={...l?.value||{},...r[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:M,valuesSources:P});const T=(0,D.getLanguageTagSettingPlainKey)(a),F={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};n.push(...E(a)),this.configurationProperties[a]=F,this.defaultLanguageConfigurationOverridesNode.properties[a]=F}else{this.configurationDefaultsOverrides.set(a,{value:r[a],source:s});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:n,source:r}of i)for(const s in n){const a=this.configurationDefaultsOverrides.get(s),l=k.isString(r)?r:r?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(l===P)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const n=[];return i.forEach(r=>{n.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),n}doDeregisterConfigurations(i){const o=[],n=r=>{if(r.properties)for(const s in r.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>n(s))};for(const r of i){n(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,n,r,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const a=[],l=i.properties;if(l)for(const M in l){const T=l[M];if(o&&f(M,T)){delete l[M];continue}if(T.source=n,T.defaultDefaultValue=l[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(M):T.restricted),l[M].hasOwnProperty("included")&&!l[M].included){this.excludedConfigurationProperties[M]=l[M],delete l[M];continue}else this.configurationProperties[M]=l[M],l[M].policy?.name&&this.policyConfigurations.set(l[M].policy.name,M);!l[M].deprecationMessage&&l[M].markdownDeprecationMessage&&(l[M].deprecationMessage=l[M].markdownDeprecationMessage),a.push(M)}const P=i.allOf;if(P)for(const M of P)a.push(...this.validateAndRegisterProperties(M,o,n,r,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const r=n.properties;if(r)for(const a in r)this.updateSchema(a,r[a]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let r=n?.value,s=n?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=p(o.type)),o.default=r,o.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(c){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=d.exec(c);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=d.exec(c)}}return(0,w.distinct)(i)}e.overrideIdentifiersFromKey=E;function b(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=b;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const S=new v;u.Registry.add(e.Extensions.Configuration,S);function f(c,i){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):S.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):i.policy?.name&&S.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,c,i.policy?.name,S.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function h(){const c=[],i=S.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=h}),define(J[107],Z([0,1,24,3,43,2,32,50,12,7,19,62,46]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(i={},o=[],n=[]){this._contents=i,this._keys=o,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,C.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const n=this.getContentsForOverrideIdentifer(o);return n?i?(0,C.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const n of this.overrides)n.identifiers.includes(i)&&o.push(...n.keys);return w.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=y.deepClone(this.contents),n=y.deepClone(this.overrides),r=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const a of s.overrides){const[l]=n.filter(P=>w.equals(P.identifiers,a.identifiers));l?(this.mergeContents(l.contents,a.contents),l.keys.push(...a.keys),l.keys=w.distinct(l.keys)):n.push(y.deepClone(a))}for(const a of s.keys)r.indexOf(a)===-1&&r.push(a)}return new g(o,r,n)}freeze(){return this.frozen=!0,this}clone(){return new g(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const r of w.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const a=o[r];a&&(typeof s=="object"&&typeof a=="object"?(s=y.deepClone(s),this.mergeContents(s,a)):s=a),n[r]=s}return new g(n,this.keys,this.overrides)}mergeContents(i,o){for(const n of Object.keys(o)){if(n in i&&u.isObject(i[n])&&u.isObject(o[n])){this.mergeContents(i[n],o[n]);continue}i[n]=y.deepClone(o[n])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?y.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,n=null;const r=s=>{s&&(n?this.mergeContents(n,s):n=y.deepClone(s))};for(const s of this.overrides)w.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,C.addToValueTree)(this.contents,i,o,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,C.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let n=0;n<o;n++)i.indexOf(this.keys[n])===0&&(o=n);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=g;class d{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!u.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:n,keys:r,overrides:s,restricted:a}=this.doParseRaw(i,o);this._configurationModel=new g(n,r,s),this._restrictedConfigurations=a||[]}doParseContent(i){let o={},n=null,r=[];const s=[],a=[];function l(M){Array.isArray(r)?r.push(M):n!==null&&(r[n]=M)}const P={onObjectBegin:()=>{const M={};l(M),s.push(r),r=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const M=[];l(M),s.push(r),r=M,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:l,onError:(M,T,F)=>{a.push({error:M,offset:T,length:F})}};if(i)try{k.visit(i,P),o=r[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return o}doParseRaw(i,o){const n=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,n,!0,o);i=r.raw;const s=(0,C.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),a=Object.keys(i),l=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:a,overrides:l,restricted:r.restricted}}filter(i,o,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const s={},a=[];for(const l in i)if(I.OVERRIDE_PROPERTY_REGEX.test(l)&&n){const P=this.filter(i[l],o,!1,r);s[l]=P.raw,a.push(...P.restricted)}else{const P=o[l],M=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&a.push(l),(M===void 0||r.scopes===void 0||r.scopes.includes(M))&&(r.skipRestricted&&P?.restricted||(s[l]=i[l]))}return{raw:s,restricted:a}}toOverrides(i,o){const n=[];for(const r of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const a in i[r])s[a]=i[r][a];n.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,C.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=d;class E extends R.Disposable{constructor(i,o,n,r){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class b{constructor(i,o,n,r,s=new g,a=new g,l=new D.ResourceMap,P=new g,M=new D.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=P,this._memoryConfigurationByResource=M,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,o,n){return this.getConsolidatedConfigurationModel(i,o,n).getValue(i)}updateValue(i,o,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new g,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(i):r.setValue(i,o),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,n){const r=this.getConsolidatedConfigurationModel(i,o,n),s=this.getFolderConfigurationModelForResource(o.resource,n),a=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,l=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),T=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),F=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),x=n?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,re=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,le=o.overrideIdentifier?a.override(o.overrideIdentifier).getValue(i):a.getValue(i),ue=r.getValue(i),se=w.distinct(r.overrides.map(de=>de.identifiers).flat()).filter(de=>r.getOverrideValue(i,de)!==void 0);return{defaultValue:l,policyValue:P,applicationValue:M,userValue:T,userLocalValue:F,userRemoteValue:U,workspaceValue:x,workspaceFolderValue:re,memoryValue:le,value:ue,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:M!==void 0?{value:M,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:s?.freeze().getValue(i),override:o.overrideIdentifier?s?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:le!==void 0?{value:a.getValue(i),override:o.overrideIdentifier?a.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const n=[];if(!o){const{added:r,updated:s,removed:a}=f(this._defaultConfiguration,i);o=[...r,...s,...a]}for(const r of o)for(const s of(0,I.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=i.getKeysForOverrideIdentifier(s),P=[...l.filter(M=>a.indexOf(M)===-1),...a.filter(M=>l.indexOf(M)===-1),...a.filter(M=>!y.equals(this._defaultConfiguration.override(s).getValue(M),i.override(s).getValue(M)))];n.push([s,P])}return this.updateDefaultConfiguration(i),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:n,removed:r}=f(this._policyConfiguration,i),s=[...o,...n,...r];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.applicationConfiguration,i),a=[...o,...n,...r];return a.length&&this.updateApplicationConfiguration(i),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.localUserConfiguration,i),a=[...o,...n,...r];return a.length&&this.updateLocalUserConfiguration(i),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.remoteUserConfiguration,i),a=[...o,...n,...r];return a.length&&this.updateRemoteUserConfiguration(i),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.workspaceConfiguration,i),a=[...o,...n,...r];return a.length&&this.updateWorkspaceConfiguration(i),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const n=this.folderConfigurations.get(i),{added:r,updated:s,removed:a,overrides:l}=f(n,o),P=[...r,...s,...a];return(P.length||!n)&&this.updateFolderConfiguration(i,o),{keys:P,overrides:l}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:s,overrides:a}=f(o,void 0);return{keys:[...n,...r,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,n){let r=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},o){let n=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const r=o.getFolder(i);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const s=this._memoryConfigurationByResource.get(i);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(o=n.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=n}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const n=o.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:n,overrides:r,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:n,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((P,M)=>(P.set(m.URI.revive(M[0]),this.parseConfigurationModel(M[1])),P),new D.ResourceMap);return new b(o,n,r,s,new g,a,l,new g,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new g(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=b;function p(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,o=new Map;for(const r of c)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,a])=>{const l=(0,D.getOrSet)(o,s,new Set);a.forEach(P=>l.add(P))});const n=[];return o.forEach((r,s)=>n.push([s,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=p;class S{constructor(i,o,n,r){this.change=i,this.previous=o,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(l=>s.add(l)),i.overrides.forEach(([,l])=>l.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const a=new g;this.affectedKeys.forEach(l=>a.setValue(l,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!y.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let n=(0,C.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(i=i[r],!i)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=S;function f(c,i){const{added:o,removed:n,updated:r}=h(i,c),s=[],a=c?.getAllOverrideIdentifiers()||[],l=i?.getAllOverrideIdentifiers()||[];if(i){const P=l.filter(M=>!a.includes(M));for(const M of P)s.push([M,i.getKeysForOverrideIdentifier(M)])}if(c){const P=a.filter(M=>!l.includes(M));for(const M of P)s.push([M,c.getKeysForOverrideIdentifier(M)])}if(i&&c){for(const P of a)if(l.includes(P)){const M=h({contents:c.getOverrideValue(void 0,P)||{},keys:c.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});s.push([P,[...M.added,...M.removed,...M.updated]])}}return{added:o,removed:n,updated:r,overrides:s}}function h(c,i){const o=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],n=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const a=(0,C.getConfigurationValue)(i.contents,s),l=(0,C.getConfigurationValue)(c.contents,s);y.equals(a,l)||r.push(s)}}return{added:o,removed:n,updated:r}}}),define(J[215],Z([0,1,24,3,2,50,12,19,107,62,6,38,46]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(v.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:f})=>this.onDidUpdateConfiguration(S,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class d extends u.ConfigurationModel{constructor(S={}){const f=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(f),c=Object.create(null),i=[];for(const o in f){const n=S[o],r=n!==void 0?n:f[o].default;(0,y.addToValueTree)(c,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(c))m.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,y.toValuesTree)(c[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(c,h,i)}}e.DefaultConfigurationModel=d;class E{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new u.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let b=class extends k.Disposable{constructor(S,f,h){super(),this.defaultConfiguration=S,this.policyService=f,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new u.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const f={},h=[],c=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of S){const o=c[i];if(!o){h.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}h.push(i),f[o.policy.name]={type:o.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),h}onDidChangePolicies(S){const f=v.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),h=(0,w.coalesce)(S.map(c=>f.get(c)));this.update(h,!0)}update(S,f){const h=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),c=[],i=this._configurationModel.isEmpty();for(const o of S){const n=h[o]?.policy?.name;if(n){const r=this.policyService.getPolicyValue(n);(i?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&c.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new u.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,r]of c)r===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,r);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=ve([Y(1,I.IPolicyService),Y(2,C.ILogService)],b),e.PolicyConfiguration=b}),define(J[216],Z([0,1,8,3,2,16,19,107,215,38]),function(q,e,w,t,k,R,D,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends k.Disposable{constructor(v,g,d,E){super(),this.settingsResource=v,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=d instanceof m.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,d,E)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:p})=>this.onDidDefaultConfigurationChange(b,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,g,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(v,g,new y.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(v,g){const d=typeof v=="string"?v:void 0,E=(0,D.isConfigurationOverrides)(v)?v:(0,D.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(d,E,void 0)}updateValue(v,g,d,E){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(d,g,2)}onDidDefaultConfigurationChange(v,g){const d=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(v,g);this.trigger(E,d,7)}onDidPolicyConfigurationChange(v){const g=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(d,g,7)}trigger(v,g,d){const E=new y.ConfigurationChangeEvent(v,{data:g},this.configuration);E.source=d,E.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(J[217],Z([0,1,18,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends w.ErrorNoTelemetry{constructor(y,u=k.Unknown,m){super(y),this._message=y,this._code=u,this._detail=m,this.isHandled=u===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===k.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[63],Z([0,1,13]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const C=m.indexOf("+");return C<0?m:m.substr(0,C)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(m){const{host:C,port:I}=u(m);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:I}}e.parseAuthorityWithPort=D;function y(m,C){let{host:I,port:v}=u(m);return typeof v>"u"&&(v=C),{host:I,port:v}}e.parseAuthorityWithOptionalPort=y;function u(m){const C=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=m.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:m,port:void 0}}}),define(J[108],Z([0,1,25,5,63]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var u;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(u=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,b){if(typeof E>"u"||E===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof E=="string"||typeof b=="string"){const p=typeof E=="string"?E:E.value,S=typeof b=="string"?b:b.value;return w.equalsIgnoreCase(p,S)}return E._lower===b._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=m;function C(d){return I(d)}e.isApplicationScopedExtension=C;function I(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function g(d,E){if(E){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return d.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[109],Z([0,1,25,192,108,4,7,18,34]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,w.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=m;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new I(n.identifier,r,s)}static parse(n){const r=C.exec(n);return r&&r[1]&&r[2]?new I({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof I?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=I;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const n=v.exec(o);return n&&n[1]?[E(n[1]),n[2]]:[E(o),void 0]}e.getIdAndVersion=g;function d(o,n){return`${o}.${n}`}e.getExtensionId=d;function E(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function b(o,n){return E(d(o,n))}e.getGalleryExtensionId=b;function p(o,n){const r=[],s=a=>{for(const l of r)if(l.some(P=>m(n(P),n(a))))return l;return null};for(const a of o){const l=s(a);l?l.push(a):r.push([a])}return r}e.groupByExtension=p;function S(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function f(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(o,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&r.every(l=>!m(l.identifier,{id:a}))){const l=o.filter(P=>m(P.identifier,{id:a}));l.length===1&&(r.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=h;async function c(o,n){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function i(o,n){const r=await c(o,n),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,u.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(J[72],Z([0,1,8,17,2,32,7,109,14,5,6]),function(q,e,w,t,k,R,D,y,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let I=class extends k.Disposable{constructor(g,d){super(),this.fileService=g,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,d){return this.withProfileExtensions(d,E=>(E=E.filter(b=>g.some(([p])=>!(0,y.areSameExtensions)(b.identifier,p.identifier))),E.push(...g.map(([b,p])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p}))),E))}removeExtensionFromProfile(g,d){return this.withProfileExtensions(d,E=>E.filter(b=>!(0,y.areSameExtensions)(b.identifier,g)))}async withProfileExtensions(g,d){return this.getResourceAccessQueue(g).queue(async()=>{let E=[];try{const b=await this.fileService.readFile(g),p=JSON.parse(b.value.toString());for(const S of p){if(!S.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",S);continue}if(!S.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",S);continue}if(!S.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",S);continue}E.push({identifier:S.identifier,location:D.URI.revive(S.location),version:S.version,metadata:S.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(d){E=d(E);const b=E.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(g,t.VSBuffer.fromString(JSON.stringify(b)))}return E})}getResourceAccessQueue(g){let d=this.resourcesAccessQueueMap.get(g);return d||(d=new w.Queue,this.resourcesAccessQueueMap.set(g,d)),d}};I=ve([Y(0,u.IFileService),Y(1,C.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(J[218],Z([0,1,8,17,22,18,3,2,28,98,217,63]),function(q,e,w,t,k,R,D,y,u,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var g;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function d(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function E(B){const H=new k.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function b(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class p{constructor(H){this._state="pending",this._disposables=new y.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function S(B,H){const L=new p(H);return L.registerDisposable(B.onControlMessage(O=>{const N=JSON.parse(O.toString()),V=_(N);V?L.reject(V):L.resolve(N)})),L.promise}function f(B,H,L,O,N,V,Q,ne){const j=new p(ne);return H.connect(L,O,N,V,Q,(te,ie)=>{j.didTimeout?(te&&B.error(te),ie?.dispose()):te||!ie?j.reject(te):j.resolve(ie)}),j.promise}function h(B,H){const L=new p(H);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(B,H,L,O){const N=z(B,H);B.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await f(B.logService,B.socketFactory,B.host,B.port,(0,I.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${d(H)}-${B.reconnectionToken}`,O)}catch(ie){throw B.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ie),ie}B.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let Q,ne;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),Q=B.reconnectionProtocol,ne=!1):(Q=new m.PersistentProtocol(V,null),ne=!0),B.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const j=await h(B.signService.createNewMessage((0,u.generateUuid)()),O),te={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};Q.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ie=await S(Q,b(O,E(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(B.logService.trace(`${N} 4/6. received SignRequest control message.`),!await h(B.signService.validate(j,ie.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const fe=await h(B.signService.sign(ie.data),O),ke={type:"connectionType",commit:B.commit,signedData:fe,desiredConnectionType:H};return L&&(ke.args=L),B.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:Q,ownsProtocol:ne}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(B.logService.error(`${N} the handshake timed out. Error:`),B.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${N} received error control message when negotiating connection. Error:`),B.logService.error(ie)),ne&&$(Q),ie}}async function i(B,H,L,O){const N=Date.now(),V=z(B,H),{protocol:Q,ownsProtocol:ne}=await c(B,H,L,O),j=new p(O);return j.registerDisposable(Q.onControlMessage(te=>{const ie=JSON.parse(te.toString()),ce=_(ie);ce?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ce),ne&&$(Q),j.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ee(N)}!`),j.resolve({protocol:Q,firstMessage:ie}))})),j.promise}async function o(B,H){const{protocol:L}=await i(B,1,void 0,H);return{protocol:L}}async function n(B,H,L){const{protocol:O,firstMessage:N}=await i(B,2,H,L),V=N&&N.debugPort;return{protocol:O,debugPort:V}}async function r(B,H,L){const O=Date.now(),N=z(B,3),{protocol:V}=await c(B,3,H,L);return B.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ee(O)}!`),V}async function s(B,H,L){const{host:O,port:N,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:N,connectionToken:V,reconnectionToken:H,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function a(B,H,L){return P(B,async O=>{const{protocol:N}=await o(O,k.CancellationToken.None);return new de(B,H,L,O.reconnectionToken,N)})}e.connectRemoteAgentManagement=a;async function l(B,H){return P(B,async L=>{const{protocol:O,debugPort:N}=await n(L,H,k.CancellationToken.None);return new K(B,H,L.reconnectionToken,O,N)})}e.connectRemoteAgentExtensionHost=l;async function P(B,H){for(let O=1;;O++)try{const N=(0,u.generateUuid)(),V=await s(B,N,null);return await H(V)}catch(N){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(N);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(N),se.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(N)),N}}async function M(B,H,L){const O=await s(B,(0,u.generateUuid)(),null);return await r(O,{host:H,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,w.createCancelablePromise)(H=>new Promise((L,O)=>{const N=setTimeout(L,B*1e3);H.onCancellationRequested(()=>{clearTimeout(N),L()})}))}var F;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class x{constructor(H,L,O,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=x;class re{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=re;class le{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=le;class ue{constructor(H,L,O,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends y.Disposable{constructor(H,L,O,N,V){super(),this._connectionType=H,this._options=L,this.reconnectionToken=O,this.protocol=N,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(N.onSocketClose(Q=>{const ne=W(this._connectionType,this.reconnectionToken,!0);Q?Q.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this._options.logService.error(Q.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this._options.logService.error(Q.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(Q=>{const ne=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,y.toDisposable)(()=>{const Q=se._instances.indexOf(this);Q>=0&&se._instances.splice(Q,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(H,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const N=O<L.length?L[O]:L[L.length-1];try{if(N>0){const Q=T(N);this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,Q)),this._options.logService.info(`${H} waiting for ${N} seconds before reconnecting...`);try{await Q}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${H} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,E(v)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,C.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(H,L,O):this._gotoPermanentFailure(H,L,O)}_gotoPermanentFailure(H,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,H,L,O)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class de extends se{constructor(H,L,O,N,V){super(1,H,N,V,!0),this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:O},H.ipcLogger))}async _reconnect(H,L){await o(H,L)}}e.ManagementPersistentConnection=de;class K extends se{constructor(H,L,O,N,V){super(2,H,O,N,!1),this._startArguments=L,this.debugPort=V}async _reconnect(H,L){await n(H,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function $(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,R.onUnexpectedError)(H)}}function _(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function A(B,H){for(;B.length<H;)B+=" ";return B}function W(B,H,L){return`[remote-connection][${A(d(B),13)}][${H.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,H){return`${W(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ee(B){return`${Date.now()-B} ms`}}),define(J[219],Z([0,1,77,83]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,y,u,m){const C=v=>m(v,void 0),I=w.createConnection({host:k,port:R},()=>{I.removeListener("error",C);const v=Buffer.alloc(16);for(let b=0;b<16;b++)v[b]=Math.round(Math.random()*256);const g=v.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${y}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];I.write(d.join(`\r
`)+`\r
\r
`);const E=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",E),m(void 0,new t.NodeSocket(I,u)))};I.on("data",E)});I.setNoDelay(!0),I.once("error",C)}}}),define(J[54],Z([0,1,17,167,62,5,46]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=y;function u(E){return E.res.statusCode===204}async function m(E){return u(E)?null:(await(0,w.streamToBuffer)(E.stream)).toString()}e.asText=m;async function C(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return m(E)}e.asTextOrError=C;async function I(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(u(E))return null;const p=(await(0,w.streamToBuffer)(E.stream)).toString();try{return JSON.parse(p)}catch(S){throw S.message+=`:
`+p,S}}e.asJson=I;function v(E){d(E)}e.updateProxyConfigurationsScope=v;let g;function d(E){const b=D.Registry.as(k.Extensions.Configuration),p=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[g],remove:p?[p]:[]})}d(2)}),define(J[220],Z([0,1,17,22]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(y){this.service=y}listen(y,u){throw new Error("Invalid listen")}call(y,u,m,C=t.CancellationToken.None){switch(u){case"request":return this.service.request(m[0],C).then(async({res:I,stream:v})=>{const g=await(0,w.streamToBuffer)(v);return[{statusCode:I.statusCode,headers:I.headers},g]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(y){this.channel=y}async request(y,u){const[m,C]=await this.channel.call("request",[y],u);return{res:m,stream:(0,w.bufferToStream)(C)}}async resolveProxy(y){return this.channel.call("resolveProxy",[y])}}e.RequestChannelClient=R}),define(J[221],Z([0,1,222,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,y){return D.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:D.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function R(D,y,u={}){const m=(0,w.parse)(D),C=u.proxyUrl||k(m,y);if(!C)return null;const I=(0,w.parse)(C);if(!/^https?:$/.test(I.protocol||""))return null;const v={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,t.isBoolean)(u.strictSSL)?u.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((g,d)=>{q(["http-proxy-agent"],g,d)}))(v):new(await new Promise((g,d)=>{q(["https-proxy-agent"],g,d)}))(v)}e.getProxyAgent=R}),define(J[110],Z([0,1,51,9,168,22,44,18,4,28,144,59,8]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let d;async function E(p,S,f){return S["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(f)&&!S["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=v.Promises.withAsyncBody(async(h,c)=>{const i=new R.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),c(new Error((0,k.localize)(0,null)))},g);try{h(await b(p,i.token))}catch(n){!(0,y.isCancellationError)(n)&&!i.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(n)))):h({})}finally{clearTimeout(o),i.dispose()}})),d)}e.getResolvedShellEnv=E;async function b(p,S){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",h);const c=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const n=await(0,C.getSystemShell)(u.OS,o);return p.trace("getUnixShellEnvironment#shell",n),new Promise((r,s)=>{if(S.isCancellationRequested)return s((0,y.canceled)());const a=(0,t.basename)(n);let l,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(l=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const T=(0,w.spawn)(n,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});S.onCancellationRequested(()=>(T.kill(),s((0,y.canceled)()))),T.on("error",x=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(x)),s(x)});const F=[];T.stdout.on("data",x=>F.push(x));const U=[];T.stderr.on("data",x=>U.push(x)),T.on("close",(x,re)=>{const le=Buffer.concat(F).toString("utf8");p.trace("getUnixShellEnvironment#raw",le);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&p.trace("getUnixShellEnvironment#stderr",ue),x||re)return s(new Error((0,k.localize)(2,null,x,re)));const se=i.exec(le),de=se?se[1]:"{}";try{const K=JSON.parse(de);f?K.ELECTRON_RUN_AS_NODE=f:delete K.ELECTRON_RUN_AS_NODE,h?K.ELECTRON_NO_ATTACH_CONSOLE=h:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",K),r(K)}catch(K){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),s(K)}})})}}),define(J[87],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[223],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const y=String(w._nextId++);return this.validators.set(y,D),{id:y,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=w,w._nextId=1}),define(J[41],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(J[21],Z([0,1,15,40,8,3,2,4,34,12,5,6,41,26]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,C.createDecorator)("lifecycleMainService");var d;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var E;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(E=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class Et extends D.Disposable{constructor(S,f,h){super(),this.logService=S,this.stateMainService=f,this.environmentMainService=h,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Et.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Et.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",S);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",f),w.app.once("will-quit",h=>{this.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",S),w.app.removeListener("window-all-closed",f),w.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const f=[];return this._onWillShutdown.fire({reason:S,join(h){f.push(h)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(f)}catch(h){this.logService.error(h)}try{await this.stateMainService.close()}catch(h){this.logService.error(h)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let f=this.phaseWhen.get(S);f||(f=new k.Barrier,this.phaseWhen.set(S,f)),await f.wait()}registerWindow(S){const f=new D.DisposableStore;this.windowCounter++,f.add(S.onWillLoad(c=>this._onWillLoadWindow.fire({window:S,workspace:c.workspace,reason:c.reason})));const h=(0,m.assertIsDefined)(S.win);h.on("close",c=>{const i=S.id;if(this.windowToCloseRequest.has(i)){this.windowToCloseRequest.delete(i);return}this.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),c.preventDefault(),this.unload(S,1).then(o=>{if(o){this.windowToCloseRequest.delete(i);return}this.windowToCloseRequest.add(i),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this._onBeforeCloseWindow.fire(S),S.close()})}),h.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,f){await this.unload(S,3)||S.reload(f)}unload(S,f){const h=this.mapWindowIdToPendingUnload.get(S.id);if(h)return h;const c=this.doUnload(S,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,c),c}async doUnload(S,f){if(!S.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${S.id}`);const h=this._quitRequested?2:f,c=await this.onBeforeUnloadWindowInRenderer(S,h);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(S,h),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,f){return new Promise(h=>{const c=this.oneTimeListenerTokenGenerator++,i=`vscode:ok${c}`,o=`vscode:cancel${c}`;t.validatedIpcMain.once(i,()=>{h(!1)}),t.validatedIpcMain.once(o,()=>{h(!0)}),S.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:o,reason:f})})}onWillUnloadWindowInRenderer(S,f){return new Promise(h=>{const i=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(i,()=>h()),S.send("vscode:onWillUnload",{replyChannel:i,reason:f})})}quit(S){return this.trace(`Lifecycle#quit() - begin (willRestart: ${S})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(S&&this.stateMainService.setItem(Et.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}trace(S){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(S):this.logService.trace(S)}async relaunch(S){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(S?.addArgs&&f.push(...S.addArgs),S?.removeArgs)for(const i of S.removeArgs){const o=f.indexOf(i);o>=0&&f.splice(o,1)}const h=()=>{try{if(y.isWindows){const i=(0,u.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.logService.error(i)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:f})};w.app.once("quit",h),await this.quit(!0)&&w.app.removeListener("quit",h)}async kill(S){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const f of w.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let h;f.webContents&&!f.webContents.isDestroyed()?h=new Promise(c=>f.once("closed",c)):h=Promise.resolve(),f.destroy(),await h}})()]),w.app.exit(S)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=ve([Y(0,I.ILogService),Y(1,v.IStateMainService),Y(2,g.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(J[224],Z([0,1,4,3,2,5,21]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let y=class extends k.Disposable{constructor(C){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,C.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const C=await new Promise((I,v)=>{q(["native-keymap"],I,v)});this._keyboardLayoutData=u(C),w.isCI||C.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(C),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};y=ve([Y(0,D.ILifecycleMainService)],y),e.KeyboardLayoutMainService=y;function u(m){const C=m.getKeyMap(),I=m.getCurrentKeyboardLayout();return{keyboardMapping:C,keyboardLayoutInfo:I}}}),define(J[225],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,w.createDecorator)("stateService")}),define(J[226],Z([0,1,8,17,12,36,14,6]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(I,v,g){this.storagePath=I,this.logService=v,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,v){const g=this.storage[I];return(0,k.isUndefinedOrNull)(g)?v:g}setItem(I,v){this.setItems([{key:I,data:v}])}setItems(I){let v=!1;for(const{key:g,data:d}of I)this.storage[g]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,v=!0):(this.storage[g]=d,v=!0));v&&this.save()}removeItem(I){(0,k.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(I){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),I)}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(I)),this.lastSavedStorageContents=I}catch(v){this.logService.error(v)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=u;let m=class{constructor(I,v,g){this.fileStorage=new u(I.stateResource,v,g)}async init(){await this.fileStorage.init()}getItem(I,v){return this.fileStorage.getItem(I,v)}};m=ve([Y(0,R.IEnvironmentService),Y(1,y.ILogService),Y(2,D.IFileService)],m),e.StateService=m}),define(J[227],Z([0,1,226]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends w.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(J[111],Z([0,1,4,34,7,28]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function y(m,C,I,v,g,d,E,b,p,S){const f=Object.create(null);f["common.machineId"]=E,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=g,f.version=d,f["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,w.PlatformToString)(w.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=v,f["common.product"]=S||"desktop",b&&(f["common.msftInternal"]=b);let h=0;const c=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),w.isLinuxSnap&&(f["common.snap"]="true");const i=D(I);i&&(f["common.platformDetail"]=i);try{const o=await m.readFile(k.URI.file(p));f["common.source"]=o.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=y;function u(m){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const I=C.toLowerCase();return m.some(v=>I===v)}e.verifyMicrosoftInternalDomain=u}),define(J[37],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[228],Z([0,1,30,57,8,43,13,9,4,7,81,23,97,84,14,20,37]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function S(o,n){const r=`${o}::${n.join(":")}`,s=p.get(r);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,P=new Map,M=2e4;function T(U,x,re,le){const ue=x.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let de;try{de=await I.Promises.readdir(x,{withFileTypes:!0})}catch{se();return}if(le.count>=M){le.count+=de.length,le.maxReached=!0,se();return}let K=de.length;if(K===0){se();return}let $=de;le.count+de.length>M&&(le.maxReached=!0,K=M-le.count,$=de.slice(0,K)),le.count+=de.length;for(const _ of $)if(_.isDirectory()){if(re.includes(_.name)||await T(U,(0,y.join)(x,_.name),re,le),--K===0){se();return}}else{const A=_.name.lastIndexOf(".");if(A>=0){const W=_.name.substring(A+1);W&&l.set(W,(l.get(W)??0)+1)}for(const W of a)W.relativePathPattern?.test(ue)!==!1&&W.filePattern.test(_.name)&&P.set(W.tag,(P.get(W.tag)??0)+1);if(--K===0){se();return}}})}const F=k.Promises.withAsyncBody(async U=>{const x={count:0,maxReached:!1};await T(o,o,n,x);const re=await c(o);U({configFiles:f(P),fileTypes:f(l),fileCount:x.count,maxFilesReached:x.maxReached,launchConfigFiles:re})});return p.set(r,F),F}e.collectWorkspaceStats=S;function f(o){return[...t.Iterable.map(o.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function h(){const o={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},n=w.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=h;async function c(o){try{const n=new Map,r=(0,y.join)(o,".vscode","launch.json"),s=await I.Promises.readFile(r),a=[],l=(0,R.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const P of l.configurations){const M=P.type;M&&(n.has(M)?n.set(M,n.get(M)+1):n.set(M,1))}return f(n)}catch{return[]}}e.collectLaunchConfigs=c;let i=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const s=w.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),u.isWindows||r.push(`Load (avg):       ${w.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,v.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[a,l]=s,P=this.formatProcessList(n,a);return r.forEach(M=>{if((0,g.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,l+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(n,M.processes)}`),M.workspaceMetadata){l+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const F=M.workspaceMetadata[T];let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),l+=`|    Folder (${T}): ${U}`,l+=this.formatWorkspaceStats(F)}}}),{processInfo:P,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:s,vmHint:a,os:l,cpus:P}=h(),M={os:l,memory:s,cpus:P,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return u.isWindows||(M.load=`${w.loadavg().map(T=>Math.round(T)).join(", ")}`),u.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(n,r){const s=[];return(0,v.listProcesses)(n.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),r.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(n,l.processes)),l.workspaceMetadata)for(const P of Object.keys(l.workspaceMetadata)){const M=l.workspaceMetadata[P];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${P}): ${T}`),s.push(this.formatWorkspaceStats(M))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const r=[];let a=0;const l=(F,U)=>{const x=` ${F}(${U})`;a+x.length>60?(r.push(P),P="|                 ",a=P.length):a+=x.length,P+=x};let P="|      File types:";const M=10,T=n.fileTypes.length>M?M:n.fileTypes.length;for(let F=0;F<T;F++){const U=n.fileTypes[F];l(U.name,U.count)}if(r.push(P),n.configFiles.length>=0&&(P="|      Conf files:",a=0,n.configFiles.forEach(F=>{l(F.name,F.count)}),r.push(P)),n.launchConfigFiles.length>0){let F="|      Launch Configs:";n.launchConfigFiles.forEach(U=>{F+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(F)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],s=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const P=m.URI.revive(l);if(P.scheme===D.Schemas.file){const M=P.fsPath;s.push(S(M,["node_modules",".git"]).then(T=>{let F=`${T.fileCount} files`;T.maxFilesReached&&(F=`more than ${F}`),r.push(`|    Folder (${(0,y.basename)(M)}): ${F}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else r.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,r){const s=new Map;n.windows.forEach(l=>s.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,s,a,r,0),a.join(`
`)}formatProcessItem(n,r,s,a,l){const P=l===0;let M;P?M=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(M=`${M} (${r.get(a.pid)})`));const T=process.platform==="win32"?a.mem:w.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(a.children)&&a.children.forEach(F=>this.formatProcessItem(n,r,s,F,l+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:s}of n.folders){const a=m.URI.revive(s);if(a.scheme!==D.Schemas.file)continue;const l=a.fsPath;try{(await S(l,["node_modules",".git"])).fileTypes.forEach(M=>r.add(M.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const s=m.URI.revive(r);if(s.scheme!==D.Schemas.file)continue;const a=s.fsPath;try{const l=await S(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:P.name,count:P.count})}),l.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:P.name,count:P.count})}),l.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};i=ve([Y(0,b.ITelemetryService),Y(1,E.IProductService)],i),e.DiagnosticsService=i}),define(J[229],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:y,data:u}){return this.appenders.forEach(m=>m.log(y,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,y=>`Failed to log telemetry: ${console.warn(y)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(J[73],Z([0,1,50,93,12,19,111,37]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class m{async publicLog(i,o,n){}async publicLogError(i,o,n){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(c,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:p(o.sourceConfig)})})}e.configurationTelemetry=C;function I(c,i){return!(i.disableTelemetry||!c.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=I;function v(c){const i=c.getValue(y.TELEMETRY_SETTING_ID),o=c.getValue("telemetry.enableCrashReporter");if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function g(c){const i={},o={},n={};b(c,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const s=n[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),i[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[r]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=g;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function E(c){if(!c)return"none";for(const i of d)if(c.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=E;function b(c,i,o=0,n){if(!!c)for(const r of Object.getOwnPropertyNames(c)){const s=c[r],a=n?n+r:r;Array.isArray(s)?i[a]=(0,w.safeStringify)(s):s instanceof Date?i[a]=s.toISOString():(0,k.isObject)(s)?o<2?b(s,i,o+1,a+"."):i[a]=(0,w.safeStringify)(s):i[a]=s}}function p(c){if(!c)return[];const i=[];return S(i,"",c),i}function S(c,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>S(c,i?`${i}.${n}`:n,o[n])):c.push(i)}function f(c,i){const o=c.msftInternalDomains||[],n=i.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=f;function h(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=h}),define(J[230],Z([0,1,189,73]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,y,u,m,C,I){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},g=await(0,w.getServiceMachineId)(y,m,C),{sessionId:d}=await I.getTelemetryInfo();return(0,t.supportsTelemetry)(D,y)&&(0,t.getTelemetryLevel)(u)===3&&(v["X-Market-User-Id"]=g,v["VSCode-SessionId"]=d),v}e.resolveMarketplaceHeaders=k}),define(J[231],Z([0,1,2,50,93,4,25,169,19,62,53,20,46,37,73]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(S,f,h){this._configurationService=f,this._productService=h,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,f){this._experimentProperties[S]=f}_updateTelemetryLevel(){let S=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const h=f.usage?3:f.error?2:0;S=Math.min(S,h)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,f=S.sessionID,h=S["common.machineId"],c=S["common.firstSessionDate"],i=S["common.msftInternal"];return{sessionId:f,machineId:h,firstSessionDate:c,msftInternal:i}}dispose(){this._disposables.dispose()}_log(S,f,h,c){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(i=>{h=(0,t.mixin)(h,i),h=(0,t.mixin)(h,this._experimentProperties),h=(0,t.cloneAndChange)(h,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(S,h))},i=>{console.error(i)})}publicLog(S,f,h){return this._log(S,3,f,h)}publicLog2(S,f,h){return this.publicLog(S,f,h)}publicLogError(S,f){return this._sendErrorTelemetry?this._log(S,2,f,!0):Promise.resolve(void 0)}publicLogError2(S,f){return this.publicLogError(S,f)}_anonymizeFilePaths(S){let f=S;const h=[];for(const n of this._cleanupPatterns)for(;;){const r=n.exec(S);if(!r)break;h.push([r.index,n.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const n=i.exec(S);if(!n)break;!c.test(n[0])&&h.every(([r,s])=>n.index<r||n.index>=s)&&(f+=S.substring(o,n.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<S.length&&(f+=S.substr(o)),f}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const f=S.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of h)if(c.regex.test(f))return`<REDACTED: ${c.label}>`;return S}_cleanupInfo(S,f){let h=S;f&&(h=this._anonymizeFilePaths(h));for(const c of this._cleanupPatterns)h=h.replace(c,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ve([Y(1,u.IConfigurationService),Y(2,I.IProductService)],E),e.TelemetryService=E;function b(){const p=(0,y.localize)(0,null,C.default.nameLong),S=C.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,y.localize)(3,null),h=(0,y.localize)(4,null),c=(0,y.localize)(5,null),i=(0,y.localize)(6,null),o=(0,y.localize)(7,null),n=`
|       | ${h} | ${c} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,y.localize)(8,null);return`
${p} ${S} ${f}

&nbsp;

${o}
${n}

&nbsp;

${r}
`}v.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,y.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,y.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[232],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(w=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===w.HIGH_CONTRAST_DARK||R===w.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===w.DARK||R===w.HIGH_CONTRAST_DARK}e.isDark=k}),define(J[233],Z([0,1,121,3,2,5,46,232]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var u;(function(b){function p(S){return S&&typeof S=="object"&&typeof S.id=="string"}b.isThemeColor=p})(u=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var C;(function(b){function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||u.isThemeColor(r.color))}b.isThemeIcon=p;const S=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const s=S.exec(r);if(!s)return;const[,a]=s;return{id:a}}b.fromString=f;function h(r){return{id:r}}b.fromId=h;function c(r,s){let a=r.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),s&&(a=`${a}~${s}`),{id:a}}b.modify=c;function i(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}b.getModifier=i;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}b.isEqual=o;function n(r,s){return{id:r.id,color:s?m(s):void 0}}b.asThemeIcon=n,b.asClassNameArray=w.CSSIcon.asClassNameArray,b.asClassName=w.CSSIcon.asClassName,b.asCSSSelector=w.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function I(b){switch(b){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(p);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new v;D.Registry.add(e.Extensions.ThemingContribution,g);function d(b){return g.onColorThemeChange(b)}e.registerThemingParticipant=d;class E extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,S){let f=this.theme.getColor(p);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=E}),define(J[64],Z([0,1,15,3,2,4,19,5,41]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",C="#1E1E1E",I="#000000",v="#FFFFFF",g="theme",d="themeBackground",E="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(S,f){super(),this.stateMainService=S,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&w.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return S.dark?I:v;let f=this.stateMainService.getItem(d,null);if(!f)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":f=m;break;case"hc-black":f=I;break;case"hc-light":f=v;break;default:f=C}return R.isMacintosh&&f.toUpperCase()===C&&(f="#171717"),f}saveWindowSplash(S,f){this.stateMainService.setItems([{key:g,data:f.baseTheme},{key:d,data:f.colorInfo.background},{key:E,data:f}]),typeof S=="number"&&this.updateBackgroundColor(S,f)}updateBackgroundColor(S,f){for(const h of w.BrowserWindow.getAllWindows())if(h.id===S){h.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};b=ve([Y(0,u.IStateMainService),Y(1,D.IConfigurationService)],b),e.ThemeMainService=b}),define(J[112],Z([0,1,3,4,5,6]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(E){E.Http="http",E.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var u;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(u=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=I;function v(E,b){return b?b!==1&&E<1024:!t.isWindows&&E<1024}e.isPortPrivileged=v;class g{constructor(b,p,S){this.remoteAddress=b,this.localAddress=p,this._dispose=S,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let d=class{constructor(b){this.logService=b,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],p=Array.from(this._tunnels.values());for(const S of p){const f=Array.from(S.values());for(const h of f){const c=await h.value;c&&b.push(c)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:p}of b.values())await p.then(S=>S?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,p,S,f,h=!1,c,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${f}.`),!b)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(b,p,S,f,h,c,i);return o?o.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==p||n.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const p=this._tunnels.get(b.tunnelRemoteHost);if(p){const S=p.get(b.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,S))}}}}async tryDisposeTunnel(b,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${p}.`);const f=S.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(p),f}}async closeTunnel(b,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${p} `);const S=this._tunnels.get(b);if(S&&S.has(p)){const f=S.get(p);f.refcount=0,await this.tryDisposeTunnel(b,p,f)}}addTunnelToMap(b,p,S){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(b,p){const S=this._tunnels.get(b);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,p){const S=[b];C(b)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):I(b)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const f=S.map(h=>this._tunnels.get(h));for(const h of f){const c=h?.get(p);if(c)return c}}canTunnel(b){return!!m(b)}createWithProvider(b,p,S,f,h,c,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${f}.`);const o=S;this._factoryInProgress.add(o);const r={elevationRequired:h?v(f===void 0?S:f):!1},s={remoteAddress:{host:p,port:S},localAddressPort:f,privacy:c,public:c?c!==y.Private:void 0,protocol:i},a=b.forwardPort(s,r);return a?(this.addTunnelToMap(p,S,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),a}};d=ve([Y(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(J[234],Z([0,1,77,92,219,8,2,19,6,20,218,112,87]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(S,f,h,c,i){let o;for(let n=3;n&&(o?.dispose(),o=await new d(S,f,h,c,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));n--);return o}class d extends D.Disposable{constructor(f,h,c,i,o){super(),this.defaultTunnelHost=h,this.suggestedLocalPort=o,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(f){f.pause();const h=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,C.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),i=c.getSocket().socket,o=c.readEntireBuffer();c.dispose(),o.byteLength>0&&f.write(o.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),i.end()}),f.on("close",()=>i.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),i.destroy()}),i.on("end",()=>f.end()),i.on("close",()=>f.end()),i.on("error",()=>{f.destroy()}),f.pipe(i),i.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),i.end()})}}let E=class extends I.AbstractTunnelService{constructor(f,h,c,i,o){super(h),this.socketFactory=f,this.signService=c,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,h,c,i,o,n,r){const s=this.getTunnelFromMap(h,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,c,i,o,n,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${c} on local port ${i}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},l=g(a,this.defaultTunnelHost,h,c,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,c,l),l}}};E=ve([Y(1,u.ILogService),Y(2,v.ISignService),Y(3,m.IProductService),Y(4,y.IConfigurationService)],E),e.BaseTunnelService=E;let b=class extends E{constructor(f,h,c,i){super(k.nodeSocketFactory,f,h,c,i)}};b=ve([Y(0,u.ILogService),Y(1,v.ISignService),Y(2,m.IProductService),Y(3,y.IConfigurationService)],b),e.TunnelService=b;let p=class extends D.Disposable{constructor(f,h,c,i){super(),this.logService=f,this.productService=h,this.signService=c,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(f,h,c,i,o,n,r,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this._tunnelServices.has(f)){const a=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(f,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(h,c,i,o,n,r,s)}};p=ve([Y(0,u.ILogService),Y(1,m.IProductService),Y(2,v.ISignService),Y(3,y.IConfigurationService)],p),e.SharedTunnelsService=p}),define(J[47],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(J[235],Z([0,1,4,170,62,46]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[236],Z([0,1,3,47]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(y){this.service=y}listen(y,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(y,u,m){switch(u){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=k;class R{constructor(y){this.channel=y,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}get state(){return this._state}set state(y){this._state=y,this._onStateChange.fire(y)}checkForUpdates(y){return this.channel.call("checkForUpdates",y)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(y){return this.channel.call("_applySpecificUpdate",y)}}e.UpdateChannelClient=R}),define(J[88],Z([0,1,8,22,3,19,26,21,6,20,54,47]),function(q,e,w,t,k,R,D,y,u,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function v(d,E,b){return`${b.updateUrl}/api/update/${d}/${E}/${b.commit}`}e.createUpdateURL=v;let g=class{constructor(E,b,p,S,f,h){this.lifecycleMainService=E,this.configurationService=b,this.environmentMainService=p,this.requestService=S,this.logService=f,this.productService=h,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const E=this.getUpdateMode(),b=this.getProductQuality(E);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),E==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}E==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(E){return E==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(E=60*60*1e3){return(0,w.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(E){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(E){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ve([Y(0,y.ILifecycleMainService),Y(1,R.IConfigurationService),Y(2,D.IEnvironmentMainService),Y(3,C.IRequestService),Y(4,u.ILogService),Y(5,m.IProductService)],g),e.AbstractUpdateService=g}),define(J[237],Z([0,1,15,52,3,2,19,26,21,6,20,54,37,47,88]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let E=class extends d.AbstractUpdateService{constructor(p,S,f,h,c,i,o){super(p,S,h,c,i,o),this.telemetryService=f,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(p,S)=>S)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(p,S,f)=>({url:S,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(p,S,f,h)=>({releaseNotes:S,version:f,productVersion:f,date:h}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(g.State.Idle(1,f))}buildUpdateFeedUrl(p){let S;this.productService.darwinUniversalAssetId?S=this.productService.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,d.createUpdateURL)(S,p,this.productService);try{w.autoUpdater.setFeedURL({url:f})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return f}doCheckForUpdates(p){this.setState(g.State.CheckingForUpdates(p)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(g.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],E.prototype,"onRawError",null),ve([t.memoize],E.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateDownloaded",null),E=ve([Y(0,u.ILifecycleMainService),Y(1,D.IConfigurationService),Y(2,v.ITelemetryService),Y(3,y.IEnvironmentMainService),Y(4,I.IRequestService),Y(5,m.ILogService),Y(6,C.IProductService)],E),e.DarwinUpdateService=E}),define(J[238],Z([0,1,51,29,8,3,9,26,21,6,37,47]),function(q,e,w,t,k,R,D,y,u,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let v=class{constructor(E,b,p){if(this.lifecycleMainService=E,this.logService=p,this._state=I.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}scheduleCheckForUpdates(E=60*60*1e3){return(0,k.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(E){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(E){}};v=ve([Y(0,u.ILifecycleMainService),Y(1,y.IEnvironmentMainService),Y(2,m.ILogService)],v);let g=class extends v{constructor(E,b,p,S,f,h){super(p,S,f),this.snap=E,this.snapRevision=b,this.telemetryService=h;const c=(0,t.watch)(D.dirname(this.snap)),i=R.Event.fromNodeEventEmitter(c,"change",(s,a)=>a),o=R.Event.filter(i,s=>s==="current"),r=R.Event.debounce(o,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{r.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(E=>{E?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,E.message||E))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const E=await new Promise((p,S)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(f,h)=>f?S(f):p(h))),b=D.basename(E);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,E=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([Y(2,u.ILifecycleMainService),Y(3,y.IEnvironmentMainService),Y(4,m.ILogService),Y(5,C.ITelemetryService)],g),e.SnapUpdateService=g}),define(J[55],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(J[239],Z([0,1,55,190,14,16,127,3,2]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(v){this.uri=v,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let C=class{constructor(v){this._fileService=v,this._dispooables=new u.DisposableStore,this._limit=2**16;const g=new Map,d=E=>{let b=g.get(E.scheme);return b===void 0&&(b=v.hasProvider(E)&&!this._fileService.hasCapability(E,1024),g.set(E.scheme,b)),b};this._dispooables.add(y.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(E=>{g.delete(E.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((E,b)=>this.extUri.compare(E,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,R.normalizePath)(v));const g=this._canonicalUris.get(v);return g?g.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new m(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((d,E)=>d[1].touch<E[1].touch?1:d[1].touch>E[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let d=0;d<g;d++)this._canonicalUris.set(v[d][0],v[d][1].touch())}};C=ve([Y(0,k.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(w.IUriIdentityService,C,!0)}),define(J[113],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(J[240],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(y){this.handler=y}listen(y,u){throw new Error(`Event not found: ${u}`)}call(y,u,m){switch(u){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=t;class k{constructor(y){this.channel=y}handleURL(y,u){return this.channel.call("handleURL",[y.toJSON(),u])}}e.URLHandlerChannelClient=k;class R{constructor(y){this.next=y}async routeCall(y,u,m,C){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(m){const I=w.URI.revive(m);if(I&&I.query){const v=/\bwindowId=(\d+)/.exec(I.query);if(v){const g=v[1],d=new RegExp(`window:${g}`),E=y.connections.find(b=>d.test(b.ctx));if(E)return E}}}return this.next.routeCall(y,u,m,C)}routeEvent(y,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=R}),define(J[241],Z([0,1,8,2,7,20]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,C){const I=[...this.handlers.values()];return(0,w.first)(I.map(v=>()=>v.handleURL(m,C)),void 0,!1).then(v=>v||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=D;let y=class extends D{constructor(m){super(),this.productService=m}create(m){let{authority:C,path:I,query:v,fragment:g}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&I&&I.indexOf("/")!==0&&(I=`/${I}`),k.URI.from({scheme:this.productService.urlProtocol,authority:C,path:I,query:v,fragment:g})}};y=ve([Y(0,R.IProductService)],y),e.NativeURLService=y}),define(J[242],Z([0,1,15,8,3,2,4,7]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function u(C){try{return y.URI.parse(C)}catch{return null}}class m{constructor(I,v,g,d,E){if(this.urlService=v,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=I,D.isWindows){const S=d.isBuilt?[]:[`"${d.appRoot}"`];S.push("--open-url","--"),w.app.setAsDefaultProtocolClient(E.urlProtocol,process.execPath,S)}const b=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(S,f)=>({event:S,url:f})),({event:S,url:f})=>(S.preventDefault(),f));this.disposables.add(b(S=>{const f=u(S);!f||this.urlService.open(f,{originalUrl:S})})),g.getWindows().filter(S=>S.isReady).length>0?this.flush():k.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const v of this.uris)await this.urlService.open(v.uri,{originalUrl:v.url})||I.push(v);I.length!==0&&(this.uris=I,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[243],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(J[244],Z([0,1,15,2,13,7]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,u)}handleWebviewRequest(u,m){try{const C=R.URI.parse(u.url),I=D.validWebviewFilePaths.get(C.path);if(typeof I=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${I}`,g=k.FileAccess.asFileUri(v,q);return m(decodeURIComponent(g.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(J[74],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(C){return!!C.workspaceUri}e.isWorkspaceToOpen=t;function k(C){return!!C.folderUri}e.isFolderToOpen=k;function R(C){return!!C.fileUri}e.isFileToOpen=R;function D(C){const I=y(C),v=C.getValue("window.menuBarVisibility");return v==="default"||I==="native"&&v==="compact"||w.isMacintosh&&w.isNative?"classic":v}e.getMenuBarVisibility=D;function y(C){if(w.isWeb)return"custom";const I=C.getValue("window");if(I){if(w.isMacintosh&&I.nativeTabs===!0||w.isMacintosh&&I.nativeFullScreen===!1)return"native";const d=I.titleBarStyle;if(d==="native"||d==="custom")return d}return w.isLinux?"native":"custom"}e.getTitleBarStyle=y;function u(C,I){if(!w.isWindows||w.isWeb||!I.isBuilt||y(C)==="native")return!1;const v=C.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=u;function m(C=0){return Math.pow(1.2,C)}e.zoomLevelToZoomFactor=m}),define(J[114],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var t;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=k;var R;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(J[33],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(J[245],Z([0,1,15,22,3,66,2,28,69,102,6,20,33]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(E){E[E.Initial=1]="Initial",E[E.StoredCredentialsUsed=2]="StoredCredentialsUsed",E[E.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let d=class extends D.Disposable{constructor(b,p,S,f,h){super(),this.logService=b,this.windowsMainService=p,this.credentialsService=S,this.encryptionMainService=f,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(w.app,"login",(p,S,f,h,c)=>({event:p,webContents:S,req:f,authInfo:h,callback:c}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:S,callback:f}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&S.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(h?.username,h?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let S,f;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(o){const n=JSON.parse(await this.encryptionMainService.decrypt(o));S=n.username,f=n.password}}catch(o){this.logService.error(o)}if(this.state!==g.StoredCredentialsUsed&&typeof S=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:S,password:f};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const c={authInfo:b,username:this.sessionCredentials?.username??S,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,y.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=g.LoginDialogShown;const i=await new Promise(o=>{const n=async(r,s,a)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",n),a){const l={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(P){this.logService.error(P)}o({username:l.username,password:l.password})}else o(void 0)};h.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=i,i}};d=ve([Y(0,C.ILogService),Y(1,v.IWindowsMainService),Y(2,u.ICredentialsMainService),Y(3,m.IEncryptionMainService),Y(4,I.IProductService)],d),e.ProxyAuthHandler=d}),define(J[246],Z([0,1,69,6,36,20,33,202]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=class extends y.BaseCredentialsMainService{constructor(C,I,v,g){super(C),this.environmentMainService=I,this.productService=v,this.windowsMainService=g,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;const C=await new Promise((I,v)=>{q(["keytar"],I,v)});return await C.findCredentials("test-keytar-loads"),this._keytarCache=C,this._keytarCache}};u=ve([Y(0,t.ILogService),Y(1,k.INativeEnvironmentService),Y(2,R.IProductService),Y(3,D.IWindowsMainService)],u),e.CredentialsNativeMainService=u}),define(J[247],Z([0,1,18,2,3,6,21,79,51,276,8,13,50,4,34,15,33]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=E.UtilityProcess,S=typeof p<"u";let f=class Ot{constructor(o,n,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,n.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const n=this._extHosts.get(o);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return S}async createExtensionHost(o){if(this._shutdown)throw(0,w.canceled)();const n=String(++Ot._lastId);let r;if(o){if(!S)throw new Error("Cannot use UtilityProcess!");r=new c(n,this._logService,this._windowsMainService)}else r=new h(n,this._logService);return this._extHosts.set(n,r),r.onExit(({pid:s,code:a,signal:l})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${a}, signal: ${l}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(n)})}),{id:n}}async start(o,n){if(this._shutdown)throw(0,w.canceled)();return this._getExtHost(o).start(n)}async enableInspectPort(o){if(this._shutdown)throw(0,w.canceled)();const n=this._extHosts.get(o);return n?n.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,w.canceled)();const n=this._extHosts.get(o);!n||n.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const n=[];for(const[,r]of this._extHosts)n.push(r.waitForExit(o));return C.Promises.settled(n).then(()=>{})}};f._lastId=0,f=ve([Y(0,R.ILogService),Y(1,D.ILifecycleMainService),Y(2,b.IWindowsMainService)],f),e.ExtensionHostStarter=f;let h=class extends t.Disposable{constructor(o,n){super(),this.id=o,this._logService=n,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){g.isCI&&this._logService.info("Calling fork to start extension host...");const n=y.StopWatch.create(!1);this._process=(0,u.fork)(I.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,v.mixin)({cwd:(0,d.cwd)()},o));const r=n.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const a=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:a.write(P);this._onStdout.fire(M)});const l=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:l.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,w.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,C.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${n} did not exit within ${o}ms.`),this._process.kill())}};h=ve([Y(1,R.ILogService)],h);let c=class extends t.Disposable{constructor(o,n,r){super(),this.id=o,this._logService=n,this._windowsMainService=r,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const n=this._windowsMainService.getWindowById(o.responseWindowId);if(!n){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=n.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,a=I.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],P=o.execArgv||[],M={...o.env};for(const re of Object.keys(M))M[re]=String(M[re]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(a,l,{serviceName:s,env:M,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(re,le)=>le);this._register(T(re=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re,signal:""})}));const F=(re,le)=>{le.type==="Utility"&&le.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${le.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:le.exitCode,signal:""}))};E.app.on("child-process-gone",F),this._register((0,t.toDisposable)(()=>{E.app.off("child-process-gone",F)}));const{port1:U,port2:x}=new E.MessageChannelMain;this._process.postMessage("port",null,[x]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,C.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};c=ve([Y(1,R.ILogService),Y(2,b.IWindowsMainService)],c)}),define(J[248],Z([0,1,15,3,2,244,33]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let y=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,C){let I;if(typeof m.windowId=="number"){const{windowId:v}=m,g=this.windowsMainService.getWindowById(v);if(!g?.win)throw new Error(`Invalid windowId: ${v}`);I=g.win.webContents}else{const{webContentsId:v}=m;if(I=w.webContents.fromId(v),!I)throw new Error(`Invalid webContentsId: ${v}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(C)}async findInFrame(m,C,I,v){const d=this.getFrameByName(m,C);if(typeof d.findInFrame=="function"){d.findInFrame(I,{findNext:v.findNext,forward:v.forward});const E=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),d.removeListener("found-in-frame",E))};d.on("found-in-frame",E)}}async stopFindInFrame(m,C,I){const g=this.getFrameByName(m,C);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,C){const I=this.windowsMainService.getWindowById(m.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${m}`);const v=I.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===C);if(!v)throw new Error(`Unknown frame: ${C}`);return v}};y=ve([Y(0,D.IWindowsMainService)],y),e.WebviewMainService=y}),define(J[249],Z([0,1,8,3,2]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:y,onDidFocusWindow:u,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(y,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(y){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=y}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(J[27],Z([0,1,174,9,32,16,7,5,13]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function m(n){const r=n;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=m;function C(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=C;function I(n){const r=n;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=I;function v(n){const r=n;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const s=n;if(s?.configPath)return{id:s.id,configPath:D.URI.revive(s.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=v;var g;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=d;function E(n){const r=n;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=E;class b{constructor(r,s,a,l,P){this._id=r,this._transient=a,this._configuration=l,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class p{constructor(r,s){this.raw=s,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function S(n){return new p({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(n,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function c(n){let r;return D.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=c;function i(n,r){return!h(n,r)&&!c(n)}e.isSavedWorkspace=i;function o(n){return(typeof n=="string"?(0,t.extname)(n):(0,R.extname)(n))===f}e.hasWorkspaceFileExtension=o}),define(J[250],Z([0,1,76,29,31,13,9,4,16,7,23,178,19,26,14,6,177,27]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(h,c,i){this.configurationService=c,this.logService=i,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=u.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,n)=>(0,k.isEqual)(o,n,!y.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let c=[];try{Array.isArray(h.rootURIWorkspaces)&&(c=h.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:m.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let i=[];try{Array.isArray(h.folderWorkspaceInfos)?i=h.folderWorkspaceInfos.map(o=>({folderUri:m.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(h.folderURIWorkspaces)&&(i=h.folderURIWorkspaces.map(o=>({folderUri:m.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(i),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,c){this.workspaces.some(o=>h.workspace.id===o.workspace.id)||(this.workspaces.push(h),this.saveSync());const i=this.getBackupPath(h.workspace.id);return c&&this.moveBackupFolderSync(i,c),i}moveBackupFolderSync(h,c){if(t.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),t.existsSync(c))try{t.renameSync(c,h)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}unregisterWorkspaceBackupSync(h){const c=h.id,i=this.workspaces.findIndex(o=>o.workspace.id===c);i!==-1&&(this.workspaces.splice(i,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(c=>this.backupUriComparer.isEqual(h.folderUri,c.folderUri))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const c=this.folders.findIndex(i=>this.backupUriComparer.isEqual(h,i.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(h,c){const i=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,i))||(this.emptyWindows.push({backupFolder:i,remoteAuthority:c}),this.saveSync()),this.getBackupPath(i)}unregisterEmptyWindowBackupSync(h){const c=this.emptyWindows.findIndex(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,h));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(h){return(0,D.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const c=new Set,i=[];for(const o of h){const n=o.workspace;if(!(0,p.isWorkspaceIdentifier)(n))return[];if(!c.has(n.id)){c.add(n.id);const r=this.getBackupPath(n.id);await this.doHasBackups(r)?n.configPath.scheme!==R.Schemas.file||await C.Promises.exists(n.configPath.fsPath)?i.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return i}async validateFolders(h){if(!Array.isArray(h))return[];const c=[],i=new Set;for(const o of h){const n=o.folderUri,r=this.backupUriComparer.getComparisonKey(n);if(!i.has(r)){i.add(r);const s=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(s)?n.scheme!==R.Schemas.file||await C.Promises.exists(n.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const c=[],i=new Set;for(const o of h){const n=o.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const r=this.getBackupPath(n);await this.doHasBackups(r)?c.push(o):await this.deleteStaleBackup(r)}}return c}async deleteStaleBackup(h){try{await C.Promises.exists(h)&&await C.Promises.rm(h,C.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(h){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c));)c=this.getRandomEmptyWindowId();const i=this.getBackupPath(c);try{await C.Promises.rename(h,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(h){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c));)c=this.getRandomEmptyWindowId();const i=this.getBackupPath(c);try{t.renameSync(h,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const h=[];for(const c of this.workspaces)await this.hasBackups(c)&&h.push(c);for(const c of this.folders)await this.hasBackups(c)&&h.push(c);return h}hasBackups(h){let c;return(0,I.isEmptyWindowBackupInfo)(h)?c=h.backupFolder:(0,b.isFolderBackupInfo)(h)?c=this.getBackupPath(this.getFolderHash(h)):c=this.getBackupPath(h.workspace.id),this.doHasBackups(c)}async doHasBackups(h){try{const c=await C.Promises.readdir(h);for(const i of c)try{if((await C.Promises.readdir((0,D.join)(h,i))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderWorkspaceInfos:this.folders.map(h=>({folderUri:h.folderUri.toString(),remoteAuthority:h.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){const c=h.folderUri;let i;return c.scheme===R.Schemas.file?i=y.isLinux?c.fsPath:c.fsPath.toLowerCase():i=c.toString().toLowerCase(),(0,w.createHash)("md5").update(i).digest("hex")}};S=ve([Y(0,g.IEnvironmentMainService),Y(1,v.IConfigurationService),Y(2,E.ILogService)],S),e.BackupMainService=S}),define(J[56],Z([0,1,15,8,66,35,2,80,4,12,23,151,5,6,27]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let E=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,S){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},S)}pickFolder(p,S){return this.doPick({...p,pickFolders:!0,title:(0,I.localize)(1,null)},S)}pickFile(p,S){return this.doPick({...p,pickFiles:!0,title:(0,I.localize)(2,null)},S)}pickWorkspace(p,S){const f=(0,I.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,I.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:f,filters:c,buttonLabel:h},S)}async doPick(p,S){const f={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(f.properties=void 0,p.pickFiles&&p.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&f.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(f,(0,m.withNullAsUndefined)(S||w.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(p){if(p){let S=this.windowDialogQueues.get(p.id);return S||(S=new t.Queue,this.windowDialogQueues.set(p.id,S)),S}else return this.noWindowDialogueQueue}showMessageBox(p,S){return this.getWindowDialogQueue(S).queue(async()=>S?w.dialog.showMessageBox(S,p):w.dialog.showMessageBox(p))}async showSaveDialog(p,S){const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(S).queue(async()=>{let h;return S?h=await w.dialog.showSaveDialog(S,p):h=await w.dialog.showSaveDialog(p),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,D.dispose)(f)}}normalizePath(p){return p&&u.isMacintosh&&(p=(0,y.normalizeNFC)(p)),p}normalizePaths(p){return p.map(S=>this.normalizePath(S))}async showOpenDialog(p,S){p.defaultPath&&(await C.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(S).queue(async()=>{let h;return S?h=await w.dialog.showOpenDialog(S,p):h=await w.dialog.showOpenDialog(p),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,D.dispose)(f)}}acquireFileDialogLock(p,S){if(!S)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let f=this.windowFileDialogLocks.get(S.id);f||(f=new Set,this.windowFileDialogLocks.set(S.id,f));const h=(0,k.hash)(p);if(!f.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),f.add(h),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),f?.delete(h),f?.size===0&&this.windowFileDialogLocks.delete(S.id)})}};E=ve([Y(0,g.ILogService)],E),e.DialogMainService=E}),define(J[251],Z([0,1,3,2,67,27]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(u,m){super(),this.logService=u,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new w.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,m){this._register(w.Event.debounce(u.onDidChangeStorage,(C,I)=>(C?C.push(I):C=[I],C),D.STORAGE_CHANGE_DEBOUNCE_TIME)(C=>{C.length&&m.fire(this.serializeStorageChangeEvents(C,u))}))}serializeStorageChangeEvents(u,m){const C=new Map,I=new Set;return u.forEach(v=>{const g=m.get(v.key);typeof g=="string"?C.set(v.key,g):I.add(v.key)}),{changed:Array.from(C.entries()),deleted:Array.from(I.values())}}listen(u,m,C){switch(m){case"onDidChangeStorage":{const I=C.profile?(0,k.revive)(C.profile):void 0;if(!I)return this.onDidChangeApplicationStorageEmitter.event;let v=this.mapProfileToOnDidChangeProfileStorageEmitter.get(I.id);return v||(v=this._register(new w.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(I),v),this.mapProfileToOnDidChangeProfileStorageEmitter.set(I.id,v)),v.event}}throw new Error(`Event not found: ${m}`)}async call(u,m,C){const I=C.profile?(0,k.revive)(C.profile):void 0,v=(0,R.reviveIdentifier)(C.workspace),g=await this.withStorageInitialized(I,v);switch(m){case"getItems":return Array.from(g.items.entries());case"updateItems":{const d=C;if(d.insert)for(const[E,b]of d.insert)g.set(E,b);d.delete?.forEach(E=>g.delete(E));break}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(u,m){let C;m?C=this.storageMainService.workspaceStorage(m):u?C=this.storageMainService.profileStorage(u):C=this.storageMainService.applicationStorage;try{await C.init()}catch(I){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":u?"profile":"application"} storage due to ${I}`)}return C}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[39],Z([0,1,66,3,2,16,12,7,171,36,14,5,6,27,32,55,8,28,25]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function f(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&y.URI.isUri(n.location)&&y.URI.isUri(n.globalStorageHome)&&y.URI.isUri(n.settingsResource)&&y.URI.isUri(n.keybindingsResource)&&y.URI.isUri(n.tasksResource)&&y.URI.isUri(n.snippetsHome)&&((0,D.isUndefined)(n.extensionsResource)||y.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=f,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function h(o,n){return{id:o.id,isDefault:o.isDefault,name:o.name,location:y.URI.revive(o.location).with({scheme:n}),globalStorageHome:y.URI.revive(o.globalStorageHome).with({scheme:n}),settingsResource:y.URI.revive(o.settingsResource).with({scheme:n}),keybindingsResource:y.URI.revive(o.keybindingsResource).with({scheme:n}),tasksResource:y.URI.revive(o.tasksResource).with({scheme:n}),snippetsHome:y.URI.revive(o.snippetsHome).with({scheme:n}),extensionsResource:y.URI.revive(o.extensionsResource)?.with({scheme:n}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=h,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(o,n,r,s){return{id:(0,w.hash)(n.path).toString(16),name:o,location:n,isDefault:!1,globalStorageHome:(0,R.joinPath)(n,"globalStorage"),settingsResource:(0,R.joinPath)(n,"settings.json"),keybindingsResource:(0,R.joinPath)(n,"keybindings.json"),tasksResource:(0,R.joinPath)(n,"tasks.json"),snippetsHome:(0,R.joinPath)(n,"snippets"),extensionsResource:(0,R.joinPath)(n,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:s}}e.toUserDataProfile=c;let i=class extends k.Disposable{constructor(n,r,s,a){super(),this.environmentService=n,this.fileService=r,this.uriIdentityService=s,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(l=>c(l.name,l.location,l.useDefaultFlags)):[];let r;const s=new d.ResourceMap,a=c((0,u.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),n.length){const l=this.getStoredProfileAssociations();if(l.workspaces)for(const[P,M]of Object.entries(l.workspaces)){const T=y.URI.parse(P),F=y.URI.parse(M),U=n.find(x=>this.uriIdentityService.extUri.isEqual(x.location,F));U&&s.set(T,U)}if(l.emptyWindow){const P=y.URI.parse(l.emptyWindow);r=n.find(M=>this.uriIdentityService.extUri.isEqual(M.location,P))}}this._profilesObject={profiles:n,workspaces:s,emptyWindow:r}}return this._profilesObject}async createTransientProfile(n){const r="Temp",s=new RegExp(`${(0,S.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const P of this.profiles){const M=s.exec(P.name),T=M?parseInt(M[1]):0;a=T>a?T:a}const l=`${r} ${a+1}`;return this.createProfile(l,void 0,n,!0)}async createProfile(n,r,s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=await this.doCreateProfile(n,r,a);return s&&await this.setProfileForWorkspace(s,l),l}async doCreateProfile(n,r,s){let a=this.profileCreationPromises.get(n);return a||(a=(async()=>{try{const l=this.profiles.find(T=>T.name===n);if(l)return l;const P=c(n,(0,R.joinPath)(this.profilesHome,(0,w.hash)((0,p.generateUuid)()).toString(16)),r,s);await this.fileService.createFolder(P.location);const M=[];return this._onWillCreateProfile.fire({profile:P,join(T){M.push(T)}}),await b.Promises.settled(M),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(n)}})(),this.profileCreationPromises.set(n,a)),a}async updateProfile(n,r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(l=>l.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=c(r,a.location,s),this.updateProfiles([],[],[a]),a}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:r,join(a){s.push(a)}}),await b.Promises.settled(s),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(n,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(n);return s||(s=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,s)),s}async setProfileForWorkspace(n,r){this.setProfileForWorkspaceSync(n,r)}setProfileForWorkspaceSync(n,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(n,s)}unsetWorkspace(n,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.getWorkspace(n);return y.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location)))}updateProfiles(n,r,s){const a=[...this.profiles,...n],l=[];this.transientProfilesObject.profiles=[];for(let P of a)P.isDefault||r.some(M=>P.id===M.id)||(P=s.find(M=>P.id===M.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):l.push({location:P.location,name:P.name,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(l),this._profilesObject=void 0,this.triggerProfilesChanges(n,r,s)}triggerProfilesChanges(n,r,s){this._onDidChangeProfiles.fire({added:n,removed:r,updated:s,all:this.profiles})}updateWorkspaceAssociation(n,r,s){s=r?.isTransient?!0:s,s||this.updateWorkspaceAssociation(n,void 0,!0);const a=this.getWorkspace(n),l=s?this.transientProfilesObject:this.profilesObject;y.URI.isUri(a)?(l.workspaces.delete(a),r&&l.workspaces.set(a,r)):l.emptyWindow=r,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[s,a]of this.profilesObject.workspaces.entries())n[s.toString()]=a.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=ve([Y(0,m.IEnvironmentService),Y(1,C.IFileService),Y(2,E.IUriIdentityService),Y(3,v.ILogService)],i),e.UserDataProfilesService=i}),define(J[89],Z([0,1,24,8,50,17,18,43,137,2,13,9,4,16,188,94,12,7,156,36,109,108,187,14,5,6,20,3,67,72,39,55,186]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n,r,s,a,l,P,M,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(K){function $(_,A){if(_===A)return!0;const W=Object.keys(_),z=new Set;for(const ee of Object.keys(A))z.add(ee);if(W.length!==z.size)return!1;for(const ee of W){if(_[ee]!==A[ee])return!1;z.delete(ee)}return z.size===0}K.equals=$})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let x=class extends m.Disposable{constructor($,_,A,W,z,ee,B,H,L,O,N){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=_,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=z,this.extensionsProfileScannerService=ee,this.fileService=B,this.logService=H,this.environmentService=L,this.productService=O,this.instantiationService=N,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(le,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,_,A){const[W,z]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(_)]),ee=A?await this.scanExtensionsUnderDevelopment($,[...W,...z]):[];return this.dedupExtensions(W,z,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const _=[];_.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),_.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[A,W]=await Promise.all(_);return this.applyScanOptions([...A,...W],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const _=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let W=await($.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return W=await this.applyScanOptions(W,1,$,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment($,_){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const z=await this.createExtensionScannerInput(W,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=_.find(H=>(0,h.areSameExtensions)(H.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",$,!0)}return[]}async scanExistingExtension($,_,A){const W=await this.createExtensionScannerInput($,!1,_,!0,A.language),z=await this.extensionsScanner.scanExtension(W);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions($,_,A){const W=await this.createExtensionScannerInput($,!1,_,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(z,_,A,!0)}async scanMetadata($){const _=(0,g.joinPath)($,"package.json"),A=(await this.fileService.readFile(_)).value.toString();return JSON.parse(A).__metadata}async updateMetadata($,_){const A=(0,g.joinPath)($,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(W);_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.installedTimestamp=_.installedTimestamp||void 0,z.__metadata={...z.__metadata,..._},await this.fileService.writeFile((0,g.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions($,_,A,W){return A.includeAllVersions||($=this.dedupExtensions(_===0?$:void 0,_===1?$:void 0,_==="development"?$:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||($=$.filter(z=>z.isValid)),$.sort((z,ee)=>{const B=I.basename(z.location.fsPath),H=I.basename(ee.location.fsPath);return B<H?-1:B>H?1:0})}dedupExtensions($,_,A,W,z){const ee=(H,L,O)=>{if(H.isValid&&!L.isValid)return!1;if(H.isValid===L.isValid){if(z&&d.gt(H.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(d.eq(H.manifest.version,L.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${H.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${L.location.path}.`),!0},B=new Map;return $?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||ee(O,H,!1))&&B.set(L,H)}),_?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);if(!O&&$&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!O||ee(O,H,!1))&&B.set(L,H)}),A?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||ee(O,H,!0))&&B.set(L,H),B.set(L,H)}),[...B.values()]}async scanDefaultSystemExtensions($,_){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,_),z=await($&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions($,_){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=_?await this.getBuiltInExtensionControl():{},z=[],ee=p.URI.file(I.normalize(I.join(C.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const H of A){const L=W[H.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,g.joinPath)(ee,H.name));break;default:z.push(p.URI.file(L));break}}const B=await Promise.all(z.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,w.coalesce)(B)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,_,A,W,z,ee=!0){const B=await this.getTranslations(z??v.language),H=await this.getMtime($),L=_?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new re($,H,L,O,_,A,W,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime($){try{const _=await this.fileService.stat($);if(typeof _.mtime=="number")return _.mtime}catch{}}};x=ve([Y(4,M.IUserDataProfilesService),Y(5,P.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,r.ILogService),Y(8,f.IEnvironmentService),Y(9,s.IProductService),Y(10,n.IInstantiationService)],x),e.AbstractExtensionsScannerService=x;class re{constructor($,_,A,W,z,ee,B,H,L,O,N,V,Q,ne){this.location=$,this.mtime=_,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=z,this.type=ee,this.excludeObsolete=B,this.validate=H,this.productVersion=L,this.productDate=O,this.productCommit=N,this.devMode=V,this.language=Q,this.translations=ne}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,_){return(0,g.isEqual)($.location,_.location)&&$.mtime===_.mtime&&(0,g.isEqual)($.applicationExtensionslocation,_.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&$.profile===_.profile&&$.type===_.type&&$.excludeObsolete===_.excludeObsolete&&$.validate===_.validate&&$.productVersion===_.productVersion&&$.productDate===_.productDate&&$.productCommit===_.productCommit&&$.devMode===_.devMode&&$.language===_.language&&U.equals($.translations,_.translations)}}let le=class extends m.Disposable{constructor($,_,A,W,z){super(),this.obsoleteFile=$,this.extensionsProfileScannerService=_,this.uriIdentityService=A,this.fileService=W,this.logService=z}async scanExtensions($){const _=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let A={};if($.excludeObsolete&&$.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,b.isEmptyObject)(A)?_:_.filter(W=>!A[h.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation($){const _=await this.fileService.resolve($.location);if(!_.children?.length)return[];const A=await Promise.all(_.children.map(async W=>{if(!W.isDirectory||$.type===1&&(0,g.basename)(W.resource).indexOf(".")===0)return null;const z=new re(W.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(z)}));return(0,w.coalesce)(A).sort((W,z)=>W.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile($){let _=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){_=_.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,$);_.push(...A)}return _}async scanExtensionsFromProfileResource($,_,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!W.length)return[];const z=await Promise.all(W.map(async ee=>{if(_(ee)){const B=new re(ee.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,ee.metadata)}return null}));return(0,w.coalesce)(z)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,g.joinPath)($.location,"package.json"))){const _=await this.scanExtension($);return _?[_]:[]}else return await this.scanExtensions($)}catch(_){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,D.getErrorMessage)(_)),[]}}async scanExtension($,_){try{let A=await this.scanExtensionManifest($.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),_=_??A.__metadata,delete A.__metadata;const W=(0,h.getGalleryExtensionId)(A.publisher,A.name),z=_?.id?{id:W,uuid:_.id}:{id:W},ee=_?.isSystem?0:$.type,B=ee===0||!!_?.isBuiltin;A=await this.translateManifest($.location,A,re.createNlsConfiguration($));const H={type:ee,identifier:z,manifest:A,location:$.location,isBuiltin:B,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return $.validate?this.validate(H,$):H}}catch(A){$.type!==0&&this.logService.error(A)}return null}validate($,_){let A=!0;const W=(0,i.validateExtensionManifest)(_.productVersion,_.productDate,_.location,$.manifest,$.isBuiltin);for(const[z,ee]of W)z===E.default.Error&&(A=!1,this.logService.error(this.formatMessage(_.location,ee)));return $.isValid=A,$.validations=W,$}async scanExtensionManifest($){const _=(0,g.joinPath)($,"package.json");let A;try{A=(await this.fileService.readFile(_)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage($,(0,S.localize)(0,null,_.path,z.message))),null}let W;try{W=JSON.parse(A)}catch{const ee=[];(0,y.parse)(A,ee);for(const B of ee)this.logService.error(this.formatMessage($,(0,S.localize)(1,null,_.path,B.offset,B.length,(0,u.getParseErrorMessage)(B.error))));return null}return(0,y.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage($,(0,S.localize)(2,null,_.path))),null):W}async translateManifest($,_,A){const W=await this.getLocalizedMessages($,_,A);if(W)try{const z=[],ee=await this.resolveOriginalMessageBundle(W.default,z);if(z.length>0)return z.forEach(H=>{this.logService.error(this.formatMessage($,(0,S.localize)(3,null,W.default?.path,(0,u.getParseErrorMessage)(H.error))))}),_;if((0,y.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage($,(0,S.localize)(4,null,W.default?.path))),_;const B=W.values||Object.create(null);return(0,F.localizeManifest)(_,B,ee)}catch{}return _}async getLocalizedMessages($,_,A){const W=(0,g.joinPath)($,"package.nls.json"),z=(L,O)=>{O.forEach(N=>{this.logService.error(this.formatMessage($,(0,S.localize)(5,null,L?.path,(0,u.getParseErrorMessage)(N.error))))})},ee=L=>{this.logService.error(this.formatMessage($,(0,S.localize)(6,null,L?.path)))},B=`${_.publisher}.${_.name}`,H=A.translations[B];if(H)try{const L=p.URI.file(H),O=(await this.fileService.readFile(L)).value.toString(),N=[],V=(0,y.parse)(O,N);return N.length>0?(z(L,N),{values:void 0,default:W}):(0,y.getNodeType)(V)!=="object"?(ee(L),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles($,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const N=(await this.fileService.readFile(O.localized)).value.toString(),V=[],Q=(0,y.parse)(N,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,y.getNodeType)(Q)!=="object"?(ee(O.localized),{values:void 0,default:O.original}):{values:Q,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle($,_){if($)try{const A=(await this.fileService.readFile($)).value.toString();return(0,y.parse)(A,_)}catch{}}findMessageBundles($,_){return new Promise((A,W)=>{const z=ee=>{const B=(0,g.joinPath)($,`package.nls.${ee}.json`);this.fileService.exists(B).then(H=>{H&&A({localized:B,original:(0,g.joinPath)($,"package.nls.json")});const L=ee.lastIndexOf("-");L===-1?A({localized:(0,g.joinPath)($,"package.nls.json"),original:null}):(ee=ee.substring(0,L),z(ee))})};if(_.devMode||_.pseudo||!_.language)return A({localized:(0,g.joinPath)($,"package.nls.json"),original:null});z(_.language)})}formatMessage($,_){return`[${$.path}]: ${_}`}};le=ve([Y(1,P.IExtensionsProfileScannerService),Y(2,T.IUriIdentityService),Y(3,o.IFileService),Y(4,r.ILogService)],le);let ue=class extends le{constructor($,_,A,W,z,ee){super(_,A,W,z,ee),this.cacheFile=$,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const _=await this.readExtensionCache();if(this.input=$,_&&_.input&&re.equals(_.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),_.result.map(W=>(W.location=p.URI.revive(W.location),W));const A=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:A}),A}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),_=JSON.parse($.value.toString());return{result:_.result,input:(0,l.revive)(_.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify($)))}catch(_){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(_))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const _=$.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,_))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ue=ve([Y(2,P.IExtensionsProfileScannerService),Y(3,T.IUriIdentityService),Y(4,o.IFileService),Y(5,r.ILogService)],ue);function se(K,$){const _=(0,h.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:_,identifier:new c.ExtensionIdentifier(_),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:$,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=se;class de extends x{constructor($,_,A,W,z,ee,B,H,L,O,N){super($,_,(0,g.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(W,c.MANIFEST_CACHE_FOLDER),z,ee,B,H,L,O,N),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const V=await this.fileService.readFile(p.URI.file(v.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(J[252],Z([0,1,7,36,72,89,14,5,6,20,39]),function(q,e,w,t,k,R,D,y,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends R.NativeExtensionsScannerService{constructor(g,d,E,b,p,S,f){super(w.URI.file(p.builtinExtensionsPath),w.URI.file(p.extensionsPath),p.userHome,w.URI.file(p.userDataPath),g,d,E,b,p,S,f)}};I=ve([Y(0,C.IUserDataProfilesService),Y(1,k.IExtensionsProfileScannerService),Y(2,D.IFileService),Y(3,u.ILogService),Y(4,t.INativeEnvironmentService),Y(5,m.IProductService),Y(6,y.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(J[253],Z([0,1,15,40,2,32,13,9,4,7,28,36,6,39]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(b,p,S){super(),this.logService=S,this.validRoots=R.TernarySearchTree.forPaths(!u.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=w.session;b.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,S)=>this.handleResourceRequest(p,S)),b.protocol.interceptFileProtocol(D.Schemas.file,(p,S)=>this.handleFileRequest(p,S)),this._register((0,k.toDisposable)(()=>{b.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(b){const p=(0,y.normalize)(b);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(b,p){const S=m.URI.parse(b.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${b.url})`),p({error:-3})}handleResourceRequest(b,p){const S=this.requestToNormalizedFilePath(b);return this.validRoots.findSubstr(S)?p({path:S}):this.validExtensions.has((0,y.extname)(S).toLowerCase())?p({path:S}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),p({error:-3}))}requestToNormalizedFilePath(b){const p=m.URI.parse(b.url),S=D.FileAccess.asFileUri(p);return(0,y.normalize)(S.fsPath)}createIPCObjectUrl(){let b;const p=m.URI.from({scheme:"vscode",path:(0,C.generateUuid)()}),S=p.toString(),f=async()=>b;return t.validatedIpcMain.handle(S,f),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:p,update:h=>b=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),t.validatedIpcMain.removeHandler(S)}}}};d=ve([Y(0,I.INativeEnvironmentService),Y(1,g.IUserDataProfilesService),Y(2,v.ILogService)],d),e.ProtocolMainService=d}),define(J[254],Z([0,1,15,40,8,3,2,13,12,99,26,21,6,53,61,64,44,39,38]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(c,i,o,n,r,s,a,l,P){super(),this.machineId=c,this.userEnv=i,this.environmentMainService=o,this.userDataProfilesService=n,this.lifecycleMainService=r,this.logService=s,this.policyService=a,this.themeMainService=l,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,i)=>this.onWindowConnection(c,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,i)=>this.onWorkerConnection(c,i)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,i){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[o])}onWorkerConnection(c,i){this.logService.trace("SharedProcess: onWorkerConnection",i);const o=new D.DisposableStore,n=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",i))},r=w.BrowserWindow.fromId(i.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>n("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>n("closed"))),r.webContents.postMessage(i.reply.channel,i.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...i){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...i)}catch(o){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,b.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,i)=>this._onDidError.fire({type:2,details:i})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,i,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:i}})))}async connect(){await this.whenIpcReady;const c=(0,u.assertIsDefined)(this.window);return(0,m.connect)(c)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};f=ve([Y(2,C.IEnvironmentMainService),Y(3,p.IUserDataProfilesService),Y(4,I.ILifecycleMainService),Y(5,v.ILogService),Y(6,S.IPolicyService),Y(7,E.IThemeMainService),Y(8,d.IProtocolMainService)],f),e.SharedProcess=f}),define(J[115],Z([0,1,8,3,2,71,12,100,5,39]),function(q,e,w,t,k,R,D,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,u.createDecorator)("storageService");var I;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var g;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(f={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,h){if(h===C){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:h,target:this.getKeyTargets(f)[h]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,h,c){return this.getStorage(h)?.get(f,c)}getBoolean(f,h,c){return this.getStorage(h)?.getBoolean(f,c)}getNumber(f,h,c){return this.getStorage(h)?.getNumber(f,c)}store(f,h,c,i){if((0,D.isUndefinedOrNull)(h)){this.remove(f,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,c,i),this.getStorage(c)?.set(f,h)})}remove(f,h){this.withPausedEmitters(()=>{this.updateKeyTarget(f,h,void 0),this.getStorage(h)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,h){const c=[],i=this.getKeyTargets(f);for(const o of Object.keys(i))i[o]===h&&c.push(o);return c}updateKeyTarget(f,h,c){const i=this.getKeyTargets(h);typeof c=="number"?i[f]!==c&&(i[f]=c,this.getStorage(h)?.set(C,JSON.stringify(i))):typeof i[f]=="number"&&(delete i[f],this.getStorage(h)?.set(C,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const h=this.get(C,f);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f});const h=this.getStorage(-1),c=this.getStorage(0),i=this.getStorage(1);switch(f){case I.NONE:await w.Promises.settled([h?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await w.Promises.settled([h?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return p(f,h,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,h){return this.emitWillSaveState(I.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,h):this.switchToWorkspace(f,h)}canSwitchProfile(f,h){return!(f.id===h.id||E(h)&&E(f))}switchData(f,h,c,i){this.withPausedEmitters(()=>{if(i)for(const[o,n]of f)h.set(o,n);else{const o=new Set;for(const[n,r]of f)o.add(n),h.get(n)!==r&&this.emitDidChangeValue(c,n);for(const[n]of h.items)o.has(n)||this.emitDidChangeValue(c,n)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class b extends d{constructor(){super(),this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=b;async function p(S,f,h,c,i,o){const n=U=>{try{return JSON.parse(U)}catch{return U}},r=new Map,s=new Map;S.forEach((U,x)=>{r.set(x,U),s.set(x,n(U))});const a=new Map,l=new Map;f.forEach((U,x)=>{a.set(x,U),l.set(x,n(U))});const P=new Map,M=new Map;h.forEach((U,x)=>{P.set(x,U),M.set(x,n(U))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(r.forEach((U,x)=>{T.push({key:x,value:U})}),console.table(T),console.groupEnd(),console.log(s),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];a.forEach((x,re)=>{U.push({key:re,value:x})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const F=[];P.forEach((U,x)=>{F.push({key:x,value:U})}),console.table(F),console.groupEnd(),console.log(M)}e.logStorage=p}),define(J[255],Z([0,1,24,8,3,2,9,79,7,23,100,148,6,115,37,27]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{constructor(o,n){super(),this.logService=o,this.fileService=n,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new C.Storage(new C.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=C.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===C.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const n=o.getBoolean(g.IS_NEW_KEY);n===void 0?o.set(g.IS_NEW_KEY,!0):n&&o.set(g.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=C.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===v.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,n){return this._storage.get(o,n)}set(o,n){return this._storage.set(o,n)}delete(o){return this._storage.delete(o)}async close(){const o=new y.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const n=(0,w.top)(Array.from(this._storage.items.entries()).map(([s,a])=>({key:s,length:a.length})),(s,a)=>a.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=C.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends b{constructor(o,n,r,s){super(r,s),this.profile=o,this.options=n}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}async doCreate(){return new C.Storage(new I.SQLiteStorageDatabase(this.path??I.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class S extends p{constructor(o,n,r,s){super(o,n,r,s)}}e.ProfileStorageMain=S;class f extends p{constructor(o,n,r,s){super(n.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(d.firstSessionDateStorageKey,void 0)===void 0&&o.set(d.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(d.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(d.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(d.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=f;class h extends b{constructor(o,n,r,s,a){super(r,a),this.workspace=o,this.options=n,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:o,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new C.Storage(new I.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:n?C.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,D.join)(o,h.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let n;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const r=(0,D.join)(o,h.WORKSPACE_META_NAME);await m.Promises.exists(r)||await m.Promises.writeFile(r,JSON.stringify(n,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class c extends b{get path(){}async doCreate(){return new C.Storage(new C.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(J[256],Z([0,1,67,36,14,6,225,55,39]),function(q,e,w,t,k,R,D,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class Mt extends u.UserDataProfilesService{constructor(I,v,g,d,E){super(g,d,v,E),this.stateService=I}getStoredProfiles(){return(0,w.revive)(this.stateService.getItem(Mt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,w.revive)(this.stateService.getItem(Mt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([Y(0,D.IStateService),Y(1,y.IUriIdentityService),Y(2,t.IEnvironmentService),Y(3,k.IFileService),Y(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(J[42],Z([0,1,7,36,14,5,6,41,55,39,256]),function(q,e,w,t,k,R,D,y,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let I=class lt extends C.UserDataProfilesService{constructor(g,d,E,b,p){super(g,d,E,b,p),this.stateMainService=g}setEnablement(g){super.setEnablement(g),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(g){if(!!this.isEnabled()&&!(!g._.length&&!g["folder-uri"]&&!g["file-uri"])){if(g.profile)return this.profiles.some(d=>d.name===g.profile)?void 0:this.createProfile(g.profile).then(()=>g);if(g["profile-temp"])return this.createTransientProfile().then(d=>(g.profile=d.name,g))}}saveStoredProfiles(g){g.length?this.stateMainService.setItem(lt.PROFILES_KEY,g):this.stateMainService.removeItem(lt.PROFILES_KEY)}saveStoredProfileAssociations(g){g.emptyWindow||g.workspaces?this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,g):this.stateMainService.removeItem(lt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",d=this.stateMainService.getItem(g,void 0);if(d){this.stateMainService.removeItem(g);const E=d.reduce((b,{workspace:p,profile:S})=>(b[w.URI.revive(p).toString()]=w.URI.revive(S).toString(),b),{});this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}return super.getStoredProfileAssociations()}};I=ve([Y(0,y.IStateMainService),Y(1,u.IUriIdentityService),Y(2,t.IEnvironmentService),Y(3,k.IFileService),Y(4,D.ILogService)],I),e.UserDataProfilesMainService=I}),define(J[257],Z([0,1,2,16,72,89,14,6,39,42]),function(q,e,w,t,k,R,D,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let C=class extends w.Disposable{constructor(v,g,d,E,b){super(),this.userDataProfilesService=v,this.fileService=g,this.extensionsScannerService=d,this.extensionsProfileScannerService=E,v.isEnabled()?(this._register(v.onWillCreateProfile(p=>{v.profiles.length===1&&p.join(this.initialize())})),this._register(v.onDidChangeProfiles(p=>{v.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>b.error(p))}async initialize(){const v=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(v)}catch{}const g=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(g.map(d=>[d,d.metadata]),v)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,u.EXTENSIONS_RESOURCE_NAME)}};C=ve([Y(0,m.IUserDataProfilesMainService),Y(1,D.IFileService),Y(2,R.IExtensionsScannerService),Y(3,k.IExtensionsProfileScannerService),Y(4,y.ILogService)],C),e.DefaultExtensionsProfileInitHandler=C}),define(J[90],Z([0,1,49,2,36,14,5,21,6,115,255,39,42]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(b,p,S,f,h){super(),this.logService=b,this.environmentService=p,this.userDataProfilesService=S,this.lifecycleMainService=f,this.fileService=h,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join(this.applicationStorage.close());for(const[,p]of this.mapProfileToStorage)b.join(p.close());for(const[,p]of this.mapWorkspaceToStorage)b.join(p.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const p=this.mapProfileToStorage.get(b.profile.id);p&&b.join(p.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,w.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,m.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let p=this.mapProfileToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),p=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,p),(0,w.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id)})),p}createProfileStorage(b){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let p=this.mapWorkspaceToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),p=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,p),(0,w.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),p}createWorkspaceStorage(b){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=ve([Y(0,u.ILogService),Y(1,k.IEnvironmentService),Y(2,v.IUserDataProfilesMainService),Y(3,y.ILifecycleMainService),Y(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let d=class extends m.AbstractStorageService{constructor(b,p){super(),this.userDataProfilesService=b,this.storageMainService=p,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};d=ve([Y(0,I.IUserDataProfilesService),Y(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(J[258],Z([0,1,2,21,42]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends w.Disposable{constructor(y,u){super(),this.userDataProfilesService=u,this._register(y.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.previousWorkspace??"empty-window")})),this._register(y.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(y){this.userDataProfilesService.getOrSetProfileForWorkspace(y).isTransient&&(this.userDataProfilesService.unsetWorkspace(y,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([Y(0,t.ILifecycleMainService),Y(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(J[116],Z([0,1,16,7,27]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(u,m,C){for(const v of u){const g=v.openedWorkspace;if((0,k.isWorkspaceIdentifier)(g)){const d=C(g);if(d){if(d.folders.some(E=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.uri)))return v}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.configPath))return v}}const I=u.filter(v=>(0,k.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,v.openedWorkspace.uri));if(I.length)return I.sort((v,g)=>-(v.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(u,m){for(const C of u)if((0,k.isWorkspaceIdentifier)(C.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,m))return C}e.findWindowOnWorkspaceOrFolder=D;function y(u,m){const C=I=>m.some(v=>w.extUriBiasedIgnorePathCase.isEqual(t.URI.file(v),t.URI.file(I)));for(const I of u)if(I.config?.extensionDevelopmentPath?.some(v=>C(v)))return I}e.findWindowOnExtensionDevelopmentPath=y}),define(J[259],Z([0,1,15,2,4,16,7,19,21,6,41,33,114,27]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Dt extends t.Disposable{constructor(h,c,i,o,n){super(),this.windowsMainService=h,this.stateMainService=c,this.lifecycleMainService=i,this.logService=o,this.configurationService=n,this._state=E(this.stateMainService.getItem(Dt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),n&&(c.lastActiveWindow=this.toWindowState(n),c.lastActiveWindow.uiState.mode===3&&h.add(c.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(i),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const r=this.toWindowState(n);return r.uiState.mode===3&&(h.has(r.uiState.display)?k.isMacintosh&&r.windowId!==c.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(r.uiState.mode=1):h.add(r.uiState.display)),r}));const o=p(c);this.stateMainService.setItem(Dt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(i=>{const o=(0,g.isWorkspaceIdentifier)(h.openedWorkspace)&&i.workspace?.id===h.openedWorkspace.id,n=(0,g.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,h.openedWorkspace.uri);(o||n)&&(i.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(h){return{windowId:h.id,workspace:(0,g.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const c=this.doGetNewWindowState(h),i=this.configurationService.getValue("window");if(c.mode===3){let o;c.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),o||(c.mode=1)}return c}doGetNewWindowState(h){const c=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,g.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===a.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,a.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(h.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===h.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let i;const o=w.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(k.isMacintosh){const a=w.screen.getCursorScreenPoint();i=w.screen.getDisplayNearestPoint(a)}!i&&c&&(i=w.screen.getDisplayMatching(c.getBounds())),i||(i=w.screen.getPrimaryDisplay()||o[0])}let n=(0,v.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")n.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")n.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?n.mode=3:n=a,s=n.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const c=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;c.some(i=>i.x===h.x||i.y===h.y);)h.x+=30,h.y+=30;return h}};d.windowsStateStorageKey="windowsState",d=ve([Y(0,I.IWindowsMainService),Y(1,C.IStateMainService),Y(2,u.ILifecycleMainService),Y(3,m.ILogService),Y(4,y.IConfigurationService)],d),e.WindowsStateHandler=d;function E(f){const h={openedWindows:[]},c=f||{openedWindows:[]};return c.lastActiveWindow&&(h.lastActiveWindow=b(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=b(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(h.openedWindows=c.openedWindows.map(i=>b(i))),h}e.restoreWindowsState=E;function b(f){const h={uiState:f.uiState};return f.backupPath&&(h.backupPath=f.backupPath),f.remoteAuthority&&(h.remoteAuthority=f.remoteAuthority),f.folder&&(h.folderUri=D.URI.parse(f.folder)),f.workspaceIdentifier&&(h.workspace={id:f.workspaceIdentifier.id,configPath:D.URI.parse(f.workspaceIdentifier.configURIPath)}),h}function p(f){return{lastActiveWindow:f.lastActiveWindow&&S(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&S(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(h=>S(h))}}e.getWindowsStateStoreData=p;function S(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(J[91],Z([0,1,31,43,124,35,13,9,4,16,7,5,63,27]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function E(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=E;function b(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=b;function p(M){return S(M)||f(M)}e.isStoredWorkspaceFolder=p;function S(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function f(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function h(M,T,F,U,x){if(M.scheme!==U.scheme)return{name:F,uri:M.toString(!0)};let re=T?void 0:x.relativePath(U,M);if(re!==void 0)re.length===0?re=".":u.isWindows&&(re=c(re));else if(M.scheme===D.Schemas.file)re=M.fsPath,u.isWindows&&(re=c(re));else if(x.isEqualAuthority(M.authority,U.authority))re=M.path;else return{name:F,uri:M.toString(!0)};return{name:F,path:re}}e.getStoredWorkspaceFolder=h;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,w.isUNC)(M)||(M=(0,w.toSlashes)(M)),M}function i(M,T,F){const U=[],x=new Set,re=F.dirname(T);for(const le of M){let ue;if(S(le))le.path&&(ue=F.resolvePath(re,le.path));else if(f(le))try{ue=C.URI.parse(le.uri),ue.path[0]!==y.posix.sep&&(ue=ue.with({path:y.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=F.getComparisonKey(ue);if(!x.has(se)){x.add(se);const de=le.name||F.basenameOrAuthority(ue);U.push(new g.WorkspaceFolder({uri:ue,name:de,index:U.length},le))}}}return U}e.toWorkspaceFolders=i;function o(M,T,F,U,x){const re=n(T,M),le=x.dirname(T),ue=x.dirname(U),se=[];for(const _ of re.folders){const A=S(_)?x.resolvePath(le,_.path):C.URI.parse(_.uri);let W;F?W=!1:W=!S(_)||(0,y.isAbsolute)(_.path),se.push(h(A,W,_.name,ue,x))}const de={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,de);let $=k.applyEdits(M,K);return(0,m.isEqualAuthority)(re.remoteAuthority,(0,v.getRemoteAuthority)(U))&&($=k.applyEdits($,k.removeProperty($,["remoteAuthority"],de))),$}e.rewriteWorkspaceFileForNewLocation=o;function n(M,T){const F=t.parse(T);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(U=>p(U));else throw new Error(`${M} looks like an invalid workspace file.`);return F}function r(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function a(M){return typeof M.fileUri=="string"}function l(M,T){const F={workspaces:[],files:[]};if(M){const U=function(re,le){for(let ue=0;ue<re.length;ue++)try{le(re[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(re[ue])}: ${se.toString()}. Skip entry.`)}},x=M;Array.isArray(x.entries)&&U(x.entries,re=>{const le=re.label,ue=re.remoteAuthority;r(re)?F.workspaces.push({label:le,remoteAuthority:ue,workspace:{id:re.workspace.id,configPath:C.URI.parse(re.workspace.configPath)}}):s(re)?F.workspaces.push({label:le,remoteAuthority:ue,folderUri:C.URI.parse(re.folderUri)}):a(re)&&F.files.push({label:le,remoteAuthority:ue,fileUri:C.URI.parse(re.fileUri)})})}return F}e.restoreRecentlyOpened=l;function P(M){const T={entries:[]};for(const F of M.workspaces)E(F)?T.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):T.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of M.files)T.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return T}e.toStoreData=P}),define(J[117],Z([0,1,76,29,13,4,16]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function y(m){function C(){let I=m.scheme===k.Schemas.file?(0,D.originalFSPath)(m):m.toString();return R.isLinux||(I=I.toLowerCase()),(0,w.createHash)("md5").update(I).digest("hex")}return{id:C(),configPath:m}}e.getWorkspaceIdentifier=y;function u(m,C){function I(){if(m.scheme!==k.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!C)try{C=(0,t.statSync)(m.fsPath)}catch{return}let g;return R.isLinux?g=C.ino:R.isMacintosh?g=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?g=Math.floor(C.birthtimeMs):g=C.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(g?String(g):"").digest("hex")}const v=I();if(typeof v=="string")return{id:v,uri:m}}e.getSingleFolderWorkspaceIdentifier=u}),define(J[48],Z([0,1,15,29,3,43,35,2,13,9,16,12,23,176,60,56,26,5,6,20,42,116,27,91,117]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let r=class extends y.Disposable{constructor(a,l,P,M,T,F){super(),this.environmentMainService=a,this.logService=l,this.userDataProfilesMainService=P,this.backupMainService=M,this.dialogMainService=T,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>v.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===u.Schemas.file)try{const P=l(a.fsPath);return P instanceof Promise?P.then(M=>this.doResolveWorkspace(a,M),M=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,i.isUntitledWorkspace)(a,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const P=this.doParseStoredWorkspace(a,l),M=(0,n.getWorkspaceIdentifier)(a);return{id:M.id,configPath:M.configPath,folders:(0,o.toWorkspaceFolders)(P.folders,M.configPath,C.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,l){const P=(0,R.parse)(l);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(M=>(0,o.isStoredWorkspaceFolder)(M));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return await v.Promises.mkdir((0,m.dirname)(T),{recursive:!0}),await v.Promises.writeFile(T,JSON.stringify(M,null,"	")),P}createUntitledWorkspaceSync(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,m.dirname)(T),{recursive:!0}),(0,v.writeFileSync)(T,JSON.stringify(M,null,"	")),P}newUntitledWorkspace(a=[],l){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,C.joinPath)(this.untitledWorkspacesHome,P),T=(0,C.joinPath)(M,i.UNTITLED_WORKSPACE_NAME),F=[];for(const U of a)F.push((0,o.getStoredWorkspaceFolder)(U.uri,!0,U.name,M,C.extUriBiasedIgnorePathCase));return{workspace:(0,n.getWorkspaceIdentifier)(T),storedWorkspace:{folders:F,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,n.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,i.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,C.originalFSPath)(a.configPath);try{(0,v.rimrafSync)((0,m.dirname)(l));const P=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,v.writeFileSync)((0,m.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${l} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,C.joinPath)(this.untitledWorkspacesHome,P,i.UNTITLED_WORKSPACE_NAME));for(const P of l){const M=(0,n.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?a.push({workspace:M,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,P))return;const T=this.doEnterWorkspace(a,(0,n.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:a,workspace:T.workspace}),T}async isValidTargetWorkspacePath(a,l,P){if(!P)return!0;if((0,i.isWorkspaceIdentifier)(a.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,P)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,C.basename)(P)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,i.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=P,{workspace:l,backupPath:P}}};r=ve([Y(0,b.IEnvironmentMainService),Y(1,S.ILogService),Y(2,h.IUserDataProfilesMainService),Y(3,d.IBackupMainService),Y(4,E.IDialogMainService),Y(5,f.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[118],Z([0,1,40,22,5,33,27,48]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let u=class{constructor(C,I){this.windowsMainService=C,this.workspacesManagementMainService=I}async getRemoteDiagnostics(C){const I=this.windowsMainService.getWindows();return(await Promise.all(I.map(g=>new Promise(d=>{const E=g.remoteAuthority;if(E){const b=`vscode:getDiagnosticInfoResponse${g.id}`,p={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:b,args:p}),w.validatedIpcMain.once(b,(S,f)=>{f||d({hostName:E,errorMessage:`Unable to resolve connection to '${E}'.`}),d(f)}),setTimeout(()=>{d({hostName:E,errorMessage:`Connection to '${E}' could not be established`})},5e3)}else d(void 0)})))).filter(g=>!!g)}getFolderURIs(C){const I=[],v=C.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(v))I.push(v.uri);else if((0,D.isWorkspaceIdentifier)(v)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(v.configPath);g&&g.folders.forEach(E=>{I.push(E.uri)})}return I}};u=ve([Y(0,R.IWindowsMainService),Y(1,y.IWorkspacesManagementMainService)],u),e.DiagnosticsMainService=u}),define(J[119],Z([0,1,15,24,4,12,7,23,19,59,5,6,113,33,27,48,42]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let p=class{constructor(f,h,c,i,o,n){this.logService=f,this.windowsMainService=h,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=o,this.userDataProfilesMainService=n}async start(f,h){this.logService.trace("Received data from other instance: ",f,h),k.isMacintosh&&w.app.focus({steal:!0});const c=this.parseOpenUrl(f);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:o,url:n}of c)this.urlService.open(o,{originalUrl:n})})}else return this.startOpenWindow(f,h)}parseOpenUrl(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,t.coalesce)(f._urls.map(h=>{try{return{uri:D.URI.parse(h),url:h}}catch{return null}})):[]}async startOpenWindow(f,h){const c=(0,m.isLaunchedFromCli)(h)?0:4;let i=[];const o=f.wait&&f.waitMarkerFilePath?D.URI.file(f.waitMarkerFilePath):void 0,n=f.remote||void 0,r=this.userDataProfilesMainService.checkAndCreateProfileFromCli(f);r&&await r;const s={context:c,cli:f,userEnv:h,waitMarkerFileURI:o,remoteAuthority:n};if(f.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,s);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let a=!1;if(f["new-window"]||f["unity-launch"])a=!0;else if(f["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!k.isMacintosh}if(a)i=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,s),i=[l]):i=this.windowsMainService.open({...s,forceEmpty:!0})}}else i=this.windowsMainService.open({...s,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(o&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,y.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const f=[];return w.BrowserWindow.getAllWindows().forEach(h=>{const c=this.windowsMainService.getWindowById(h.id);c?f.push(this.codeWindowToInfo(c)):f.push(this.browserWindowToInfo(h))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(f){const h=[],c=f.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(c))h.push(c.uri);else if((0,d.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(n=>{h.push(n.uri)})}return h}codeWindowToInfo(f){const h=this.getFolderURIs(f),c=(0,R.assertIsDefined)(f.win);return this.browserWindowToInfo(c,h,f.remoteAuthority)}browserWindowToInfo(f,h=[],c){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:h,remoteAuthority:c}}};p=ve([Y(0,I.ILogService),Y(1,g.IWindowsMainService),Y(2,v.IURLService),Y(3,E.IWorkspacesManagementMainService),Y(4,u.IConfigurationService),Y(5,b.IUserDataProfilesMainService)],p),e.LaunchMainService=p}),define(J[65],Z([0,1,51,15,30,142,52,3,35,2,13,9,4,7,96,81,23,92,166,56,26,5,21,6,20,64,33,27,48,17]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n,r,s,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class extends m.Disposable{constructor(F,U,x,re,le,ue,se,de,K){super(),this.sharedProcess=F,this.windowsMainService=U,this.dialogMainService=x,this.lifecycleMainService=re,this.environmentMainService=le,this.logService=ue,this.productService=se,this.themeMainService=de,this.workspacesManagementMainService=K,this.onDidOpenWindow=y.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidTriggerSystemContextMenu=y.Event.filter(y.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:$,x:_,y:A})=>({windowId:$.id,x:_,y:A})),({windowId:$})=>!!this.windowsMainService.getWindowById($)),this.onDidMaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-blur",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=y.Event.any(y.Event.map(y.Event.filter(y.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-focus",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=y.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new y.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=y.Event.debounce(y.Event.any(y.Event.filter(y.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",($,_,A)=>A),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),y.Event.fromNodeEventEmitter(t.screen,"display-added"),y.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(F,U,x){return Array.isArray(U)?this.doOpenWindow(F,U,x):this.doOpenEmptyWindow(F,U)}async doOpenWindow(F,U,x=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0})}async doOpenEmptyWindow(F,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F){this.windowById(F)?.toggleFullScreen()}async handleTitleDoubleClick(F){this.windowById(F)?.handleTitleDoubleClick()}async isMaximized(F){const U=this.windowById(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.windowById(F);U?.win&&U.win.minimize()}async updateWindowControls(F,U){const x=this.windowById(F);x&&x.updateWindowControls(U)}async focusWindow(F,U){U&&typeof U.windowId=="number"&&(F=U.windowId),this.windowById(F)?.focus({force:U?.force??!1})}async setMinimumSize(F,U,x){const re=this.windowById(F);if(re?.win){const[le,ue]=re.win.getSize(),[se,de]=re.win.getMinimumSize(),[K,$]=[U??se,x??de],[_,A]=[Math.max(le,K),Math.max(ue,$)];(se!==K||de!==$)&&re.win.setMinimumSize(K,$),(le!==_||ue!==A)&&re.win.setSize(_,A)}}async saveWindowSplash(F,U){this.themeMainService.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:x}=await this.getShellCommandLink();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(U);if(re&&!re.dangling){const le=await(0,d.realpath)(U);if(x===le)return}await b.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(x,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:le}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(le===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(ue)}catch{throw new Error((0,S.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.getShellCommandLink();try{await b.Promises.unlink(U)}catch(x){switch(x.code){case"EACCES":{const{response:re}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(le)}catch{throw new Error((0,S.localize)(7,null,U))}break}case"ENOENT":break;default:throw x}}}async getShellCommandLink(){const F=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(F))throw new Error((0,S.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(F))}async showSaveDialog(F,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(F))}async showOpenDialog(F,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(F))}toBrowserWindow(F){const U=this.windowById(F);if(U?.win)return U.win}async pickFileFolderAndOpen(F,U){const x=await this.dialogMainService.pickFileFolder(U);x&&this.doOpenPicked(await Promise.all(x.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),U,F)}async pickFolderAndOpen(F,U){const x=await this.dialogMainService.pickFolder(U);x&&this.doOpenPicked(x.map(re=>({folderUri:g.URI.file(re)})),U,F)}async pickFileAndOpen(F,U){const x=await this.dialogMainService.pickFile(U);x&&this.doOpenPicked(x.map(re=>({fileUri:g.URI.file(re)})),U,F)}async pickWorkspaceAndOpen(F,U){const x=await this.dialogMainService.pickWorkspace(U);x&&this.doOpenPicked(x.map(re=>({workspaceUri:g.URI.file(re)})),U,F)}doOpenPicked(F,U,x){this.windowsMainService.open({context:3,contextWindowId:x,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}async showItemInFolder(F,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(F,U){this.windowById(F)?.setRepresentedFilename(U)}async setDocumentEdited(F,U){this.windowById(F)?.setDocumentEdited(U)}async openExternal(F,U){return v.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(F){const U=process.env.GDK_PIXBUF_MODULE_FILE,x=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=x}moveItemToTrash(F,U){return t.shell.trashItem(U)}async isAdmin(){let F;return v.isWindows?F=(await new Promise((U,x)=>{q(["native-is-elevated"],U,x)}))():F=process.getuid()===0,F}async writeElevated(F,U,x,re){const le=await new Promise((ue,se)=>{q(["@vscode/sudo-prompt"],ue,se)});return new Promise((ue,se)=>{const de=[`"${this.cliPath}"`];re?.unlock&&de.push("--file-chmod"),de.push("--file-write",`"${U.fsPath}"`,`"${x.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:v.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(de.join(" "),K,($,_,A)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),A&&this.logService.trace(`[sudo-prompt] received stderr: ${A}`),$?se($):ue(void 0)})})}get cliPath(){return v.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):v.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return E.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(F,U,x){process.kill(U,x)}async readClipboardText(F,U){return t.clipboard.readText(U)}async writeClipboardText(F,U,x){return t.clipboard.writeText(U,x)}async readClipboardFindText(F){return t.clipboard.readFindText()}async writeClipboardFindText(F,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,x,re){return t.clipboard.writeBuffer(U,Buffer.from(x.buffer),re)}async readClipboardBuffer(F,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(F,U,x){return t.clipboard.has(U,x)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){this.windowById(F)?.updateTouchBar(U)}async notifyReady(F){this.windowById(F)?.setReady()}async relaunch(F,U){return this.lifecycleMainService.relaunch(U)}async reload(F,U){const x=this.windowById(F);if(x){if((0,a.isWorkspaceIdentifier)(x.openedWorkspace)){const re=x.openedWorkspace.configPath;if(re.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(x,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){const x=this.windowById(U);if(x?.win)return x.win.close()}async quit(F){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(F,U){await this.lifecycleMainService.kill(U)}async resolveProxy(F,U){const re=this.windowById(F)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(F,U,x,re,le=1){return(0,p.findFreePort)(U,x,re,le)}async openDevTools(F,U){const x=this.windowById(F);x?.win&&x.win.webContents.openDevTools(U)}async toggleDevTools(F){const U=this.windowById(F);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(F,U){const x=this.windowById(F);x?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&x.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,U,x,re){if(!v.isWindows)return;const le=await new Promise((ue,se)=>{q(["@vscode/windows-registry"],ue,se)});try{return le.GetStringRegKey(U,x,re)}catch{return}}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};ve([D.memoize],M.prototype,"cliPath",null),M=ve([Y(1,s.IWindowsMainService),Y(2,f.IDialogMainService),Y(3,i.ILifecycleMainService),Y(4,h.IEnvironmentMainService),Y(5,o.ILogService),Y(6,n.IProductService),Y(7,r.IThemeMainService),Y(8,l.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(J[260],Z([0,1,15,40,30,35,2,13,4,97,164,84,118,56,26,5,119,6,65,53,20,61,74]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,E.createDecorator)("issueMainService");let o=class Wt{constructor(r,s,a,l,P,M,T,F,U,x){this.userEnv=r,this.environmentMainService=s,this.launchMainService=a,this.logService=l,this.diagnosticsService=P,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=F,this.protocolMainService=U,this.productService=x,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[s,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(s,a);this.safeSend(r,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async r=>{const s=[];try{const a=await this.launchMainService.getMainProcessId();s.push({name:(0,C.localize)(0,null),rootProcess:await(0,m.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,I.isRemoteDiagnosticError)(P)?s.push({name:P.hostName,rootProcess:P}):P.processes&&s.push({name:P.hostName,rootProcess:P.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(r,"vscode:listProcessesResponse",s)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{const s={title:this.productService.nameLong,message:(0,C.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const s=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",s)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,C.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(r,s)=>{const{id:a,from:l,args:P}=s;let M;switch(l){case"issueReporter":M=this.issueReporterParentWindow;break;case"processExplorer":M=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}M?.webContents.send("vscode:runAction",{id:a,from:l,args:P})}),t.validatedIpcMain.on("vscode:openExternal",(r,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),t.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",s.windows)})}safeSend(r,s,...a){r.sender.isDestroyed()||r.sender.send(s,...a)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new D.DisposableStore,a=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,a,{backgroundColor:r.styles.backgroundColor,title:(0,C.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:f.default}),this.issueReporterWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new D.DisposableStore,a=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,a,{backgroundColor:r.styles.backgroundColor,title:(0,C.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:f.default}),this.processExplorerWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,s,a,l){const P=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:a.title,backgroundColor:a.backgroundColor||Wt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}async getSystemStatus(){const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,s)}getWindowPosition(r,s,a){let l;const P=w.screen.getAllDisplays();if(P.length===1)l=P[0];else{if(u.isMacintosh){const F=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(F)}!l&&r&&(l=w.screen.getDisplayMatching(r.getBounds())),l||(l=w.screen.getPrimaryDisplay()||P[0])}const M={width:s,height:a},T=l.bounds;return M.x=T.x+T.width/2-M.width/2,M.y=T.y+T.height/2-M.height/2,T.width>0&&T.height>0&&(M.x<T.x&&(M.x=T.x),M.y<T.y&&(M.y=T.y),M.x>T.x+T.width&&(M.x=T.x),M.y>T.y+T.height&&(M.y=T.y),M.width>T.width&&(M.width=T.width),M.height>T.height&&(M.height=T.height)),M}async getPerformanceInfo(){try{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,s)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=ve([Y(1,d.IEnvironmentMainService),Y(2,b.ILaunchMainService),Y(3,p.ILogService),Y(4,I.IDiagnosticsService),Y(5,v.IDiagnosticsMainService),Y(6,g.IDialogMainService),Y(7,S.INativeHostMainService),Y(8,c.IProtocolMainService),Y(9,h.IProductService)],o),e.IssueMainService=o}),define(J[261],Z([0,1,22,19,26,21,6,65,20,54,37,47,88]),function(q,e,w,t,k,R,D,y,u,m,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends v.AbstractUpdateService{constructor(E,b,p,S,f,h,c,i){super(E,b,S,f,h,i),this.telemetryService=p,this.nativeHostMainService=c}buildUpdateFeedUrl(E){return(0,v.createUpdateURL)(`linux-${process.arch}`,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(I.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const p=E?b.message||b:void 0;this.setState(I.State.Idle(1,p))}))}async doDownloadUpdate(E){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(I.State.Idle(1))}};g=ve([Y(0,R.ILifecycleMainService),Y(1,t.IConfigurationService),Y(2,C.ITelemetryService),Y(3,k.IEnvironmentMainService),Y(4,m.IRequestService),Y(5,D.ILogService),Y(6,y.INativeHostMainService),Y(7,u.IProductService)],g),e.LinuxUpdateService=g}),define(J[262],Z([0,1,51,29,30,8,22,52,9,7,128,23,19,26,14,21,6,65,20,54,37,47,88]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(a,l=1e3){for(;!a();)await(0,R.timeout)(l)}let n;function r(){return typeof n>"u"&&(n=t.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?0:1),n}let s=class extends i.AbstractUpdateService{constructor(l,P,M,T,F,U,x,re,le){super(l,P,T,F,U,le),this.telemetryService=M,this.fileService=x,this.nativeHostMainService=re}get cachePath(){const l=u.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(l,{recursive:!0}).then(()=>l)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,i.createUpdateURL)(P,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(f.asJson).then(P=>{const M=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>I.Promises.exists(T).then(F=>{if(F)return Promise.resolve(T);const U=P.url,x=P.hash,re=`${T}.tmp`;return this.requestService.request({url:U},D.CancellationToken.None).then(le=>this.fileService.writeFile(m.URI.file(re),le.stream)).then(x?()=>(0,C.checksum)(re,P.hash):()=>{}).then(()=>I.Promises.rename(re,T)).then(()=>T)})).then(T=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},F&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const M=l?P.message||P:void 0;this.setState(c.State.Idle(r(),M))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(r()))}async getUpdatePackagePath(l){const P=await this.cachePath;return u.join(P,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const P=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,M=await this.cachePath,F=(await I.Promises.readdir(M)).filter(P).map(async U=>{try{await I.Promises.unlink(u.join(M,U))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const P=await this.cachePath;this.availableUpdate.updateFilePath=u.join(P,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,x)=>{q(["windows-mutex"],U,x)});o(()=>F.isActive(T)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:l},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([y.memoize],s.prototype,"cachePath",null),s=ve([Y(0,E.ILifecycleMainService),Y(1,v.IConfigurationService),Y(2,h.ITelemetryService),Y(3,g.IEnvironmentMainService),Y(4,f.IRequestService),Y(5,b.ILogService),Y(6,d.IFileService),Y(7,p.INativeHostMainService),Y(8,S.IProductService)],s),e.Win32UpdateService=s}),define(J[263],Z([0,1,15,8,22,44,3,35,2,13,9,71,4,7,172,60,19,56,26,59,14,21,6,20,61,230,90,37,233,64,74,33,27,48,114,122,38,41,53,42]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n,r,s,a,l,P,M,T,F,U,x,re,le,ue,se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(K||(K={}));let $=class Rt extends u.Disposable{constructor(A,W,z,ee,B,H,L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le){super(),this.logService=W,this.environmentMainService=z,this.policyService=ee,this.userDataProfilesService=B,this.fileService=H,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=N,this.themeMainService=V,this.workspacesManagementMainService=Q,this.backupMainService=ne,this.telemetryService=j,this.dialogMainService=te,this.lifecycleMainService=ie,this.productService=ce,this.protocolMainService=fe,this.windowsMainService=ke,this.stateMainService=Le,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Pe,Ae]=this.restoreWindowState(A.state);this.windowState=Pe,this.logService.trace("window#ctor: using window state",Pe);const Ke=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window");let we=!1;typeof me?.experimental?.useSandbox=="boolean"?we=me.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const be={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!Ke,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?be.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):v.isWindows&&!this.environmentMainService.isBuilt&&(be.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.useNativeFullScreen()&&(be.fullscreenable=!1),v.isMacintosh&&(be.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(be.acceptFirstMouse=!1));const X=v.isMacintosh&&me?.nativeTabs===!0;X&&(be.tabbingIdentifier=this.productService.nameShort);const oe=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(oe&&(be.titleBarStyle="hidden",v.isMacintosh||(be.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=re.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";be.titleBarOverlay={height:29,color:he,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(be),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,v.isMacintosh&&oe&&this._win.setSheetOffset(22),oe&&(v.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||v.isMacintosh)){const he=this.stateMainService.getItem(Rt.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}v.isWindows&&oe&&this._win.hookWindowMessage(278,()=>{const[ye,Ce]=this._win.getPosition(),Te=w.screen.getCursorScreenPoint(),Oe=Te.x-ye,Ne=Te.y-Ce;return(()=>!(Oe>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:Ne})),0}),(v.isMacintosh||v.isWindows)&&Ae&&(!X||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Ke&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get previousWorkspace(){return this._previousWorkspace}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){v.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return v.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){v.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return v.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){v.isMacintosh&&A?.force&&w.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){z.dispose(),ee.dispose(),A()}const z=this.onDidClose(()=>W()),ee=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(W,z,ee)=>this.onWindowError(3,{reason:ee,exitCode:z})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),w.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),w.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,z)=>{const ee=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,ee)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(z.response!==1){const ee=z.response===0;this.destroyWindow(ee,z.checkboxChecked)}}else if(A===2){let z;W?z=(0,d.localize)(7,null,W.reason,W.exitCode??"<unknown>"):z=(0,d.localize)(6,null);const ee=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(9,null))],message:z,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),B=ee.response===0;this.destroyWindow(B,ee.checkboxChecked)}break}}async destroyWindow(A,W){const z=this._config?.workspace;if(W&&z)try{const ee=this.storageMainService.workspaceStorage(z);await ee.init(),ee.delete("memento/workbench.parts.editor"),await ee.close()}catch(ee){this.logService.error(ee)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let ee,B;(0,F.isSingleFolderWorkspaceIdentifier)(z)?ee={folderUri:z.uri}:(0,F.isWorkspaceIdentifier)(z)?ee={workspaceUri:z.configPath}:B=!0;const[H]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ee?[ee]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const ee=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||ee!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=ee;const B=z||"",H=ee?`${ee},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(A){v.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this._previousWorkspace=this.openedWorkspace,this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:z?2:1})}updateConfiguration(A,W){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const ee=(0,f.isLaunchedFromCli)(z)&&!(0,f.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(ee||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),A.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,F.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,x.defaultWindowState)();if(this.isFullScreen){let z;try{z=w.screen.getDisplayMatching(this.getBounds())}catch{}const ee=(0,x.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||ee.width,height:this.windowState.height||ee.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!v.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let z;W===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Rt.windowControlHeightStateStorageKey,A.height),v.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):v.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,I.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const z=w.screen.getAllDisplays();W=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[A||(0,x.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let H=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),H(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),H()}return A}if(A.display&&A.mode===3){const B=W.find(H=>H.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,x.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let z,ee;try{z=w.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),ee=this.getWorkingArea(z)}catch{}if(z&&ee&&A.x+A.width>ee.x&&A.y+A.height>ee.y&&A.x<ee.x+ee.width&&A.y<ee.y+ee.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ee),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[z,ee]=this._win.getSize();return{x:A,y:W,width:z,height:ee}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){v.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){v.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...z)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!v.isMacintosh||this.touchBarGroups.forEach((W,z)=>{const ee=A[z];W.segments=this.createTouchBarGroupSegments(ee)})}createTouchBar(){if(!!v.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),z=new w.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:ee=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[ee].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let ee;z.icon&&!l.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===m.Schemas.file&&(ee=w.nativeImage.createFromPath(g.URI.revive(z.icon.dark).fsPath),ee.isEmpty()&&(ee=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:ee?void 0:B,icon:ee}})}dispose(){super.dispose(),this._win=null}};$.windowControlHeightStateStorageKey="windowControlHeight",$=ve([Y(1,i.ILogService),Y(2,S.IEnvironmentMainService),Y(3,le.IPolicyService),Y(4,de.IUserDataProfilesMainService),Y(5,h.IFileService),Y(6,s.IApplicationStorageMainService),Y(7,s.IStorageMainService),Y(8,b.IConfigurationService),Y(9,P.IThemeMainService),Y(10,U.IWorkspacesManagementMainService),Y(11,E.IBackupMainService),Y(12,a.ITelemetryService),Y(13,p.IDialogMainService),Y(14,c.ILifecycleMainService),Y(15,o.IProductService),Y(16,n.IProtocolMainService),Y(17,T.IWindowsMainService),Y(18,ue.IStateMainService)],$),e.CodeWindow=$}),define(J[75],Z([0,1,15,24,8,3,35,2,13,4,16,7,23,175,5,21,6,90,91,27,48]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class nt extends y.Disposable{constructor(o,n,r,s){super(),this.logService=o,this.workspacesManagementMainService=n,this.lifecycleMainService=r,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){const n=[],r=[];for(const s of o)if((0,S.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(n,s.workspace)===-1&&n.push(s);else if((0,S.isRecentFolder)(s))this.indexOfFolder(n,s.folderUri)===-1&&n.push(s);else{const a=this.indexOfFile(r,s.fileUri)>=0,l=s.fileUri.scheme===u.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,C.basename)(s.fileUri))>=0;!a&&!l&&(r.push(s),m.isWindows&&s.fileUri.scheme===u.Schemas.file&&w.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(n,r),n.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=nt.MAX_TOTAL_RECENT_ENTRIES),r.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:r}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const n=l=>{const P=this.location(l);for(const M of o)if(C.extUriBiasedIgnorePathCase.isEqual(M,P))return!1;return!0},r=await this.getRecentlyOpened(),s=r.workspaces.filter(n),a=r.files.filter(n);(s.length!==r.workspaces.length||a.length!==r.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const o=[],n=[];return await this.addEntriesFromStorage(o,n),{workspaces:o,files:n}}async addEntriesFromStorage(o,n){const r=await this.getRecentlyOpenedFromStorage();for(const s of r.workspaces){const a=(0,S.isRecentFolder)(s)?this.indexOfFolder(o,s.folderUri):this.indexOfWorkspace(o,s.workspace);a>=0?o[a].label=o[a].label||s.label:o.push(s)}for(const s of r.files){const a=this.indexOfFile(n,s.fileUri);a>=0?n[a].label=n[a].label||s.label:n.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const n=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{o=JSON.parse(n)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,S.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,S.toStoreData)(o)),-1,1)}location(o){return(0,S.isRecentFolder)(o)?o.folderUri:(0,S.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,n){return o.findIndex(r=>(0,S.isRecentWorkspace)(r)&&r.workspace.id===n.id)}indexOfFolder(o,n){return o.findIndex(r=>(0,S.isRecentFolder)(r)&&C.extUriBiasedIgnorePathCase.isEqual(r.folderUri,n))}indexOfFile(o,n){return o.findIndex(r=>C.extUriBiasedIgnorePathCase.isEqual(r.fileUri,n))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const a of w.app.getJumpListSettings().removedItems){const l=a.args;if(l){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);P&&n.push(I.URI.parse(P[2]))}}await this.removeRecentlyOpened(n);let r=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const l=(0,S.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:M}=this.getWindowsJumpListLabel(l,a.label);let T;return I.URI.isUri(l)?T=`--folder-uri "${l.toString()}"`:(r=!0,T=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&o.push({type:"custom",name:r?(0,g.localize)(2,null):(0,g.localize)(3,null),items:s})}o.push({type:"recent"});try{const n=w.app.setJumpList(o);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(o,n){if(n)return{title:(0,D.splitName)(n).name,description:n};if(I.URI.isUri(o))return{title:(0,C.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,g.localize)(4,null),description:""};let r=(0,C.basename)(o.configPath);return r.endsWith(f.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,r),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,D.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),n=[];let r=0;for(let a=0;a<o.workspaces.length&&r<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const l=this.location(o.workspaces[a]);if(l.scheme===u.Schemas.file){const P=(0,C.originalFSPath)(l);await v.Promises.exists(P)&&(n.push(P),r++)}}const s=[];for(let a=0;a<o.files.length&&r<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const l=this.location(o.files[a]);if(l.scheme===u.Schemas.file){const P=(0,C.originalFSPath)(l);if(nt.COMMON_FILES_FILTER.includes((0,C.basename)(l))||n.includes(P))continue;await v.Promises.exists(P)&&(s.push(P),r++)}}s.reverse().forEach(a=>w.app.addRecentDocument(a)),n.reverse().forEach(a=>w.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([Y(0,b.ILogService),Y(1,h.IWorkspacesManagementMainService),Y(2,E.ILifecycleMainService),Y(3,p.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(J[264],Z([0,1,15,8,22,35,4,7,165,19,26,21,6,210,65,20,41,37,47,74,33,75]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let o=class Lt{constructor(s,a,l,P,M,T,F,U,x,re,le){this.updateService=s,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=F,this.lifecycleMainService=U,this.logService=x,this.nativeHostMainService=re,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Lt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,F,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Lt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=w.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(D.isMacintosh?new w.Menu:null);return}const a=new w.Menu;let l;if(D.isMacintosh){const M=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),a.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new w.Menu;M.append(new w.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:M});this.setMenuById(M,"File"),a.append(T)}if(this.shouldDrawMenu("Edit")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),a.append(T)}if(this.shouldDrawMenu("Selection")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),a.append(T)}if(this.shouldDrawMenu("View")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:M});this.setMenuById(M,"View"),a.append(T)}if(this.shouldDrawMenu("Go")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),a.append(T)}if(this.shouldDrawMenu("Run")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),a.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),a.append(T)}let P;if(this.shouldDrawMenu("Window")){const M=new w.Menu;P=new w.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),a.append(T)}a.items&&a.items.length>0?w.Menu.setApplicationMenu(a):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const a=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ue=new w.Menu;this.setMenuById(ue,"Preferences"),P=new w.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:ue})}const M=new w.Menu,T=new w.MenuItem({label:u.localize(12,null),role:"services",submenu:M}),F=new w.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new w.MenuItem({label:u.localize(15,null),role:"unhide"}),re=new w.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(ue,se,de)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(de)&&this.nativeHostMainService.quit(void 0)}})),le=[a];le.push(...l),P&&le.push(n(),P),le.push(n(),T,n(),F,U,x,n(),re),le.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(s)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(u.localize(17,null)),(0,R.mnemonicButtonLabel)(u.localize(18,null))],message:u.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return P===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,a){a.forEach(l=>{if((0,g.isMenubarMenuItemSeparator)(l))s.append(n());else if((0,g.isMenubarMenuItemSubmenu)(l)){const P=new w.Menu,M=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:P});this.setMenu(P,l.submenu.items),s.append(M)}else(0,g.isMenubarMenuItemRecentAction)(l)?s.append(this.createOpenRecentMenuItem(l)):(0,g.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?s.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):s.append(this.createMenuItem(l.label,l.id,!1,l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(s,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(s,this.menubarMenus[a].items)}insertCheckForUpdatesItems(s){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>s.append(l)),s.append(n()))}createOpenRecentMenuItem(s){const a=y.URI.revive(s.uri),l=s.id,P=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new w.MenuItem(this.likeAction(l,{label:s.label,click:(M,T,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,a,l){const P={label:this.mnemonicLabel(s),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(s){const a=new w.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new w.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(n()),T.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,n(),M,...T,n(),P].forEach(F=>s.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,a,l,P){const M=this.mnemonicLabel(s),T=typeof a=="function"?a:(le,ue,se)=>{const de=le?le.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(se)?a[1]:a[0]),de&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:de}):this.runActionInRenderer({type:"commandId",commandId:K})},F=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,x={label:M,click:T,enabled:F};U&&(x.type="checkbox",x.checked=U);let re;return typeof a=="string"?re=a:Array.isArray(a)&&(re=a[0]),D.isMacintosh&&(re==="editor.action.clipboardCutAction"?x.role="cut":re==="editor.action.clipboardCopyAction"?x.role="copy":re==="editor.action.clipboardPasteAction"&&(x.role="paste"),re==="undo"?x.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?x.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(re,x))}makeContextAwareClickHandler(s,a){return(l,P,M)=>{const T=w.BrowserWindow.getFocusedWindow();if(!T)return a.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return a.inDevTools(T.webContents.devToolsWebContents);s(l,P||T,M)}}runActionInRenderer(s){let a=w.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const P={id:s.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:s.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,a){const l=typeof s=="string"?this.keybindings[s]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(s,a,l=!a.accelerator){l&&(a=this.withKeybinding(s,a));const P=a.click;return a.click=(M,T,F)=>{this.reportMenuActionTelemetry(s),P?.(M,T,F)},a}openUrl(s,a){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:i})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([Y(0,S.IUpdateService),Y(1,m.IConfigurationService),Y(2,h.IWindowsMainService),Y(3,C.IEnvironmentMainService),Y(4,p.ITelemetryService),Y(5,c.IWorkspacesHistoryMainService),Y(6,b.IStateMainService),Y(7,I.ILifecycleMainService),Y(8,v.ILogService),Y(9,d.INativeHostMainService),Y(10,E.IProductService)],o),e.Menubar=o;function n(){return new w.MenuItem({type:"separator"})}}),define(J[265],Z([0,1,5,21,6,264]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let D=class{constructor(u,m,C){this.instantiationService=u,this.lifecycleMainService=m,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(u,m){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(m,u)}};D=ve([Y(0,w.IInstantiationService),Y(1,t.ILifecycleMainService),Y(2,k.ILogService)],D),e.MenubarMainService=D}),define(J[266],Z([0,1,15,29,30,24,22,3,31,49,35,2,13,9,71,4,34,16,12,7,173,60,19,56,26,14,5,21,6,53,20,61,63,41,74,263,116,259,27,117,75,48,64,38,42]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n,r,s,a,l,P,M,T,F,U,x,re,le,ue,se,de,K,$,_,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(H){return(0,se.isWorkspaceIdentifier)(H?.workspace)}function ee(H){return(0,se.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class ut extends I.Disposable{constructor(L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le,Pe,Ae,Ke,me,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=N,this.stateMainService=V,this.policyService=Q,this.environmentMainService=ne,this.userDataProfilesMainService=j,this.lifecycleMainService=te,this.backupMainService=ie,this.configurationService=ce,this.workspacesHistoryMainService=fe,this.workspacesManagementMainService=ke,this.instantiationService=Le,this.dialogMainService=Pe,this.fileService=Ae,this.productService=Ke,this.protocolMainService=me,this.themeMainService=we,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new y.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new I.DisposableStore;if(O.add(y.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const N of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const N=this.environmentMainService.args,V=O?.remoteAuthority||void 0,Q=!0,ne=O?.forceReuseWindow,j=!ne;return this.open({...L,cli:N,forceEmpty:Q,forceNewWindow:j,forceReuseWindow:ne,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],N=[],V=[],Q=[],ne=[];let j,te=0;const ie=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const Pe of ie)ee(Pe)?L.addMode?O.push(Pe):N.push(Pe):z(Pe)?V.push(Pe):Pe.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),j.filesToOpenOrCreate.push(Pe)):Pe.backupPath?ne.push({backupFolder:(0,g.basename)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):te++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Q.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...Q),ne.push(...this.backupMainService.getEmptyWindowBackupPaths())):ne.length=0;const{windows:ce,filesOpenedInWindow:fe}=this.doOpen(L,V,N,ne,te,j,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${N.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${te})`),ce.length>1)if(fe)fe.focus();else{const Pe=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,Ke=!0;if(Pe){const me=ce.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,Ke=!1)}if(Ae)for(let me=ce.length-1;me>=0;me--){const we=ce[me];if(!(we.openedWorkspace&&Q.some(be=>we.openedWorkspace&&be.workspace.id===we.openedWorkspace.id)||we.backupPath&&ne.some(be=>we.backupPath&&be.backupFolder===(0,g.basename)(we.backupPath)))){we.focus(),Ke=!1;break}}Ke&&ce[ce.length-1].focus()}const ke=j&&j.filesToDiff.length>0,Le=j&&j.filesToMerge.length>0;if(!ce.some(Pe=>Pe.isExtensionDevelopmentHost)&&!ke&&!Le&&!L.noRecentEntry){const Pe=[];for(const Ae of ie)z(Ae)&&!Ae.transient?Pe.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):ee(Ae)?Pe.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Pe.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Pe)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const N=L.waitMarkerFileURI;L.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(L,O,N,V,Q,ne,j){const te=[];let ie;function ce(me,we){te.push(me),we&&(ie=me,ne=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const me=j[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(me);we&&ce(this.doAddFoldersToExistingWindow(we,j.map(be=>be.workspace.uri)))}const Le=N.length+O.length+V.length;if(ne&&Le===0){const me=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],we=this.getWindows().filter(X=>ne&&(0,p.isEqualAuthority)(X.remoteAuthority,ne.remoteAuthority));let be;me?.fileUri&&!ke&&((L.context===4||L.context===0||L.context===1)&&(be=(0,le.findWindowOnFile)(we,me.fileUri,X=>X.configPath.scheme===v.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(X.configPath):void 0)),be||(be=this.doGetLastActiveWindow(we))),be?(0,se.isWorkspaceIdentifier)(be.openedWorkspace)?O.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?N.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,be,ne),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Pe=(0,R.distinct)(O,me=>me.workspace.id);if(Pe.length>0){const me=(0,R.coalesce)(Pe.map(we=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],be=(0,p.isEqualAuthority)(ne?.remoteAuthority,we.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,we,be),!!be),fe=!0}Pe.forEach(we=>{if(me.some(oe=>oe.openedWorkspace&&oe.openedWorkspace.id===we.workspace.id))return;const be=we.remoteAuthority,X=(0,p.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,we,fe,X),!!X),fe=!0})}const Ae=(0,R.distinct)(N,me=>p.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(we=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],be=(0,p.isEqualAuthority)(ne?.remoteAuthority,we.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,we,be),!!be),fe=!0}Ae.forEach(we=>{if(me.some(oe=>(0,se.isSingleFolderWorkspaceIdentifier)(oe.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(oe.openedWorkspace.uri,we.workspace.uri)))return;const be=we.remoteAuthority,X=(0,p.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,we,fe,X),!!X),fe=!0})}const Ke=(0,R.distinct)(V,me=>me.backupFolder);if(Ke.length>0&&Ke.forEach(me=>{const we=me.remoteAuthority,be=(0,p.isEqualAuthority)(ne?.remoteAuthority,we)?ne:void 0;ce(this.doOpenEmpty(L,!0,we,be,me),!!be),fe=!0}),te.length===0||ne){ne&&!Q&&Q++;const me=ne?ne.remoteAuthority:L.remoteAuthority;for(let we=0;we<Q;we++)ce(this.doOpenEmpty(L,fe,me,ne),!!ne),fe=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(L,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const V={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const N={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,N),L}doOpenEmpty(L,O,N,V,Q){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:N,filesToOpen:V,forceNewWindow:O});let ne;return!O&&typeof L.contextWindowId=="number"&&(ne=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ne,emptyWindowBackupInfo:Q})}doOpenFolderOrWorkspace(L,O,N,V,Q){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!N&&!Q&&typeof L.contextWindowId=="number"&&(Q=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:Q,userDataProfileInfo:O.userDataProfileInfo})}getPathsToOpen(L){let O,N=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),N=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&N){const Q=O.filter(ne=>ee(ne));if(Q.length>1){const ne=Q[0].remoteAuthority;if(Q.every(j=>(0,p.isEqualAuthority)(j.remoteAuthority,ne))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(Q.map(te=>({uri:te.workspace.uri})));O.push({workspace:j,remoteAuthority:ne}),O=O.filter(te=>!ee(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(Q=>z(Q)||ee(Q)||Q.backupPath)),O}doExtractPathsFromAPI(L){const O=[],N={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const Q=this.resolveOpenable(V,N);if(Q)Q.label=V.label,O.push(Q);else{const ne=this.resourceFromOpenable(V),j={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:ne.scheme===v.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:ne.scheme===v.Schemas.file?(0,h.localize)(3,null,(0,C.getPathLabel)(ne,{os:E.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,ne.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,S.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const j of V){const te=this.cliArgToUri(j);if(te){const ie=this.resolveOpenable({folderUri:te},N);ie&&O.push(ie)}}const Q=L["file-uri"];if(Q)for(const j of Q){const te=this.cliArgToUri(j);if(te){const ie=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(j)?{workspaceUri:te}:{fileUri:te},N);ie&&O.push(ie)}}const ne=L._;for(const j of ne){const te=N.remoteAuthority?this.doResolvePathRemote(j,N):this.doResolveFilePath(j,N);te&&O.push(te)}if(L.profile)for(const j of O)j.userDataProfileInfo={name:L.profile};return O}cliArgToUri(L){try{const O=f.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const V of O)if(V.workspace){const Q=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});z(Q)&&N.push(Q)}else if(V.folderUri){const Q=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});ee(Q)&&N.push(Q)}else L!=="folders"&&V.backupPath&&N.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return N}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const N=this.resourceFromOpenable(L);return N.scheme===v.Schemas.file?((0,x.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let N=this.resourceFromOpenable(L);const V=(0,F.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(N)),(0,x.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Q,line:ne,column:j}=(0,u.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:Q}),options:{selection:ne?{startLineNumber:ne,startColumn:j||1}:void 0},remoteAuthority:V}}return{fileUri:N,remoteAuthority:V}}else if((0,x.isWorkspaceToOpen)(L))return{workspace:(0,de.getWorkspaceIdentifier)(N),remoteAuthority:V};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:V}}resourceFromOpenable(L){return(0,x.isWorkspaceToOpen)(L)?L.workspaceUri:(0,x.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let N,V;O.gotoLineMode&&({path:L,line:N,column:V}=(0,u.parseLineAndColumnAware)(L)),L=(0,u.sanitizeFilePath)((0,g.normalize)(L),(0,b.cwd)());try{const Q=(0,t.statSync)(L);if(Q.isFile()){if(!O.forceOpenWorkspaceAsFile){const ne=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.URI.file(L));if(ne)return ne.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:r.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:f.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:V||1}:void 0}}}else{if(Q.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),Q),type:r.FileType.Directory,exists:!0};if(!E.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const ne=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ne]),O.ignoreFileNotFound)return{fileUri:ne,type:r.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const N=L.charCodeAt(0),V=O.remoteAuthority;let Q,ne;O.gotoLineMode&&({path:L,line:Q,column:ne}=(0,u.parseLineAndColumnAware)(L)),N!==47&&((0,u.isWindowsDriveLetter)(N)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,u.toSlashes)(L)),L=`/${L}`);const j=f.URI.from({scheme:v.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:V};if(O.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0},remoteAuthority:V}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let Q=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(N==="on"||N==="off")&&(Q=N==="on");let ne=!1;return L.forceNewWindow||L.forceReuseWindow?ne=!!L.forceNewWindow&&!L.forceReuseWindow:(E.isMacintosh?L.context===1&&(ne=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ne=V==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:ne}}openExtensionDevelopmentHostWindow(L,O){const N=(0,le.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let V=O.cli["folder-uri"]||[],Q=O.cli["file-uri"]||[],ne=O.cli._;if(!ne.length&&!V.length&&!Q.length&&!O.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,fe=ce&&(ce.workspace||ce.folderUri);fe&&(f.URI.isUri(fe)?fe.scheme===v.Schemas.file?ne=[fe.fsPath]:V=[fe.toString()]:fe.configPath.scheme===v.Schemas.file?ne=[(0,p.originalFSPath)(fe.configPath)]:Q=[fe.configPath.toString()])}let j=O.remoteAuthority;for(const ce of L)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const fe=f.URI.parse(ce),ke=(0,F.getRemoteAuthority)(fe);ke&&(j?(0,p.isEqualAuthority)(ke,j)||this.logService.error("more than one extension development path authority"):j=ke)}ne=ne.filter(ce=>{const fe=f.URI.file(ce);return(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(fe),j)}),V=V.filter(ce=>{const fe=this.cliArgToUri(ce);return fe&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(fe),j):!1}),Q=Q.filter(ce=>{const fe=this.cliArgToUri(ce);return fe&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(fe),j):!1}),O.cli._=ne,O.cli["folder-uri"]=V,O.cli["file-uri"]=Q;const te=!ne.length&&!V.length&&!Q.length,ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const Q=V.config;!N.extensionDevelopmentPath&&Q&&!!Q.extensionDevelopmentPath&&(N.extensionDevelopmentPath=Q.extensionDevelopmentPath,N.extensionDevelopmentKind=Q.extensionDevelopmentKind,N["enable-proposed-api"]=Q["enable-proposed-api"],N.verbose=Q.verbose,N["inspect-extensions"]=Q["inspect-extensions"],N["inspect-brk-extensions"]=Q["inspect-brk-extensions"],N.debugId=Q.debugId,N.extensionEnvironment=Q.extensionEnvironment,N["extensions-dir"]=Q["extensions-dir"],N["disable-extensions"]=Q["disable-extensions"])}else{const Q=this.windowsStateHandler.getNewWindowState(N);(0,d.mark)("code/willCreateCodeWindow");const ne=V=this.instantiationService.createInstance(re.CodeWindow,{state:Q,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),ut.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,m.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,m.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne)),ne.onDidTriggerSystemContextMenu(({x:te,y:ie})=>this._onDidTriggerSystemContextMenu.fire({window:ne,x:te,y:ie}));const j=(0,S.assertIsDefined)(ne.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return N.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(Q=>{Q||this.doOpenInBrowserWindow(V,N,L)}):this.doOpenInBrowserWindow(V,N,L),V}resolveProfileForBrowserWindow(L){let O;return L.userDataProfileInfo&&(O=this.userDataProfilesMainService.profiles.find(N=>N.name===L.userDataProfileInfo.name),O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O)),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}doOpenInBrowserWindow(L,O,N){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,O.remoteAuthority)}L.load(O)}onWindowClosed(L){const O=ut.WINDOWS.indexOf(L);ut.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=w.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(N=>N.lastFocusTime));return L.find(N=>N.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,N){for(const V of this.getWindows())N&&N.indexOf(V.id)>=0||V.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(N=>N.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=w.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([Y(2,l.ILogService),Y(3,U.IStateMainService),Y(4,A.IPolicyService),Y(5,n.IEnvironmentMainService),Y(6,W.IUserDataProfilesMainService),Y(7,a.ILifecycleMainService),Y(8,c.IBackupMainService),Y(9,i.IConfigurationService),Y(10,K.IWorkspacesHistoryMainService),Y(11,$.IWorkspacesManagementMainService),Y(12,s.IInstantiationService),Y(13,o.IDialogMainService),Y(14,r.IFileService),Y(15,M.IProductService),Y(16,T.IProtocolMainService),Y(17,_.IThemeMainService)],B),e.WindowsMainService=B}),define(J[267],Z([0,1,60,33,75,48]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(u,m,C,I){this.workspacesManagementMainService=u,this.windowsMainService=m,this.workspacesHistoryMainService=C,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,m){const C=this.windowsMainService.getWindowById(u);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(u,m,C){return this.workspacesManagementMainService.createUntitledWorkspace(m,C)}deleteUntitledWorkspace(u,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(u,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(u,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([Y(0,R.IWorkspacesManagementMainService),Y(1,t.IWindowsMainService),Y(2,k.IWorkspacesHistoryMainService),Y(3,w.IBackupMainService)],D),e.WorkspacesMainService=D}),define(J[268],Z([0,1,15,40,29,30,17,44,18,31,49,43,35,2,13,9,4,12,7,28,81,132,45,146,99,245,149,60,250,19,69,182,84,118,56,102,180,26,59,110,193,213,194,247,103,195,196,14,206,86,68,5,85,260,224,119,21,6,208,265,65,20,63,254,87,41,251,90,111,37,229,231,73,47,236,237,261,238,262,113,240,241,242,243,248,33,266,249,27,91,75,267,48,246,38,212,42,257,220,54,72,89,252,258,8]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n,r,s,a,l,P,M,T,F,U,x,re,le,ue,se,de,K,$,_,A,W,z,ee,B,H,L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le,Pe,Ae,Ke,me,we,be,X,oe,he,ye,Ce,Te,Oe,Ne,ze,$e,Be,qe,G,ae,pe,ge,Se,De,We,Qe,tt,Ge,Ye,it,ot,ht,Ft,_t,Ct,Ut,Nt,Bt,At,zt,$t,qt,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let It=class extends g.Disposable{constructor(Ee,Me,Re,Ie,Fe,xe,je,He,Ue,Ve,_e){super(),this.mainProcessNodeIpcServer=Ee,this.userEnv=Me,this.mainInstantiationService=Re,this.logService=Ie,this.environmentMainService=Fe,this.lifecycleMainService=xe,this.configurationService=je,this.stateMainService=He,this.fileService=Ue,this.productService=Ve,this.userDataProfilesMainService=_e,this.configureSession(),this.registerListeners()}configureSession(){const Ee=Ue=>Ue?.startsWith(`${d.Schemas.vscodeWebview}://`),Me=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ue,Ve,_e,Je)=>Ee(Je.requestingUrl)?_e(Me.has(Ve)):_e(!1)),w.session.defaultSession.setPermissionCheckHandler((Ue,Ve,_e,Je)=>Ee(Je.requestingUrl)?Me.has(Ve):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ue=>{for(let Ve=Ue;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ue=>Ue.resourceType==="xhr"||Ie(Ue.frame),xe=Ue=>{const Ve=Ue.frame;if(!Ve||!this.windowsMainService)return!1;const _e=w.BrowserWindow.getAllWindows();for(const Je of _e)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},je=(Ue,Ve)=>{if(Ue.path!=="/index.html")return!0;const _e=Ve.frame;if(!_e||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&_e.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ue,Ve)=>{const _e=S.URI.parse(Ue.url);return _e.scheme===d.Schemas.vscodeWebview&&!je(_e,Ue)?(this.logService.error("Blocked vscode-webview request",Ue.url),Ve({cancel:!0})):_e.scheme===d.Schemas.vscodeFileResource&&!xe(Ue)?(this.logService.error("Blocked vscode-file request",Ue.url),Ve({cancel:!0})):_e.path.endsWith(".svg")&&!Re.has(_e.scheme)?Ve({cancel:!Fe(Ue)}):Ve({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ue,Ve)=>{const _e=Ue.responseHeaders,Je=_e["content-type"]||_e["Content-Type"];if(Je&&Array.isArray(Je)){const st=S.URI.parse(Ue.url);if(st.path.endsWith(".svg")&&Re.has(st.scheme))return _e["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:_e});if(!st.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(dt=>dt.toLowerCase().includes("image/svg")))return Ve({cancel:!Fe(Ue)})}return Ve({cancel:!1})});const He=w.session.defaultSession;typeof He.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&He.setCodeCachePath((0,E.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,u.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,u.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,u.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Re,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),w.app.on("activate",(Re,Ie)=>{this.logService.trace("app#activate"),Ie||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",Fe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.nativeHostMainService?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Me;w.app.on("open-file",(Re,Ie)=>{this.logService.trace("app#open-file: ",Ie),Re.preventDefault(),Ee.push(this.getWindowOpenableFromPathSync(Ie)),Me!==void 0&&(clearTimeout(Me),Me=void 0),Me=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Me=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.windowsMainService?.getWindowByWebContents(Re.sender);let Fe,xe;return Ie?.config?(Fe=Ie.config,xe={...process.env,...Ie.config.userEnv}):(Fe=this.environmentMainService.args,xe=process.env),this.resolveShellEnvironment(Fe,xe,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,Fe)=>{const xe=this.validateNlsPath([Ie]);if(!xe||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(xe,D.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const Fe=this.validateNlsPath(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(Ee){let Me;for(const Re of Ee)typeof Re=="string"&&(typeof Me!="string"?Me=Re:Me=(0,E.join)(Me,Re));if(!(typeof Me!="string"||!(0,E.isAbsolute)(Me)||!(0,m.isEqualOrParent)(Me,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return S.URI.file(Me)}onUnexpectedError(Ee){if(Ee){const Me={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.logService.error(Ee.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ee=this.productService.win32AppUserModelId;b.isWindows&&Ee&&w.app.setAppUserModelId(Ee);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Me=new o.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Me.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:xe}=this.setupSharedProcess(Re),je=await this.initServices(Re,Ie,Fe);this.setUpHandlers(je);const He=this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);He&&await He,je.invokeFunction(_e=>this.initChannels(_e,Me,xe));const Ue=je.invokeFunction(_e=>this.openFirstWindow(_e,Me));je.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this.environmentMainService.args.trace&&je.invokeFunction(_e=>this.stopTracingEventually(_e,Ue)),this._register(new Tt.RunOnceScheduler(()=>{this._register((0,Tt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(Ee){this._register(Ee.createInstance(r.ProxyAuthHandler)),this._register(Ee.createInstance(Ut.DefaultExtensionsProfileInitHandler)),this._register(Ee.createInstance(qt.UserDataTransientProfilesHandler))}async resolveMachineId(){let Ee=this.stateMainService.getItem(oe.machineIdKey);return(!Ee||b.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,h.getMachineId)(),this.stateMainService.setItem(oe.machineIdKey,Ee)),Ee}setupSharedProcess(Ee){const Me=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,Ee,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Fe=await Me.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new n.Client(Fe,"main")})(),Ie=(async()=>(await Me.whenReady(),Re))();return{sharedProcess:Me,sharedProcessReady:Ie,sharedProcessClient:Re}}async initServices(Ee,Me,Re){const Ie=new V.ServiceCollection;switch(process.platform){case"win32":Ie.set(Te.IUpdateService,new O.SyncDescriptor(Be.Win32UpdateService));break;case"linux":b.isLinuxSnap?Ie.set(Te.IUpdateService,new O.SyncDescriptor($e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Te.IUpdateService,new O.SyncDescriptor(ze.LinuxUpdateService));break;case"darwin":Ie.set(Te.IUpdateService,new O.SyncDescriptor(Ne.DarwinUpdateService));break}Ie.set(De.IWindowsMainService,new O.SyncDescriptor(We.WindowsMainService,[Ee,this.userEnv])),Ie.set(x.IDialogMainService,new O.SyncDescriptor(x.DialogMainService)),Ie.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService)),Ie.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService)),Ie.set(F.IDiagnosticsService,i.ProxyChannel.toService((0,i.getDelayedChannel)(Re.then(xe=>xe.getChannel("diagnostics"))))),Ie.set(Q.IIssueMainService,new O.SyncDescriptor(Q.IssueMainService,[this.userEnv])),Ie.set(re.IEncryptionMainService,new O.SyncDescriptor(le.EncryptionMainService,[Ee])),Ie.set(ne.IKeyboardLayoutMainService,new O.SyncDescriptor(ne.KeyboardLayoutMainService)),Ie.set(ke.INativeHostMainService,new O.SyncDescriptor(ke.NativeHostMainService,[Me])),Ie.set(M.ICredentialsMainService,new O.SyncDescriptor(ht.CredentialsNativeMainService)),Ie.set(ge.IWebviewManagerService,new O.SyncDescriptor(Se.WebviewMainService)),Ie.set(Ge.IWorkspacesService,new O.SyncDescriptor(it.WorkspacesMainService)),Ie.set(ot.IWorkspacesManagementMainService,new O.SyncDescriptor(ot.WorkspacesManagementMainService)),Ie.set(Ye.IWorkspacesHistoryMainService,new O.SyncDescriptor(Ye.WorkspacesHistoryMainService)),Ie.set(fe.IMenubarMainService,new O.SyncDescriptor(fe.MenubarMainService)),Ie.set(K.IExtensionUrlTrustService,new O.SyncDescriptor($.ExtensionUrlTrustService)),Ie.set(_.IExtensionHostStarter,new O.SyncDescriptor(A.ExtensionHostStarter)),Ie.set(be.IStorageMainService,new O.SyncDescriptor(be.StorageMainService)),Ie.set(be.IApplicationStorageMainService,new O.SyncDescriptor(be.ApplicationStorageMainService)),b.isWindows?Ie.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.WindowsExternalTerminalService)):b.isMacintosh?Ie.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.MacExternalTerminalService)):b.isLinux&&Ie.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.LinuxExternalTerminalService));const Fe=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Ie.set(a.IBackupMainService,Fe),Ie.set(qe.IURLService,new O.SyncDescriptor(ae.NativeURLService)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const xe=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),je=(0,i.getDelayedChannel)(Re.then(Je=>Je.getChannel("telemetryAppender"))),He=new he.TelemetryAppenderClient(je),Ue=(0,X.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,Ee,xe,this.environmentMainService.installSourcePath),Ve=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),_e={appenders:[He],commonProperties:Ue,piiPaths:Ve,sendErrorTelemetry:!0};Ie.set(oe.ITelemetryService,new O.SyncDescriptor(ye.TelemetryService,[_e]))}else Ie.set(oe.ITelemetryService,Ce.NullTelemetryService);return Ie.set(At.IExtensionsProfileScannerService,new O.SyncDescriptor(At.ExtensionsProfileScannerService)),Ie.set(zt.IExtensionsScannerService,new O.SyncDescriptor($t.ExtensionsScannerService)),await Fe.initialize(),this.mainInstantiationService.createChild(Ie)}initChannels(Ee,Me,Re){const Ie=i.ProxyChannel.fromService(Ee.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const Fe=i.ProxyChannel.fromService(Ee.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Fe);const xe=new _t.PolicyChannel(Ee.get(Ft.IPolicyService));Me.registerChannel("policy",xe),Re.then(et=>et.registerChannel("policy",xe));const je=this.fileService.getProvider(d.Schemas.file);(0,p.assertType)(je instanceof L.DiskFileSystemProvider);const He=new H.DiskFileSystemProviderChannel(je,this.logService,this.environmentMainService);Me.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He),Re.then(et=>et.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He));const Ue=i.ProxyChannel.fromService(Ee.get(Ct.IUserDataProfilesMainService));Me.registerChannel("userDataProfiles",Ue),Re.then(et=>et.registerChannel("userDataProfiles",Ue));const Ve=new Nt.RequestChannel(Ee.get(Bt.IRequestService));Re.then(et=>et.registerChannel("request",Ve));const _e=new Oe.UpdateChannel(Ee.get(Te.IUpdateService));Me.registerChannel("update",_e);const Je=i.ProxyChannel.fromService(Ee.get(Q.IIssueMainService));Me.registerChannel("issue",Je);const st=i.ProxyChannel.fromService(Ee.get(re.IEncryptionMainService));Me.registerChannel("encryption",st);const dt=i.ProxyChannel.fromService(Ee.get(M.ICredentialsMainService));Me.registerChannel("credentials",dt);const Pt=i.ProxyChannel.fromService(Ee.get(Ke.ISignService));Me.registerChannel("sign",Pt);const Ze=i.ProxyChannel.fromService(Ee.get(ne.IKeyboardLayoutMainService));Me.registerChannel("keyboardLayout",Ze),this.nativeHostMainService=Ee.get(ke.INativeHostMainService);const ft=i.ProxyChannel.fromService(this.nativeHostMainService);Me.registerChannel("nativeHost",ft),Re.then(et=>et.registerChannel("nativeHost",ft));const gt=i.ProxyChannel.fromService(Ee.get(Ge.IWorkspacesService));Me.registerChannel("workspaces",gt);const mt=i.ProxyChannel.fromService(Ee.get(fe.IMenubarMainService));Me.registerChannel("menubar",mt);const vt=i.ProxyChannel.fromService(Ee.get(qe.IURLService));Me.registerChannel("url",vt);const St=i.ProxyChannel.fromService(Ee.get(K.IExtensionUrlTrustService));Me.registerChannel("extensionUrlTrust",St);const pt=i.ProxyChannel.fromService(Ee.get(ge.IWebviewManagerService));Me.registerChannel("webview",pt);const at=this._register(new we.StorageDatabaseChannel(this.logService,Ee.get(be.IStorageMainService)));Me.registerChannel("storage",at),Re.then(et=>et.registerChannel("storage",at));const yt=i.ProxyChannel.fromService(Ee.get(W.IExternalTerminalMainService));Me.registerChannel("externalTerminal",yt);const Xe=new ce.LogLevelChannel(Ee.get(ie.ILogService));Me.registerChannel("logLevel",Xe),Re.then(et=>et.registerChannel("logLevel",Xe));const rt=new ce.LoggerChannel(Ee.get(ie.ILoggerService));Me.registerChannel("logger",rt),Re.then(et=>et.registerChannel("logger",rt));const ct=new T.ElectronExtensionHostDebugBroadcastChannel(Ee.get(De.IWindowsMainService),Ee.get(Ct.IUserDataProfilesMainService));Me.registerChannel("extensionhostdebugservice",ct);const wt=i.ProxyChannel.fromService(Ee.get(_.IExtensionHostStarter));Me.registerChannel(_.ipcExtensionHostStarterChannelName,wt)}openFirstWindow(Ee,Me){const Re=this.windowsMainService=Ee.get(De.IWindowsMainService),Ie=Ee.get(qe.IURLService),Fe=Ee.get(ke.INativeHostMainService);this.lifecycleMainService.phase=2;const xe=[],je=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Xe=>{try{return{uri:S.URI.parse(Xe),url:Xe}}catch{return}}).filter(Xe=>{if(!Xe||this.shouldBlockURI(Xe.uri))return!1;const rt=this.getWindowOpenableFromProtocolLink(Xe.uri);return rt?(xe.push(rt),!1):!0}),He=this,Ue=this.environmentMainService,Ve=this.productService,_e=this.logService;Ie.registerHandler({async handleURL(Xe,rt){if(_e.trace("app#handleURL: ",Xe.toString(!0),rt),Xe.scheme===Ve.urlProtocol&&Xe.path==="workspace"&&(Xe=Xe.with({authority:"file",path:S.URI.parse(Xe.query).path,query:""})),He.shouldBlockURI(Xe))return!0;let ct=!1;const wt=new URLSearchParams(Xe.query);wt.get("windowId")==="_blank"&&(wt.delete("windowId"),Xe=Xe.with({query:wt.toString()}),ct=!0),ct||=b.isMacintosh&&Re.getWindowCount()===0;const et=He.getWindowOpenableFromProtocolLink(Xe);if(_e.trace("app#handleURL: windowOpenableFromProtocolLink = ",et),et){const[kt]=Re.open({context:5,cli:{...Ue.args},urisToOpen:[et],forceNewWindow:ct,gotoLineMode:!0});return kt.focus(),!0}if(ct){const[kt]=Re.open({context:5,cli:{...Ue.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Pe.getRemoteAuthority)(Xe)});return await kt.ready(),Ie.open(Xe,rt)}return!1}});const Je=this._register(new Qe.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new i.StaticRouter(Xe=>Je.getActiveClientId().then(rt=>Xe===rt)),dt=new G.URLHandlerRouter(st),Pt=Me.getChannel("urlHandler",dt);Ie.registerHandler(new G.URLHandlerChannelClient(Pt)),this._register(new pe.ElectronURLListener(je,Ie,Re,this.environmentMainService,this.productService));const Ze=this.environmentMainService.args,ft=global.macOpenFiles,gt=(0,se.isLaunchedFromCli)(process.env)?0:4,mt=Ze._.length,vt=!!Ze["folder-uri"],St=!!Ze["file-uri"],pt=Ze["skip-add-to-recently-opened"]===!0,at=Ze.wait&&Ze.waitMarkerFilePath?S.URI.file(Ze.waitMarkerFilePath):void 0,yt=Ze.remote||void 0;return xe.length>0?Re.open({context:gt,cli:Ze,urisToOpen:xe,gotoLineMode:!0,initialStartup:!0}):Ze["new-window"]&&!mt&&!vt&&!St?Re.open({context:gt,cli:Ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:pt,waitMarkerFileURI:at,initialStartup:!0,remoteAuthority:yt}):ft.length&&!mt&&!vt&&!St?Re.open({context:1,cli:Ze,urisToOpen:ft.map(Xe=>this.getWindowOpenableFromPathSync(Xe)),noRecentEntry:pt,waitMarkerFileURI:at,initialStartup:!0}):Re.open({context:gt,cli:Ze,forceNewWindow:Ze["new-window"]||!mt&&Ze["unity-launch"],diffMode:Ze.diff,mergeMode:Ze.merge,noRecentEntry:pt,waitMarkerFileURI:at,gotoLineMode:Ze.goto,initialStartup:!0,remoteAuthority:yt})}shouldBlockURI(Ee){return!!(Ee.authority===d.Schemas.file&&b.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,v.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,v.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,v.getPathLabel)(Ee,{os:b.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(Ee){if(!!Ee.path){if(Ee.authority===d.Schemas.file){const Me=S.URI.file(Ee.fsPath);return(0,tt.hasWorkspaceFileExtension)(Me)?{workspaceUri:Me}:{fileUri:Me}}else if(Ee.authority===d.Schemas.vscodeRemote){const Me=Ee.path.indexOf(E.posix.sep,1);if(Me!==-1){const Re=Ee.path.substring(1,Me),Ie=Ee.path.substring(Me),Fe=S.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,tt.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}getWindowOpenableFromPathSync(Ee){try{if((0,k.statSync)(Ee).isDirectory())return{folderUri:S.URI.file(Ee)};if((0,tt.hasWorkspaceFileExtension)(Ee))return{workspaceUri:S.URI.file(Ee)}}catch{}return{fileUri:S.URI.file(Ee)}}async afterWindowOpen(Ee,Me){this.lifecycleMainService.phase=3;let Re=!1;(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0);const Ie=Ee.get(oe.ITelemetryService);this._register(Me.onDidError(({type:je,details:He})=>{let Ue;switch(je){case 1:Ue="SharedProcess: detected unresponsive window";break;case 2:Ue=`SharedProcess: crashed (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break;case 3:Ue=`SharedProcess: failed to load (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break}(0,u.onUnexpectedError)(new Error(Ue)),Ie.publicLog2("sharedprocesserror",{type:je,reason:He?.reason,code:He?.exitCode,visible:Me.isVisible(),shuttingdown:Re})}));const Fe=this.productService.win32MutexName;if(b.isWindows&&Fe)try{const je=q.__$__nodeRequire("windows-mutex").Mutex,He=new je(Fe);(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>He.release())}catch(je){this.logService.error(je)}w.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(je,He)=>{He({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})});const xe=Ee.get(Te.IUpdateService);(xe instanceof Be.Win32UpdateService||xe instanceof ze.LinuxUpdateService||xe instanceof Ne.DarwinUpdateService)&&await xe.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const He=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,I.stripComments)(He))["enable-crash-reporter"]===void 0){const _e=(0,Ce.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],st=He.substring(0,He.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(st))}}catch(je){this.logService.error(je)}}async resolveShellEnvironment(Ee,Me,Re){try{return await(0,de.getResolvedShellEnv)(this.logService,Ee,Me)}catch(Ie){const Fe=(0,y.toErrorMessage)(Ie);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.logService.error(Fe)}return{}}stopTracingEventually(Ee,Me){this.logService.info("Tracing: waiting for windows to get ready...");const Re=Ee.get(x.IDialogMainService);let Ie=!1;const Fe=async je=>{if(Ie)return;Ie=!0;const He=await w.contentTracing.stopRecording(`${(0,m.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);je?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${He}`):Re.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,He),buttons:[(0,v.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},xe=setTimeout(()=>Fe(!0),3e4);Promise.all(Me.map(je=>je.ready())).then(()=>{clearTimeout(xe),Fe(!1)})}};It=ve([Y(2,N.IInstantiationService),Y(3,ie.ILogService),Y(4,ue.IEnvironmentMainService),Y(5,te.ILifecycleMainService),Y(6,P.IConfigurationService),Y(7,me.IStateMainService),Y(8,B.IFileService),Y(9,Le.IProductService),Y(10,Ct.IUserDataProfilesMainService)],It),e.CodeApplication=It}),define(J[269],Z([0,1,38,8,277,2]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends w.AbstractPolicyService{constructor(u){super(),this.productName=u,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(u){await this.throttler.queue(()=>new Promise((m,C)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,u,I=>{for(const v in I){const g=I[v];g===void 0?this.policies.delete(v):this.policies.set(v,g)}this._onDidChange.fire(Object.keys(I)),m()})}catch(I){C(I)}}))}}e.NativePolicyService=D}),define(J[270],Z([0,1,222,8,17,18,2,12,19,36,110,6,221,278]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(b,p,S){super(),this.environmentService=p,this.logService=S,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:S,strictSSL:f}=this;let h;try{h=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const c={...process.env,...h},i=b.agent?b.agent:await(0,v.getProxyAgent)(b.url||"",c,{proxyUrl:S,strictSSL:f});b.agent=i,b.strictSSL=f,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(b,p);return this.logService.trace("RequestService#request (node) - success",b.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",b.url,o),o}}async getNodeRequest(b){return((0,w.parse)(b.url).protocol==="https:"?await new Promise((f,h)=>{q(["https"],f,h)}):await new Promise((f,h)=>{q(["http"],f,h)})).request}_request(b,p){return t.Promises.withAsyncBody(async(S,f)=>{const h=(0,w.parse)(b.url),c=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),i={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,y.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const o=c(i,n=>{const r=(0,y.isNumber)(b.followRedirects)?b.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request({...b,url:n.headers.location,followRedirects:r-1},p).then(S,f);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,g.createGunzip)())),S({res:n,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",f),b.timeout&&o.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),p.onCancellationRequested(()=>{o.abort(),f(new R.CancellationError)})})}async resolveProxy(b){}};d=ve([Y(0,u.IConfigurationService),Y(1,m.INativeEnvironmentService),Y(2,I.ILogService)],d),e.RequestService=d}),define(J[271],Z([0,1,15,270]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return w.net.request}class R extends t.RequestService{request(y,u){return super.request({...y||{},getRawRequest:k},u)}}e.RequestMainService=R}),define(J[279],Z([0,1,15,29,7,24,8,44,18,31,49,35,13,9,71,4,34,25,23,45,83,268,10,19,216,228,26,59,185,14,204,86,68,201,85,21,105,6,209,106,53,20,61,253,112,234,54,271,87,223,41,227,73,64,42,38,269,211,2,55,239,39,235]),function(q,e,w,t,k,R,D,y,u,m,C,I,v,g,d,E,b,p,S,f,h,c,i,o,n,r,s,a,l,P,M,T,F,U,x,re,le,ue,se,de,K,$,_,A,W,z,ee,B,H,L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.startup()}catch(me){console.error(me.message),w.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,we,be,X,oe,he,ye,Ce]=this.createServices();try{try{await this.initServices(be,Ce,X,oe,ye)}catch(Te){throw this.handleStartupDataDirError(be,ye.nameLong,Te),Te}await me.invokeFunction(async Te=>{const Oe=Te.get(ue.ILogService),Ne=Te.get(re.ILifecycleMainService),ze=Te.get(P.IFileService),$e=await this.claimInstance(Oe,be,Ne,me,ye,!0);return S.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(Be=>{Oe.warn(`Error writing main lockfile: ${Be.stack}`)}),he.logger=new de.SpdLogLogger("main",(0,g.join)(be.logsPath,"main.log"),!0,!1,he.getLevel()),(0,C.once)(Ne.onWillShutdown)(Be=>{ze.dispose(),X.dispose(),Be.join(S.Promises.unlink(be.mainLockfile).catch(()=>{}))}),me.createInstance(c.CodeApplication,$e,we).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new x.ServiceCollection,we=new ce.DisposableStore;process.once("exit",()=>we.dispose());const be={_serviceBrand:void 0,...K.default};me.set($.IProductService,be);const X=new s.EnvironmentMainService(this.resolveArgs(),be),oe=this.patchEnvironment(X);me.set(s.IEnvironmentMainService,X);const he=new le.BufferLogService,ye=we.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(X)),he]));me.set(ue.ILogService,ye);const Ce=new M.FileService(ye);me.set(P.IFileService,Ce);const Te=new T.DiskFileSystemProvider(ye);Ce.registerProvider(v.Schemas.file,Te);const Oe=new ke.UriIdentityService(Ce);me.set(fe.IUriIdentityService,Oe),me.set(ue.ILoggerService,new se.LoggerService(ye,Ce));const Ne=new N.StateMainService(X,ye,Ce);me.set(O.IStateMainService,Ne);const ze=new ne.UserDataProfilesMainService(Ne,Oe,X,Ce,ye);me.set(ne.IUserDataProfilesMainService,ze);const $e=E.isWindows&&be.win32RegValueName?we.add(new te.NativePolicyService(be.win32RegValueName)):X.policyFile?we.add(new ie.FilePolicyService(X.policyFile,Ce,ye)):new j.NullPolicyService;me.set(j.IPolicyService,$e);const Be=new n.ConfigurationService(ze.defaultProfile.settingsResource,Ce,$e,ye);return me.set(o.IConfigurationService,Be),me.set(re.ILifecycleMainService,new F.SyncDescriptor(re.LifecycleMainService)),me.set(ee.IRequestService,new F.SyncDescriptor(B.RequestMainService)),me.set(Q.IThemeMainService,new F.SyncDescriptor(Q.ThemeMainService)),me.set(H.ISignService,new F.SyncDescriptor(L.SignService)),me.set(W.ITunnelService,new F.SyncDescriptor(z.TunnelService)),me.set(_.IProtocolMainService,new F.SyncDescriptor(A.ProtocolMainService)),[new U.InstantiationService(me,!0),oe,X,Be,Ne,he,be,ze]}patchEnvironment(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const X=process.env[be];typeof X=="string"&&(we[be]=X)}),Object.assign(process.env,we),we}async initServices(me,we,be,X,oe){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,we.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(he=>he?S.Promises.mkdir(he,{recursive:!0}):void 0)),X.init(),be.initialize()]),we.setEnablement(oe.quality!=="stable"||be.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,we,be,X,oe,he){let ye;try{(0,d.mark)("code/willStartMainServer"),ye=await(0,h.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,C.once)(be.onWillShutdown)(()=>ye.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,oe.nameLong,Ce),Ce;let Te;try{Te=await(0,h.connect)(we.mainIPCHandle,"main")}catch($e){if(!he||E.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(0,null,oe.nameShort),(0,i.localize)(1,null),oe.nameLong),$e;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Be){throw me.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(me,we,be,X,oe,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const $e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error($e),Te.dispose(),new Error($e)}let Oe;!we.args.wait&&!we.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(2,null,oe.nameShort),(0,i.localize)(3,null),oe.nameLong)},1e4));const Ne=f.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=f.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return X.invokeFunction(async()=>{const $e=new r.DiagnosticsService(V.NullTelemetryService,oe),Be=await Ne.getMainProcessInfo(),qe=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),G=await $e.getDiagnostics(Be,qe);throw console.log(G),new u.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,me),me.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new u.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(me,we,be){if(be.code==="EACCES"||be.code==="EPERM"){const X=(0,R.coalesce)([me.userDataPath,me.extensionsPath,h.XDG_RUNTIME_DIR]).map(oe=>(0,I.getPathLabel)(k.URI.file(oe),{os:E.OS,tildify:me}));this.showStartupWarningDialog((0,i.localize)(4,null),(0,i.localize)(5,null,(0,y.toErrorMessage)(be),X.join(`
`)),we)}}showStartupWarningDialog(me,we,be){w.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(6,null))],message:me,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,we){if(E.isWindows){const be=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((X,oe)=>{q(["windows-foreground-love"],X,oe)})).allowSetForegroundWindow(be)}catch(X){we.error(X)}}}quit(me,we){const be=me.get(ue.ILogService),X=me.get(re.ILifecycleMainService);let oe=0;we&&(we.isExpected?we.message&&be.trace(we.message):(oe=1,we.stack?be.error(we.stack):be.error(`Startup error: ${we.toString()}`))),X.kill(oe)}resolveArgs(){const me=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,l.createWaitMarkerFile)(me.verbose);we&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.doValidatePaths(me._,me.goto);me._=we}return me}doValidatePaths(me,we){const be=(0,b.cwd)(),X=me.map(ye=>{let Ce=String(ye),Te;we&&(Te=(0,m.parseLineAndColumnAware)(Ce),Ce=Te.path),Ce&&(Ce=this.preparePath(be,Ce));const Oe=(0,m.sanitizeFilePath)(Ce,be),Ne=(0,g.basename)(Oe);return Ne&&!(0,m.isValidBasename)(Ne)?null:we&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),oe=E.isWindows||E.isMacintosh,he=(0,R.distinct)(X,ye=>ye&&oe?ye.toLowerCase():ye||"");return(0,R.coalesce)(he)}preparePath(me,we){return E.isWindows&&(we=(0,p.rtrim)(we,'"')),we=(0,p.trim)((0,p.trim)(we," "),"	"),E.isWindows&&(we=(0,g.resolve)(me,we),we=(0,p.rtrim)(we,".")),we}toPath(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/eec059902f85f5031b4ebd8ba90f9602076be512/core/vs/code/electron-main/main.js.map
