/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/common/editor","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],De=function(ie){for(var e=[],a=0,v=ie.length;a<v;a++)e[a]=ye[ie[a]];return e};define(ye[72],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(y,P){const w=Object.create(null);for(const T of y){const R=P(T);let S=w[R];S||(S=w[R]=[]),S.push(T)}return w}e.groupBy=a;function v(y,P){const w=[],T=[];for(const R of y)P.has(R)||w.push(R);for(const R of P)y.has(R)||T.push(R);return{removed:w,added:T}}e.diffSets=v;function b(y,P){const w=[],T=[];for(const[R,S]of y)P.has(R)||w.push(S);for(const[R,S]of P)y.has(R)||T.push(S);return{removed:w,added:T}}e.diffMaps=b;class M{constructor(){this.map=new Map}add(P,w){let T=this.map.get(P);T||(T=new Set,this.map.set(P,T)),T.add(w)}delete(P,w){const T=this.map.get(P);!T||(T.delete(w),T.size===0&&this.map.delete(P))}forEach(P,w){const T=this.map.get(P);!T||T.forEach(w)}}e.SetMap=M}),define(ye[55],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(y){return(P,w,T)=>{let R=null,S=null;if(typeof T.value=="function"?(R="value",S=T.value):typeof T.get=="function"&&(R="get",S=T.get),!S)throw new Error("not supported");T[R]=y(S,w)}}e.createDecorator=a;function v(y,P,w){let T=null,R=null;if(typeof w.value=="function"?(T="value",R=w.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(T="get",R=w.get),!R)throw new Error("not supported");const S=`$memoize$${P}`;w[T]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[S]}}e.memoize=v;function b(y,P,w){return a((T,R)=>{const S=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...I){this[m]||(this[m]=w?w():void 0),clearTimeout(this[S]),P&&(this[m]=P(this[m],...I),I=[this[m]]),this[S]=setTimeout(()=>{T.apply(this,I),this[m]=w?w():void 0},y)}})}e.debounce=b;function M(y,P,w){return a((T,R)=>{const S=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,I=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...d){if(this[m]||(this[m]=w?w():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...d)),this[f])return;const u=this[I]+y;u<=Date.now()?(this[I]=Date.now(),T.apply(this,[this[m]]),this[m]=w?w():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[I]=Date.now(),T.apply(this,[this[m]]),this[m]=w?w():void 0},u-Date.now()))}})}e.throttle=M}),define(ye[73],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[106],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var v;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(v=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function y(i,h=!1){let r=0;const n=i.length;let s="",t=0,c=16,_=0;function p(B){let F=0,K=0;for(;F<B;){const H=i.charCodeAt(r);if(H>=48&&H<=57)K=K*16+H-48;else if(H>=65&&H<=70)K=K*16+H-65+10;else if(H>=97&&H<=102)K=K*16+H-97+10;else break;r++,F++}return F<B&&(K=-1),K}function k(B){r=B,s="",t=0,c=16,_=0}function U(){const B=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&T(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&T(i.charCodeAt(r)))for(r++;r<i.length&&T(i.charCodeAt(r));)r++;else return _=3,i.substring(B,r);let F=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&T(i.charCodeAt(r))){for(r++;r<i.length&&T(i.charCodeAt(r));)r++;F=r}else _=3;return i.substring(B,F)}function V(){let B="",F=r;for(;;){if(r>=n){B+=i.substring(F,r),_=2;break}const K=i.charCodeAt(r);if(K===34){B+=i.substring(F,r),r++;break}if(K===92){if(B+=i.substring(F,r),r++,r>=n){_=2;break}switch(i.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const O=p(4);O>=0?B+=String.fromCharCode(O):_=4;break}default:_=5}F=r;continue}if(K>=0&&K<=31)if(w(K)){B+=i.substring(F,r),_=2;break}else _=6;r++}return B}function x(){if(s="",_=0,t=r,r>=n)return t=n,c=17;let B=i.charCodeAt(r);if(P(B)){do r++,s+=String.fromCharCode(B),B=i.charCodeAt(r);while(P(B));return c=15}if(w(B))return r++,s+=String.fromCharCode(B),B===13&&i.charCodeAt(r)===10&&(r++,s+=`
`),c=14;switch(B){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,s=V(),c=10;case 47:{const F=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!w(i.charCodeAt(r));)r++;return s=i.substring(F,r),c=12}if(i.charCodeAt(r+1)===42){r+=2;const K=n-1;let H=!1;for(;r<K;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,_=1),s=i.substring(F,r),c=13}return s+=String.fromCharCode(B),r++,c=16}case 45:if(s+=String.fromCharCode(B),r++,r===n||!T(i.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),c=11;default:for(;r<n&&D(B);)r++,B=i.charCodeAt(r);if(t!==r){switch(s=i.substring(t,r),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(B),r++,c=16}}function D(B){if(P(B)||w(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:k,getPosition:()=>r,scan:h?L:x,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>_}}e.createScanner=y;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,h){const r=[],n=new Object;let s;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function _(p,k,U,V){t.value=p,t.offset=k,t.length=U,t.type=V,t.colonOffset=void 0,s=t}try{A(i,{onObjectBegin:(p,k)=>{if(h<=p)throw n;s=void 0,c=h>p,r.push("")},onObjectProperty:(p,k,U)=>{if(h<k||(_(p,k,U,"property"),r[r.length-1]=p,h<=k+U))throw n},onObjectEnd:(p,k)=>{if(h<=p)throw n;s=void 0,r.pop()},onArrayBegin:(p,k)=>{if(h<=p)throw n;s=void 0,r.push(0)},onArrayEnd:(p,k)=>{if(h<=p)throw n;s=void 0,r.pop()},onLiteralValue:(p,k,U)=>{if(h<k||(_(p,k,U,E(p)),h<=k+U))throw n},onSeparator:(p,k,U)=>{if(h<=k)throw n;if(p===":"&&s&&s.type==="property")s.colonOffset=k,c=!1,s=void 0;else if(p===","){const V=r[r.length-1];typeof V=="number"?r[r.length-1]=V+1:(c=!0,r[r.length-1]=""),s=void 0}}})}catch(p){if(p!==n)throw p}return{path:r,previousNode:s,isAtPropertyKey:c,matches:p=>{let k=0;for(let U=0;k<p.length&&U<r.length;U++)if(p[k]===r[U]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}e.getLocation=S;function m(i,h=[],r=M.DEFAULT){let n=null,s=[];const t=[];function c(p){Array.isArray(s)?s.push(p):n!==null&&(s[n]=p)}return A(i,{onObjectBegin:()=>{const p={};c(p),t.push(s),s=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{s=t.pop()},onArrayBegin:()=>{const p=[];c(p),t.push(s),s=p,n=null},onArrayEnd:()=>{s=t.pop()},onLiteralValue:c,onError:(p,k,U)=>{h.push({error:p,offset:k,length:U})}},r),s[0]}e.parse=m;function I(i,h=[],r=M.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function t(p){return n.children.push(p),p}A(i,{onObjectBegin:p=>{n=t({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,k,U)=>{n=t({type:"property",offset:k,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:k,length:U,parent:n})},onObjectEnd:(p,k)=>{n.length=p+k-n.offset,n=n.parent,s(p+k)},onArrayBegin:(p,k)=>{n=t({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,k)=>{n.length=p+k-n.offset,n=n.parent,s(p+k)},onLiteralValue:(p,k,U)=>{t({type:E(p),offset:k,length:U,parent:n,value:p}),s(k+U)},onSeparator:(p,k,U)=>{n.type==="property"&&(p===":"?n.colonOffset=k:p===","&&s(k))},onError:(p,k,U)=>{h.push({error:p,offset:k,length:U})}},r);const _=n.children[0];return _&&delete _.parent,_}e.parseTree=I;function f(i,h){if(!i)return;let r=i;for(const n of h)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===n){r=t.children[1],s=!0;break}if(!s)return}else{const s=n;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=f;function d(i){if(!i.parent||!i.parent.children)return[];const h=d(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;h.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&h.push(r)}return h}e.getNodePath=d;function u(i){switch(i.type){case"array":return i.children.map(u);case"object":{const h=Object.create(null);for(const r of i.children){const n=r.children[1];n&&(h[r.children[0].value]=u(n))}return h}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=u;function o(i,h,r=!1){return h>=i.offset&&h<i.offset+i.length||r&&h===i.offset+i.length}e.contains=o;function g(i,h,r=!1){if(o(i,h,r)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=h;s++){const t=g(n[s],h,r);if(t)return t}return i}}e.findNodeAtOffset=g;function A(i,h,r=M.DEFAULT){const n=y(i,!1);function s(Ee){return Ee?()=>Ee(n.getTokenOffset(),n.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=s(h.onObjectBegin),_=t(h.onObjectProperty),p=s(h.onObjectEnd),k=s(h.onArrayBegin),U=s(h.onArrayEnd),V=t(h.onLiteralValue),x=t(h.onSeparator),D=s(h.onComment),L=t(h.onError),B=r&&r.disallowComments,F=r&&r.allowTrailingComma;function K(){for(;;){const Ee=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:B||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(Ee){case 12:case 13:B?H(10):D();break;case 16:H(1);break;case 15:case 14:break;default:return Ee}}}function H(Ee,be=[],ne=[]){if(L(Ee),be.length+ne.length>0){let ve=n.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){K();break}else if(ne.indexOf(ve)!==-1)break;ve=K()}}}function O(Ee){const be=n.getTokenValue();return Ee?V(be):_(be),K(),!0}function ee(){switch(n.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(n.getTokenValue()),typeof Ee!="number"&&(H(2),Ee=0)}catch{H(2)}V(Ee);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function ce(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(O(!1),n.getToken()===6?(x(":"),K(),te()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function oe(){c(),K();let Ee=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Ee||H(4,[],[]),x(","),K(),n.getToken()===2&&F)break}else Ee&&H(6,[],[]);ce()||H(4,[],[2,5]),Ee=!0}return p(),n.getToken()!==2?H(7,[2],[]):K(),!0}function le(){k(),K();let Ee=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Ee||H(4,[],[]),x(","),K(),n.getToken()===4&&F)break}else Ee&&H(6,[],[]);te()||H(4,[],[4,5]),Ee=!0}return U(),n.getToken()!==4?H(8,[4],[]):K(),!0}function te(){switch(n.getToken()){case 3:return le();case 1:return oe();case 10:return O(!0);default:return ee()}}return K(),n.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):te()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=A;function l(i,h){const r=y(i),n=[];let s,t=0,c;do switch(c=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:t!==c&&n.push(i.substring(t,c)),h!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,h)),t=r.getPosition();break}while(s!==17);return n.join("")}e.stripComments=l;function E(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[107],De([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(Ie,Se){for(var Te=0;Te<Se.length;Te++){var ae=Se[Te];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Ie,ae.key,ae)}}function a(Ie,Se,Te){return Se&&e(Ie.prototype,Se),Te&&e(Ie,Te),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function v(Ie,Se){if(!!Ie){if(typeof Ie=="string")return b(Ie,Se);var Te=Object.prototype.toString.call(Ie).slice(8,-1);if(Te==="Object"&&Ie.constructor&&(Te=Ie.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ie);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return b(Ie,Se)}}function b(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var Te=0,ae=new Array(Se);Te<Se;Te++)ae[Te]=Ie[Te];return ae}function M(Ie,Se){var Te=typeof Symbol<"u"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Te)return(Te=Te.call(Ie)).next.bind(Te);if(Array.isArray(Ie)||(Te=v(Ie))||Se&&Ie&&typeof Ie.length=="number"){Te&&(Ie=Te);var ae=0;return function(){return ae>=Ie.length?{done:!0}:{done:!1,value:Ie[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=y();function P(Ie){ie.defaults=Ie}var w=/[&<>"']/,T=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(Se){return m[Se]};function f(Ie,Se){if(Se){if(w.test(Ie))return Ie.replace(T,I)}else if(R.test(Ie))return Ie.replace(S,I);return Ie}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Ie){return Ie.replace(d,function(Se,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var o=/(^|[^\[])\^/g;function g(Ie,Se){Ie=typeof Ie=="string"?Ie:Ie.source,Se=Se||"";var Te={replace:function(ue,X){return X=X.source||X,X=X.replace(o,"$1"),Ie=Ie.replace(ue,X),Te},getRegex:function(){return new RegExp(Ie,Se)}};return Te}var A=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(Ie,Se,Te){if(Ie){var ae;try{ae=decodeURIComponent(u(Te)).replace(A,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!l.test(Te)&&(Te=s(Se,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch{return null}return Te}var i={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Ie,Se){i[" "+Ie]||(h.test(Ie)?i[" "+Ie]=Ie+"/":i[" "+Ie]=p(Ie,"/",!0)),Ie=i[" "+Ie];var Te=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?Te?Se:Ie.replace(r,"$1")+Se:Se.charAt(0)==="/"?Te?Se:Ie.replace(n,"$1")+Se:Ie+Se}var t={exec:function(){}};function c(Ie){for(var Se=1,Te,ae;Se<arguments.length;Se++){Te=arguments[Se];for(ae in Te)Object.prototype.hasOwnProperty.call(Te,ae)&&(Ie[ae]=Te[ae])}return Ie}function _(Ie,Se){var Te=Ie.replace(/\|/g,function(X,Y,C){for(var z=!1,W=Y;--W>=0&&C[W]==="\\";)z=!z;return z?"|":" |"}),ae=Te.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function p(Ie,Se,Te){var ae=Ie.length;if(ae===0)return"";for(var ue=0;ue<ae;){var X=Ie.charAt(ae-ue-1);if(X===Se&&!Te)ue++;else if(X!==Se&&Te)ue++;else break}return Ie.slice(0,ae-ue)}function k(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var Te=Ie.length,ae=0,ue=0;ue<Te;ue++)if(Ie[ue]==="\\")ue++;else if(Ie[ue]===Se[0])ae++;else if(Ie[ue]===Se[1]&&(ae--,ae<0))return ue;return-1}function U(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Ie,Se){if(Se<1)return"";for(var Te="";Se>1;)Se&1&&(Te+=Ie),Se>>=1,Ie+=Ie;return Te+Ie}function x(Ie,Se,Te,ae){var ue=Se.href,X=Se.title?f(Se.title):null,Y=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ae.state.inLink=!0;var C={type:"link",raw:Te,href:ue,title:X,text:Y,tokens:ae.inlineTokens(Y,[])};return ae.state.inLink=!1,C}return{type:"image",raw:Te,href:ue,title:X,text:f(Y)}}function D(Ie,Se){var Te=Ie.match(/^(\s+)(?:```)/);if(Te===null)return Se;var ae=Te[1];return Se.split(`
`).map(function(ue){var X=ue.match(/^\s+/);if(X===null)return ue;var Y=X[0];return Y.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var L=function(){function Ie(Te){this.options=Te||ie.defaults}var Se=Ie.prototype;return Se.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},Se.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var X=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?X:p(X,`
`)}}},Se.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var X=ue[0],Y=D(X,ue[3]||"");return{type:"code",raw:X,lang:ue[2]?ue[2].trim():ue[2],text:Y}}},Se.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var X=ue[2].trim();if(/#$/.test(X)){var Y=p(X,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(X=Y.trim())}var C={type:"heading",raw:ue[0],depth:ue[1].length,text:X,tokens:[]};return this.lexer.inline(C.text,C.tokens),C}},Se.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var X=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(X,[]),text:X}}},Se.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var X,Y,C,z,W,j,se,de,Z,pe,ge,Ne,Be=ue[1].trim(),Je=Be.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var ke=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=ke.exec(ae))||this.rules.block.hr.test(ae)));){if(X=ue[0],ae=ae.substring(X.length),de=ue[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(z=2,ge=de.trimLeft()):(z=ue[2].search(/[^ ]/),z=z>4?1:z,ge=de.slice(z),z+=ue[1].length),j=!1,!de&&/^ *$/.test(Z)&&(X+=Z+`
`,ae=ae.substring(Z.length+1),Ne=!0),!Ne)for(var rt=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ae&&(pe=ae.split(`
`,1)[0],de=pe,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(de)||G.test(ae)));){if(de.search(/[^ ]/)>=z||!de.trim())ge+=`
`+de.slice(z);else if(!j)ge+=`
`+de;else break;!j&&!de.trim()&&(j=!0),X+=pe+`
`,ae=ae.substring(pe.length+1)}Ge.loose||(se?Ge.loose=!0:/\n *\n *$/.test(X)&&(se=!0)),this.options.gfm&&(Y=/^\[[ xX]\] /.exec(ge),Y&&(C=Y[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:X,task:!!Y,checked:C,loose:!1,text:ge}),Ge.raw+=X}Ge.items[Ge.items.length-1].raw=X.trimRight(),Ge.items[Ge.items.length-1].text=ge.trimRight(),Ge.raw=Ge.raw.trimRight();var Q=Ge.items.length;for(W=0;W<Q;W++){this.lexer.state.top=!1,Ge.items[W].tokens=this.lexer.blockTokens(Ge.items[W].text,[]);var fe=Ge.items[W].tokens.filter(function(He){return He.type==="space"}),Ue=fe.every(function(He){for(var Ze=He.raw.split(""),qe=0,We=M(Ze),nt;!(nt=We()).done;){var ot=nt.value;if(ot===`
`&&(qe+=1),qe>1)return!0}return!1});!Ge.loose&&fe.length&&Ue&&(Ge.loose=!0,Ge.items[W].loose=!0)}return Ge}},Se.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var X={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(X.type="paragraph",X.text=this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]),X.tokens=[],this.lexer.inline(X.text,X.tokens)),X}},Se.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var X=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:X,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var X={type:"table",header:_(ue[1]).map(function(se){return{text:se}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=ue[0];var Y=X.align.length,C,z,W,j;for(C=0;C<Y;C++)/^ *-+: *$/.test(X.align[C])?X.align[C]="right":/^ *:-+: *$/.test(X.align[C])?X.align[C]="center":/^ *:-+ *$/.test(X.align[C])?X.align[C]="left":X.align[C]=null;for(Y=X.rows.length,C=0;C<Y;C++)X.rows[C]=_(X.rows[C],X.header.length).map(function(se){return{text:se}});for(Y=X.header.length,z=0;z<Y;z++)X.header[z].tokens=[],this.lexer.inline(X.header[z].text,X.header[z].tokens);for(Y=X.rows.length,z=0;z<Y;z++)for(j=X.rows[z],W=0;W<j.length;W++)j[W].tokens=[],this.lexer.inline(j[W].text,j[W].tokens);return X}}},Se.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue){var X={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var X={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue){var X={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:f(ue[1])}},Se.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]):ue[0]}},Se.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var X=ue[2].trim();if(!this.options.pedantic&&/^</.test(X)){if(!/>$/.test(X))return;var Y=p(X.slice(0,-1),"\\");if((X.length-Y.length)%2===0)return}else{var C=k(ue[2],"()");if(C>-1){var z=ue[0].indexOf("!")===0?5:4,W=z+ue[1].length+C;ue[2]=ue[2].substring(0,C),ue[0]=ue[0].substring(0,W).trim(),ue[3]=""}}var j=ue[2],se="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);de&&(j=de[1],se=de[3])}else se=ue[3]?ue[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(X)?j=j.slice(1):j=j.slice(1,-1)),x(ue,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(ae,ue){var X;if((X=this.rules.inline.reflink.exec(ae))||(X=this.rules.inline.nolink.exec(ae))){var Y=(X[2]||X[1]).replace(/\s+/g," ");if(Y=ue[Y.toLowerCase()],!Y||!Y.href){var C=X[0].charAt(0);return{type:"text",raw:C,text:C}}return x(X,Y,X[0],this.lexer)}},Se.emStrong=function(ae,ue,X){X===void 0&&(X="");var Y=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Y&&!(Y[3]&&X.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var C=Y[1]||Y[2]||"";if(!C||C&&(X===""||this.rules.inline.punctuation.exec(X))){var z=Y[0].length-1,W,j,se=z,de=0,Z=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,ue=ue.slice(-1*ae.length+z);(Y=Z.exec(ue))!=null;)if(W=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!W){if(j=W.length,Y[3]||Y[4]){se+=j;continue}else if((Y[5]||Y[6])&&z%3&&!((z+j)%3)){de+=j;continue}if(se-=j,!(se>0)){if(j=Math.min(j,j+se+de),Math.min(z,j)%2){var pe=ae.slice(1,z+Y.index+j);return{type:"em",raw:ae.slice(0,z+Y.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ge=ae.slice(2,z+Y.index+j-1);return{type:"strong",raw:ae.slice(0,z+Y.index+j+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}}}}},Se.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var X=ue[2].replace(/\n/g," "),Y=/[^ ]/.test(X),C=/^ /.test(X)&&/ $/.test(X);return Y&&C&&(X=X.substring(1,X.length-1)),X=f(X,!0),{type:"codespan",raw:ue[0],text:X}}},Se.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(ae,ue){var X=this.rules.inline.autolink.exec(ae);if(X){var Y,C;return X[2]==="@"?(Y=f(this.options.mangle?ue(X[1]):X[1]),C="mailto:"+Y):(Y=f(X[1]),C=Y),{type:"link",raw:X[0],text:Y,href:C,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.url=function(ae,ue){var X;if(X=this.rules.inline.url.exec(ae)){var Y,C;if(X[2]==="@")Y=f(this.options.mangle?ue(X[0]):X[0]),C="mailto:"+Y;else{var z;do z=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(z!==X[0]);Y=f(X[0]),X[1]==="www."?C="http://"+Y:C=Y}return{type:"link",raw:X[0],text:Y,href:C,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.inlineText=function(ae,ue){var X=this.rules.inline.text.exec(ae);if(X){var Y;return this.lexer.state.inRawBlock?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):f(X[0]):X[0]:Y=f(this.options.smartypants?ue(X[0]):X[0]),{type:"text",raw:X[0],text:Y}}},Ie}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=g(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=g(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=g(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=g(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=g(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=g(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=g(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=g(F.reflink).replace("label",F._label).replace("ref",B._label).getRegex(),F.nolink=g(F.nolink).replace("ref",B._label).getRegex(),F.reflinkSearch=g(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=c({},F),F.pedantic=c({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=c({},F.normal,{escape:g(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=g(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=c({},F.gfm,{br:g(F.br).replace("{2,}","*").getRegex(),text:g(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ie){var Se="",Te,ae,ue=Ie.length;for(Te=0;Te<ue;Te++)ae=Ie.charCodeAt(Te),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var O=function(){function Ie(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||ie.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:B.normal,inline:F.normal};this.options.pedantic?(ae.block=B.pedantic,ae.inline=F.pedantic):this.options.gfm&&(ae.block=B.gfm,this.options.breaks?ae.inline=F.breaks:ae.inline=F.gfm),this.tokenizer.rules=ae}Ie.lex=function(ae,ue){var X=new Ie(ue);return X.lex(ae)},Ie.lexInline=function(ae,ue){var X=new Ie(ue);return X.inlineTokens(ae)};var Se=Ie.prototype;return Se.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(ae,ue){var X=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,de,Z){return de+"    ".repeat(Z.length)});for(var Y,C,z,W;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(Y=se.call({lexer:X},ae,ue))?(ae=ae.substring(Y.raw.length),ue.push(Y),!0):!1}))){if(Y=this.tokenizer.space(ae)){ae=ae.substring(Y.raw.length),Y.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(Y);continue}if(Y=this.tokenizer.code(ae)){ae=ae.substring(Y.raw.length),C=ue[ue.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+Y.raw,C.text+=`
`+Y.text,this.inlineQueue[this.inlineQueue.length-1].src=C.text):ue.push(Y);continue}if(Y=this.tokenizer.fences(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.heading(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.hr(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.blockquote(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.list(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.html(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.def(ae)){ae=ae.substring(Y.raw.length),C=ue[ue.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+Y.raw,C.text+=`
`+Y.raw,this.inlineQueue[this.inlineQueue.length-1].src=C.text):this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.lheading(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(z=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,de=ae.slice(1),Z=void 0;X.options.extensions.startBlock.forEach(function(pe){Z=pe.call({lexer:this},de),typeof Z=="number"&&Z>=0&&(se=Math.min(se,Z))}),se<1/0&&se>=0&&(z=ae.substring(0,se+1))}(),this.state.top&&(Y=this.tokenizer.paragraph(z))){C=ue[ue.length-1],W&&C.type==="paragraph"?(C.raw+=`
`+Y.raw,C.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ue.push(Y),W=z.length!==ae.length,ae=ae.substring(Y.raw.length);continue}if(Y=this.tokenizer.text(ae)){ae=ae.substring(Y.raw.length),C=ue[ue.length-1],C&&C.type==="text"?(C.raw+=`
`+Y.raw,C.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ue.push(Y);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ue},Se.inline=function(ae,ue){this.inlineQueue.push({src:ae,tokens:ue})},Se.inlineTokens=function(ae,ue){var X=this;ue===void 0&&(ue=[]);var Y,C,z,W=ae,j,se,de;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)Z.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,j.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(de=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(Y=ge.call({lexer:X},ae,ue))?(ae=ae.substring(Y.raw.length),ue.push(Y),!0):!1}))){if(Y=this.tokenizer.escape(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.tag(ae)){ae=ae.substring(Y.raw.length),C=ue[ue.length-1],C&&Y.type==="text"&&C.type==="text"?(C.raw+=Y.raw,C.text+=Y.text):ue.push(Y);continue}if(Y=this.tokenizer.link(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Y.raw.length),C=ue[ue.length-1],C&&Y.type==="text"&&C.type==="text"?(C.raw+=Y.raw,C.text+=Y.text):ue.push(Y);continue}if(Y=this.tokenizer.emStrong(ae,W,de)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.codespan(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.br(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.del(ae)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.autolink(ae,H)){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(!this.state.inLink&&(Y=this.tokenizer.url(ae,H))){ae=ae.substring(Y.raw.length),ue.push(Y);continue}if(z=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;X.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(z=ae.substring(0,ge+1))}(),Y=this.tokenizer.inlineText(z,K)){ae=ae.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(de=Y.raw.slice(-1)),se=!0,C=ue[ue.length-1],C&&C.type==="text"?(C.raw+=Y.raw,C.text+=Y.text):ue.push(Y);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ue},a(Ie,null,[{key:"rules",get:function(){return{block:B,inline:F}}}]),Ie}(),ee=function(){function Ie(Te){this.options=Te||ie.defaults}var Se=Ie.prototype;return Se.code=function(ae,ue,X){var Y=(ue||"").match(/\S*/)[0];if(this.options.highlight){var C=this.options.highlight(ae,Y);C!=null&&C!==ae&&(X=!0,ae=C)}return ae=ae.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+f(Y,!0)+'">'+(X?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(X?ae:f(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,ue,X,Y){if(this.options.headerIds){var C=this.options.headerPrefix+Y.slug(X);return"<h"+ue+' id="'+C+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,ue,X){var Y=ue?"ol":"ul",C=ue&&X!==1?' start="'+X+'"':"";return"<"+Y+C+`>
`+ae+"</"+Y+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,ue){var X=ue.header?"th":"td",Y=ue.align?"<"+X+' align="'+ue.align+'">':"<"+X+">";return Y+ae+("</"+X+`>
`)},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,ue,X){if(ae=E(this.options.sanitize,this.options.baseUrl,ae),ae===null)return X;var Y='<a href="'+f(ae)+'"';return ue&&(Y+=' title="'+ue+'"'),Y+=">"+X+"</a>",Y},Se.image=function(ae,ue,X){if(ae=E(this.options.sanitize,this.options.baseUrl,ae),ae===null)return X;var Y='<img src="'+ae+'" alt="'+X+'"';return ue&&(Y+=' title="'+ue+'"'),Y+=this.options.xhtml?"/>":">",Y},Se.text=function(ae){return ae},Ie}(),ce=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,ue,X){return""+X},Se.image=function(ae,ue,X){return""+X},Se.br=function(){return""},Ie}(),oe=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,ue){var X=ae,Y=0;if(this.seen.hasOwnProperty(X)){Y=this.seen[ae];do Y++,X=ae+"-"+Y;while(this.seen.hasOwnProperty(X))}return ue||(this.seen[ae]=Y,this.seen[X]=0),X},Se.slug=function(ae,ue){ue===void 0&&(ue={});var X=this.serialize(ae);return this.getNextSafeSlug(X,ue.dryrun)},Ie}(),le=function(){function Ie(Te){this.options=Te||ie.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new oe}Ie.parse=function(ae,ue){var X=new Ie(ue);return X.parse(ae)},Ie.parseInline=function(ae,ue){var X=new Ie(ue);return X.parseInline(ae)};var Se=Ie.prototype;return Se.parse=function(ae,ue){ue===void 0&&(ue=!0);var X="",Y,C,z,W,j,se,de,Z,pe,ge,Ne,Be,Je,Ge,ke,rt,G,Q,fe,Ue=ae.length;for(Y=0;Y<Ue;Y++){if(ge=ae[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(fe=this.options.extensions.renderers[ge.type].call({parser:this},ge),fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){X+=fe||"";continue}switch(ge.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,u(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Z="",de="",W=ge.header.length,C=0;C<W;C++)de+=this.renderer.tablecell(this.parseInline(ge.header[C].tokens),{header:!0,align:ge.align[C]});for(Z+=this.renderer.tablerow(de),pe="",W=ge.rows.length,C=0;C<W;C++){for(se=ge.rows[C],de="",j=se.length,z=0;z<j;z++)de+=this.renderer.tablecell(this.parseInline(se[z].tokens),{header:!1,align:ge.align[z]});pe+=this.renderer.tablerow(de)}X+=this.renderer.table(Z,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),X+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Je=ge.loose,W=ge.items.length,pe="",C=0;C<W;C++)ke=ge.items[C],rt=ke.checked,G=ke.task,Ge="",ke.task&&(Q=this.renderer.checkbox(rt),Je?ke.tokens.length>0&&ke.tokens[0].type==="paragraph"?(ke.tokens[0].text=Q+" "+ke.tokens[0].text,ke.tokens[0].tokens&&ke.tokens[0].tokens.length>0&&ke.tokens[0].tokens[0].type==="text"&&(ke.tokens[0].tokens[0].text=Q+" "+ke.tokens[0].tokens[0].text)):ke.tokens.unshift({type:"text",text:Q}):Ge+=Q),Ge+=this.parse(ke.tokens,Je),pe+=this.renderer.listitem(Ge,G,rt);X+=this.renderer.list(pe,Ne,Be);continue}case"html":{X+=this.renderer.html(ge.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;Y+1<Ue&&ae[Y+1].type==="text";)ge=ae[++Y],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);X+=ue?this.renderer.paragraph(pe):pe;continue}default:{var He='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return X},Se.parseInline=function(ae,ue){ue=ue||this.renderer;var X="",Y,C,z,W=ae.length;for(Y=0;Y<W;Y++){if(C=ae[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[C.type]&&(z=this.options.extensions.renderers[C.type].call({parser:this},C),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(C.type))){X+=z||"";continue}switch(C.type){case"escape":{X+=ue.text(C.text);break}case"html":{X+=ue.html(C.text);break}case"link":{X+=ue.link(C.href,C.title,this.parseInline(C.tokens,ue));break}case"image":{X+=ue.image(C.href,C.title,C.text);break}case"strong":{X+=ue.strong(this.parseInline(C.tokens,ue));break}case"em":{X+=ue.em(this.parseInline(C.tokens,ue));break}case"codespan":{X+=ue.codespan(C.text);break}case"br":{X+=ue.br();break}case"del":{X+=ue.del(this.parseInline(C.tokens,ue));break}case"text":{X+=ue.text(C.text);break}default:{var j='Token with "'+C.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return X},Ie}();function te(Ie,Se,Te){if(typeof Ie>"u"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(Te=Se,Se=null),Se=c({},te.defaults,Se||{}),U(Se),Te){var ae=Se.highlight,ue;try{ue=O.lex(Ie,Se)}catch(z){return Te(z)}var X=function(W){var j;if(!W)try{Se.walkTokens&&te.walkTokens(ue,Se.walkTokens),j=le.parse(ue,Se)}catch(se){W=se}return Se.highlight=ae,W?Te(W):Te(null,j)};if(!ae||ae.length<3||(delete Se.highlight,!ue.length))return X();var Y=0;te.walkTokens(ue,function(z){z.type==="code"&&(Y++,setTimeout(function(){ae(z.text,z.lang,function(W,j){if(W)return X(W);j!=null&&j!==z.text&&(z.text=j,z.escaped=!0),Y--,Y===0&&X()})},0))}),Y===0&&X();return}try{var C=O.lex(Ie,Se);return Se.walkTokens&&te.walkTokens(C,Se.walkTokens),le.parse(C,Se)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(z.message+"",!0)+"</pre>";throw z}}te.options=te.setOptions=function(Ie){return c(te.defaults,Ie),P(te.defaults),te},te.getDefaults=y,te.defaults=ie.defaults,te.use=function(){for(var Ie=arguments.length,Se=new Array(Ie),Te=0;Te<Ie;Te++)Se[Te]=arguments[Te];var ae=c.apply(void 0,[{}].concat(Se)),ue=te.defaults.extensions||{renderers:{},childTokens:{}},X;Se.forEach(function(Y){if(Y.extensions&&(X=!0,Y.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var W=ue.renderers?ue.renderers[z.name]:null;W?ue.renderers[z.name]=function(){for(var j=arguments.length,se=new Array(j),de=0;de<j;de++)se[de]=arguments[de];var Z=z.renderer.apply(this,se);return Z===!1&&(Z=W.apply(this,se)),Z}:ue.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[z.level]?ue[z.level].unshift(z.tokenizer):ue[z.level]=[z.tokenizer],z.start&&(z.level==="block"?ue.startBlock?ue.startBlock.push(z.start):ue.startBlock=[z.start]:z.level==="inline"&&(ue.startInline?ue.startInline.push(z.start):ue.startInline=[z.start]))}z.childTokens&&(ue.childTokens[z.name]=z.childTokens)})),Y.renderer&&function(){var z=te.defaults.renderer||new ee,W=function(de){var Z=z[de];z[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Y.renderer[de].apply(z,ge);return Be===!1&&(Be=Z.apply(z,ge)),Be}};for(var j in Y.renderer)W(j);ae.renderer=z}(),Y.tokenizer&&function(){var z=te.defaults.tokenizer||new L,W=function(de){var Z=z[de];z[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Y.tokenizer[de].apply(z,ge);return Be===!1&&(Be=Z.apply(z,ge)),Be}};for(var j in Y.tokenizer)W(j);ae.tokenizer=z}(),Y.walkTokens){var C=te.defaults.walkTokens;ae.walkTokens=function(z){Y.walkTokens.call(this,z),C&&C.call(this,z)}}X&&(ae.extensions=ue),te.setOptions(ae)})},te.walkTokens=function(Ie,Se){for(var Te=function(){var Y=ue.value;switch(Se.call(te,Y),Y.type){case"table":{for(var C=M(Y.header),z;!(z=C()).done;){var W=z.value;te.walkTokens(W.tokens,Se)}for(var j=M(Y.rows),se;!(se=j()).done;)for(var de=se.value,Z=M(de),pe;!(pe=Z()).done;){var ge=pe.value;te.walkTokens(ge.tokens,Se)}break}case"list":{te.walkTokens(Y.items,Se);break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[Y.type]?te.defaults.extensions.childTokens[Y.type].forEach(function(Ne){te.walkTokens(Y[Ne],Se)}):Y.tokens&&te.walkTokens(Y.tokens,Se)}},ae=M(Ie),ue;!(ue=ae()).done;)Te()},te.parseInline=function(Ie,Se){if(typeof Ie>"u"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=c({},te.defaults,Se||{}),U(Se);try{var Te=O.lexInline(Ie,Se);return Se.walkTokens&&te.walkTokens(Te,Se.walkTokens),le.parseInline(Te,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},te.Parser=le,te.parser=le.parse,te.Renderer=ee,te.TextRenderer=ce,te.Lexer=O,te.lexer=O.lex,te.Tokenizer=L,te.Slugger=oe,te.parse=te;var Ee=te.options,be=te.setOptions,ne=te.use,ve=te.walkTokens,Pe=te.parseInline,Fe=te,xe=le.parse,Qe=O.lex;ie.Lexer=O,ie.Parser=le,ie.Renderer=ee,ie.Slugger=oe,ie.TextRenderer=ce,ie.Tokenizer=L,ie.getDefaults=y,ie.lexer=Qe,ie.marked=te,ie.options=Ee,ie.parse=Fe,ie.parseInline=Pe,ie.parser=xe,ie.setOptions=be,ie.use=ne,ie.walkTokens=ve,Object.defineProperty(ie,"__esModule",{value:!0})}),define(ye[108],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(P,w,T){return Math.min(Math.max(P,w),T)}e.clamp=a;function v(P,w){return(w+P%w)%w}e.rot=v;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class M{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class y{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const T=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function ie(b){const M=[];typeof b=="number"&&M.push("code/timeOrigin",b);function y(w){M.push(w,Date.now())}function P(){const w=[];for(let T=0;T<M.length;T+=2)w.push({name:M[T],startTime:M[T+1]});return w}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const y of performance.getEntriesByType("mark"))M.push({name:y.name,startTime:Math.round(b+y.startTime)});return M}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var v;typeof global=="object"?v=global:typeof self=="object"?v=self:v={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(v)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(v):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),v.perf=a(v))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var v in a)(typeof exports=="object"?exports:ie)[v]=a[v]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function a(v){if(e[v])return e[v].exports;var b=e[v]={i:v,l:!1,exports:{}};return ie[v].call(b.exports,b,b.exports,a),b.l=!0,b.exports}return a.m=ie,a.c=e,a.d=function(v,b,M){a.o(v,b)||Object.defineProperty(v,b,{enumerable:!0,get:M})},a.r=function(v){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(v,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(v,"__esModule",{value:!0})},a.t=function(v,b){if(1&b&&(v=a(v)),8&b||4&b&&typeof v=="object"&&v&&v.__esModule)return v;var M=Object.create(null);if(a.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:v}),2&b&&typeof v!="string")for(var y in v)a.d(M,y,function(P){return v[P]}.bind(null,y));return M},a.n=function(v){var b=v&&v.__esModule?function(){return v.default}:function(){return v};return a.d(b,"a",b),b},a.o=function(v,b){return Object.prototype.hasOwnProperty.call(v,b)},a.p="",a(a.s=0)}([function(ie,e,a){(function(v){var b;e=ie.exports=ne,b=typeof v=="object"&&v.env&&v.env.NODE_DEBUG&&/\bsemver\b/i.test(v.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],T=0,R=T++;w[R]="0|[1-9]\\d*";var S=T++;w[S]="[0-9]+";var m=T++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=T++;w[I]="("+w[R]+")\\.("+w[R]+")\\.("+w[R]+")";var f=T++;w[f]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var d=T++;w[d]="(?:"+w[R]+"|"+w[m]+")";var u=T++;w[u]="(?:"+w[S]+"|"+w[m]+")";var o=T++;w[o]="(?:-("+w[d]+"(?:\\."+w[d]+")*))";var g=T++;w[g]="(?:-?("+w[u]+"(?:\\."+w[u]+")*))";var A=T++;w[A]="[0-9A-Za-z-]+";var l=T++;w[l]="(?:\\+("+w[A]+"(?:\\."+w[A]+")*))";var E=T++,i="v?"+w[I]+w[o]+"?"+w[l]+"?";w[E]="^"+i+"$";var h="[v=\\s]*"+w[f]+w[g]+"?"+w[l]+"?",r=T++;w[r]="^"+h+"$";var n=T++;w[n]="((?:<|>)?=?)";var s=T++;w[s]=w[S]+"|x|X|\\*";var t=T++;w[t]=w[R]+"|x|X|\\*";var c=T++;w[c]="[v=\\s]*("+w[t]+")(?:\\.("+w[t]+")(?:\\.("+w[t]+")(?:"+w[o]+")?"+w[l]+"?)?)?";var _=T++;w[_]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[g]+")?"+w[l]+"?)?)?";var p=T++;w[p]="^"+w[n]+"\\s*"+w[c]+"$";var k=T++;w[k]="^"+w[n]+"\\s*"+w[_]+"$";var U=T++;w[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=T++;w[V]="(?:~>?)";var x=T++;w[x]="(\\s*)"+w[V]+"\\s+",P[x]=new RegExp(w[x],"g");var D=T++;w[D]="^"+w[V]+w[c]+"$";var L=T++;w[L]="^"+w[V]+w[_]+"$";var B=T++;w[B]="(?:\\^)";var F=T++;w[F]="(\\s*)"+w[B]+"\\s+",P[F]=new RegExp(w[F],"g");var K=T++;w[K]="^"+w[B]+w[c]+"$";var H=T++;w[H]="^"+w[B]+w[_]+"$";var O=T++;w[O]="^"+w[n]+"\\s*("+h+")$|^$";var ee=T++;w[ee]="^"+w[n]+"\\s*("+i+")$|^$";var ce=T++;w[ce]="(\\s*)"+w[n]+"\\s*("+h+"|"+w[c]+")",P[ce]=new RegExp(w[ce],"g");var oe=T++;w[oe]="^\\s*("+w[c]+")\\s+-\\s+("+w[c]+")\\s*$";var le=T++;w[le]="^\\s*("+w[_]+")\\s+-\\s+("+w[_]+")\\s*$";var te=T++;w[te]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)b(Ee,w[Ee]),P[Ee]||(P[Ee]=new RegExp(w[Ee]));function be(Z,pe){if(Z instanceof ne)return Z;if(typeof Z!="string"||Z.length>M||!(pe?P[r]:P[E]).test(Z))return null;try{return new ne(Z,pe)}catch{return null}}function ne(Z,pe){if(Z instanceof ne){if(Z.loose===pe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ne))return new ne(Z,pe);b("SemVer",Z,pe),this.loose=pe;var ge=Z.trim().match(pe?P[r]:P[E]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<y)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(Z,pe){var ge=be(Z,pe);return ge?ge.version:null},e.clean=function(Z,pe){var ge=be(Z.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(Z){return b("SemVer.compare",this.version,this.loose,Z),Z instanceof ne||(Z=new ne(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ne.prototype.compareMain=function(Z){return Z instanceof ne||(Z=new ne(Z,this.loose)),Pe(this.major,Z.major)||Pe(this.minor,Z.minor)||Pe(this.patch,Z.patch)},ne.prototype.comparePre=function(Z){if(Z instanceof ne||(Z=new ne(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=Z.prerelease[pe];if(b("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Pe(ge,Ne)}while(++pe)},ne.prototype.inc=function(Z,pe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ne(Z,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(Z,pe){if(Ie(Z,pe))return null;var ge=be(Z),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Pe;var ve=/^[0-9]+$/;function Pe(Z,pe){var ge=ve.test(Z),Ne=ve.test(pe);return ge&&Ne&&(Z=+Z,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:Z<pe?-1:Z>pe?1:0}function Fe(Z,pe,ge){return new ne(Z,ge).compare(new ne(pe,ge))}function xe(Z,pe,ge){return Fe(Z,pe,ge)>0}function Qe(Z,pe,ge){return Fe(Z,pe,ge)<0}function Ie(Z,pe,ge){return Fe(Z,pe,ge)===0}function Se(Z,pe,ge){return Fe(Z,pe,ge)!==0}function Te(Z,pe,ge){return Fe(Z,pe,ge)>=0}function ae(Z,pe,ge){return Fe(Z,pe,ge)<=0}function ue(Z,pe,ge,Ne){var Be;switch(pe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Be=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Be=Z!==ge;break;case"":case"=":case"==":Be=Ie(Z,ge,Ne);break;case"!=":Be=Se(Z,ge,Ne);break;case">":Be=xe(Z,ge,Ne);break;case">=":Be=Te(Z,ge,Ne);break;case"<":Be=Qe(Z,ge,Ne);break;case"<=":Be=ae(Z,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function X(Z,pe){if(Z instanceof X){if(Z.loose===pe)return Z;Z=Z.value}if(!(this instanceof X))return new X(Z,pe);b("comparator",Z,pe),this.loose=pe,this.parse(Z),this.semver===Y?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(Z,pe){return Pe(pe,Z)},e.major=function(Z,pe){return new ne(Z,pe).major},e.minor=function(Z,pe){return new ne(Z,pe).minor},e.patch=function(Z,pe){return new ne(Z,pe).patch},e.compare=Fe,e.compareLoose=function(Z,pe){return Fe(Z,pe,!0)},e.rcompare=function(Z,pe,ge){return Fe(pe,Z,ge)},e.sort=function(Z,pe){return Z.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(Z,pe){return Z.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=xe,e.lt=Qe,e.eq=Ie,e.neq=Se,e.gte=Te,e.lte=ae,e.cmp=ue,e.Comparator=X;var Y={};function C(Z,pe){if(Z instanceof C)return Z.loose===pe?Z:new C(Z.raw,pe);if(Z instanceof X)return new C(Z.value,pe);if(!(this instanceof C))return new C(Z,pe);if(this.loose=pe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function z(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function W(Z,pe,ge,Ne,Be,Je,Ge,ke,rt,G,Q,fe,Ue){return((pe=z(ge)?"":z(Ne)?">="+ge+".0.0":z(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(ke=z(rt)?"":z(G)?"<"+(+rt+1)+".0.0":z(Q)?"<"+rt+"."+(+G+1)+".0":fe?"<="+rt+"."+G+"."+Q+"-"+fe:"<="+ke)).trim()}function j(Z,pe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(b(Z[ge].semver),Z[ge].semver!==Y&&Z[ge].semver.prerelease.length>0){var Ne=Z[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function se(Z,pe,ge){try{pe=new C(pe,ge)}catch{return!1}return pe.test(Z)}function de(Z,pe,ge,Ne){var Be,Je,Ge,ke,rt;switch(Z=new ne(Z,Ne),pe=new C(pe,Ne),ge){case">":Be=xe,Je=ae,Ge=Qe,ke=">",rt=">=";break;case"<":Be=Qe,Je=Te,Ge=xe,ke="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Z,pe,Ne))return!1;for(var G=0;G<pe.set.length;++G){var Q=pe.set[G],fe=null,Ue=null;if(Q.forEach(function(He){He.semver===Y&&(He=new X(">=0.0.0")),fe=fe||He,Ue=Ue||He,Be(He.semver,fe.semver,Ne)?fe=He:Ge(He.semver,Ue.semver,Ne)&&(Ue=He)}),fe.operator===ke||fe.operator===rt||(!Ue.operator||Ue.operator===ke)&&Je(Z,Ue.semver)||Ue.operator===rt&&Ge(Z,Ue.semver))return!1}return!0}X.prototype.parse=function(Z){var pe=this.loose?P[O]:P[ee],ge=Z.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ne(ge[2],this.loose):this.semver=Y},X.prototype.toString=function(){return this.value},X.prototype.test=function(Z){return b("Comparator.test",Z,this.loose),this.semver===Y||(typeof Z=="string"&&(Z=new ne(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},X.prototype.intersects=function(Z,pe){if(!(Z instanceof X))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new C(Z.value,pe),se(this.value,ge,pe);if(Z.operator==="")return ge=new C(this.value,pe),se(Z.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Je=this.semver.version===Z.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ke=ue(this.semver,"<",Z.semver,pe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),rt=ue(this.semver,">",Z.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ne||Be||Je&&Ge||ke||rt},e.Range=C,C.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},C.prototype.toString=function(){return this.range},C.prototype.parseRange=function(Z){var pe=this.loose;Z=Z.trim(),b("range",Z,pe);var ge=pe?P[le]:P[oe];Z=Z.replace(ge,W),b("hyphen replace",Z),Z=Z.replace(P[ce],"$1$2$3"),b("comparator trim",Z,P[ce]),Z=(Z=(Z=Z.replace(P[x],"$1~")).replace(P[F],"$1^")).split(/\s+/).join(" ");var Ne=pe?P[O]:P[ee],Be=Z.split(" ").map(function(Je){return function(Ge,ke){return b("comp",Ge),Ge=function(rt,G){return rt.trim().split(/\s+/).map(function(Q){return function(fe,Ue){b("caret",fe,Ue);var He=Ue?P[H]:P[K];return fe.replace(He,function(Ze,qe,We,nt,ot){var ht;return b("caret",fe,Ze,qe,We,nt,ot),z(qe)?ht="":z(We)?ht=">="+qe+".0.0 <"+(+qe+1)+".0.0":z(nt)?ht=qe==="0"?">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+".0 <"+(+qe+1)+".0.0":ot?(b("replaceCaret pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),ht=qe==="0"?We==="0"?">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+We+"."+(+nt+1):">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+nt+ot+" <"+(+qe+1)+".0.0"):(b("no pr"),ht=qe==="0"?We==="0"?">="+qe+"."+We+"."+nt+" <"+qe+"."+We+"."+(+nt+1):">="+qe+"."+We+"."+nt+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+nt+" <"+(+qe+1)+".0.0"),b("caret return",ht),ht})}(Q,G)}).join(" ")}(Ge,ke),b("caret",Ge),Ge=function(rt,G){return rt.trim().split(/\s+/).map(function(Q){return function(fe,Ue){var He=Ue?P[L]:P[D];return fe.replace(He,function(Ze,qe,We,nt,ot){var ht;return b("tilde",fe,Ze,qe,We,nt,ot),z(qe)?ht="":z(We)?ht=">="+qe+".0.0 <"+(+qe+1)+".0.0":z(nt)?ht=">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":ot?(b("replaceTilde pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),ht=">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+(+We+1)+".0"):ht=">="+qe+"."+We+"."+nt+" <"+qe+"."+(+We+1)+".0",b("tilde return",ht),ht})}(Q,G)}).join(" ")}(Ge,ke),b("tildes",Ge),Ge=function(rt,G){return b("replaceXRanges",rt,G),rt.split(/\s+/).map(function(Q){return function(fe,Ue){fe=fe.trim();var He=Ue?P[k]:P[p];return fe.replace(He,function(Ze,qe,We,nt,ot,ht){b("xRange",fe,Ze,qe,We,nt,ot,ht);var kt=z(We),it=kt||z(nt),ut=it||z(ot);return qe==="="&&ut&&(qe=""),kt?Ze=qe===">"||qe==="<"?"<0.0.0":"*":qe&&ut?(it&&(nt=0),ut&&(ot=0),qe===">"?(qe=">=",it?(We=+We+1,nt=0,ot=0):ut&&(nt=+nt+1,ot=0)):qe==="<="&&(qe="<",it?We=+We+1:nt=+nt+1),Ze=qe+We+"."+nt+"."+ot):it?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":ut&&(Ze=">="+We+"."+nt+".0 <"+We+"."+(+nt+1)+".0"),b("xRange return",Ze),Ze})}(Q,G)}).join(" ")}(Ge,ke),b("xrange",Ge),Ge=function(rt,G){return b("replaceStars",rt,G),rt.trim().replace(P[te],"")}(Ge,ke),b("stars",Ge),Ge}(Je,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(Ne)})),Be=Be.map(function(Je){return new X(Je,pe)})},C.prototype.intersects=function(Z,pe){if(!(Z instanceof C))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Z.set.some(function(Be){return Be.every(function(Je){return Ne.intersects(Je,pe)})})})})},e.toComparators=function(Z,pe){return new C(Z,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},C.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ne(Z,this.loose));for(var pe=0;pe<this.set.length;pe++)if(j(this.set[pe],Z))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Z,pe,ge){var Ne=null,Be=null;try{var Je=new C(pe,ge)}catch{return null}return Z.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==-1||(Be=new ne(Ne=Ge,ge)))}),Ne},e.minSatisfying=function(Z,pe,ge){var Ne=null,Be=null;try{var Je=new C(pe,ge)}catch{return null}return Z.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==1||(Be=new ne(Ne=Ge,ge)))}),Ne},e.validRange=function(Z,pe){try{return new C(Z,pe).range||"*"}catch{return null}},e.ltr=function(Z,pe,ge){return de(Z,pe,"<",ge)},e.gtr=function(Z,pe,ge){return de(Z,pe,">",ge)},e.outside=de,e.prerelease=function(Z,pe){var ge=be(Z,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,pe,ge){return Z=new C(Z,ge),pe=new C(pe,ge),Z.intersects(pe)},e.coerce=function(Z){if(Z instanceof ne)return Z;if(typeof Z!="string")return null;var pe=Z.match(P[U]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,a(1))},function(ie,e){var a,v,b=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function P(u){if(a===setTimeout)return setTimeout(u,0);if((a===M||!a)&&setTimeout)return a=setTimeout,setTimeout(u,0);try{return a(u,0)}catch{try{return a.call(null,u,0)}catch{return a.call(this,u,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:M}catch{a=M}try{v=typeof clearTimeout=="function"?clearTimeout:y}catch{v=y}})();var w,T=[],R=!1,S=-1;function m(){R&&w&&(R=!1,w.length?T=w.concat(T):S=-1,T.length&&I())}function I(){if(!R){var u=P(m);R=!0;for(var o=T.length;o;){for(w=T,T=[];++S<o;)w&&w[S].run();S=-1,o=T.length}w=null,R=!1,function(g){if(v===clearTimeout)return clearTimeout(g);if((v===y||!v)&&clearTimeout)return v=clearTimeout,clearTimeout(g);try{v(g)}catch{try{return v.call(null,g)}catch{return v.call(this,g)}}}(u)}}function f(u,o){this.fun=u,this.array=o}function d(){}b.nextTick=function(u){var o=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)o[g-1]=arguments[g];T.push(new f(u,o)),T.length!==1||R||P(I)},f.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=d,b.addListener=d,b.once=d,b.off=d,b.removeListener=d,b.removeAllListeners=d,b.emit=d,b.prependListener=d,b.prependOnceListener=d,b.listeners=function(u){return[]},b.binding=function(u){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(u){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(ye[109],De([1,0,11,7]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(l){const E=l;return E?typeof E.read=="function":!1}e.isReadable=b;function M(l){const E=l;return E?[E.on,E.pause,E.resume,E.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function y(l){const E=l;return E?M(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=y;function P(l,E){return new w(l,E)}e.newWriteableStream=P;class w{constructor(E,i){this.reducer=E,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(i=>i(E))}emitError(E){this.listeners.error.length===0?(0,a.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(i=>i(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,i){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(E,i){if(this.state.destroyed)return;let h;switch(E){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const r=h.indexOf(i);r>=0&&h.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function T(l,E){const i=[];let h;for(;(h=l.read())!==null;)i.push(h);return E(i)}e.consumeReadable=T;function R(l,E,i){const h=[];let r;for(;(r=l.read())!==null&&h.length<i;)h.push(r);return r===null&&h.length>0?E(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return l.read()}}}e.peekReadable=R;function S(l,E){return new Promise((i,h)=>{const r=[];m(l,{onData:n=>{E&&r.push(n)},onError:n=>{E?h(n):i(void 0)},onEnd:()=>{i(E?E(r):void 0)}})})}e.consumeStream=S;function m(l,E){let i=!1;return l.on("error",h=>{i||E.onError(h)}),l.on("end",()=>{i||E.onEnd()}),l.on("data",h=>{i||E.onData(h)}),(0,v.toDisposable)(()=>i=!0)}e.listenStream=m;function I(l,E){return new Promise((i,h)=>{const r=new v.DisposableStore,n=[],s=_=>{if(n.push(_),n.length>E)return r.dispose(),l.pause(),i({stream:l,buffer:n,ended:!1})},t=_=>h(_),c=()=>i({stream:l,buffer:n,ended:!0});r.add((0,v.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),r.add((0,v.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),r.add((0,v.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=I;function f(l,E){const i=P(E);return i.end(l),i}e.toStream=f;function d(){const l=P(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=d;function u(l){let E=!1;return{read:()=>E?null:(E=!0,l)}}e.toReadable=u;function o(l,E,i){const h=P(i);return m(l,{onData:r=>h.write(E.data(r)),onError:r=>h.error(E.error?E.error(r):r),onEnd:()=>h.end()}),h}e.transform=o;function g(l,E,i){let h=!1;return{read:()=>{const r=E.read();return h?r:(h=!0,r!==null?i([l,r]):l)}}}e.prefixedReadable=g;function A(l,E,i){let h=!1;const r=P(i);return m(E,{onData:n=>h?r.write(n):(h=!0,r.write(i([l,n]))),onError:n=>r.error(n),onEnd:()=>{h||(h=!0,r.write(l)),r.end()}}),r}e.prefixedStream=A}),define(ye[23],De([1,0,109]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const v=typeof Buffer<"u";let b,M;class y{constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}static alloc(_){return v?new y(Buffer.allocUnsafe(_)):new y(new Uint8Array(_))}static wrap(_){return v&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new y(_)}static fromString(_,p){return!(p?.dontUseNodeBuffer||!1)&&v?new y(Buffer.from(_)):(b||(b=new TextEncoder),new y(b.encode(_)))}static fromByteArray(_){const p=y.alloc(_.length);for(let k=0,U=_.length;k<U;k++)p.buffer[k]=_[k];return p}static concat(_,p){if(typeof p>"u"){p=0;for(let V=0,x=_.length;V<x;V++)p+=_[V].byteLength}const k=y.alloc(p);let U=0;for(let V=0,x=_.length;V<x;V++){const D=_[V];k.set(D,U),U+=D.byteLength}return k}clone(){const _=y.alloc(this.byteLength);return _.set(this),_}toString(){return v?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(_,p){return new y(this.buffer.subarray(_,p))}set(_,p){if(_ instanceof y)this.buffer.set(_.buffer,p);else if(_ instanceof Uint8Array)this.buffer.set(_,p);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),p);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return T(this.buffer,_)}writeUInt32BE(_,p){R(this.buffer,_,p)}readUInt32LE(_){return S(this.buffer,_)}writeUInt32LE(_,p){m(this.buffer,_,p)}readUInt8(_){return I(this.buffer,_)}writeUInt8(_,p){f(this.buffer,_,p)}}e.VSBuffer=y;function P(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0}e.readUInt16LE=P;function w(c,_,p){c[p+0]=_&255,_=_>>>8,c[p+1]=_&255}e.writeUInt16LE=w;function T(c,_){return c[_]*2**24+c[_+1]*2**16+c[_+2]*2**8+c[_+3]}e.readUInt32BE=T;function R(c,_,p){c[p+3]=_,_=_>>>8,c[p+2]=_,_=_>>>8,c[p+1]=_,_=_>>>8,c[p]=_}e.writeUInt32BE=R;function S(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0|c[_+2]<<16>>>0|c[_+3]<<24>>>0}e.readUInt32LE=S;function m(c,_,p){c[p+0]=_&255,_=_>>>8,c[p+1]=_&255,_=_>>>8,c[p+2]=_&255,_=_>>>8,c[p+3]=_&255}e.writeUInt32LE=m;function I(c,_){return c[_]}e.readUInt8=I;function f(c,_,p){c[p]=_}e.writeUInt8=f;function d(c){return a.consumeReadable(c,_=>y.concat(_))}e.readableToBuffer=d;function u(c){return a.toReadable(c)}e.bufferToReadable=u;function o(c){return a.consumeStream(c,_=>y.concat(_))}e.streamToBuffer=o;async function g(c){return c.ended?y.concat(c.buffer):y.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=g;function A(c){return a.toStream(c,_=>y.concat(_))}e.bufferToStream=A;function l(c){return a.transform(c,{data:_=>typeof _=="string"?y.fromString(_):y.wrap(_)},_=>y.concat(_))}e.streamToBufferReadableStream=l;function E(c){return a.newWriteableStream(_=>y.concat(_),c)}e.newWriteableBufferStream=E;function i(c,_){return a.prefixedReadable(c,_,p=>y.concat(p))}e.prefixedBufferReadable=i;function h(c,_){return a.prefixedStream(c,_,p=>y.concat(p))}e.prefixedBufferStream=h;function r(c){let _=0,p=0,k=0;const U=new Uint8Array(Math.floor(c.length/4*3)),V=D=>{switch(p){case 3:U[k++]=_|D,p=0;break;case 2:U[k++]=_|D>>>2,_=D<<6,p=3;break;case 1:U[k++]=_|D>>>4,_=D<<4,p=2;break;default:_=D<<2,p=1}};for(let D=0;D<c.length;D++){const L=c.charCodeAt(D);if(L>=65&&L<=90)V(L-65);else if(L>=97&&L<=122)V(L-97+26);else if(L>=48&&L<=57)V(L-48+52);else if(L===43||L===45)V(62);else if(L===47||L===95)V(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${c[D]}`)}}const x=k;for(;p>0;)V(0);return y.wrap(U).slice(0,x)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},_=!0,p=!1){const k=p?s:n;let U="";const V=c.byteLength%3;let x=0;for(;x<c.byteLength-V;x+=3){const D=c[x+0],L=c[x+1],B=c[x+2];U+=k[D>>>2],U+=k[(D<<4|L>>>4)&63],U+=k[(L<<2|B>>>6)&63],U+=k[B&63]}if(V===1){const D=c[x+0];U+=k[D>>>2],U+=k[D<<4&63],_&&(U+="==")}else if(V===2){const D=c[x+0],L=c[x+1];U+=k[D>>>2],U+=k[(D<<4|L>>>4)&63],U+=k[L<<2&63],_&&(U+="=")}return U}e.encodeBase64=t}),define(ye[42],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function v(b){return a.test(b)}e.isUUID=v,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),y=[];for(let P=0;P<256;P++)y.push(P.toString(16).padStart(2,"0"));return function(){b(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let w=0,T="";return T+=y[M[w++]],T+=y[M[w++]],T+=y[M[w++]],T+=y[M[w++]],T+="-",T+=y[M[w++]],T+=y[M[w++]],T+="-",T+=y[M[w++]],T+=y[M[w++]],T+="-",T+=y[M[w++]],T+=y[M[w++]],T+="-",T+=y[M[w++]],T+=y[M[w++]],T+=y[M[w++]],T+=y[M[w++]],T+=y[M[w++]],T+=y[M[w++]],T}}()}),define(ye[110],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[111],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class v{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let w=0,T=P.notIn.length;w<T;w++)switch(P.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,w){if(P.getTokenCount()===0)return!0;const T=P.findTokenIndexAtOffset(w-2),R=P.getStandardTokenType(T);return this.isOK(R)}_findNeutralCharacterInRange(P,w){for(let T=P;T<=w;T++){const R=String.fromCharCode(T);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=v;class b{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of P)M(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),M(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),M(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),M(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&M(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=b;function M(y,P,w){y.has(P)?y.get(P).push(w):y.set(P,[w])}}),define(ye[112],De([17,18]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ye[113],De([1,0,112]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const v=60,b=v*60,M=b*24,y=M*7,P=M*30,w=M*365;function T(S,m,I){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,a.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let d;return f<v?(d=f,m?d===1?I?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):I?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?I?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):I?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):f<b?(d=Math.floor(f/v),m?d===1?I?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):I?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?I?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):I?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):f<M?(d=Math.floor(f/b),m?d===1?I?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):I?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?I?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):I?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):f<y?(d=Math.floor(f/M),m?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):f<P?(d=Math.floor(f/y),m?d===1?I?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):I?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?I?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):I?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):f<w?(d=Math.floor(f/P),m?d===1?I?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):I?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?I?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):I?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(f/w),m?d===1?I?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):I?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?I?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):I?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=T;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[114],De([17,18]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ye[43],De([1,0,16,10,114]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(S,m){return m&&(S.stack||S.stacktrace)?b.localize(0,null,P(S),y(S.stack)||y(S.stacktrace)):P(S)}function y(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?b.localize(1,null,S.message):S.message||b.localize(2,null)}function w(S=null,m=!1){if(!S)return b.localize(3,null);if(Array.isArray(S)){const I=a.coalesce(S),f=w(I[0],m);return I.length>1?b.localize(4,null,f,I.length):f}if(v.isString(S))return S;if(S.detail){const I=S.detail;if(I.error)return M(I.error,m);if(I.exception)return M(I.exception,m)}return S.stack?M(S,m):S.message?S.message:b.localize(5,null)}e.toErrorMessage=w;function T(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=T;function R(S,m){let I;return typeof S=="string"?I=new Error(S):I=S,I.actions=m,I}e.createErrorWithActions=R}),define(ye[74],De([1,0,19]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const S=(0,a.extname)(R),m=v[S.toLowerCase()];return m!==void 0?m:y(R)}e.getMediaOrTextMime=M;function y(R){const S=(0,a.extname)(R);return b[S.toLowerCase()]}e.getMediaMime=y;function P(R){for(const S in b)if(b[S]===R)return S}e.getExtensionForMimeType=P;const w=/^(.+)\/(.+?)(;.+)?$/;function T(R,S){const m=w.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:R}e.normalizeMimeType=T}),define(ye[37],De([1,0,19,21,9,10]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function P(s){return s.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function w(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function T(s,t=a.posix.sep){if(!s)return"";const c=s.length,_=s.charCodeAt(0);if(y(_)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let k=3;const U=k;for(;k<c&&!y(s.charCodeAt(k));k++);if(U!==k&&!y(s.charCodeAt(k+1))){for(k+=1;k<c;k++)if(y(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,t)}}return t}else if(o(_)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+t:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<c;p++)if(y(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=T;function R(s){if(!v.isWindows||!s||s.length<5)return!1;let t=s.charCodeAt(0);if(t!==92||(t=s.charCodeAt(1),t!==92))return!1;let c=2;const _=c;for(;c<s.length&&(t=s.charCodeAt(c),t!==92);c++);return!(_===c||(t=s.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=R;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,t=v.isWindows){const c=t?S:m;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||t&&I.test(s)||s==="."||s===".."||t&&s[s.length-1]==="."||t&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function d(s,t,c){const _=s===t;return!c||_?_:!s||!t?!1:(0,b.equalsIgnoreCase)(s,t)}e.isEqual=d;function u(s,t,c,_=a.sep){if(s===t)return!0;if(!s||!t||t.length>s.length)return!1;if(c){if(!(0,b.startsWithIgnoreCase)(s,t))return!1;if(t.length===s.length)return!0;let k=t.length;return t.charAt(t.length-1)===_&&k--,s.charAt(k)===_}return t.charAt(t.length-1)!==_&&(t+=_),s.indexOf(t)===0}e.isEqualOrParent=u;function o(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=o;function g(s,t){return v.isWindows&&s.endsWith(":")&&(s+=a.sep),(0,a.isAbsolute)(s)||(s=(0,a.join)(t,s)),s=(0,a.normalize)(s),v.isWindows?(s=(0,b.rtrim)(s,a.sep),s.endsWith(":")&&(s+=a.sep)):(s=(0,b.rtrim)(s,a.sep),s||(s=a.sep)),s}e.sanitizeFilePath=g;function A(s){const t=(0,a.normalize)(s);return v.isWindows?s.length>3?!1:l(t)&&(s.length===2||t.charCodeAt(2)===92):t===a.posix.sep}e.isRootOrDriveLetter=A;function l(s,t=v.isWindows){return t?o(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function E(s){return l(s)?s[0]:void 0}e.getDriveLetter=E;function i(s,t,c){return t.length>s.length?-1:s===t?0:(c&&(s=s.toLowerCase(),t=t.toLowerCase()),s.indexOf(t))}e.indexOfPath=i;function h(s){const t=s.split(":");let c,_,p;for(const k of t){const U=Number(k);(0,M.isNumber)(U)?_===void 0?_=U:p===void 0&&(p=U):c=c?[c,k].join(":"):k}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:_!==void 0?_:void 0,column:p!==void 0?p:_!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,t,c=8){let _="";for(let k=0;k<c;k++)_+=r.charAt(Math.floor(Math.random()*r.length));let p;return t?p=`${t}-${_}`:p=_,s?(0,a.join)(s,p):p}e.randomPath=n}),define(ye[25],De([1,0,16,9]),function(ie,e,a,v){"use strict";var b,M,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,n,s){let t=r.get(n);return t===void 0&&(t=s,r.set(n,t)),t}e.getOrSet=P;function w(r){const n=[];return r.forEach((s,t)=>{n.push(`${t} => ${s}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=w;function T(r){const n=[];return r.forEach(s=>{n.push(s)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),t=this._value.charCodeAt(this._pos);return s-t}value(){return this._value[this._pos]}}e.StringIterator=R;class S{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,v.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class m{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const t=this._value.charCodeAt(s);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,v.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var I;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(I||(I={}));class f{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,v.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,v.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,v.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,v.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(u||(u={}));class o{constructor(n){this._iter=n}static forUris(n=()=>!1,s=()=>!1){return new o(new f(n,s))}static forPaths(n=!1){return new o(new m(void 0,!n))}static forStrings(){return new o(new R)}static forConfigKeys(){return new o(new S)}clear(){this._root=void 0}fill(n,s){if(s){const t=s.slice(0);(0,a.shuffle)(t);for(const c of t)this.set(c,n)}else{const t=n.slice(0);(0,a.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(n,s){const t=this._iter.reset(n);let c;this._root||(this._root=new d,this._root.segment=t.value());const _=[];for(c=this._root;;){const k=t.cmp(c.segment);if(k>0)c.left||(c.left=new d,c.left.segment=t.value()),_.push([-1,c]),c=c.left;else if(k<0)c.right||(c.right=new d,c.right.segment=t.value()),_.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new d,c.mid.segment=t.value()),_.push([0,c]),c=c.mid;else break}const p=c.value;c.value=s,c.key=n;for(let k=_.length-1;k>=0;k--){const U=_[k][1];U.updateHeight();const V=U.balanceFactor();if(V<-1||V>1){const x=_[k][0],D=_[k+1][0];if(x===1&&D===1)_[k][1]=U.rotateLeft();else if(x===-1&&D===-1)_[k][1]=U.rotateRight();else if(x===1&&D===-1)U.right=_[k+1][1]=_[k+1][1].rotateRight(),_[k][1]=U.rotateLeft();else if(x===-1&&D===1)U.left=_[k+1][1]=_[k+1][1].rotateLeft(),_[k][1]=U.rotateRight();else throw new Error;if(k>0)switch(_[k-1][0]){case-1:_[k-1][1].left=_[k][1];break;case 1:_[k-1][1].right=_[k][1];break;case 0:_[k-1][1].mid=_[k][1];break}else this._root=_[0][1]}}return p}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let t=this._root;for(;t;){const c=s.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else break}return t}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const t=this._iter.reset(n),c=[];let _=this._root;for(;_;){const p=t.cmp(_.segment);if(p>0)c.push([-1,_]),_=_.left;else if(p<0)c.push([1,_]),_=_.right;else if(t.hasNext())t.next(),c.push([0,_]),_=_.mid;else break}if(!!_){if(s?(_.left=void 0,_.mid=void 0,_.right=void 0,_.height=1):(_.key=void 0,_.value=void 0),!_.mid&&!_.value)if(_.left&&_.right){const p=this._min(_.right),{key:k,value:U,segment:V}=p;this._delete(p.key,!1),_.key=k,_.value=U,_.segment=V}else{const p=_.left??_.right;if(c.length>0){const[k,U]=c[c.length-1];switch(k){case-1:U.left=p;break;case 0:U.mid=p;break;case 1:U.right=p;break}}else this._root=p}for(let p=c.length-1;p>=0;p--){const k=c[p][1];k.updateHeight();const U=k.balanceFactor();if(U>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),c[p][1]=k.rotateLeft()):U<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),c[p][1]=k.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let t=this._root,c;for(;t;){const _=s.cmp(t.segment);if(_>0)t=t.left;else if(_<0)t=t.right;else if(s.hasNext())s.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(n){const s=this._iter.reset(n);let t=this._root;for(;t;){const c=s.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(n){for(const[s,t]of this)n(t,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const t=s.balanceFactor();return t<-1||t>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=o;class g{constructor(n,s){this.uri=n,this.value=s}}class A{constructor(n,s){this[b]="ResourceMap",n instanceof A?(this.map=new Map(n.map),this.toKey=s??A.defaultToKey):(this.map=new Map,this.toKey=n??A.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new g(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[t,c]of this.map)n(c.value,c.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=A,A.defaultToKey=r=>r.toString();class l{constructor(n,s){this[M]="ResourceSet",!n||typeof n=="function"?this._map=new A(n):(this._map=new A(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((t,c)=>n.call(s,c,c,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var E;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class i{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const t=this._map.get(n);if(!!t)return s!==0&&this.touch(t,s),t.value}set(n,s,t=0){let c=this._map.get(n);if(c)c.value=s,t!==0&&this.touch(c,t);else{switch(c={key:n,value:s,next:void 0,previous:void 0},t){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const t=this._state;let c=this._head;for(;c;){if(s?n.bind(s)(c.value,c.key,this):n(c.value,c.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.key,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}values(){const n=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.value,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}entries(){const n=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:[t.key,t.value],done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,t=this.size;for(;s&&t>n;)this._map.delete(s.key),s=s.next,t--;this._head=s,this._size=t,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,t=n.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const t=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(t.previous=c,c.next=t),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const t=n.next,c=n.previous;n===this._head?(t.previous=void 0,this._head=t):(t.previous=c,c.next=t),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,t)=>{n.push([t,s])}),n}fromJSON(n){this.clear();for(const[s,t]of n)this.set(s,t)}}e.LinkedMap=i;class h extends i{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h}),define(ye[115],De([1,0,25,9]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...X){return function(Y,C){for(let z=0,W=X.length;z<W;z++){const j=X[z](Y,C);if(j)return j}return null}}e.or=b,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(X,Y,C){if(!C||C.length<Y.length)return null;let z;return X?z=v.startsWithIgnoreCase(C,Y):z=C.indexOf(Y)===0,z?Y.length>0?[{start:0,end:Y.length}]:[]:null}function y(X,Y){const C=Y.toLowerCase().indexOf(X.toLowerCase());return C===-1?null:[{start:C,end:C+X.length}]}e.matchesContiguousSubString=y;function P(X,Y){return w(X.toLowerCase(),Y.toLowerCase(),0,0)}e.matchesSubString=P;function w(X,Y,C,z){if(C===X.length)return[];if(z===Y.length)return null;if(X[C]===Y[z]){let W=null;return(W=w(X,Y,C+1,z+1))?o({start:z,end:z+1},W):null}return w(X,Y,C,z+1)}function T(X){return 97<=X&&X<=122}function R(X){return 65<=X&&X<=90}e.isUpper=R;function S(X){return 48<=X&&X<=57}function m(X){return X===32||X===9||X===10||X===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(X=>I.add(X.charCodeAt(0)));function f(X){return m(X)||I.has(X)}function d(X,Y){return X===Y||f(X)&&f(Y)}function u(X){return T(X)||R(X)||S(X)}function o(X,Y){return Y.length===0?Y=[X]:X.end===Y[0].start?Y[0].start=X.start:Y.unshift(X),Y}function g(X,Y){for(let C=Y;C<X.length;C++){const z=X.charCodeAt(C);if(R(z)||S(z)||C>0&&!u(X.charCodeAt(C-1)))return C}return X.length}function A(X,Y,C,z){if(C===X.length)return[];if(z===Y.length)return null;if(X[C]!==Y[z].toLowerCase())return null;{let W=null,j=z+1;for(W=A(X,Y,C+1,z+1);!W&&(j=g(Y,j))<Y.length;)W=A(X,Y,C+1,j),j++;return W===null?null:o({start:z,end:z+1},W)}}function l(X){let Y=0,C=0,z=0,W=0,j=0;for(let ge=0;ge<X.length;ge++)j=X.charCodeAt(ge),R(j)&&Y++,T(j)&&C++,u(j)&&z++,S(j)&&W++;const se=Y/X.length,de=C/X.length,Z=z/X.length,pe=W/X.length;return{upperPercent:se,lowerPercent:de,alphaPercent:Z,numericPercent:pe}}function E(X){const{upperPercent:Y,lowerPercent:C}=X;return C===0&&Y>.6}function i(X){const{upperPercent:Y,lowerPercent:C,alphaPercent:z,numericPercent:W}=X;return C>.2&&Y<.8&&z>.6&&W<.2}function h(X){let Y=0,C=0,z=0,W=0;for(let j=0;j<X.length;j++)z=X.charCodeAt(j),R(z)&&Y++,T(z)&&C++,m(z)&&W++;return(Y===0||C===0)&&W===0?X.length<=30:Y<=5}function r(X,Y){if(!Y||(Y=Y.trim(),Y.length===0)||!h(X)||Y.length>60)return null;const C=l(Y);if(!i(C)){if(!E(C))return null;Y=Y.toLowerCase()}let z=null,W=0;for(X=X.toLowerCase();W<Y.length&&(z=A(X,Y,0,W))===null;)W=g(Y,W+1);return z}e.matchesCamelCase=r;function n(X,Y,C=!1){if(!Y||Y.length===0)return null;let z=null,W=0;for(X=X.toLowerCase(),Y=Y.toLowerCase();W<Y.length&&(z=s(X,Y,0,W,C))===null;)W=t(Y,W+1);return z}e.matchesWords=n;function s(X,Y,C,z,W){if(C===X.length)return[];if(z===Y.length)return null;if(d(X.charCodeAt(C),Y.charCodeAt(z))){let j=null,se=z+1;if(j=s(X,Y,C+1,z+1,W),!W)for(;!j&&(se=t(Y,se))<Y.length;)j=s(X,Y,C+1,se,W),se++;return j?X.charCodeAt(C)!==Y.charCodeAt(z)?j:o({start:z,end:z+1},j):null}else return null}function t(X,Y){for(let C=Y;C<X.length;C++)if(f(X.charCodeAt(C))||C>0&&f(X.charCodeAt(C-1)))return C;return X.length}const c=b(e.matchesPrefix,r,y),_=b(e.matchesPrefix,r,P),p=new a.LRUCache(1e4);function k(X,Y,C=!1){if(typeof X!="string"||typeof Y!="string")return null;let z=p.get(X);z||(z=new RegExp(v.convertSimple2RegExpPattern(X),"i"),p.set(X,z));const W=z.exec(Y);return W?[{start:W.index,end:W.index+W[0].length}]:C?_(X,Y):c(X,Y)}e.matchesFuzzy=k;function U(X,Y){const C=xe(X,X.toLowerCase(),0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return C?x(C):null}e.matchesFuzzy2=U;function V(X,Y,C,z,W,j){const se=Math.min(13,X.length);for(;C<se;C++){const de=xe(X,Y,C,z,W,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(de)return de}return[0,j]}e.anyScore=V;function x(X){if(typeof X>"u")return[];const Y=[],C=X[1];for(let z=X.length-1;z>1;z--){const W=X[z]+C,j=Y[Y.length-1];j&&j.end===W?j.end=W+1:Y.push({start:W,end:W+1})}return Y}e.createMatches=x;const D=128;function L(){const X=[],Y=[];for(let C=0;C<=D;C++)Y[C]=0;for(let C=0;C<=D;C++)X.push(Y.slice(0));return X}function B(X){const Y=[];for(let C=0;C<=X;C++)Y[C]=0;return Y}const F=B(2*D),K=B(2*D),H=L(),O=L(),ee=L(),ce=!1;function oe(X,Y,C,z,W){function j(de,Z,pe=" "){for(;de.length<Z;)de=pe+de;return de}let se=` |   |${z.split("").map(de=>j(de,3)).join("|")}
`;for(let de=0;de<=C;de++)de===0?se+=" |":se+=`${Y[de-1]}|`,se+=X[de].slice(0,W+1).map(Z=>j(Z.toString(),3)).join("|")+`
`;return se}function le(X,Y,C,z){X=X.substr(Y),C=C.substr(z),console.log(oe(O,X,X.length,C,C.length)),console.log(oe(ee,X,X.length,C,C.length)),console.log(oe(H,X,X.length,C,C.length))}function te(X,Y){if(Y<0||Y>=X.length)return!1;const C=X.codePointAt(Y);switch(C){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!v.isEmojiImprecise(C)}}function Ee(X,Y){if(Y<0||Y>=X.length)return!1;switch(X.charCodeAt(Y)){case 32:case 9:return!0;default:return!1}}function be(X,Y,C){return Y[X]!==C[X]}function ne(X,Y,C,z,W,j,se=!1){for(;Y<C&&W<j;)X[Y]===z[W]&&(se&&(F[Y]=W),Y+=1),W+=1;return Y===C}e.isPatternInWord=ne;var ve;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Pe;(function(X){X.Default=[-100,0];function Y(C){return!C||C.length===2&&C[0]===-100&&C[1]===0}X.isDefault=Y})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Y,C){this.firstMatchCanBeWeak=Y,this.boostFullMatch=C}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function xe(X,Y,C,z,W,j,se=Fe.default){const de=X.length>D?D:X.length,Z=z.length>D?D:z.length;if(C>=de||j>=Z||de-C>Z-j||!ne(Y,C,de,W,j,Z,!0))return;Qe(de,Z,C,j,Y,W);let pe=1,ge=1,Ne=C,Be=j;const Je=[!1];for(pe=1,Ne=C;Ne<de;pe++,Ne++){const Q=F[Ne],fe=K[Ne],Ue=Ne+1<de?K[Ne+1]:Z;for(ge=Q-j+1,Be=Q;Be<Ue;ge++,Be++){let He=Number.MIN_SAFE_INTEGER,Ze=!1;Be<=fe&&(He=Ie(X,Y,Ne,C,z,W,Be,Z,j,H[pe-1][ge-1]===0,Je));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(Ze=!0,qe=He+O[pe-1][ge-1]);const We=Be>Q,nt=We?O[pe][ge-1]+(H[pe][ge-1]>0?-5:0):0,ot=Be>Q+1&&H[pe][ge-1]>0,ht=ot?O[pe][ge-2]+(H[pe][ge-2]>0?-5:0):0;if(ot&&(!We||ht>=nt)&&(!Ze||ht>=qe))O[pe][ge]=ht,ee[pe][ge]=3,H[pe][ge]=0;else if(We&&(!Ze||nt>=qe))O[pe][ge]=nt,ee[pe][ge]=2,H[pe][ge]=0;else if(Ze)O[pe][ge]=qe,ee[pe][ge]=1,H[pe][ge]=H[pe-1][ge-1]+1;else throw new Error("not possible")}}if(ce&&le(X,C,z,j),!Je[0]&&!se.firstMatchCanBeWeak)return;pe--,ge--;const Ge=[O[pe][ge],j];let ke=0,rt=0;for(;pe>=1;){let Q=ge;do{const fe=ee[pe][Q];if(fe===3)Q=Q-2;else if(fe===2)Q=Q-1;else break}while(Q>=1);ke>1&&Y[C+pe-1]===W[j+ge-1]&&!be(Q+j-1,z,W)&&ke+1>H[pe][Q]&&(Q=ge),Q===ge?ke++:ke=1,rt||(rt=Q),pe--,ge=Q-1,Ge.push(ge)}Z===de&&se.boostFullMatch&&(Ge[0]+=2);const G=rt-de;return Ge[0]-=G,Ge}e.fuzzyScore=xe;function Qe(X,Y,C,z,W,j){let se=X-1,de=Y-1;for(;se>=C&&de>=z;)W[se]===j[de]&&(K[se]=de,se--),de--}function Ie(X,Y,C,z,W,j,se,de,Z,pe,ge){if(Y[C]!==j[se])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return se===C-z?Ne=X[C]===W[se]?7:5:be(se,W,j)&&(se===0||!be(se-1,W,j))?(Ne=X[C]===W[se]?7:5,Be=!0):te(j,se)&&(se===0||!te(j,se-1))?Ne=5:(te(j,se-1)||Ee(j,se-1))&&(Ne=5,Be=!0),Ne>1&&C===z&&(ge[0]=!0),Be||(Be=be(se,W,j)||te(j,se-1)||Ee(j,se-1)),C===z?se>Z&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,se+1===de&&(Ne-=Be?3:5),Ne}function Se(X,Y,C,z,W,j,se){return ae(X,Y,C,z,W,j,!0,se)}e.fuzzyScoreGracefulAggressive=Se;function Te(X,Y,C,z,W,j,se){return ae(X,Y,C,z,W,j,!1,se)}e.fuzzyScoreGraceful=Te;function ae(X,Y,C,z,W,j,se,de){let Z=xe(X,Y,C,z,W,j,de);if(Z&&!se)return Z;if(X.length>=3){const pe=Math.min(7,X.length-1);for(let ge=C+1;ge<pe;ge++){const Ne=ue(X,ge);if(Ne){const Be=xe(Ne,Ne.toLowerCase(),C,z,W,j,de);Be&&(Be[0]-=3,(!Z||Be[0]>Z[0])&&(Z=Be))}}}return Z}function ue(X,Y){if(Y+1>=X.length)return;const C=X[Y],z=X[Y+1];if(C!==z)return X.slice(0,Y)+z+C+X.slice(Y+2)}}),define(ye[116],De([1,0,117,115,9]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(a.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${M.source}`,"g");function w(u){return u.replace(P,(o,g)=>g?o:`\\${o}`)}e.escapeIcons=w;const T=new RegExp(`\\\\${M.source}`,"g");function R(u){return u.replace(T,o=>`\\${o}`)}e.markdownEscapeEscapedIcons=R;const S=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(S,(o,g,A,l)=>A?o:g||l||"")}e.stripIcons=m;function I(u){const o=u.indexOf(e.iconStartMarker);return o===-1?{text:u}:f(u,o)}e.parseLabelWithIcons=I;function f(u,o){const g=[];let A="";function l(c){if(c){A+=c;for(const _ of c)g.push(h)}}let E=-1,i="",h=0,r,n,s=o;const t=u.length;for(l(u.substr(0,o));s<t;)r=u[s],n=u[s+1],r===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(E=s,l(i),i=e.iconStartMarker,s++):r===")"&&E!==-1?(h+=s-E+1,E=-1,i=""):E!==-1?y.test(r)?i+=r:(l(i),E=-1,i=""):l(r),s++;return l(i),{text:A,iconOffsets:g}}function d(u,o,g=!1){const{text:A,iconOffsets:l}=o;if(!l||l.length===0)return(0,v.matchesFuzzy)(u,A,g);const E=(0,b.ltrim)(A," "),i=A.length-E.length,h=(0,v.matchesFuzzy)(u,E,g);if(h)for(const r of h){const n=l[r.start+i]+i;r.start+=n,r.end+=n}return h}e.matchesFuzzyIconAware=d}),define(ye[29],De([1,0,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var v;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(v||(v={})),function(b){const M="error",y="warning",P="warn",w="info",T="ignore";function R(m){return m?a.equalsIgnoreCase(M,m)?b.Error:a.equalsIgnoreCase(y,m)||a.equalsIgnoreCase(P,m)?b.Warning:a.equalsIgnoreCase(w,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=R;function S(m){switch(m){case b.Error:return M;case b.Warning:return y;case b.Info:return w;default:return T}}b.toString=S}(v||(v={})),e.default=v}),define(ye[56],De([1,0,23,9,2]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,P)}e.stringify=M;function y(T){let R=JSON.parse(T);return R=w(R),R}e.parse=y;function P(T,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,v.regExpFlags)(R)}:R}function w(T,R=0){if(!T||R>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return b.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 14:return new Date(T.source)}if(T instanceof a.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let S=0;S<T.length;++S)T[S]=w(T[S],R+1);else for(const S in T)Object.hasOwnProperty.call(T,S)&&(T[S]=w(T[S],R+1))}return T}e.revive=w}),define(ye[12],De([1,0,21,2]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${b.vscodeRemoteResource}`}set(w,T,R){this._hosts[w]=T,this._ports[w]=R}setConnectionToken(w,T){this._connectionTokens[w]=T}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const T=w.authority;let R=this._hosts[T];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const S=this._ports[T],m=this._connectionTokens[T];let I=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(I+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),v.URI.from({scheme:a.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${R}:${S}`,path:this._remoteResourcesPath,query:I})}}e.RemoteAuthorities=new M;class y{asBrowserUri(w,T){const R=this.toUri(w,T);return R.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===b.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${b.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?R.with({scheme:b.vscodeFileResource,authority:R.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(w,T){const R=this.toUri(w,T);return R.scheme===b.vscodeFileResource?R.with({scheme:b.file,authority:R.authority!==y.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(w,T){return v.URI.isUri(w)?w:v.URI.parse(T.toUrl(w))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(ye[22],De([1,0,37,12,19,21,9,2]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=w;class T{constructor(f){this._ignorePathCasing=f}compare(f,d,u=!1){return f===d?0:(0,y.compare)(this.getComparisonKey(f,u),this.getComparisonKey(d,u))}isEqual(f,d,u=!1){return f===d?!0:!f||!d?!1:this.getComparisonKey(f,u)===this.getComparisonKey(d,u)}getComparisonKey(f,d=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,d,u=!1){if(f.scheme===d.scheme){if(f.scheme===v.Schemas.file)return a.isEqualOrParent(w(f),w(d),this._ignorePathCasing(f))&&f.query===d.query&&(u||f.fragment===d.fragment);if((0,e.isEqualAuthority)(f.authority,d.authority))return a.isEqualOrParent(f.path,d.path,this._ignorePathCasing(f),"/")&&f.query===d.query&&(u||f.fragment===d.fragment)}return!1}joinPath(f,...d){return P.URI.joinPath(f,...d)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return b.posix.basename(f.path)}extname(f){return b.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let d;return f.scheme===v.Schemas.file?d=P.URI.file(b.dirname(w(f))).path:(d=b.posix.dirname(f.path),f.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),d="/")),f.with({path:d})}normalizePath(f){if(!f.path.length)return f;let d;return f.scheme===v.Schemas.file?d=P.URI.file(b.normalize(w(f))).path:d=b.posix.normalize(f.path),f.with({path:d})}relativePath(f,d){if(f.scheme!==d.scheme||!(0,e.isEqualAuthority)(f.authority,d.authority))return;if(f.scheme===v.Schemas.file){const g=b.relative(w(f),w(d));return M.isWindows?a.toSlashes(g):g}let u=f.path||"/";const o=d.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const A=Math.min(u.length,o.length);g<A&&!(u.charCodeAt(g)!==o.charCodeAt(g)&&u.charAt(g).toLowerCase()!==o.charAt(g).toLowerCase());g++);u=o.substr(0,g)+u.substr(g)}return b.posix.relative(u,o)}resolvePath(f,d){if(f.scheme===v.Schemas.file){const u=P.URI.file(b.resolve(w(f),d));return f.with({authority:u.authority,path:u.path})}return d=a.toPosixPath(d),f.with({path:b.posix.resolve(f.path,d)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,d){return f===d||f!==void 0&&d!==void 0&&(0,y.equalsIgnoreCase)(f,d)}hasTrailingPathSeparator(f,d=b.sep){if(f.scheme===v.Schemas.file){const u=w(f);return u.length>a.getRoot(u).length&&u[u.length-1]===d}else{const u=f.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,d=b.sep){return(0,e.hasTrailingPathSeparator)(f,d)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,d=b.sep){let u=!1;if(f.scheme===v.Schemas.file){const o=w(f);u=o!==void 0&&o.length===a.getRoot(o).length&&o[o.length-1]===d}else{d="/";const o=f.path;u=o.length===1&&o.charCodeAt(o.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(f,d)?f.with({path:f.path+"/"}):f}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(I=>I.scheme===v.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(I,f){const d=[];for(let u=0;u<I.length;u++){const o=f(I[u]);I.some((g,A)=>A===u?!1:(0,e.isEqualOrParent)(o,f(g)))||d.push(I[u])}return d}e.distinctParents=R;var S;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function f(d){const u=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(A=>{const[l,E]=A.split(":");l&&E&&u.set(l,E)});const g=d.path.substring(0,d.path.indexOf(";"));return g&&u.set(I.META_DATA_MIME,g),u}I.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function m(I,f,d){if(f){let u=I.path;return u&&u[0]!==b.posix.sep&&(u=b.posix.sep+u),I.with({scheme:d,authority:f,path:u})}return I.with({scheme:d})}e.toLocalResource=m}),define(ye[14],De([1,0,20,11,5,7,22,21]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(be){return!!be&&typeof be.then=="function"}e.isThenable=w;function T(be){const ne=new a.CancellationTokenSource,ve=be(ne.token),Pe=new Promise((Fe,xe)=>{const Qe=ne.token.onCancellationRequested(()=>{Qe.dispose(),ne.dispose(),xe(new v.CancellationError)});Promise.resolve(ve).then(Ie=>{Qe.dispose(),ne.dispose(),Fe(Ie)},Ie=>{Qe.dispose(),ne.dispose(),xe(Ie)})});return new class{cancel(){ne.cancel()}then(Fe,xe){return Pe.then(Fe,xe)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=T;function R(be,ne,ve){return new Promise((Pe,Fe)=>{const xe=ne.onCancellationRequested(()=>{xe.dispose(),Pe(ve)});be.then(Pe,Fe).finally(()=>xe.dispose())})}e.raceCancellation=R;function S(be,ne){return new Promise((ve,Pe)=>{const Fe=ne.onCancellationRequested(()=>{Fe.dispose(),Pe(new v.CancellationError)});be.then(ve,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=S;async function m(be){let ne=-1;const ve=be.map((Fe,xe)=>Fe.then(Qe=>(ne=xe,Qe))),Pe=await Promise.race(ve);return be.forEach((Fe,xe)=>{xe!==ne&&Fe.cancel()}),Pe}e.raceCancellablePromises=m;function I(be,ne,ve){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),ve?.()},ne);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise(xe=>Pe=xe)])}e.raceTimeout=I;function f(be){return new Promise((ne,ve)=>{const Pe=be();w(Pe)?Pe.then(ne,ve):ne(Pe)})}e.asPromise=f;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(ve,ve).then(Pe)})}return new Promise((ve,Pe)=>{this.queuedPromise.then(ve,Pe)})}return this.activePromise=ne(),new Promise((ve,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=d;class u{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=u;class o{constructor(){this.promiseMap=new Map}queue(ne,ve){const Fe=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ne)===Fe&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Fe),Fe}}e.SequencerByKey=o;const g=(be,ne)=>{let ve=!0;const Pe=setTimeout(()=>{ve=!1,ne()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Pe),ve=!1}}},A=be=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,be())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,ve=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,xe)=>{this.doResolve=Fe,this.doReject=xe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?A(Pe):g(ve,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new v.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class E{constructor(ne){this.delayer=new l(ne),this.throttler=new d}trigger(ne,ve){return this.delayer.trigger(()=>this.throttler.queue(ne),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class i{constructor(){this._isOpen=!1,this._promise=new Promise((ne,ve)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class h extends i{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function r(be,ne){return ne?new Promise((ve,Pe)=>{const Fe=setTimeout(()=>{xe.dispose(),ve()},be),xe=ne.onCancellationRequested(()=>{clearTimeout(Fe),xe.dispose(),Pe(new v.CancellationError)})}):T(ve=>r(be,ve))}e.timeout=r;function n(be,ne=0){const ve=setTimeout(be,ne);return(0,M.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=n;function s(be){const ne=[];let ve=0;const Pe=be.length;function Fe(){return ve<Pe?be[ve++]():null}function xe(Qe){Qe!=null&&ne.push(Qe);const Ie=Fe();return Ie?Ie.then(xe):Promise.resolve(ne)}return Promise.resolve(null).then(xe)}e.sequence=s;function t(be,ne=Pe=>!!Pe,ve=null){let Pe=0;const Fe=be.length,xe=()=>{if(Pe>=Fe)return Promise.resolve(ve);const Qe=be[Pe++];return Promise.resolve(Qe()).then(Se=>ne(Se)?Promise.resolve(Se):xe())};return xe()}e.first=t;function c(be,ne=Pe=>!!Pe,ve=null){if(be.length===0)return Promise.resolve(ve);let Pe=be.length;const Fe=()=>{Pe=-1;for(const xe of be)xe.cancel?.()};return new Promise((xe,Qe)=>{for(const Ie of be)Ie.then(Se=>{--Pe>=0&&ne(Se)?(Fe(),xe(Se)):Pe===0&&xe(ve)}).catch(Se=>{--Pe>=0&&(Fe(),Qe(Se))})})}e.firstParallel=c;class _{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((ve,Pe)=>{this.outstandingPromises.push({factory:ne,c:ve,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const ve=ne.factory();ve.then(ne.c,ne.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=_;class p extends _{constructor(){super(1)}}e.Queue=p;class k{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new ee;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,ve=y.extUri){const Pe=ve.getComparisonKey(ne);let Fe=this.queues.get(Pe);return Fe||(Fe=new p,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=k;class U{constructor(ne,ve){this._token=-1,typeof ne=="function"&&typeof ve=="number"&&this.setIfNotSet(ne,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},ve)}setIfNotSet(ne,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},ve))}}e.TimeoutTimer=U;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,ve){this.cancel(),this._token=setInterval(()=>{ne()},ve)}}e.IntervalTimer=V;class x{constructor(ne,ve){this.timeoutToken=-1,this.runner=ne,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class D{constructor(ne,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class L extends x{constructor(ne,ve){super(ne,ve),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class B extends M.Disposable{constructor(ne,ve){super(),this.options=ne,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,P.setTimeout0)(()=>{if(ne)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(be,ne)=>{const ve=requestIdleCallback(be,typeof ne=="number"?{timeout:ne}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(ve))}}}}();class F{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function K(be,ne,ve){let Pe;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch(xe){Pe=xe,await r(ne)}throw Pe}e.retry=K;class H{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,ve,Pe){return this._pending={taskId:ne,cancel:()=>Pe?.(),promise:ve},ve.then(()=>this.donePending(ne),()=>this.donePending(ne)),ve}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let ve,Pe;const Fe=new Promise((xe,Qe)=>{ve=xe,Pe=Qe});this._next={run:ne,promise:Fe,promiseResolve:ve,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=H;class O{constructor(ne,ve=()=>Date.now()){this.interval=ne,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,ve)=>{this.completeCallback=ne,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(ve=>{this.completeCallback(ne),this.resolved=!0,ve()})}error(ne){return new Promise(ve=>{this.errorCallback(ne),this.rejected=!0,ve()})}cancel(){new Promise(ne=>{this.errorCallback(new v.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=ee;var ce;(function(be){async function ne(Pe){let Fe;const xe=await Promise.all(Pe.map(Qe=>Qe.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe<"u")throw Fe;return xe}be.settled=ne;function ve(Pe){return new Promise(async(Fe,xe)=>{try{await Pe(Fe,xe)}catch(Qe){xe(Qe)}})}be.withAsyncBody=ve})(ce=e.Promises||(e.Promises={}));var oe;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(oe||(oe={}));class le{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const ve={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(ne(ve)),this.resolve()}catch(Pe){this.reject(Pe)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(ne){return new le(ve=>{ve.emitMany(ne)})}static fromPromise(ne){return new le(async ve=>{ve.emitMany(await ne)})}static fromPromises(ne){return new le(async ve=>{await Promise.all(ne.map(async Pe=>ve.emitOne(await Pe)))})}static merge(ne){return new le(async ve=>{await Promise.all(ne.map(async Pe=>{for await(const Fe of Pe)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,ve){return new le(async Pe=>{for await(const Fe of ne)Pe.emitOne(ve(Fe))})}map(ne){return le.map(this,ne)}static filter(ne,ve){return new le(async Pe=>{for await(const Fe of ne)ve(Fe)&&Pe.emitOne(Fe)})}filter(ne){return le.filter(this,ne)}static coalesce(ne){return le.filter(ne,ve=>!!ve)}coalesce(){return le.coalesce(this)}static async toPromise(ne){const ve=[];for await(const Pe of ne)ve.push(Pe);return ve}toPromise(){return le.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=le,le.EMPTY=le.fromArray([]);class te extends le{constructor(ne,ve){super(ve),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function Ee(be){const ne=new a.CancellationTokenSource,ve=be(ne.token);return new te(ne,async Pe=>{const Fe=ne.token.onCancellationRequested(()=>{Fe.dispose(),ne.dispose(),Pe.reject(new v.CancellationError)});try{for await(const xe of ve){if(ne.token.isCancellationRequested)return;Pe.emitOne(xe)}Fe.dispose(),ne.dispose()}catch(xe){Fe.dispose(),ne.dispose(),Pe.reject(xe)}})}e.createCancelableAsyncIterable=Ee}),define(ye[118],De([1,0,14,19]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new a.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),M=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(p,k,U=!1){const V=p||"",x=k||"",D=b.value.collator.compare(V,x);return b.value.collatorIsNumeric&&D===0&&V!==x?V<x?-1:1:D}e.compareFileNames=P;function w(p,k){const U=M.value.collator;return p=p||"",k=k||"",E(U,p,k)}e.compareFileNamesDefault=w;function T(p,k){const U=M.value.collator;return p=p||"",k=k||"",n(p,k)||E(U,p,k)}e.compareFileNamesUpper=T;function R(p,k){const U=M.value.collator;return p=p||"",k=k||"",r(p,k)||E(U,p,k)}e.compareFileNamesLower=R;function S(p,k){return p=p||"",k=k||"",p===k?0:p<k?-1:1}e.compareFileNamesUnicode=S;function m(p,k,U=!1){U||(p=p&&p.toLowerCase(),k=k&&k.toLowerCase());const[V,x]=A(p),[D,L]=A(k);return V!==D?V<D?-1:1:x===L?0:x<L?-1:1}e.noIntlCompareFileNames=m;function I(p,k){const[U,V]=A(p),[x,D]=A(k);let L=b.value.collator.compare(V,D);if(L===0){if(b.value.collatorIsNumeric&&V!==D)return V<D?-1:1;if(L=b.value.collator.compare(U,x),b.value.collatorIsNumeric&&L===0&&U!==x)return U<x?-1:1}return L}e.compareFileExtensions=I;function f(p,k){p=p||"",k=k||"";const U=l(p),V=l(k),x=M.value.collator,D=y.value.collator;return E(D,U,V)||E(x,p,k)}e.compareFileExtensionsDefault=f;function d(p,k){p=p||"",k=k||"";const U=l(p),V=l(k),x=M.value.collator,D=y.value.collator;return E(D,U,V)||n(p,k)||E(x,p,k)}e.compareFileExtensionsUpper=d;function u(p,k){p=p||"",k=k||"";const U=l(p),V=l(k),x=M.value.collator,D=y.value.collator;return E(D,U,V)||r(p,k)||E(x,p,k)}e.compareFileExtensionsLower=u;function o(p,k){p=p||"",k=k||"";const U=l(p).toLowerCase(),V=l(k).toLowerCase();return U!==V?U<V?-1:1:p!==k?p<k?-1:1:0}e.compareFileExtensionsUnicode=o;const g=/^(.*?)(\.([^.]*))?$/;function A(p,k=!1){const U=p?g.exec(p):[];let V=[U&&U[1]||"",U&&U[3]||""];return k&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function l(p){const k=p?g.exec(p):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function E(p,k,U){const V=p.compare(k,U);return V!==0?V:k.length!==U.length?k.length<U.length?-1:1:0}function i(p){const k=p.charAt(0);return k.toLocaleUpperCase()!==k}function h(p){const k=p.charAt(0);return k.toLocaleLowerCase()!==k}function r(p,k){return i(p)&&h(k)?-1:h(p)&&i(k)?1:0}function n(p,k){return h(p)&&i(k)?-1:i(p)&&h(k)?1:0}function s(p,k,U=!1){return U||(p=p&&p.toLowerCase(),k=k&&k.toLowerCase()),p===k?0:p<k?-1:1}function t(p,k,U=!1){const V=p.split(v.sep),x=k.split(v.sep),D=V.length-1,L=x.length-1;let B,F;for(let K=0;;K++){if(B=D===K,F=L===K,B&&F)return P(V[K],x[K],U);if(B)return-1;if(F)return 1;const H=s(V[K],x[K],U);if(H!==0)return H}}e.comparePaths=t;function c(p,k,U){const V=p.toLowerCase(),x=k.toLowerCase(),D=_(p,k,U);if(D)return D;const L=V.endsWith(U),B=x.endsWith(U);if(L!==B)return L?-1:1;const F=P(V,x);return F!==0?F:V.localeCompare(x)}e.compareAnything=c;function _(p,k,U){const V=p.toLowerCase(),x=k.toLowerCase(),D=V.startsWith(U),L=x.startsWith(U);if(D!==L)return D?-1:1;if(D&&L){if(V.length<x.length)return-1;if(V.length>x.length)return 1}return 0}e.compareByPrefix=_}),define(ye[34],De([1,0,16,14,37,25,19,21,9]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",S="[^/\\\\]",m=/\//g;function I(ee,ce){switch(ee){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${ce?`|${R}${S}+`:""})*?`}}function f(ee,ce){if(!ee)return[];const oe=[];let le=!1,te=!1,Ee="";for(const be of ee){switch(be){case ce:if(!le&&!te){oe.push(Ee),Ee="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":te=!0;break;case"]":te=!1;break}Ee+=be}return Ee&&oe.push(Ee),oe}e.splitGlobAware=f;function d(ee){if(!ee)return"";let ce="";const oe=f(ee,e.GLOB_SPLIT);if(oe.every(le=>le===e.GLOBSTAR))ce=".*";else{let le=!1;oe.forEach((te,Ee)=>{if(te===e.GLOBSTAR){if(le)return;ce+=I(2,Ee===oe.length-1)}else{let be=!1,ne="",ve=!1,Pe="";for(const Fe of te){if(Fe!=="}"&&be){ne+=Fe;continue}if(ve&&(Fe!=="]"||!Pe)){let xe;Fe==="-"?xe=Fe:(Fe==="^"||Fe==="!")&&!Pe?xe="^":Fe===e.GLOB_SPLIT?xe="":xe=(0,w.escapeRegExpCharacters)(Fe),Pe+=xe;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{ce+=`(?:${f(ne,",").map(Ie=>d(Ie)).join("|")})`,be=!1,ne="";break}case"]":{ce+="["+Pe+"]",ve=!1,Pe="";break}case"?":ce+=S;continue;case"*":ce+=I(1);continue;default:ce+=(0,w.escapeRegExpCharacters)(Fe)}}Ee<oe.length-1&&(oe[Ee+1]!==e.GLOBSTAR||Ee+2<oe.length)&&(ce+=R)}le=te===e.GLOBSTAR})}return ce}const u=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,A=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),h=function(){return!1},r=function(){return null};function n(ee,ce){if(!ee)return r;let oe;typeof ee!="string"?oe=ee.pattern:oe=ee,oe=oe.trim();const le=`${oe}_${!!ce.trimForExclusions}`;let te=i.get(le);if(te)return s(te,ee);let Ee;return u.test(oe)?te=c(oe.substr(4),oe):(Ee=o.exec(t(oe,ce)))?te=_(Ee[1],oe):(ce.trimForExclusions?A:g).test(oe)?te=p(oe,ce):(Ee=l.exec(t(oe,ce)))?te=k(Ee[1].substr(1),oe,!0):(Ee=E.exec(t(oe,ce)))?te=k(Ee[1],oe,!1):te=U(oe),i.set(le,te),s(te,ee)}function s(ee,ce){if(typeof ce=="string")return ee;const oe=function(le,te){return(0,b.isEqualOrParent)(le,ce.base,!P.isLinux)?ee(le.substr(ce.base.length+1),te):null};return oe.allBasenames=ee.allBasenames,oe.allPaths=ee.allPaths,oe.basenames=ee.basenames,oe.patterns=ee.patterns,oe}function t(ee,ce){return ce.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function c(ee,ce){return function(oe,le){return typeof oe=="string"&&oe.endsWith(ee)?ce:null}}function _(ee,ce){const oe=`/${ee}`,le=`\\${ee}`,te=function(be,ne){return typeof be!="string"?null:ne?ne===ee?ce:null:be===ee||be.endsWith(oe)||be.endsWith(le)?ce:null},Ee=[ee];return te.basenames=Ee,te.patterns=[ce],te.allBasenames=Ee,te}function p(ee,ce){const oe=H(ee.slice(1,-1).split(",").map(ne=>n(ne,ce)).filter(ne=>ne!==r),ee),le=oe.length;if(!le)return r;if(le===1)return oe[0];const te=function(ne,ve){for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++)if(oe[Pe](ne,ve))return ee;return null},Ee=oe.find(ne=>!!ne.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ne,ve)=>ve.allPaths?ne.concat(ve.allPaths):ne,[]);return be.length&&(te.allPaths=be),te}function k(ee,ce,oe){const le=y.sep===y.posix.sep,te=le?ee:ee.replace(m,y.sep),Ee=y.sep+te,be=y.posix.sep+ee;let ne;return oe?ne=function(ve,Pe){return typeof ve=="string"&&(ve===te||ve.endsWith(Ee)||!le&&(ve===ee||ve.endsWith(be)))?ce:null}:ne=function(ve,Pe){return typeof ve=="string"&&(ve===te||!le&&ve===ee)?ce:null},ne.allPaths=[(oe?"*/":"./")+ee],ne}function U(ee){try{const ce=new RegExp(`^${d(ee)}$`);return function(oe){return ce.lastIndex=0,typeof oe=="string"&&ce.test(oe)?ee:null}}catch{return r}}function V(ee,ce,oe){return!ee||typeof ce!="string"?!1:x(ee)(ce,void 0,oe)}e.match=V;function x(ee,ce={}){if(!ee)return h;if(typeof ee=="string"||D(ee)){const oe=n(ee,ce);if(oe===r)return h;const le=function(te,Ee){return!!oe(te,Ee)};return oe.allBasenames&&(le.allBasenames=oe.allBasenames),oe.allPaths&&(le.allPaths=oe.allPaths),le}return F(ee,ce)}e.parse=x;function D(ee){const ce=ee;return ce?typeof ce.base=="string"&&typeof ce.pattern=="string":!1}e.isRelativePattern=D;function L(ee){return ee.allBasenames||[]}e.getBasenameTerms=L;function B(ee){return ee.allPaths||[]}e.getPathTerms=B;function F(ee,ce){const oe=H(Object.getOwnPropertyNames(ee).map(ne=>K(ne,ee[ne],ce)).filter(ne=>ne!==r)),le=oe.length;if(!le)return r;if(!oe.some(ne=>!!ne.requiresSiblings)){if(le===1)return oe[0];const ne=function(Fe,xe){let Qe;for(let Ie=0,Se=oe.length;Ie<Se;Ie++){const Te=oe[Ie](Fe,xe);if(typeof Te=="string")return Te;(0,v.isThenable)(Te)&&(Qe||(Qe=[]),Qe.push(Te))}return Qe?(async()=>{for(const Ie of Qe){const Se=await Ie;if(typeof Se=="string")return Se}return null})():null},ve=oe.find(Fe=>!!Fe.allBasenames);ve&&(ne.allBasenames=ve.allBasenames);const Pe=oe.reduce((Fe,xe)=>xe.allPaths?Fe.concat(xe.allPaths):Fe,[]);return Pe.length&&(ne.allPaths=Pe),ne}const te=function(ne,ve,Pe){let Fe,xe;for(let Qe=0,Ie=oe.length;Qe<Ie;Qe++){const Se=oe[Qe];Se.requiresSiblings&&Pe&&(ve||(ve=(0,y.basename)(ne)),Fe||(Fe=ve.substr(0,ve.length-(0,y.extname)(ne).length)));const Te=Se(ne,ve,Fe,Pe);if(typeof Te=="string")return Te;(0,v.isThenable)(Te)&&(xe||(xe=[]),xe.push(Te))}return xe?(async()=>{for(const Qe of xe){const Ie=await Qe;if(typeof Ie=="string")return Ie}return null})():null},Ee=oe.find(ne=>!!ne.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ne,ve)=>ve.allPaths?ne.concat(ve.allPaths):ne,[]);return be.length&&(te.allPaths=be),te}function K(ee,ce,oe){if(ce===!1)return r;const le=n(ee,oe);if(le===r)return r;if(typeof ce=="boolean")return le;if(ce){const te=ce.when;if(typeof te=="string"){const Ee=(be,ne,ve,Pe)=>{if(!Pe||!le(be,ne))return null;const Fe=te.replace("$(basename)",ve),xe=Pe(Fe);return(0,v.isThenable)(xe)?xe.then(Qe=>Qe?ee:null):xe?ee:null};return Ee.requiresSiblings=!0,Ee}}return le}function H(ee,ce){const oe=ee.filter(ne=>!!ne.basenames);if(oe.length<2)return ee;const le=oe.reduce((ne,ve)=>{const Pe=ve.basenames;return Pe?ne.concat(Pe):ne},[]);let te;if(ce){te=[];for(let ne=0,ve=le.length;ne<ve;ne++)te.push(ce)}else te=oe.reduce((ne,ve)=>{const Pe=ve.patterns;return Pe?ne.concat(Pe):ne},[]);const Ee=function(ne,ve){if(typeof ne!="string")return null;if(!ve){let Fe;for(Fe=ne.length;Fe>0;Fe--){const xe=ne.charCodeAt(Fe-1);if(xe===47||xe===92)break}ve=ne.substr(Fe)}const Pe=le.indexOf(ve);return Pe!==-1?te[Pe]:null};Ee.basenames=le,Ee.patterns=te,Ee.allBasenames=le;const be=ee.filter(ne=>!ne.basenames);return be.push(Ee),be}function O(ee,ce){return(0,a.equals)(ee,ce,(oe,le)=>typeof oe=="string"&&typeof le=="string"?oe===le:typeof oe!="string"&&typeof le!="string"?oe.base===le.base&&oe.pattern===le.pattern:!1)}e.patternsEquals=O}),define(ye[75],De([1,0,11,116,22,9,2]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(o="",g=!1){if(this.value=o,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(o,g=0){return this.value+=m(this.supportThemeIcons?(0,v.escapeIcons)(o):o).replace(/([ \t]+)/g,(A,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,g){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(o,g,A){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(o),")"),A&&(this.value+=` "${this._escape(this._escape(A,'"'),")")}"`),this.value+=")",this}_escape(o,g){const A=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return o.replace(A,(l,E)=>o.charAt(E-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=w;function T(u){return R(u)?!u.value:Array.isArray(u)?u.every(T):!0}e.isEmptyMarkdownString=T;function R(u){return u instanceof w?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function S(u,o){return u===o?!0:!u||!o?!1:u.value===o.value&&u.isTrusted===o.isTrusted&&u.supportThemeIcons===o.supportThemeIcons&&u.supportHtml===o.supportHtml&&(u.baseUri===o.baseUri||!!u.baseUri&&!!o.baseUri&&(0,b.isEqual)(y.URI.from(u.baseUri),y.URI.from(o.baseUri)))}e.markdownStringEqual=S;function m(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function I(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function f(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function d(u){const o=[],g=u.split("|").map(l=>l.trim());u=g[0];const A=g[1];if(A){const l=/height=(\d+)/.exec(A),E=/width=(\d+)/.exec(A),i=l?l[1]:"",h=E?E[1]:"",r=isFinite(parseInt(h)),n=isFinite(parseInt(i));r&&o.push(`width="${h}"`),n&&o.push(`height="${i}"`)}return{href:u,dimensions:o}}e.parseHrefAndDimensions=d}),define(ye[76],De([1,0,16,37,19,21,22,9]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(r,n){const{os:s,tildify:t,relative:c}=n;if(c){const k=T(r,c,s);if(typeof k=="string")return k}let _=r.fsPath;if(s===1&&!M.isWindows?_=_.replace(/\//g,"\\"):s!==1&&M.isWindows&&(_=_.replace(/\\/g,"/")),s!==1&&t?.userHome){const k=t.userHome.fsPath;let U;r.scheme!==t.userHome.scheme&&r.path.startsWith(b.posix.sep)?U=t.userHome.with({path:r.path}).fsPath:U=r.fsPath,_=m(U,k,s)}return(s===1?b.win32:b.posix).normalize(R(_,s===1))}e.getPathLabel=w;function T(r,n,s){const t=s===1?b.win32:b.posix,c=s===3?y.extUri:y.extUriIgnorePathCase,_=n.getWorkspace(),p=(0,a.firstOrDefault)(_.folders);if(!p)return;r.scheme!==p.uri.scheme&&r.path.startsWith(b.posix.sep)&&(r=p.uri.with({path:r.path}));const k=n.getWorkspaceFolder(r);if(!k)return;let U;if(c.isEqual(k.uri,r)?U="":U=c.relativePath(k.uri,r)??"",U&&(U=t.normalize(U)),_.folders.length>1&&!n.noPrefix){const V=k.name?k.name:c.basenameOrAuthority(k.uri);U=U?`${V} \u2022 ${U}`:V}return U}function R(r,n=M.isWindows){return(0,v.hasDriveLetter)(r,n)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let S=Object.create(null);function m(r,n,s=M.OS){if(s===1||!r||!n)return r;let t=S.original===n?S.normalized:void 0;t||(t=n,M.isWindows&&(t=(0,v.toSlashes)(t)),t=`${(0,P.rtrim)(t,b.posix.sep)}${b.posix.sep}`,S={original:n,normalized:t});let c=r;return M.isWindows&&(c=(0,v.toSlashes)(c)),(s===3?c.startsWith(t):(0,P.startsWithIgnoreCase)(c,t))?`~/${c.substr(t.length)}`:r}e.tildify=m;function I(r,n){return r.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=I;const f="\u2026",d="\\\\",u="~";function o(r,n=b.sep){const s=new Array(r.length);let t=!1;for(let c=0;c<r.length;c++){const _=r[c];if(_===""){s[c]=`.${n}`;continue}if(!_){s[c]=_;continue}t=!0;let p="",k=_;k.indexOf(d)===0?(p=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length)):k.indexOf(n)===0?(p=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(u)===0&&(p=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length));const U=k.split(n);for(let V=1;t&&V<=U.length;V++)for(let x=U.length-V;t&&x>=0;x--){t=!1;let D=U.slice(x,x+V).join(n);for(let L=0;!t&&L<r.length;L++)if(L!==c&&r[L]&&r[L].indexOf(D)>-1){const B=x+V===U.length,F=x>0&&r[L].indexOf(n)>-1?n+D:D,K=r[L].endsWith(F);t=!B||K}if(!t){let L="";(U[0].endsWith(":")||p!=="")&&(x===1&&(x=0,V++,D=U[0]+n+D),x>0&&(L=U[0]+n),L=p+L),x>0&&(L=L+f+n),L=L+D,x+V<U.length&&(L=L+n+f),s[c]=L}}t&&(s[c]=_)}return s}e.shorten=o;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function A(r,n=Object.create(null)){const s=[];let t=!1,c="";for(const _ of r)if(_==="$"||t&&_==="{")c&&s.push({value:c,type:g.TEXT}),c="",t=!0;else if(_==="}"&&t){const p=n[c];if(typeof p=="string")p.length&&s.push({value:p,type:g.VARIABLE});else if(p){const k=s[s.length-1];(!k||k.type!==g.SEPARATOR)&&s.push({value:p.label,type:g.SEPARATOR})}c="",t=!1}else c+=_;return c&&!t&&s.push({value:c,type:g.TEXT}),s.filter((_,p)=>{if(_.type===g.SEPARATOR){const k=s[p-1],U=s[p+1];return[k,U].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=A;function l(r,n){return M.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function E(r,n){return M.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,s=>s==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=E;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function h(r){const n=r.indexOf("/")!==-1?b.posix:b.win32,s=n.basename(r),t=n.dirname(r);return s.length?{name:s,parentPath:t}:{name:t,parentPath:""}}e.splitName=h}),define(ye[119],De([1,0,2]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function v(R){return R.toJSON()}class b{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:v(a.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:v(a.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:a.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function M(R,S,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return S.transformOutgoing(R);for(const I in R)if(Object.hasOwnProperty.call(R,I)){const f=M(R[I],S,m+1);f!==null&&(R[I]=f)}}return null}function y(R,S){const m=M(R,S,0);return m===null?R:m}e.transformOutgoingURIs=y;function P(R,S,m,I){if(!R||I>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?a.URI.revive(S.transformIncoming(R)):S.transformIncoming(R);for(const f in R)if(Object.hasOwnProperty.call(R,f)){const d=P(R[f],S,m,I+1);d!==null&&(R[f]=d)}}return null}function w(R,S){const m=P(R,S,!1,0);return m===null?R:m}e.transformIncomingURIs=w;function T(R,S){const m=P(R,S,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=T}),define(ye[120],De([1,0,34,19]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(M,y,P,w,T,R){if(Array.isArray(M)){let S=0;for(const m of M){const I=b(m,y,P,w,T,R);if(I===10)return I;I>S&&(S=I)}return S}else{if(typeof M=="string")return w?M==="*"?5:M===P?10:0:0;if(M){const{language:S,pattern:m,scheme:I,hasAccessToAllModels:f,notebookType:d}=M;if(!w&&!f)return 0;d&&T&&(y=T);let u=0;if(I)if(I===y.scheme)u=10;else if(I==="*")u=5;else return 0;if(S)if(S===P)u=10;else if(S==="*")u=Math.max(u,5);else return 0;if(d)if(d===R)u=10;else if(d==="*"&&R!==void 0)u=Math.max(u,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,v.normalize)(m.base)},o===y.fsPath||(0,a.match)(o,y.fsPath))u=10;else return 0}return u}else return 0}}e.score=b}),define(ye[77],De([1,0,23,21]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(b||(b={}));function M(S){for(let m=0,I=S.length;m<I;m+=4){const f=S[m+0],d=S[m+1],u=S[m+2],o=S[m+3];S[m+0]=o,S[m+1]=u,S[m+2]=d,S[m+3]=f}}function y(S){const m=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return v.isLittleEndian()||M(m),a.VSBuffer.wrap(m)}function P(S){const m=S.buffer;if(v.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const I=new Uint8Array(m.byteLength);return I.set(m),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function w(S){const m=new Uint32Array(T(S));let I=0;if(m[I++]=S.id,S.type==="full")m[I++]=1,m[I++]=S.data.length,m.set(S.data,I),I+=S.data.length;else{m[I++]=2,m[I++]=S.deltas.length;for(const f of S.deltas)m[I++]=f.start,m[I++]=f.deleteCount,f.data?(m[I++]=f.data.length,m.set(f.data,I),I+=f.data.length):m[I++]=0}return y(m)}e.encodeSemanticTokensDto=w;function T(S){let m=0;if(m+=1+1,S.type==="full")m+=1+S.data.length;else{m+=1,m+=(1+1+1)*S.deltas.length;for(const I of S.deltas)I.data&&(m+=I.data.length)}return m}function R(S){const m=P(S);let I=0;const f=m[I++];if(m[I++]===1){const g=m[I++],A=m.subarray(I,I+g);return I+=g,{id:f,type:"full",data:A}}const u=m[I++],o=[];for(let g=0;g<u;g++){const A=m[I++],l=m[I++],E=m[I++];let i;E>0&&(i=m.subarray(I,I+E),I+=E),o[g]={start:A,deleteCount:l,data:i}}return{id:f,type:"delta",deltas:o}}e.decodeSemanticTokensDto=R}),define(ye[121],De([17,18]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(ye[122],De([1,0,121,21,123,16,26,110]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=T;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(Q,fe,Ue,He){this.id=Q,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(Q,fe){return I(Q,fe)}compute(Q,fe,Ue){return Ue}}class m{constructor(Q,fe){this.newValue=Q,this.didChange=fe}}e.ApplyUpdateResult=m;function I(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new m(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Ue=Array.isArray(G)&&Array.isArray(Q)&&M.equals(G,Q);return new m(Q,!Ue)}let fe=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const He=I(G[Ue],Q[Ue]);He.didChange&&(G[Ue]=He.newValue,fe=!0)}return new m(G,fe)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,fe){return I(Q,fe)}validate(Q){return this.defaultValue}}class d{constructor(Q,fe,Ue,He){this.id=Q,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(Q,fe){return I(Q,fe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,fe,Ue){return Ue}}function u(G,Q){return typeof G>"u"?Q:G==="false"?!1:Boolean(G)}e.boolean=u;class o extends d{constructor(Q,fe,Ue,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Ue),super(Q,fe,Ue,He)}validate(Q){return u(Q,this.defaultValue)}}function g(G,Q,fe,Ue){if(typeof G>"u")return Q;let He=parseInt(G,10);return isNaN(He)?Q:(He=Math.max(fe,He),He=Math.min(Ue,He),He|0)}e.clampedInt=g;class A extends d{constructor(Q,fe,Ue,He,Ze,qe=void 0){typeof qe<"u"&&(qe.type="integer",qe.default=Ue,qe.minimum=He,qe.maximum=Ze),super(Q,fe,Ue,qe),this.minimum=He,this.maximum=Ze}static clampedInt(Q,fe,Ue,He){return g(Q,fe,Ue,He)}validate(Q){return A.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class l extends d{constructor(Q,fe,Ue,He,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(Q,fe,Ue,Ze),this.validationFn=He}static clamp(Q,fe,Ue){return Q<fe?fe:Q>Ue?Ue:Q}static float(Q,fe){if(typeof Q=="number")return Q;if(typeof Q>"u")return fe;const Ue=parseFloat(Q);return isNaN(Ue)?fe:Ue}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class E extends d{static string(Q,fe){return typeof Q!="string"?fe:Q}constructor(Q,fe,Ue,He=void 0){typeof He<"u"&&(He.type="string",He.default=Ue),super(Q,fe,Ue,He)}validate(Q){return E.string(Q,this.defaultValue)}}function i(G,Q,fe){return typeof G!="string"||fe.indexOf(G)===-1?Q:G}e.stringSet=i;class h extends d{constructor(Q,fe,Ue,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=He,Ze.default=Ue),super(Q,fe,Ue,Ze),this._allowedValues=He}validate(Q){return i(Q,this.defaultValue,this._allowedValues)}}class r extends S{constructor(Q,fe,Ue,He,Ze,qe,We=void 0){typeof We<"u"&&(We.type="string",We.enum=Ze,We.default=He),super(Q,fe,Ue,We),this._allowedValues=Ze,this._convert=qe}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function n(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,fe,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class t extends S{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertSpace:u(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function _(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(G){switch(G){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function U(G){switch(G){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class V extends f{constructor(){super(130)}compute(Q,fe,Ue){const He=["monaco-editor"];return fe.get(34)&&He.push(fe.get(34)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),fe.get(67)==="default"?He.push("mouse-default"):fe.get(67)==="copy"&&He.push("mouse-copy"),fe.get(101)&&He.push("showUnused"),fe.get(128)&&He.push("showDeprecated"),He.join(" ")}}class x extends o{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,fe,Ue){return Ue&&Q.emptySelectionClipboard}}class D extends S{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:v.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{cursorMoveOnType:u(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":i(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":i(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(fe.loop,this.defaultValue.loop)}}}class L extends S{constructor(){super(46,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?L.OFF:Q==="true"?L.ON:Q:Boolean(Q)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class B extends f{constructor(){super(45)}compute(Q,fe,Ue){return Q.fontInfo}}class F extends d{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(Q){const fe=l.float(Q,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(fe,6,100)}compute(Q,fe,Ue){return Q.fontInfo.fontSize}}class K extends S{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(A.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class H extends S{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:a.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{multiple:i(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??i(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??i(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??i(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??i(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??i(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class O extends S{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),delay:A.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:u(fe.sticky,this.defaultValue.sticky),above:u(fe.above,this.defaultValue.above)}}}var ee;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(ee=e.RenderMinimap||(e.RenderMinimap={}));class ce extends f{constructor(){super(133)}compute(Q,fe,Ue){return ce.computeLayout(fe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const fe=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?fe-1:0,He=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/He);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:Ze}}static _computeMinimapLayout(Q,fe){const Ue=Q.outerWidth,He=Q.outerHeight,Ze=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const qe=fe.stableMinimapLayoutInput,We=qe&&Q.outerHeight===qe.outerHeight&&Q.lineHeight===qe.lineHeight&&Q.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&Q.pixelRatio===qe.pixelRatio&&Q.scrollBeyondLastLine===qe.scrollBeyondLastLine&&Q.minimap.enabled===qe.minimap.enabled&&Q.minimap.side===qe.minimap.side&&Q.minimap.size===qe.minimap.size&&Q.minimap.showSlider===qe.minimap.showSlider&&Q.minimap.renderCharacters===qe.minimap.renderCharacters&&Q.minimap.maxColumn===qe.minimap.maxColumn&&Q.minimap.scale===qe.minimap.scale&&Q.verticalScrollbarWidth===qe.verticalScrollbarWidth&&Q.isViewportWrapping===qe.isViewportWrapping,nt=Q.lineHeight,ot=Q.typicalHalfwidthCharacterWidth,ht=Q.scrollBeyondLastLine,kt=Q.minimap.renderCharacters;let it=Ze>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ut=Q.minimap.maxColumn,Rt=Q.minimap.size,$t=Q.minimap.side,yt=Q.verticalScrollbarWidth,ft=Q.viewLineCount,Dt=Q.remainingWidth,Mt=Q.isViewportWrapping,Ot=kt?2:3;let Ve=Math.floor(Ze*He);const Ft=Ve/Ze;let Pt=!1,Ut=!1,vt=Ot*it,we=it/Ze,Ce=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:je,extraLinesBeyondLastLine:ct,desiredRatio:gt,minimapLineCount:St}=ce.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:ht,height:He,lineHeight:nt,pixelRatio:Ze});if(ft/St>1)Pt=!0,Ut=!0,it=1,vt=1,we=it/Ze;else{let _t=!1,Tt=it+1;if(Rt==="fit"){const mt=Math.ceil((ft+ct)*vt);Mt&&We&&Dt<=fe.stableFitRemainingWidth?(_t=!0,Tt=fe.stableFitMaxMinimapScale):_t=mt>Ve}if(Rt==="fill"||_t){Pt=!0;const mt=it;vt=Math.min(nt*Ze,Math.max(1,Math.floor(1/gt))),Mt&&We&&Dt<=fe.stableFitRemainingWidth&&(Tt=fe.stableFitMaxMinimapScale),it=Math.min(Tt,Math.max(1,Math.floor(vt/Ot))),it>mt&&(Ce=Math.min(2,it/mt)),we=it/Ze/Ce,Ve=Math.ceil(Math.max(je,ft+ct)*vt),Mt?(fe.stableMinimapLayoutInput=Q,fe.stableFitRemainingWidth=Dt,fe.stableFitMaxMinimapScale=it):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const me=Math.floor(ut*we),q=Math.min(me,Math.max(0,Math.floor((Dt-yt-2)*we/(ot+we)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*q);const Le=Ae/Ze;Ae=Math.floor(Ae*Ce);const tt=kt?1:2,Xe=$t==="left"?0:Ue-q-yt;return{renderMinimap:tt,minimapLeft:Xe,minimapWidth:q,minimapHeightIsEditorHeight:Pt,minimapIsSampling:Ut,minimapScale:it,minimapLineHeight:vt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Ve,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(Q,fe){const Ue=fe.outerWidth|0,He=fe.outerHeight|0,Ze=fe.lineHeight|0,qe=fe.lineNumbersDigitCount|0,We=fe.typicalHalfwidthCharacterWidth,nt=fe.maxDigitWidth,ot=fe.pixelRatio,ht=fe.viewLineCount,kt=Q.get(125),it=kt==="inherit"?Q.get(124):kt,ut=it==="inherit"?Q.get(120):it,Rt=Q.get(123),$t=Q.get(2),yt=fe.isDominatedByLongLines,ft=Q.get(51),Dt=Q.get(61).renderType!==0,Mt=Q.get(62),Ot=Q.get(95),Ve=Q.get(66),Ft=Q.get(93),Pt=Ft.verticalScrollbarSize,Ut=Ft.verticalHasArrows,vt=Ft.arrowSize,we=Ft.horizontalScrollbarSize,Ce=Q.get(59),me=Q.get(38),q=Q.get(100)!=="never";let Ae;if(typeof Ce=="string"&&/^\d+(\.\d+)?ch$/.test(Ce)){const Wt=parseFloat(Ce.substr(0,Ce.length-2));Ae=A.clampedInt(Wt*We,0,0,1e3)}else Ae=A.clampedInt(Ce,0,0,1e3);me&&q&&(Ae+=16);let Le=0;if(Dt){const Wt=Math.max(qe,Mt);Le=Math.round(Wt*nt)}let tt=0;ft&&(tt=Ze);let Xe=0,je=Xe+tt,ct=je+Le,gt=ct+Ae;const St=Ue-tt-Le-Ae;let pt=!1,_t=!1,Tt=-1;$t!==2&&(it==="inherit"&&yt?(pt=!0,_t=!0):ut==="on"||ut==="bounded"?_t=!0:ut==="wordWrapColumn"&&(Tt=Rt));const mt=ce._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:Ze,typicalHalfwidthCharacterWidth:We,pixelRatio:ot,scrollBeyondLastLine:Ot,minimap:Ve,verticalScrollbarWidth:Pt,viewLineCount:ht,remainingWidth:St,isViewportWrapping:_t},fe.memory||new R);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Xe+=mt.minimapWidth,je+=mt.minimapWidth,ct+=mt.minimapWidth,gt+=mt.minimapWidth);const Qt=St-mt.minimapWidth,Yt=Math.max(1,Math.floor((Qt-Pt-2)/We)),bt=Ut?vt:0;return _t&&(Tt=Math.max(1,Yt),ut==="bounded"&&(Tt=Math.min(Tt,Rt))),{width:Ue,height:He,glyphMarginLeft:Xe,glyphMarginWidth:tt,lineNumbersLeft:je,lineNumbersWidth:Le,decorationsLeft:ct,decorationsWidth:Ae,contentLeft:gt,contentWidth:Qt,minimap:mt,viewportColumn:Yt,isWordWrapMinified:pt,isViewportWrapping:_t,wrappingColumn:Tt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:we,overviewRuler:{top:bt,width:Pt,height:He-2*bt,right:0}}}}e.EditorLayoutInfoComputer=ce;class oe extends S{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class le extends S{constructor(){const Q={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:a.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:a.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),maxLineCount:A.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class te extends S{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:a.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(47,null),a.localize(48,null,v.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(49,null,v.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:a.localize(53,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:i(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:A.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(fe.fontFamily,this.defaultValue.fontFamily),padding:u(fe.padding,this.defaultValue.padding)}}}class Ee extends l{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:a.localize(54,null)})}compute(Q,fe,Ue){return Q.fontInfo.lineHeight}}class be extends S{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:a.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(57,null),a.localize(58,null),a.localize(59,null)],default:Q.size,description:a.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(62,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),autohide:u(fe.autohide,this.defaultValue.autohide),size:i(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(fe.side,this.defaultValue.side,["right","left"]),showSlider:i(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(fe.renderCharacters,this.defaultValue.renderCharacters),scale:A.clampedInt(fe.scale,1,1,3),maxColumn:A.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(G){return G==="ctrlCmd"?v.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends S{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(67,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{top:A.clampedInt(fe.top,0,0,1e3),bottom:A.clampedInt(fe.bottom,0,0,1e3)}}}class Pe extends S{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(69,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),cycle:u(fe.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(Q,fe,Ue){return Q.pixelRatio}}class xe extends S{constructor(){const Q={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(70,null),a.localize(71,null),a.localize(72,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:Q.strings,description:a.localize(73,null)},comments:{anyOf:fe,default:Q.comments,description:a.localize(74,null)},other:{anyOf:fe,default:Q.other,description:a.localize(75,null)}},default:Q,markdownDescription:a.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ot=Q?"on":"off";return{comments:ot,strings:ot,other:ot}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:He}=Q,Ze=["on","inline","off"];let qe,We,nt;return typeof fe=="boolean"?qe=fe?"on":"off":qe=i(fe,this.defaultValue.other,Ze),typeof Ue=="boolean"?We=Ue?"on":"off":We=i(Ue,this.defaultValue.comments,Ze),typeof He=="boolean"?nt=He?"on":"off":nt=i(He,this.defaultValue.strings,Ze),{other:qe,comments:We,strings:nt}}}var Qe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends S{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(77,null),a.localize(78,null),a.localize(79,null),a.localize(80,null)],default:"on",description:a.localize(81,null)})}validate(Q){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(fe=4,Ue=Q):Q==="interval"?fe=3:Q==="relative"?fe=2:Q==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function Se(G){const Q=G.get(88);return Q==="editable"?G.get(82):Q!=="on"}e.filterValidationDecorations=Se;class Te extends S{constructor(){const Q=[],fe={type:"number",description:a.localize(82,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:a.localize(83,null),format:"color-hex"}}}]},default:Q,description:a.localize(84,null)})}validate(Q){if(Array.isArray(Q)){const fe=[];for(const Ue of Q)if(typeof Ue=="number")fe.push({column:A.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;fe.push({column:A.clampedInt(He.column,0,0,1e4),color:He.color})}return fe.sort((Ue,He)=>Ue.column-He.column),fe}return this.defaultValue}}function ae(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends S{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"auto",description:a.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(89,null),a.localize(90,null),a.localize(91,null)],default:"auto",description:a.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(95,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q,Ue=A.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=A.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:A.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(fe.vertical,this.defaultValue.vertical),horizontal:ae(fe.horizontal,this.defaultValue.horizontal),useShadows:u(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:A.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:A.clampedInt(fe.verticalSliderSize,He,0,1e3),scrollByPage:u(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends S{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:a.localize(102,null)}})}applyUpdate(Q,fe){let Ue=!1;fe.allowedCharacters&&Q&&(y.equals(Q.allowedCharacters,fe.allowedCharacters)||(Q={...Q,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&Q&&(y.equals(Q.allowedLocales,fe.allowedLocales)||(Q={...Q,allowedLocales:fe.allowedLocales},Ue=!0));const He=super.applyUpdate(Q,fe);return Ue?new m(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{nonBasicASCII:W(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:W(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:W(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,fe){if(typeof Q!="object"||!Q)return fe;const Ue={};for(const[He,Ze]of Object.entries(Q))Ze===!0&&(Ue[He]=!0);return Ue}}class Y extends S{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),mode:i(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class C extends S{constructor(){const Q={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:a.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class z extends S{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(106,null),a.localize(107,null),a.localize(108,null)],default:Q.bracketPairs,description:a.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(110,null),a.localize(111,null),a.localize(112,null)],default:Q.bracketPairsHorizontal,description:a.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(116,null),a.localize(117,null),a.localize(118,null)],default:Q.highlightActiveIndentation,description:a.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{bracketPairs:W(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:W(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:W(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function W(G,Q,fe){const Ue=fe.indexOf(G);return Ue===-1?Q:fe[Ue]}class j extends S{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(120,null),a.localize(121,null)],default:Q.insertMode,description:a.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertMode:i(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(fe.showIcons,this.defaultValue.showIcons),showStatusBar:u(fe.showStatusBar,this.defaultValue.showStatusBar),preview:u(fe.preview,this.defaultValue.preview),previewMode:i(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(fe.showMethods,this.defaultValue.showMethods),showFunctions:u(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(fe.showFields,this.defaultValue.showFields),showVariables:u(fe.showVariables,this.defaultValue.showVariables),showClasses:u(fe.showClasses,this.defaultValue.showClasses),showStructs:u(fe.showStructs,this.defaultValue.showStructs),showInterfaces:u(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(fe.showModules,this.defaultValue.showModules),showProperties:u(fe.showProperties,this.defaultValue.showProperties),showEvents:u(fe.showEvents,this.defaultValue.showEvents),showOperators:u(fe.showOperators,this.defaultValue.showOperators),showUnits:u(fe.showUnits,this.defaultValue.showUnits),showValues:u(fe.showValues,this.defaultValue.showValues),showConstants:u(fe.showConstants,this.defaultValue.showConstants),showEnums:u(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(fe.showKeywords,this.defaultValue.showKeywords),showWords:u(fe.showWords,this.defaultValue.showWords),showColors:u(fe.showColors,this.defaultValue.showColors),showFiles:u(fe.showFiles,this.defaultValue.showFiles),showReferences:u(fe.showReferences,this.defaultValue.showReferences),showFolders:u(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(fe.showSnippets,this.defaultValue.showSnippets),showUsers:u(fe.showUsers,this.defaultValue.showUsers),showIssues:u(fe.showIssues,this.defaultValue.showIssues)}}}class se extends S{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(163,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends f{constructor(){super(132)}compute(Q,fe,Ue){return fe.get(82)?!0:Q.tabFocusMode}}var Z;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Z=e.WrappingIndent||(e.WrappingIndent={}));function pe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(Q,fe,Ue){const He=fe.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Ne extends S{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(164,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:v.isMacintosh?Je:v.isLinux?Ge:Be,fontWeight:"normal",fontSize:v.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var rt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.dropIntoEditor=32]="dropIntoEditor",G[G.emptySelectionClipboard=33]="emptySelectionClipboard",G[G.extraEditorClassName=34]="extraEditorClassName",G[G.fastScrollSensitivity=35]="fastScrollSensitivity",G[G.find=36]="find",G[G.fixedOverflowWidgets=37]="fixedOverflowWidgets",G[G.folding=38]="folding",G[G.foldingStrategy=39]="foldingStrategy",G[G.foldingHighlight=40]="foldingHighlight",G[G.foldingImportsByDefault=41]="foldingImportsByDefault",G[G.foldingMaximumRegions=42]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=44]="fontFamily",G[G.fontInfo=45]="fontInfo",G[G.fontLigatures=46]="fontLigatures",G[G.fontSize=47]="fontSize",G[G.fontWeight=48]="fontWeight",G[G.formatOnPaste=49]="formatOnPaste",G[G.formatOnType=50]="formatOnType",G[G.glyphMargin=51]="glyphMargin",G[G.gotoLocation=52]="gotoLocation",G[G.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",G[G.hover=54]="hover",G[G.inDiffEditor=55]="inDiffEditor",G[G.inlineSuggest=56]="inlineSuggest",G[G.letterSpacing=57]="letterSpacing",G[G.lightbulb=58]="lightbulb",G[G.lineDecorationsWidth=59]="lineDecorationsWidth",G[G.lineHeight=60]="lineHeight",G[G.lineNumbers=61]="lineNumbers",G[G.lineNumbersMinChars=62]="lineNumbersMinChars",G[G.linkedEditing=63]="linkedEditing",G[G.links=64]="links",G[G.matchBrackets=65]="matchBrackets",G[G.minimap=66]="minimap",G[G.mouseStyle=67]="mouseStyle",G[G.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=69]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",G[G.multiCursorModifier=71]="multiCursorModifier",G[G.multiCursorPaste=72]="multiCursorPaste",G[G.occurrencesHighlight=73]="occurrencesHighlight",G[G.overviewRulerBorder=74]="overviewRulerBorder",G[G.overviewRulerLanes=75]="overviewRulerLanes",G[G.padding=76]="padding",G[G.parameterHints=77]="parameterHints",G[G.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",G[G.quickSuggestions=80]="quickSuggestions",G[G.quickSuggestionsDelay=81]="quickSuggestionsDelay",G[G.readOnly=82]="readOnly",G[G.renameOnType=83]="renameOnType",G[G.renderControlCharacters=84]="renderControlCharacters",G[G.renderFinalNewline=85]="renderFinalNewline",G[G.renderLineHighlight=86]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=88]="renderValidationDecorations",G[G.renderWhitespace=89]="renderWhitespace",G[G.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",G[G.roundedSelection=91]="roundedSelection",G[G.rulers=92]="rulers",G[G.scrollbar=93]="scrollbar",G[G.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=95]="scrollBeyondLastLine",G[G.scrollPredominantAxis=96]="scrollPredominantAxis",G[G.selectionClipboard=97]="selectionClipboard",G[G.selectionHighlight=98]="selectionHighlight",G[G.selectOnLineNumbers=99]="selectOnLineNumbers",G[G.showFoldingControls=100]="showFoldingControls",G[G.showUnused=101]="showUnused",G[G.snippetSuggestions=102]="snippetSuggestions",G[G.smartSelect=103]="smartSelect",G[G.smoothScrolling=104]="smoothScrolling",G[G.stickyScroll=105]="stickyScroll",G[G.stickyTabStops=106]="stickyTabStops",G[G.stopRenderingLineAfter=107]="stopRenderingLineAfter",G[G.suggest=108]="suggest",G[G.suggestFontSize=109]="suggestFontSize",G[G.suggestLineHeight=110]="suggestLineHeight",G[G.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",G[G.suggestSelection=112]="suggestSelection",G[G.tabCompletion=113]="tabCompletion",G[G.tabIndex=114]="tabIndex",G[G.unicodeHighlighting=115]="unicodeHighlighting",G[G.unusualLineTerminators=116]="unusualLineTerminators",G[G.useShadowDOM=117]="useShadowDOM",G[G.useTabStops=118]="useTabStops",G[G.wordSeparators=119]="wordSeparators",G[G.wordWrap=120]="wordWrap",G[G.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=123]="wordWrapColumn",G[G.wordWrapOverride1=124]="wordWrapOverride1",G[G.wordWrapOverride2=125]="wordWrapOverride2",G[G.wrappingIndent=126]="wrappingIndent",G[G.wrappingStrategy=127]="wrappingStrategy",G[G.showDeprecated=128]="showDeprecated",G[G.inlayHints=129]="inlayHints",G[G.editorClassName=130]="editorClassName",G[G.pixelRatio=131]="pixelRatio",G[G.tabFocusMode=132]="tabFocusMode",G[G.layoutInfo=133]="layoutInfo",G[G.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(165,null)})),acceptSuggestionOnEnter:ke(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(166,null),""],markdownDescription:a.localize(167,null)})),accessibilitySupport:ke(new s),accessibilityPageSize:ke(new A(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(168,null)})),ariaLabel:ke(new E(4,"ariaLabel",a.localize(169,null))),autoClosingBrackets:ke(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(170,null),a.localize(171,null),""],description:a.localize(172,null)})),autoClosingDelete:ke(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(173,null),""],description:a.localize(174,null)})),autoClosingOvertype:ke(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(175,null),""],description:a.localize(176,null)})),autoClosingQuotes:ke(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(177,null),a.localize(178,null),""],description:a.localize(179,null)})),autoIndent:ke(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[a.localize(180,null),a.localize(181,null),a.localize(182,null),a.localize(183,null),a.localize(184,null)],description:a.localize(185,null)})),automaticLayout:ke(new o(10,"automaticLayout",!1)),autoSurround:ke(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(186,null),a.localize(187,null),a.localize(188,null),""],description:a.localize(189,null)})),bracketPairColorization:ke(new C),bracketPairGuides:ke(new z),stickyTabStops:ke(new o(106,"stickyTabStops",!1,{description:a.localize(190,null)})),codeLens:ke(new o(14,"codeLens",!0,{description:a.localize(191,null)})),codeLensFontFamily:ke(new E(15,"codeLensFontFamily","",{description:a.localize(192,null)})),codeLensFontSize:ke(new A(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(193,null)})),colorDecorators:ke(new o(17,"colorDecorators",!0,{description:a.localize(194,null)})),columnSelection:ke(new o(18,"columnSelection",!1,{description:a.localize(195,null)})),comments:ke(new t),contextmenu:ke(new o(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new o(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(196,null)})),cursorBlinking:ke(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],_,{description:a.localize(197,null)})),cursorSmoothCaretAnimation:ke(new o(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(198,null)})),cursorStyle:ke(new r(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:a.localize(199,null)})),cursorSurroundingLines:ke(new A(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(200,null)})),cursorSurroundingLinesStyle:ke(new h(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(201,null),a.localize(202,null)],description:a.localize(203,null)})),cursorWidth:ke(new A(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(204,null)})),disableLayerHinting:ke(new o(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new o(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new o(30,"domReadOnly",!1)),dragAndDrop:ke(new o(31,"dragAndDrop",!0,{description:a.localize(205,null)})),emptySelectionClipboard:ke(new x),dropIntoEditor:ke(new Ne),stickyScroll:ke(new le),extraEditorClassName:ke(new E(34,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(35,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:a.localize(206,null)})),find:ke(new D),fixedOverflowWidgets:ke(new o(37,"fixedOverflowWidgets",!1)),folding:ke(new o(38,"folding",!0,{description:a.localize(207,null)})),foldingStrategy:ke(new h(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(208,null),a.localize(209,null)],description:a.localize(210,null)})),foldingHighlight:ke(new o(40,"foldingHighlight",!0,{description:a.localize(211,null)})),foldingImportsByDefault:ke(new o(41,"foldingImportsByDefault",!1,{description:a.localize(212,null)})),foldingMaximumRegions:ke(new A(42,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(213,null)})),unfoldOnClickAfterEndOfLine:ke(new o(43,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(214,null)})),fontFamily:ke(new E(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(215,null)})),fontInfo:ke(new B),fontLigatures2:ke(new L),fontSize:ke(new F),fontWeight:ke(new K),formatOnPaste:ke(new o(49,"formatOnPaste",!1,{description:a.localize(216,null)})),formatOnType:ke(new o(50,"formatOnType",!1,{description:a.localize(217,null)})),glyphMargin:ke(new o(51,"glyphMargin",!0,{description:a.localize(218,null)})),gotoLocation:ke(new H),hideCursorInOverviewRuler:ke(new o(53,"hideCursorInOverviewRuler",!1,{description:a.localize(219,null)})),hover:ke(new O),inDiffEditor:ke(new o(55,"inDiffEditor",!1)),letterSpacing:ke(new l(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>l.clamp(G,-5,20),{description:a.localize(220,null)})),lightbulb:ke(new oe),lineDecorationsWidth:ke(new d(59,"lineDecorationsWidth",10)),lineHeight:ke(new Ee),lineNumbers:ke(new Ie),lineNumbersMinChars:ke(new A(62,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new o(63,"linkedEditing",!1,{description:a.localize(221,null)})),links:ke(new o(64,"links",!0,{description:a.localize(222,null)})),matchBrackets:ke(new h(65,"matchBrackets","always",["always","near","never"],{description:a.localize(223,null)})),minimap:ke(new be),mouseStyle:ke(new h(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(68,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:a.localize(224,null)})),mouseWheelZoom:ke(new o(69,"mouseWheelZoom",!1,{markdownDescription:a.localize(225,null)})),multiCursorMergeOverlapping:ke(new o(70,"multiCursorMergeOverlapping",!0,{description:a.localize(226,null)})),multiCursorModifier:ke(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[a.localize(227,null),a.localize(228,null)],markdownDescription:a.localize(229,null)})),multiCursorPaste:ke(new h(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(230,null),a.localize(231,null)],markdownDescription:a.localize(232,null)})),occurrencesHighlight:ke(new o(73,"occurrencesHighlight",!0,{description:a.localize(233,null)})),overviewRulerBorder:ke(new o(74,"overviewRulerBorder",!0,{description:a.localize(234,null)})),overviewRulerLanes:ke(new A(75,"overviewRulerLanes",3,0,3)),padding:ke(new ve),parameterHints:ke(new Pe),peekWidgetDefaultFocus:ke(new h(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),definitionLinkOpensInPeek:ke(new o(79,"definitionLinkOpensInPeek",!1,{description:a.localize(238,null)})),quickSuggestions:ke(new xe),quickSuggestionsDelay:ke(new A(81,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(239,null)})),readOnly:ke(new o(82,"readOnly",!1)),renameOnType:ke(new o(83,"renameOnType",!1,{description:a.localize(240,null),markdownDeprecationMessage:a.localize(241,null)})),renderControlCharacters:ke(new o(84,"renderControlCharacters",!0,{description:a.localize(242,null),restricted:!0})),renderFinalNewline:ke(new o(85,"renderFinalNewline",!0,{description:a.localize(243,null)})),renderLineHighlight:ke(new h(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(244,null)],description:a.localize(245,null)})),renderLineHighlightOnlyWhenFocus:ke(new o(87,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(246,null)})),renderValidationDecorations:ke(new h(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new h(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(247,null),a.localize(248,null),a.localize(249,null),""],description:a.localize(250,null)})),revealHorizontalRightPadding:ke(new A(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new o(91,"roundedSelection",!0,{description:a.localize(251,null)})),rulers:ke(new Te),scrollbar:ke(new ue),scrollBeyondLastColumn:ke(new A(94,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(252,null)})),scrollBeyondLastLine:ke(new o(95,"scrollBeyondLastLine",!0,{description:a.localize(253,null)})),scrollPredominantAxis:ke(new o(96,"scrollPredominantAxis",!0,{description:a.localize(254,null)})),selectionClipboard:ke(new o(97,"selectionClipboard",!0,{description:a.localize(255,null),included:v.isLinux})),selectionHighlight:ke(new o(98,"selectionHighlight",!0,{description:a.localize(256,null)})),selectOnLineNumbers:ke(new o(99,"selectOnLineNumbers",!0)),showFoldingControls:ke(new h(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),showUnused:ke(new o(101,"showUnused",!0,{description:a.localize(261,null)})),showDeprecated:ke(new o(128,"showDeprecated",!0,{description:a.localize(262,null)})),inlayHints:ke(new te),snippetSuggestions:ke(new h(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(263,null),a.localize(264,null),a.localize(265,null),a.localize(266,null)],description:a.localize(267,null)})),smartSelect:ke(new se),smoothScrolling:ke(new o(104,"smoothScrolling",!1,{description:a.localize(268,null)})),stopRenderingLineAfter:ke(new A(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new j),inlineSuggest:ke(new Y),suggestFontSize:ke(new A(109,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new A(110,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new o(111,"suggestOnTriggerCharacters",!0,{description:a.localize(271,null)})),suggestSelection:ke(new h(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(272,null),a.localize(273,null),a.localize(274,null)],description:a.localize(275,null)})),tabCompletion:ke(new h(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(276,null),a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),tabIndex:ke(new A(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new X),unusualLineTerminators:ke(new h(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(280,null),a.localize(281,null),a.localize(282,null)],description:a.localize(283,null)})),useShadowDOM:ke(new o(117,"useShadowDOM",!0)),useTabStops:ke(new o(118,"useTabStops",!0,{description:a.localize(284,null)})),wordSeparators:ke(new E(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:a.localize(285,null)})),wordWrap:ke(new h(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(286,null),a.localize(287,null),a.localize(288,null),a.localize(289,null)],description:a.localize(290,null)})),wordWrapBreakAfterCharacters:ke(new E(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new E(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new A(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(291,null)})),wordWrapOverride1:ke(new h(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new h(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new r(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[a.localize(292,null),a.localize(293,null),a.localize(294,null),a.localize(295,null)],description:a.localize(296,null)})),wrappingStrategy:ke(new h(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(297,null),a.localize(298,null)],description:a.localize(299,null)})),editorClassName:ke(new V),pixelRatio:ke(new Fe),tabFocusMode:ke(new de),layoutInfo:ke(new ce),wrappingInfo:ke(new ge)}}),define(ye[124],De([17,18]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[125],De([17,18]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[126],De([17,18]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[127],De([17,18]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ye[128],De([17,18]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(ye[129],De([17,18]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ye[130],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[131],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[132],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[133],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[134],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[135],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[136],De([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[137],De([17,18]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(ye[138],De([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[139],De([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[140],De([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[141],De([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[142],De([17,18]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[143],De([17,18]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[144],De([17,18]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[145],De([1,0,22,29,126,239]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(o){return o=o.trim(),o==="*"||y.test(o)}e.isValidVersionStr=w;function T(o){if(!w(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=o.match(y);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=T;function R(o){if(!o)return null;const g=o.majorBase,A=o.majorMustEqual,l=o.minorBase;let E=o.minorMustEqual;const i=o.patchBase;let h=o.patchMustEqual;o.hasCaret&&(g===0||(E=!1),h=!1);let r=0;if(o.preRelease){const n=P.exec(o.preRelease);if(n){const[,s,t,c]=n;r=Date.UTC(Number(s),Number(t)-1,Number(c))}}return{majorBase:g,majorMustEqual:A,minorBase:l,minorMustEqual:E,patchBase:i,patchMustEqual:h,isMinimum:o.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function S(o,g,A){let l;typeof o=="string"?l=R(T(o)):l=o;let E;g instanceof Date?E=g.getTime():typeof g=="string"&&(E=new Date(g).getTime());let i;if(typeof A=="string"?i=R(T(A)):i=A,!l||!i)return!1;const h=l.majorBase,r=l.minorBase,n=l.patchBase;let s=i.majorBase,t=i.minorBase,c=i.patchBase;const _=i.notBefore;let p=i.majorMustEqual,k=i.minorMustEqual,U=i.patchMustEqual;return i.isMinimum?h>s?!0:h<s?!1:r>t?!0:r<t||E&&E<_?!1:n>=c:(h===1&&s===0&&(!p||!k||!U)&&(s=1,t=0,c=0,p=!0,k=!1,U=!1),h<s?!1:h>s?!p:r<t?!1:r>t?!k:n<c?!1:n>c?!U:!(E&&E<_))}e.isValidVersion=S;function m(o,g,A,l,E){const i=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return i.push([v.default.Error,b.localize(0,null)]),i;if(typeof l.name!="string")return i.push([v.default.Error,b.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([v.default.Error,b.localize(2,null,"version")]),i;if(!l.engines)return i.push([v.default.Error,b.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([v.default.Error,b.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies<"u"&&!u(l.extensionDependencies))return i.push([v.default.Error,b.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents<"u"){if(!u(l.activationEvents))return i.push([v.default.Error,b.localize(6,null,"activationEvents")]),i;if(typeof l.main>"u"&&typeof l.browser>"u")return i.push([v.default.Error,b.localize(7,null,"activationEvents","main")]),i}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&i.push([v.default.Warning,b.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return i.push([v.default.Error,b.localize(9,null,"main")]),i;{const n=(0,a.joinPath)(A,l.main);(0,a.isEqualOrParent)(n,A)||i.push([v.default.Warning,b.localize(10,null,n.path,A.path)])}if(typeof l.activationEvents>"u")return i.push([v.default.Error,b.localize(11,null,"activationEvents","main")]),i}if(typeof l.browser<"u"){if(typeof l.browser!="string")return i.push([v.default.Error,b.localize(12,null,"browser")]),i;{const n=(0,a.joinPath)(A,l.browser);(0,a.isEqualOrParent)(n,A)||i.push([v.default.Warning,b.localize(13,null,n.path,A.path)])}if(typeof l.activationEvents>"u")return i.push([v.default.Error,b.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(l.version))return i.push([v.default.Error,b.localize(15,null)]),i;const h=[];if(!I(o,g,l,E,h))for(const n of h)i.push([v.default.Error,n]);return i}e.validateExtensionManifest=m;function I(o,g,A,l,E){return l||typeof A.main>"u"&&typeof A.browser>"u"?!0:d(o,g,A.engines.vscode,E)}e.isValidExtensionVersion=I;function f(o,g,A){return o==="*"||d(g,A,o)}e.isEngineValid=f;function d(o,g,A,l=[]){const E=R(T(A));if(!E)return l.push(b.localize(16,null,A)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return l.push(b.localize(17,null,A)),!1}else if(!E.majorMustEqual)return l.push(b.localize(18,null,A)),!1;return S(o,g,E)?!0:(l.push(b.localize(19,null,o,A)),!1)}function u(o){if(!Array.isArray(o))return!1;for(let g=0,A=o.length;g<A;g++)if(typeof o[g]!="string")return!1;return!0}}),define(ye[78],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(b,M=[],y=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=a}),define(ye[57],De([1,0,78]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const v=[];function b(y,P,w){P instanceof a.SyncDescriptor||(P=new a.SyncDescriptor(P,[],w)),v.push([y,P])}e.registerSingleton=b;function M(){return v}e.getSingletonServiceDescriptors=M}),define(ye[146],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=a;class v{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const y of this._nodes.values())y.outgoing.size===0&&M.push(y);return M}insertEdge(M,y){const P=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),w),w.incoming.set(this._hashFn(M),P)}removeNode(M){const y=this._hashFn(M);this._nodes.delete(y);for(const P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(M){const y=this._hashFn(M);let P=this._nodes.get(y);return P||(P=new a(M),this._nodes.set(y,P)),P}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[y,P]of this._nodes)M.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(const[M,y]of this._nodes){const P=new Set([M]),w=this._findCycle(y,P);if(w)return w}}_findCycle(M,y){for(const[P,w]of M.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const T=this._findCycle(w,y);if(T)return T;y.delete(P)}}}e.Graph=v}),define(ye[3],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function v(y,P,w){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:y,index:w}):(P[a.DI_DEPENDENCIES]=[{id:y,index:w}],P[a.DI_TARGET]=P)}function b(y){if(a.serviceIds.has(y))return a.serviceIds.get(y);const P=function(w,T,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");v(P,w,R)};return P.toString=()=>y,a.serviceIds.set(y,P),P}e.createDecorator=b;function M(y){return y}e.refineServiceDecorator=M}),define(ye[58],De([1,0,10,2,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof v.URI)}e.isConfigurationOverrides=M;function y(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof v.URI)}e.isConfigurationUpdateOverrides=y;var P;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function T(o,g){const A=Object.create(null);for(const l in o)R(A,l,o[l],g);return A}e.toValuesTree=T;function R(o,g,A,l){const E=g.split("."),i=E.pop();let h=o;for(let r=0;r<E.length;r++){const n=E[r];let s=h[n];switch(typeof s){case"undefined":s=h[n]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${E.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}h=s}if(typeof h=="object"&&h!==null)try{h[i]=A}catch{l(`Ignoring ${g} as ${E.join(".")} is ${JSON.stringify(h)}`)}else l(`Ignoring ${g} as ${E.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=R;function S(o,g){const A=g.split(".");m(o,A)}e.removeFromValueTree=S;function m(o,g){const A=g.shift();if(g.length===0){delete o[A];return}if(Object.keys(o).indexOf(A)!==-1){const l=o[A];typeof l=="object"&&!Array.isArray(l)&&(m(l,g),Object.keys(l).length===0&&delete o[A])}}function I(o,g,A){function l(h,r){let n=h;for(const s of r){if(typeof n!="object"||n===null)return;n=n[s]}return n}const E=g.split("."),i=l(o,E);return typeof i>"u"?A:i}e.getConfigurationValue=I;function f(o,g,A){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in o?a.isObject(o[l])&&a.isObject(g[l])?f(o[l],g[l],A):A&&(o[l]=g[l]):o[l]=g[l])})}e.merge=f;function d(o,g,A){const l=o.inspect(g),E=o.inspect(A);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:l.defaultValue}e.getMigratedSettingValue=d;function u(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(ye[38],De([1,0,21,9,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",a.isMacintosh),M.set("isLinux",a.isLinux),M.set("isWindows",a.isWindows),M.set("isWeb",a.isWeb),M.set("isMacNative",a.isMacintosh&&!a.isWeb),M.set("isEdge",a.isEdge),M.set("isFirefox",a.isFirefox),M.set("isChrome",a.isChrome),M.set("isSafari",a.isSafari);const y=Object.prototype.hasOwnProperty;var P;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return S.INSTANCE}static true(){return m.INSTANCE}static has(D){return I.create(D)}static equals(D,L){return f.create(D,L)}static notEquals(D,L){return o.create(D,L)}static regex(D,L){return r.create(D,L)}static in(D,L){return d.create(D,L)}static notIn(D,L){return u.create(D,L)}static not(D){return g.create(D)}static and(...D){return t.create(D,null)}static or(...D){return c.create(D,null,!0)}static greater(D,L){return l.create(D,L)}static greaterEquals(D,L){return E.create(D,L)}static smaller(D,L){return i.create(D,L)}static smallerEquals(D,L){return h.create(D,L)}static deserialize(D,L=!1){if(!!D)return this._deserializeOrExpression(D,L)}static _deserializeOrExpression(D,L){const B=D.split("||");return c.create(B.map(F=>this._deserializeAndExpression(F,L)),null,!0)}static _deserializeAndExpression(D,L){const B=D.split("&&");return t.create(B.map(F=>this._deserializeOne(F,L)),null)}static _deserializeOne(D,L){if(D=D.trim(),D.indexOf("!=")>=0){const B=D.split("!=");return o.create(B[0].trim(),this._deserializeValue(B[1],L))}if(D.indexOf("==")>=0){const B=D.split("==");return f.create(B[0].trim(),this._deserializeValue(B[1],L))}if(D.indexOf("=~")>=0){const B=D.split("=~");return r.create(B[0].trim(),this._deserializeRegexValue(B[1],L))}if(D.indexOf(" not in ")>=0){const B=D.split(" not in ");return u.create(B[0].trim(),B[1].trim())}if(D.indexOf(" in ")>=0){const B=D.split(" in ");return d.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const B=D.split(">=");return E.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const B=D.split(">");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const B=D.split("<=");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const B=D.split("<");return i.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(D)?g.create(D.substr(1).trim()):I.create(D)}static _deserializeValue(D,L){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const B=/^'([^']*)'$/.exec(D);return B?B[1].trim():D}static _deserializeRegexValue(D,L){if((0,v.isFalsyOrWhitespace)(D)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const B=D.indexOf("/"),F=D.lastIndexOf("/");if(B===F||B<0){if(L)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const K=D.slice(B+1,F),H=D[F+1]==="i"?"i":"";try{return new RegExp(K,H)}catch(O){if(L)throw new Error(`bad regexp-value '${D}', parse error: ${O}`);return console.warn(`bad regexp-value '${D}', parse error: ${O}`),null}}}e.ContextKeyExpr=w;function T(x,D){const L=x?x.substituteConstants():void 0,B=D?D.substituteConstants():void 0;return!L&&!B?!0:!L||!B?!1:L.equals(B)}e.expressionsAreEqualWithConstantSubstitution=T;function R(x,D){return x.cmp(D)}class S{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class I{constructor(D,L){this.key=D,this.negated=L,this.type=2}static create(D,L=null){const B=M.get(D);return typeof B=="boolean"?B?m.INSTANCE:S.INSTANCE:new I(D,L)}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:S.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class f{constructor(D,L,B){this.key=D,this.value=L,this.negated=B,this.type=4}static create(D,L,B=null){if(typeof L=="boolean")return L?I.create(D,B):g.create(D,B);const F=M.get(D);return typeof F=="boolean"?L===(F?"true":"false")?m.INSTANCE:S.INSTANCE:new f(D,L,B)}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const L=D?"true":"false";return this.value===L?m.INSTANCE:S.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class d{constructor(D,L){this.key=D,this.valueKey=L,this.type=10,this.negated=null}static create(D,L){return new d(D,L)}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const L=D.getValue(this.valueKey),B=D.getValue(this.key);return Array.isArray(L)?L.includes(B):typeof B=="string"&&typeof L=="object"&&L!==null?y.call(L,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=d;class u{constructor(D,L){this.key=D,this.valueKey=L,this.type=11,this._negated=d.create(D,L)}static create(D,L){return new u(D,L)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=u;class o{constructor(D,L,B){this.key=D,this.value=L,this.negated=B,this.type=5}static create(D,L,B=null){if(typeof L=="boolean")return L?g.create(D,B):I.create(D,B);const F=M.get(D);return typeof F=="boolean"?L===(F?"true":"false")?S.INSTANCE:m.INSTANCE:new o(D,L,B)}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const L=D?"true":"false";return this.value===L?S.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=o;class g{constructor(D,L){this.key=D,this.negated=L,this.type=3}static create(D,L=null){const B=M.get(D);return typeof B=="boolean"?B?S.INSTANCE:m.INSTANCE:new g(D,L)}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?S.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function A(x,D){if(typeof x=="string"){const L=parseFloat(x);isNaN(L)||(x=L)}return typeof x=="string"||typeof x=="number"?D(x):S.INSTANCE}class l{constructor(D,L,B){this.key=D,this.value=L,this.negated=B,this.type=12}static create(D,L,B=null){return A(L,F=>new l(D,F,B))}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class E{constructor(D,L,B){this.key=D,this.value=L,this.negated=B,this.type=13}static create(D,L,B=null){return A(L,F=>new E(D,F,B))}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=E;class i{constructor(D,L,B){this.key=D,this.value=L,this.negated=B,this.type=14}static create(D,L,B=null){return A(L,F=>new i(D,F,B))}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class h{constructor(D,L,B){this.key=D,this.value=L,this.negated=B,this.type=15}static create(D,L,B=null){return A(L,F=>new h(D,F,B))}cmp(D){return D.type!==this.type?this.type-D.type:k(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class r{constructor(D,L){this.key=D,this.regexp=L,this.type=7,this.negated=null}static create(D,L){return new r(D,L)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const L=this.regexp?this.regexp.source:"",B=D.regexp?D.regexp.source:"";return L<B?-1:L>B?1:0}equals(D){if(D.type===this.type){const L=this.regexp?this.regexp.source:"",B=D.regexp?D.regexp.source:"";return this.key===D.key&&L===B}return!1}substituteConstants(){return this}evaluate(D){const L=D.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(D){this._actual=D,this.type=8}static create(D){return new n(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(x){let D=null;for(let L=0,B=x.length;L<B;L++){const F=x[L].substituteConstants();if(x[L]!==F&&D===null){D=[];for(let K=0;K<L;K++)D[K]=x[K]}D!==null&&(D[L]=F)}return D===null?x:D}class t{constructor(D,L){this.expr=D,this.negated=L,this.type=6}static create(D,L){return t._normalizeArr(D,L)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const F=R(this.expr[L],D.expr[L]);if(F!==0)return F}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(D.expr[L]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:t.create(D,this.negated)}evaluate(D){for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].evaluate(D))return!1;return!0}static _normalizeArr(D,L){const B=[];let F=!1;for(const K of D)if(!!K){if(K.type===1){F=!0;continue}if(K.type===0)return S.INSTANCE;if(K.type===6){B.push(...K.expr);continue}B.push(K)}if(B.length===0&&F)return m.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(R);for(let K=1;K<B.length;K++)B[K-1].equals(B[K])&&(B.splice(K,1),K--);if(B.length===1)return B[0];for(;B.length>1;){const K=B[B.length-1];if(K.type!==9)break;B.pop();const H=B.pop(),O=B.length===0,ee=c.create(K.expr.map(ce=>t.create([ce,H],null)),null,O);ee&&(B.push(ee),B.sort(R))}return B.length===1?B[0]:new t(B,L)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const L of this.expr)D.push(...L.keys());return D}map(D){return new t(this.expr.map(L=>L.map(D)),null)}negate(){if(!this.negated){const D=[];for(const L of this.expr)D.push(L.negate());this.negated=c.create(D,this,!0)}return this.negated}}class c{constructor(D,L){this.expr=D,this.negated=L,this.type=9}static create(D,L,B){return c._normalizeArr(D,L,B)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const F=R(this.expr[L],D.expr[L]);if(F!==0)return F}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(D.expr[L]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:c.create(D,this.negated,!1)}evaluate(D){for(let L=0,B=this.expr.length;L<B;L++)if(this.expr[L].evaluate(D))return!0;return!1}static _normalizeArr(D,L,B){let F=[],K=!1;if(D){for(let H=0,O=D.length;H<O;H++){const ee=D[H];if(!!ee){if(ee.type===0){K=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){F=F.concat(ee.expr);continue}F.push(ee)}}if(F.length===0&&K)return S.INSTANCE;F.sort(R)}if(F.length!==0){if(F.length===1)return F[0];for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];if(B){for(let H=0;H<F.length;H++)for(let O=H+1;O<F.length;O++)U(F[H],F[O])&&(F.splice(O,1),O--);if(F.length===1)return F[0]}return new c(F,L)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const L of this.expr)D.push(...L.keys());return D}map(D){return new c(this.expr.map(L=>L.map(D)),null)}negate(){if(!this.negated){const D=[];for(const L of this.expr)D.push(L.negate());for(;D.length>1;){const L=D.shift(),B=D.shift(),F=[];for(const H of V(L))for(const O of V(B))F.push(t.create([H,O],null));const K=D.length===0;D.unshift(c.create(F,null,K))}this.negated=D[0]}return this.negated}}class _ extends I{constructor(D,L,B){super(D,null),this._defaultValue=L,typeof B=="object"?_._info.push({...B,key:D}):B!==!0&&_._info.push({key:D,description:B,type:L!=null?typeof L:void 0})}static all(){return _._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return f.create(this.key,D)}notEqualsTo(D){return o.create(this.key,D)}}e.RawContextKey=_,_._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(x,D){return x<D?-1:x>D?1:0}function k(x,D,L,B){return x<L?-1:x>L?1:D<B?-1:D>B?1:0}function U(x,D){if(D.type===6&&x.type!==9&&x.type!==6){for(const F of D.expr)if(x.equals(F))return!0}const L=x.negate(),B=V(L).concat(V(D));B.sort(R);for(let F=0;F<B.length;F++){const H=B[F].negate();for(let O=F+1;O<B.length;O++){const ee=B[O];if(H.equals(ee))return!0}}return!1}e.implies=U;function V(x){return x.type===9?x.expr:[x]}}),define(ye[147],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[79],De([1,0,125,3]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function M(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function y(o,g){switch(o){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function P(o,g){return g==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(o,g,A){return P(g,A)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===A?!0:T(A).includes(o)}e.isTargetPlatformCompatible=w;function T(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function R(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=R;var S;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var I;(function(o){o.Install="install",o.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var f;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,v.createDecorator)("extensionGalleryService");var d;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(g,A){super(g),this.code=A,this.name=A}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,v.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,v.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,v.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,v.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,v.createDecorator)("IExtensionManagementCLIService")}),define(ye[39],De([1,0,25,19,9,10,2,127,3]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function T(H){return H.create===!0}e.isFileOpenForWriteOptions=T;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var S;(function(H){H[H.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var m;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=I;function f(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=f;function d(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=d;function u(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function o(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=o;function g(H){return I(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var A;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(O,ee){super(O),this.code=ee}}e.FileSystemProviderError=l;function E(H,O){const ee=new l(H.toString(),O);return h(ee,O),ee}e.createFileSystemProviderError=E;function i(H){return H||E((0,P.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=i;function h(H,O){return H.name=O?`${O} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=h;function r(H){if(!H)return A.Unknown;if(H instanceof l)return H.code;const O=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!O)return A.Unknown;switch(O[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=r;function n(H){if(H instanceof k)return H.fileOperationResult;switch(r(H)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class t{constructor(O,ee,ce){this.resource=O,this.operation=ee,this.target=ce}isOperation(O){return this.operation===O}}e.FileOperationEvent=t;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class _{constructor(O,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const ce=new Map;for(const oe of O){const le=ce.get(oe.type);switch(le?le.push([oe.resource,oe]):ce.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,le]of ce)switch(oe){case 1:this.added=a.TernarySearchTree.forUris(()=>ee),this.added.fill(le);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>ee),this.updated.fill(le);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>ee),this.deleted.fill(le);break}}contains(O,...ee){return this.doContains(O,{includeChildren:!1},...ee)}affects(O,...ee){return this.doContains(O,{includeChildren:!0},...ee)}doContains(O,ee,...ce){if(!O)return!1;const oe=ce.length>0;return!!((!oe||ce.includes(1))&&(this.added?.get(O)||ee.includeChildren&&this.added?.findSuperstr(O))||(!oe||ce.includes(0))&&(this.updated?.get(O)||ee.includeChildren&&this.updated?.findSuperstr(O))||(!oe||ce.includes(2))&&(this.deleted?.findSubstr(O)||ee.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=_;function p(H,O,ee){return!H||!O||H===O||O.length>H.length?!1:(O.charAt(O.length-1)!==v.sep&&(O+=v.sep),ee?(0,b.startsWithIgnoreCase)(H,O):H.indexOf(O)===0)}e.isParent=p;class k extends Error{constructor(O,ee,ce){super(O),this.fileOperationResult=ee,this.options=ce}}e.FileOperationError=k;class U extends k{constructor(O,ee,ce){super(O,2,ce),this.stat=ee}}e.NotModifiedSinceFileOperationError=U;var V;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=D;async function L(H,O){if(!O.hasProvider(y.URI.from({scheme:H.scheme})))return new Promise(ee=>{const ce=O.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===H.scheme&&oe.added&&(ce.dispose(),ee())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(O){return(0,M.isNumber)(O)||(O=0),O<B.KB?(0,P.localize)(1,null,O.toFixed(0)):O<B.MB?(0,P.localize)(2,null,(O/B.KB).toFixed(2)):O<B.GB?(0,P.localize)(3,null,(O/B.MB).toFixed(2)):O<B.TB?(0,P.localize)(4,null,(O/B.GB).toFixed(2)):(0,P.localize)(5,null,(O/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var F;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function K(H){return{maxFileSize:H===0?300*B.MB:16*B.GB,maxHeapSize:H===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=K}),define(ye[59],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...b){this._entries=new Map;for(const[M,y]of b)this.set(M,y)}set(b,M){const y=this._entries.get(b);return this._entries.set(b,M),y}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=a}),define(ye[148],De([1,0,14,11,78,146,3,59]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class T extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new P.ServiceCollection,d=!1,u){this._activeInstantiations=new Set,this._services=f,this._strict=d,this._parent=u,this._services.set(y.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...d){const u=m.traceInvocation(f);let o=!1;try{return f({get:A=>{if(o)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(A,u);if(!l)throw new Error(`[invokeFunction] unknown service '${A}'`);return l}},...d)}finally{o=!0,u.stop()}}createInstance(f,...d){let u,o;return f instanceof b.SyncDescriptor?(u=m.traceCreation(f.ctor),o=this._createInstance(f.ctor,f.staticArguments.concat(d),u)):(u=m.traceCreation(f),o=this._createInstance(f,d,u)),u.stop(),o}_createInstance(f,d=[],u){const o=y._util.getServiceDependencies(f).sort((l,E)=>l.index-E.index),g=[];for(const l of o){const E=this._getOrCreateServiceInstance(l.id,u);E||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(E)}const A=o.length>0?o[0].index:d.length;if(d.length!==A){console.trace(`[createInstance] First service dependency of ${f.name} at position ${A+1} conflicts with ${d.length} static arguments`);const l=A-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,A)}return new f(...d,...g)}_setServiceInstance(f,d){if(this._services.get(f)instanceof b.SyncDescriptor)this._services.set(f,d);else if(this._parent)this._parent._setServiceInstance(f,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const d=this._services.get(f);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):d}_getOrCreateServiceInstance(f,d){const u=this._getServiceInstanceOrDescriptor(f);return u instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,u,d.branch(f,!0)):(d.branch(f,!1),u)}_safeCreateAndCacheServiceInstance(f,d,u){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,d,u)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,d,u){const o=new M.Graph(l=>l.id.toString());let g=0;const A=[{id:f,desc:d,_trace:u}];for(;A.length;){const l=A.pop();if(o.lookupOrInsertNode(l),g++>1e3)throw new T(o);for(const E of y._util.getServiceDependencies(l.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(E.id);if(i||this._throwIfStrict(`[createInstance] ${f} depends on ${E.id} which is NOT registered.`,!0),i instanceof b.SyncDescriptor){const h={id:E.id,desc:i,_trace:l._trace.branch(E.id,!0)};o.insertEdge(l,h),A.push(h)}}}for(;;){const l=o.roots();if(l.length===0){if(!o.isEmpty())throw new T(o);break}for(const{data:E}of l){if(this._getServiceInstanceOrDescriptor(E.id)instanceof b.SyncDescriptor){const h=this._createServiceInstanceWithOwner(E.id,E.desc.ctor,E.desc.staticArguments,E.desc.supportsDelayedInstantiation,E._trace);this._setServiceInstance(E.id,h)}o.removeNode(E)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,d,u=[],o,g){if(this._services.get(f)instanceof b.SyncDescriptor)return this._createServiceInstance(d,u,o,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,d,u,o,g);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(f,d=[],u,o){if(u){const g=new a.IdleValue(()=>this._createInstance(f,d,o));return new Proxy(Object.create(null),{get(A,l){if(l in A)return A[l];const E=g.value;let i=E[l];return typeof i!="function"||(i=i.bind(E),A[l]=i),i},set(A,l,E){return g.value[l]=E,!0}})}else return this._createInstance(f,d,o)}_throwIfStrict(f,d){if(d&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=R;var S;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(S||(S={}));class m{constructor(f,d){this.type=f,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return w?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return w?new m(0,f.name):m._None}branch(f,d){const u=new m(2,f.toString());return this._dep.push([f,d,u]),u}stop(){const f=Date.now()-this._start;m._totals+=f;let d=!1;function u(g,A){const l=[],E=new Array(g+1).join("	");for(const[i,h,r]of A._dep)if(h&&r){d=!0,l.push(`${E}CREATES -> ${i}`);const n=u(g+1,r);n&&l.push(n)}else l.push(`${E}uses -> ${i}`);return l.join(`
`)}const o=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||d)&&console.log(o.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ye[15],De([1,0,43,5,7,21,3]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function T(h,r,n){switch(r){case w.Trace:h.trace(n);break;case w.Debug:h.debug(n);break;case w.Info:h.info(n);break;case w.Warning:h.warn(n);break;case w.Error:h.error(n);break;case w.Critical:h.critical(n);break;default:throw new Error("Invalid log level")}}e.log=T;function R(h){let r="";for(let n=0;n<h.length;n++){let s=h[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(n>0?" ":"")+s}return r}e.format=R;class S extends b.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new v.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class m extends S{constructor(r){super(),this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(w.Trace)&&this.log(w.Trace,R([r,...n]))}debug(r,...n){this.checkLogLevel(w.Debug)&&this.log(w.Debug,R([r,...n]))}info(r,...n){this.checkLogLevel(w.Info)&&this.log(w.Info,R([r,...n]))}warn(r,...n){this.checkLogLevel(w.Warning)&&this.log(w.Warning,R([r,...n]))}error(r,...n){if(this.checkLogLevel(w.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(w.Error,R(s))}else this.log(w.Error,R([r,...n]))}critical(r,...n){this.checkLogLevel(w.Critical)&&this.log(w.Critical,R([r,...n]))}flush(){}}e.AbstractMessageLogger=m;class I extends S{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.useColors=!M.isWindows}trace(r,...n){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}debug(r,...n){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}info(r,...n){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}warn(r,...n){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,r,...n):console.warn(`[main ${P()}]`,r,...n))}error(r,...n){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,r,...n):console.error(`[main ${P()}]`,r,...n))}critical(r,...n){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,r,...n):console.error(`[main ${P()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class f extends S{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...n){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class d extends S{constructor(r,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,a.toErrorMessage)(r,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class u extends S{constructor(r){super(),this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const s of this.logServices)s.trace(r,...n)}debug(r,...n){for(const s of this.logServices)s.debug(r,...n)}info(r,...n){for(const s of this.logServices)s.info(r,...n)}warn(r,...n){for(const s of this.logServices)s.warn(r,...n)}error(r,...n){for(const s of this.logServices)s.error(r,...n)}critical(r,...n){for(const s of this.logServices)s.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=u;class o extends b.Disposable{constructor(r){super(),this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=o;class g extends b.Disposable{constructor(r,n){super(),this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,n?.always?w.Trace:this.logLevel,n),this.loggers.set(r.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class A{constructor(){this.onDidChangeLogLevel=new v.Emitter().event}setLevel(r){}getLevel(){return w.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=A;function l(h){if(h.verbose)return w.Trace;if(typeof h.logLevel=="string"){const r=E(h.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function E(h){switch(h){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=E;function i(h){switch(h){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=i}),define(ye[80],De([1,0,29,128,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var y;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function T(f,d){return d-f}w.compare=T;const R=Object.create(null);R[w.Error]=(0,v.localize)(0,null),R[w.Warning]=(0,v.localize)(1,null),R[w.Info]=(0,v.localize)(2,null);function S(f){return R[f]||""}w.toString=S;function m(f){switch(f){case a.default.Error:return w.Error;case a.default.Warning:return w.Warning;case a.default.Info:return w.Info;case a.default.Ignore:return w.Hint}}w.fromSeverity=m;function I(f){switch(f){case w.Error:return a.default.Error;case w.Warning:return a.default.Warning;case w.Info:return a.default.Info;case w.Hint:return a.default.Ignore}}w.toSeverity=I}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(w){const T="";function R(m){return S(m,!0)}w.makeKey=R;function S(m,I){const f=[T];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(T),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(T),m.severity!==void 0&&m.severity!==null?f.push(y.toString(m.severity)):f.push(T),m.message&&I?f.push(m.message.replace("\xA6","\\\xA6")):f.push(T),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(T),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(T),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(T),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(T),f.push(T),f.join("\xA6")}w.makeKeyOptionalMessage=S})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(ye[149],De([1,0,5,29,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,b.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new w,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=P;class w{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=w}),define(ye[81],De([1,0,7,9,2,3]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,S){return b.URI.isUri(R)?(0,v.equalsIgnoreCase)(R.scheme,S):(0,v.startsWithIgnoreCase)(R,S+":")}e.matchesScheme=y;function P(R,...S){return S.some(m=>y(R,m))}e.matchesSomeScheme=P;function w(R,S){return R.with({fragment:`${S.startLineNumber},${S.startColumn}${S.endLineNumber?`-${S.endLineNumber}${S.endColumn?`,${S.endColumn}`:""}`:""}`})}e.withSelection=w;function T(R){let S;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return m&&(S={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},R=R.with({fragment:""})),{selection:S,uri:R}}e.extractSelection=T}),define(ye[150],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ie,e,a,v){var b=arguments.length,M=b<3?e:v===null?v=Object.getOwnPropertyDescriptor(e,a):v,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,a,v);else for(var P=ie.length-1;P>=0;P--)(y=ie[P])&&(M=(b<3?y(M):b>3?y(e,a,M):y(e,a))||M);return b>3&&M&&Object.defineProperty(e,a,M),M},$e=this&&this.__param||function(ie,e){return function(a,v){e(a,v,ie)}};define(ye[151],De([1,0,14,20,7,3]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var y;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(S){this.callback=S}get value(){return this._value}report(S){this._value=S,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let w=class extends b.Disposable{constructor(S,m){super(),this.deferred=new a.DeferredPromise,m.withProgress(S,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};w=ze([$e(1,e.IProgressService)],w),e.UnmanagedProgress=w;class T extends b.Disposable{constructor(S){super(),this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(S){this.stop();const m=++this.currentOperationId,I=new v.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:I.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(ye[30],De([1,0,44,10]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(y,P){a.ok(v.isString(y)),a.ok(v.isObject(P)),a.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new b}),define(ye[82],De([1,0,5,30]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,T){this.schemasById[b(w)]=T,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new M;v.Registry.add(e.Extensions.JSONContribution,y)}),define(ye[83],De([1,0,16,5,10,124,58,82,30]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=w.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new v.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new v.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,h=!0){this.registerConfigurations([i],h)}registerConfigurations(i,h=!0){const r=this.doRegisterConfigurations(i,h);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(i){const h=this.doDeregisterConfigurations(i);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:i,remove:h}){const r=[];r.push(...this.doDeregisterConfigurations(h)),r.push(...this.doRegisterConfigurations(i,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(r)})}registerDefaultConfigurations(i){const h=[],r=[];for(const{overrides:n,source:s}of i)for(const t in n)if(h.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),_=c?.valuesSources??new Map;if(s)for(const V of Object.keys(n[t]))_.set(V,s);const p={...c?.value||{},...n[t]};this.configurationDefaultsOverrides.set(t,{source:s,value:p,valuesSources:_});const k=(0,y.getLanguageTagSettingPlainKey)(t),U={type:"object",default:p,description:M.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:b.isString(s)?void 0:s,defaultValueSource:s};r.push(...d(t)),this.configurationProperties[t]=U,this.defaultLanguageConfigurationOverridesNode.properties[t]=U}else{this.configurationDefaultsOverrides.set(t,{value:n[t],source:s});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const h=[];for(const{overrides:r,source:n}of i)for(const s in r){const t=this.configurationDefaultsOverrides.get(s),c=b.isString(n)?n:n?.id,_=b.isString(t?.source)?t?.source:t?.source?.id;if(c===_)if(h.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const p=this.configurationProperties[s];p&&(this.updatePropertyDefaultValue(s,p),this.updateSchema(s,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const h of i)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,h){const r=[];return i.forEach(n=>{r.push(...this.validateAndRegisterProperties(n,h,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),r}doDeregisterConfigurations(i){const h=[],r=n=>{if(n.properties)for(const s in n.properties){h.push(s);const t=this.configurationProperties[s];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>r(s))};for(const n of i){r(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return h}validateAndRegisterProperties(i,h=!0,r,n,s=3){s=b.isUndefinedOrNull(i.scope)?s:i.scope;const t=[],c=i.properties;if(c)for(const p in c){const k=c[p];if(h&&A(p,k)){delete c[p];continue}if(k.source=r,k.defaultDefaultValue=c[p].default,this.updatePropertyDefaultValue(p,k),e.OVERRIDE_PROPERTY_REGEX.test(p)?k.scope=void 0:(k.scope=b.isUndefinedOrNull(k.scope)?s:k.scope,k.restricted=b.isUndefinedOrNull(k.restricted)?!!n?.includes(p):k.restricted),c[p].hasOwnProperty("included")&&!c[p].included){this.excludedConfigurationProperties[p]=c[p],delete c[p];continue}else this.configurationProperties[p]=c[p],c[p].policy?.name&&this.policyConfigurations.set(c[p].policy.name,p);!c[p].deprecationMessage&&c[p].markdownDeprecationMessage&&(c[p].deprecationMessage=c[p].markdownDeprecationMessage),t.push(p)}const _=i.allOf;if(_)for(const p of _)t.push(...this.validateAndRegisterProperties(p,h,r,n,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const h=r=>{const n=r.properties;if(n)for(const t in n)this.updateSchema(t,n[t]);r.allOf?.forEach(h)};h(i)}updateSchema(i,h){switch(e.allSettings.properties[i]=h,h.scope){case 1:e.applicationSettings.properties[i]=h;break;case 2:e.machineSettings.properties[i]=h;break;case 6:e.machineOverridableSettings.properties[i]=h;break;case 3:e.windowSettings.properties[i]=h;break;case 4:e.resourceSettings.properties[i]=h;break;case 5:e.resourceSettings.properties[i]=h,this.resourceLanguageSettingsSchema.properties[i]=h;break}}removeFromSchema(i,h){switch(delete e.allSettings.properties[i],h.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const h=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,r),e.allSettings.properties[h]=r,e.applicationSettings.properties[h]=r,e.machineSettings.properties[h]=r,e.machineOverridableSettings.properties[h]=r,e.windowSettings.properties[h]=r,e.resourceSettings.properties[h]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,h){const r=this.configurationDefaultsOverrides.get(i);let n=r?.value,s=r?.source;b.isUndefined(n)&&(n=h.defaultDefaultValue,s=void 0),b.isUndefined(n)&&(n=o(h.type)),h.default=n,h.defaultValueSource=s}}const I="\\[([^\\]]+)\\]",f=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(E){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let h=f.exec(E);for(;h?.length;){const r=h[1].trim();r&&i.push(r),h=f.exec(E)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=d;function u(E){return E.reduce((i,h)=>`${i}[${h}]`,"")}e.keyFromOverrideIdentifiers=u;function o(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const g=new m;w.Registry.add(e.Extensions.Configuration,g);function A(E,i){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?M.localize(7,null,E):g.getConfigurationProperties()[E]!==void 0?M.localize(8,null,E):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,E,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=A;function l(){const E=[],i=g.getConfigurationProperties();for(const h of Object.keys(i))E.push([h,i[h].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=l}),define(ye[152],De([1,0,16,5,106,7,25,26,10,2,58,83,30]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(i={},h=[],r=[]){this._contents=i,this._keys=h,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,h){const r=this.getContentsForOverrideIdentifer(h);return r?i?(0,R.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const h=[];for(const r of this.overrides)r.identifiers.includes(i)&&h.push(...r.keys);return a.distinct(h)}getAllOverrideIdentifiers(){const i=[];for(const h of this.overrides)i.push(...h.identifiers);return a.distinct(i)}override(i){let h=this.overrideConfigurations.get(i);return h||(h=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,h)),h}merge(...i){const h=P.deepClone(this.contents),r=P.deepClone(this.overrides),n=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(h,s.contents);for(const t of s.overrides){const[c]=r.filter(_=>a.equals(_.identifiers,t.identifiers));c?(this.mergeContents(c.contents,t.contents),c.keys.push(...t.keys),c.keys=a.distinct(c.keys)):r.push(P.deepClone(t))}for(const t of s.keys)n.indexOf(t)===-1&&n.push(t)}return new I(h,n,r)}freeze(){return this.frozen=!0,this}clone(){return new I(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(i){const h=this.getContentsForOverrideIdentifer(i);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const r={};for(const n of a.distinct([...Object.keys(this.contents),...Object.keys(h)])){let s=this.contents[n];const t=h[n];t&&(typeof s=="object"&&typeof t=="object"?(s=P.deepClone(s),this.mergeContents(s,t)):s=t),r[n]=s}return new I(r,this.keys,this.overrides)}mergeContents(i,h){for(const r of Object.keys(h)){if(r in i&&w.isObject(i[r])&&w.isObject(h[r])){this.mergeContents(i[r],h[r]);continue}i[r]=P.deepClone(h[r])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let h=null,r=null;const n=s=>{s&&(r?this.mergeContents(r,s):r=P.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[i])?h=s.contents:s.identifiers.includes(i)&&n(s.contents);return n(h),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,h){this.addKey(i),(0,R.addToValueTree)(this.contents,i,h,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let h=this.keys.length;for(let r=0;r<h;r++)i.indexOf(this.keys[r])===0&&(h=r);this.keys.splice(h,1,i)}removeKey(i){const h=this.keys.indexOf(i);return h!==-1?(this.keys.splice(h,1),!0):!1}}e.ConfigurationModel=I;class f{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,h){if(!w.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,h)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,h){this._raw=i;const{contents:r,keys:n,overrides:s,restricted:t}=this.doParseRaw(i,h);this._configurationModel=new I(r,n,s),this._restrictedConfigurations=t||[]}doParseContent(i){let h={},r=null,n=[];const s=[],t=[];function c(p){Array.isArray(n)?n.push(p):r!==null&&(n[r]=p)}const _={onObjectBegin:()=>{const p={};c(p),s.push(n),n=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const p=[];c(p),s.push(n),n=p,r=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:c,onError:(p,k,U)=>{t.push({error:p,offset:k,length:U})}};if(i)try{b.visit(i,_),h=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return h}doParseRaw(i,h){const r=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,r,!0,h);i=n.raw;const s=(0,R.toValuesTree)(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),t=Object.keys(i),c=this.toOverrides(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:s,keys:t,overrides:c,restricted:n.restricted}}filter(i,h,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[]};const s={},t=[];for(const c in i)if(S.OVERRIDE_PROPERTY_REGEX.test(c)&&r){const _=this.filter(i[c],h,!1,n);s[c]=_.raw,t.push(..._.restricted)}else{const _=h[c],p=_?typeof _.scope<"u"?_.scope:3:void 0;_?.restricted&&t.push(c),(p===void 0||n.scopes===void 0||n.scopes.includes(p))&&(n.skipRestricted&&_?.restricted||(s[c]=i[c]))}return{raw:s,restricted:t}}toOverrides(i,h){const r=[];for(const n of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const t in i[n])s[t]=i[n][t];r.push({identifiers:(0,S.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,h)})}return r}}e.ConfigurationModelParser=f;class d extends M.Disposable{constructor(i,h,r,n){super(),this.userSettingsResource=i,this.scopes=h,this.fileService=n,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.any(v.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),v.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class u{constructor(i,h,r,n,s=new I,t=new I,c=new y.ResourceMap,_=new I,p=new y.ResourceMap,k=!0){this._defaultConfiguration=i,this._policyConfiguration=h,this._applicationConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=t,this._folderConfigurations=c,this._memoryConfiguration=_,this._memoryConfigurationByResource=p,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(i,h,r){return this.getConsolidatedConfigurationModel(i,h,r).getValue(i)}updateValue(i,h,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new I,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,h===void 0?n.removeValue(i):n.setValue(i,h),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,h,r){const n=this.getConsolidatedConfigurationModel(i,h,r),s=this.getFolderConfigurationModelForResource(h.resource,r),t=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,c=h.overrideIdentifier?this._defaultConfiguration.freeze().override(h.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),_=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),p=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),k=h.overrideIdentifier?this.userConfiguration.freeze().override(h.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),U=h.overrideIdentifier?this.localUserConfiguration.freeze().override(h.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),V=h.overrideIdentifier?this.remoteUserConfiguration.freeze().override(h.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),x=r?h.overrideIdentifier?this._workspaceConfiguration.freeze().override(h.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,D=s?h.overrideIdentifier?s.freeze().override(h.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,L=h.overrideIdentifier?t.override(h.overrideIdentifier).getValue(i):t.getValue(i),B=n.getValue(i),F=a.distinct(n.overrides.map(K=>K.identifiers).flat()).filter(K=>n.getOverrideValue(i,K)!==void 0);return{defaultValue:c,policyValue:_,applicationValue:p,userValue:k,userLocalValue:U,userRemoteValue:V,workspaceValue:x,workspaceFolderValue:D,memoryValue:L,value:B,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:h.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,policy:_!==void 0?{value:_}:void 0,application:p!==void 0?{value:p,override:h.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:h.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:h.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,userRemote:V!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:h.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:h.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:s?.freeze().getValue(i),override:h.overrideIdentifier?s?.freeze().getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:t.getValue(i),override:h.overrideIdentifier?t.getOverrideValue(i,h.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(i){const h=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:h?h.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,h){this._folderConfigurations.set(i,h),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,h){const r=[];if(!h){const{added:n,updated:s,removed:t}=A(this._defaultConfiguration,i);h=[...n,...s,...t]}for(const n of h)for(const s of(0,S.overrideIdentifiersFromKey)(n)){const t=this._defaultConfiguration.getKeysForOverrideIdentifier(s),c=i.getKeysForOverrideIdentifier(s),_=[...c.filter(p=>t.indexOf(p)===-1),...t.filter(p=>c.indexOf(p)===-1),...t.filter(p=>!P.equals(this._defaultConfiguration.override(s).getValue(p),i.override(s).getValue(p)))];r.push([s,_])}return this.updateDefaultConfiguration(i),{keys:h,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:h,updated:r,removed:n}=A(this._policyConfiguration,i),s=[...h,...r,...n];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:h,updated:r,removed:n,overrides:s}=A(this.applicationConfiguration,i),t=[...h,...r,...n];return t.length&&this.updateApplicationConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:h,updated:r,removed:n,overrides:s}=A(this.localUserConfiguration,i),t=[...h,...r,...n];return t.length&&this.updateLocalUserConfiguration(i),{keys:t,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:h,updated:r,removed:n,overrides:s}=A(this.remoteUserConfiguration,i),t=[...h,...r,...n];return t.length&&this.updateRemoteUserConfiguration(i),{keys:t,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:h,updated:r,removed:n,overrides:s}=A(this.workspaceConfiguration,i),t=[...h,...r,...n];return t.length&&this.updateWorkspaceConfiguration(i),{keys:t,overrides:s}}compareAndUpdateFolderConfiguration(i,h){const r=this.folderConfigurations.get(i),{added:n,updated:s,removed:t,overrides:c}=A(r,h),_=[...n,...s,...t];return(_.length||!r)&&this.updateFolderConfiguration(i,h),{keys:_,overrides:c}}compareAndDeleteFolderConfiguration(i){const h=this.folderConfigurations.get(i);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:n,removed:s,overrides:t}=A(h,void 0);return{keys:[...r,...n,...s],overrides:t}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,h,r){let n=this.getConsolidatedConfigurationModelForResource(h,r);return h.overrideIdentifier&&(n=n.override(h.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},h){let r=this.getWorkspaceConsolidatedConfiguration();if(h&&i){const n=h.getFolder(i);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const s=this._memoryConfigurationByResource.get(i);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let h=this._foldersConsolidatedConfigurations.get(i);if(!h){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(h=r.merge(n),this._freeze&&(h=h.freeze()),this._foldersConsolidatedConfigurations.set(i,h)):h=r}return h}getFolderConfigurationModelForResource(i,h){if(h&&i){const r=h.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,h)=>{const{contents:r,overrides:n,keys:s}=this._folderConfigurations.get(h);return i.push([h,{contents:r,overrides:n,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(h=>i.add(h)),this.userConfiguration.freeze().keys.forEach(h=>i.add(h)),this._workspaceConfiguration.freeze().keys.forEach(h=>i.add(h)),this._folderConfigurations.forEach(h=>h.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(h=>i.add(h)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(h=>i.add(h)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(h=>i.add(h)),this._folderConfigurations.forEach(h=>h.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>h.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>h.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(n=>h.add(n))),[...h.values()]}static parse(i){const h=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),t=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((_,p)=>(_.set(T.URI.revive(p[0]),this.parseConfigurationModel(p[1])),_),new y.ResourceMap);return new u(h,r,n,s,new I,t,c,new I,new y.ResourceMap,!1)}static parseConfigurationModel(i){return new I(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=u;function o(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const i=new Set,h=new Map;for(const n of E)n.keys.forEach(s=>i.add(s)),n.overrides.forEach(([s,t])=>{const c=(0,y.getOrSet)(h,s,new Set);t.forEach(_=>c.add(_))});const r=[];return h.forEach((n,s)=>r.push([s,[...n.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=o;class g{constructor(i,h,r,n){this.change=i,this.previous=h,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(c=>s.add(c)),i.overrides.forEach(([,c])=>c.forEach(_=>s.add(_))),this.affectedKeys=[...s.values()];const t=new I;this.affectedKeys.forEach(c=>t.setValue(c,{})),this.affectedKeysTree=t.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,h){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(h){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,h,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,h,this.currentWorkspace);return!P.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(i,h){let r=(0,R.toValuesTree)({[h]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(i=i[n],!i)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=g;function A(E,i){const{added:h,removed:r,updated:n}=l(i,E),s=[],t=E?.getAllOverrideIdentifiers()||[],c=i?.getAllOverrideIdentifiers()||[];if(i){const _=c.filter(p=>!t.includes(p));for(const p of _)s.push([p,i.getKeysForOverrideIdentifier(p)])}if(E){const _=t.filter(p=>!c.includes(p));for(const p of _)s.push([p,E.getKeysForOverrideIdentifier(p)])}if(i&&E){for(const _ of t)if(c.includes(_)){const p=l({contents:E.getOverrideValue(void 0,_)||{},keys:E.getKeysForOverrideIdentifier(_)},{contents:i.getOverrideValue(void 0,_)||{},keys:i.getKeysForOverrideIdentifier(_)});s.push([_,[...p.added,...p.removed,...p.updated]])}}return{added:h,removed:r,updated:n,overrides:s}}function l(E,i){const h=E?i?E.keys.filter(s=>i.keys.indexOf(s)===-1):[...E.keys]:[],r=i?E?i.keys.filter(s=>E.keys.indexOf(s)===-1):[...i.keys]:[],n=[];if(E&&i){for(const s of i.keys)if(E.keys.indexOf(s)!==-1){const t=(0,R.getConfigurationValue)(i.contents,s),c=(0,R.getConfigurationValue)(E.contents,s);P.equals(t,c)||n.push(s)}}return{added:h,removed:r,updated:n}}}),define(ye[84],De([1,0,11,3]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var b;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends a.ErrorNoTelemetry{constructor(P,w=b.Unknown,T){super(P),this._message=P,this._code=w,this._detail=T,this.isHandled=w===b.NotAvailable&&T===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(P){return P instanceof M&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof M&&P._code===b.NoResolverFound}static isHandled(P){return P instanceof M&&P.isHandled}}e.RemoteAuthorityResolverError=M}),define(ye[85],De([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function v(T){return T.scheme===a.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=v;function b(T){if(!T)return;const R=T.indexOf("+");return R<0?T:T.substr(0,R)}e.getRemoteName=b;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function y(T){const{host:R,port:S}=w(T);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.parseAuthorityWithPort=y;function P(T,R){let{host:S,port:m}=w(T);return typeof m>"u"&&(m=R),{host:S,port:m}}e.parseAuthorityWithOptionalPort=P;function w(T){const R=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=T.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=T.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:T,port:void 0}}}),define(ye[27],De([1,0,9,3,85]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class T{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,u){if(typeof d>"u"||d===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof d=="string"||typeof u=="string"){const o=typeof d=="string"?d:d.value,g=typeof u=="string"?u:u.value;return a.equalsIgnoreCase(o,g)}return d._lower===u._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=T;function R(f){return S(f)}e.isApplicationScopedExtension=R;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function I(f,d){if(d){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(d)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,v.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[153],De([1,0,9,79,27,21,2,11,60]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,a.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=T;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{constructor(r,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=r.id}static create(r){const n=r.manifest?r.manifest.version:r.version,s=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new S(r.identifier,n,s)}static parse(r){const n=R.exec(r);return n&&n[1]&&n[2]?new S({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof S?T(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(h){const r=m.exec(h);return r&&r[1]?[d(r[1]),r[2]]:[d(h),void 0]}e.getIdAndVersion=I;function f(h,r){return`${h}.${r}`}e.getExtensionId=f;function d(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function u(h,r){return d(f(h,r))}e.getGalleryExtensionId=u;function o(h,r){const n=[],s=t=>{for(const c of n)if(c.some(_=>T(r(_),r(t))))return c;return null};for(const t of h){const c=s(t);c?c.push(t):n.push([t])}return n}e.groupByExtension=o;function g(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function A(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function l(h,r){const n=[],s=r.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const t=s.shift();if(t&&n.every(c=>!T(c.identifier,{id:t}))){const c=h.filter(_=>T(_.identifier,{id:t}));c.length===1&&(n.push(c[0]),s.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=l;async function E(h,r){if(!M.isLinux)return!1;let n;try{n=(await h.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await h.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(t){r.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(t))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=E;async function i(h,r){const n=await E(h,r),s=(0,v.getTargetPlatform)(n?"alpine":M.platform,w.arch);return r.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(ye[154],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,M,y=5){const P=M(w=>{const T=typeof w=="string"?w:w.data;let R=this._terminalBufferMap.get(b);if(R){R.data.push(T);return}const S=setTimeout(()=>this.flushBuffer(b),y);R={data:[T],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(b),P.dispose()}},this._terminalBufferMap.set(b,R)});return P}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const M=this._terminalBufferMap.get(b);M&&(this._terminalBufferMap.delete(b),this._callback(b,M.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[155],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function v(M){return M===a.HIGH_CONTRAST_DARK||M===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=v;function b(M){return M===a.DARK||M===a.HIGH_CONTRAST_DARK}e.isDark=b}),define(ye[61],De([1,0,117,5,7,3,30,155]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var w;(function(u){function o(g){return g&&typeof g=="object"&&typeof g.id=="string"}u.isThemeColor=o})(w=e.ThemeColor||(e.ThemeColor={}));function T(u){return{id:u}}e.themeColorFromId=T;var R;(function(u){function o(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||w.isThemeColor(n.color))}u.isThemeIcon=o;const g=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function A(n){const s=g.exec(n);if(!s)return;const[,t]=s;return{id:t}}u.fromString=A;function l(n){return{id:n}}u.fromId=l;function E(n,s){let t=n.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),s&&(t=`${t}~${s}`),{id:t}}u.modify=E;function i(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}u.getModifier=i;function h(n,s){return n.id===s.id&&n.color?.id===s.color?.id}u.isEqual=h;function r(n,s){return{id:n.id,color:s?T(s):void 0}}u.asThemeIcon=r,u.asClassNameArray=a.CSSIcon.asClassNameArray,u.asClassName=a.CSSIcon.asClassName,u.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function S(u){switch(u){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new v.Emitter}onColorThemeChange(o){return this.themingParticipants.push(o),this.onThemingParticipantAddedEmitter.fire(o),(0,b.toDisposable)(()=>{const g=this.themingParticipants.indexOf(o);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const I=new m;y.Registry.add(e.Extensions.ThemingContribution,I);function f(u){return I.onColorThemeChange(u)}e.registerThemingParticipant=f;class d extends b.Disposable{constructor(o){super(),this.themeService=o,this.theme=o.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(o){this.theme=o,this.updateStyles()}updateStyles(){}getColor(o,g){let A=this.theme.getColor(o);return A&&g&&(A=g(A,this.theme)),A?A.toString():null}}e.Themable=d}),define(ye[156],De([1,0,5,21,3,15]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var y;(function(d){d.Http="http",d.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=S;function m(d,u){return u?u!==1&&d<1024:!v.isWindows&&d<1024}e.isPortPrivileged=m;class I{constructor(u,o,g){this.remoteAddress=u,this.localAddress=o,this._dispose=g,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=I;let f=class{constructor(u){this.logService=u,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],o=Array.from(this._tunnels.values());for(const g of o){const A=Array.from(g.values());for(const l of A){const E=await l.value;E&&u.push(E)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:o}of u.values())await o.then(g=>g?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,o,g,A,l=!1,E,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${g} on local port ${A}.`),!u)return;if(o||(o="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.retainOrCreateTunnel(u,o,g,A,l,E,i);return h?h.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(o,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(r);return(r.tunnelRemoteHost!==o||r.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const o=this._tunnels.get(u.tunnelRemoteHost);if(o){const g=o.get(u.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,g))}}}}async tryDisposeTunnel(u,o,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${o}.`);const A=g.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(o),A}}async closeTunnel(u,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${o} `);const g=this._tunnels.get(u);if(g&&g.has(o)){const A=g.get(o);A.refcount=0,await this.tryDisposeTunnel(u,o,A)}}addTunnelToMap(u,o,g){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(o,{refcount:1,value:g})}async removeEmptyTunnelFromMap(u,o){const g=this._tunnels.get(u);g&&(await g.get(o)||g.delete(o),g.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,o){const g=[u];R(u)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):S(u)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const A=g.map(l=>this._tunnels.get(l));for(const l of A){const E=l?.get(o);if(E)return E}}canTunnel(u){return!!T(u)}createWithProvider(u,o,g,A,l,E,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${g} on local port ${A}.`);const h=g;this._factoryInProgress.add(h);const n={elevationRequired:l?m(A===void 0?g:A):!1},s={remoteAddress:{host:o,port:g},localAddressPort:A,privacy:E,public:E?E!==P.Private:void 0,protocol:i},t=u.forwardPort(s,n);return t?(this.addTunnelToMap(o,g,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(h)})):this._factoryInProgress.delete(h),t}};f=ze([$e(0,M.ILogService)],f),e.AbstractTunnelService=f}),define(ye[157],De([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function v(w){return w.scheme!==a.Schemas.file&&w.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=v;function b(w){if(w.folders.length)return w.folders.every(T=>v(T.uri))?w.folders[0].uri:void 0;if(w.configuration&&v(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=b;function M(w){return b(w)?.scheme}e.getVirtualWorkspaceScheme=M;function y(w){return b(w)?.authority}e.getVirtualWorkspaceAuthority=y;function P(w){return b(w)!==void 0}e.isVirtualWorkspace=P}),define(ye[45],De([1,0,129,19,25,22,2,3,12]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function T(r){const n=r;return typeof n?.id=="string"&&y.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=T;function R(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=R;function S(r){const n=r;return typeof n?.id=="string"&&y.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function m(r){const n=r;if(n?.uri)return{id:n.id,uri:y.URI.revive(n.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:y.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=m;var I;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function d(r){const n=r;return!!(n&&typeof n=="object"&&y.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=d;class u{constructor(n,s,t,c,_){this._id=n,this._transient=t,this._configuration=c,this._ignorePathCasing=_,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class o{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=o;function g(r){return new o({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const A=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(r,n){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function E(r){let n;return y.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=E;function i(r,n){return!l(r,n)&&!E(r)}e.isSavedWorkspace=i;function h(r){return(typeof r=="string"?(0,v.extname)(r):(0,M.extname)(r))===A}e.hasWorkspaceFileExtension=h}),define(ye[62],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const M=this._idPool++;return this._data.set(M,b),this.logDebugInfo(),M}get(b,M){return this._data.has(b)?this._data.get(b)[M]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(ye[35],De([1,0,12,22,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new v.ExtUri(P=>{const w=this._providerInfo.get(P.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(P,w){w===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,w)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[158],De([1,0,14]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class v{constructor(y,P,w){this._deferredPromises=new Map,this._id=y,this._shared=P,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of T.values())R.complete()}catch(R){for(const S of T.values())S.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,P){let w=this._value[y];return typeof w>"u"&&(w=P),w}update(y,P){this._value[y]=P;const w=this._deferredPromises.get(y);if(w!==void 0)return w.p;const T=new a.DeferredPromise;return this._deferredPromises.set(y,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=v;class b extends v{constructor(y,P){super(y.identifier.value,!0,P),this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=b}),define(ye[159],De([1,0,5,2]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,P,w,T){const S=this._notebooksAndEditors.getNotebookDocument(v.URI.revive(y)).acceptModelChanged(P.value,w,T);this._onDidChangeNotebookDocument.fire(S)}$acceptDirtyStateChanged(y,P){this._notebooksAndEditors.getNotebookDocument(v.URI.revive(y)).acceptDirty(P)}$acceptModelSaved(y){const P=this._notebooksAndEditors.getNotebookDocument(v.URI.revive(y));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(ye[13],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class v{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=v});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[160],De([1,0,27,5]),function(ie,e,a,v){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(P,w){b.set(this,void 0),this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(P.identifier),Ye(this,b,w,"f"),Oe(this,b,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Oe(this,b,"f").get(this._id,P)}store(P,w){return Oe(this,b,"f").store(this._id,P,w)}delete(P){return Oe(this,b,"f").delete(this._id,P)}}e.ExtensionSecrets=M,b=new WeakMap}),define(ye[86],De([1,0,3,5]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new v.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new v.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(y,P){this._level=y,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[63],De([1,0,3,156,5,13]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(w){function T(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:S.protocol}}w.fromApiTunnel=T;function R(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==v.TunnelPrivacyId.ConstantPrivate&&S.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}w.fromServiceTunnel=R})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,R){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,R){return{dispose:()=>{}}}async $providePortAttributes(T,R,S,m,I){return[]}async $forwardPort(T,R){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=ze([$e(0,M.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[6],De([1,0,16,11,75,25,74,9,10,2,42,39,84]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m){"use strict";var I,f,d,u,o,g,A,l,E,i,h,r,n,s,t,c,_,p,k,U,V,x,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L($){function N(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(N,$),Object.setPrototypeOf(N.prototype,$.prototype),N}let B=g=class{constructor(N){I.set(this,void 0),Ye(this,I,N,"f")}static from(...N){let J=N;return new g(function(){if(J){for(const _e of J)_e&&typeof _e.dispose=="function"&&_e.dispose();J=void 0}})}dispose(){typeof Oe(this,I,"f")=="function"&&(Oe(this,I,"f").call(this),Ye(this,I,void 0,"f"))}};I=new WeakMap,B=g=ze([L],B),e.Disposable=B;let F=A=class{constructor(N,J){if(N<0)throw(0,v.illegalArgument)("line must be non-negative");if(J<0)throw(0,v.illegalArgument)("character must be non-negative");this._line=N,this._character=J}static Min(...N){if(N.length===0)throw new TypeError;let J=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isBefore(J)&&(J=Ke)}return J}static Max(...N){if(N.length===0)throw new TypeError;let J=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isAfter(J)&&(J=Ke)}return J}static isPosition(N){if(!N)return!1;if(N instanceof A)return!0;const{line:J,character:_e}=N;return typeof J=="number"&&typeof _e=="number"}static of(N){if(N instanceof A)return N;if(this.isPosition(N))return new A(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,J=0){if(N===null||J===null)throw(0,v.illegalArgument)();let _e;return typeof N>"u"?_e=0:typeof N=="number"?_e=N:(_e=typeof N.lineDelta=="number"?N.lineDelta:0,J=typeof N.characterDelta=="number"?N.characterDelta:0),_e===0&&J===0?this:new A(this.line+_e,this.character+J)}with(N,J=this.character){if(N===null||J===null)throw(0,v.illegalArgument)();let _e;return typeof N>"u"?_e=this.line:typeof N=="number"?_e=N:(_e=typeof N.line=="number"?N.line:this.line,J=typeof N.character=="number"?N.character:this.character),_e===this.line&&J===this.character?this:new A(_e,J)}toJSON(){return{line:this.line,character:this.character}}};F=A=ze([L],F),e.Position=F;let K=l=class{constructor(N,J,_e,Ke){let et,at;if(typeof N=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(N,J),at=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(J)&&(et=F.of(N),at=F.of(J)),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(N){return N instanceof l?!0:N?F.isPosition(N.start)&&F.isPosition(N.end):!1}static of(N){if(N instanceof l)return N;if(this.isRange(N))return new l(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return l.isRange(N)?this.contains(N.start)&&this.contains(N.end):F.isPosition(N)?!(F.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const J=F.Max(N.start,this._start),_e=F.Min(N.end,this._end);if(!J.isAfter(_e))return new l(J,_e)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const J=F.Min(N.start,this._start),_e=F.Max(N.end,this.end);return new l(J,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,J=this.end){if(N===null||J===null)throw(0,v.illegalArgument)();let _e;return N?F.isPosition(N)?_e=N:(_e=N.start||this.start,J=N.end||this.end):_e=this.start,_e.isEqual(this._start)&&J.isEqual(this.end)?this:new l(_e,J)}toJSON(){return[this.start,this.end]}};K=l=ze([L],K),e.Range=K;let H=E=class extends K{constructor(N,J,_e,Ke){let et,at;if(typeof N=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(N,J),at=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(J)&&(et=F.of(N),at=F.of(J)),!et||!at)throw new Error("Invalid arguments");super(et,at),this._anchor=et,this._active=at}static isSelection(N){return N instanceof E?!0:N?K.isRange(N)&&F.isPosition(N.anchor)&&F.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=E=ze([L],H),e.Selection=H;class O{constructor(N,J,_e){if(typeof N!="string"||N.length===0)throw(0,v.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,v.illegalArgument)("port");if(typeof _e<"u"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,v.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(J),this.connectionToken=_e}}e.ResolvedAuthority=O;class ee extends Error{constructor(N,J=m.RemoteAuthorityResolverErrorCode.Unknown,_e){super(N),this._message=N,this._code=J,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable(N,J){return new ee(N,m.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(N){return new ee(N,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var ce;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var oe;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(oe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=i=class{constructor(N,J){this._range=N,this._newText=J}static isTextEdit(N){return N instanceof i?!0:N?K.isRange(N)&&typeof N.newText=="string":!1}static replace(N,J){return new i(N,J)}static insert(N,J){return i.replace(new K(N,N),J)}static delete(N){return i.replace(N,"")}static setEndOfLine(N){const J=new i(new K(new F(0,0),new F(0,0)),"");return J.newEol=N,J}get range(){return this._range}set range(N){if(N&&!K.isRange(N))throw(0,v.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,v.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,v.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=i=ze([L],le),e.TextEdit=le;let te=h=class{constructor(N,J){this.range=N,this.newCells=J}static isNotebookCellEdit(N){return N instanceof h?!0:N?Vt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,J){return new h(N,J)}static insertCells(N,J){return new h(new Vt(N,N),J)}static deleteCells(N){return new h(N,[])}static updateCellMetadata(N,J){const _e=new h(new Vt(N,N),[]);return _e.newCellMetadata=J,_e}static updateNotebookMetadata(N){const J=new h(new Vt(0,0),[]);return J.newNotebookMetadata=N,J}};te=h=ze([L],te),e.NotebookEdit=te;var Ee;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,J,_e,Ke){this._edits.push({_type:1,from:N,to:J,options:_e,metadata:Ke})}createFile(N,J,_e){this._edits.push({_type:1,from:void 0,to:N,options:J,metadata:_e})}deleteFile(N,J,_e){this._edits.push({_type:1,from:N,to:void 0,options:J,metadata:_e})}replaceNotebookMetadata(N,J,_e){this._edits.push({_type:3,metadata:_e,uri:N,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(N,J,_e,Ke){const et=J.start,at=J.end;(et!==at||_e.length>0)&&this._edits.push({_type:5,uri:N,index:et,count:at-et,cells:_e,metadata:Ke})}replaceNotebookCellMetadata(N,J,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:J,metadata:_e}})}replace(N,J,_e,Ke){typeof _e=="string"?this._edits.push({_type:2,uri:N,edit:new le(J,_e),metadata:Ke}):this._edits.push({_type:6,uri:N,range:J,edit:_e,metadata:Ke})}insert(N,J,_e,Ke){this.replace(N,new K(J,J),_e,Ke)}delete(N,J,_e){this.replace(N,J,"",_e)}has(N){return this._edits.some(J=>J._type===2&&J.uri.toString()===N.toString())}set(N,J){if(J)for(const _e of J)_e&&(te.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(N,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(N,_e.newNotebookMetadata):this.replaceNotebookCells(N,_e.range,_e.newCells):this._edits.push({_type:2,uri:N,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(N){const J=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===N.toString()&&J.push(_e.edit);return J}entries(){const N=new M.ResourceMap;for(const J of this._edits)if(J._type===2){let _e=N.get(J.uri);_e||(_e=[J.uri,[]],N.set(J.uri,_e)),_e[1].push(J.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=ze([L],be),e.WorkspaceEdit=be;let ne=r=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof r?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=r._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,J=this._tabstop++){if(typeof N=="function"){const _e=new r;_e._tabstop=this._tabstop,N(_e),this._tabstop=_e._tabstop,N=_e.value}else N=r._escape(N);return this.value+="${",this.value+=J,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,J=this._tabstop++){const _e=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(N,J){if(typeof J=="function"){const _e=new r;_e._tabstop=this._tabstop,J(_e),this._tabstop=_e._tabstop,J=_e.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,J&&(this.value+=":",this.value+=J),this.value+="}",this}};ne=r=ze([L],ne),e.SnippetString=ne;var ve;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var Pe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Pe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=n=class{constructor(N,J){if(this.uri=N,J)if(K.isRange(J))this.range=K.of(J);else if(F.isPosition(J))this.range=new K(J,J);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof n?!0:N?K.isRange(N.range)&&T.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=n=ze([L],Fe),e.Location=Fe;let xe=class{constructor(N,J){this.location=N,this.message=J}static is(N){return N?typeof N.message=="string"&&N.location&&K.isRange(N.location.range)&&T.URI.isUri(N.location.uri):!1}static isEqual(N,J){return N===J?!0:!N||!J?!1:N.message===J.message&&N.location.range.isEqual(J.location.range)&&N.location.uri.toString()===J.location.uri.toString()}};xe=ze([L],xe),e.DiagnosticRelatedInformation=xe;let Qe=class{constructor(N,J,_e=Pe.Error){if(!K.isRange(N))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=N,this.message=J,this.severity=_e}toJSON(){return{severity:Pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,J){return N===J?!0:!N||!J?!1:N.message===J.message&&N.severity===J.severity&&N.code===J.code&&N.severity===J.severity&&N.source===J.source&&N.range.isEqual(J.range)&&(0,a.equals)(N.tags,J.tags)&&(0,a.equals)(N.relatedInformation,J.relatedInformation,xe.isEqual)}};Qe=ze([L],Qe),e.Diagnostic=Qe;let Ie=class{constructor(N,J){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=J}};Ie=ze([L],Ie),e.Hover=Ie;var Se;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(N,J=Se.Text){this.range=N,this.kind=J}toJSON(){return{range:this.range,kind:Se[this.kind]}}};Te=ze([L],Te),e.DocumentHighlight=Te;var ae;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(ae=e.SymbolKind||(e.SymbolKind={}));var ue;(function($){$[$.Deprecated=1]="Deprecated"})(ue=e.SymbolTag||(e.SymbolTag={}));let X=s=class{constructor(N,J,_e,Ke,et){this.name=N,this.kind=J,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof Fe?this.location=Ke:_e instanceof K&&(this.location=new Fe(Ke,_e)),s.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ae[this.kind],location:this.location,containerName:this.containerName}}};X=s=ze([L],X),e.SymbolInformation=X;let Y=t=class{constructor(N,J,_e,Ke,et){this.name=N,this.detail=J,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],t.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(t.validate)}};Y=t=ze([L],Y),e.DocumentSymbol=Y;var C;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(C=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let z=class{constructor(N,J){this.title=N,this.kind=J}};z=ze([L],z),e.CodeAction=z;let W=c=class{constructor(N){this.value=N}append(N){return new c(this.value?this.value+c.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+c.sep)}};W.sep=".",W=c=ze([L],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let j=class{constructor(N,J){if(this.range=N,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=ze([L],j),e.SelectionRange=j;class se{constructor(N,J,_e,Ke,et,at){this.kind=N,this.name=J,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=se;class de{constructor(N,J){this.fromRanges=J,this.from=N}}e.CallHierarchyIncomingCall=de;class Z{constructor(N,J){this.fromRanges=J,this.to=N}}e.CallHierarchyOutgoingCall=Z;var pe;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(pe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(N,J){this.range=N,this.command=J}get isResolved(){return!!this.command}};ge=ze([L],ge),e.CodeLens=ge;let Ne=_=class{constructor(N,J=!1){f.set(this,void 0),Ye(this,f,new b.MarkdownString(N,{supportThemeIcons:J}),"f")}static isMarkdownString(N){return N instanceof _?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Oe(this,f,"f").value}set value(N){Oe(this,f,"f").value=N}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(N){Oe(this,f,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,f,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(N){Oe(this,f,"f").supportHtml=N}get baseUri(){return Oe(this,f,"f").baseUri}set baseUri(N){Oe(this,f,"f").baseUri=N}appendText(N){return Oe(this,f,"f").appendText(N),this}appendMarkdown(N){return Oe(this,f,"f").appendMarkdown(N),this}appendCodeblock(N,J){return Oe(this,f,"f").appendCodeblock(J??"",N),this}};f=new WeakMap,Ne=_=ze([L],Ne),e.MarkdownString=Ne;let Be=class{constructor(N,J){this.label=N,this.documentation=J}};Be=ze([L],Be),e.ParameterInformation=Be;let Je=class{constructor(N,J){this.label=N,this.documentation=J,this.parameters=[]}};Je=ze([L],Je),e.SignatureInformation=Je;let Ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ge=ze([L],Ge),e.SignatureHelp=Ge;var ke;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var rt;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(rt=e.InlayHintKind||(e.InlayHintKind={}));let G=class{constructor(N){this.value=N}};G=ze([L],G),e.InlayHintLabelPart=G;let Q=class{constructor(N,J,_e){this.position=N,this.label=J,this.kind=_e}};Q=ze([L],Q),e.InlayHint=Q;var fe;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function($){$[$.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(N,J){this.label=N,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=ze([L],Ze),e.CompletionItem=Ze;let qe=class{constructor(N=[],J=!1){this.items=N,this.isIncomplete=J}};qe=ze([L],qe),e.CompletionList=qe;let We=class{constructor(N,J,_e){this.insertText=N,this.range=J,this.command=_e}};We=ze([L],We),e.InlineSuggestion=We;let nt=class{constructor(N){this.commands=void 0,this.items=N}};nt=ze([L],nt),e.InlineSuggestionList=nt;let ot=class{constructor(N,J,_e){this.insertText=N,this.range=J,this.command=_e}};ot=ze([L],ot),e.InlineSuggestionNew=ot;let ht=class{constructor(N,J){this.items=N,this.commands=J}};ht=ze([L],ht),e.InlineSuggestionsNew=ht;var kt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var it;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ut;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Rt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(Rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var $t;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})($t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var yt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(yt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Dt;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Dt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function N(J){switch(J){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=N}(yt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(N,J){if(J&&!T.URI.isUri(J))throw(0,v.illegalArgument)("target");if(!K.isRange(N)||N.isEmpty)throw(0,v.illegalArgument)("range");this.range=N,this.target=J}};Mt=ze([L],Mt),e.DocumentLink=Mt;let Ot=class{constructor(N,J,_e,Ke){this.red=N,this.green=J,this.blue=_e,this.alpha=Ke}};Ot=ze([L],Ot),e.Color=Ot;let Ve=class{constructor(N,J){if(J&&!(J instanceof Ot))throw(0,v.illegalArgument)("color");if(!K.isRange(N)||N.isEmpty)throw(0,v.illegalArgument)("range");this.range=N,this.color=J}};Ve=ze([L],Ve),e.ColorInformation=Ve;let Ft=class{constructor(N){if(!N||typeof N!="string")throw(0,v.illegalArgument)("label");this.label=N}};Ft=ze([L],Ft),e.ColorPresentation=Ft;var Pt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Pt=e.ColorFormat||(e.ColorFormat={}));var Ut;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Ut=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(vt=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(N,J,_e){if(this.startIndex=N,this.length=J,this.tooltip=_e,typeof N!="number"||N<0)throw(0,v.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,v.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,v.illegalArgument)("tooltip")}}e.TerminalLink=we;var Ce;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Ce=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(N){if(this.options=N,typeof N!="object")throw(0,v.illegalArgument)("options")}}e.TerminalProfile=me;var q;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(q=e.TaskRevealKind||(e.TaskRevealKind={}));var Ae;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(Ae=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=p=class{constructor(N,J){if(this.label=J,typeof N!="string"||typeof J!="string")throw(0,v.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Le.Clean=new p("clean","Clean"),Le.Build=new p("build","Build"),Le.Rebuild=new p("rebuild","Rebuild"),Le.Test=new p("test","Test"),Le=p=ze([L],Le),e.TaskGroup=Le;function tt($){let N="";for(let J=0;J<$.length;J++)N+=$[J].replace(/,/g,",,")+",";return N}let Xe=class{constructor(N,J,_e){if(typeof N!="string")throw(0,v.illegalArgument)("process");this._args=[],this._process=N,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=_e):this._options=J)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,v.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const J of this._args)N.push(J);return tt(N)}};Xe=ze([L],Xe),e.ProcessExecution=Xe;let je=class{constructor(N,J,_e){if(this._args=[],Array.isArray(J)){if(!N)throw(0,v.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,v.illegalArgument)("command");this._command=N,this._args=J,this._options=_e}else{if(typeof N!="string")throw(0,v.illegalArgument)("commandLine");this._commandLine=N,this._options=J}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,v.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,v.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const J of this._args)N.push(typeof J=="string"?J:J.value);return tt(N)}};je=ze([L],je),e.ShellExecution=je;var ct;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class St{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=St;let pt=k=class{constructor(N,J,_e,Ke,et,at){this.__deprecated=!1,this._definition=this.definition=N;let dt;typeof J=="string"?(this._name=this.name=J,this._source=this.source=_e,this.execution=Ke,dt=et,this.__deprecated=!0):J===gt.Global||J===gt.Workspace?(this.target=J,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,dt=at):(this.target=J,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:k.ProcessType,id:this._execution.computeId()}:this._execution instanceof je?this._definition={type:k.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:k.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:k.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,v.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,v.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const J=this._definition.type;(k.EmptyType===J||k.ProcessType===J||k.ShellType===J||k.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,v.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=k=ze([L],pt),e.Task=pt;var _t;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let Tt=U=class{constructor(N,J=mt.None){this.collapsibleState=J,T.URI.isUri(N)?this.resourceUri=N:this.label=N}static isTreeItem(N){if(N instanceof U)return!0;const J=N;if(J.label!==void 0&&!(0,w.isString)(J.label)&&!J.label?.label)return console.log("INVALID tree item, invalid label",J.label),!1;if(J.id!==void 0&&!(0,w.isString)(J.id))return console.log("INVALID tree item, invalid id",J.id),!1;if(J.iconPath!==void 0&&!(0,w.isString)(J.iconPath)&&!T.URI.isUri(J.iconPath)&&(!J.iconPath||!(0,w.isString)(J.iconPath.id))){const _e=J.iconPath;if(!_e||!(0,w.isString)(_e.light)&&!T.URI.isUri(_e.light)&&!(0,w.isString)(_e.dark)&&!T.URI.isUri(_e.dark))return console.log("INVALID tree item, invalid iconPath",J.iconPath),!1}return J.description!==void 0&&!(0,w.isString)(J.description)&&typeof J.description!="boolean"?(console.log("INVALID tree item, invalid description",J.description),!1):J.resourceUri!==void 0&&!T.URI.isUri(J.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",J.resourceUri),!1):J.tooltip!==void 0&&!(0,w.isString)(J.tooltip)&&!(J.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",J.tooltip),!1):J.command!==void 0&&!J.command.command?(console.log("INVALID tree item, invalid command",J.command),!1):J.collapsibleState!==void 0&&J.collapsibleState<mt.None&&J.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",J.collapsibleState),!1):J.contextValue!==void 0&&!(0,w.isString)(J.contextValue)?(console.log("INVALID tree item, invalid contextValue",J.contextValue),!1):J.accessibilityInformation!==void 0&&!J.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",J.accessibilityInformation),!1):!0}};Tt=U=ze([L],Tt),e.TreeItem=Tt;var mt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Qt=class{constructor(N){this.value=N}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Qt=ze([L],Qt),e.DataTransferItem=Qt;let Yt=class{constructor(N){d.set(this,new Map);for(const[J,_e]of N??[]){const Ke=Oe(this,d,"f").get(J);Ke?Ke.push(_e):Oe(this,d,"f").set(J,[_e])}}get(N){return Oe(this,d,"f").get(N)?.[0]}set(N,J){Oe(this,d,"f").set(N,[J])}forEach(N,J){for(const[_e,Ke]of Oe(this,d,"f"))for(const et of Ke)N.call(J,et,_e,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[N,J]of Oe(this,d,"f"))for(const _e of J)yield[N,_e]}};Yt=ze([L],Yt),e.DataTransfer=Yt;let bt=class{constructor(N){this.insertText=N}};bt=ze([L],bt),e.DocumentDropEdit=bt;let Wt=class{constructor(N){this.insertText=N}};Wt=ze([L],Wt),e.DocumentPasteEdit=Wt;let Bt=class{constructor(N,J){this.id=N,this.color=J}};Bt=ze([L],Bt),e.ThemeIcon=Bt,Bt.File=new Bt("file"),Bt.Folder=new Bt("folder");let si=class{constructor(N){this.id=N}};si=ze([L],si),e.ThemeColor=si;var Ti;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Ti=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(N,J){if(typeof N!="string"&&(!N||!T.URI.isUri(N)&&!T.URI.isUri(N.uri)))throw(0,v.illegalArgument)("base");if(typeof J!="string")throw(0,v.illegalArgument)("pattern");typeof N=="string"?this.baseUri=T.URI.file(N):T.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=J}get base(){return this._base}set base(N){this._base=N,this._baseUri=T.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=ze([L],Ct),e.RelativePattern=Ct;let qt=class{constructor(N,J,_e,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof J=="string"&&(this.condition=J),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};qt=ze([L],qt),e.Breakpoint=qt;let mi=class extends qt{constructor(N,J,_e,Ke,et){if(super(J,_e,Ke,et),N===null)throw(0,v.illegalArgument)("location");this.location=N}};mi=ze([L],mi),e.SourceBreakpoint=mi;let Jt=class extends qt{constructor(N,J,_e,Ke,et){super(J,_e,Ke,et),this.functionName=N}};Jt=ze([L],Jt),e.FunctionBreakpoint=Jt;let Zt=class extends qt{constructor(N,J,_e,Ke,et,at,dt){if(super(Ke,et,at,dt),!J)throw(0,v.illegalArgument)("dataId");this.label=N,this.dataId=J,this.canPersist=_e}};Zt=ze([L],Zt),e.DataBreakpoint=Zt;let lt=class{constructor(N,J,_e){this.command=N,this.args=J||[],this.options=_e}};lt=ze([L],lt),e.DebugAdapterExecutable=lt;let gi=class{constructor(N,J){this.port=N,this.host=J}};gi=ze([L],gi),e.DebugAdapterServer=gi;let zt=class{constructor(N){this.path=N}};zt=ze([L],zt),e.DebugAdapterNamedPipeServer=zt;let Kt=class{constructor(N){this.implementation=N}};Kt=ze([L],Kt),e.DebugAdapterInlineImplementation=Kt;let oi=class{constructor(N,J){this.range=N,this.expression=J}};oi=ze([L],oi),e.EvaluatableExpression=oi;var Pi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Pi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let pi=class{constructor(N,J){this.range=N,this.text=J}};pi=ze([L],pi),e.InlineValueText=pi;let ai=class{constructor(N,J,_e=!0){this.range=N,this.variableName=J,this.caseSensitiveLookup=_e}};ai=ze([L],ai),e.InlineValueVariableLookup=ai;let ei=class{constructor(N,J){this.range=N,this.expression=J}};ei=ze([L],ei),e.InlineValueEvaluatableExpression=ei;let vi=class{constructor(N,J){this.frameId=N,this.stoppedLocation=J}};vi=ze([L],vi),e.InlineValueContext=vi;var Ei;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ei=e.FileChangeType||(e.FileChangeType={}));let ti=V=class extends Error{constructor(N,J=S.FileSystemProviderErrorCode.Unknown,_e){super(T.URI.isUri(N)?N.toString(!0):N),this.code=_e?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(N){return new V(N,S.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(N){return new V(N,S.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(N){return new V(N,S.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(N){return new V(N,S.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(N){return new V(N,S.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(N){return new V(N,S.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}};ti=V=ze([L],ti),e.FileSystemError=ti;let bi=class{constructor(N,J,_e){this.start=N,this.end=J,this.kind=_e}};bi=ze([L],bi),e.FoldingRange=bi;var Ai;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Ai=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ii;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(ii=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ri;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Ri=e.CommentMode||(e.CommentMode={}));var Oi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Oi=e.CommentThreadState||(e.CommentThreadState={}));class Fi{constructor(N,J=[]){this.tokenTypes=N,this.tokenModifiers=J}}e.SemanticTokensLegend=Fi;function Ni($){return typeof $>"u"||(0,w.isStringArray)($)}class ni{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let J=0,_e=N.tokenTypes.length;J<_e;J++)this._tokenTypeStrToInt.set(N.tokenTypes[J],J);for(let J=0,_e=N.tokenModifiers.length;J<_e;J++)this._tokenModifierStrToInt.set(N.tokenModifiers[J],J)}}push(N,J,_e,Ke,et){if(typeof N=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(N,J,_e,Ke,et);if(K.isRange(N)&&typeof J=="string"&&Ni(_e))return this._push(N,J,_e);throw(0,v.illegalArgument)()}_push(N,J,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,et=N.start.character,at=N.end.character-N.start.character,dt=this._tokenTypeStrToInt.get(J);let At=0;if(_e)for(const Lt of _e){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Lt);At|=1<<xt>>>0}this._pushEncoded(Ke,et,at,dt,At)}_pushEncoded(N,J,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Lt=0,xt=0;for(let jt=0;jt<At;jt++){let Gt=this._data[5*jt],_i=this._data[5*jt+1];Gt===0?(Gt=Lt,_i+=xt):Gt+=Lt,this._data[5*jt]=Gt,this._data[5*jt+1]=_i,Lt=Gt,xt=_i}}let at=N,dt=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=N,this._prevChar=J}static _sortAndDeltaEncode(N){const J=[],_e=N.length/5|0;for(let dt=0;dt<_e;dt++)J[dt]=dt;J.sort((dt,At)=>{const Lt=N[5*dt],xt=N[5*At];if(Lt===xt){const jt=N[5*dt+1],Gt=N[5*At+1];return jt-Gt}return Lt-xt});const Ke=new Uint32Array(N.length);let et=0,at=0;for(let dt=0;dt<_e;dt++){const At=5*J[dt],Lt=N[At+0],xt=N[At+1],jt=N[At+2],Gt=N[At+3],_i=N[At+4],Qi=Lt-et,bn=Qi===0?xt-at:xt,Si=5*dt;Ke[Si+0]=Qi,Ke[Si+1]=bn,Ke[Si+2]=jt,Ke[Si+3]=Gt,Ke[Si+4]=_i,et=Lt,at=xt}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new li(new Uint32Array(this._data),N):new li(ni._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ni;class li{constructor(N,J){this.resultId=J,this.data=N}}e.SemanticTokens=li;class Di{constructor(N,J,_e){this.start=N,this.deleteCount=J,this.data=_e}}e.SemanticTokensEdit=Di;class Me{constructor(N,J){this.resultId=J,this.edits=N}}e.SemanticTokensEdits=Me;var Ht;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Ht=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ri=class{constructor(){}};ri.Back={iconPath:new Bt("arrow-left")},ri=ze([L],ri),e.QuickInputButtons=ri;var Et;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Mi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Mi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Li;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Li=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(N,J,_e){this.badge=N,this.tooltip=J,this.color=_e}static validate(N){if(N.badge){let J=(0,P.nextCharLength)(N.badge,0);if(J<N.badge.length&&(J+=(0,P.nextCharLength)(N.badge,J)),N.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let wi=class{constructor(N){this.kind=N}};wi=ze([L],wi),e.ColorTheme=wi;var ci;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(ci=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(N,J){if(N<0)throw(0,v.illegalArgument)("start must be positive");if(J<0)throw(0,v.illegalArgument)("end must be positive");N<=J?(this._start=N,this._end=J):(this._start=J,this._end=N)}static isNotebookRange(N){return N instanceof Vt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let J=this._start,_e=this._end;return N.start!==void 0&&(J=N.start),N.end!==void 0&&(_e=N.end),J===this._start&&_e===this._end?this:new Vt(J,_e)}}e.NotebookRange=Vt;class ui{constructor(N,J,_e,Ke,et,at,dt){this.kind=N,this.value=J,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=at,this.executionSummary=dt,ui.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(J=>ui.isNotebookCellData(J))}static isNotebookCellData(N){return!0}}e.NotebookCellData=ui;class Ui{constructor(N){this.cells=N}}e.NotebookData=Ui;class Nt{constructor(N,J){this.data=N,this.mime=J;const _e=(0,y.normalizeMimeType)(J,!0);if(!_e)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(N){return N instanceof Nt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const J={name:N.name,message:N.message,stack:N.stack};return Nt.json(J,"application/vnd.code.notebook.error")}static stdout(N){return Nt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Nt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,J="application/octet-stream"){return new Nt(N,J)}static text(N,J=y.Mimes.text){const _e=Oe(Nt,u,"f",o).encode(String(N));return new Nt(_e,J)}static json(N,J="text/x-json"){const _e=JSON.stringify(N,void 0,"	");return Nt.text(_e,J)}}e.NotebookCellOutputItem=Nt,u=Nt,o={value:new TextEncoder};class di{constructor(N,J,_e){this.items=di.ensureUniqueMimeTypes(N,!0),typeof J=="string"?(this.id=J,this.metadata=_e):(this.id=(0,R.generateUuid)(),this.metadata=J??_e)}static isNotebookCellOutput(N){return N instanceof di?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,J=!1){const _e=new Set,Ke=new Set;for(let et=0;et<N.length;et++){const at=N[et],dt=(0,y.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}Ke.add(et),J&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?N:N.filter((et,at)=>!Ke.has(at))}}e.NotebookCellOutput=di;var Bi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(Bi=e.NotebookCellKind||(e.NotebookCellKind={}));var zi;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(zi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xi;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(xi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var $i;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})($i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class re{constructor(N,J){this.text=N,this.alignment=J}}e.NotebookCellStatusBarItem=re;var he;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(he=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Re{constructor(N,J=[]){this.uri=N,this.provides=(0,a.asArray)(J)}}e.NotebookRendererScript=Re;let st=class{constructor(N,J){this.label=N,this.timestamp=J}};st=ze([L],st),e.TimelineItem=st;var wt;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(wt=e.ExtensionMode||(e.ExtensionMode={}));var It;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(It=e.ExtensionRuntime||(e.ExtensionRuntime={}));var en;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(en=e.StandardTokenType||(e.StandardTokenType={}));class tn{constructor(N,J){this.ranges=N,this.wordPattern=J}}e.LinkedEditingRanges=tn;class nn{constructor(N,J){this._port=N,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=nn;var rn;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(rn=e.TestResultState||(e.TestResultState={}));var sn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(sn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(N=void 0,J=void 0,_e=void 0){this.include=N,this.exclude=J,this.profile=_e}};Wi=ze([L],Wi),e.TestRunRequest=Wi;let Hi=x=class{constructor(N){this.message=N}static diff(N,J,_e){const Ke=new x(N);return Ke.expectedOutput=J,Ke.actualOutput=_e,Ke}};Hi=x=ze([L],Hi),e.TestMessage=Hi;let Vi=class{constructor(N){this.id=N}};Vi=ze([L],Vi),e.TestTag=Vi;let hi=class{constructor(N,J){this.covered=N,this.total=J}};hi=ze([L],hi),e.CoveredCount=hi;let ji=D=class{constructor(N,J,_e,Ke){this.uri=N,this.statementCoverage=J,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(N,J){const _e=new hi(0,0),Ke=new hi(0,0),et=new hi(0,0);for(const dt of J)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const At of dt.branches)Ke.total+=1,Ke.covered+=At.executionCount>0?1:0}else et.total+=1,et.covered+=dt.executionCount>0?1:0;const at=new D(N,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return at.detailedCoverage=J,at}};ji=D=ze([L],ji),e.FileCoverage=ji;let qi=class{constructor(N,J,_e=[]){this.executionCount=N,this.location=J,this.branches=_e}};qi=ze([L],qi),e.StatementCoverage=qi;let Ki=class{constructor(N,J){this.executionCount=N,this.location=J}};Ki=ze([L],Ki),e.BranchCoverage=Ki;let Gi=class{constructor(N,J){this.executionCount=N,this.location=J}};Gi=ze([L],Gi),e.FunctionCoverage=Gi;var on;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(on=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var an;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(an=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ln;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(ln=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class cn{constructor(N,J,_e,Ke,et,at){this.kind=N,this.name=J,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=at}}e.TypeHierarchyItem=cn;class un{constructor(N){this.uri=N}}e.TextTabInput=un;class dn{constructor(N,J){this.original=N,this.modified=J}}e.TextDiffTabInput=dn;class hn{constructor(N,J,_e,Ke){this.base=N,this.input1=J,this.input2=_e,this.result=Ke}}e.TextMergeTabInput=hn;class fn{constructor(N,J){this.uri=N,this.viewType=J}}e.CustomEditorTabInput=fn;class mn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=mn;class gn{constructor(N,J){this.uri=N,this.notebookType=J}}e.NotebookEditorTabInput=gn;class pn{constructor(N,J,_e){this.original=N,this.modified=J,this.notebookType=_e}}e.NotebookDiffEditorTabInput=pn;class vn{constructor(){}}e.TerminalEditorTabInput=vn;class En{constructor(N,J){this.uri=N,this.inputBoxUri=J}}e.InteractiveWindowInput=En}),define(ye[87],De([1,0,44,12,9,240,123,6,16]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function R(f,d){d?T.set(f,d):T.delete(f)}e.setWordDefinitionFor=R;function S(f){return T.get(f)}e.getWordDefinitionFor=S;class m extends M.MirrorTextModel{constructor(d,u,o,g,A,l,E,i){super(u,o,g,A),this._proxy=d,this._languageId=l,this._isDirty=E,this.notebook=i,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,w.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===v.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},save(){return d._save()},getText(u){return u?d._getTextInRange(u):d.getText()},get eol(){return d._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(u){return d._lineAt(u)},offsetAt(u){return d._offsetAt(u)},positionAt(u){return d._positionAt(u)},validateRange(u){return d._validateRange(u)},validatePosition(u){return d._validatePosition(u)},getWordRangeAtPosition(u,o){return d._getWordRangeAtPosition(u,o)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,a.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,a.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const u=this._validateRange(d);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const o=this._eol,g=u.start.line,A=u.end.line,l=[];l.push(this._lines[g].substring(u.start.character));for(let E=g+1;E<A;E++)l.push(this._lines[E]);return l.push(this._lines[A].substring(0,u.end.character)),l.join(o)}_lineAt(d){let u;if(d instanceof P.Position?u=d.line:typeof d=="number"&&(u=d),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new I(u,this._lines[u],u===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(d),o=this._lines[u.index].length;return new P.Position(u.index,Math.min(u.remainder,o))}_validateRange(d){if(!(d instanceof P.Range))throw new Error("Invalid argument");const u=this._validatePosition(d.start),o=this._validatePosition(d.end);return u===d.start&&o===d.end?d:new P.Range(u.line,u.character,o.line,o.character)}_validatePosition(d){if(!(d instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:u,character:o}=d,g=!1;if(u<0)u=0,o=0,g=!0;else if(u>=this._lines.length)u=this._lines.length-1,o=this._lines[u].length,g=!0;else{const A=this._lines[u].length;o<0?(o=0,g=!0):o>A&&(o=A,g=!0)}return g?new P.Position(u,o):d}_getWordRangeAtPosition(d,u){const o=this._validatePosition(d);if(!u)u=S(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const g=(0,y.getWordAtText)(o.character+1,(0,y.ensureValidWordDefinition)(u),this._lines[o.line],0);if(g)return new P.Range(o.line,g.startColumn-1,o.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class I{constructor(d,u,o){this._line=d,this._text=u,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(ye[161],De([1,0,6,13,5]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(P){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let w;switch(P){case"light":w=a.ColorThemeKind.Light;break;case"hcDark":w=a.ColorThemeKind.HighContrast;break;case"hcLight":w=a.ColorThemeKind.HighContrastLight;break;default:w=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=ze([$e(0,v.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(ye[46],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class v{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=v}),define(ye[162],De([1,0,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class v{constructor(){this.buffers=[]}add(w){let T=this.buffers.indexOf(w);return T<0&&(T=this.buffers.length,this.buffers.push(w)),T}}function b(P,w){if(w.serializeBuffersForPostMessage){const T=new v,R=(I,f)=>{if(f instanceof ArrayBuffer){const d=T.add(f);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(f)){const d=M(f);if(d){const u=T.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:d,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},S=JSON.stringify(P,R),m=T.buffers.map(I=>{const f=new Uint8Array(I);return a.VSBuffer.wrap(f)});return{message:S,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=b;function M(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,w){const T=w.map(m=>{const I=new ArrayBuffer(m.byteLength);return new Uint8Array(I).set(m.buffer),I}),R=w.length?(m,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const f=I,{index:d}=f,u=T[d];if(f.view)switch(f.view.type){case 1:return new Int8Array(u,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return I}:void 0;return{message:JSON.parse(P,R),arrayBuffers:T}}e.deserializeWebviewMessage=y}),define(ye[88],De([1,0,137,10,2,7,3,30,39,16,12]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(S=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function I(O){const ee=O;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=I;function f(O,ee,ce){for(const oe of ce.visibleEditorPanes)if(oe.group.id===ee&&O.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=f;function d(O){if(n(O))return!1;const ee=O;return b.URI.isUri(ee?.resource)}e.isResourceEditorInput=d;function u(O){if(n(O))return!1;const ee=O;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=u;function o(O){if(n(O)||u(O))return!1;const ee=O;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function g(O){if(n(O))return!1;const ee=O;return ee?ee.resource===void 0||ee.resource.scheme===R.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function A(O){if(n(O))return!1;const ee=O;return b.URI.isUri(ee?.base?.resource)&&b.URI.isUri(ee?.input1?.resource)&&b.URI.isUri(ee?.input2?.resource)&&b.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=A;var l;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var E;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(E=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.mapIdToSaveSource=new Map}registerSource(ee,ce){let oe=this.mapIdToSaveSource.get(ee);return oe||(oe={source:ee,label:ce},this.mapIdToSaveSource.set(ee,oe)),oe.source}getSourceLabel(ee){return this.mapIdToSaveSource.get(ee)?.label??ee}}e.SaveSourceRegistry=new i;var h;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends M.Disposable{}e.AbstractEditorInput=r;function n(O){return O instanceof r}e.isEditorInput=n;function s(O){const ee=O;return b.URI.isUri(ee?.preferredResource)}function t(O){const ee=O;return n(ee?.primary)&&n(ee?.secondary)}e.isSideBySideEditorInput=t;function c(O){const ee=O;return n(ee?.modified)&&n(ee?.original)}e.isDiffEditorInput=c;function _(O){return n(O?.editor)}e.isEditorInputWithOptions=_;function p(O){const ee=O;return _(O)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function k(O){const ee=O;return typeof ee?.groupId=="number"&&n(ee.editor)}e.isEditorIdentifier=k;var U;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var V;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class D{getOriginalUri(ee,ce){if(!ee)return;if(A(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,ce);if(ce?.supportSideBySide){const{primary:le,secondary:te}=this.getSideEditors(ee);if(le&&te){if(ce?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:ce.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===x.ANY)return this.getOriginalUri(le,{filterByScheme:ce.filterByScheme})??this.getOriginalUri(te,{filterByScheme:ce.filterByScheme});ee=ce.supportSideBySide===x.PRIMARY?le:te}}if(u(ee)||o(ee)||A(ee))return;const oe=s(ee)?ee.preferredResource:ee.resource;return!oe||!ce||!ce.filterByScheme?oe:this.filterUri(oe,ce.filterByScheme)}getSideEditors(ee){return t(ee)||o(ee)?{primary:ee.primary,secondary:ee.secondary}:c(ee)||u(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,ce){if(!ee)return;if(A(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,ce);if(ce?.supportSideBySide){const{primary:le,secondary:te}=this.getSideEditors(ee);if(le&&te){if(ce?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:ce.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===x.ANY)return this.getCanonicalUri(le,{filterByScheme:ce.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:ce.filterByScheme});ee=ce.supportSideBySide===x.PRIMARY?le:te}}if(u(ee)||o(ee)||A(ee))return;const oe=ee.resource;return!oe||!ce||!ce.filterByScheme?oe:this.filterUri(oe,ce.filterByScheme)}filterUri(ee,ce){if(Array.isArray(ce)){if(ce.some(oe=>ee.scheme===oe))return ee}else if(ce===ee.scheme)return ee}}e.EditorResourceAccessor=new D;var L;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ee){const ce=this.instantiationService=ee.get(y.IInstantiationService);for(const[oe,le]of this.editorSerializerConstructors)this.createEditorSerializer(oe,le,ce);this.editorSerializerConstructors.clear()}createEditorSerializer(ee,ce,oe){const le=oe.createInstance(ce);this.editorSerializerInstances.set(ee,le)}registerFileEditorFactory(ee){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ee}getFileEditorFactory(){return(0,v.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ee,ce){if(this.editorSerializerConstructors.has(ee)||this.editorSerializerInstances.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ee,ce,this.instantiationService):this.editorSerializerConstructors.set(ee,ce),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ee),this.editorSerializerInstances.delete(ee)})}getEditorSerializer(ee){return this.editorSerializerInstances.get(typeof ee=="string"?ee:ee.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new B);async function F(O,ee){if(!O||!O.length)return[];const ce=await Promise.all(O.map(async oe=>{const le=b.URI.revive(oe.fileUri);if(!le||!await ee.canHandleResource(le))return;let Ee=oe.exists,be=oe.type;if(typeof Ee!="boolean"||typeof be!="number")try{be=(await ee.stat(le)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Ee=!0}catch{Ee=!1}if(!Ee&&oe.openOnlyIfExists||be===w.FileType.Directory)return;const ne={...oe.options,pinned:!0};let ve;return Ee?ve={resource:le,options:ne}:ve={resource:le,options:ne,forceUntitled:!0},ve}));return(0,T.coalesce)(ce)}e.pathsToEditors=F;var K;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function H(O){const ee=O;if(!ee)return!1;const ce=ee;if(ce.modified)return H(ce.modified);const oe=ee;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=H}),define(ye[64],De([1,0,12,2]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(P,w){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(w&&w.authority&&w.isRemote&&P.scheme===a.Schemas.file&&(P=v.URI.from({scheme:a.Schemas.vscodeRemote,authority:w.authority,path:P.path})),v.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${M(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=b;function M(P){return P.replace(/./g,w=>{const T=w.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?w:"-"+T.toString(16).padStart(4,"0")})}function y(P){return P.replace(/-([0-9a-f]{4})/g,(w,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=y}),define(ye[163],De([1,0,5,7,64]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(P,w,T){this._proxy=P,this._editors=w,this._remoteInfo=T,this._handlePool=0,this._disposables=new v.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const R=w.getVisibleTextEditors();for(const S of this._insets.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,w,T,R,S){let m;for(const A of this._editors.getVisibleTextEditors(!0))if(A.value===P){m=A;break}if(!m)throw new Error("not a visible editor");const I=this,f=this._handlePool++,d=new a.Emitter,u=new a.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(A){return(0,b.asWebviewUri)(A,I._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(A){this._options=A,I._proxy.$setOptions(f,A)}get options(){return this._options}set html(A){this._html=A,I._proxy.$setHtml(f,A)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(A){return I._proxy.$postMessage(f,A)}},g=new class{constructor(){this.editor=P,this.line=w,this.height=T,this.webview=o,this.onDidDispose=u.event}dispose(){I._insets.has(f)&&(I._insets.delete(f),I._proxy.$disposeEditorInset(f),u.fire(),u.dispose(),d.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,w+1,T,R||{},S.identifier,S.extensionLocation),this._insets.set(f,{editor:P,inset:g,onDidReceiveMessage:d}),g}$onDidDispose(P){const w=this._insets.get(P);w&&w.inset.dispose()}$onDidReceiveMessage(P,w){this._insets.get(P)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=M}),define(ye[164],De([1,0,5,14,138]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,w,T,R){const S={command:P};if(w&&Object.keys(w).length>0&&(S.arguments=w),this.internalSend("request",S),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const I=this.pendingRequests.get(S.seq);if(I){this.pendingRequests.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:P,message:(0,b.localize)(0,null,R,P)};I(f)}},R)}return T&&this.pendingRequests.set(S.seq,T),S.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,w){return P.type!=="event"||w.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,v.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const w=P,T=this.pendingRequests.get(w.request_seq);T&&(this.pendingRequests.delete(w.request_seq),T(w));break}}}}internalSend(P,w){w.type=P,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((w,T)=>P.set(T,w)),await(0,v.timeout)(500),P.forEach((w,T)=>{w({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(ye[165],De([1,0,139,38,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new v.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new v.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new v.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new v.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new v.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new v.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new v.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new v.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new v.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new v.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new v.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new v.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new v.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new v.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new v.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new v.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new v.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new v.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new v.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new v.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new v.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new v.RawContextKey("breakpointAccessType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new v.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new v.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new v.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new v.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new v.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new v.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new v.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new v.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new v.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new v.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new v.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new v.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new v.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new v.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new v.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new v.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new v.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new v.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new v.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new v.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new v.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new v.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new v.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new v.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new v.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new v.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new v.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new v.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new v.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const M=m=>a.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var y;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(y=e.State||(e.State={}));function P(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var w;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var S;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[166],De([1,0,9,2,19,26,12]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function w(r,n,s){return r.replace(P,function(t,c){return n&&c.length>0&&c[0]!=="_"?t:s&&s.hasOwnProperty(c)?s[c]:t})}e.formatPII=w;function T(r){const n={};for(const s of Object.keys(r))s.startsWith("!")||(n[s]=r[s]);return n}e.filterExceptionsFromTelemetry=T;function R(r){return r.configuration.request==="attach"&&!S(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function S(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(n,"extensionhost")||(0,a.equalsIgnoreCase)(n,"pwa-extensionhost")?r:r.parentSession?S(r.parentSession):void 0}e.getExtensionHostDebugSession=S;function m(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=m;function I(r,n,s){let t,c=0;const _=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=_.exec(r);){const k=p.index+1,U=k+p[0].length;if(k<=n&&U>=s){t=p[0],c=k;break}}if(t){const k=/\w+/g;let U=null;for(;(U=k.exec(t))&&!(U.index+1+c+U[0].length>=s););U&&(t=t.substring(0,k.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(r){return!!(r&&r.match(f))}e.isUri=d;function u(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(d(r.path))return v.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return v.URI.file(r.path)}return r.path}function o(r){if(typeof r.path=="object"){const n=v.URI.revive(r.path);if(n)return n.scheme===y.Schemas.file?n.fsPath:n.toString()}return r.path}function g(r,n){const s=n?u:o,t=(0,M.deepClone)(r);return l(t,(c,_)=>{c&&_&&(_.path=s(_))}),t}e.convertToDAPaths=g;function A(r,n){const s=n?u:o,t=(0,M.deepClone)(r);return l(t,(c,_)=>{!c&&_&&(_.path=s(_))}),t}e.convertToVSCPaths=A;function l(r,n){switch(r.type){case"event":{const s=r;switch(s.event){case"output":n(!1,s.body.source);break;case"loadedSource":n(!1,s.body.source);break;case"breakpoint":n(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=r;switch(s.command){case"setBreakpoints":n(!0,s.arguments.source);break;case"breakpointLocations":n(!0,s.arguments.source);break;case"source":n(!0,s.arguments.source);break;case"gotoTargets":n(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(t=>n(!1,t));break;default:break}break}case"response":{const s=r;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(t=>n(!1,t.source));break;case"loadedSources":s.body.sources.forEach(t=>n(!1,t));break;case"scopes":s.body.scopes.forEach(t=>n(!1,t.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(t=>n(!1,t.source));break;case"setBreakpoints":s.body.breakpoints.forEach(t=>n(!1,t.source));break;case"disassemble":s.body?.instructions.forEach(c=>n(!1,c.location));break;default:break}break}}}function E(r){return r.filter(n=>!n.presentation?.hidden).sort((n,s)=>n.presentation?s.presentation?n.presentation.group?s.presentation.group?n.presentation.group!==s.presentation.group?n.presentation.group.localeCompare(s.presentation.group):i(n.presentation.order,s.presentation.order):-1:s.presentation.group?1:i(n.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=E;function i(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}async function h(r,n){const s=r.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(s!=="none"&&(await n.saveAll(),s==="allEditorsInActiveGroup")){const t=n.activeEditorPane;t&&t.input.resource?.scheme===y.Schemas.untitled&&await n.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(ye[89],De([1,0,23,34,167,74,12,19,21,38]),function(ie,e,a,v,b,M,y,P,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeCellLanguage=5]="ChangeCellLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var o;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(o=e.CellEditType||(e.CellEditType={}));var g;(function(t){t.scheme=y.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],_=new RegExp(`^[${c.join("")}]+`),p=7;function k(F,K){const H=K.toString(p),ee=`${H.length<c.length?c[H.length-1]:"z"}${H}s${(0,a.encodeBase64)(a.VSBuffer.fromString(F.scheme),!0,!0)}`;return F.with({scheme:t.scheme,fragment:ee})}t.generate=k;function U(F){if(F.scheme!==t.scheme)return;const K=F.fragment.indexOf("s");if(K<0)return;const H=parseInt(F.fragment.substring(0,K).replace(_,""),p),O=(0,a.decodeBase64)(F.fragment.substring(K+1)).toString();if(!isNaN(H))return{handle:H,notebook:F.with({scheme:O,fragment:null})}}t.parse=U;const V=/^(\d{8,})(\w[\w\d+.-]*)$/;function x(F,K){return F.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${F.scheme!==y.Schemas.file?F.scheme:""}`})}t.generateCellOutputUri=x;function D(F){if(F.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!K)return;const H=K[1]&&K[1]!==""?K[1]:void 0,O=K[2];return{outputId:H,notebook:F.with({scheme:O||y.Schemas.file,fragment:null})}}t.parseCellOutputUri=D;function L(F,K,H){return F.with({scheme:H,fragment:`ch${K.toString().padStart(7,"0")}${F.scheme!==y.Schemas.file?F.scheme:""}`})}t.generateCellUri=L;function B(F,K){if(F.scheme!==K)return;const H=V.exec(F.fragment);return H?{handle:Number(H[1]),notebook:F.with({scheme:F.fragment.substring(H[0].length)||y.Schemas.file,fragment:null})}:void 0}t.parseCellUri=B})(g=e.CellUri||(e.CellUri={}));const A=t=>w.isWindows?t.replace(/\//g,"\\"):t;class l{constructor(c=[],_=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=_,this.order=[...new Set(c)].map(p=>({pattern:p,matches:v.parse(A(p))}))}sort(c){const _=new Map(b.Iterable.map(c,k=>[k,A(k)]));let p=[];for(const{matches:k}of this.order)for(const[U,V]of _)if(k(V)){p.push(U),_.delete(U);break}return _.size&&(p=p.concat([..._.keys()].sort((k,U)=>this.defaultOrder.indexOf(k)-this.defaultOrder.indexOf(U)))),p}prioritize(c,_){const p=this.findIndex(c);if(p===-1){this.order.unshift({pattern:c,matches:v.parse(A(c))});return}const k=new Set(_.map(V=>this.findIndex(V,p)));k.delete(-1);const U=Array.from(k).sort();this.order.splice(p+1,0,...U.map(V=>this.order[V]));for(let V=U.length-1;V>=0;V--)this.order.splice(U[V],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,_=this.order.length){const p=A(c);for(let k=0;k<_;k++)if(this.order[k].matches(p))return k;return-1}}e.MimeTypeDisplayOrder=l;function E(t,c,_,p=(k,U)=>k===U){const k=[];function U(D,L,B){if(L===0&&B.length===0)return;const F=k[k.length-1];F&&F.start+F.deleteCount===D?(F.deleteCount+=L,F.toInsert.push(...B)):k.push({start:D,deleteCount:L,toInsert:B})}let V=0,x=0;for(;;){if(V===t.length){U(V,0,c.slice(x));break}if(x===c.length){U(V,t.length-V,[]);break}const D=t[V],L=c[x];if(p(D,L)){V+=1,x+=1;continue}_(L)?(U(V,1,[]),V+=1):(U(V,0,[L]),x+=1)}return k}e.diff=E,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(t){t.default="default",t.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(t){const c=t;return!!((typeof c.include=="string"||v.isRelativePattern(c.include))&&(typeof c.exclude=="string"||v.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=h;function r(t,c,_){if(Array.isArray(t.viewType)&&t.viewType.indexOf(c)>=0||t.viewType===c)return!0;if(t.filenamePattern){const p=h(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,k=h(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(v.match(p,(0,P.basename)(_.fsPath).toLowerCase()))return!(k&&v.match(k,(0,P.basename)(_.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(c){return`${s._prefix}${c}`}static parse(c){if(c.startsWith(s._prefix))return c.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(ye[168],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var v;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(v=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[169],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=a;function v(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=v;function b(y){return Array.from(y.entries()).map(P=>[P[0],a(P[1].map)])}e.serializeEnvironmentVariableCollections=b;function M(y){return new Map(y.map(P=>[P[0],{map:v(P[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(ye[47],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(M){M.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var v;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(v=e.TestPosition||(e.TestPosition={}));class b{constructor(y,P=y.length){if(this.path=y,this.viewEnd=P,y.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,P,w=y.parent){if(y.id===P)return new b([P]);const T=[y.id];for(let R=w;R&&R.id!==P;R=R.parent)T.push(R.id);return T.push(P),new b(T.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const P=y.indexOf("\0");return P===-1?y:y.slice(0,P)}static fromString(y){return new b(y.split("\0"))}static join(y,P){return new b([...y.path,P])}static joinToString(y,P){return y.toString()+"\0"+P}static compare(y,P){return y===P?0:P.startsWith(y+"\0")?2:y.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new b(this.path,y)}compare(y){if(typeof y=="string")return b.compare(this.toString(),y);for(let P=0;P<y.viewEnd&&P<this.viewEnd;P++)if(y.path[P]!==this.path[P])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=b}),define(ye[48],De([1,0,2,49]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var M;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(s){s.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),s.deserialize=t=>({range:v.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var P;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var w;(function(s){s.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.deserialize(t.location)})})(w=e.ITestErrorMessage||(e.ITestErrorMessage={}));var T;(function(s){s.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.deserialize(t.location)})})(T=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(s){s.serialize=t=>t.type===0?w.serialize(t):T.serialize(t),s.deserialize=t=>t.type===0?w.deserialize(t):T.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var S;(function(s){s.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),s.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),s.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(S=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",I=(s,t)=>s+m+t;e.namespaceTestTag=I;const f=s=>{const t=s.indexOf(m);return{ctrlId:s.slice(0,t),tagId:s.slice(t+1)}};e.denamespaceTestTag=f;var d;(function(s){s.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),s.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?v.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(d=e.ITestItem||(e.ITestItem={}));var u;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(u=e.TestItemExpandState||(e.TestItemExpandState={}));var o;(function(s){s.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:d.serialize(t.item)}),s.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:d.deserialize(t.item)})})(o=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},s.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?v.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const A=(s,t)=>{t.expand!==void 0&&(s.expand=t.expand),t.item!==void 0&&(s.item=s.item?Object.assign(s.item,t.item):t.item)};e.applyTestItemUpdate=A;var l;(function(s){s.serializeWithoutMessages=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(S.serializeWithoutMessages),retired:t.retired}),s.serialize=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(S.serialize),retired:t.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var E;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var h;(function(s){s.deserialize=t=>t.op===0?{op:t.op,item:o.deserialize(t.item)}:t.op===1?{op:t.op,item:g.deserialize(t.item)}:t,s.serialize=t=>t.op===0?{op:t.op,item:o.serialize(t.item)}:t.op===1?{op:t.op,item:g.serialize(t.item)}:t})(h=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=r;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const _ of t)switch(_.op){case 0:{const p=o.deserialize(_.item);if(p.parent){if(this.items.has(p.parent)){const k=this.items.get(p.parent);k.children.add(p.item.extId);const U=this.createItem(p,k);this.items.set(p.item.extId,U),c.add(U)}}else{const k=this.createItem(p);this.roots.add(k),this.items.set(p.item.extId,k),c.add(k)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=g.deserialize(_.item),k=this.items.get(p.extId);if(!k)break;p.expand!==void 0&&(k.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(k,p),c.update(k);break}case 2:{const p=this.items.get(_.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const k=[[_.itemId]];for(;k.length;)for(const U of k.pop()){const V=this.items.get(U);V&&(k.push(V.children),this.items.delete(U),c.remove(V,V!==p),V.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(_.itemId);break;case 3:this.updatePendingRoots(_.amount);break;case 5:this._tags.set(_.tag.id,_.tag);break;case 6:this._tags.delete(_.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=n}),define(ye[65],De([1,0,14,5,7,44,48,47]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(o){o[o.Upsert=0]="Upsert",o[o.SetTags=1]="SetTags",o[o.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",o[o.RemoveChild=3]="RemoveChild",o[o.SetProp=4]="SetProp",o[o.Bulk=5]="Bulk"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(o,g)=>o===g,R={range:(o,g)=>o===g?!0:!o||!g?!1:o.equalsRange(g),busy:T,label:T,description:T,error:T,tags:(o,g)=>!(o.length!==g.length||o.some(A=>!g.includes(A)))},S=(o,g)=>{let A;for(const[l,E]of Object.entries(R))E(o[l],g[l])||(A?A[l]=g[l]:A={[l]:g[l]});return A};class m extends b.Disposable{constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new v.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const A of this.tree.values())this.updateExpandability(A)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const A=this.diff[this.diff.length-1];if(A&&g.op===1){if(A.op===1&&A.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(A.item,g.item);return}if(A.op===0&&A.item.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(A.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,A){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||A>l.expandLevels)&&(l.expandLevels=A),l.expand===1){const E=this.resolveChildren(l);return E.isOpen()?this.expandChildren(l,A-1):E.wait().then(()=>this.expandChildren(l,A-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,A-1)):this.expandChildren(l,A-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,A){switch(A.op){case 3:this.removeItem(P.TestId.joinToString(g.fullId,A.id));break;case 0:this.upsertItem(A.item,g);break;case 5:for(const l of A.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(A.new,A.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:A.update}});break;default:(0,M.assertNever)(A)}}upsertItem(g,A){const l=P.TestId.fromExtHostTestItem(g,this.root.id,A?.actual),E=this.options.getApiFor(g);E.parent&&E.parent!==A?.actual&&this.options.getChildren(E.parent).delete(g.id);let i=this.tree.get(l.toString());if(!i){i={fullId:l,actual:g,parent:A?l.parentId:null,expandLevels:A?.expandLevels?A.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(g,A),this.pushDiff({op:0,item:{parent:i.parent&&i.parent.toString(),controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,i,A);return}if(i.actual===g){this.connectItem(g,i,A);return}const h=this.options.getChildren(i.actual),r=i.actual,n=S(this.options.toITestItem(r),this.options.toITestItem(g));this.options.getApiFor(r).listener=void 0,i.actual=g,i.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,r.tags,l.toString()),delete n.tags),this.onTestItemEvent(i,{op:4,update:n})),this.connectItemAndChildren(g,i,A);for(const[s,t]of h)this.options.getChildren(g).get(t.id)||this.removeItem(P.TestId.joinToString(l,t.id))}diffTagRefs(g,A,l){const E=new Set(A.map(i=>i.id));for(const i of g)E.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(i=>(0,y.namespaceTestTag)(this.options.controllerId,i.id))}}}),E.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const A=this.tags.get(g.id);A?A.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const A=this.tags.get(g);A&&!--A.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,A){this.options.getApiFor(g).parent=A&&A.actual!==this.root?A.actual:void 0}connectItem(g,A,l){this.setItemParent(g,l);const E=this.options.getApiFor(g);E.parent=l?.actual,E.listener=i=>this.onTestItemEvent(A,i),this.updateExpandability(A)}connectItemAndChildren(g,A,l){this.connectItem(g,A,l);for(const[E,i]of this.options.getChildren(g))this.upsertItem(i,A)}updateExpandability(g){let A;this._resolveHandler?g.resolveBarrier?A=g.resolveBarrier.isOpen()?3:2:A=g.actual.canResolveChildren?1:0:A=0,A!==g.expand&&(g.expand=A,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:A}}),A===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,A){if(A<0)return;const l=[];for(const[E,i]of this.options.getChildren(g.actual)){const h=this.expand(P.TestId.joinToString(g.fullId,i.id),A);(0,a.isThenable)(h)&&l.push(h)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const i=new a.Barrier;return i.open(),i}g.expand=2,this.pushExpandStateUpdate(g);const A=g.resolveBarrier=new a.Barrier,l=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let E;try{E=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(i){l(i)}return(0,a.isThenable)(E)?E.catch(l).then(()=>{A.open(),this.updateExpandability(g)}):(A.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const A=this.tree.get(g);if(!A)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[A];for(;l.length;){const E=l.pop();if(!!E){this.options.getApiFor(E.actual).listener=void 0;for(const i of E.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(E.fullId.toString());for(const[i,h]of this.options.getChildren(E.actual))l.push(this.tree.get(P.TestId.joinToString(E.fullId,h.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class I extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=I;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(g,A,l){super(`TestItem with ID "${g}" is from controller "${A}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=d;const u=(o,g,A)=>{let l=new Map;return{get size(){return l.size},forEach(E,i){for(const h of l.values())E.call(i,h,this)},[Symbol.iterator](){return l.entries()},replace(E){const i=new Map,h=new Set(l.keys()),r={op:5,ops:[]};for(const n of E){if(!(n instanceof A))throw new f(n.id);const s=g(n).controllerId;if(s!==o.controllerId)throw new d(n.id,s,o.controllerId);if(i.has(n.id))throw new I(n.id);i.set(n.id,n),h.delete(n.id),r.ops.push({op:0,item:n})}for(const n of h.keys())r.ops.push({op:3,id:n});o.listener?.(r),l=i},add(E){if(!(E instanceof A))throw new f(E.id);l.set(E.id,E),o.listener?.({op:0,item:E})},delete(E){l.delete(E)&&o.listener?.({op:3,id:E})},get(E){return l.get(E)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=u}),define(ye[90],De([1,0,65]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const v=new WeakMap,b=(y,P)=>{const w={controllerId:P};return v.set(y,w),w};e.createPrivateApiFor=b;const M=y=>{const P=v.get(y);if(!P)throw new a.InvalidTestItemError(y?.id||"<unknown>");return P};e.getPrivateApiFor=M}),define(ye[170],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var v;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(v=e.VariableKind||(e.VariableKind={}));class b extends Error{constructor(y,P){super(P),this.variable=y}}e.VariableError=b}),define(ye[171],De([1,0,19,60,10,26,21,76,142,170,9]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(I,f,d,u){this._contributedVariables=new Map,this._context=I,this._labelService=f,this._userHomePromise=d,u&&(this._envVariablesPromise=u.then(o=>this.prepareEnv(o)))}prepareEnv(I){if(y.isWindows){const f=Object.create(null);return Object.keys(I).forEach(d=>{f[d.toLowerCase()]=I[d]}),f}return I}resolveWithEnvironment(I,f,d){return this.recursiveResolve({env:this.prepareEnv(I),userHome:void 0},f?f.uri:void 0,d)}async resolveAsync(I,f){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,I?I.uri:void 0,f)}async resolveAnyBase(I,f,d,u){const o=M.deepClone(f);y.isWindows&&o.windows?Object.keys(o.windows).forEach(A=>o[A]=o.windows[A]):y.isMacintosh&&o.osx?Object.keys(o.osx).forEach(A=>o[A]=o.osx[A]):y.isLinux&&o.linux&&Object.keys(o.linux).forEach(A=>o[A]=o.linux[A]),delete o.windows,delete o.osx,delete o.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,I?I.uri:void 0,o,d,u)}async resolveAnyAsync(I,f,d){return this.resolveAnyBase(I,f,d)}async resolveAnyMap(I,f,d){const u=new Map;return{newConfig:await this.resolveAnyBase(I,f,d,u),resolvedVariables:u}}resolveWithInteractionReplace(I,f,d,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,f,d,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,f){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,f)}async recursiveResolve(I,f,d,u,o){if(b.isString(d))return this.resolveString(I,f,d,u,o);if(Array.isArray(d))return Promise.all(d.map(g=>this.recursiveResolve(I,f,g,u,o)));if(b.isObject(d)){const g=Object.create(null),A=await Promise.all(Object.keys(d).map(async l=>[await this.resolveString(I,f,l,u,o),await this.recursiveResolve(I,f,d[l],u,o)]));for(const[l,E]of A)g[l]=E;return g}return d}resolveString(I,f,d,u,o){return(0,R.replaceAsync)(d,S.VARIABLE_REGEXP,async(g,A)=>{if(A.includes(S.VARIABLE_LHS))return g;let l=await this.evaluateSingleVariable(I,g,A,f,u);return o?.set(A,l),l!==g&&b.isString(l)&&l.match(S.VARIABLE_REGEXP)&&(l=await this.resolveString(I,f,l,u,o)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}async evaluateSingleVariable(I,f,d,u,o){let g;const A=d.split(":");A.length>1&&(d=A[0],g=A[1]);const l=h=>{const r=this._context.getFilePath();if(r)return r;throw new T.VariableError(h,(0,w.localize)(0,null,f))},E=h=>{const r=l(h);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new T.VariableError(h,(0,w.localize)(1,null,f,a.basename(r)))},i=h=>{if(g){const r=this._context.getFolderUri(g);if(r)return r;throw new T.VariableError(h,(0,w.localize)(2,null,f,g))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new T.VariableError(h,(0,w.localize)(3,null,f)):new T.VariableError(h,(0,w.localize)(4,null,f))};switch(d){case"env":if(g){if(I.env){const h=I.env[y.isWindows?g.toLowerCase():g];if(b.isString(h))return h}return""}throw new T.VariableError(T.VariableKind.Env,(0,w.localize)(5,null,f));case"config":if(g){const h=this._context.getConfigurationValue(u,g);if(b.isUndefinedOrNull(h))throw new T.VariableError(T.VariableKind.Config,(0,w.localize)(6,null,f,g));if(b.isObject(h))throw new T.VariableError(T.VariableKind.Config,(0,w.localize)(7,null,f,g));return h}throw new T.VariableError(T.VariableKind.Config,(0,w.localize)(8,null,f));case"command":return this.resolveFromMap(T.VariableKind.Command,f,g,o,"command");case"input":return this.resolveFromMap(T.VariableKind.Input,f,g,o,"input");case"extensionInstallFolder":if(g){const h=await this._context.getExtension(g);if(!h)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,f,g));return this.fsPath(h.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,f));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(i(T.VariableKind.WorkspaceFolder)));case"cwd":return u||g?(0,P.normalizeDriveLetter)(this.fsPath(i(T.VariableKind.Cwd))):v.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(i(T.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(I.userHome)return I.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,w.localize)(11,null,f))}case"lineNumber":{const h=this._context.getLineNumber();if(h)return h;throw new T.VariableError(T.VariableKind.LineNumber,(0,w.localize)(12,null,f))}case"selectedText":{const h=this._context.getSelectedText();if(h)return h;throw new T.VariableError(T.VariableKind.SelectedText,(0,w.localize)(13,null,f))}case"file":return l(T.VariableKind.File);case"fileWorkspaceFolder":return E(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||g?a.relative(this.fsPath(i(T.VariableKind.RelativeFile)),l(T.VariableKind.RelativeFile)):l(T.VariableKind.RelativeFile);case"relativeFileDirname":{const h=a.dirname(l(T.VariableKind.RelativeFileDirname));if(u||g){const r=a.relative(this.fsPath(i(T.VariableKind.RelativeFileDirname)),h);return r.length===0?".":r}return h}case"fileDirname":return a.dirname(l(T.VariableKind.FileDirname));case"fileExtname":return a.extname(l(T.VariableKind.FileExtname));case"fileBasename":return a.basename(l(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=a.basename(l(T.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-a.extname(h).length)}case"fileDirnameBasename":return a.basename(a.dirname(l(T.VariableKind.FileDirnameBasename)));case"execPath":{const h=this._context.getExecPath();return h||f}case"execInstallFolder":{const h=this._context.getAppRoot();return h||f}case"pathSeparator":return a.sep;default:try{const h=g?`${d}:${g}`:d;return this.resolveFromMap(T.VariableKind.Unknown,f,h,o,void 0)}catch{return f}}}}resolveFromMap(I,f,d,u,o){if(d&&u){const g=o===void 0?u[d]:u[o+":"+d];if(typeof g=="string")return g;throw new T.VariableError(I,(0,w.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[91],De([1,0,3,88]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var b;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function T(f){const d=f;return(0,v.isEditorInput)(d?.editor)&&(0,v.isEditorInput)(d?.replacement)}e.isEditorReplacement=T;var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const d=f;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=m;function I(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ye[172],De([1,0,3,91]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(M){const y=M;return typeof M=="number"||(0,v.isEditorGroup)(y)}e.isPreferredGroup=b}),define(ye[8],De([1,0,16,23,75,25,107,56,26,10,2,49,66,80,90,88,89,47,48,172,6,173]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(we){function Ce(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:tt,positionColumn:Xe}=q,je=new l.Position(Ae-1,Le-1),ct=new l.Position(tt-1,Xe-1);return new l.Selection(je,ct)}we.to=Ce;function me(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}we.from=me})(i=e.Selection||(e.Selection={}));var h;(function(we){function Ce(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}we.from=Ce;function me(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:tt,endColumn:Xe}=q;return new l.Range(Ae-1,Le-1,tt-1,Xe-1)}we.to=me})(h=e.Range||(e.Range={}));var r;(function(we){function Ce(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=Ce})(r=e.TokenType||(e.TokenType={}));var n;(function(we){function Ce(q){return new l.Position(q.lineNumber-1,q.column-1)}we.to=Ce;function me(q){return{lineNumber:q.line+1,column:q.character+1}}we.from=me})(n=e.Position||(e.Position={}));var s;(function(we){function Ce(Ae,Le){return(0,a.coalesce)((0,a.asArray)(Ae).map(tt=>me(tt,Le)))}we.from=Ce;function me(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:fe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function Ce(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=Ce;function me(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(we){function Ce(q){let Ae;return q.code&&((0,T.isString)(q.code)||(0,T.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...h.from(q.range),message:q.message,source:q.source,code:Ae,severity:p.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(_.from),tags:Array.isArray(q.tags)?(0,a.coalesce)(q.tags.map(t.from)):void 0}}we.from=Ce;function me(q){const Ae=new l.Diagnostic(h.to(q),q.message,p.to(q.severity));return Ae.source=q.source,Ae.code=(0,T.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(_.to),Ae.tags=q.tags&&(0,a.coalesce)(q.tags.map(t.to)),Ae}we.to=me})(c=e.Diagnostic||(e.Diagnostic={}));var _;(function(we){function Ce(q){return{...h.from(q.location.range),message:q.message,resource:q.location.uri}}we.from=Ce;function me(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,h.to(q)),q.message)}we.to=me})(_=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(we){function Ce(q){switch(q){case l.DiagnosticSeverity.Error:return I.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return I.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return I.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return I.MarkerSeverity.Hint}return I.MarkerSeverity.Error}we.from=Ce;function me(q){switch(q){case I.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case I.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case I.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case I.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=me})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var k;(function(we){function Ce(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}we.from=Ce;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=me})(k=e.ViewColumn||(e.ViewColumn={}));function U(we){return typeof we.range<"u"}function V(we){return we.length===0?!0:!!U(we[0])}e.isDecorationOptionsArr=V;var x;(function(we){function Ce(Xe){return Xe.map(we.from)}we.fromMany=Ce;function me(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let je;if(me(Xe)){const{language:pt,value:_t}=Xe;je={value:"```"+pt+`
`+_t+"\n```\n"}}else l.MarkdownString.isMarkdownString(Xe)?je={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?je={value:Xe}:je={value:""};const ct=Object.create(null);je.uris=ct;const gt=pt=>{try{let _t=R.URI.parse(pt,!0);_t=_t.with({query:Ae(_t.query,ct)}),ct[pt]=_t}catch{}return""},St=new y.marked.Renderer;return St.link=gt,St.image=pt=>typeof pt=="string"?gt(b.parseHrefAndDimensions(pt).href):"",(0,y.marked)(je.value,{renderer:St}),je}we.from=q;function Ae(Xe,je){if(!Xe)return Xe;let ct;try{ct=(0,P.parse)(Xe)}catch{}if(!ct)return Xe;let gt=!1;return ct=(0,w.cloneAndChange)(ct,St=>{if(R.URI.isUri(St)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return je[pt]=St,gt=!0,pt}else return}),gt?JSON.stringify(ct):Xe}function Le(Xe){const je=new l.MarkdownString(Xe.value,Xe.supportThemeIcons);return je.isTrusted=Xe.isTrusted,je.supportHtml=Xe.supportHtml,je.baseUri=Xe.baseUri?R.URI.from(Xe.baseUri):void 0,je}we.to=Le;function tt(Xe){if(!!Xe)return typeof Xe=="string"?Xe:we.from(Xe)}we.fromStrict=tt})(x=e.MarkdownString||(e.MarkdownString={}));function D(we){return V(we)?we.map(Ce=>({range:h.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?x.fromMany(Ce.hoverMessage):Ce.hoverMessage?x.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):we.map(Ce=>({range:h.from(Ce)}))}e.fromRangeOrRangeWithMessage=D;function L(we){return typeof we>"u"?we:typeof we=="string"?R.URI.file(we):we}e.pathOrURIToURI=L;var B;(function(we){function Ce(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?L(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}we.from=Ce})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(we){function Ce(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?L(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?B.from(me.before):void 0,after:me.after?B.from(me.after):void 0}}we.from=Ce})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(we){function Ce(me){if(typeof me>"u")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ce})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var H;(function(we){function Ce(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?K.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?F.from(me.light):void 0,dark:me.dark?F.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?L(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?B.from(me.before):void 0,after:me.after?B.from(me.after):void 0}}we.from=Ce})(H=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(we){function Ce(q){return{text:q.newText,eol:q.newEol&&Ge.from(q.newEol),range:h.from(q.range)}}we.from=Ce;function me(q){const Ae=new l.TextEdit(h.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Ge.to(q.eol),Ae}we.to=me})(O=e.TextEdit||(e.TextEdit={}));var ee;(function(we){function Ce(q,Ae,Le){const tt={edits:[]};if(q instanceof l.WorkspaceEdit){const Xe=new M.ResourceSet;for(const je of q._allEntries())je._type===1&&R.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of q._allEntries())if(je._type===1)tt.edits.push({oldResource:je.from,newResource:je.to,options:je.options,metadata:je.metadata});else if(je._type===2)tt.edits.push({resource:je.uri,textEdit:O.from(je.edit),versionId:Xe.has(je.uri)?void 0:Ae?.getTextDocumentVersion(je.uri),metadata:je.metadata});else if(je._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",je);continue}tt.edits.push({resource:je.uri,textEdit:{range:h.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Ae?.getTextDocumentVersion(je.uri),metadata:je.metadata})}else je._type===3?tt.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(je.uri)}):je._type===5&&tt.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(ot.from)}})}return tt}we.from=Ce;function me(q){const Ae=new l.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(R.URI.revive(Le.resource),h.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(R.URI.revive(Le.oldResource),R.URI.revive(Le.newResource),Le.options);return Ae}we.to=me})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(we){const Ce=Object.create(null);Ce[l.SymbolKind.File]=0,Ce[l.SymbolKind.Module]=1,Ce[l.SymbolKind.Namespace]=2,Ce[l.SymbolKind.Package]=3,Ce[l.SymbolKind.Class]=4,Ce[l.SymbolKind.Method]=5,Ce[l.SymbolKind.Property]=6,Ce[l.SymbolKind.Field]=7,Ce[l.SymbolKind.Constructor]=8,Ce[l.SymbolKind.Enum]=9,Ce[l.SymbolKind.Interface]=10,Ce[l.SymbolKind.Function]=11,Ce[l.SymbolKind.Variable]=12,Ce[l.SymbolKind.Constant]=13,Ce[l.SymbolKind.String]=14,Ce[l.SymbolKind.Number]=15,Ce[l.SymbolKind.Boolean]=16,Ce[l.SymbolKind.Array]=17,Ce[l.SymbolKind.Object]=18,Ce[l.SymbolKind.Key]=19,Ce[l.SymbolKind.Null]=20,Ce[l.SymbolKind.EnumMember]=21,Ce[l.SymbolKind.Struct]=22,Ce[l.SymbolKind.Event]=23,Ce[l.SymbolKind.Operator]=24,Ce[l.SymbolKind.TypeParameter]=25;function me(Ae){return typeof Ce[Ae]=="number"?Ce[Ae]:6}we.from=me;function q(Ae){for(const Le in Ce)if(Ce[Le]===Ae)return Number(Le);return l.SymbolKind.Property}we.to=q})(ce=e.SymbolKind||(e.SymbolKind={}));var oe;(function(we){function Ce(q){switch(q){case l.SymbolTag.Deprecated:return 1}}we.from=Ce;function me(q){switch(q){case 1:return l.SymbolTag.Deprecated}}we.to=me})(oe=e.SymbolTag||(e.SymbolTag={}));var le;(function(we){function Ce(q){return{name:q.name,kind:ce.from(q.kind),tags:q.tags&&q.tags.map(oe.from),containerName:q.containerName,location:ve.from(q.location)}}we.from=Ce;function me(q){const Ae=new l.SymbolInformation(q.name,ce.to(q.kind),q.containerName,ve.to(q.location));return Ae.tags=q.tags&&q.tags.map(oe.to),Ae}we.to=me})(le=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(we){function Ce(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:h.from(q.range),selectionRange:h.from(q.selectionRange),kind:ce.from(q.kind),tags:q.tags?.map(oe.from)??[]};return q.children&&(Ae.children=q.children.map(Ce)),Ae}we.from=Ce;function me(q){const Ae=new l.DocumentSymbol(q.name,q.detail,ce.to(q.kind),h.to(q.range),h.to(q.selectionRange));return(0,a.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(oe.to)),q.children&&(Ae.children=q.children.map(me)),Ae}we.to=me})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(we){function Ce(q){const Ae=new l.CallHierarchyItem(ce.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),h.to(q.range),h.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}we.to=Ce;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:ce.from(q.kind),uri:q.uri,range:h.from(q.range),selectionRange:h.from(q.selectionRange),tags:q.tags?.map(oe.from)}}we.from=me})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(we){function Ce(me){return new l.CallHierarchyIncomingCall(Ee.to(me.from),me.fromRanges.map(q=>h.to(q)))}we.to=Ce})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(we){function Ce(me){return new l.CallHierarchyOutgoingCall(Ee.to(me.to),me.fromRanges.map(q=>h.to(q)))}we.to=Ce})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(we){function Ce(q){return{range:q.range&&h.from(q.range),uri:q.uri}}we.from=Ce;function me(q){return new l.Location(R.URI.revive(q.uri),h.to(q.range))}we.to=me})(ve=e.location||(e.location={}));var Pe;(function(we){function Ce(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?h.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:h.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?h.from(Ae.targetSelectionRange):void 0}}we.from=Ce;function me(q){return{targetUri:R.URI.revive(q.uri),targetRange:h.to(q.range),targetSelectionRange:q.targetSelectionRange?h.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?h.to(q.originSelectionRange):void 0}}we.to=me})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(we){function Ce(q){return{range:h.from(q.range),contents:x.fromMany(q.contents)}}we.from=Ce;function me(q){return new l.Hover(q.contents.map(x.to),h.to(q.range))}we.to=me})(Fe=e.Hover||(e.Hover={}));var xe;(function(we){function Ce(q){return{range:h.from(q.range),expression:q.expression}}we.from=Ce;function me(q){return new l.EvaluatableExpression(h.to(q.range),q.expression)}we.to=me})(xe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(we){function Ce(q){if(q instanceof l.InlineValueText)return{type:"text",range:h.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:h.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ce;function me(q){switch(q.type){case"text":return{range:h.to(q.range),text:q.text};case"variable":return{range:h.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:h.to(q.range),expression:q.expression}}}we.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var Ie;(function(we){function Ce(q){return{frameId:q.frameId,stoppedLocation:h.from(q.stoppedLocation)}}we.from=Ce;function me(q){return new l.InlineValueContext(q.frameId,h.to(q.stoppedLocation))}we.to=me})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(we){function Ce(q){return{range:h.from(q.range),kind:q.kind}}we.from=Ce;function me(q){return new l.DocumentHighlight(h.to(q.range),q.kind)}we.to=me})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(we){function Ce(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=Ce})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(we){function Ce(me){return{triggerKind:Te.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}we.to=Ce})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(we){function Ce(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}we.from=Ce;function me(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}we.to=me})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(we){const Ce=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Le){return Ce.get(Le)??9}we.from=me;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??l.CompletionItemKind.Property}we.to=Ae})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var Y;(function(we){function Ce(me,q){const Ae=new l.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=X.to(me.kind),Ae.tags=me.tags?.map(ue.to),Ae.detail=me.detail,Ae.documentation=b.isMarkdownString(me.documentation)?x.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,S.Range.isIRange(me.range)?Ae.range=h.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:h.to(me.range.insert),replacing:h.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new l.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Le=>O.to(Le))),Ae.command=q&&me.command?q.fromInternal(me.command):void 0,Ae}we.to=Ce})(Y=e.CompletionItem||(e.CompletionItem={}));var C;(function(we){function Ce(q){return{label:q.label,documentation:x.fromStrict(q.documentation)}}we.from=Ce;function me(q){return{label:q.label,documentation:b.isMarkdownString(q.documentation)?x.to(q.documentation):q.documentation}}we.to=me})(C=e.ParameterInformation||(e.ParameterInformation={}));var z;(function(we){function Ce(q){return{label:q.label,documentation:x.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(C.from):[],activeParameter:q.activeParameter}}we.from=Ce;function me(q){return{label:q.label,documentation:b.isMarkdownString(q.documentation)?x.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(C.to):[],activeParameter:q.activeParameter}}we.to=me})(z=e.SignatureInformation||(e.SignatureInformation={}));var W;(function(we){function Ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(z.from):[]}}we.from=Ce;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(z.to):[]}}we.to=me})(W=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(we){function Ce(me,q){const Ae=new l.InlayHint(n.to(q.position),typeof q.label=="string"?q.label:q.label.map(se.to.bind(void 0,me)),q.kind&&de.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map(O.to),Ae.tooltip=b.isMarkdownString(q.tooltip)?x.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}we.to=Ce})(j=e.InlayHint||(e.InlayHint={}));var se;(function(we){function Ce(me,q){const Ae=new l.InlayHintLabelPart(q.label);return Ae.tooltip=b.isMarkdownString(q.tooltip)?x.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Ae.command=me.fromInternal(q.command)),q.location&&(Ae.location=ve.to(q.location)),Ae}we.to=Ce})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(we){function Ce(q){return q}we.from=Ce;function me(q){return q}we.to=me})(de=e.InlayHintKind||(e.InlayHintKind={}));var Z;(function(we){function Ce(q){return{range:h.from(q.range),url:q.target,tooltip:q.tooltip}}we.from=Ce;function me(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?R.URI.parse(q.url,!0):R.URI.revive(q.url)}catch{}return new l.DocumentLink(h.to(q.range),Ae)}we.to=me})(Z=e.DocumentLink||(e.DocumentLink={}));var pe;(function(we){function Ce(q){const Ae=new l.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=O.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>O.to(Le))),Ae}we.to=Ce;function me(q){return{label:q.label,textEdit:q.textEdit?O.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>O.from(Ae)):void 0}}we.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(we){function Ce(q){return new l.Color(q[0],q[1],q[2],q[3])}we.to=Ce;function me(q){return[q.red,q.green,q.blue,q.alpha]}we.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(we){function Ce(q){return{range:h.from(q.range)}}we.from=Ce;function me(q){return new l.SelectionRange(h.to(q.range))}we.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(we){function Ce(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=Ce})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(we){function Ce(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ce;function me(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(we){function Ce(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}we.from=Ce;function me(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}we.to=me})(Ge=e.EndOfLine||(e.EndOfLine={}));var ke;(function(we){function Ce(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ce})(ke=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(we){function Ce(me){const q={start:me.start+1,end:me.end+1};return me.kind&&(q.kind=G.from(me.kind)),q}we.from=Ce})(rt=e.FoldingRange||(e.FoldingRange={}));var G;(function(we){function Ce(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=Ce})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(we){function Ce(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?h.from(me.selection):void 0,override:typeof me.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=Ce})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(we){function Ce(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||q(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}we.from=Ce;function me(Le){const tt=Le;return tt?R.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function q(Le){const tt=Le;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new l.RelativePattern(R.URI.revive(Le.baseUri),Le.pattern)}we.to=Ae})(fe=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(we){function Ce(me){if(me){if(Array.isArray(me))return me.map(Ce);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:fe.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}we.from=Ce})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(we){function Ce(q){return{start:q.start,end:q.end}}we.from=Ce;function me(q){return new l.NotebookRange(q.start,q.end)}we.to=me})(He=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(we){function Ce(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}we.to=Ce;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}we.from=me})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(we){function Ce(me){if(me===u.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(me===u.NotebookCellExecutionState.Pending)return;if(me===u.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}we.to=Ce})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(we){function Ce(q){switch(q){case l.NotebookCellKind.Markup:return u.CellKind.Markup;case l.NotebookCellKind.Code:default:return u.CellKind.Code}}we.from=Ce;function me(q){switch(q){case u.CellKind.Markup:return l.NotebookCellKind.Markup;case u.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=me})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(we){function Ce(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)l.NotebookCellData.validate(Le),Ae.cells.push(ot.from(Le));return Ae}we.from=Ce;function me(q){const Ae=new l.NotebookData(q.cells.map(ot.to));return(0,T.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}we.to=me})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(we){function Ce(q){return{cellKind:We.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ze.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(kt.from):[]}}we.from=Ce;function me(q){return new l.NotebookCellData(We.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(kt.to):void 0,q.metadata,q.internalMetadata?Ze.to(q.internalMetadata):void 0)}we.to=me})(ot=e.NotebookCellData||(e.NotebookCellData={}));var ht;(function(we){function Ce(q){return{mime:q.mime,valueBytes:v.VSBuffer.wrap(q.data)}}we.from=Ce;function me(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}we.to=me})(ht=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var kt;(function(we){function Ce(q){return{outputId:q.id,items:q.items.map(ht.from),metadata:q.metadata}}we.from=Ce;function me(q){const Ae=q.items.map(ht.to);return new l.NotebookCellOutput(Ae,q.outputId,q.metadata)}we.to=me})(kt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(we){function Ce(Ae){return q(Ae)?{include:(0,T.withNullAsUndefined)(fe.from(Ae.include)),exclude:(0,T.withNullAsUndefined)(fe.from(Ae.exclude))}:(0,T.withNullAsUndefined)(fe.from(Ae))}we.from=Ce;function me(Ae){return q(Ae)?{include:fe.to(Ae.include),exclude:fe.to(Ae.exclude)}:fe.to(Ae)}we.to=me;function q(Ae){const Le=Ae;return Le?!(0,T.isUndefinedOrNull)(Le.include)&&!(0,T.isUndefinedOrNull)(Le.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(we){function Ce(me,q,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}we.from=Ce})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(we){function Ce(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}we.from=Ce})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var $t;(function(we){function Ce(q){return{uri:q.uri,provides:q.provides}}we.from=Ce;function me(q){return new l.NotebookRendererScript(R.URI.revive(q.uri),q.provides)}we.to=me})($t=e.NotebookRendererScript||(e.NotebookRendererScript={}));var yt;(function(we){function Ce(q){return{message:x.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:h.from(q.location.range),uri:q.location.uri}}}we.from=Ce;function me(q){const Ae=new l.TestMessage(typeof q.message=="string"?q.message:x.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?ve.to(q.location):void 0,Ae}we.to=me})(yt=e.TestMessage||(e.TestMessage={}));var ft;(function(we){we.namespace=g.namespaceTestTag,we.denamespace=g.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Dt;(function(we){function Ce(q){const Ae=(0,f.getPrivateApiFor)(q).controllerId;return{extId:o.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:R.URI.revive(q.uri),busy:!1,tags:q.tags.map(Le=>ft.namespace(Ae,Le.id)),range:S.Range.lift(h.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&x.fromStrict(q.error)||null}}we.from=Ce;function me(q){return{parent:void 0,error:void 0,id:o.TestId.fromString(q.extId).localId,label:q.label,uri:R.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=ft.denamespace(Ae);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(q.range||void 0),canResolveChildren:!1,busy:!1,description:q.description||void 0,sortText:q.sortText||void 0}}we.toPlain=me})(Dt=e.TestItem||(e.TestItem={})),function(we){function Ce(q){return{id:q.id}}we.from=Ce;function me(q){return new l.TestTag(q.id)}we.to=me}(ft=e.TestTag||(e.TestTag={}));var Mt;(function(we){const Ce=(q,Ae)=>{const Le=[];for(const[Xe,je]of Ae)o.TestId.compare(je.item.extId,Xe)===2&&(Ae.delete(Xe),Le.push(je));const tt={...Dt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(je=>je.type===0).map(yt.to)})),children:Le.map(Xe=>Ce(Xe,Ae))};for(const Xe of tt.children)Xe.parent=tt;return tt};function me(q){const Ae=[],Le=new Map;for(const tt of q.items)Le.set(tt.item.extId,tt),q.request.targets.some(Xe=>Xe.controllerId===tt.controllerId&&Xe.testIds.includes(tt.item.extId))&&Ae.push(tt);return{completedAt:q.completedAt,results:Ae.map(tt=>Ce(tt,Le))}}we.to=me})(Mt=e.TestResults||(e.TestResults={}));var Ot;(function(we){function Ce(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?n.from(Le):h.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(tt=>({count:tt.executionCount,location:tt.location&&me(tt.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}we.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:Ce(Le.statementCoverage),branch:Le.branchCoverage&&Ce(Le.branchCoverage),function:Le.functionCoverage&&Ce(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}we.fromFile=Ae})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(we){function Ce(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=Ce})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(we){function Ce(q){const Ae=new l.TypeHierarchyItem(ce.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),h.to(q.range),h.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}we.to=Ce;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ce.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:h.from(q.range),selectionRange:h.from(q.selectionRange),tags:q.tags?.map(oe.from)}}we.from=me})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Pt;(function(we){function Ce(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}we.from=Ce})(Pt=e.ViewBadge||(e.ViewBadge={}));var Ut;(function(we){function Ce(me,q){const Ae=me.fileData;return Ae?new class extends l.DataTransferItem{asFile(){return{name:Ae.name,uri:R.URI.revive(Ae.uri),data:(0,E.once)(()=>q())}}}(""):new l.DataTransferItem(me.asString)}we.toDataTransferItem=Ce})(Ut=e.DataTransferItem||(e.DataTransferItem={}));var vt;(function(we){function Ce(q,Ae){const Le=q.items.map(([tt,Xe],je)=>[tt,Ut.toDataTransferItem(Xe,()=>Ae(je))]);return new l.DataTransfer(Le)}we.toDataTransfer=Ce;async function me(q){const Ae={items:[]},Le=[];return q.forEach((tt,Xe)=>{Le.push((async()=>{const je=await tt.asString(),ct=tt.asFile();Ae.items.push([Xe,{asString:je,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all(Le),Ae}we.toDataTransferDTO=me})(vt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[174],De([1,0,2,11,6,8,241]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,R,S,m={timeout:1500,errors:3}){this._logService=T,this._documents=R,this._mainThreadBulkEdits=S,this._thresholds=m,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(R,S,m)=>{const f={dispose:this._callbacks.push([R,S,T])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(T,R){const S=a.URI.revive(T);let m=!1;const I=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const d of[...this._callbacks]){if(m)break;const u=this._documents.getDocument(S),o=await this._deliverEventAsyncAndBlameBadListeners(d,{document:u,reason:M.TextDocumentSaveReason.to(R)});f.push(o)}}finally{clearTimeout(I)}return f}_deliverEventAsyncAndBlameBadListeners([T,R,S],m){const I=this._badListeners.get(T);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,T,R,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const d=this._badListeners.get(T);this._badListeners.set(T,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,R,S,m){const I=[],f=Date.now(),{document:d,reason:u}=m,{version:o}=d,g=Object.freeze({document:d,reason:u,waitUntil(A){if(Object.isFrozen(I))throw(0,v.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(A))}});try{R.apply(S,[g])}catch(A){return Promise.reject(A)}return Object.freeze(I),new Promise((A,l)=>{const E=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(E),A(i)}).catch(i=>{clearTimeout(E),l(i)})}).then(A=>{const l={edits:[]};for(const E of A)if(Array.isArray(E)&&E.every(i=>i instanceof b.TextEdit))for(const{newText:i,newEol:h,range:r}of E)l.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:i,eol:h&&M.EndOfLine.from(h)}});if(l.edits.length!==0)return o===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[175],De([1,0,12,2,8,6,89]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(S,m,I,f){this.start=S,this.deletedCount=m,this.deletedItems=I,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class w{constructor(S,m,I){this.notebook=S,this._extHostDocument=m,this._cellData=I,this.handle=I.handle,this.uri=v.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}static asModelAddData(S,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:S}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const S=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return S._mime},set mime(f){S._mime=f},get outputs(){return S._outputs.slice(0)},get metadata(){return S._metadata},get executionSummary(){return S._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(S){this._outputs=S.map(b.NotebookCellOutput.to)}setOutputItems(S,m,I){const f=I.map(b.NotebookCellOutputItem.to),d=this._outputs.find(u=>u.id===S);d&&(m||(d.items.length=0),d.items.push(...f))}setMetadata(S){this._metadata=Object.freeze(S)}setInternalMetadata(S){this._internalMetadata=S,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=w;class T{constructor(S,m,I,f,d){this._proxy=S,this._textDocumentsAndEditors=m,this._textDocuments=I,this.uri=f,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0,void 0),this._versionId=d.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const S=this,m={get uri(){return S.uri},get version(){return S._versionId},get notebookType(){return S._notebookType},get isDirty(){return S._isDirty},get isUntitled(){return S.uri.scheme===a.Schemas.untitled},get isClosed(){return S._disposed},get metadata(){return S._metadata},get cellCount(){return S._cells.length},cellAt(I){return I=S._validateIndex(I),S._cells[I].apiCell},getCells(I){return(I?S._getCells(I):S._cells).map(d=>d.apiCell)},save(){return S._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(S){this._backup?.delete(),this._backup=S}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(S){S.metadata&&(this._metadata=Object.freeze({...this._metadata,...S.metadata}))}acceptDirty(S){this._isDirty=S}acceptModelChanged(S,m,I){this._versionId=S.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:I});const f={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},d=[];for(const o of S.rawEvents)o.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,f.contentChanges):o.kind===y.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx,f.contentChanges):o.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),d.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),d.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),d.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===y.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),d.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),d.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const u=new Map;for(let o=0;o<d.length;o++){const g=d[o],A=u.get(g.cell);if(A===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});u.set(g.cell,l-1)}else f.cellChanges[A]={...f.cellChanges[A],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(S){return S=S|0,S<0?0:S>=this._cells.length?this._cells.length-1:S}_validateRange(S){let m=S.start|0,I=S.end|0;return m<0&&(m=0),I>this._cells.length&&(I=this._cells.length),S.with({start:m,end:I})}_getCells(S){S=this._validateRange(S);const m=[];for(let I=S.start;I<S.end;I++)m.push(this._cells[I]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(S,m,I){if(this._disposed)return;const f=[],d=[],u=[];if(S.reverse().forEach(o=>{const A=o[2].map(i=>{const h=new w(this,this._textDocumentsAndEditors,i);return m||d.push(w.asModelAddData(this.apiNotebook,i)),h}),l=new P(o[0],o[1],[],A),E=this._cells.splice(o[0],o[1],...A);for(const i of E)u.push(i.uri),l.deletedItems.push(i.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:u}),I)for(const o of f)I.push(o.asApiEvent())}_moveCell(S,m,I){const f=this._cells.splice(S,1);this._cells.splice(m,0,...f);const d=[new P(S,1,f.map(u=>u.apiCell),[]),new P(m,0,[],f)];for(const u of d)I.push(u.asApiEvent())}_setCellOutputs(S,m){this._cells[S].setOutputs(m)}_setCellOutputItems(S,m,I,f){this._cells[S].setOutputItems(m,I,f)}_changeCellLanguage(S,m){const I=this._cells[S];I.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(I.uri,m)}_changeCellMime(S,m){const I=this._cells[S];I.apiCell.mime=m}_changeCellMetadata(S,m){this._cells[S].setMetadata(m)}_changeCellInternalMetadata(S,m){this._cells[S].setInternalMetadata(m)}getCellFromApiCell(S){return this._cells.find(m=>m.apiCell===S)}getCellFromIndex(S){return this._cells[S]}getCell(S){return this._cells.find(m=>m.handle===S)}getCellIndex(S){return this._cells.indexOf(S)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ye[92],De([1,0,11,8,6]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(P,w,T,R,S,m){this.id=P,this._proxy=w,this.notebookData=T,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=S,this._visibleRanges=R,this._viewColumn=m}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(w){this.selections=[w]},get selections(){return P._selections},set selections(w){if(!Array.isArray(w)||!w.every(b.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");P._selections=w,P._trySetSelections(w)},get visibleRanges(){return P._visibleRanges},revealRange(w,T){P._proxy.$tryRevealRange(P.id,v.NotebookRange.from(w),T??b.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(v.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(ye[176],De([1,0,5,15,8]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(P,w){this._logService=P,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(P,w){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,w);const T=this._notebooksAndEditors.getEditorById(P);w.visibleRanges&&T._acceptVisibleRanges(w.visibleRanges.ranges.map(b.NotebookRange.to)),w.selections&&T._acceptSelections(w.selections.selections.map(b.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const w in P)this._notebooksAndEditors.getEditorById(w)._acceptViewColumn(b.ViewColumn.to(P[w]))}};M=ze([$e(0,v.ILogService)],M),e.ExtHostNotebookEditors=M}),define(ye[177],De([1,0,8,151,132,20,55,11]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,I,f){const d=this._handles++,{title:u,location:o,cancellable:g}=I,A={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(d,{location:a.ProgressLocation.from(o),title:u,source:A,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(d,f,!!g)}_withProgress(m,I,f){let d;f&&(d=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,d));const u=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),d?.dispose()};let o;try{o=I(new R(this._proxy,m),f&&d?d.token:M.CancellationToken.None)}catch(g){throw u(m),g}return o.then(g=>u(m),g=>u(m)),o}$acceptProgressCanceled(m){const I=this._mapHandleToCancellationSource.get(m);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=w;function T(S,m){return S.message=m.message,typeof m.increment=="number"&&(typeof S.increment=="number"?S.increment+=m.increment:S.increment=m.increment),S}class R extends v.Progress{constructor(m,I){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=I}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,y.throttle)(100,(S,m)=>T(S,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ye[93],De([1,0,49,90,47,65,48,8,2]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(A,l,E,i)=>{let h=l;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!E(h,r)){const n=h;h=r,A.listener?.(i(r,n))}}}},R=(A,l)=>A===l,S={range:(A,l)=>A===l?!0:!A||!l?!1:A.isEqual(l),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(A,l)=>!(A.length!==l.length||A.some(E=>!l.find(i=>E.id===i.id)))},m=A=>l=>({op:4,update:A(l)}),I=(A,l)=>({range:T(A,void 0,S.range,m(E=>({range:a.Range.lift(P.Range.from(E))}))),label:T(A,l,S.label,m(E=>({label:E}))),description:T(A,void 0,S.description,m(E=>({description:E}))),sortText:T(A,void 0,S.sortText,m(E=>({sortText:E}))),canResolveChildren:T(A,!1,S.canResolveChildren,E=>({op:2,state:E})),busy:T(A,!1,S.busy,m(E=>({busy:E}))),error:T(A,void 0,S.error,m(E=>({error:P.MarkdownString.fromStrict(E)||null}))),tags:T(A,[],S.tags,(E,i)=>({op:1,new:E.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),f=A=>{const l=b.TestId.fromString(A.extId),E=new u(l.controllerId,l.localId,A.label,w.URI.revive(A.uri)||void 0);return E.range=P.Range.to(A.range||void 0),E.description=A.description||void 0,E.sortText=A.sortText||void 0,E.tags=A.tags.map(i=>P.TestTag.to({id:(0,y.denamespaceTestTag)(i).tagId})),E},d=A=>{let l;for(const E of A.tests){const i=f(E.item);(0,v.getPrivateApiFor)(i).parent=l,l=i}return l};e.toItemFromContext=d;class u{constructor(l,E,i,h){if(E.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(E)} symbol`);const r=(0,v.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:E,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,v.getPrivateApiFor,u),enumerable:!0,writable:!1},...I(r,i)})}}e.TestItemImpl=u;class o extends u{constructor(l,E){super(l,l,E,void 0)}}e.TestItemRootImpl=o;class g extends M.TestItemCollection{constructor(l,E){super({controllerId:l,getApiFor:v.getPrivateApiFor,getChildren:i=>i.children,root:new o(l,E),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ye[94],De([1,0,44,11,73,8,6]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(m,I,f){const d=P._Keys.nextId();m.$registerTextEditorDecorationType(I.identifier,d,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:d,dispose(){m.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=P,P._Keys=new b.IdGenerator("TextEditorDecorationType");class w{constructor(m,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,I){this._throwIfFinalized();let f=null;if(m instanceof y.Position)f=new y.Range(m,m);else if(m instanceof y.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,I,!1)}insert(m,I){this._throwIfFinalized(),this._pushEdit(new y.Range(m,m),I,!0)}delete(m){this._throwIfFinalized();let I=null;if(m instanceof y.Range)I=m;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(m,I,f){const d=this._document.validateRange(m);this._collectedEdits.push({range:d,text:I,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==y.EndOfLine.LF&&m!==y.EndOfLine.CRLF)throw(0,v.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=w;class T{constructor(m,I,f,d){this._proxy=m,this._id=I,this._accept(f),this._logService=d;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(o){u._setTabSize(o)},get insertSpaces(){return u._insertSpaces},set insertSpaces(o){u._setInsertSpaces(o)},get cursorStyle(){return u._cursorStyle},set cursorStyle(o){u._setCursorStyle(o)},get lineNumbers(){return u._lineNumbers},set lineNumbers(o){u._setLineNumbers(o)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const I=Math.floor(m);return I>0?I:null}if(typeof m=="string"){const I=parseInt(m,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(m){const I=this._validateTabSize(m);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const I=this._validateInsertSpaces(m);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const I={};let f=!1;if(typeof m.tabSize<"u"){const d=this._validateTabSize(m.tabSize);d==="auto"?(f=!0,I.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,f=!0,I.tabSize=d)}if(typeof m.insertSpaces<"u"){const d=this._validateInsertSpaces(m.insertSpaces);d==="auto"?(f=!0,I.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,f=!0,I.insertSpaces=d)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,I.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,I.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(m,I){I.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=T;class R{constructor(m,I,f,d,u,o,g,A){this.id=m,this._proxy=I,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new T(this._proxy,this.id,o,f),this._visibleRanges=g,this._viewColumn=A;const l=this;this.value=Object.freeze({get document(){return d.getValue()},set document(E){throw(0,v.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(E){if(!(E instanceof y.Selection))throw(0,v.illegalArgument)("selection");l._selections=[E],l._trySetSelection()},get selections(){return l._selections},set selections(E){if(!Array.isArray(E)||E.some(i=>!(i instanceof y.Selection)))throw(0,v.illegalArgument)("selections");l._selections=E,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(E){throw(0,v.readonly)("visibleRanges")},get options(){return l._options.value},set options(E){l._disposed||l._options.assign(E)},get viewColumn(){return l._viewColumn},set viewColumn(E){throw(0,v.readonly)("viewColumn")},edit(E,i={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new w(d.getValue(),i);return E(h),l._applyEdit(h)},insertSnippet(E,i,h={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=l._selections.map(n=>M.Range.from(n));else if(i instanceof y.Position){const{lineNumber:n,column:s}=M.Position.from(i);r=[{startLineNumber:n,startColumn:s,endLineNumber:n,endColumn:s}]}else if(i instanceof y.Range)r=[M.Range.from(i)];else{r=[];for(const n of i)if(n instanceof y.Range)r.push(M.Range.from(n));else{const{lineNumber:s,column:t}=M.Position.from(n);r.push({startLineNumber:s,startColumn:t,endLineNumber:s,endColumn:t})}}return I.$tryInsertSnippet(m,d.getValue().version,E.value,r,h)},setDecorations(E,i){const h=i.length===0;h&&!l._hasDecorationsForKey.has(E.key)||(h?l._hasDecorationsForKey.delete(E.key):l._hasDecorationsForKey.add(E.key),l._runOnProxy(()=>{if(M.isDecorationOptionsArr(i))return I.$trySetDecorations(m,E.key,M.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let n=0,s=i.length;n<s;n++){const t=i[n];r[4*n]=t.start.line+1,r[4*n+1]=t.start.character+1,r[4*n+2]=t.end.line+1,r[4*n+3]=t.end.character+1}return I.$trySetDecorationsFast(m,E.key,r)}}))},revealRange(E,i){l._runOnProxy(()=>I.$tryRevealRange(m,M.Range.from(E),i||y.TextEditorRevealType.Default))},show(E){I.$tryShowEditor(m,M.ViewColumn.from(E))},hide(){I.$tryHideEditor(m)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,a.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,a.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,a.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,a.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const I=m.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const f=I.edits.map(u=>u.range);f.sort((u,o)=>u.end.line===o.end.line?u.end.character===o.end.character?u.start.line===o.start.line?u.start.character-o.start.character:u.start.line-o.start.line:u.end.character-o.end.character:u.end.line-o.end.line);for(let u=0,o=f.length-1;u<o;u++){const g=f[u].end;if(f[u+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=I.edits.map(u=>({range:M.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,d,{setEndOfLine:typeof I.setEndOfLine=="number"?M.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=R}),define(ye[178],De([1,0,3,147]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(v.IEnvironmentService)}),define(ye[179],De([1,0,27,5,19]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(S){this.removedDueToLooping=S}}e.DeltaExtensionsResult=M;class y{constructor(S){this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=S,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const S of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(S.identifier))){console.error("Extension `"+S.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(S.identifier),S),this._extensionsArr.push(S),Array.isArray(S.activationEvents))for(let m of S.activationEvents)m==="onUri"&&(m=`onUri:${a.ExtensionIdentifier.toKey(S.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(S)}}set(S){this._extensionDescriptions=S,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(S,m){this._extensionDescriptions=T(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(S);const I=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=T(this._extensionDescriptions,I.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(I)}static _findLoopingExtensions(S){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(o){this._nodesSet.has(o)||(this._nodesSet.add(o),this._nodesArr.push(o))}addArc(o,g){this.addNode(o),this.addNode(g),this._arcs.has(o)?this._arcs.get(o).push(g):this._arcs.set(o,[g])}getArcs(o){return this._arcs.has(o)?this._arcs.get(o):[]}hasOnlyGoodArcs(o,g){const A=m.getArcs(o);for(let l=0;l<A.length;l++)if(!g.has(A[l]))return!1;return!0}getNodes(){return this._nodesArr}},I=new Map;for(const o of S){const g=a.ExtensionIdentifier.toKey(o.identifier);if(I.set(g,o),o.extensionDependencies)for(const A of o.extensionDependencies){const l=a.ExtensionIdentifier.toKey(A);m.addArc(g,l)}}const f=new Set;m.getNodes().filter(o=>m.getArcs(o).length===0).forEach(o=>f.add(o));const d=m.getNodes().filter(o=>!f.has(o));let u;do{u=!1;for(let o=0;o<d.length;o++){const g=d[o];m.hasOnlyGoodArcs(g,f)&&(d.splice(o,1),o--,f.add(g),u=!0)}}while(u);return d.map(o=>I.get(o))}containsActivationEvent(S){return this._activationMap.has(S)}containsExtension(S){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(S))}getExtensionDescriptionsForActivationEvent(S){const m=this._activationMap.get(S);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(S){const m=this._extensionsMap.get(a.ExtensionIdentifier.toKey(S));return m||void 0}getExtensionDescriptionByUUID(S){for(const m of this._extensionsArr)if(m.uuid===S)return m}getExtensionDescriptionByIdOrUUID(S,m){return this.getExtensionDescription(S)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=y;var P;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(P||(P={}));function w(R,S){const m=R.isBuiltin?0:R.isUnderDevelopment?2:1,I=S.isBuiltin?0:S.isUnderDevelopment?2:1;if(m!==I)return m-I;const f=b.posix.basename(R.extensionLocation.path),d=b.posix.basename(S.extensionLocation.path);return f<d?-1:f>d?1:0}function T(R,S){const m=new Set;return S.forEach(I=>m.add(a.ExtensionIdentifier.toKey(I))),R.filter(I=>!m.has(a.ExtensionIdentifier.toKey(I.identifier)))}}),define(ye[95],De([1,0,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var v;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(v=e.UIKind||(e.UIKind={}));var b;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function y(T){const R=a.VSBuffer.alloc(1);switch(T){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function P(T,R){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=P;var w;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[24],De([1,0,5,2,3,27,153]),function(ie,e,a,v,b,M,y){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:v.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class w{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class T{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=T;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class S{constructor(t){this.dependency=t}}e.MissingExtensionDependency=S;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const _=[],p=[],k=[],U=[],V=o(this._allExtensions),x=o(t),D=(K,H)=>K.extensionLocation.toString()===H.extensionLocation.toString()||K.isBuiltin===H.isBuiltin||K.isUserBuiltin===H.isUserBuiltin||K.isUnderDevelopment===H.isUnderDevelopment;for(const K of this._allExtensions){const H=x.get(M.ExtensionIdentifier.toKey(K.identifier));if(!H){_.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}if(!D(K,H)){_.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of t){const H=V.get(M.ExtensionIdentifier.toKey(K.identifier));if(!H){p.push(K);continue}if(!D(H,K)){_.push(H.identifier),V.delete(M.ExtensionIdentifier.toKey(H.identifier));continue}}const L=u(this._myExtensions),B=u(c);for(const K of this._myExtensions)B.has(M.ExtensionIdentifier.toKey(K))||k.push(K);for(const K of c)L.has(M.ExtensionIdentifier.toKey(K))||U.push(K);const F={toRemove:_,toAdd:p,myToRemove:k,myToAdd:U};return this.delta(F),F}delta(t){const{toRemove:c,toAdd:_,myToRemove:p,myToAdd:k}=t,U=u(c),V=u(p);for(let x=0;x<this._allExtensions.length;x++)U.has(M.ExtensionIdentifier.toKey(this._allExtensions[x].identifier))&&(this._allExtensions.splice(x,1),x--);for(let x=0;x<this._myExtensions.length;x++)V.has(M.ExtensionIdentifier.toKey(this._myExtensions[x]))&&(this._myExtensions.splice(x,1),x--);for(const x of _)this._allExtensions.push(x);for(const x of k)this._myExtensions.push(x)}containsExtension(t){for(const c of this._myExtensions)if(M.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=f;class d{constructor(t){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(_=>t.call(c,_,_,this))}*entries(){for(const[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=d;function u(s){const t=new Set;for(const c of s)t.add(M.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=u;function o(s){const t=new Map;for(const c of s)t.set(M.ExtensionIdentifier.toKey(c.identifier),c);return t}function g(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=g;function A(s,t){if(!g(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=A;class l{constructor(t,c,_,p){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=_,this.activationReason=p}}e.ActivationTimes=l;class E{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=E,e.ExtensionHostLogFileName="exthost";var i;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function h(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function r(s,t){return{identifier:new M.ExtensionIdentifier((0,y.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=r;class n{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=n}),define(ye[180],De([1,0,11,27,24,15,14]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(u,o,g,A){this.startup=u,this.codeLoadingTime=o,this.activateCallTime=g,this.activateResolvedTime=A}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class w{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,o){return u===-1||o===-1?-1:o-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class T{constructor(u,o,g,A,l,E){this.activationFailed=u,this.activationFailedError=o,this.activationTimes=g,this.module=A,this.exports=l,this.subscriptions=E}}e.ActivatedExtension=T;class R extends T{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class S extends T{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class m extends T{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let I=class{constructor(u,o,g,A,l){this._logService=l,this._registry=u,this._resolvedExtensionsSet=new Set,o.forEach(E=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(E))),this._externalExtensionsMap=new Map,g.forEach(E=>this._externalExtensionsMap.set(v.ExtensionIdentifier.toKey(E),E)),this._host=A,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,o]of this._operations)o.dispose()}isActivated(u){const o=this._operations.get(v.ExtensionIdentifier.toKey(u));return Boolean(o&&o.value)}getActivatedExtension(u){const o=this._operations.get(v.ExtensionIdentifier.toKey(u));if(!o||!o.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return o.value}async activateByEvent(u,o){if(this._alreadyActivatedEvents[u])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(g.map(A=>({id:A.identifier,reason:{startup:o,extensionId:A.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,o){const g=this._registry.getExtensionDescription(u);if(!g)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:g.identifier,reason:o}])}async _activateExtensions(u){const o=u.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(o.map(g=>g.wait()))}_handleActivationRequest(u){if(this._operations.has(v.ExtensionIdentifier.toKey(u.id)))return this._operations.get(v.ExtensionIdentifier.toKey(u.id));if(this._externalExtensionsMap.has(v.ExtensionIdentifier.toKey(u.id)))return this._createAndSaveOperation(u,null,[],null);const o=this._registry.getExtensionDescription(u.id);if(!o){const l=new Error(`Cannot activate unknown extension '${u.id.value}'`),E=this._createAndSaveOperation(u,null,[],new m(l));return this._host.onExtensionActivationError(u.id,l,new b.MissingExtensionDependency(u.id.value)),E}const g=[],A=typeof o.extensionDependencies>"u"?[]:o.extensionDependencies;for(const l of A){if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(l)))continue;const E=this._operations.get(v.ExtensionIdentifier.toKey(l));if(E){g.push(E);continue}if(this._externalExtensionsMap.has(v.ExtensionIdentifier.toKey(l))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(v.ExtensionIdentifier.toKey(l)),reason:u.reason}));continue}const i=this._registry.getExtensionDescription(l);if(i){if(!i.main&&!i.browser)continue;g.push(this._handleActivationRequest({id:i.identifier,reason:u.reason}));continue}const h=o.displayName||o.identifier.value,r=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${l}'`),n=this._createAndSaveOperation(u,o.displayName,[],new m(r));return this._host.onExtensionActivationError(o.identifier,r,new b.MissingExtensionDependency(l)),n}return this._createAndSaveOperation(u,o.displayName,g,null)}_createAndSaveOperation(u,o,g,A){const l=new f(u.id,o,u.reason,g,A,this._host,this._logService);return this._operations.set(v.ExtensionIdentifier.toKey(u.id),l),l}};I=ze([$e(4,M.ILogService)],I),e.ExtensionsActivator=I;let f=class{constructor(u,o,g,A,l,E,i){this._id=u,this._displayName=o,this._reason=g,this._deps=A,this._value=l,this._host=E,this._logService=i,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const o=this._deps[u];if(o.value&&!o.value.activationFailed){this._deps.splice(u,1),u--;continue}if(o.value&&o.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${o.friendlyName}' failed to activate`);g.detail=o.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const o=new Error;if(u&&u.name&&(o.name=u.name),u&&u.message?o.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:o.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(o.stack=u.stack),this._value=new m(o),this._isDisposed&&a.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,o,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};f=ze([$e(6,M.ILogService)],f)}),define(ye[181],De([1,0,15,28,24]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends a.LogService{constructor(P,w){super(P.createLogger(w.logFile,{name:b.ExtensionHostLogFileName}))}};M=ze([$e(0,a.ILoggerService),$e(1,v.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(ye[182],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[183],De([1,0,143,11,29,79,82,30,27,182,150]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=P.Registry.as(y.Extensions.JSONContribution);class m{constructor(l,E,i){this._messageHandler=l,this._extension=E,this._extensionPointId=i}_msg(l,E){this._messageHandler({type:l,message:E,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(b.default.Error,l)}warn(l){this._msg(b.default.Warning,l)}info(l){this._msg(b.default.Info,l)}}e.ExtensionMessageCollector=m;class I{constructor(l,E){this.added=l,this.removed=E}static _toSet(l){const E=new Set;for(let i=0,h=l.length;i<h;i++)E.add(w.ExtensionIdentifier.toKey(l[i].description.identifier));return E}static compute(l,E){if(!l||!l.length)return new I(E,[]);if(!E||!E.length)return new I([],l);const i=this._toSet(l),h=this._toSet(E),r=E.filter(s=>!i.has(w.ExtensionIdentifier.toKey(s.description.identifier))),n=l.filter(s=>!h.has(w.ExtensionIdentifier.toKey(s.description.identifier)));return new I(r,n)}}e.ExtensionPointUserDelta=I;class f{constructor(l,E){this.name=l,this.defaultExtensionKind=E,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=I.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,v.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:a.localize(31,null)},{label:"onUri",body:"onUri",description:a.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(36,null)},{label:"onRenderer",description:a.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(39,null)},{label:"*",description:a.localize(40,null),body:"*"}]}},badges:{type:"array",description:a.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(42,null)},href:{type:"string",description:a.localize(43,null)},description:{type:"string",description:a.localize(44,null)}}}},markdown:{type:"string",description:a.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(49,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(50,null)},{body:["workspace"],description:a.localize(51,null)},{body:["ui","workspace"],description:a.localize(52,null)},{body:["workspace","ui"],description:a.localize(53,null)},{body:[],description:a.localize(54,null)}]},capabilities:{description:a.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(58,null),a.localize(59,null),a.localize(60,null)]},description:{type:"string",markdownDescription:a.localize(61,null)}}},untrustedWorkspaces:{description:a.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)]},restrictedConfigurations:{description:a.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(68,null)}}}}},sponsor:{description:a.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(71,null),type:"string"},"vscode:uninstall":{description:a.localize(72,null),type:"string"}}},icon:{type:"string",description:a.localize(73,null)}}};class o{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const E=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,E),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,S.registerSchema(u,e.schema),E}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=o;const g={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(g.ExtensionsRegistry,new o),e.ExtensionsRegistry=P.Registry.as(g.ExtensionsRegistry),S.registerSchema(u,e.schema),S.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(ye[184],De([1,0,140,10,26,183,38,5]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var T;(function(m){function I(f,d,u){if(!f)return;const o=v.isString(f.type)?f.type:void 0;if(!o||o.length===0){u.error(a.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const A of f.required)v.isString(A)&&g.push(A);return{extensionId:d.value,taskType:o,required:g,properties:f.properties?b.deepClone(f.properties):{},when:f.when?y.ContextKeyExpr.deserialize(f.when):void 0}}m.from=I})(T||(T={}));const R=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:w}});class S{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,f)=>{R.setHandler((d,u)=>{this._schema=void 0;try{for(const o of u.removed){const g=o.value;for(const A of g)this.taskTypes&&A.type&&this.taskTypes[A.type]&&delete this.taskTypes[A.type]}for(const o of u.added){const g=o.value;for(const A of g){const l=T.from(A,o.description.identifier,o.collector);l&&(this.taskTypes[l.taskType]=l)}}(u.removed.length>0||u.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){const I=[];for(const f of this.all()){const d={type:"object",additionalProperties:!1};f.required.length>0&&(d.required=f.required.slice(0)),f.properties!==void 0?d.properties=b.deepClone(f.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[f.taskType]},I.push(d)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=S,e.TaskDefinitionRegistry=new S}),define(ye[185],De([1,0,141,10,22,26,38,184]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var w;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function K(H){if(!H)return F.Strong;switch(H.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=K}(w=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function K(H){switch(H.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=K}(R=e.RevealKind||(e.RevealKind={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function K(H){switch(H.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=K}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function K(H){switch(H.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var I;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function K(O){switch(O.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=K;function H(O){switch(O){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=H}(f=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function K(H){return v.isString(H)?H:H.value}F.value=K})(d=e.CommandString||(e.CommandString={}));var u;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function K(O){return O===F.Clean._id||O===F.Build._id||O===F.Rebuild._id||O===F.Test._id}F.is=K;function H(O){if(O!==void 0)return v.isString(O)?K(O)?{_id:O,isDefault:!1}:void 0:O}F.from=H})(u=e.TaskGroup||(e.TaskGroup={}));var o;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(o=e.TaskScope||(e.TaskScope={}));var g;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function K(H){switch(H){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=K})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var A;(function(F){F.parallel="parallel",F.sequence="sequence"})(A=e.DependsOrder||(e.DependsOrder={}));var l;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var E;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(E=e.RunOptions||(e.RunOptions={}));class i{constructor(K,H,O,ee,ce,oe){this._label="",this._id=K,H&&(this._label=H),O&&(this.type=O),this.runOptions=ee,this.configurationProperties=ce,this._source=oe}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,H=!1){if(K===void 0)return!1;if(v.isString(K))return K===this._label||K===this.configurationProperties.identifier||H&&K===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class h extends i{constructor(K,H,O,ee,ce,oe,le,te){super(K,O,void 0,le,te,H),this.command={},this._source=H,this.hasDefinedMatchers=oe,ce&&(this.command=ce)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case f.Shell:H="shell";break;case f.Process:H="process";break;case f.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(K){return K instanceof h}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:H};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new h(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=h;class r extends i{constructor(K,H,O,ee,ce,oe,le){super(K,O,ee,oe,le,H),this._source=H,this.configures=ce}static is(K){return K instanceof r}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:H};return JSON.stringify(O)}}e.ConfiguringTask=r;class n extends i{constructor(K,H,O,ee,ce,oe,le,te,Ee){super(K,O,ee,te,Ee,H),this.defines=ce,this.hasDefinedMatchers=le,this.command=oe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof n}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new n(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=n;class s extends i{constructor(K,H,O,ee,ce,oe){super(K,O,ee,ce,oe,H),this._source=H}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new s(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=s;var t;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class _{constructor(K){this._order=new Map;for(let H=0;H<K.length;H++)this._order.set(K[H].uri.toString(),H)}compare(K,H){const O=K.getWorkspaceFolder(),ee=H.getWorkspaceFolder();if(O&&ee){let ce=this._order.get(O.uri.toString());ce=ce===void 0?0:ce+1;let oe=this._order.get(ee.uri.toString());return oe=oe===void 0?0:oe+1,ce===oe?K._label.localeCompare(H._label):ce-oe}else return!O&&ee?-1:O&&!ee?1:0}}e.TaskSorter=_;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(F){F.SingleRun="singleRun",F.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var U;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(U=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(F){function K(H,O,ee,ce,oe){if(O){const le={kind:H,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:O};return H==="start"?(le.terminalId=ee,le.resolvedVariables=ce):H==="processStarted"?le.processId=ee:H==="processEnded"&&(le.exitCode=ee),Object.freeze(le)}else return Object.freeze({kind:"changed"})}F.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var x;(function(F){function K(O){const ee=Object.keys(O).sort();let ce="";for(const oe of ee){let le=O[oe];le instanceof Object?le=K(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),ce+=oe+","+le+","}return ce}function H(O){const ce={_key:K(O),type:O.taskType};return Object.assign(ce,O),ce}F.create=H})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(F){function K(H,O){const ee=P.TaskDefinitionRegistry.get(H.type);if(ee===void 0){const te=M.deepClone(H);return delete te._key,x.create(te)}const ce=Object.create(null);ce.type=ee.taskType;const oe=new Set;ee.required.forEach(te=>oe.add(te));const le=ee.properties;for(const te of Object.keys(le)){const Ee=H[te];if(Ee!=null)ce[te]=Ee;else if(oe.has(te)){const be=le[te];if(be.default!==void 0)ce[te]=M.deepClone(be.default);else switch(be.type){case"boolean":ce[te]=!1;break;case"number":case"integer":ce[te]=0;break;case"string":ce[te]="";break;default:O.error(a.localize(2,null,JSON.stringify(H,void 0,0),te));return}}}return x.create(ce)}F.createTaskIdentifier=K})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[186],De([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class v{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,P)=>{this._actualOk=y,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,a.onUnexpectedError)(y))}then(y,P){return this._ensureActual().then(y,P)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=v;class b extends v{constructor(){super(),this._hasErr=!0,this._err=new a.CancellationError}}e.CanceledLazyPromise=b}),define(ye[40],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const v=[];function b(P){const w=new a(P);return v[w.nid]=w,w}e.createProxyIdentifier=b;function M(P){return v[P].sid}e.getStringIdentifierForProxy=M;class y{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=y}),define(ye[4],De([1,0,56,40]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var b;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(b=e.TextEditorRevealType||(e.TextEditorRevealType={}));var M;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(M=e.TabInputKind||(e.TabInputKind={}));var y;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(y=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var w;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(w=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(S=e.CandidatePortSource||(e.CandidatePortSource={}));class m{static mixin(g){return g._id=m._n++,g}}e.IdObject=m,m._n=0;var I;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(I=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function d(o){return o&&o.edits&&(0,a.revive)(o),o}e.reviveWorkspaceEditDto=d;var u;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(u=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry")}}),define(ye[67],De([1,0,3,15,4,13]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(w,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(b.MainContext.MainThreadTelemetry)}report(w,T,R){const S=this.getUsageKey(w,T);this._reportedUsages.has(S)||(this._reportedUsages.add(S),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:w}))}getUsageKey(w,T){return`${w}-${T.identifier.value}`}};y=ze([$e(0,M.IExtHostRpcService),$e(1,v.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,w,T){}})}),define(ye[187],De([1,0,5,4,6,27]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(v.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,T,R,S={}){const m=M.ExtensionIdentifier.toKey(w.identifier),I=this._inFlightRequests.get(m)||[],f=[...R].sort().join(" ");let d=I.find(u=>u.providerId===T&&u.scopes===f);if(d)return d.result;{const u=this._getSession(w,m,T,R,S);d={providerId:T,scopes:f,result:u},I.push(d),this._inFlightRequests.set(m,I);try{await u}finally{const o=I.findIndex(g=>g.providerId===T&&g.scopes===f);o>-1&&(I.splice(o),this._inFlightRequests.set(m,I))}return u}}async _getSession(w,T,R,S,m={}){await this._proxy.$ensureProvider(R);const I=w.displayName||w.name;return this._proxy.$getSession(R,S,T,I,m)}async removeSession(w,T){const R=this._authenticationProviders.get(w);return R?R.provider.removeSession(T):this._proxy.$removeSession(w,T)}registerAuthenticationProvider(w,T,R,S){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:T,provider:R,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===w)||this._providers.push({id:w,label:T});const m=R.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(w,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,T,S?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(w);const I=this._providers.findIndex(f=>f.id===w);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,T){const R=this._authenticationProviders.get(w);if(R)return Promise.resolve(R.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,T){const R=this._authenticationProviders.get(w);if(R)return Promise.resolve(R.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,T){const R=this._authenticationProviders.get(w);if(R)return Promise.resolve(R.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,T){return this._onDidChangeSessions.fire({provider:{id:w,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ye[188],De([1,0,4,13,8,24]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(w,T){this._proxy=w.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>T.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,T){const R=(0,M.isProposedApiEnabled)(T,"snippetWorkspaceEdit"),S=b.WorkspaceEdit.from(w,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=ze([$e(0,v.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(ye[189],De([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class v{constructor(M){const y=M.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=v});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[36],De([1,0,10,6,8,26,4,16,15,56,49,242,2,7,3,13,93,23,40,43]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A){"use strict";var l,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(c,_){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,E.set(this,void 0),Ye(this,l,c.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=_,Ye(this,E,c.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new h(this,p=>{const k=this._apiCommands.get(p);return k?.result===n.Void?k:void 0},_),this._argumentProcessors=[{processArgument(p){return(0,T.revive)(p)}},{processArgument(p){return(0,M.cloneAndChange)(p,function(k){if(R.Range.isIRange(k))return b.Range.to(k);if(S.Position.isIPosition(k))return b.Position.to(k);if(R.Range.isIRange(k.range)&&m.URI.isUri(k.uri))return b.location.to(k);if(k instanceof o.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const _=this.registerCommand(!1,c.id,async(...p)=>{const k=c.args.map((V,x)=>{if(!V.validate(p[x]))throw new Error(`Invalid argument '${V.name}' when running '${c.id}', received: ${p[x]}`);return V.convert(p[x])}),U=await this.executeCommand(c.internalId,...k);return c.result.convert(U,p,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new v.Disposable(()=>{_.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,_,p,k,U,V){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:p,thisArg:k,description:U,extension:V}),c&&Oe(this,l,"f").$registerCommand(_),new v.Disposable(()=>{this._commands.delete(_)&&c&&Oe(this,l,"f").$unregisterCommand(_)})}executeCommand(c,..._){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,_,!0)}async _doExecuteCommand(c,_,p){if(this._commands.has(c))return Oe(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,_,!1);{let k=!1;const U=(0,M.cloneAndChange)(_,function(V){if(V instanceof v.Position)return b.Position.from(V);if(V instanceof v.Range)return b.Range.from(V);if(V instanceof v.Location)return b.location.from(V);if(v.NotebookRange.isNotebookRange(V))return b.NotebookRange.from(V);if(V instanceof ArrayBuffer)return k=!0,o.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return k=!0,o.VSBuffer.wrap(V);if(V instanceof o.VSBuffer)return k=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,l,"f").$executeCommand(c,k?new g.SerializableObjectWithBuffers(U):U,p);return(0,T.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(c,_,!1);throw V}}}async _executeContributedCommand(c,_,p){const k=this._commands.get(c);if(!k)throw new Error("Unknown command");this._reportTelemetry(k,c);const{callback:U,thisArg:V,description:x}=k;if(x)for(let D=0;D<x.args.length;D++)try{(0,a.validateConstraint)(_[D],x.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${x.args[D].name}' - ${x.args[D].description}`)}try{return await U.apply(V,_)}catch(D){if(c===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(..._);L&&(c=L.command)}throw this._logService.error(D,c,k.extension?.identifier),p?new class extends Error{constructor(){super((0,A.toErrorMessage)(D)),this.id=c,this.source=k.extension?.displayName??k.extension?.name}}:D}}_reportTelemetry(c,_){!c.extension||c.extension.isBuiltin||Oe(this,E,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:_})}$executeContributedCommand(c,..._){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(_=_.map(p=>this._argumentProcessors.reduce((k,U)=>U.processArgument(k),p)),this._executeContributedCommand(c,_,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Oe(this,l,"f").$getCommands().then(_=>(c&&(_=_.filter(p=>p[0]!=="_")),_))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[_,p]of this._commands){const{description:k}=p;k&&(c[_]=k)}return Promise.resolve(c)}};l=new WeakMap,E=new WeakMap,i=ze([$e(0,d.IExtHostRpcService),$e(1,w.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class h{constructor(c,_,p){this._commands=c,this._lookupApiCommand=_,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,_){if(!c)return;const p={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return p;const k=this._lookupApiCommand(c.command);if(k)p.id=k.internalId,p.arguments=k.args.map((U,V)=>U.convert(c.arguments&&c.arguments[V]));else if((0,P.isNonEmptyArray)(c.arguments)){const U=++this._cachIdPool;this._cache.set(U,c),_.add((0,I.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),p.$ident=U,p.id=this.delegatingCommandId,p.arguments=[U],this._logService.trace("CommandsConverter#CREATE",c.command,U)}return p}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const _=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class r{constructor(c,_,p,k){this.name=c,this.description=_,this.validate=p,this.convert=k}optional(){return new r(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,_){return new r(c??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>v.Position.isPosition(t),b.Position.from),r.Range=new r("range","A range in a text document",t=>v.Range.isRange(t),b.Range.from),r.Selection=new r("selection","A selection in a text document",t=>v.Selection.isSelection(t),b.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof v.CallHierarchyItem,b.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof v.TypeHierarchyItem,b.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof u.TestItemImpl,b.TestItem.from);class n{constructor(c,_){this.description=c,this.convert=_}}e.ApiCommandResult=n,n.Void=new n("no result",t=>t);class s{constructor(c,_,p,k,U){this.id=c,this.internalId=_,this.description=p,this.args=k,this.result=U}}e.ApiCommand=s}),define(ye[190],De([1,0,2,8,6,66,36,16,77,81,12]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(v.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,u)=>{if((0,P.isFalsyOrEmpty)(d))return;class o extends b.SymbolInformation{static to(A){const l=new o(A.name,v.SymbolKind.to(A.kind),A.containerName||"",new b.Location(u[0],v.Range.to(A.range)));return l.detail=A.detail,l.range=l.location.range,l.selectionRange=v.Range.to(A.selectionRange),l.children=A.children?A.children.map(o.to):[],l}}return d.map(o.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(v.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(v.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new y.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(v.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(v.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(v.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(u=>b.Position.isPosition(u)),d=>d.map(v.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(u=>{let o;for(const g of u.reverse())o=new b.SelectionRange(v.Range.to(g),o);return o}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(v.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(v.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(v.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(v.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:v.Range.to(d.range),placeholder:d.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return v.WorkspaceEdit.to(d)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(v.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new b.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const u=(0,w.decodeSemanticTokensDto)(d);if(u.type==="full")return new b.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new b.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const u=(0,w.decodeSemanticTokensDto)(d);if(u.type==="full")return new b.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,u,o)=>{if(!d)return new b.CompletionList([]);const g=d.suggestions.map(A=>v.CompletionItem.to(A,o));return new b.CompletionList(g,d.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return v.SignatureHelp.to(d)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,u,o)=>I(g=>new b.CodeLens(v.Range.to(g.range),g.command&&o.fromInternal(g.command)))(d))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>b.Range.isRange(d),d=>b.Selection.isSelection(d)?v.Selection.from(d):v.Range.from(d)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,u,o)=>I(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(g.command)}else{const A=new b.CodeAction(g.title,g.kind?new b.CodeActionKind(g.kind):void 0);return g.edit&&(A.edit=v.WorkspaceEdit.to(g.edit)),g.command&&(A.command=o.fromInternal(g.command)),A.isPreferred=g.isPreferred,A}})(d))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(u=>new b.ColorInformation(v.Range.to(u.range),v.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",d=>d instanceof b.Color,v.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:v.Range.from(d.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(v.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,u,o)=>d.map(v.InlayHint.to.bind(void 0,o)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(u=>v.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(v.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>a.URI.isUri(d)||typeof d=="string"&&(0,T.matchesSomeScheme)(d,R.Schemas.http,R.Schemas.https),d=>d),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[v.ViewColumn.from(d),void 0]:[v.ViewColumn.from(d.viewColumn),v.TextEditorOpenOptions.from(d)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[v.ViewColumn.from(d),void 0]:[v.ViewColumn.from(d.viewColumn),v.TextEditorOpenOptions.from(d)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[v.ViewColumn.from(d.viewColumn),v.TextEditorOpenOptions.from(d)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(v.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(v.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(v.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class m{static register(u){S.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=m;function I(d){return u=>{if(Array.isArray(u))return u.map(d)}}function f(d){if(!Array.isArray(d))return;const u=[];for(const o of d)M.isLocationLink(o)?u.push(v.DefinitionLink.to(o)):u.push(v.location.to(o));return u}}),define(ye[191],De([1,0,14,55,5,7,2,66,27,8,6,24,4]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(f,d,u){const o=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.commentThreadHandle);return _?_.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);return _?{thread:_.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const p=t.commentUniqueId,k=_.getCommentByUniqueId(p);return k||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const p=t.text,k=t.commentUniqueId,U=_.getCommentByUniqueId(k);return U?(typeof U.body=="string"?U.body=p:U.body.value=p,U):t}return t}})}createCommentController(t,c,_){const p=g.handlePool++,k=new l(t,p,c,_);this._commentControllers.set(k.handle,k);const U=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(t.identifier))||[];return U.push(k),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(t.identifier),U),k.value}$createCommentThreadTemplate(t,c,_){const p=this._commentControllers.get(t);!p||p.$createCommentThreadTemplate(c,_)}async $updateCommentThreadTemplate(t,c,_){const p=this._commentControllers.get(t);!p||p.$updateCommentThreadTemplate(c,_)}$deleteCommentThread(t,c){this._commentControllers.get(t)?.$deleteCommentThread(c)}$provideCommentingRanges(t,c,_){const p=this._commentControllers.get(t);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const k=u.getDocument(y.URI.revive(c));return(0,a.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(k,_)).then(U=>U?U.map(V=>T.Range.from(V)):void 0)}$toggleReaction(t,c,_,p,k){const U=this._commentControllers.get(t);return!U||!U.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const V=U.getCommentThread(c);if(V){const x=V.getCommentByUniqueId(p.uniqueIdInThread);if(U!==void 0&&x&&U.reactionHandler)return U.reactionHandler(x,h(k))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class A{constructor(t,c,_,p,k,U,V,x){this._commentControllerHandle=c,this._id=_,this._uri=p,this._range=k,this._comments=U,this.extensionDescription=V,this._isTemplate=x,this.handle=A._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),o.$createCommentThread(c,this.handle,this._id,this._uri,T.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=U,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(c,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(L){D.range=L},get comments(){return D.comments},set comments(L){D.comments=L},get collapsibleState(){return D.collapsibleState},set collapsibleState(L){D.collapsibleState=L},get canReply(){return D.canReply},set canReply(L){D.canReply=L},get contextValue(){return D.contextValue},set contextValue(L){D.contextValue=L},get label(){return D.label},set label(L){D.label=L},get state(){return D.state},set state(L){D.state=L},dispose:()=>{D.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const t=_=>Object.prototype.hasOwnProperty.call(this.modifications,_),c={};t("range")&&(c.range=T.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(_=>E(this,_,this._commentsMap))),t("collapsibleState")&&(c.collapseState=r(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=n(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(const c of this._commentsMap){const _=c[0],p=c[1];if(t===p)return _}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}A._handlePool=0,ze([(0,v.debounce)(100)],A.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,c,_,p){this._extension=t,this._handle=c,this._id=_,this._label=p,this._threads=new Map,o.$registerCommentController(this.handle,_,p);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(U){k.options=U},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(U){k.commentingRangeProvider=U},get reactionHandler(){return k.reactionHandler},set reactionHandler(U){k.reactionHandler=U},createCommentThread(U,V,x){return k.createCommentThread(U,V,x).value},dispose:()=>{k.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,_,p){if(typeof t=="string"){const k=new A(this.id,this.handle,t,c,_,p,this._extension,!1);return this._threads.set(k.handle,k),k}else{const k=new A(this.id,this.handle,void 0,t,c,_,this._extension,!1);return this._threads.set(k.handle,k),k}}$createCommentThreadTemplate(t,c){const _=new A(this.id,this.handle,void 0,y.URI.revive(t),T.Range.to(c),[],this._extension,!0);return _.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(_.handle,_),_}$updateCommentThreadTemplate(t,c){const _=this._threads.get(t);_&&(_.range=T.Range.to(c))}$deleteCommentThread(t){this._threads.get(t)?.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function E(s,t,c){let _=c.get(t);_||(_=++s.commentHandle,c.set(t,_));const p=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:_,body:typeof t.body=="string"?t.body:T.MarkdownString.from(t.body),userName:t.author.name,userIconPath:p,label:t.label,commentReactions:t.reactions?t.reactions.map(k=>i(k)):void 0,timestamp:t.timestamp?.toJSON()}}function i(s){return{label:s.label,iconPath:s.iconPath?T.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function h(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?y.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function n(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new g}e.createExtHostComments=I}),define(ye[192],De([1,0,26,4,28,13]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(R,S){this._mainThreadConsole=R.getProxy(v.MainContext.MainThreadConsole),this._includeStack=S.consoleForward.includeStack,this._logNative=S.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,S){const m=this,I=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m._handleConsoleCall(R,S,I,arguments)}})}_handleConsoleCall(R,S,m,I){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:S,arguments:w(I,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,m,I)}};y=ze([$e(0,M.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const P=1e5;function w(T,R){const S=[];if(T.length)for(let m=0;m<T.length;m++){let I=T[m];if(typeof I>"u")I="undefined";else if(I instanceof Error){const f=I;f.stack?I=f.stack:I=f.toString()}S.push(I)}if(R){const m=new Error().stack;m&&S.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,a.safeStringify)(S);return m.length>P?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ye[96],De([1,0,2,4,6,3,13,15,16,9,19]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class Ii{constructor(I,f){this._logService=f,this._provider=new Map,this._proxy=I.getProxy(v.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,f){const d=Ii._handlePool++;this._provider.set(d,{provider:I,extensionId:f}),this._proxy.$registerDecorationProvider(d,f.value);const u=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(o=>{if(!o){this._proxy.$onDidChange(d,null);return}const g=(0,w.asArray)(o);if(g.length<=Ii._maxEventSize){this._proxy.$onDidChange(d,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,g.length);const A=g.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),l=(0,w.groupBy)(A,(i,h)=>i.rank-h.rank||(0,T.compare)(i.uri.path,h.uri.path)),E=[];e:for(const i of l){let h;for(const r of i){const n=(0,R.dirname)(r.uri.path);if(h!==n&&(h=n,E.push(r.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(d,E)});return new b.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(I,f,d){if(!this._provider.has(I))return Object.create(null);const u=Object.create(null),{provider:o,extensionId:g}=this._provider.get(I);return await Promise.all(f.map(async A=>{try{const{uri:l,id:E}=A,i=await Promise.resolve(o.provideFileDecoration(a.URI.revive(l),d));if(!i)return;try{b.FileDecoration.validate(i),u[E]=[i.propagate,i.tooltip,i.badge,i.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${g.value}': ${h}`)}}catch(l){this._logService.error(l)}})),u}};S._handlePool=0,S._maxEventSize=250,S=ze([$e(0,y.IExtHostRpcService),$e(1,P.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[193],De([1,0,130,80,2,4,6,8,5,15,25,35]),function(ie,e,a,v,b,M,y,P,w,T,R,S){"use strict";var m,I,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(g,A,l,E,i,h){this._name=g,this._owner=A,this._maxDiagnosticsPerFile=l,m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Ye(this,f,new R.ResourceMap(r=>E.getComparisonKey(r)),"f"),Ye(this,m,i,"f"),Ye(this,I,h,"f")}dispose(){this._isDisposed||(Oe(this,I,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,A){if(!g){this.clear();return}this._checkDisposed();let l=[];if(b.URI.isUri(g)){if(!A){this.delete(g);return}Oe(this,f,"f").set(g,A.slice()),l=[g]}else if(Array.isArray(g)){l=[];let i;g=[...g].sort(d._compareIndexedTuplesByUri);for(const h of g){const[r,n]=h;if((!i||r.toString()!==i.toString())&&(i&&Oe(this,f,"f").get(i).length===0&&Oe(this,f,"f").delete(i),i=r,l.push(r),Oe(this,f,"f").set(r,[])),n)Oe(this,f,"f").get(r)?.push(...n);else{const s=Oe(this,f,"f").get(r);s&&(s.length=0)}}}if(Oe(this,I,"f").fire(l),!Oe(this,m,"f"))return;const E=[];for(const i of l){let h=[];const r=Oe(this,f,"f").get(i);if(r)if(r.length>this._maxDiagnosticsPerFile){h=[];const n=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const t of r)if(t.severity===n[s]&&h.push(P.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;h.push({severity:v.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(n=>P.Diagnostic.from(n));E.push([i,h])}Oe(this,m,"f").$changeMany(this._owner,E)}delete(g){this._checkDisposed(),Oe(this,I,"f").fire([g]),Oe(this,f,"f").delete(g),Oe(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,I,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(g,A){this._checkDisposed();for(const[l,E]of this)g.call(A,l,E,this)}*[(m=new WeakMap,I=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,f,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const A=Oe(this,f,"f").get(g);return Array.isArray(A)?Object.freeze(A.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,A){return g[0].toString()<A[0].toString()?-1:g[0].toString()>A[0].toString()?1:0}}e.DiagnosticCollection=d;let u=class fi{constructor(g,A,l){this._logService=A,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}static _mapper(g){const A=new R.ResourceMap;for(const l of g)A.set(l,l);return{uris:Object.freeze(Array.from(A.values()))}}createDiagnosticCollection(g,A){const{_collections:l,_proxy:E,_onDidChangeDiagnostics:i,_logService:h,_fileSystemInfoService:r}=this,n=new class{$changeMany(c,_){E.$changeMany(c,_),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,c,_.length===0?"CLEARING":_)}$clear(c){E.$clear(c),h.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,c)}dispose(){E.dispose()}};let s;if(!A)A="_generated_diagnostic_collection_name_#"+fi._idPool++,s=A;else if(!l.has(A))s=A;else{this._logService.warn(`DiagnosticCollection with name '${A}' does already exist.`);do s=A+fi._idPool++;while(l.has(s))}return new class extends d{constructor(){super(A,s,fi._maxDiagnosticsPerFile,r.extUri,n,i),l.set(s,this)}dispose(){super.dispose(),l.delete(s)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const A=new Map,l=[];for(const E of this._collections.values())E.forEach((i,h)=>{let r=A.get(i.toString());typeof r>"u"&&(r=l.length,A.set(i.toString(),r),l.push([i,[]])),l[r][1]=l[r][1].concat(...h)});return l}}_getDiagnostics(g){let A=[];for(const l of this._collections.values())l.has(g)&&(A=A.concat(l.get(g)));return A}$acceptMarkersChange(g){if(!this._mirrorCollection){const A="_generated_mirror",l=new d(A,A,fi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(A,l),this._mirrorCollection=l}for(const[A,l]of g)this._mirrorCollection.set(b.URI.revive(A),l.map(P.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=ze([$e(1,T.ILogService),$e(2,S.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(ye[194],De([1,0,2,4]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(y){this._proxy=y.getProxy(v.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(w=>a.URI.revive(w)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?a.URI.revive(P):void 0)}}e.ExtHostDialogs=b}),define(ye[195],De([1,0,11,2,6,4,12,20,9]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(S,m,I){this._documentsAndEditors=m,this._logService=I,this._documentContentProviders=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,m){if(Object.keys(y.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const I=T._handlePool++;this._documentContentProviders.set(I,m),this._proxy.$registerTextContentProvider(I,S);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(d=>{if(d.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(I,d).then(u=>{if(!u&&typeof u!="string")return;const o=this._documentsAndEditors.getDocument(d);if(!o)return;const g=(0,w.splitLines)(u);if(!o.equalLines(g))return this._proxy.$onVirtualDocumentChange(d,u)},a.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,m){const I=this._documentContentProviders.get(S);return I?Promise.resolve(I.provideTextDocumentContent(v.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ye[196],De([1,0,5,7,2,4,87,8,10,26,6]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(I,f){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new v.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const u of d)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const u of d)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const f=this._documentsAndEditors.getDocument(I);if(f)return f}getDocument(I){const f=this.getDocumentData(I);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return f.document}ensureDocumentData(I){const f=this._documentsAndEditors.getDocument(I);if(f)return Promise.resolve(f);let d=this._documentLoader.get(I.toString());return d||(d=this._proxy.$tryOpenDocument(I).then(u=>{this._documentLoader.delete(I.toString());const o=b.URI.revive(u);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(o))},u=>(this._documentLoader.delete(I.toString()),Promise.reject(u))),this._documentLoader.set(I.toString(),d)),d}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(f=>b.URI.revive(f))}$acceptModelLanguageChanged(I,f){const d=b.URI.revive(I),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(f),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(I){const f=b.URI.revive(I),d=this._documentsAndEditors.getDocument(f);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(I,f){const d=b.URI.revive(I),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(f),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,f,d){const u=b.URI.revive(I),o=this._documentsAndEditors.getDocument(u);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),o.onEvents(f);let g;f.isUndoing?g=R.TextDocumentChangeReason.Undo:f.isRedoing&&(g=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:o.document,contentChanges:f.changes.map(A=>({range:P.Range.to(A.range),rangeOffset:A.rangeOffset,rangeLength:A.rangeLength,text:A.text})),reason:g}))}setWordDefinitionFor(I,f){(0,y.setWordDefinitionFor)(I,f)}}e.ExtHostDocuments=S}),define(ye[50],De([1,0,44,5,7,2,3,4,87,13,94,8,15,25,12,167,197]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(l,E){this._extHostRpc=l,this._logService=E,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new v.Emitter,this._onDidRemoveDocuments=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const E=[],i=[],h=[];if(l.removedDocuments)for(const r of l.removedDocuments){const n=M.URI.revive(r),s=this._documents.get(n);s?.unref()&&(this._documents.delete(n),E.push(s.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const n=M.URI.revive(r.uri);let s=this._documents.get(n);if(s&&n.scheme!==f.Schemas.vscodeNotebookCell&&n.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);s||(s=new o(new w.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(n,s),i.push(s.value)),s.ref()}if(l.removedEditors)for(const r of l.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&h.push(n)}if(l.addedEditors)for(const r of l.addedEditors){const n=M.URI.revive(r.documentUri);a.ok(this._documents.has(n),`document '${n}' does not exist`),a.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const s=this._documents.get(n).value,t=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>s.document),r.selections.map(S.Selection.to),r.options,r.visibleRanges.map(c=>S.Range.to(c)),typeof r.editorPosition=="number"?S.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}l.newActiveEditor!==void 0&&(a.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,b.dispose)(E),(0,b.dispose)(h),l.removedDocuments&&this._onDidRemoveDocuments.fire(E),l.addedDocuments&&this._onDidAddDocuments.fire(i),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const E=this._editors.get(this._activeEditorId);return l?E:E?.value}allEditors(){return[...this._editors.values()]}};g=ze([$e(0,T.IExtHostRpcService),$e(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[51],De([1,0,8,4,2,5,3,6,13,10,72]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class S{constructor(u,o,g){this._activeTabIdGetter=g,this._parentGroup=o,this.acceptDtoUpdate(u)}get apiObject(){if(!this._apiObject){const u=this,o={get isActive(){return u._dto.id===u._activeTabIdGetter()},get label(){return u._dto.label},get input(){return u._input},get isDirty(){return u._dto.isDirty},get isPinned(){return u._dto.isPinned},get isPreview(){return u._dto.isPreview},get group(){return u._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(u){this._dto=u,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(u,o){this._tabs=[],this._activeTabId="",this._dto=u,this._activeGroupIdGetter=o;for(const g of u.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new S(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const u=this,o={get isActive(){return u._dto.groupId===u._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(u._dto.viewColumn)},get activeTab(){return u._tabs.find(g=>g.tabId===u._activeTabId)?.apiObject},get tabs(){return Object.freeze(u._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(u){this._dto=u}acceptTabOperation(u){if(u.kind===0){const g=new S(u.tabDto,this,()=>this.activeTabId());return this._tabs.splice(u.index,0,g),u.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(u.kind===1){const g=this._tabs.splice(u.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(u.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this._tabs.splice(u.index,0,g),g}const o=this._tabs.find(g=>g.tabId===u.tabDto.id);if(!o)throw new Error("INVALID tab");return u.tabDto.isActive?this._activeTabId=u.tabDto.id:this._activeTabId===u.tabDto.id&&!u.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(u.tabDto),o}activeTabId(){return this._activeTabId}}let I=class{constructor(u){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=u.getProxy(v.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const u=this,o={onDidChangeTabGroups:u._onDidChangeTabGroups.event,onDidChangeTabs:u._onDidChangeTabs.event,get all(){return Object.freeze(u._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=u._activeGroupId;return(0,T.assertIsDefined)(u._extHostTabGroups.find(l=>l.groupId===g)?.apiObject)},close:async(g,A)=>{const l=Array.isArray(g)?g:[g];return l.length?f(l[0])?this._closeGroups(l,A):this._closeTabs(l,A):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(u){const o=new Set(this._extHostTabGroups.map(r=>r.groupId)),g=new Set(u.map(r=>r.groupId)),A=(0,R.diffSets)(o,g),l=this._extHostTabGroups.filter(r=>A.removed.includes(r.groupId)).map(r=>r.apiObject),E=[],i=[];this._extHostTabGroups=u.map(r=>{const n=new m(r,()=>this._activeGroupId);return A.added.includes(n.groupId)?E.push(n.apiObject):i.push(n.apiObject),n});const h=(0,T.assertIsDefined)(u.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:E,closed:l,changed:i}))}$acceptTabGroupUpdate(u){const o=this._extHostTabGroups.find(g=>g.groupId===u.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(u),u.isActive&&(this._activeGroupId=u.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const o=this._extHostTabGroups.find(A=>A.groupId===u.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const g=o.acceptTabOperation(u);switch(u.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(u){for(const o of this._extHostTabGroups)for(const g of o.tabs)if(g.apiObject===u)return g}_findExtHostTabGroupFromApi(u){return this._extHostTabGroups.find(o=>o.apiObject===u)}async _closeTabs(u,o){const g=[];for(const A of u){const l=this._findExtHostTabFromApi(A);if(!l)throw new Error("Tab close: Invalid tab not found!");g.push(l.tabId)}return this._proxy.$closeTab(g,o)}async _closeGroups(u,o){const g=[];for(const A of u){const l=this._findExtHostTabGroupFromApi(A);if(!l)throw new Error("Group close: Invalid group not found!");g.push(l.groupId)}return this._proxy.$closeGroup(g,o)}};I=ze([$e(0,w.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function f(d){return d.tabs!==void 0}}),define(ye[198],De([1,0,2,4,7,6,8,243,9,23,24]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const d=this._schemes.indexOf(f);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),d=[];let u,o,g=14,A=14;for(const l of f){let E=u?(0,w.commonPrefixLength)(u,l):0;for(E===0?o=1:o=A;E<l.length;E++)E+1===l.length?(g=A,A=9):A+=1,d.push([o,l.toUpperCase().charCodeAt(E),A]),d.push([o,l.toLowerCase().charCodeAt(E),A]),o=A;u=l,A=g}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new P.StateMachine(d)}}provideDocumentLinks(f){this._initStateMachine();const d=[],u=P.LinkComputer.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const o of u){const g=y.DocumentLink.to(o);g.target&&d.push(g)}return d}}class m{constructor(f,d){this._extHostLanguageFeatures=d,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(v.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,d,u,o={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(g,u);let A=2;o.isCaseSensitive&&(A+=1024),o.isReadonly&&(A+=2048),typeof u.copy=="function"&&(A+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,R.checkProposedApiEnabled)(f,"fsChunks"),A+=4),this._proxy.$registerFileSystemProvider(g,d,A).catch(E=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${d}`),console.error(E)});const l=u.onDidChangeFile(E=>{const i=[];for(const h of E){const{uri:r,type:n}=h;if(r.scheme!==d)continue;let s;switch(n){case M.FileChangeType.Changed:s=0;break;case M.FileChangeType.Created:s=1;break;case M.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:s})}this._proxy.$onFileSystemChange(g,i)});return(0,b.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:d,ctime:u,mtime:o,size:g,permissions:A}=f;return{type:d,ctime:u,mtime:o,size:g,permissions:A}}$stat(f,d){return Promise.resolve(this._getFsProvider(f).stat(a.URI.revive(d))).then(u=>m._asIStat(u))}$readdir(f,d){return Promise.resolve(this._getFsProvider(f).readDirectory(a.URI.revive(d)))}$readFile(f,d){return Promise.resolve(this._getFsProvider(f).readFile(a.URI.revive(d))).then(u=>T.VSBuffer.wrap(u))}$writeFile(f,d,u,o){return Promise.resolve(this._getFsProvider(f).writeFile(a.URI.revive(d),u.buffer,o))}$delete(f,d,u){return Promise.resolve(this._getFsProvider(f).delete(a.URI.revive(d),u))}$rename(f,d,u,o){return Promise.resolve(this._getFsProvider(f).rename(a.URI.revive(d),a.URI.revive(u),o))}$copy(f,d,u,o){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(a.URI.revive(d),a.URI.revive(u),o))}$mkdir(f,d){return Promise.resolve(this._getFsProvider(f).createDirectory(a.URI.revive(d)))}$watch(f,d,u,o){const g=this._getFsProvider(f).watch(a.URI.revive(u),o);this._watches.set(d,g)}$unwatch(f,d){const u=this._watches.get(d);u&&(u.dispose(),this._watches.delete(d))}$open(f,d,u){const o=this._getFsProvider(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(a.URI.revive(d),u))}$close(f,d){const u=this._getFsProvider(f);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(d))}$read(f,d,u,o){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const A=T.VSBuffer.alloc(o);return Promise.resolve(g.read(d,u,A.buffer,0,o)).then(l=>A.slice(0,l))}$write(f,d,u,o){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(d,u,o.buffer,0,o.byteLength))}_getFsProvider(f){const d=this._fsProvider.get(f);if(!d){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return d}}e.ExtHostFileSystem=m}),define(ye[52],De([1,0,4,39,6,23,3,13,35,7]),function(ie,e,a,v,b,M,y,P,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Xt{constructor(m,I){this._fileSystemProvider=new Map,this._proxy=m.getProxy(a.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(d){try{const u=f._fileSystemProvider.get(d.scheme);if(!u)return await f._proxy.$stat(d);await f._proxy.$ensureActivation(d.scheme);const o=await u.stat(d);return{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions}}catch(u){Xt._handleError(u)}},async readDirectory(d){try{const u=f._fileSystemProvider.get(d.scheme);return u?(await f._proxy.$ensureActivation(d.scheme),(await u.readDirectory(d)).slice()):await f._proxy.$readdir(d)}catch(u){return Xt._handleError(u)}},async createDirectory(d){try{return await f._proxy.$mkdir(d)}catch(u){return Xt._handleError(u)}},async readFile(d){try{const u=f._fileSystemProvider.get(d.scheme);return u?(await f._proxy.$ensureActivation(d.scheme),(await u.readFile(d)).slice()):(await f._proxy.$readFile(d)).buffer}catch(u){return Xt._handleError(u)}},async writeFile(d,u){try{return await f._proxy.$writeFile(d,M.VSBuffer.wrap(u))}catch(o){return Xt._handleError(o)}},async delete(d,u){try{const o=f._fileSystemProvider.get(d.scheme);return o?(await f._proxy.$ensureActivation(d.scheme),await o.delete(d,{recursive:!1,...u})):await f._proxy.$delete(d,{recursive:!1,useTrash:!1,...u})}catch(o){return Xt._handleError(o)}},async rename(d,u,o){try{return await f._proxy.$rename(d,u,{overwrite:!1,...o})}catch(g){return Xt._handleError(g)}},async copy(d,u,o){try{return await f._proxy.$copy(d,u,{overwrite:!1,...o})}catch(g){return Xt._handleError(g)}},isWritableFileSystem(d){const u=I.getCapabilities(d);if(typeof u=="number")return!(u&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case v.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case v.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case v.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case v.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case v.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case v.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,I){return this._fileSystemProvider.set(m,I),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(m))}};R=ze([$e(0,P.IExtHostRpcService),$e(1,w.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[199],De([1,0,5,34,2,4,8,6,24]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(m,I,f,d,u,o,g,A){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const l=this.ensureWatching(m,f,u);this._config=0,o&&(this._config+=1),g&&(this._config+=2),A&&(this._config+=4);const E=(0,v.parse)(u),i=typeof u=="string",h=d(r=>{if(!o)for(const n of r.created){const s=b.URI.revive(n);E(s.fsPath)&&(!i||I.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(const n of r.changed){const s=b.URI.revive(n);E(s.fsPath)&&(!i||I.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!A)for(const n of r.deleted){const s=b.URI.revive(n);E(s.fsPath)&&(!i||I.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,h)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,I,f){const d=P.Disposable.from();if(typeof f=="string")return d;const u=m.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(f.pattern.includes(v.GLOBSTAR)||f.pattern.includes(v.GLOB_SPLIT))&&(o=!0);const g=Math.random();return u.$watch(I.identifier.value,g,f.baseUri,{recursive:o,excludes:[]}),P.Disposable.from({dispose:()=>u.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(m,I,f){this._mainContext=m,this._logService=I,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,I,f,d,u,o){return new T(this._mainContext,m,I,this._onFileSystemEvent.event,y.GlobPattern.from(f),d,u,o)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,I){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(f=>({oldUri:b.URI.revive(f.source),newUri:b.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(f=>b.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:I.map(f=>b.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,I){return(f,d,u)=>{const o=function(A){f.call(d,A)};return o.extension=m,I.event(o,void 0,u)}}async $onWillRunFileOperation(m,I,f,d){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(u=>({oldUri:b.URI.revive(u.source),newUri:b.URI.revive(u.target)}))},f,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(u=>b.URI.revive(u.target))},f,d);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(u=>b.URI.revive(u.target))},f,d)}}async _fireWillEvent(m,I,f,d){const u=new Set,o=[];if(await m.fireAsync(I,d,async(A,l)=>{const E=Date.now(),i=await Promise.resolve(A);i instanceof P.WorkspaceEdit&&(o.push([l.extension,i]),u.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-E>f&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),d.isCancellationRequested||o.length===0)return;const g={edits:[]};for(const[A,l]of o){const{edits:E}=y.WorkspaceEdit.from(l,{getTextDocumentVersion:i=>this._extHostDocumentsAndEditors.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}},(0,w.isProposedApiEnabled)(A,"snippetWorkspaceEdit"));g.edits=g.edits.concat(E)}return{edit:g,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=R}),define(ye[200],De([1,0,2,36]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(y,P,w,T,R){this._extHostNotebooks=P,this._textDocumentsAndEditors=w,this._commands=T;const S=new v.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new v.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new v.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new v.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new v.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new v.ApiCommandResult("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const I=this._extHostNotebooks.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri),notebookEditor:I.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(S)}$willAddInteractiveDocument(y,P,w,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:w,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=b}),define(ye[201],De([1,0,7,4]),function(ie,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(y){this._handlePool=0,this._proxy=y.getProxy(v.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=b}),define(ye[202],De([1,0,2,26,8,6,66,4,9,49,16,10,244,20,7,77,73,62,203,11,14,24]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class i{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentSymbols(C,z){const W=this._documents.getDocument(C),j=await this._provider.provideDocumentSymbols(W,z);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(b.DocumentSymbol.from):i._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(C){C=C.slice(0).sort((j,se)=>{let de=j.location.range.start.compareTo(se.location.range.start);return de===0&&(de=se.location.range.end.compareTo(j.location.range.end)),de});const z=[],W=[];for(const j of C){const se={name:j.name||"!!MISSING: name!!",kind:b.SymbolKind.from(j.kind),tags:j.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:b.Range.from(j.location.range),selectionRange:b.Range.from(j.location.range),children:[]};for(;;){if(W.length===0){W.push(se),z.push(se);break}const de=W[W.length-1];if(T.Range.containsRange(de.range,se.range)&&!T.Range.equalsRange(de.range,se.range)){de.children?.push(se),W.push(se);break}W.pop()}}return z}}class h{constructor(C,z,W){this._documents=C,this._commands=z,this._provider=W,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(C,z){const W=this._documents.getDocument(C),j=await this._provider.provideCodeLenses(W,z);if(!j||z.isCancellationRequested)return;const se=this._cache.add(j),de=new f.DisposableStore;this._disposables.set(se,de);const Z={cacheId:se,lenses:[]};for(let pe=0;pe<j.length;pe++)Z.lenses.push({cacheId:[se,pe],range:b.Range.from(j[pe].range),command:this._commands.toInternal(j[pe].command,de)});return Z}async resolveCodeLens(C,z){const W=C.cacheId&&this._cache.get(...C.cacheId);if(!W)return;let j;if(typeof this._provider.resolveCodeLens!="function"||W.isResolved?j=W:j=await this._provider.resolveCodeLens(W,z),j||(j=W),z.isCancellationRequested)return;const se=C.cacheId&&this._disposables.get(C.cacheId[0]);if(!!se)return C.command=this._commands.toInternal(j.command??h._badCmd,se),C}releaseCodeLenses(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(Y){return Array.isArray(Y)?Y.map(b.DefinitionLink.from):Y?[b.DefinitionLink.from(Y)]:[]}class n{constructor(C,z){this._documents=C,this._provider=z}async provideDefinition(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideDefinition(j,se,W);return r(de)}}class s{constructor(C,z){this._documents=C,this._provider=z}async provideDeclaration(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideDeclaration(j,se,W);return r(de)}}class t{constructor(C,z){this._documents=C,this._provider=z}async provideImplementation(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideImplementation(j,se,W);return r(de)}}class c{constructor(C,z){this._documents=C,this._provider=z}async provideTypeDefinition(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideTypeDefinition(j,se,W);return r(de)}}class _{constructor(C,z){this._documents=C,this._provider=z}async provideHover(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideHover(j,se,W);if(!(!de||(0,R.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=j.getWordRangeAtPosition(se)),de.range||(de.range=new M.Range(se,se)),b.Hover.from(de)}}class p{constructor(C,z){this._documents=C,this._provider=z}async provideEvaluatableExpression(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideEvaluatableExpression(j,se,W);if(de)return b.EvaluatableExpression.from(de)}}class k{constructor(C,z){this._documents=C,this._provider=z}async provideInlineValues(C,z,W,j){const se=this._documents.getDocument(C),de=await this._provider.provideInlineValues(se,b.Range.to(z),b.InlineValueContext.to(W),j);if(Array.isArray(de))return de.map(Z=>b.InlineValue.from(Z))}}class U{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentHighlights(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideDocumentHighlights(j,se,W);if(Array.isArray(de))return de.map(b.DocumentHighlight.from)}}class V{constructor(C,z){this._documents=C,this._provider=z}async provideLinkedEditingRanges(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.provideLinkedEditingRanges(j,se,W);if(de&&Array.isArray(de.ranges))return{ranges:(0,R.coalesce)(de.ranges.map(b.Range.from)),wordPattern:de.wordPattern}}}class x{constructor(C,z){this._documents=C,this._provider=z}async provideReferences(C,z,W,j){const se=this._documents.getDocument(C),de=b.Position.to(z),Z=await this._provider.provideReferences(se,de,W,j);if(Array.isArray(Z))return Z.map(b.location.from)}}class D{constructor(C,z,W,j,se,de,Z){this._documents=C,this._commands=z,this._diagnostics=W,this._provider=j,this._logService=se,this._extension=de,this._apiDeprecation=Z,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(C,z,W,j){const se=this._documents.getDocument(C),de=m.Selection.isISelection(z)?b.Selection.to(z):b.Range.to(z),Z=[];for(const Ge of this._diagnostics.getDiagnostics(C))if(de.intersection(Ge.range)&&Z.push(Ge)>D._maxCodeActionsPerFile)break;const pe={diagnostics:Z,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:b.CodeActionTriggerKind.to(W.trigger)},ge=await this._provider.provideCodeActions(se,de,pe,j);if(!(0,R.isNonEmptyArray)(ge)||j.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Je=[];for(let Ge=0;Ge<ge.length;Ge++){const ke=ge[Ge];!ke||(D._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,Be)})):(pe.only&&(ke.kind?pe.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,Be),diagnostics:ke.diagnostics&&ke.diagnostics.map(b.Diagnostic.from),edit:ke.edit&&b.WorkspaceEdit.from(ke.edit,void 0,(0,E.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,disabled:ke.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(C,z){const[W,j]=C,se=this._cache.get(W,j);if(!se||D._isCommand(se)||!this._provider.resolveCodeAction)return;const de=await this._provider.resolveCodeAction(se,z)??se;return de?.edit?b.WorkspaceEdit.from(de.edit,void 0,(0,E.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}static _isCommand(C){return typeof C.command=="string"&&typeof C.title=="string"}}D._maxCodeActionsPerFile=1e3;class L{constructor(C,z,W,j){this._proxy=C,this._documents=z,this._provider=W,this._handle=j}async prepareDocumentPaste(C,z,W,j){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(C),de=z.map(pe=>b.Range.to(pe)),Z=b.DataTransfer.toDataTransfer(W,()=>{throw new A.NotImplementedError});return await this._provider.prepareDocumentPaste(se,de,Z,j),b.DataTransfer.toDataTransferDTO(Z)}async providePasteEdits(C,z,W,j,se){const de=this._documents.getDocument(z),Z=W.map(Ne=>b.Range.to(Ne)),pe=b.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,C,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(de,Z,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class B{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentFormattingEdits(C,z,W){const j=this._documents.getDocument(C),se=await this._provider.provideDocumentFormattingEdits(j,z,W);if(Array.isArray(se))return se.map(b.TextEdit.from)}}class F{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentRangeFormattingEdits(C,z,W,j){const se=this._documents.getDocument(C),de=b.Range.to(z),Z=await this._provider.provideDocumentRangeFormattingEdits(se,de,W,j);if(Array.isArray(Z))return Z.map(b.TextEdit.from)}}class K{constructor(C,z){this._documents=C,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,z,W,j,se){const de=this._documents.getDocument(C),Z=b.Position.to(z),pe=await this._provider.provideOnTypeFormattingEdits(de,Z,W,j,se);if(Array.isArray(pe))return pe.map(b.TextEdit.from)}}class H{constructor(C,z){this._provider=C,this._logService=z,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,z){const W=await this._provider.provideWorkspaceSymbols(C,z);if(!(0,R.isNonEmptyArray)(W))return{symbols:[]};const j=this._cache.add(W),se={cacheId:j,symbols:[]};for(let de=0;de<W.length;de++){const Z=W[de];if(!Z||!Z.name){this._logService.warn("INVALID SymbolInformation",Z);continue}se.symbols.push({...b.WorkspaceSymbol.from(Z),cacheId:[j,de]})}return se}async resolveWorkspaceSymbol(C,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const W=this._cache.get(...C.cacheId);if(W){const j=await this._provider.resolveWorkspaceSymbol(W,z);return j&&(0,v.mixin)(C,b.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(C){this._cache.delete(C)}}class O{constructor(C,z,W){this._documents=C,this._provider=z,this._logService=W}static supportsResolving(C){return typeof C.prepareRename=="function"}async provideRenameEdits(C,z,W,j){const se=this._documents.getDocument(C),de=b.Position.to(z);try{const Z=await this._provider.provideRenameEdits(se,de,W,j);return Z?b.WorkspaceEdit.from(Z):void 0}catch(Z){const pe=O._asMessage(Z);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Z)}}async resolveRenameLocation(C,z,W){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(C),se=b.Position.to(z);try{const de=await this._provider.prepareRename(j,se,W);let Z,pe;if(M.Range.isRange(de)?(Z=de,pe=j.getText(de)):(0,S.isObject)(de)&&(Z=de.range,pe=de.placeholder),!Z||!pe)return;if(Z.start.line>se.line||Z.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(Z),text:pe}}catch(de){const Z=O._asMessage(de);return Z?{rejectReason:Z,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class ee{constructor(C,z){this.resultId=C,this.tokens=z}}class ce{constructor(C,z){this._documents=C,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(C,z,W){const j=this._documents.getDocument(C),se=z!==0?this._previousResults.get(z):null;let de=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,se.resultId,W):await this._provider.provideDocumentSemanticTokens(j,W);return se&&this._previousResults.delete(z),de?(de=ce._fixProvidedSemanticTokens(de),this._send(ce._convertToEdits(se,de),de)):null}async releaseDocumentSemanticColoring(C){this._previousResults.delete(C)}static _fixProvidedSemanticTokens(C){return ce._isSemanticTokens(C)?ce._isCorrectSemanticTokens(C)?C:new M.SemanticTokens(new Uint32Array(C.data),C.resultId):ce._isSemanticTokensEdits(C)?ce._isCorrectSemanticTokensEdits(C)?C:new M.SemanticTokensEdits(C.edits.map(z=>new M.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),C.resultId):C}static _isSemanticTokens(C){return C&&!!C.data}static _isCorrectSemanticTokens(C){return C.data instanceof Uint32Array}static _isSemanticTokensEdits(C){return C&&Array.isArray(C.edits)}static _isCorrectSemanticTokensEdits(C){for(const z of C.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(C,z){if(!ce._isSemanticTokens(z)||!C||!C.tokens)return z;const W=C.tokens,j=W.length,se=z.data,de=se.length;let Z=0;const pe=Math.min(j,de);for(;Z<pe&&W[Z]===se[Z];)Z++;if(Z===j&&Z===de)return new M.SemanticTokensEdits([],z.resultId);let ge=0;const Ne=pe-Z;for(;ge<Ne&&W[j-ge-1]===se[de-ge-1];)ge++;return new M.SemanticTokensEdits([{start:Z,deleteCount:j-Z-ge,data:se.subarray(Z,de-ge)}],z.resultId)}_send(C,z){if(ce._isSemanticTokens(C)){const W=this._nextResultId++;return this._previousResults.set(W,new ee(C.resultId,C.data)),(0,d.encodeSemanticTokensDto)({id:W,type:"full",data:C.data})}if(ce._isSemanticTokensEdits(C)){const W=this._nextResultId++;return ce._isSemanticTokens(z)?this._previousResults.set(W,new ee(z.resultId,z.data)):this._previousResults.set(W,new ee(C.resultId)),(0,d.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(C.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=ce;class oe{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentRangeSemanticTokens(C,z,W){const j=this._documents.getDocument(C),se=await this._provider.provideDocumentRangeSemanticTokens(j,b.Range.to(z),W);return se?this._send(se):null}_send(C){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class le{constructor(C,z,W,j,se){this._documents=C,this._commands=z,this._provider=W,this._apiDeprecation=j,this._extension=se,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}async provideCompletionItems(C,z,W,j){const se=this._documents.getDocument(C),de=b.Position.to(z),Z=se.getWordRangeAtPosition(de)||new M.Range(de,de),pe=Z.with({end:de}),ge=new g.StopWatch(!0),Ne=await this._provider.provideCompletionItems(se,de,j,b.CompletionContext.to(W));if(!Ne||j.isCancellationRequested)return;const Be=Array.isArray(Ne)?new M.CompletionList(Ne):Ne,Je=le.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Je,Ge);const ke=[],rt={x:Je,b:ke,a:{replace:b.Range.from(Z),insert:b.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let G=0;G<Be.items.length;G++){const Q=Be.items[G],fe=this._convertCompletionItem(Q,[Je,G],pe,Z);ke.push(fe)}return rt}async resolveCompletionItem(C,z){if(typeof this._provider.resolveCompletionItem!="function")return;const W=this._cache.get(...C);if(!W)return;const j=await this._provider.resolveCompletionItem(W,z);if(!!j)return this._convertCompletionItem(j,C)}releaseCompletionItems(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_convertCompletionItem(C,z,W,j){const se=this._disposables.get(z[0]);if(!se)throw Error("DisposableStore is missing...");const de={x:z,a:C.label,b:C.kind!==void 0?b.CompletionItemKind.from(C.kind):void 0,n:C.tags&&C.tags.map(b.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:b.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters,l:C.additionalTextEdits&&C.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(C.command,se)};C.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=C.textEdit.newText):typeof C.insertText=="string"?de.h=C.insertText:C.insertText instanceof M.SnippetString&&(de.h=C.insertText.value,de.i|=4);let Z;return C.textEdit?Z=C.textEdit.range:C.range&&(Z=C.range),M.Range.isRange(Z)?de.j=b.Range.from(Z):Z&&(!W?.isEqual(Z.inserting)||!j?.isEqual(Z.replacing))&&(de.j={insert:b.Range.from(Z.inserting),replace:b.Range.from(Z.replacing)}),de}}class te{async provideInlineCompletions(C,z,W,j){}disposeCompletions(C){}handleDidShowCompletionItem(C,z){}}class Ee extends te{constructor(C,z,W,j){super(),this._extension=C,this._documents=z,this._provider=W,this._commands=j,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,E.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,E.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(C,z,W,j){const se=this._documents.getDocument(C),de=b.Position.to(z),Z=await this._provider.provideInlineCompletionItems(se,de,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:b.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const pe=Array.isArray(Z)?Z:Z.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(Z)?[]:Z.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Je,Ge)=>{let ke;Je.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:ke,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ge.map(Je=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,z){const W=this._references.get(C)?.items[z];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class be extends te{constructor(C,z,W,j){super(),this.extension=C,this._documents=z,this._provider=W,this._commands=j,this._references=new ne,this.isAdditionProposedApiEnabled=(0,E.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(C,z,W,j){const se=this._documents.getDocument(C),de=b.Position.to(z),Z=await this._provider.provideInlineCompletionItems(se,de,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:b.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const pe=Array.isArray(Z)?Z:Z.items,ge=Array.isArray(Z)?[]:Z.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Je,Ge)=>{let ke;Je.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:ke,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ge.map(Je=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,z){const W=this._references.get(C)?.items[z];W&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(C){const z=this._idPool++;return this._references.set(z,C),z}disposeReferenceId(C){const z=this._references.get(C);return this._references.delete(C),z}get(C){return this._references.get(C)}}class ve{constructor(C,z){this._documents=C,this._provider=z,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(C,z,W,j){const se=this._documents.getDocument(C),de=b.Position.to(z),Z=this.reviveContext(W),pe=await this._provider.provideSignatureHelp(se,de,j,Z);if(pe){const ge=this._cache.add([pe]);return{...b.SignatureHelp.from(pe),id:ge}}}reviveContext(C){let z;if(C.activeSignatureHelp){const W=b.SignatureHelp.to(C.activeSignatureHelp),j=this._cache.get(C.activeSignatureHelp.id,0);j?(z=j,z.activeSignature=W.activeSignature,z.activeParameter=W.activeParameter):z=W}return{...C,activeSignatureHelp:z}}releaseSignatureHelp(C){this._cache.delete(C)}}class Pe{constructor(C,z,W,j,se){this._documents=C,this._commands=z,this._provider=W,this._logService=j,this._extension=se,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(C,z,W){const j=this._documents.getDocument(C),se=b.Range.to(z),de=await this._provider.provideInlayHints(j,se,W);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(W.isCancellationRequested)return;const Z=this._cache.add(de);this._disposables.set(Z,new f.DisposableStore);const pe={hints:[],cacheId:Z};for(let ge=0;ge<de.length;ge++)this._isValidInlayHint(de[ge],se)&&pe.hints.push(this._convertInlayHint(de[ge],[Z,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),pe}async resolveInlayHint(C,z){if(typeof this._provider.resolveInlayHint!="function")return;const W=this._cache.get(...C);if(!W)return;const j=await this._provider.resolveInlayHint(W,z);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,C)}releaseHints(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_isValidInlayHint(C,z){return C.label.length===0||Array.isArray(C.label)&&C.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(z&&!z.contains(C.position))}_convertInlayHint(C,z){const W=this._disposables.get(z[0]);if(!W)throw Error("DisposableStore is missing...");const j={label:"",cacheId:z,tooltip:b.MarkdownString.fromStrict(C.tooltip),position:b.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(b.TextEdit.from),kind:C.kind&&b.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?j.label=C.label:j.label=C.label.map(se=>{const de={label:se.value};return de.tooltip=b.MarkdownString.fromStrict(se.tooltip),M.Location.isLocation(se.location)&&(de.location=b.location.from(se.location)),se.command&&(de.command=this._commands.toInternal(se.command,W)),de}),j}}class Fe{constructor(C,z){this._documents=C,this._provider=z,this._cache=new o.Cache("DocumentLink")}async provideLinks(C,z){const W=this._documents.getDocument(C),j=await this._provider.provideDocumentLinks(W,z);if(!(!Array.isArray(j)||j.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(b.DocumentLink.from)};{const se=this._cache.add(j),de={links:[],cacheId:se};for(let Z=0;Z<j.length;Z++){if(!Fe._validateLink(j[Z]))continue;const pe=b.DocumentLink.from(j[Z]);pe.cacheId=[se,Z],de.links.push(pe)}return de}}}static _validateLink(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,z){if(typeof this._provider.resolveDocumentLink!="function")return;const W=this._cache.get(...C);if(!W)return;const j=await this._provider.resolveDocumentLink(W,z);if(!(!j||!Fe._validateLink(j)))return b.DocumentLink.from(j)}releaseLinks(C){this._cache.delete(C)}}class xe{constructor(C,z){this._documents=C,this._provider=z}async provideColors(C,z){const W=this._documents.getDocument(C),j=await this._provider.provideDocumentColors(W,z);return Array.isArray(j)?j.map(de=>({color:b.Color.from(de.color),range:b.Range.from(de.range)})):[]}async provideColorPresentations(C,z,W){const j=this._documents.getDocument(C),se=b.Range.to(z.range),de=b.Color.to(z.color),Z=await this._provider.provideColorPresentations(de,{document:j,range:se},W);if(!!Array.isArray(Z))return Z.map(b.ColorPresentation.from)}}class Qe{constructor(C,z){this._documents=C,this._provider=z}async provideFoldingRanges(C,z,W){const j=this._documents.getDocument(C),se=await this._provider.provideFoldingRanges(j,z,W);if(!!Array.isArray(se))return se.map(b.FoldingRange.from)}}class Ie{constructor(C,z,W){this._documents=C,this._provider=z,this._logService=W}async provideSelectionRanges(C,z,W){const j=this._documents.getDocument(C),se=z.map(b.Position.to),de=await this._provider.provideSelectionRanges(j,se,W);if(!(0,R.isNonEmptyArray)(de))return[];if(de.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Z=[];for(let pe=0;pe<se.length;pe++){const ge=[];Z.push(ge);let Ne=se[pe],Be=de[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(b.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Z}}class Se{constructor(C,z){this._documents=C,this._provider=z,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.prepareCallHierarchy(j,se,W);if(!de)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Z,pe)):[this._cacheAndConvertItem(Z,de)]}async provideCallsTo(C,z,W){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(j,W);if(!!se)return se.map(de=>({from:this._cacheAndConvertItem(C,de.from),fromRanges:de.fromRanges.map(Z=>b.Range.from(Z))}))}async provideCallsFrom(C,z,W){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(j,W);if(!!se)return se.map(de=>({to:this._cacheAndConvertItem(C,de.to),fromRanges:de.fromRanges.map(Z=>b.Range.from(Z))}))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,z){const W=this._cache.get(C),j=b.CallHierarchyItem.from(z,C,W.size.toString(36));return W.set(j._itemId,z),j}_itemFromCache(C,z){return this._cache.get(C)?.get(z)}}class Te{constructor(C,z){this._documents=C,this._provider=z,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(C,z,W){const j=this._documents.getDocument(C),se=b.Position.to(z),de=await this._provider.prepareTypeHierarchy(j,se,W);if(!de)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Z,pe)):[this._cacheAndConvertItem(Z,de)]}async provideSupertypes(C,z,W){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(j,W);if(!!se)return se.map(de=>this._cacheAndConvertItem(C,de))}async provideSubtypes(C,z,W){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(j,W);if(!!se)return se.map(de=>this._cacheAndConvertItem(C,de))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,z){const W=this._cache.get(C),j=b.TypeHierarchyItem.from(z,C,W.size.toString(36));return W.set(j._itemId,z),j}_itemFromCache(C,z){return this._cache.get(C)?.get(z)}}class ae{constructor(C,z,W,j){this._proxy=C,this._documents=z,this._provider=W,this._handle=j}async provideDocumentOnDropEdits(C,z,W,j,se){const de=this._documents.getDocument(z),Z=b.Position.to(W),pe=b.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,C,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(de,Z,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ue{constructor(C,z){this.adapter=C,this.extension=z}}class X{constructor(C,z,W,j,se,de,Z){this._adapter=new Map,this._uriTransformer=z,this._proxy=C.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=W,this._commands=j,this._diagnostics=se,this._logService=de,this._apiDeprecation=Z}_transformDocumentSelector(C){return b.DocumentSelector.from(C,this._uriTransformer)}_createDisposable(C){return new M.Disposable(()=>{this._adapter.delete(C),this._proxy.$unregister(C)})}_nextHandle(){return X._handlePool++}async _withAdapter(C,z,W,j,se,de=!1){const Z=this._adapter.get(C);if(!Z||!(Z.adapter instanceof z))return j;const pe=Date.now();de||this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ge=W(Z.adapter,Z.extension);return Promise.resolve(ge).catch(Ne=>{(0,A.isCancellationError)(Ne)||(this._logService.error(`[${Z.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{de||this._logService.trace(`[${Z.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),I.CancellationToken.isCancellationToken(se)?(0,l.raceCancellationError)(ge,se):ge}_addNewAdapter(C,z){const W=this._nextHandle();return this._adapter.set(W,new ue(C,z)),W}static _extLabel(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,z,W,j){const se=this._addNewAdapter(new i(this._documents,W),C),de=j&&j.label||X._extLabel(C);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(z),de),this._createDisposable(se)}$provideDocumentSymbols(C,z,W){return this._withAdapter(C,i,j=>j.provideDocumentSymbols(a.URI.revive(z),W),void 0,W)}registerCodeLensProvider(C,z,W){const j=this._nextHandle(),se=typeof W.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new h(this._documents,this._commands.converter,W),C)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(z),se);let de=this._createDisposable(j);if(se!==void 0){const Z=W.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(se));de=M.Disposable.from(de,Z)}return de}$provideCodeLenses(C,z,W){return this._withAdapter(C,h,j=>j.provideCodeLenses(a.URI.revive(z),W),void 0,W)}$resolveCodeLens(C,z,W){return this._withAdapter(C,h,j=>j.resolveCodeLens(z,W),void 0,void 0)}$releaseCodeLenses(C,z){this._withAdapter(C,h,W=>Promise.resolve(W.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(C,z,W){const j=this._addNewAdapter(new n(this._documents,W),C);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDefinition(C,z,W,j){return this._withAdapter(C,n,se=>se.provideDefinition(a.URI.revive(z),W,j),[],j)}registerDeclarationProvider(C,z,W){const j=this._addNewAdapter(new s(this._documents,W),C);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDeclaration(C,z,W,j){return this._withAdapter(C,s,se=>se.provideDeclaration(a.URI.revive(z),W,j),[],j)}registerImplementationProvider(C,z,W){const j=this._addNewAdapter(new t(this._documents,W),C);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideImplementation(C,z,W,j){return this._withAdapter(C,t,se=>se.provideImplementation(a.URI.revive(z),W,j),[],j)}registerTypeDefinitionProvider(C,z,W){const j=this._addNewAdapter(new c(this._documents,W),C);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideTypeDefinition(C,z,W,j){return this._withAdapter(C,c,se=>se.provideTypeDefinition(a.URI.revive(z),W,j),[],j)}registerHoverProvider(C,z,W,j){const se=this._addNewAdapter(new _(this._documents,W),C);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(z)),this._createDisposable(se)}$provideHover(C,z,W,j){return this._withAdapter(C,_,se=>se.provideHover(a.URI.revive(z),W,j),void 0,j)}registerEvaluatableExpressionProvider(C,z,W,j){const se=this._addNewAdapter(new p(this._documents,W),C);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(z)),this._createDisposable(se)}$provideEvaluatableExpression(C,z,W,j){return this._withAdapter(C,p,se=>se.provideEvaluatableExpression(a.URI.revive(z),W,j),void 0,j)}registerInlineValuesProvider(C,z,W,j){const se=typeof W.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new k(this._documents,W),C);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(z),se);let Z=this._createDisposable(de);if(se!==void 0){const pe=W.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(se));Z=M.Disposable.from(Z,pe)}return Z}$provideInlineValues(C,z,W,j,se){return this._withAdapter(C,k,de=>de.provideInlineValues(a.URI.revive(z),W,j,se),void 0,se)}registerDocumentHighlightProvider(C,z,W){const j=this._addNewAdapter(new U(this._documents,W),C);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentHighlights(C,z,W,j){return this._withAdapter(C,U,se=>se.provideDocumentHighlights(a.URI.revive(z),W,j),void 0,j)}registerLinkedEditingRangeProvider(C,z,W){const j=this._addNewAdapter(new V(this._documents,W),C);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideLinkedEditingRanges(C,z,W,j){return this._withAdapter(C,V,async se=>{const de=await se.provideLinkedEditingRanges(a.URI.revive(z),W,j);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?X._serializeRegExp(de.wordPattern):void 0}},void 0,j)}registerReferenceProvider(C,z,W){const j=this._addNewAdapter(new x(this._documents,W),C);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideReferences(C,z,W,j,se){return this._withAdapter(C,x,de=>de.provideReferences(a.URI.revive(z),W,j,se),void 0,se)}registerCodeActionProvider(C,z,W,j){const se=new f.DisposableStore,de=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,W,this._logService,C,this._apiDeprecation),C);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(z),{providedKinds:j?.providedCodeActionKinds?.map(Z=>Z.value),documentation:j?.documentation?.map(Z=>({kind:Z.kind.value,command:this._commands.converter.toInternal(Z.command,se)}))},X._extLabel(C),Boolean(W.resolveCodeAction)),se.add(this._createDisposable(de)),se}$provideCodeActions(C,z,W,j,se){return this._withAdapter(C,D,de=>de.provideCodeActions(a.URI.revive(z),W,j,se),void 0,se)}$resolveCodeAction(C,z,W){return this._withAdapter(C,D,j=>j.resolveCodeAction(z,W),void 0,void 0)}$releaseCodeActions(C,z){this._withAdapter(C,D,W=>Promise.resolve(W.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(C,z,W){const j=this._addNewAdapter(new B(this._documents,W),C);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(z),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentFormattingEdits(C,z,W,j){return this._withAdapter(C,B,se=>se.provideDocumentFormattingEdits(a.URI.revive(z),W,j),void 0,j)}registerDocumentRangeFormattingEditProvider(C,z,W){const j=this._addNewAdapter(new F(this._documents,W),C);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(z),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(C,z,W,j,se){return this._withAdapter(C,F,de=>de.provideDocumentRangeFormattingEdits(a.URI.revive(z),W,j,se),void 0,se)}registerOnTypeFormattingEditProvider(C,z,W,j){const se=this._addNewAdapter(new K(this._documents,W),C);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(z),j,C.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(C,z,W,j,se,de){return this._withAdapter(C,K,Z=>Z.provideOnTypeFormattingEdits(a.URI.revive(z),W,j,se,de),void 0,de)}registerWorkspaceSymbolProvider(C,z){const W=this._addNewAdapter(new H(z,this._logService),C);return this._proxy.$registerNavigateTypeSupport(W,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(W)}$provideWorkspaceSymbols(C,z,W){return this._withAdapter(C,H,j=>j.provideWorkspaceSymbols(z,W),{symbols:[]},W)}$resolveWorkspaceSymbol(C,z,W){return this._withAdapter(C,H,j=>j.resolveWorkspaceSymbol(z,W),void 0,void 0)}$releaseWorkspaceSymbols(C,z){this._withAdapter(C,H,W=>W.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(C,z,W){const j=this._addNewAdapter(new O(this._documents,W,this._logService),C);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(z),O.supportsResolving(W)),this._createDisposable(j)}$provideRenameEdits(C,z,W,j,se){return this._withAdapter(C,O,de=>de.provideRenameEdits(a.URI.revive(z),W,j,se),void 0,se)}$resolveRenameLocation(C,z,W,j){return this._withAdapter(C,O,se=>se.resolveRenameLocation(a.URI.revive(z),W,j),void 0,j)}registerDocumentSemanticTokensProvider(C,z,W,j){const se=this._addNewAdapter(new ce(this._documents,W),C),de=typeof W.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(z),j,de);let Z=this._createDisposable(se);if(de){const pe=W.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(de));Z=M.Disposable.from(Z,pe)}return Z}$provideDocumentSemanticTokens(C,z,W,j){return this._withAdapter(C,ce,se=>se.provideDocumentSemanticTokens(a.URI.revive(z),W,j),null,j)}$releaseDocumentSemanticTokens(C,z){this._withAdapter(C,ce,W=>W.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,z,W,j){const se=this._addNewAdapter(new oe(this._documents,W),C);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(z),j),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(C,z,W,j){return this._withAdapter(C,oe,se=>se.provideDocumentRangeSemanticTokens(a.URI.revive(z),W,j),null,j)}registerCompletionItemProvider(C,z,W,j){const se=this._addNewAdapter(new le(this._documents,this._commands.converter,W,this._apiDeprecation,C),C);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(z),j,le.supportsResolving(W),`${C.identifier.value}(${j.join("")})`),this._createDisposable(se)}$provideCompletionItems(C,z,W,j,se){return this._withAdapter(C,le,de=>de.provideCompletionItems(a.URI.revive(z),W,j,se),void 0,se)}$resolveCompletionItem(C,z,W){return this._withAdapter(C,le,j=>j.resolveCompletionItem(z,W),void 0,W)}$releaseCompletionItems(C,z){this._withAdapter(C,le,W=>W.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(C,z,W){const j=new Ee(C,this._documents,W,this._commands.converter),se=this._addNewAdapter(j,C);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(z),j.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(C,z,W){const j=this._addNewAdapter(new be(C,this._documents,W,this._commands.converter),C);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(z),!0),this._createDisposable(j)}$provideInlineCompletions(C,z,W,j,se){return this._withAdapter(C,te,de=>de.provideInlineCompletions(a.URI.revive(z),W,j,se),void 0,se)}$handleInlineCompletionDidShow(C,z,W){this._withAdapter(C,te,async j=>{j.handleDidShowCompletionItem(z,W)},void 0,void 0)}$freeInlineCompletionsList(C,z){this._withAdapter(C,te,async W=>{W.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(C,z,W,j){const se=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,de=this._addNewAdapter(new ve(this._documents,W),C);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(z),se),this._createDisposable(de)}$provideSignatureHelp(C,z,W,j,se){return this._withAdapter(C,ve,de=>de.provideSignatureHelp(a.URI.revive(z),W,j,se),void 0,se)}$releaseSignatureHelp(C,z){this._withAdapter(C,ve,W=>W.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(C,z,W){const j=typeof W.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new Pe(this._documents,this._commands.converter,W,this._logService,C),C);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(z),typeof W.resolveInlayHint=="function",j,X._extLabel(C));let de=this._createDisposable(se);if(j!==void 0){const Z=W.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(j));de=M.Disposable.from(de,Z)}return de}$provideInlayHints(C,z,W,j){return this._withAdapter(C,Pe,se=>se.provideInlayHints(a.URI.revive(z),W,j),void 0,j)}$resolveInlayHint(C,z,W){return this._withAdapter(C,Pe,j=>j.resolveInlayHint(z,W),void 0,W)}$releaseInlayHints(C,z){this._withAdapter(C,Pe,W=>W.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(C,z,W){const j=this._addNewAdapter(new Fe(this._documents,W),C);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(z),typeof W.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(C,z,W){return this._withAdapter(C,Fe,j=>j.provideLinks(a.URI.revive(z),W),void 0,W,z.scheme==="output")}$resolveDocumentLink(C,z,W){return this._withAdapter(C,Fe,j=>j.resolveLink(z,W),void 0,void 0,!0)}$releaseDocumentLinks(C,z){this._withAdapter(C,Fe,W=>W.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(C,z,W){const j=this._addNewAdapter(new xe(this._documents,W),C);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentColors(C,z,W){return this._withAdapter(C,xe,j=>j.provideColors(a.URI.revive(z),W),[],W)}$provideColorPresentations(C,z,W,j){return this._withAdapter(C,xe,se=>se.provideColorPresentations(a.URI.revive(z),W,j),void 0,j)}registerFoldingRangeProvider(C,z,W){const j=this._nextHandle(),se=typeof W.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new Qe(this._documents,W),C)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(z),se);let de=this._createDisposable(j);if(se!==void 0){const Z=W.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));de=M.Disposable.from(de,Z)}return de}$provideFoldingRanges(C,z,W,j){return this._withAdapter(C,Qe,se=>se.provideFoldingRanges(a.URI.revive(z),W,j),void 0,j)}registerSelectionRangeProvider(C,z,W){const j=this._addNewAdapter(new Ie(this._documents,W,this._logService),C);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideSelectionRanges(C,z,W,j){return this._withAdapter(C,Ie,se=>se.provideSelectionRanges(a.URI.revive(z),W,j),[],j)}registerCallHierarchyProvider(C,z,W){const j=this._addNewAdapter(new Se(this._documents,W),C);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$prepareCallHierarchy(C,z,W,j){return this._withAdapter(C,Se,se=>Promise.resolve(se.prepareSession(a.URI.revive(z),W,j)),void 0,j)}$provideCallHierarchyIncomingCalls(C,z,W,j){return this._withAdapter(C,Se,se=>se.provideCallsTo(z,W,j),void 0,j)}$provideCallHierarchyOutgoingCalls(C,z,W,j){return this._withAdapter(C,Se,se=>se.provideCallsFrom(z,W,j),void 0,j)}$releaseCallHierarchy(C,z){this._withAdapter(C,Se,W=>Promise.resolve(W.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(C,z,W){const j=this._addNewAdapter(new Te(this._documents,W),C);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$prepareTypeHierarchy(C,z,W,j){return this._withAdapter(C,Te,se=>Promise.resolve(se.prepareSession(a.URI.revive(z),W,j)),void 0,j)}$provideTypeHierarchySupertypes(C,z,W,j){return this._withAdapter(C,Te,se=>se.provideSupertypes(z,W,j),void 0,j)}$provideTypeHierarchySubtypes(C,z,W,j){return this._withAdapter(C,Te,se=>se.provideSubtypes(z,W,j),void 0,j)}$releaseTypeHierarchy(C,z){this._withAdapter(C,Te,W=>Promise.resolve(W.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(C,z,W){const j=this._nextHandle();return this._adapter.set(j,new ue(new ae(this._proxy,this._documents,W,j),C)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentOnDropEdits(C,z,W,j,se,de){return this._withAdapter(C,ae,Z=>Promise.resolve(Z.provideDocumentOnDropEdits(z,a.URI.revive(W),j,se,de)),void 0,void 0)}registerDocumentPasteEditProvider(C,z,W,j){const se=this._nextHandle();return this._adapter.set(se,new ue(new L(this._proxy,this._documents,W,se),C)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(z),!!W.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(C,z,W,j,se){return this._withAdapter(C,L,de=>de.prepareDocumentPaste(a.URI.revive(z),W,j,se),void 0,se)}$providePasteEdits(C,z,W,j,se,de){return this._withAdapter(C,L,Z=>Z.providePasteEdits(z,a.URI.revive(W),j,se,de),void 0,de)}static _serializeRegExp(C){return{pattern:C.source,flags:(0,w.regExpFlags)(C)}}static _serializeIndentationRule(C){return{decreaseIndentPattern:X._serializeRegExp(C.decreaseIndentPattern),increaseIndentPattern:X._serializeRegExp(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?X._serializeRegExp(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?X._serializeRegExp(C.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(C){return{beforeText:X._serializeRegExp(C.beforeText),afterText:C.afterText?X._serializeRegExp(C.afterText):void 0,previousLineText:C.previousLineText?X._serializeRegExp(C.previousLineText):void 0,action:C.action}}static _serializeOnEnterRules(C){return C.map(X._serializeOnEnterRule)}setLanguageConfiguration(C,z,W){const{wordPattern:j}=W;if(j&&(0,w.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(z,j):this._documents.setWordDefinitionFor(z,void 0),W.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),W.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const se=this._nextHandle(),de={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?X._serializeRegExp(W.wordPattern):void 0,indentationRules:W.indentationRules?X._serializeIndentationRule(W.indentationRules):void 0,onEnterRules:W.onEnterRules?X._serializeOnEnterRules(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,z,de),this._createDisposable(se)}$setWordDefinitions(C){for(const z of C)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=X,X._handlePool=0}),define(ye[204],De([1,0,4,8,6,29,14,7]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(R,S,m,I){this._documents=S,this._commands=m,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,S){await this._proxy.$changeLanguage(R,S);const m=this._documents.getDocumentData(R);if(!m)throw new Error(`document '${R.toString()}' NOT found`);return m.document}async tokenAtPosition(R,S){const m=R.version,I=v.Position.from(S),f=await this._proxy.$tokensAtPosition(R.uri,I),d={type:b.StandardTokenType.Other,range:R.getWordRangeAtPosition(S)??new b.Range(S.line,S.character,S.line,S.character)};if(!f)return d;const u={range:v.Range.to(f.range),type:v.TokenType.to(f.type)};return!u.range.contains(S)||m!==R.version?d:u}createLanguageStatusItem(R,S,m){const I=this._handlePool++,f=this._proxy,d=this._ids,u=`${R.identifier.value}/${S}`;if(d.has(u))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);d.add(u);const o={selector:m,id:S,name:R.displayName??R.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const A=new P.DisposableStore,l=()=>{g?.dispose(),g=(0,y.disposableTimeout)(()=>{A.clear(),this._proxy.$setLanguageStatus(I,{id:u,name:o.name??R.displayName??R.name,source:R.displayName??R.name,selector:v.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===b.LanguageStatusSeverity.Error?M.default.Error:o.severity===b.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:o.command&&this._commands.toInternal(o.command,A),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},E={dispose(){A.dispose(),g?.dispose(),f.$removeLanguageStatus(I),d.delete(u)},get id(){return o.id},get name(){return o.name},set name(i){o.name=i,l()},get selector(){return o.selector},set selector(i){o.selector=i,l()},get text(){return o.text},set text(i){o.text=i,l()},get detail(){return o.detail},set detail(i){o.detail=i,l()},get severity(){return o.severity},set severity(i){o.severity=i,l()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(i){o.accessibilityInformation=i,l()},get command(){return o.command},set command(i){o.command=i,l()},get busy(){return o.busy},set busy(i){o.busy=i,l()}};return l(),E}}e.ExtHostLanguages=w}),define(ye[205],De([1,0,15,4,28,13,5]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends a.AbstractLoggerService{constructor(R,S){const m=new y.Emitter;super(S.logLevel,m.event),this._proxy=R.getProxy(v.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,S,m){return new w(this._proxy,R,S,m)}};P=ze([$e(0,M.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class w extends a.AbstractMessageLogger{constructor(R,S,m,I){super(I?.always),this.proxy=R,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(S,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,S){const m=[[R,S]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ye[206],De([1,0,4,15,24]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(P){return P&&P.title}let y=class{constructor(w,T){this._logService=T,this._proxy=w.getProxy(a.MainContext.MainThreadMessageService)}showMessage(w,T,R,S,m){const I={source:{identifier:w.identifier,label:w.displayName||w.name}};let f;typeof S=="string"||M(S)?f=[S,...m]:(I.modal=S?.modal,I.useCustom=S?.useCustom,I.detail=S?.detail,f=m),I.useCustom&&(0,b.checkProposedApiEnabled)(w,"resolvers");const d=[];for(let u=0;u<f.length;u++){const o=f[u];if(typeof o=="string")d.push({title:o,handle:u,isCloseAffordance:!1});else if(typeof o=="object"){const{title:g,isCloseAffordance:A}=o;d.push({title:g,isCloseAffordance:!!A,handle:u})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(T,R,I,d).then(u=>{if(typeof u=="number")return f[u]})}};y=ze([$e(1,v.ILogService)],y),e.ExtHostMessageService=y}),define(ye[207],De([1,0,23,5,97,7,25,9,10,2,62,4,36,8,6,40,175,92]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class g{constructor(l,E,i,h,r){this._textDocumentsAndEditors=i,this._textDocuments=h,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new v.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new v.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new v.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new v.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(S.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(S.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(S.MainContext.MainThreadNotebookEditors),this._commandsConverter=E.converter,E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const s=n.notebookEditor?.notebookUri,t=n.cell.handle,_=this._documents.get(s)?.getCell(t);if(_)return _.apiCell}return n}}),g._registerApiCommands(E)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const E=this._editors.get(l);if(!E)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return E}getIdByEditor(l){for(const[E,i]of this._editors)if(i.apiEditor===l)return E}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,E){const i=this._documents.get(l);if(!i&&!E)throw new Error(`NO notebook document for '${l}'`);return i}_getProviderData(l){const E=this._notebookContentProviders.get(l);if(!E)throw new Error(`NO provider for '${l}'`);return E}registerNotebookContentProvider(l,E,i,h,r){if((0,P.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(E))throw new Error(`Notebook provider for '${E}' already registered`);this._notebookContentProviders.set(E,{extension:l,provider:i});let n;return i.onDidChangeNotebookContentOptions&&(n=i.onDidChangeNotebookContentOptions(()=>{const s=I.NotebookDocumentContentOptions.from(i.options);this._notebookProxy.$updateNotebookProviderOptions(E,s)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},E,I.NotebookDocumentContentOptions.from(h),g._convertNotebookRegistrationData(l,r)),new f.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(E),this._notebookProxy.$unregisterNotebookProvider(E)})}static _convertNotebookRegistrationData(l,E){if(!E)return;const i=E.filenamePattern.map(h=>I.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(E.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:E.displayName,filenamePattern:i,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,E,i){const h=g._notebookStatusBarItemProviderHandlePool++,r=typeof i.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(h,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(h,r,E);let n;return r!==void 0&&(n=i.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(r))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(h),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(h,r),n?.dispose()})}async createNotebookDocument(l){const E=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&I.NotebookData.from(l.content)});return T.URI.revive(E)}async openNotebookDocument(l){const E=this._documents.get(l);if(E)return E.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(l),h=this._documents.get(T.URI.revive(i));return(0,w.assertIsDefined)(h?.apiNotebook)}async showNotebookDocument(l,E){T.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let i;typeof E=="object"?i={position:I.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(I.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:i={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,i),r=h&&this._editors.get(h)?.apiEditor;if(r)return r;throw h?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,E,i,h){const r=this._notebookStatusBarItemProviders.get(l),n=T.URI.revive(E),s=this._documents.get(n);if(!s||!r)return;const t=s.getCellFromIndex(i);if(!t)return;const c=await r.provideCellStatusBarItems(t.apiCell,h);if(!c)return;const _=new M.DisposableStore,p=this._statusBarCache.add([_]),U=(Array.isArray(c)?c:[c]).map(V=>I.NotebookStatusBarItem.from(V,this._commandsConverter,_));return{cacheId:p,items:U}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,E,i,h,r){if((0,P.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,i),this._notebookProxy.$registerNotebookSerializer(n,{id:l.identifier,location:l.extensionLocation},E,I.NotebookDocumentContentOptions.from(h),g._convertNotebookRegistrationData(l,r)),(0,M.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(l,E,i){const h=this._notebookSerializer.get(l);if(!h)throw new Error("NO serializer found");const r=await h.deserializeNotebook(E.buffer,i);return new d.SerializableObjectWithBuffers(I.NotebookData.from(r))}async $notebookToData(l,E,i){const h=this._notebookSerializer.get(l);if(!h)throw new Error("NO serializer found");const r=await h.serializeNotebook(I.NotebookData.to(E.value),i);return a.VSBuffer.wrap(r)}async $openNotebook(l,E,i,h,r){const{provider:n}=this._getProviderData(l),s=await n.openNotebook(T.URI.revive(E),{backupId:i,untitledDocumentData:h?.buffer},r);return new d.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(I.NotebookCellData.from)})}async $saveNotebook(l,E,i){const h=this.getNotebookDocument(T.URI.revive(E)),{provider:r}=this._getProviderData(l);return await r.saveNotebook(h.apiNotebook,i),!0}async $saveNotebookAs(l,E,i,h){const r=this.getNotebookDocument(T.URI.revive(E)),{provider:n}=this._getProviderData(l);return await n.saveNotebookAs(T.URI.revive(i),r.apiNotebook,h),!0}async $backupNotebook(l,E,i){const h=this.getNotebookDocument(T.URI.revive(E)),r=this._getProviderData(l),n=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),s=String((0,b.hash)([h.uri.toString(),this._backupIdPool++])),t=T.URI.joinPath(n,s),c=await r.provider.backupNotebook(h.apiNotebook,{destination:t},i);return h.updateBackup(c),c.id}_createExtHostEditor(l,E,i){if(this._editors.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const h=new o.ExtHostNotebookEditor(E,this._notebookEditorsProxy,l,i.visibleRanges.map(I.NotebookRange.to),i.selections.map(I.NotebookRange.to),typeof i.viewColumn=="number"?I.ViewColumn.to(i.viewColumn):void 0);this._editors.set(E,h)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const i of l.value.removedDocuments){const h=T.URI.revive(i),r=this._documents.get(h);r&&(r.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===h.toString()&&this._editors.delete(n.id)}if(l.value.addedDocuments){const i=[];for(const h of l.value.addedDocuments){const r=T.URI.revive(h.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const n=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,h);i.push(...h.cells.map(s=>u.ExtHostCell.asModelAddData(n.apiNotebook,s))),this._documents.get(r)?.dispose(),this._documents.set(r,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(l.value.addedEditors)for(const i of l.value.addedEditors){if(this._editors.has(i.id))return;const h=T.URI.revive(i.documentUri),r=this._documents.get(h);r&&this._createExtHostEditor(r,i.id,i)}const E=[];if(l.value.removedEditors)for(const i of l.value.removedEditors){const h=this._editors.get(i);h&&(this._editors.delete(i),this._activeNotebookEditor?.id===h.id&&(this._activeNotebookEditor=void 0),E.push(h))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const i=new Set;this._visibleNotebookEditors.forEach(h=>i.add(h.id));for(const h of this._editors.values()){const r=i.has(h.id);h._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const E=m.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new m.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>a.VSBuffer.wrap(r))],new m.ApiCommandResult("Notebook Data",r=>I.NotebookData.to(r.value))),h=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new d.SerializableObjectWithBuffers(I.NotebookData.from(r)))],new m.ApiCommandResult("Bytes",r=>r.buffer));l.registerApiCommand(i),l.registerApiCommand(h)}}e.ExtHostNotebookController=g,g._notebookStatusBarItemProviderHandlePool=0}),define(ye[208],De([1,0,16,14,20,5,7,25,2,27,15,4,36,8,6,64,168,24,40]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let A=class{constructor(n,s,t,c,_){this._initData=s,this._extHostNotebook=t,this._commands=c,this._logService=_,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(S.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",k=>!0,k=>{if(k&&"notebookEditor"in k&&"id"in k){const U=this._extHostNotebook.getIdByEditor(k.notebookEditor);return{id:k.id,extension:k.extension,notebookEditorId:U}}else if(k&&"notebookEditor"in k){const U=this._extHostNotebook.getIdByEditor(k.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${k.notebookEditor.document.uri.toString()}`);return{notebookEditorId:U}}return k})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(n,s,t,c,_,p){for(const le of this._kernelData.values())if(le.controller.id===s&&T.ExtensionIdentifier.equals(n.identifier,le.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const k=this._handlePool++,U=this;this._logService.trace(`NotebookController[${k}], CREATED by ${n.identifier.value}, ${s}`);const V=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${n.identifier}'`);let x=!1;const D=new y.DisposableStore,L=new M.Emitter,B=new M.Emitter,F={id:h(n.identifier,s),notebookType:t,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:c||n.identifier.value,preloads:p?p.map(I.NotebookRendererScript.from):[]};let K=_??V,H;this._proxy.$addKernel(k,F).catch(le=>{console.log(le),x=!0});let O=0;const ee=()=>{if(x)return;const le=++O;Promise.resolve().then(()=>{le===O&&this._proxy.$updateKernel(k,F)})},ce=new P.ResourceMap,oe={get id(){return s},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return F.label},set label(le){F.label=le??n.displayName??n.name,ee()},get detail(){return F.detail??""},set detail(le){F.detail=le,ee()},get description(){return F.description??""},set description(le){F.description=le,ee()},get kind(){return(0,o.checkProposedApiEnabled)(n,"notebookControllerKind"),F.kind??""},set kind(le){(0,o.checkProposedApiEnabled)(n,"notebookControllerKind"),F.kind=le,ee()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(le){F.supportedLanguages=le,ee()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(le){F.supportsExecutionOrder=le,ee()},get rendererScripts(){return F.preloads?F.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(le){K=le??V},get interruptHandler(){return H},set interruptHandler(le){H=le,F.supportsInterrupt=Boolean(le),ee()},createNotebookCellExecution(le){if(x)throw new Error("notebook controller is DISPOSED");if(!ce.has(le.notebook.uri))throw U._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return U._createNotebookCellExecution(le,h(n.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${k}], DISPOSED`),x=!0,this._kernelData.delete(k),D.dispose(),L.dispose(),B.dispose(),this._proxy.$removeKernel(k))},updateNotebookAffinity(le,te){U._proxy.$updateNotebookPriority(k,le.uri,te)},onDidReceiveMessage:B.event,postMessage(le,te){return(0,o.checkProposedApiEnabled)(n,"notebookMessaging"),U._proxy.$postMessage(k,te&&U._extHostNotebook.getIdByEditor(te),le)},asWebviewUri(le){return(0,o.checkProposedApiEnabled)(n,"notebookMessaging"),(0,d.asWebviewUri)(le,U._initData.remote)}};return this._kernelData.set(k,{extensionId:n.identifier,controller:oe,onDidReceiveMessage:B,onDidChangeSelection:L,associatedNotebooks:ce}),oe}getIdByController(n){for(const[s,t]of this._kernelData)if(t.controller===n)return h(t.extensionId,n.id);return null}$acceptNotebookAssociation(n,s,t){const c=this._kernelData.get(n);if(c){const _=this._extHostNotebook.getNotebookDocument(w.URI.revive(s));t?c.associatedNotebooks.set(_.uri,!0):c.associatedNotebooks.delete(_.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,_.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:_.apiNotebook})}}async $executeCells(n,s,t){const c=this._kernelData.get(n);if(!c)return;const _=this._extHostNotebook.getNotebookDocument(w.URI.revive(s)),p=[];for(const k of t){const U=_.getCell(k);U&&p.push(U.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,_.uri.toString(),p.length),await c.controller.executeHandler.call(c.controller,p,_.apiNotebook,c.controller)}catch(k){this._logService.error(`NotebookController[${n}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(n,s,t){const c=this._kernelData.get(n);if(!c)return;const _=this._extHostNotebook.getNotebookDocument(w.URI.revive(s));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,_.apiNotebook);else for(const p of t){const k=_.getCell(p);k&&this._activeExecutions.get(k.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,s,t){const c=this._kernelData.get(n);if(!c)return;const _=this._extHostNotebook.getEditorById(s);c.onDidReceiveMessage.fire(Object.freeze({editor:_.apiEditor,message:t}))}$cellExecutionChanged(n,s,t){const _=this._extHostNotebook.getNotebookDocument(w.URI.revive(n)).getCell(s);if(_){const p=t?I.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:_.apiCell,state:p})}}_createNotebookCellExecution(n,s){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const _=new E(s,c,this._proxy);this._activeExecutions.set(c.uri,_);const p=_.onDidChangeState(()=>{_.state===l.Resolved&&(_.dispose(),p.dispose(),this._activeExecutions.delete(c.uri))});return _.asApiObject()}};A=ze([$e(4,R.ILogService)],A),e.ExtHostNotebookKernels=A;var l;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(l||(l={}));class E extends y.Disposable{constructor(n,s,t){super(),this._cell=s,this._proxy=t,this._handle=E.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new i(10,c=>this.update(c)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const s=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let s=this._cell;if(n&&(s=this._cell.notebook.getCellFromApiCell(n)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(n){return n.map(s=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return t===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:t,id:s.id,metadata:s.metadata})})}async updateOutputs(n,s,t){const c=this.cellIndexToHandle(s),_=this.validateAndConvertOutputs((0,a.asArray)(n));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:c,append:t,outputs:_})}async updateOutputItems(n,s,t){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(n),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:n.map(I.NotebookCellOutputItem.from),outputId:s.id,append:t})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(t){n._executionOrder=t,n.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(t){if(n._state===l.Resolved||n._state===l.Started)throw new Error("Cannot call start again");n._state=l.Started,n._onDidChangeState.fire(),n.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(n._state===l.Resolved)throw new Error("Cannot call resolve twice");n._state=l.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new g.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return n.verifyStateForOutput(),n.updateOutputs([],t,!1)},appendOutput(t,c){return n.verifyStateForOutput(),n.updateOutputs(t,c,!0)},replaceOutput(t,c){return n.verifyStateForOutput(),n.updateOutputs(t,c,!1)},appendOutputItems(t,c){return n.verifyStateForOutput(),n.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return n.verifyStateForOutput(),n.updateOutputItems(t,c,!1)}})}}E.HANDLE=0;class i{constructor(n,s){this.delay=n,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new v.DeferredPromise,this.startedTimer=Date.now(),(0,v.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>n.complete())}}function h(r,n){return`${r.value}/${n}`}e.createKernelId=h}),define(ye[209],De([1,0,5,4,92]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(P,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(v.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,w,T){const R=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(w)?.fire({editor:R.apiEditor,message:T})}createRendererMessaging(P,w){if(!P.contributes?.notebookRenderer?.some(R=>R.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(R,S,m)=>this.getOrCreateEmitterFor(w).event(R,S,m),postMessage:(R,S)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const m=S&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.proxy.$postMessage(m?.id,w,R)}}}getOrCreateEmitterFor(P){let w=this._rendererMessageEmitters.get(P);return w||(w=new a.Emitter({onLastListenerRemove:()=>{w?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,w),w)}}e.ExtHostNotebookRenderers=M}),define(ye[210],De([1,0,20,5,7,4,2,6,11,16,29,61]),function(ie,e,a,v,b,M,y,P,w,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(I,f,d){const u=I.getProxy(M.MainContext.MainThreadQuickOpen);class o{constructor(s,t){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=t}showQuickPick(s,t,c=a.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(s),p=++this._instances,k=u.$show(p,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),U={},V=k.then(()=>U);return Promise.race([V,_]).then(x=>{if(x!==U)return _.then(D=>{const L=[];for(let B=0;B<D.length;B++){const F=D[B];typeof F=="string"?L.push({label:F,handle:B}):F.kind===P.QuickPickItemKind.Separator?L.push({type:"separator",label:F.label}):L.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:B})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{t.onDidSelectItem(D[B])}),u.$setItems(p,L),k.then(B=>{if(typeof B=="number")return D[B];if(Array.isArray(B))return B.map(F=>D[F])})})}).then(void 0,x=>{if(!(0,w.isCancellationError)(x))return u.$setError(p,x),Promise.reject(x)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,t=a.CancellationToken.None){return this._validateInput=s?.validateInput,u.$input(s,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,w.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(s){if(!this._validateInput)return;const t=await this._validateInput(s);if(!t||typeof t=="string")return t;let c;switch(t.severity){case P.InputBoxValidationSeverity.Info:c=R.default.Info;break;case P.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case P.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=t.message?R.default.Error:R.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(s,t=a.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!c)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(p=>p.uri.toString()===c.uri.toString())}createQuickPick(s){const t=new h(s,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(s){const t=new r(s,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(s,t){this._sessions.get(s)?._fireDidChangeValue(t)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,t){const c=this._sessions.get(s);c instanceof h&&c._fireDidChangeActive(t)}$onDidChangeSelection(s,t){const c=this._sessions.get(s);c instanceof h&&c._fireDidChangeSelection(t)}$onDidTriggerButton(s,t){this._sessions.get(s)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(s,t,c){const _=this._sessions.get(s);_ instanceof h&&_._fireDidTriggerItemButton(t,c)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class g{constructor(s,t){this._extensionId=s,this._onDidDispose=t,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new v.Emitter,this._onDidChangeValueEmitter=new v.Emitter,this._onDidTriggerButtonEmitter=new v.Emitter,this._onDidHideEmitter=new v.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((t,c)=>{const _=t===P.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(_,t)}),this.update({buttons:s.map((t,c)=>({...i(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const t=this._handlesToButtons.get(s);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(s){if(!this._disposed){for(const t of Object.keys(s)){const c=s[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function A(n){if(n instanceof P.ThemeIcon)return{id:n.id};const s=E(n),t=l(n);return{dark:typeof s=="string"?y.URI.file(s):s,light:typeof t=="string"?y.URI.file(t):t}}function l(n){return typeof n=="object"&&"light"in n?n.light:n}function E(n){return typeof n=="object"&&"dark"in n?n.dark:n}function i(n){const s=A(n.iconPath);let t,c;return"id"in s?c=S.ThemeIcon.asClassName(s):t=s,{iconPath:t,iconClass:c}}class h extends g{constructor(s,t){super(s.identifier,t),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new v.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new v.Emitter,this._onDidTriggerItemButtonEmitter=new v.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((c,_)=>{this._handlesToItems.set(_,c),this._itemsToHandles.set(c,_)});const t=[];for(let c=0;c<s.length;c++){const _=s[c];_.kind===P.QuickPickItemKind.Separator?t.push({type:"separator",label:_.label}):t.push({handle:c,label:_.label,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,buttons:_.buttons?.map((p,k)=>({...i(p),tooltip:p.tooltip,handle:k}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(s){const t=(0,T.coalesce)(s.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(s){const t=(0,T.coalesce)(s.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(s,t){const c=this._handlesToItems.get(s);if(!c||!c.buttons||!c.buttons.length)return;const _=c.buttons[t];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:c})}}class r extends g{constructor(s,t){super(s.identifier,t),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:R.default.Error}):this.update({validationMessage:s.message,severity:s.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new o(f,d)}e.createExtHostQuickOpen=m});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[211],De([1,0,2,5,55,7,14,4,16,118,15,27,61,8,24]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f){"use strict";var d,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(_){if(_)return typeof _.iconPath=="string"?a.URI.file(_.iconPath):a.URI.isUri(_.iconPath)||m.ThemeIcon.isThemeIcon(_.iconPath)?_.iconPath:void 0}function g(_,p){if(!_.iconPath&&!p.iconPath)return 0;if(_.iconPath){if(!p.iconPath)return 1}else return-1;const k=typeof _.iconPath=="string"?_.iconPath:a.URI.isUri(_.iconPath)?_.iconPath.fsPath:_.iconPath.id,U=typeof p.iconPath=="string"?p.iconPath:a.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(k,U)}function A(_,p){let k=0;if(_.strikeThrough!==p.strikeThrough)return _.strikeThrough?1:-1;if(_.faded!==p.faded)return _.faded?1:-1;if(_.tooltip!==p.tooltip)return(_.tooltip||"").localeCompare(p.tooltip||"");if(k=g(_,p),k!==0)return k;if(_.light&&p.light)k=g(_.light,p.light);else{if(_.light)return 1;if(p.light)return-1}if(k!==0)return k;if(_.dark&&p.dark)k=g(_.dark,p.dark);else{if(_.dark)return 1;if(p.dark)return-1}return k}function l(_,p){if(_.command!==p.command)return _.command<p.command?-1:1;if(_.title!==p.title)return _.title<p.title?-1:1;if(_.tooltip!==p.tooltip){if(_.tooltip!==void 0&&p.tooltip!==void 0)return _.tooltip<p.tooltip?-1:1;if(_.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(_.arguments===p.arguments)return 0;if(_.arguments)if(p.arguments){if(_.arguments.length!==p.arguments.length)return _.arguments.length-p.arguments.length}else return 1;else return-1;for(let k=0;k<_.arguments.length;k++){const U=_.arguments[k],V=p.arguments[k];if(U!==V)return U<V?-1:1}return 0}function E(_,p){let k=(0,T.comparePaths)(_.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(k!==0)return k;if(_.command&&p.command)k=l(_.command,p.command);else{if(_.command)return 1;if(p.command)return-1}if(k!==0)return k;if(_.decorations&&p.decorations)k=A(_.decorations,p.decorations);else{if(_.decorations)return 1;if(p.decorations)return-1}return k}function i(_,p){for(let k=0;k<_.length;k++)if(_[k]!==p[k])return!1;return!0}function h(_,p){return _.command===p.command&&_.title===p.title&&_.tooltip===p.tooltip&&(_.arguments&&p.arguments?i(_.arguments,p.arguments):_.arguments===p.arguments)}function r(_,p){return(0,w.equals)(_,p,h)}class n{constructor(p,k,U){this._extension=p,this._sourceControlHandle=U,d.set(this,void 0),this._value="",this._onDidChange=new v.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,d,k,"f")}get value(){return this._value}set value(p){p=p??"",Oe(this,d,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,d,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,d,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,d,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,d,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,k){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,d,"f").$showValidationMessage(this._sourceControlHandle,p,k)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,d=new WeakMap;class s{constructor(p,k,U,V,x){this._proxy=p,this._commands=k,this._sourceControlHandle=U,this._id=V,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new v.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,k){const U=this._resourceStatesCommandsMap.get(p);return U?(0,y.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(E),U=(0,w.sortedDiff)(this._resourceSnapshot,p,E).map(D=>{const L=D.toInsert.map(B=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,B);const K=B.resourceUri;let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ve=new M.DisposableStore;H=this._commands.converter.toInternal(B.command,ve),this._resourceStatesDisposablesMap.set(F,ve)}else this._resourceStatesCommandsMap.set(F,B.command);const O=o(B.decorations),ee=B.decorations&&o(B.decorations.light)||O,ce=B.decorations&&o(B.decorations.dark)||O,oe=[ee,ce],le=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,Ee=B.decorations&&!!B.decorations.faded,be=B.contextValue||"";return{rawResource:[F,K,oe,le,te,Ee,be,H],handle:F}});return{start:D.start,deleteCount:D.deleteCount,toInsert:L}}),V=U.map(({start:D,deleteCount:L,toInsert:B})=>[D,L,B.map(F=>F.rawResource)]),x=U.reverse();for(const{start:D,deleteCount:L,toInsert:B}of x){const F=B.map(H=>H.handle),K=this._handlesSnapshot.splice(D,L,...F);for(const H of K)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=p,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class t{constructor(p,k,U,V,x,D){this._extension=p,this._commands=U,this._id=V,this._label=x,this._rootUri=D,u.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new v.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,u,k,"f"),this._inputBox=new n(p,Oe(this,u,"f"),this.handle),Oe(this,u,"f").$registerSourceControl(this.handle,V,x,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,u,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,u,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,u,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=p;const k=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,u,"f").$updateSourceControl(this.handle,{acceptInputCommand:k})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=p;const k=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(U=>U.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,u,"f").$updateSourceControl(this.handle,{actionButton:k??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&r(this._statusBarCommands,p))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=p;const k=(p||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));Oe(this,u,"f").$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}createResourceGroup(p,k){const U=new s(Oe(this,u,"f"),this._commands,this.handle,p,k),V=v.Event.once(U.onDidDispose)(()=>this.createdResourceGroups.delete(U));return this.createdResourceGroups.set(U,V),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const p=[],k=[];for(const[U,V]of this.createdResourceGroups){V.dispose();const x=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});v.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),x.dispose(),this._groups.delete(U.handle),Oe(this,u,"f").$unregisterGroup(this.handle,U.handle)}),p.push([U.handle,U.id,U.label,U.features]);const D=U._takeResourceStateSnapshot();D.length>0&&k.push([U.handle,D]),this._groups.set(U.handle,U)}Oe(this,u,"f").$registerGroups(this.handle,p,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(k=>{const U=k._takeResourceStateSnapshot();U.length!==0&&p.push([k.handle,U])}),p.length>0&&Oe(this,u,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,u,"f").$unregisterSourceControl(this.handle)}}u=new WeakMap,t._handlePool=0,ze([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),ze([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Yi{constructor(p,k,U){this._commands=k,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new v.Emitter,this._proxy=p.getProxy(P.MainContext.MainThreadSCM),this._telemetry=p.getProxy(P.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const x=this._sourceControls.get(V.sourceControlHandle);if(!x)return V;const D=x.getResourceGroup(V.groupHandle);return D?D.getResourceState(V.handle):V}else if(V&&V.$mid===4){const x=this._sourceControls.get(V.sourceControlHandle);return x?x.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const x=this._sourceControls.get(V.handle);return x||V}return V}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,k,U,V){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,k,U,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const x=Yi._handlePool++,D=new t(p,this._proxy,this._commands,k,U,V);this._sourceControls.set(x,D);const L=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(p.identifier))||[];return L.push(D),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(p.identifier),L),D}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const k=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(p.identifier)),U=k&&k[k.length-1];return U&&U.inputBox}$provideOriginalResource(p,k,U){const V=a.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,V.toString());const x=this._sourceControls.get(p);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(V,U)).then(D=>D||null)}$onInputBoxValueChange(p,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const U=this._sourceControls.get(p);return U&&U.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(p,k,U,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,k,U);const x=this._sourceControls.get(p);if(!x)return Promise.resolve(void 0);const D=x.getResourceGroup(k);return D?D.$executeResourceCommand(U,V):Promise.resolve(void 0)}$validateInput(p,k,U){this.logService.trace("ExtHostSCM#$validateInput",p);const V=this._sourceControls.get(p);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>V.inputBox.validateInput(k,U)).then(x=>{if(!x)return Promise.resolve(void 0);const D=I.MarkdownString.fromStrict(x.message);return D?Promise.resolve([D,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};c._handlePool=0,c=ze([$e(2,R.ILogService)],c),e.ExtHostSCM=c}),define(ye[68],De([1,0,4,5,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(P){this._onDidChangePassword=new v.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,w){return this._proxy.$getPassword(P,w)}store(P,w,T){return this._proxy.$setPassword(P,w,T)}delete(P,w){return this._proxy.$deletePassword(P,w)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[212],De([1,0,6,4,133,7,8,10]),function(ie,e,a,v,b,M,y,P){"use strict";var w,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(f,d,u,o,g=a.StatusBarAlignment.Left,A){w.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Ye(this,w,f,"f"),Ye(this,T,d,"f"),this._entryId=R.ID_GEN++,this._extension=u,this._id=o,this._alignment=g,this._priority=this.validatePriority(A)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!R.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,T,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,T,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let d;this._name?d=this._name:d=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=y.MarkdownString.fromStrict(this._tooltip);Oe(this,w,"f").$setEntry(this._entryId,f,d,this._text,o,this._command?.internal,u,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,w=new WeakMap,T=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const d={message:f};return this._messages.unshift(d),this._update(),new a.Disposable(()=>{const u=this._messages.indexOf(d);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,d){this._proxy=f.getProxy(v.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new S(this)}createStatusBarEntry(f,d,u,o){return new R(this._proxy,this._commands,f,d,u,o)}setStatusBarMessage(f,d){const u=this._statusMessage.setMessage(f);let o;return typeof d=="number"?o=setTimeout(()=>u.dispose(),d):typeof d<"u"&&d.then(()=>u.dispose(),()=>u.dispose()),new a.Disposable(()=>{u.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=m}),define(ye[69],De([1,0,4,5,3]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(P){this._onDidChangeStorage=new v.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,w){this._proxy.$registerExtensionStorageKeysToSync(P,w)}initializeExtensionStorage(P,w,T){return this._proxy.$initializeExtensionStorage(P,w).then(R=>R||T)}setValue(P,w,T){return this._proxy.$setValue(P,w,T)}$acceptValue(P,w,T){this._onDidChangeStorage.fire({shared:P,key:w,value:T})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(ye[70],De([1,0,3,28,15,52,2]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,R,S){this._logService=R,this._extHostFileSystem=S,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(T){return y.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,R=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(T){if(this._value)return y.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return y.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=ze([$e(0,v.IExtHostInitDataService),$e(1,b.ILogService),$e(2,M.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[98],De([1,0,3,4,13]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,a.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(P){this._telemetryShape=P.getProxy(v.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(P,w,T){this._telemetryShape.$logTelemetryToOutputChannel(`${P.identifier.value}/${w}`,T)}};M=ze([$e(0,b.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(ye[53],De([1,0,5,4,3,2,13,7,6,134,11,169,20,42,154,61,10,14]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class g{constructor(t,c,_,p){this._proxy=t,this._id=c,this._creationOptions=_,this._name=p,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const k=this;this.value={get name(){return k._name||""},get processId(){return k._pidPromise},get creationOptions(){return k._creationOptions},get exitStatus(){return k._exitStatus},get state(){return k._state},sendText(U,V=!0){k._checkDisposed(),k._proxy.$sendText(k._id,U,V)},show(U){k._checkDisposed(),k._proxy.$show(k._id,U)},hide(){k._checkDisposed(),k._proxy.$hide(k._id)},dispose(){k._disposed||(k._disposed=!0,k._proxy.$dispose(k._id))},get dimensions(){if(!(k._cols===void 0||k._rows===void 0))return{columns:k._cols,rows:k._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,u.withNullAsUndefined)(t.shellPath),shellArgs:(0,u.withNullAsUndefined)(t.shellArgs),cwd:(0,u.withNullAsUndefined)(t.cwd),env:(0,u.withNullAsUndefined)(t.env),icon:(0,u.withNullAsUndefined)(r(t.iconPath)),color:d.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,u.withNullAsUndefined)(t.message),strictEnv:(0,u.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,u.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,_,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:_,color:d.ThemeColor.isThemeColor(p)?p.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,c){this._exitStatus=Object.freeze({code:t,reason:c})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=g;class A{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=A;let l=1,E=class extends P.Disposable{constructor(t,c){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(v.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[_,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const _=new g(this._proxy,(0,I.generateUuid)(),t,t.name),p=new A(t.pty);return _.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,r(t.iconPath),n(t.color)).then(k=>{const U=this._setupExtHostProcessListeners(k,p);this._terminalProcessDisposables[k]=U}),this._terminals.push(_),_.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const _=t.location.parentTerminal;if(_){const p=this._terminals.find(k=>k.value===_);p&&(c.resolvedExtHostIdentifier=p._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const p=new A(c),k=this._setupExtHostProcessListeners(t,p);this._terminalProcessDisposables[t]=k}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const _=this._getTerminalById(t);_&&(this._activeTerminal=_,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const _=this._getTerminalById(t);_&&this._onDidWriteTerminalData.fire({terminal:_.value,data:c})}async $acceptTerminalDimensions(t,c,_){const p=this._getTerminalById(t);p&&p.setDimensions(c,_)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,_){this._terminalProcesses.get(t)?.resize(c,_)}async $acceptTerminalTitleChange(t,c){const _=this._getTerminalById(t);_&&(_.name=c)}async $acceptTerminalClosed(t,c,_){const p=this._getTerminalObjectIndexById(this._terminals,t);if(p!==null){const k=this._terminals.splice(p,1)[0];k.setExitStatus(c,_),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(t,c,_,p){if(c){const V=this._getTerminalObjectIndexById(this._terminals,c);if(V!==null){this._terminals[V]._id=t,this._onDidOpenTerminal.fire(this.terminals[V]),this._terminals[V].isOpen=!0;return}}const k={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:M.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},U=new g(this._proxy,t,k,_);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(t,c){this._getTerminalById(t)?._setProcessId(c)}async $startExtensionTerminal(t,c){const _=this._getTerminalById(t);if(!_)return{message:(0,T.localize)(0,null,t)};_.isOpen||await new Promise(k=>{const U=this.onDidOpenTerminal(async V=>{V===_.value&&(U.dispose(),k())})});const p=this._terminalProcesses.get(t);p?p.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const _=new P.DisposableStore;_.add(c.onProcessReady(k=>this._proxy.$sendProcessReady(t,k.pid,k.cwd))),_.add(c.onDidChangeProperty(k=>this._proxy.$sendProcessProperty(t,k))),this._bufferer.startBuffering(t,c.onProcessData),_.add(c.onProcessExit(k=>this._onProcessExit(t,k))),this._terminalProcesses.set(t,c);const p=this._extensionTerminalAwaitingStart[t];return p&&c instanceof A&&(c.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),_}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,_){try{this._terminalProcesses.get(t)?.resize(c,_)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,_){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,_),this._proxy.$registerProfileProvider(c,t.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const _=new m.CancellationTokenSource().token;let p=await this._profileProviders.get(t)?.provideTerminalProfile(_);if(!_.isCancellationRequested){if(p&&!("options"in p)&&(p={options:p}),!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,c);return}this.createTerminalFromOptions(p.options,c)}}async $provideLinks(t,c){const _=this._getTerminalById(t);if(!_)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const k=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,k);const U=[],V={terminal:_.value,line:c},x=[];for(const B of this._linkProviders)x.push(o.Promises.withAsyncBody(async F=>{k.token.onCancellationRequested(()=>F({provider:B,links:[]}));const K=await B.provideTerminalLinks(V,k.token)||[];k.token.isCancellationRequested||F({provider:B,links:K})}));const D=await Promise.all(x);if(k.token.isCancellationRequested)return[];const L=new Map;for(const B of D)B&&B.links.length>0&&U.push(...B.links.map(F=>{const K={id:l++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return L.set(K.id,{provider:B.provider,link:F}),K}));return this._terminalLinkCache.set(t,L),U}$activateLink(t,c){const _=this._terminalLinkCache.get(t)?.get(c);!_||_.provider.handleTerminalLink(_.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const _=this._terminalProcessDisposables[t];_&&(_.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const _=this._getTerminalObjectIndexById(t,c);return _!==null?t[_]:null}_getTerminalObjectIndexById(t,c){let _=null;return t.some((p,k)=>p._id===c?(_=k,!0):!1),_}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const _=(0,S.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,_.length===0?void 0:_)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const _=c[0],p=new i(c[1]);this._setEnvironmentVariableCollection(_,p)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};E=ze([$e(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class i{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:w.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:w.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const _=this.map.get(t);(!_||_.value!==c.value||_.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((_,p)=>t.call(c,p,_,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let h=class extends E{constructor(t){super(!1,t)}createTerminal(t,c,_){throw new R.NotSupportedError}createTerminalFromOptions(t,c){throw new R.NotSupportedError}};h=ze([$e(0,y.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function n(s){return d.ThemeColor.isThemeColor(s)?s:void 0}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[213],De([1,0,16,23,20,5,173,97,7,26,10,42,4,13,93,8,6,47,65,48]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A){"use strict";var l,E;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(x,D){this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=x.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new r(this.proxy),D.registerArgumentProcessor({processArgument:L=>L?.$mid===13?(0,f.toItemFromContext)(L):L})}createTestController(x,D,L){if(this.controllers.has(x))throw new Error(`Attempt to insert a duplicate controller with ID "${x}"`);const B=new w.DisposableStore,F=B.add(new f.ExtHostTestItemCollection(x,D));F.root.label=D;const K=new Map,H=this.proxy,O={items:F.root.children,get label(){return D},set label(ce){D=ce,F.root.label=ce,H.$updateController(x,{label:D})},get refreshHandler(){return L},set refreshHandler(ce){L=ce,H.$updateController(x,{canRefresh:!!ce})},get id(){return x},createRunProfile:(ce,oe,le,te,Ee)=>{let be=(0,P.hash)(ce);for(;K.has(be);)be++;return new k(this.proxy,K,x,be,ce,oe,le,te,Ee)},createTestItem(ce,oe,le){return new f.TestItemImpl(x,ce,oe,le)},createTestRun:(ce,oe,le=!0)=>this.runTracker.createTestRun(x,F,ce,oe,le),set resolveHandler(ce){F.resolveHandler=ce},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};H.$registerTestController(x,D,!!L),B.add((0,w.toDisposable)(()=>H.$unregisterTestController(x)));const ee={controller:O,collection:F,profiles:K};return this.controllers.set(x,ee),B.add((0,w.toDisposable)(()=>this.controllers.delete(x))),B.add(F.onDidGenerateDiff(ce=>H.$publishDiff(x,ce.map(A.TestsDiffOp.serialize)))),O}createTestObserver(){return this.observer.checkout()}async runTests(x,D=b.CancellationToken.None){const L=n(x);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(L.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:x.include?.map(F=>o.TestId.fromExtHostTestItem(F,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:U[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:x.exclude?.map(F=>F.id)},D)}$provideFileCoverage(x,D,L){return(0,a.mapFind)(this.runTracker.trackers,F=>F.id===x?F.getCoverage(D):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(x,D,L,B){return(0,a.mapFind)(this.runTracker.trackers,K=>K.id===x?K.getCoverage(D):void 0)?.resolveFileCoverage(L,B)??Promise.resolve([])}$configureRunProfile(x,D){this.controllers.get(x)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(x,D){await this.controllers.get(x)?.controller.refreshHandler?.(D)}$publishTestResults(x){this.results=Object.freeze(x.map(D=>(0,T.deepFreeze)(d.TestResults.to(D))).concat(this.results).sort((D,L)=>L.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(x,D){const L=this.controllers.get(o.TestId.fromString(x).controllerId)?.collection;L&&(await L.expand(x,D<0?1/0:D),L.flushDiff())}$acceptDiff(x){this.observer.applyDiff(x.map(A.TestsDiffOp.deserialize))}async $runControllerTests(x,D){return Promise.all(x.map(L=>this.runControllerTestRequest(L,D)))}async runControllerTestRequest(x,D){const L=this.controllers.get(x.controllerId);if(!L)return{};const{collection:B,profiles:F}=L,K=F.get(x.profileId);if(!K)return{};const H=x.testIds.map(oe=>B.tree.get(oe)).filter(R.isDefined),O=x.excludeExtIds.map(oe=>L.collection.tree.get(oe)).filter(R.isDefined).filter(oe=>H.some(le=>le.fullId.compare(oe.fullId)===2));if(!H.length)return{};const ee=new u.TestRunRequest(H.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:H.map(oe=>oe.actual),O.map(oe=>oe.actual),K),ce=this.runTracker.prepareForMainThreadTestRun(ee,s.fromInternal(x,L.collection),D);try{return await K.runHandler(ee,D),{}}catch(oe){return{error:String(oe)}}finally{ce.isRunning&&!D.isCancellationRequested&&await M.Event.toPromise(ce.onEnd),ce.dispose()}}$cancelExtensionTestRun(x){x===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(x)}};i=ze([$e(0,I.IExtHostRpcService)],i),e.ExtHostTesting=i;class h extends w.Disposable{constructor(x,D,L){super(),this.dto=x,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(x){return this.tasks.get(x)?.coverage}createRun(x){const D=this.dto.id,L=this.dto.controllerId,B=(0,S.generateUuid)(),F=new t(this.proxy,D,B),K=ce=>(oe,...le)=>{if(O){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),ce(oe,...le))},H=(ce,oe)=>{const le=oe instanceof Array?oe.map(d.TestMessage.from):[d.TestMessage.from(oe)];if(ce.uri&&ce.range){const te={range:d.Range.from(ce.range),uri:ce.uri};for(const Ee of le)Ee.location=Ee.location||te}this.proxy.$appendTestMessagesInRun(D,B,o.TestId.fromExtHostTestItem(ce,L).toString(),le)};let O=!1;const ee={isPersisted:this.dto.isPersisted,token:this.cts.token,name:x,get coverageProvider(){return F.coverageProvider},set coverageProvider(ce){F.coverageProvider=ce},enqueued:K(ce=>{this.proxy.$updateTestStateInRun(D,B,o.TestId.fromExtHostTestItem(ce,L).toString(),1)}),skipped:K(ce=>{this.proxy.$updateTestStateInRun(D,B,o.TestId.fromExtHostTestItem(ce,L).toString(),5)}),started:K(ce=>{this.proxy.$updateTestStateInRun(D,B,o.TestId.fromExtHostTestItem(ce,L).toString(),2)}),errored:K((ce,oe,le)=>{H(ce,oe),this.proxy.$updateTestStateInRun(D,B,o.TestId.fromExtHostTestItem(ce,L).toString(),6,le)}),failed:K((ce,oe,le)=>{H(ce,oe),this.proxy.$updateTestStateInRun(D,B,o.TestId.fromExtHostTestItem(ce,L).toString(),4,le)}),passed:K((ce,oe)=>{this.proxy.$updateTestStateInRun(D,B,o.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,oe)}),appendOutput:(ce,oe,le)=>{O||(le&&(this.dto.isIncluded(le)?this.ensureTestIsKnown(le):le=void 0),this.proxy.$appendOutputToRun(D,B,v.VSBuffer.fromString(ce),oe&&d.location.from(oe),le&&o.TestId.fromExtHostTestItem(le,L).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(D,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:ee,coverage:F}),this.proxy.$startedTestRunTask(D,{id:B,name:x,running:!0}),ee}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(x){if(!(x instanceof f.TestItemImpl))throw new g.InvalidTestItemError(x.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString()))return;const D=[],L=this.dto.colllection.root;for(;;){const B=d.TestItem.from(x);if(D.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),x===L))break;x=x.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class r{constructor(x){this.proxy=x,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(x,D,L){return this.getTracker(x,D,L)}cancelRunById(x){for(const D of this.tracked.values())if(D.id===x){D.dispose();return}}cancelAllRuns(){for(const x of this.tracked.values())x.dispose()}createTestRun(x,D,L,B,F){const K=this.tracked.get(L);if(K)return K.createRun(B);const H=s.fromPublic(x,D,L,F),O=n(L);this.proxy.$startedExtensionTestRun({controllerId:x,profile:O&&{group:U[O.kind],id:O.profileId},exclude:L.exclude?.map(ce=>o.TestId.fromExtHostTestItem(ce,D.root.id).toString())??[],id:H.id,include:L.include?.map(ce=>o.TestId.fromExtHostTestItem(ce,D.root.id).toString())??[D.root.id],persist:F});const ee=this.getTracker(L,H);return ee.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),ee.createRun(B)}getTracker(x,D,L){const B=new h(D,this.proxy,L);return this.tracked.set(x,B),B.onEnd(()=>this.tracked.delete(x)),B}}e.TestRunCoordinator=r;const n=V=>{if(!!V.profile){if(!(V.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class s{constructor(x,D,L,B,F,K){this.controllerId=x,this.id=D,this.isPersisted=F,this.colllection=K,this.includePrefix=L.map(H=>H+"\0"),this.excludePrefix=B.map(H=>H+"\0")}static fromPublic(x,D,L,B){return new s(x,(0,S.generateUuid)(),L.include?.map(F=>o.TestId.fromExtHostTestItem(F,x).toString())??[x],L.exclude?.map(F=>o.TestId.fromExtHostTestItem(F,x).toString())??[],B,D)}static fromInternal(x,D){return new s(x.controllerId,x.runId,x.testIds,x.excludeExtIds,!0,D)}isIncluded(x){const D=o.TestId.fromExtHostTestItem(x,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(D===L||D.startsWith(L))return!1;for(const L of this.includePrefix)if(D===L||D.startsWith(L))return!0;return!1}}e.TestRunDto=s;class t{constructor(x,D,L){this.proxy=x,this.runId=D,this.taskId=L}set coverageProvider(x){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!x||(this._coverageProvider=x,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(x){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(x))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(x,D){const L=await this.fileCoverage;let B=L?.[x];return!this._coverageProvider||!L||!B?[]:(B.detailedCoverage||(B=L[x]=await this._coverageProvider.resolveFileCoverage?.(B,D)??B),B.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class c extends A.IncrementalChangeCollector{constructor(x){super(),this.emitter=x,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(x){this.added.add(x)}update(x){Object.assign(x.revived,d.TestItem.toPlain(x.item)),this.added.has(x)||this.updated.add(x)}remove(x){if(this.added.has(x)){this.added.delete(x);return}if(this.updated.delete(x),x.parent&&this.alreadyRemoved.has(x.parent)){this.alreadyRemoved.add(x.item.extId);return}this.removed.add(x)}getChangeEvent(){const{added:x,updated:D,removed:L}=this;return{get added(){return[...x].map(B=>B.revived)},get updated(){return[...D].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class _ extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(x){return this.items.get(x)}getMirroredTestDataByReference(x){return this.items.get(x.id)}createItem(x,D){return{...x,revived:d.TestItem.toPlain(x.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=_;class p{constructor(x){this.proxy=x}checkout(){this.current||(this.current=this.createObserverData());const x=this.current;return x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,get tests(){return[...x.tests.rootTests].map(D=>D.revived)},dispose:(0,y.once)(()=>{--x.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(x){return this.current?.tests.getMirroredTestDataByReference(x)}applyDiff(x){this.current?.tests.apply(x)}createObserverData(){const x=new _;return this.proxy.$subscribeToDiffs(),{observers:0,tests:x}}}class k{constructor(x,D,L,B,F,K,H,O=!1,ee=void 0){this.controllerId=L,this.profileId=B,this._label=F,this.kind=K,this.runHandler=H,this._isDefault=O,this._tag=ee,l.set(this,void 0),E.set(this,void 0),Ye(this,l,x,"f"),Ye(this,E,D,"f"),D.set(B,this);const ce=U[K];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:B,controllerId:L,tag:ee?d.TestTag.namespace(this.controllerId,ee.id):null,label:F,group:ce,isDefault:O,hasConfigurationHandler:!1})}get label(){return this._label}set label(x){x!==this._label&&(this._label=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:x}))}get isDefault(){return this._isDefault}set isDefault(x){x!==this._isDefault&&(this._isDefault=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:x}))}get tag(){return this._tag}set tag(x){x?.id!==this._tag?.id&&(this._tag=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:x?d.TestTag.namespace(this.controllerId,x.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(x){x!==this._configureHandler&&(this._configureHandler=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!x}))}dispose(){Oe(this,E,"f")?.delete(this.profileId)&&(Ye(this,E,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=k,l=new WeakMap,E=new WeakMap;const U={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(ye[214],De([1,0,16,5,4,94,8,6]),function(ie,e,a,v,b,M,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(R,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const S=this._extHostDocumentsAndEditors.allEditors();return R?S:S.map(m=>m.value)}async showTextDocument(R,S,m){let I;typeof S=="number"?I={position:y.ViewColumn.from(S),preserveFocus:m}:typeof S=="object"?I={position:y.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?y.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:I={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(R.uri,I),d=f&&this._extHostDocumentsAndEditors.getEditor(f);if(d)return d.value;throw f?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,S){return new M.TextEditorDecorationType(this._proxy,R,S).value}$acceptEditorPropertiesChanged(R,S){const m=this._extHostDocumentsAndEditors.getEditor(R);if(!m)throw new Error("unknown text editor");if(S.options&&m._acceptOptions(S.options),S.selections){const I=S.selections.selections.map(y.Selection.to);m._acceptSelections(I)}if(S.visibleRanges){const I=a.coalesce(S.visibleRanges.map(y.Range.to));m._acceptVisibleRanges(I)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...S.options,lineNumbers:y.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const I=P.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:I})}if(S.visibleRanges){const I=a.coalesce(S.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:I})}}$acceptEditorPositionData(R){for(const S in R){const m=this._extHostDocumentsAndEditors.getEditor(S);if(!m)throw new Error("Unknown text editor");const I=y.ViewColumn.to(R[S]);m.value.viewColumn!==I&&(m._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:I}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=w}),define(ye[215],De([1,0,2,3,4,7,6,8,10]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,v.createDecorator)("IExtHostTimeline");class T{constructor(m,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const d=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(R(d))?.get(f.handle)}return f}})}async $getTimeline(m,I,f,d){return this._providers.get(m)?.provideTimeline(a.URI.revive(I),f,d)}registerTimelineProvider(m,I,f,d){const u=new M.DisposableStore,o=this.convertTimelineItem(I.id,d,u).bind(this);let g;I.onDidChange&&(g=I.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:I.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:m,onDidChange:void 0,async provideTimeline(l,E,i){E?.resetCache&&(u.clear(),A.get(I.id)?.clear());const h=await I.provideTimeline(l,E,i);if(h==null)return;const r=o(l,E);return{...h,source:I.id,items:h.items.map(r)}},dispose(){for(const l of A.values())l.get(I.id)?.clear();g?.dispose(),u.dispose()}})}convertTimelineItem(m,I,f){return(d,u)=>{let o;if(u?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const A=R(d);o=g.get(A),o===void 0&&(o=new Map,g.set(A,o))}return g=>{const{iconPath:A,...l}=g,E=`${m}|${g.id??g.timestamp}`;o?.set(E,g);let i,h,r;g.iconPath&&(A instanceof y.ThemeIcon?r={id:A.id,color:A.color}:a.URI.isUri(A)?(i=A,h=A):{light:i,dark:h}=A);let n;return y.MarkdownString.isMarkdownString(l.tooltip)?n=P.MarkdownString.from(l.tooltip):(0,w.isString)(l.tooltip)?n=l.tooltip:y.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=P.MarkdownString.from(l.detail)):(0,w.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=l.detail),{...l,id:l.id??void 0,handle:E,source:m,command:g.command?I.toInternal(g.command,f):void 0,icon:i,iconDark:h,themeIcon:r,tooltip:n,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=T;function R(S){return S?.toString()}}),define(ye[216],De([1,0,7,12,2,4]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(w){this._openers=new Map,this._proxy=w.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,T,R,S){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const m=S.schemes.find(I=>!y.supportedSchemes.has(I));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,R),this._proxy.$registerUriOpener(T,S.schemes,w,S.label),(0,a.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(w,T,R){const S=this._openers.get(w);if(!S)throw new Error(`Unknown opener with id: ${w}`);const m=b.URI.revive(T);return S.canOpenExternalUri(m,R)}async $openUri(w,T,R){const S=this._openers.get(w);if(!S)throw new Error(`Unknown opener id: '${w}'`);return S.openExternalUri(b.URI.revive(T.resolvedUri),{sourceUri:b.URI.revive(T.sourceUri)},R)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([v.Schemas.http,v.Schemas.https])}),define(ye[217],De([1,0,4,2,7,11,27]),function(ie,e,a,v,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(T,R){if(this.handles.has(y.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const S=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(T)),this.handlers.set(S,R),this._proxy.$registerUriHandler(S,T),(0,b.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(T)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(T,R){const S=this.handlers.get(T);if(!S)return Promise.resolve(void 0);try{S.handleUri(v.URI.revive(R))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(T){return v.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[54],De([1,0,5,12,2,145,162,64,4]),function(ie,e,a,v,b,M,y,P,w){"use strict";var T,R,S,m,I,f,d,u,o,g,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class E{constructor(_,p,k,U,V,x,D){T.set(this,void 0),R.set(this,void 0),S.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),d.set(this,""),u.set(this,void 0),o.set(this,!1),g.set(this,!1),A.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new a.Emitter),this._onDidDispose=Oe(this,l,"f").event,Ye(this,T,_,"f"),Ye(this,R,p,"f"),Ye(this,u,k,"f"),Ye(this,m,U,"f"),Ye(this,I,V,"f"),Ye(this,f,x,"f"),Ye(this,A,i(x),"f"),Ye(this,S,D,"f")}dispose(){Ye(this,o,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return Ye(this,g,!0,"f"),(0,P.asWebviewUri)(_,Oe(this,m,"f"))}get cspSource(){const _=Oe(this,f,"f").extensionLocation;if(_.scheme===v.Schemas.https||_.scheme===v.Schemas.http){let p=_.toString();return p.endsWith("/")||(p+="/"),p+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,d,"f")}set html(_){this.assertNotDisposed(),Oe(this,d,"f")!==_&&(Ye(this,d,_,"f"),!Oe(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(Ye(this,g,!0,"f"),Oe(this,S,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,T,"f"),_))}get options(){return this.assertNotDisposed(),Oe(this,u,"f")}set options(_){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,T,"f"),n(Oe(this,f,"f"),Oe(this,I,"f"),_)),Ye(this,u,_,"f")}async postMessage(_){if(Oe(this,o,"f"))return!1;const p=(0,y.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Oe(this,A,"f")});return Oe(this,R,"f").$postMessage(Oe(this,T,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=E,T=new WeakMap,R=new WeakMap,S=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,o=new WeakMap,g=new WeakMap,A=new WeakMap,l=new WeakMap;function i(c){try{const _=(0,M.normalizeVersion)((0,M.parseVersion)(c.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class h{constructor(_,p,k,U,V){this.remoteInfo=p,this.workspace=k,this._logService=U,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=_.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(_,p,k){const U=this.getWebview(_);if(U){const{message:V}=(0,y.deserializeWebviewMessage)(p,k.value);U._onMessageEmitter.fire(V)}}$onMissingCsp(_,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,p,k){const U=new E(_,this._webviewProxy,s(p),this.remoteInfo,this.workspace,k,this._deprecationService);return this._webviews.set(_,U),U._onDidDispose(()=>{this._webviews.delete(_)}),U}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=h;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function n(c,_,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||t(c,_)}}e.serializeWebviewOptions=n;function s(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(_=>b.URI.from(_))}}e.reviveOptions=s;function t(c,_){return[...(_?.getWorkspaceFolders()||[]).map(p=>p.uri),c.extensionLocation]}}),define(ye[218],De([1,0,20,97,7,12,22,2,8,54,62,4,6]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(i,h){this.document=i,this._storagePath=h,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,h){await this.getEdit(i).undo(),h||this.disposeBackup()}async redo(i,h){await this.getEdit(i).redo(),h||this.disposeBackup()}disposeEdits(i){for(const h of i)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const h=this._edits.get(i,0);if(!h)throw new Error("No edit found");return h}}class f{constructor(){this._documents=new Map}get(i,h){return this._documents.get(this.key(i,h))}add(i,h,r){const n=this.key(i,h.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${i} resource:${h.uri}`);const s=new I(h,r);return this._documents.set(n,s),s}delete(i,h){const r=this.key(i,h.uri);this._documents.delete(r)}key(i,h){return`${i}@@@${h}`}}var d;(function(E){E[E.Text=0]="Text",E[E.Custom=1]="Custom"})(d||(d={}));class u{constructor(){this._providers=new Map}addTextProvider(i,h,r){return this.add(0,i,h,r)}addCustomProvider(i,h,r){return this.add(1,i,h,r)}get(i){return this._providers.get(i)}add(i,h,r,n){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:i,extension:r,provider:n}),new m.Disposable(()=>this._providers.delete(h))}}class o{constructor(i,h,r,n,s){this._extHostDocuments=h,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=s,this._editorProviders=new u,this._documents=new f,this._proxy=i.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,h,r,n){const s=new b.DisposableStore;return g(r)?(s.add(this._editorProviders.addTextProvider(h,i,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),h,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(s.add(this._editorProviders.addCustomProvider(h,i,r)),this.supportEditing(r)&&s.add(r.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(h,t.document.uri);if(A(t)){const _=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,h,_,t.label)}else this._proxy.$onContentChange(t.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),h,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),m.Disposable.from(s,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(i,h,r,n,s){const t=this._editorProviders.get(h);if(!t)throw new Error(`No provider found for '${h}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${h}'`);const c=P.URI.revive(i),_=await t.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:n?.buffer},s);let p;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(h,_,p),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(i,h){const r=this._editorProviders.get(h);if(!r)throw new Error(`No provider found for '${h}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${h}'`);const n=P.URI.revive(i),{document:s}=this.getCustomDocumentEntry(h,n);this._documents.delete(h,s),s.dispose()}async $resolveWebviewEditor(i,h,r,n,s,t){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const _=w.ViewColumn.to(s),p=this._extHostWebview.createNewWebview(h,n.webviewOptions,c.extension),k=this._extHostWebviewPanels.createNewWebviewPanel(h,r,n.title,_,n.panelOptions,p,!0),U=P.URI.revive(i);switch(c.type){case 1:{const{document:V}=this.getCustomDocumentEntry(r,U);return c.provider.resolveCustomEditor(V,k,t)}case 0:{const V=this._extHostDocuments.getDocument(U);return c.provider.resolveCustomTextEditor(V,k,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,h,r){this.getCustomDocumentEntry(h,i).disposeEdits(r)}async $onMoveCustomEditor(i,h,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const s=this._extHostWebviewPanels.getWebviewPanel(i);if(!s)throw new Error("No webview found");const t=P.URI.revive(h),c=this._extHostDocuments.getDocument(t);await n.provider.moveCustomTextEditor(c,s,a.CancellationToken.None)}async $undo(i,h,r,n){return this.getCustomDocumentEntry(h,i).undo(r,n)}async $redo(i,h,r,n){return this.getCustomDocumentEntry(h,i).redo(r,n)}async $revert(i,h,r){const n=this.getCustomDocumentEntry(h,i);await this.getCustomEditorProvider(h).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(i,h,r){const n=this.getCustomDocumentEntry(h,i);await this.getCustomEditorProvider(h).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(i,h,r,n){const s=this.getCustomDocumentEntry(h,i);return this.getCustomEditorProvider(h).saveCustomDocumentAs(s.document,P.URI.revive(r),n)}async $backup(i,h,r){const n=this.getCustomDocumentEntry(h,i),t=await this.getCustomEditorProvider(h).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(t),t.id}getCustomDocumentEntry(i,h){const r=this._documents.get(i,P.URI.revive(h));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=o;function g(E){return typeof E.resolveCustomTextEditor=="function"}function A(E){return typeof E.undo=="function"&&typeof E.redo=="function"}function l(E){const i=E.scheme===M.Schemas.file||E.scheme===M.Schemas.untitled?E.fsPath:E.toString();return(0,v.hash)(i)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[219],De([1,0,5,7,2,42,8,54,4,6]),function(ie,e,a,v,b,M,y,P,w,T){"use strict";var R,S,m,I,f,d,u,o,g,A,l,E,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends v.Disposable{constructor(t,c,_,p){super(),R.set(this,void 0),S.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),d.set(this,void 0),u.set(this,void 0),o.set(this,void 0),g.set(this,!0),A.set(this,void 0),l.set(this,!1),E.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,E,"f").event,i.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Oe(this,i,"f").event,Ye(this,R,t,"f"),Ye(this,S,c,"f"),Ye(this,I,_,"f"),Ye(this,m,p.viewType,"f"),Ye(this,f,p.panelOptions,"f"),Ye(this,o,p.viewColumn,"f"),Ye(this,d,p.title,"f"),Ye(this,A,p.active,"f")}dispose(){Oe(this,l,"f")||(Ye(this,l,!0,"f"),Oe(this,E,"f").fire(),Oe(this,S,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,I,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(t){this.assertNotDisposed(),Oe(this,d,"f")!==t&&(Ye(this,d,t,"f"),Oe(this,S,"f").$setTitle(Oe(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Oe(this,u,"f")}set iconPath(t){this.assertNotDisposed(),Oe(this,u,"f")!==t&&(Ye(this,u,t,"f"),Oe(this,S,"f").$setIconPath(Oe(this,R,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,o,"f")=="number"&&Oe(this,o,"f")<0))return Oe(this,o,"f")}get active(){return this.assertNotDisposed(),Oe(this,A,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(t){Oe(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ye(this,A,t.active,"f"),Ye(this,g,t.visible,"f"),Ye(this,o,t.viewColumn,"f"),Oe(this,i,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Oe(this,S,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof t>"u"?void 0:y.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,S=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,o=new WeakMap,g=new WeakMap,A=new WeakMap,l=new WeakMap,E=new WeakMap,i=new WeakMap;class r{constructor(t,c,_){this.webviews=c,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(w.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,M.generateUuid)()}createWebviewPanel(t,c,_,p,k={}){const U=typeof p=="object"?p.viewColumn:p,V={viewColumn:y.ViewColumn.from(U),preserveFocus:typeof p=="object"&&!!p.preserveFocus},x=(0,P.shouldSerializeBuffersForPostMessage)(t),D=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(t),D,c,{title:_,panelOptions:n(k),webviewOptions:(0,P.serializeWebviewOptions)(t,this.workspace,k),serializeBuffersForPostMessage:x},V);const L=this.webviews.createNewWebview(D,k,t);return this.createNewWebviewPanel(D,c,_,U,k,L,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((_,p)=>{const k=t[_],U=t[p];return k.active?1:U.active?-1:+k.visible-+U.visible});for(const _ of c){const p=this.getWebviewPanel(_);if(!p)continue;const k=t[_];p._updateViewState({active:k.active,visible:k.visible,viewColumn:y.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,_){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:_,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,_,p){const k=this._serializers.get(c);if(!k)throw new Error(`No serializer found for '${c}'`);const{serializer:U,extension:V}=k,x=this.webviews.createNewWebview(t,_.webviewOptions,V),D=this.createNewWebviewPanel(t,c,_.title,p,_.panelOptions,x,_.active);await U.deserializeWebviewPanel(D,_.state)}createNewWebviewPanel(t,c,_,p,k,U,V){const x=new h(t,this._proxy,U,{viewType:c,title:_,viewColumn:p,panelOptions:k,active:V});return this._webviewPanels.set(t,x),x}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function n(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[220],De([1,0,5,7,54,24,8,4,6]),function(ie,e,a,v,b,M,y,P,w){"use strict";var T,R,S,m,I,f,d,u,o,g,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends v.Disposable{constructor(r,n,s,t,c,_,p){super(),T.set(this,void 0),R.set(this,void 0),S.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,!1),d.set(this,void 0),u.set(this,void 0),o.set(this,void 0),g.set(this,void 0),A.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Oe(this,A,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,l,"f").event,Ye(this,S,s,"f"),Ye(this,u,t,"f"),Ye(this,T,r,"f"),Ye(this,R,n,"f"),Ye(this,m,c,"f"),Ye(this,I,_,"f"),Ye(this,d,p,"f")}dispose(){Oe(this,f,"f")||(Ye(this,f,!0,"f"),Oe(this,l,"f").fire(),Oe(this,m,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,u,"f")}set title(r){this.assertNotDisposed(),Oe(this,u,"f")!==r&&(Ye(this,u,r,"f"),Oe(this,R,"f").$setWebviewViewTitle(Oe(this,T,"f"),r))}get description(){return this.assertNotDisposed(),Oe(this,o,"f")}set description(r){this.assertNotDisposed(),Oe(this,o,"f")!==r&&(Ye(this,o,r,"f"),Oe(this,R,"f").$setWebviewViewDescription(Oe(this,T,"f"),r))}get visible(){return Oe(this,d,"f")}get webview(){return Oe(this,m,"f")}get viewType(){return Oe(this,S,"f")}_setVisible(r){r===Oe(this,d,"f")||Oe(this,f,"f")||(Ye(this,d,r,"f"),Oe(this,A,"f").fire())}get badge(){return this.assertNotDisposed(),(0,M.checkProposedApiEnabled)(Oe(this,I,"f"),"badges"),Oe(this,g,"f")}set badge(r){this.assertNotDisposed(),(0,M.checkProposedApiEnabled)(Oe(this,I,"f"),"badges"),!(r?.value===Oe(this,g,"f")?.value&&r?.tooltip===Oe(this,g,"f")?.tooltip)&&(Ye(this,g,y.ViewBadge.from(r),"f"),Oe(this,R,"f").$setWebviewViewBadge(Oe(this,T,"f"),r))}show(r){this.assertNotDisposed(),Oe(this,R,"f").$show(Oe(this,T,"f"),!!r)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,R=new WeakMap,S=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,o=new WeakMap,g=new WeakMap,A=new WeakMap,l=new WeakMap;class i{constructor(r,n){this._extHostWebview=n,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,n,s,t){if(this._viewProviders.has(n))throw new Error(`View provider for '${n}' already registered`);return this._viewProviders.set(n,{provider:s,extension:r}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(r),n,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(r)}),new w.Disposable(()=>{this._viewProviders.delete(n),this._proxy.$unregisterWebviewViewProvider(n)})}async $resolveWebviewView(r,n,s,t,c){const _=this._viewProviders.get(n);if(!_)throw new Error(`No view provider found for '${n}'`);const{provider:p,extension:k}=_,U=this._extHostWebview.createNewWebview(r,{},k),V=new E(r,this._proxy,n,s,U,k,!0);this._webviewViews.set(r,V),await p.resolveWebviewView(V,{state:t},c)}async $onDidChangeWebviewViewVisibility(r,n){this.getWebviewView(r)._setVisible(n)}async $disposeWebviewView(r){const n=this.getWebviewView(r);this._webviewViews.delete(r),n.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const n=this._webviewViews.get(r);if(!n)throw new Error("No webview found");return n}}e.ExtHostWebviewViews=i}),define(ye[99],De([1,0,5,4,2,12,9,3,13]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Ji{constructor(S){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ji.InitialState,this._proxy=S.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,m){let I;if(typeof S=="string"){I=S;try{S=b.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,y.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,I,m)}async asExternalUri(S,m){if((0,y.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(S,m);return b.URI.from(I)}};T.InitialState={focused:!0},T=ze([$e(0,w.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[221],De([1,0,192,28,13]),function(ie,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends a.AbstractExtHostConsoleForwarder{constructor(P,w){super(P,w)}_nativeConsoleLogMessage(P,w,T){w.apply(console,T)}};M=ze([$e(0,b.IExtHostRpcService),$e(1,v.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(ye[222],De([1,0,14,23,20,11,5,7,119,186,40]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(k,U){try{return JSON.stringify(k,U)}catch{return"null"}}const I="$$ref$$",f={[I]:-1};class d{constructor(U,V){this.jsonString=U,this.referencedBuffers=V}}function u(k,U=null,V=!1){const x=[];return{jsonString:(V?m:JSON.stringify)(k,(L,B)=>{if(typeof B>"u")return f;if(typeof B=="object"){if(B instanceof v.VSBuffer){const F=x.push(B)-1;return{[I]:F}}if(U)return U(L,B)}return B}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=u;function o(k,U,V){return JSON.parse(k,(x,D)=>{if(D){const L=D[I];if(typeof L=="number")return U[L];if(V&&D.$mid===1)return V.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=o;function g(k,U){return JSON.stringify(k,U)}function A(k){return k?(U,V)=>V&&V.$mid===1?k.transformOutgoing(V):V:null}var l;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class n extends P.Disposable{constructor(U,V=null,x=null){super(),this[S]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=U,this._logger=V,this._uriTransformer=x,this._uriReplacer=A(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,L=R.ProxyIdentifier.count;D<L;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(U=>{this._pendingRPCReplies[U].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(U){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(U){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(U){this._responsiveState!==U&&(this._responsiveState=U,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(U){return this._uriTransformer?(0,w.transformIncomingURIs)(U,this._uriTransformer):U}getProxy(U){const{nid:V,sid:x}=U;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,x)),this._proxies[V]}_createProxy(U,V){const x={get:(D,L)=>(typeof L=="string"&&!D[L]&&L.charCodeAt(0)===36&&(D[L]=(...B)=>this._remoteCall(U,L,B)),L===r?V:D[L])};return new Proxy(Object.create(null),x)}set(U,V){return this._locals[U.nid]=V,V}assertRegistered(U){for(let V=0,x=U.length;V<x;V++){const D=U[V];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(U){if(this._isDisposed)return;const V=U.byteLength,x=s.read(U,0),D=x.readUInt8(),L=x.readUInt32();switch(D){case 1:case 2:{let{rpcId:B,method:F,args:K}=c.deserializeRequestJSONArgs(x);this._uriTransformer&&(K=(0,w.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,L,B,F,K,D===2);break}case 3:case 4:{let{rpcId:B,method:F,args:K}=c.deserializeRequestMixedArgs(x);this._uriTransformer&&(K=(0,w.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,L,B,F,K,D===4);break}case 5:{this._logger?.logIncoming(V,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(V,L);break}case 7:{this._receiveReply(V,L,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(x);this._uriTransformer&&(B=(0,w.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(V,L,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(V,L,B);break}case 8:{const B=c.deserializeReplyOKVSBuffer(x);this._receiveReply(V,L,B);break}case 11:{let B=c.deserializeReplyErrError(x);this._uriTransformer&&(B=(0,w.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(V,L,B);break}case 12:{this._receiveReplyErr(V,L,void 0);break}default:console.error("received unexpected message"),console.error(U)}}_receiveRequest(U,V,x,D,L,B){this._logger?.logIncoming(U,V,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(x)}.${D}(`,L);const F=String(V);let K,H;if(B){const ee=new b.CancellationTokenSource;L.push(ee.token),K=this._invokeHandler(x,D,L),H=()=>ee.cancel()}else K=this._invokeHandler(x,D,L),H=i;this._cancelInvokedHandlers[F]=H;const O=c.serializeAcknowledged(V);this._logger?.logOutgoing(O.byteLength,V,1,"ack"),this._protocol.send(O),K.then(ee=>{delete this._cancelInvokedHandlers[F];const ce=c.serializeReplyOK(V,ee,this._uriReplacer);this._logger?.logOutgoing(ce.byteLength,V,1,"reply:",ee),this._protocol.send(ce)},ee=>{delete this._cancelInvokedHandlers[F];const ce=c.serializeReplyErr(V,ee);this._logger?.logOutgoing(ce.byteLength,V,1,"replyErr:",ee),this._protocol.send(ce)})}_receiveCancel(U,V){this._logger?.logIncoming(U,V,1,"receiveCancel");const x=String(V);this._cancelInvokedHandlers[x]?.()}_receiveReply(U,V,x){this._logger?.logIncoming(U,V,0,"receiveReply:",x);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const L=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],L.resolveOk(x)}_receiveReplyErr(U,V,x){this._logger?.logIncoming(U,V,0,"receiveReplyErr:",x);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const L=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let B;x&&(x.$isError?(B=new Error,B.name=x.name,B.message=x.message,B.stack=x.stack):B=x),L.resolveErr(B)}_invokeHandler(U,V,x){try{return Promise.resolve(this._doInvokeHandler(U,V,x))}catch(D){return Promise.reject(D)}}_doInvokeHandler(U,V,x){const D=this._locals[U];if(!D)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(U));const L=D[V];if(typeof L!="function")throw new Error("Unknown method "+V+" on actor "+(0,R.getStringIdentifierForProxy)(U));return L.apply(D,x)}_remoteCall(U,V,x){if(this._isDisposed)return new T.CanceledLazyPromise;let D=null;if(x.length>0&&b.CancellationToken.isCancellationToken(x[x.length-1])&&(D=x.pop()),D&&D.isCancellationRequested)return Promise.reject(M.canceled());const L=c.serializeRequestArguments(x,this._uriReplacer),B=++this._lastMessageId,F=String(B),K=new T.LazyPromise;D&&D.onCancellationRequested(()=>{const O=c.serializeCancel(B);this._logger?.logOutgoing(O.byteLength,B,0,"cancel"),this._protocol.send(c.serializeCancel(B))}),this._pendingRPCReplies[F]=K,this._onWillSendRequest(B);const H=c.serializeRequest(B,U,V,L,!!D);return this._logger?.logOutgoing(H.byteLength,B,0,`request: ${(0,R.getStringIdentifierForProxy)(U)}.${V}(`,x),this._protocol.send(H),K}}e.RPCProtocol=n,S=h,n.UNRESPONSIVE_TIME=3*1e3;class s{constructor(U,V){this._buff=U,this._offset=V}static alloc(U,V,x){const D=new s(v.VSBuffer.alloc(x+1+4),0);return D.writeUInt8(U),D.writeUInt32(V),D}static read(U,V){return new s(U,V)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(U){this._buff.writeUInt8(U,this._offset),this._offset+=1}readUInt8(){const U=this._buff.readUInt8(this._offset);return this._offset+=1,U}writeUInt32(U){this._buff.writeUInt32BE(U,this._offset),this._offset+=4}readUInt32(){const U=this._buff.readUInt32BE(this._offset);return this._offset+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this._buff.writeUInt8(U.byteLength,this._offset),this._offset+=1,this._buff.set(U,this._offset),this._offset+=U.byteLength}readShortString(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,x}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readLongString(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,x}writeBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readVSBuffer(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+U);return this._offset+=U,V}static sizeMixedArray(U){let V=0;V+=1;for(let x=0,D=U.length;x<D;x++){const L=U[x];switch(V+=1,L.type){case 1:V+=this.sizeLongString(L.value);break;case 2:V+=this.sizeVSBuffer(L.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)V+=this.sizeVSBuffer(L.buffers[B]);break;case 4:break}}return V}writeMixedArray(U){this._buff.writeUInt8(U.length,this._offset),this._offset+=1;for(let V=0,x=U.length;V<x;V++){const D=U[V];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let L=0;L<D.buffers.length;++L)this.writeBuffer(D.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(U);for(let x=0;x<U;x++)switch(this.readUInt8()){case 1:V[x]=this.readLongString();break;case 2:V[x]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),B=this.readLongString(),F=[];for(let K=0;K<L;++K)F.push(this.readVSBuffer());V[x]=new R.SerializableObjectWithBuffers(o(B,F,null));break}case 4:V[x]=void 0;break}return V}}s.sizeUInt32=4;var t;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(U){for(let V=0,x=U.length;V<x;V++)if(U[V]instanceof v.VSBuffer||U[V]instanceof R.SerializableObjectWithBuffers||typeof U[V]>"u")return!0;return!1}static serializeRequestArguments(U,V){if(this._useMixedArgSerialization(U)){const x=[];for(let D=0,L=U.length;D<L;D++){const B=U[D];if(B instanceof v.VSBuffer)x[D]={type:2,value:B};else if(typeof B>"u")x[D]={type:4};else if(B instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:K}=u(B.value,V);x[D]={type:3,value:v.VSBuffer.fromString(F),buffers:K}}else x[D]={type:1,value:v.VSBuffer.fromString(g(B,V))}}return{type:1,args:x}}return{type:0,args:g(U,V)}}static serializeRequest(U,V,x,D,L){switch(D.type){case 0:return this._requestJSONArgs(U,V,x,D.args,L);case 1:return this._requestMixedArgs(U,V,x,D.args,L)}}static _requestJSONArgs(U,V,x,D,L){const B=v.VSBuffer.fromString(x),F=v.VSBuffer.fromString(D);let K=0;K+=s.sizeUInt8(),K+=s.sizeShortString(B),K+=s.sizeLongString(F);const H=s.alloc(L?2:1,U,K);return H.writeUInt8(V),H.writeShortString(B),H.writeLongString(F),H.buffer}static deserializeRequestJSONArgs(U){const V=U.readUInt8(),x=U.readShortString(),D=U.readLongString();return{rpcId:V,method:x,args:JSON.parse(D)}}static _requestMixedArgs(U,V,x,D,L){const B=v.VSBuffer.fromString(x);let F=0;F+=s.sizeUInt8(),F+=s.sizeShortString(B),F+=s.sizeMixedArray(D);const K=s.alloc(L?4:3,U,F);return K.writeUInt8(V),K.writeShortString(B),K.writeMixedArray(D),K.buffer}static deserializeRequestMixedArgs(U){const V=U.readUInt8(),x=U.readShortString(),D=U.readMixedArray(),L=new Array(D.length);for(let B=0,F=D.length;B<F;B++){const K=D[B];typeof K=="string"?L[B]=JSON.parse(K):L[B]=K}return{rpcId:V,method:x,args:L}}static serializeAcknowledged(U){return s.alloc(5,U,0).buffer}static serializeCancel(U){return s.alloc(6,U,0).buffer}static serializeReplyOK(U,V,x){if(typeof V>"u")return this._serializeReplyOKEmpty(U);if(V instanceof v.VSBuffer)return this._serializeReplyOKVSBuffer(U,V);if(V instanceof R.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:L}=u(V.value,x,!0);return this._serializeReplyOKJSONWithBuffers(U,D,L)}else return this._serializeReplyOKJSON(U,m(V,x))}static _serializeReplyOKEmpty(U){return s.alloc(7,U,0).buffer}static _serializeReplyOKVSBuffer(U,V){let x=0;x+=s.sizeVSBuffer(V);const D=s.alloc(8,U,x);return D.writeVSBuffer(V),D.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static _serializeReplyOKJSON(U,V){const x=v.VSBuffer.fromString(V);let D=0;D+=s.sizeLongString(x);const L=s.alloc(9,U,D);return L.writeLongString(x),L.buffer}static _serializeReplyOKJSONWithBuffers(U,V,x){const D=v.VSBuffer.fromString(V);let L=0;L+=s.sizeUInt32,L+=s.sizeLongString(D);for(const F of x)L+=s.sizeVSBuffer(F);const B=s.alloc(10,U,L);B.writeUInt32(x.length),B.writeLongString(D);for(const F of x)B.writeBuffer(F);return B.buffer}static deserializeReplyOKJSON(U){const V=U.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(U,V){const x=U.readUInt32(),D=U.readLongString(),L=[];for(let B=0;B<x;++B)L.push(U.readVSBuffer());return new R.SerializableObjectWithBuffers(o(D,L,V))}static serializeReplyErr(U,V){const x=V?m(M.transformErrorForSerialization(V),null):void 0;if(typeof x!="string")return this._serializeReplyErrEmpty(U);const D=v.VSBuffer.fromString(x);let L=0;L+=s.sizeLongString(D);const B=s.alloc(11,U,L);return B.writeLongString(D),B.buffer}static deserializeReplyErrError(U){const V=U.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(U){return s.alloc(12,U,0).buffer}}var _;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(_||(_={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(ye[223],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(M){const y=P=>{self.removeEventListener("message",y);const w=P.data;Object.defineProperties(self,{postMessage:{value(T,R){w.postMessage(T,R)}},onmessage:{get(){return w.onmessage},set(T){w.onmessage=T}}}),w.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),w.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",y)}.toString();class v extends EventTarget{constructor(M,y,P){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${a})('${y}'))`,T=new Blob([w],{type:"application/javascript"}),R=URL.createObjectURL(T),S=new MessageChannel,m=R,I={type:"_newWorker",id:m,port:S.port2,url:R,options:P};M(I,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const d=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(d)}),S.port1.addEventListener("message",f=>{const d=new MessageEvent("message",{data:f.data});this.dispatchEvent(d)}),S.port1.start()}}e.NestedWorker=v}),define(ye[224],De([1,0,5,30,38,3,39,11,14]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var T;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(T=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(d=>f.push(d)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}v.Registry.add(e.Extensions.OutputChannels,new R);function S(I,f,d,u,o){return(0,w.createCancelablePromise)(async g=>{await(0,y.whenProviderRegistered)(d,u);const A=v.Registry.as(e.Extensions.OutputChannels);try{await m(d,1,u,o,g),A.registerChannel({id:I,label:f,file:d,log:!0})}catch(l){(0,P.isCancellationError)(l)||o.error("Error while registering log channel",d.toString(),(0,P.getErrorMessage)(l))}})}e.registerLogChannel=S;async function m(I,f,d,u,o){if(!await d.exists(I)){if(o.isCancellationRequested)throw new P.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");u.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,w.timeout)(1e3,o),await m(I,f+1,d,u,o)}}}),define(ye[100],De([1,0,4,7,3,13,15,224,52,28,35,113,23,10]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends v.Disposable{constructor(o,g,A,l){super(),this.id=o,this.name=g,this.logger=A,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(o){this.append(o+`
`)}append(o){this.write(o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const o=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,o)}replace(o){const g=this.offset;this.write(o),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,g),this.visible&&this.logger.flush()}show(o,g){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof o=="boolean"?o:g))}hide(){this.proxy.$close(this.id)}write(o){this.offset+=m.VSBuffer.fromString(o).byteLength,this.logger.info(o)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let d=class{constructor(o,g,A,l,E){this.extHostFileSystem=A,this.extHostFileSystemInfo=l,this.loggerService=E,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=o.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(g.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.visibleChannelId=o;for(const[g,A]of this.channels)A.visible=g===this.visibleChannelId}createOutputChannel(o,g,A){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if((0,I.isString)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(o,g,A);return l.then(E=>{this.channels.set(E.id,E),E.visible=E.id===this.visibleChannelId}),this.createExtHostOutputChannel(o,l)}async doCreateOutputChannel(o,g,A){const l=await this.createOutputDirectory(),E=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.loggerService.createLogger(E,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.proxy.$register(o,!1,E,g,A.identifier.value);return new f(h,o,i,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(o,g){let A=!1;const l=()=>{if(A)throw new Error("Channel has been closed")};return{get name(){return o},append(E){l(),g.then(i=>i.append(E))},appendLine(E){l(),g.then(i=>i.appendLine(E))},clear(){l(),g.then(E=>E.clear())},replace(E){l(),g.then(i=>i.replace(E))},show(E,i){l(),g.then(h=>h.show(E,i))},hide(){l(),g.then(E=>E.hide())},dispose(){A=!0,g.then(E=>E.dispose())}}}};d=ze([$e(0,M.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,w.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,y.ILoggerService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(ye[225],De([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[226],De([1,0,37,12,19,21,22,2,3,157,45,178,225]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let I=class Zi{constructor(d,u,o,g){this.localUserHome=d,this.remoteAgentService=u,this.environmentService=o,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome??d})()}hasValidBasename(d,u,o){return typeof u=="string"||typeof u>"u"?this.resolveOS.then(g=>this.doHasValidBasename(d,g,u)):this.doHasValidBasename(d,u,o)}doHasValidBasename(d,u,o){return d.scheme===v.Schemas.file||d.scheme===v.Schemas.vscodeRemote?(0,a.isValidBasename)(o??(0,y.basename)(d),u===1):!0}get defaultUriScheme(){return Zi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,u){if(d.remoteAuthority)return v.Schemas.vscodeRemote;const o=(0,T.getVirtualWorkspaceScheme)(u.getWorkspace());if(o)return o;const g=u.getWorkspace().folders[0];if(g)return g.uri.scheme;const A=u.getWorkspace().configuration;return A?A.scheme:v.Schemas.file}userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?b.win32:b.posix)}async fileURI(d){let u="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const g=d.indexOf("/",2);g===-1?(u=d.substring(2),d="/"):(u=d.substring(2,g),d=d.substring(g)||"/")}return P.URI.from({scheme:v.Schemas.file,authority:u,path:d,query:"",fragment:""})}};I=ze([$e(1,m.IRemoteAgentService),$e(2,S.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ye[101],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(y,P){this.line=y,this.character=P}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,P){return new a(0,0)}with(y){return new a(0,0)}}e.Position=a;class v{constructor(y,P,w,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(y,P),this.end=new a(w,T)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new v(0,0,0,0)}with(y){return new v(0,0,0,0)}}e.Range=v;var b;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],De([1,0,16,34,26,37,9,3,19,11,101,14]),function(ie,e,a,v,b,M,y,P,w,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",I=" characters skipped \u27EB",f=(m.length+I.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var d;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function o(oe){return!!oe.preview}e.resultIsMatch=o;function g(oe){return!!oe.resource}e.isFileMatch=g;function A(oe){return!!oe.message}e.isProgressMessage=A;var l;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class E{constructor(le){this.resource=le,this.results=[]}}e.FileMatch=E;class i{constructor(le,te,Ee){this.ranges=te;const be=Array.isArray(te)?te:[te];if(Ee&&Ee.matchLines===1&&h(be)){le=(0,y.getNLines)(le,Ee.matchLines);let ne="",ve=0,Pe=0;const Fe=Math.floor(Ee.charsPerLine/5),xe=[];for(const Qe of be){const Ie=Math.max(Qe.startColumn-Fe,0),Se=Qe.startColumn+Ee.charsPerLine;if(Ie>Pe+Fe+f){const Te=m+(Ie-Pe)+I;ne+=Te+le.slice(Ie,Se),ve+=Ie-(Pe+Te.length)}else ne+=le.slice(Pe,Se);xe.push(new n(0,Qe.startColumn-ve,Qe.endColumn-ve)),Pe=Se}this.preview={text:ne,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const ne=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:le,matches:(0,a.mapArrayOrNot)(te,ve=>new r(ve.startLineNumber-ne,ve.startColumn,ve.endLineNumber-ne,ve.endColumn))}}}}e.TextSearchMatch=i;function h(oe){const le=oe[0].startLineNumber;for(const te of oe)if(te.startLineNumber!==le||te.endLineNumber!==le)return!1;return!0}class r{constructor(le,te,Ee,be){this.startLineNumber=le,this.startColumn=te,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=r;class n extends r{constructor(le,te,Ee){super(le,te,le,Ee)}}e.OneLineRange=n;var s;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,le=!0){const te=oe&&oe.files&&oe.files.exclude,Ee=le&&oe&&oe.search&&oe.search.exclude;if(!te&&!Ee)return;if(!te||!Ee)return te||Ee;let be=Object.create(null);return be=b.mixin(be,b.deepClone(te)),be=b.mixin(be,b.deepClone(Ee),!0),be}e.getExcludes=t;function c(oe,le){return oe.excludePattern&&v.match(oe.excludePattern,le)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&v.match(oe.includePattern,le)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(te=>{const Ee=te.folder.fsPath;if(M.isEqualOrParent(le,Ee)){const be=w.relative(Ee,le);return!te.includePattern||!!v.match(te.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var _;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(_=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(le,te){super(le),this.code=te}}e.SearchError=p;function k(oe){const le=oe.message;if((0,T.isCancellationError)(oe))return new p(le,_.canceled);try{const te=JSON.parse(le);return new p(te.message,te.code)}catch{return new p(le,_.other)}}e.deserializeSearchError=k;function U(oe){const le={message:oe.message,code:oe.code};return new Error(JSON.stringify(le))}e.serializeSearchError=U;function V(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=V;function x(oe){return oe.type==="success"}e.isSerializedSearchSuccess=x;function D(oe){return!!oe.path}e.isSerializedFileMatch=D;function L(oe,le){const te=oe.searchPath?oe.searchPath:oe.relativePath;return(0,y.fuzzyContains)(te,le)}e.isFilePatternMatch=L;class B{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function F(oe,le){const te={...oe||{},...le||{}};return Object.keys(te).filter(Ee=>{const be=te[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=F;class K{constructor(le,te){this._parsedIncludeExpression=null,this._excludeExpression={...le.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=v.parse(this._excludeExpression);let Ee=le.includePattern;te.includePattern&&(Ee?Ee={...Ee,...te.includePattern}:Ee=te.includePattern),Ee&&(this._parsedIncludeExpression=v.parse(Ee))}matchesExcludesSync(le,te,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,te,Ee))}includedInQuerySync(le,te,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,te,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(le,te,Ee))}includedInQuery(le,te,Ee){const be=this._parsedExcludeExpression(le,te,Ee),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(le,te,Ee):!0;return(0,S.isThenable)(be)?be.then(ve=>ve?!1:ne()):ne()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=K;function H(oe){for(const le in oe)if(typeof oe[le]!="boolean")return!0;return!1}function O(oe){if(!oe)return;let le;return te=>(le||(le=(oe()||Promise.resolve([])).then(Ee=>Ee?ce(Ee):{})),le.then(Ee=>!!Ee[te]))}e.hasSiblingPromiseFn=O;function ee(oe){if(!oe)return;let le;return te=>{if(!le){const Ee=oe();le=Ee?ce(Ee):{}}return!!le[te]}}e.hasSiblingFn=ee;function ce(oe){const le={};for(const te of oe)le[te]=!0;return le}}),define(ye[31],De([1,0,16,14,20,5,7,25,12,108,22,9,10,2,136,3,15,149,45,35,28,13,8,6,46,41,4]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l,E,i,h,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function t(D,L,B){return new R.ExtUri(F=>k(F,B)).isEqual(D,L)}function c(D,L,B){return t(D.uri,L.uri,B)?0:(0,S.compare)(D.uri.toString(),L.uri.toString())}function _(D,L,B){return D.index!==L.index?D.index<L.index?-1:1:t(D.uri,L.uri,B)?(0,S.compare)(D.name,L.name):(0,S.compare)(D.uri.toString(),L.uri.toString())}function p(D,L,B,F){const K=D.slice(0).sort((O,ee)=>B(O,ee,F)),H=L.slice(0).sort((O,ee)=>B(O,ee,F));return(0,a.delta)(K,H,(O,ee)=>B(O,ee,F))}function k(D,L){const B=L.getCapabilities(D.scheme);return!(B&&B&1024)}class U extends g.Workspace{constructor(L,B,F,K,H,O,ee){super(L,F.map(ce=>new g.WorkspaceFolder(ce)),K,H,ee),this._name=B,this._isUntitled=O,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(ee),F.forEach(ce=>{this._workspaceFolders.push(ce),this._structure.set(ce.uri,ce)})}static toExtHostWorkspace(L,B,F,K){if(!L)return{workspace:null,added:[],removed:[]};const{id:H,name:O,folders:ee,configuration:ce,transient:oe,isUntitled:le}=L,te=[],Ee=B;B?ee.forEach((Pe,Fe)=>{const xe=I.URI.revive(Pe.uri),Qe=U._findFolder(F||B,xe,K);Qe?(Qe.name=Pe.name,Qe.index=Pe.index,te.push(Qe)):te.push({uri:xe,name:Pe.name,index:Fe})}):te.push(...ee.map(({uri:Pe,name:Fe,index:xe})=>({uri:I.URI.revive(Pe),name:Fe,index:xe}))),te.sort((Pe,Fe)=>Pe.index<Fe.index?-1:1);const be=new U(H,O,te,!!oe,ce?I.URI.revive(ce):null,!!le,Pe=>k(Pe,K)),{added:ne,removed:ve}=p(Ee?Ee.workspaceFolders:[],be.workspaceFolders,c,K);return{workspace:be,added:ne,removed:ve}}static _findFolder(L,B,F){for(let K=0;K<L.folders.length;K++){const H=L.workspaceFolders[K];if(t(H.uri,B,F))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,R.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let V=class{constructor(L,B,F,K,H){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=F,this._uriTransformerService=H,this._requestIdProvider=new T.Counter,this._barrier=new v.Barrier,this._proxy=L.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(s.MainContext.MainThreadMessageService);const O=B.workspace;this._confirmedWorkspace=O?new U(O.id,O.name,[],!!O.transient,O.configuration?I.URI.revive(O.configuration):null,!!O.isUntitled,ee=>k(ee,F)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?I.URI.from({scheme:w.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,F,...K){const H=[];if(Array.isArray(K)&&K.forEach(le=>{I.URI.isUri(le.uri)&&!H.some(te=>t(te.uri,le.uri,this._extHostFileSystemInfo))&&H.push({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[B,F].some(le=>typeof le!="number"||le<0)||F===0&&H.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+F>O.length)return!1;const ee=O.slice(0);ee.splice(B,F,...H.map(le=>({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<ee.length;le++){const te=ee[le];if(ee.some((Ee,be)=>be!==le&&t(te.uri,Ee.uri,this._extHostFileSystemInfo)))return!1}ee.forEach((le,te)=>le.index=te);const{added:ce,removed:oe}=p(O,ee,_,this._extHostFileSystemInfo);if(ce.length===0&&oe.length===0)return!1;if(this._proxy){const le=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(le,B,F,H).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const Ee={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(o.Severity.Error,(0,f.localize)(0,null,le,te.toString()),Ee,[])})}return this.trySetWorkspaceFolders(ee),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let F,K="";if(typeof L=="string"?(F=I.URI.file(L),K=L):typeof L<"u"&&(F=L,K=L.fsPath),!F)return K;const H=this.getWorkspaceFolder(F,!0);if(!H)return K;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let O=(0,R.relativePath)(H.uri,F);return B&&H.name&&(O=`${H.name}/${O}`),O}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=U.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:F,removed:K}=U.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:K}))}findFiles(L,B,F,K,H=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let O;if(B===null?O=!1:B&&(typeof B=="string"?O=B:O=B.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:ce}=x(i.GlobPattern.from(L));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(ee),(0,m.withUndefinedAsNull)(ce),(0,m.withUndefinedAsNull)(O),(0,m.withUndefinedAsNull)(F),H).then(oe=>Array.isArray(oe)?oe.map(le=>I.URI.revive(le)):[])}async findTextInFiles(L,B,F,K,H=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),ee=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ce,folder:oe}=x(i.GlobPattern.from(B.include)),le=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,te={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ee,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ce,excludePattern:le},Ee=!1;if(this._activeSearchCallbacks[O]=be=>{if(Ee)return;const ne=I.URI.revive(be.resource);be.results.forEach(ve=>{(0,n.resultIsMatch)(ve)?F({uri:ne,preview:{text:ve.preview.text,matches:(0,a.mapArrayOrNot)(ve.preview.matches,Pe=>new h.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,a.mapArrayOrNot)(ve.ranges,Pe=>new h.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):F({uri:ne,text:ve.text,lineNumber:ve.lineNumber})})},H.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(L,(0,m.withUndefinedAsNull)(oe),te,O,H);return delete this._activeSearchCallbacks[O],be||{}}catch(be){throw delete this._activeSearchCallbacks[O],be}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,B){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,B);const F=this._uriTransformerService.transformOutgoingScheme(L),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,F),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(L,B){this._logService.info("Getting edit session identifier for workspaceFolder",L);const F=await this.resolveWorkspaceFolder(I.URI.revive(L));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const K=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!K),!K)return;const H=await K.provideEditSessionIdentity(F,B);if(this._logService.info("Provider returned edit session identifier: ",H),!!H)return H}};V=ze([$e(0,E.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,A.IExtHostFileSystemInfo),$e(3,u.ILogService),$e(4,r.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function x(D){let L,B;return D&&(typeof D=="string"?L=D:(L=D.pattern,B=I.URI.revive(D.baseUri))),{includePattern:L,folder:B}}}),define(ye[32],De([1,0,26,5,31,4,6,152,83,10,14,3,13,15,2]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(h,r){if(r){const n=r.split(".");let s=h;for(let t=0;s&&t<n.length;t++)s=s[n[t]];return s}}function u(h){return h instanceof f.URI}function o(h){return h&&h.uri instanceof f.URI&&h.languageId&&typeof h.languageId=="string"}function g(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function A(h){return h&&h.uri instanceof f.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function l(h){if(u(h))return{resource:h};if(o(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(g(h))return{overrideIdentifier:h.languageId};if(A(h))return{resource:h.uri};if(h===null)return{resource:null}}let E=class{constructor(r,n,s){this._proxy=r.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,n))}};E=ze([$e(0,m.IExtHostRpcService),$e(1,b.IExtHostWorkspace),$e(2,I.ILogService)],E),e.ExtHostConfiguration=E;class i{constructor(r,n,s,t){this._onDidChangeConfiguration=new v.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,s))}getConfiguration(r,n,s){const t=l(n)||{},c=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,s?.identifier);function _(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(k){return typeof d(c,k)<"u"},get:(k,U)=>{this._validateConfigurationAccess(r?`${r}.${k}`:k,t,s?.identifier);let V=d(c,k);if(typeof V>"u")V=U;else{let x;const D=(L,B)=>{let F;const K=()=>{x=x||(0,a.deepClone)(c),F=F||d(x,B)};return(0,T.isObject)(L)?new Proxy(L,{get:(H,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return K(),()=>F;if(x)return F=F||d(x,B),F[O];const ee=H[O];return typeof O=="string"?D(ee,`${B}.${O}`):ee},set:(H,O,ee)=>(K(),F&&(F[O]=ee),!0),deleteProperty:(H,O)=>(K(),F&&delete F[O],!0),defineProperty:(H,O,ee)=>(K(),F&&Object.defineProperty(F,O,ee),!0)}):L};V=D(V,k)}return V},update:(k,U,V,x)=>{k=r?`${r}.${k}`:k;const D=_(V);return U!==void 0?this._proxy.$updateConfigurationOption(D,k,U,t,x):this._proxy.$removeConfigurationOption(D,k,t,x)},inspect:k=>{k=r?`${r}.${k}`:k;const U=(0,a.deepClone)(this._configuration.inspect(k,t,this._extHostWorkspace.workspace));if(U)return{key:k,defaultValue:U.policy?.value??U.default?.value,globalValue:U.user?.value??U.application?.value,workspaceValue:U.workspace?.value,workspaceFolderValue:U.workspaceFolder?.value,defaultLanguageValue:U.default?.override,globalLanguageValue:U.user?.override??U.application?.override,workspaceLanguageValue:U.workspace?.override,workspaceFolderLanguageValue:U.workspaceFolder?.override,languageIds:U.overrideIdentifiers}}};return typeof c=="object"&&(0,a.mixin)(p,c,!1),Object.freeze(p)}_toReadonlyValue(r){const n=s=>(0,T.isObject)(s)?new Proxy(s,{get:(t,c)=>n(t[c]),set:(t,c,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return n(r)}_validateConfigurationAccess(r,n,s){const t=w.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=s?`[${s.value}] `:"";if(t===4){typeof n?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const s=new P.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>s.affectsConfiguration(t,l(c))})}_toMap(r){return r.reduce((n,s)=>(n.set(s[0],s[1]),n),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[102],De([1,0,2,14,5,4,6,31,50,32,20,53,13,28,3,12,21,15,67,185,11]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(B){function F(O){if(O){const ee=O;return ee&&!!ee.process}else return!1}B.is=F;function K(O){if(O==null)return;const ee={process:O.process,args:O.args};return O.options&&(ee.options=r.from(O.options)),ee}B.from=K;function H(O){if(O!=null)return new y.ProcessExecution(O.process,O.args,O.options)}B.to=H})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(B){function F(O){if(O){const ee=O;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}B.is=F;function K(O){if(O==null)return;const ee={};return O.commandLine!==void 0?ee.commandLine=O.commandLine:(ee.command=O.command,ee.args=O.args),O.options&&(ee.options=s.from(O.options)),ee}B.from=K;function H(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new y.ShellExecution(O.commandLine,O.options):new y.ShellExecution(O.command,O.args?O.args:[],O.options)}B.to=H})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(B){function F(O){if(O){const ee=O;return ee&&ee.customExecution==="customExecution"}else return!1}B.is=F;function K(O){return{customExecution:"customExecution"}}B.from=K;function H(O,ee){return ee.get(O)}B.to=H})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(B){function F(K,H){let O;return K.scope!==void 0&&typeof K.scope!="number"?O=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===y.TaskScope.Workspace&&H&&H.workspaceFile?O=H.workspaceFile:O=A.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:O}}B.from=F})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(B){function F(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}B.from=F})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var k;(function(B){function F(O,ee){if(O==null)return[];const ce=[];for(const oe of O){const le=K(oe,ee);le&&ce.push(le)}return ce}B.fromMany=F;function K(O,ee){if(O==null)return;let ce;O.execution instanceof y.ProcessExecution?ce=n.from(O.execution):O.execution instanceof y.ShellExecution?ce=t.from(O.execution):O.execution&&O.execution instanceof y.CustomExecution&&(ce=c.from(O.execution));const oe=i.from(O.definition);let le;return O.scope?typeof O.scope=="number"?le=O.scope:le=O.scope.uri:le=y.TaskScope.Workspace,!oe||!le?void 0:{_id:O._id,definition:oe,name:O.name,source:{extensionId:ee.identifier.value,label:O.source,scope:le},execution:ce,isBackground:O.isBackground,group:p.from(O.group),presentationOptions:h.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}B.from=K;async function H(O,ee,ce){if(O==null)return;let oe;n.is(O.execution)?oe=n.to(O.execution):t.is(O.execution)?oe=t.to(O.execution):c.is(O.execution)&&(oe=c.to(O._id,ce));const le=i.to(O.definition);let te;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?te=O.source.scope:te=await ee.resolveWorkspaceFolder(a.URI.revive(O.source.scope)):te=y.TaskScope.Workspace),!le||!te)return;const Ee=new y.Task(le,te,O.name,O.source.label,oe,O.problemMatchers);return O.isBackground!==void 0&&(Ee.isBackground=O.isBackground),O.group!==void 0&&(Ee.group=y.TaskGroup.from(O.group._id),Ee.group&&O.group.isDefault&&(Ee.group=new y.TaskGroup(Ee.group.id,Ee.group.label),O.group.isDefault===!0&&(Ee.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Ee.presentationOptions=h.to(O.presentationOptions)),O._id&&(Ee._id=O._id),O.detail&&(Ee.detail=O.detail),Ee}B.to=H})(k=e.TaskDTO||(e.TaskDTO={}));var U;(function(B){function F(H){return H}B.from=F;function K(H){if(!!H)return Object.assign(Object.create(null),H)}B.to=K})(U=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(F,K,H){this._id=K,this._task=H,E.set(this,void 0),Ye(this,E,F,"f")}get task(){return this._task}terminate(){Oe(this,E,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}E=new WeakMap;var x;(function(B){function F(K){return{id:K._id,task:void 0}}B.from=F})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(F,K,H,O,ee,ce,oe,le){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=F.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=O,this._configurationService=ee,this._terminalService=ce,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,K,H){if(!H)return new y.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:K,provider:H,extension:F}),this._proxy.$registerTaskProvider(O,K),new y.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(F,K){this._proxy.$registerTaskSystem(F,K)}fetchTasks(F){return this._proxy.$fetchTasks(U.from(F)).then(async K=>{const H=[];for(const O of K){const ee=await k.to(O,this._workspaceProvider,this._providedCustomExecutions2);ee&&H.push(ee)}return H})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(K=>F.push(K)),F}terminateTask(F){if(!(F instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,K,H){const O=this._providedCustomExecutions2.get(F.id);O&&(this._activeCustomExecutions2.set(F.id,O),this._terminalService.attachPtyToTerminal(K,await O.callback(H))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const K=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const K=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:K,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const K=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:F.exitCode})}$provideTasks(F,K){const H=this._handlers.get(F);if(!H)return Promise.reject(new Error("no handler found"));const O=[],ee=(0,v.asPromise)(()=>H.provider.provideTasks(R.CancellationToken.None)).then(ce=>this.provideTasksInternal(K,O,H,ce));return new Promise(ce=>{ee.then(oe=>{Promise.all(O).then(()=>{ce(oe)})})})}async $resolveTask(F,K){const H=this._handlers.get(F);if(!H)return Promise.reject(new Error("no handler found"));if(K.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${H.type}].`);const O=await k.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const ee=await H.provider.resolveTask(O,R.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,H);const ce=k.from(ee,H.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(ce.execution)&&await this.addCustomExecution(ce,ee,!0),await this.resolveTaskInternal(ce)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,K,H){const O=await this._proxy.$createTaskId(F);!H&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,K.execution)),this._providedCustomExecutions2.set(O,K.execution)}async getTaskExecution(F,K){if(typeof F=="string"){const ee=this._taskExecutionPromises.get(F);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}const H=this._taskExecutionPromises.get(F.id);if(H)return H;const O=new Promise((ee,ce)=>{function oe(le,te,Ee){Ee?ee(new V(le,te.id,Ee)):ce("Unexpected: Task does not exist.")}K?oe(this,F,K):k.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(le=>oe(this,F,le))});return this._taskExecutionPromises.set(F.id,O),O.then(ee=>(this._taskExecutions.set(F.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(F,K){F._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const H=this._notProvidedCustomExecutions.values();let O=H.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=H.next()}};D=ze([$e(0,m.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,w.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,S.IExtHostTerminalService),$e(6,o.ILogService),$e(7,g.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let L=class extends D{constructor(F,K,H,O,ee,ce,oe,le){super(F,K,H,O,ee,ce,oe,le),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(F,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const H=k.from(K,F);if(H===void 0)throw new Error("Task is not valid");if(c.is(H.execution))await this.addCustomExecution(H,K,!1);else throw new l.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),K);return this._proxy.$executeTask(H).catch(ee=>{throw new Error(ee)}),O}provideTasksInternal(F,K,H,O){const ee=[];if(O)for(const ce of O){this.checkDeprecation(ce,H),(!ce.definition||!F[ce.definition.type])&&this._logService.warn(`The task [${ce.source}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=k.from(ce,H.extension);oe&&c.is(oe.execution)?(ee.push(oe),K.push(this.addCustomExecution(oe,ce,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:H.extension}}async resolveTaskInternal(F){if(c.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,K,H){}};L=ze([$e(0,m.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,w.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,S.IExtHostTerminalService),$e(6,o.ILogService),$e(7,g.IExtHostApiDeprecationService)],L),e.WorkerExtHostTask=L,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ye[227],De([1,0,19,20,43,34,22,203,41]),function(ie,e,a,v,b,M,y,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(m,I,f){this.config=m,this.provider=I,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const I=this.config.folderQueries||[];return new Promise((f,d)=>{const u=o=>{this.resultCount++,m(o)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const g=o.toString(),A=a.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,A)||this.matchFile(u,{base:o,basename:A})}),Promise.all(I.map(o=>this.searchInFolder(o,u))).then(o=>{f({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{d(new Error((0,b.toErrorMessage)(o)))})})}async searchInFolder(m,I){const f=new v.CancellationTokenSource,d=this.getSearchOptionsForFolder(m),u=this.initDirectoryTree(),o=new w.QueryGlobTester(this.config,m),g=!o.hasSiblingExcludeClauses();let A;try{this.activeCancellationTokens.add(f),A=P.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,f.token),E=A.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(h=>{const r=a.posix.relative(m.folder.path,h.path);if(g){const n=a.basename(h.path);this.matchFile(I,{base:m.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(u,m.folder,r,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,o,I),{providerTime:E,postProcessTime:i.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const I=(0,w.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,w.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:I,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},I,f,d){if(f===this.filePattern){const o=a.basename(this.filePattern);this.matchFile(d,{base:I,relativePath:this.filePattern,basename:o})}function u(o){const g=a.basename(o),A=a.dirname(o);let l=m[A];l||(l=m[A]=[],u(A)),l.push({base:I,relativePath:o,basename:g})}u(f)}matchDirectoryTree({rootEntries:m,pathToEntries:I},f,d){const u=this,o=this.filePattern;function g(A){const l=(0,w.hasSiblingFn)(()=>A.map(E=>E.basename));for(let E=0,i=A.length;E<i;E++){const h=A[E],{relativePath:r,basename:n}=h;if(f.matchesExcludesSync(r,n,o!==n?l:void 0))continue;const s=I[r];if(s)g(s);else{if(r===o)continue;u.matchFile(d,h)}if(u.isLimitHit)break}}g(m)}matchFile(m,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(I))}}class R{constructor(){this.sessions=new Map}fileSearch(m,I,f,d){const u=this.getSessionTokenSource(m.cacheKey),o=new T(m,I,u&&u.token);let g=0;const A=l=>{g+=l.length,f(l.map(E=>this.rawMatchToSearchItem(E)))};return this.doSearch(o,R.BATCH_SIZE,A,d).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new v.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:y.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,I,f,d){d.onCancellationRequested(()=>{m.cancel()});const u=g=>{g&&(o.push(g),I>0&&o.length>=I&&(f(o),o=[]))};let o=[];return m.search(u).then(g=>(o.length&&f(o),g),g=>(o.length&&f(o),Promise.reject(g)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ye[228],De([1,0,16,72,34,76,25,12,19,22,9,10,2,245,144,58,15,45,91,226,41]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let E=class{constructor(p,k,U,V,x){this.configurationService=p,this.workspaceContextService=k,this.editorGroupsService=U,this.logService=V,this.pathService=x}text(p,k,U={}){p=this.getContentPattern(p,U);const V=this.configurationService.getValue(),x=k&&k.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(k?.map(o.toWorkspaceFolder),U),type:2,contentPattern:p,previewOptions:U.previewOptions,maxFileSize:U.maxFileSize,usePCRE2:V.search.usePCRE2||x||!1,beforeContext:U.beforeContext,afterContext:U.afterContext,userDisabledExcludesAndIgnoreFiles:U.disregardExcludeSettings&&U.disregardIgnoreFiles}}getContentPattern(p,k){const U=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const V={...p,wordSeparators:U.editor.wordSeparators};return this.isCaseSensitive(p,k)&&(V.isCaseSensitive=!0),this.isMultiline(p)&&(V.isMultiline=!0),V}file(p,k={}){return{...this.commonQuery(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}handleIncludeExclude(p,k){return p?(p=Array.isArray(p)?p.map(s):s(p),k?this.parseSearchPaths(p):{pattern:h(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],k={}){const U=this.handleIncludeExclude(k.includePattern,k.expandPatterns),V=this.handleIncludeExclude(k.excludePattern,k.expandPatterns),x=p.length>1,D=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,k,V)):p.map(F=>this.getFolderQueryForRoot(F,k,V,x))).filter(F=>!!F),L={_reason:k._reason,folderQueries:D,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:V.pattern,includePattern:U.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const F=a.coalesce(a.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(ee=>ee.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const K=F.filter(O=>(0,l.pathIncludedInQuery)(L,O.fsPath)),H=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...L,...H}}const B=k.extraFileResources&&k.extraFileResources.filter(F=>(0,l.pathIncludedInQuery)(L,F.fsPath));return L.extraFileResources=B&&B.length?B:void 0,L}commonQueryFromFileList(p){const k=[],U=new y.ResourceMap,V={};let x=!1;return p.forEach(D=>{if(D.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(D)){const B=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:w.dirname(D.fsPath)});let F=U.get(B);F||(x=!0,F={folder:B,includePattern:{}},k.push(F),U.set(B,F));const K=w.relative(B.fsPath,D.fsPath);(0,S.assertIsDefined)(F.includePattern)[K.replace(/\\/g,"/")]=!0}else D.fsPath&&(x=!0,V[D.fsPath]=!0)}),{folderQueries:k,includePattern:V,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}isCaseSensitive(p,k){if(k.isSmartCase){if(p.isRegExp){if(R.containsUppercaseCharacter(p.pattern,!0))return!0}else if(R.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,I.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=H=>w.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),V=(Array.isArray(p)?p:r(p)).map(H=>{const O=this.pathService.resolvedUserHome;return O?(0,M.untildify)(H,O.scheme===P.Schemas.file?O.fsPath:O.path):H}),x=v.groupBy(V,H=>k(H)?"searchPaths":"exprSegments"),D=(x.exprSegments||[]).map(H=>R.rtrim(H,"/")).map(H=>R.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),n(H))),L={},B=this.expandSearchPathPatterns(x.searchPaths||[]);B&&B.length&&(L.searchPaths=B);const F=a.flatten(D),K=h(...F);return K&&(L.pattern=K),L}getExcludesForFolder(p,k){return k.disregardExcludeSettings?void 0:(0,l.getExcludes)(p,!k.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const k=a.flatten(p.map(V=>{let{pathPortion:x,globPortion:D}=i(V);D&&(D=t(D));const L=this.expandOneSearchPath(x);return a.flatten(L.map(B=>this.resolveOneSearchPathPattern(B,D)))})),U=new Map;return k.forEach(V=>{const x=V.searchPath.toString(),D=U.get(x);D?V.pattern&&(D.pattern=D.pattern||{},D.pattern[V.pattern]=!0):U.set(x,{searchPath:V.searchPath,pattern:V.pattern?h(V.pattern):void 0})}),Array.from(U.values())}expandOneSearchPath(p){if(w.isAbsolute(p)){const k=this.workspaceContextService.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==P.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:m.URI.file(w.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const k=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=s(p),p.startsWith("../")||p===".."){const V=w.posix.resolve(k.path,p);return[{searchPath:k.with({path:V})}]}const U=t(p);return[{searchPath:k,pattern:U}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(x=>{const D=k.match(new RegExp(`^${R.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return D?{match:D,folder:x}:null}).filter(S.isDefined);if(V.length)return V.map(x=>{const D=x.match[1];return{searchPath:x.folder.uri,pattern:D&&t(D)}});{const x=p.match(/\.[\/\\](.+)[\/\\]?/),D=x?x[1]:p,L=f.localize(0,null,D);throw new Error(L)}}}}resolveOneSearchPathPattern(p,k){const U=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,V=[{searchPath:p.searchPath,pattern:U}];return U&&!U.endsWith("**")&&V.push({searchPath:p.searchPath,pattern:U+"/**"}),V}getFolderQueryForSearchPath(p,k,U){const V=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(p.searchPath),k,U,!1);return V?{...V,includePattern:p.pattern}:null}getFolderQueryForRoot(p,k,U,V){let x;const D=m.URI.isUri(p)?p:p.uri;if(U.searchPaths){const H=U.searchPaths.filter(O=>(0,T.isEqual)(O.searchPath,D))[0];if(H&&!H.pattern)return null;H&&(x=H.pattern)}const L=this.configurationService.getValue({resource:D}),F={...this.getExcludesForFolder(L,k)||{},...x||{}},K=m.URI.isUri(p)?(0,T.basename)(p):p.name;return{folder:D,folderName:V?K:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!L.search.followSymlinks}}};E=ze([$e(0,d.IConfigurationService),$e(1,o.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,u.ILogService),$e(4,A.IPathService)],E),e.QueryBuilder=E;function i(_){const p=_.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,U=_.substr(0,k).match(/[/|\\][^/\\]*$/);if(U){let V=_.substr(0,U.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:_.substr((U.index||0)+1)}}}return{pathPortion:_}}function h(..._){return _.length?_.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function r(_){return b.splitGlobAware(_,",").map(p=>p.trim()).filter(p=>!!p.length)}function n(_){return[`**/${_}/**`,`**/${_}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function s(_){return _.replace(/\\/g,"/")}function t(_){return s(_).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(_,p){_=a.distinct(_,V=>V.toString());const k=[],U=p.getWorkspace();return _&&_.forEach(V=>{let x;if(p.getWorkbenchState()===2)x=(0,T.relativePath)(U.folders[0].uri,V),x&&x!=="."&&(x="./"+x);else{const D=p.getWorkspaceFolder(V);if(D){const L=D.name;if(U.folders.filter(F=>F.name===L).length===1){const F=(0,T.relativePath)(D.uri,V);F===""?x=`./${D.name}`:x=`./${D.name}/${F}`}else x=V.fsPath}}x&&k.push(x)}),k}e.resolveResourcesForSearchIncludes=c}),define(ye[229],De([1,0,22,2,20,11,3,228,41,45]),function(ie,e,a,v,b,M,y,P,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function S(d,u){const o=u.activationEvents;if(!o)return Promise.resolve(void 0);const g=[],A=[];for(const n of o)if(/^workspaceContains:/.test(n)){const s=n.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||d.forceUsingSearch?A.push(s):g.push(s)}if(g.length===0&&A.length===0)return Promise.resolve(void 0);let l;const E=new Promise((n,s)=>{l=n}),i=n=>l({activationEvent:n}),h=Promise.all(g.map(n=>m(d,n,i))).then(()=>{}),r=I(d,u.identifier,A,i);return Promise.all([h,r]).then(()=>{l(void 0)}),E}e.checkActivateWorkspaceContainsExtension=S;async function m(d,u,o){for(const g of d.folders)if(await d.exists(a.joinPath(v.URI.revive(g),u))){o(`workspaceContains:${u}`);return}}async function I(d,u,o,g){if(o.length===0)return Promise.resolve(void 0);const A=new b.CancellationTokenSource,l=d.checkExists(d.folders,o,A.token),E=setTimeout(async()=>{A.cancel(),d.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let i=!1;try{i=await l}catch(h){M.isCancellationError(h)||M.onUnexpectedError(h)}A.dispose(),clearTimeout(E),i&&g(`workspaceContains:${o.join(",")}`)}function f(d,u,o,g){const A=d.get(y.IInstantiationService),l=d.get(w.ISearchService),i=A.createInstance(P.QueryBuilder).file(u.map(h=>(0,T.toWorkspaceFolder)(v.URI.revive(h))),{_reason:"checkExists",includePattern:o,exists:!0});return l.fileSearch(i,g).then(h=>!!h.limitHit,h=>M.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ie,a):b?b.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!v:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ie):v?v.value:e.get(ie)};define(ye[33],De([1,0,131,19,71,22,14,7,25,2,15,4,32,180,69,31,24,179,11,27,23,158,6,84,3,28,70,13,59,63,53,5,229,68,160,12]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l,E,i,h,r,n,s,t,c,_,p,k,U,V,x,D){"use strict";var L,B,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let K=class ki extends P.Disposable{constructor(te,Ee,be,ne,ve,Pe,Fe,xe,Qe,Ie){super(),this._onDidChangeRemoteConnectionData=this._register(new k.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ne,this._extHostConfiguration=ve,this._logService=Pe,this._extHostTunnelService=Qe,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new o.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,u.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(ee(this._globalRegistry,Se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=te.createChild(new c.ServiceCollection([f.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let Te=[],ae=[];this._initData.remote.isRemote&&(Te=this._initData.allExtensions.filter(X=>!X.main&&!X.browser).map(X=>X.identifier),ae=this._initData.allExtensions.filter(X=>!Se.has(A.ExtensionIdentifier.toKey(X.identifier.value))).filter(X=>(X.main||X.browser)&&X.api==="none").map(X=>X.identifier));const ue=(0,u.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,Te,ae,{onExtensionActivationError:(X,Y,C)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(X,g.transformErrorForSerialization(Y),C)},actualActivateExtension:async(X,Y)=>{if(ue.has(A.ExtensionIdentifier.toKey(X)))return await this._mainThreadExtensionsProxy.$activateExtension(X,Y),new I.HostExtension;const C=this._myRegistry.getExtensionDescription(X);return this._activateExtension(C,Y)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){g.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(te)}terminate(te,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const Ee=await this._mainThreadExtensionsProxy.$getExtension(te);let be;if(Ee?.browserNlsBundleUris){be={};for(const ne of Object.keys(Ee.browserNlsBundleUris))be[ne]=T.URI.revive(Ee.browserNlsBundleUris[ne])}return Ee&&{...Ee,identifier:new A.ExtensionIdentifier(Ee.identifier.value),extensionLocation:T.URI.revive(Ee.extensionLocation),browserNlsBundleUris:be}}_activateByEvent(te,Ee){return this._activator.activateByEvent(te,Ee)}_activateById(te,Ee){return this._activator.activateById(te,Ee)}activateByIdWithErrors(te,Ee){return this._activateById(te,Ee).then(()=>{const be=this._activator.getActivatedExtension(te);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==D.Schemas.file)return te;const Ee=await this._hostUtils.realpath(te.fsPath);return T.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new oe(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const Ee=w.TernarySearchTree.forUris(be=>M.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(te.map(async be=>{if(this._getEntryPoint(be)){const ne=await this._realPathExtensionUri(be.extensionLocation);Ee.set(ne,be)}})),Ee}_deactivate(te){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return Ee;const be=this._activator.getActivatedExtension(te);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ne)}try{(0,P.dispose)(be.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ne)}return Ee}async _activateExtension(te,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,Ee).then(be=>{const ne=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,Ee),this._logExtensionActivationTimes(te,Ee,"success",ne),be},be=>{throw this._logExtensionActivationTimes(te,Ee,"failure"),be})}_logExtensionActivationTimes(te,Ee,be,ne){const ve=H(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ne||{},outcome:be})}_doActivateExtension(te,Ee){const be=H(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ne=this._getEntryPoint(te);if(!ne)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${te.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new I.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(te,(0,M.joinPath)(te.extensionLocation,ne),ve),this._loadExtensionContext(te)]).then(Pe=>(b.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),ki._callActivate(this._logService,te.identifier,Pe[0],Pe[1],ve))).then(Pe=>(b.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Pe))}_loadExtensionContext(te){const Ee=new E.ExtensionGlobalMemento(te,this._storage),be=new E.ExtensionMemento(te.identifier.value,!1,this._storage),ne=new x.ExtensionSecrets(te,this._secretState),ve=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let xe,Qe;const Ie=(0,u.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(A.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:ne,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Se){return v.join(te.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(te).fsPath},get logPath(){return v.join(Fe._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return T.URI.joinPath(Fe._initData.logsLocation,te.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(te)},get globalStorageUri(){return Fe._storagePath.globalValue(te)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new O(Fe,te.identifier,te,Pe,!1)),xe},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Qe){if(!Ie)return;const Se=k.Event.buffer(k.Event.fromDOMEventEmitter(Ie,"message",Te=>Te.data));Ie.start(),Qe={onDidReceiveMessage:Se,postMessage:Ie.postMessage.bind(Ie)}}return Qe}})})}static _callActivate(te,Ee,be,ne,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,Ee,be,ne,ve).then(Pe=>new I.ActivatedExtension(!1,null,ve.build(),be,Pe,ne.subscriptions))}static _callActivateOptional(te,Ee,be,ne,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Pe=typeof global=="object"?global:self,Fe=be.activate.apply(Pe,[ne]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then(xe=>(ve.activateResolveStop(),xe))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(be)}_activateOneStartupFinished(te,Ee){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const Ee of te.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(te,Ee)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),ne=Promise.all([te,be]).then(()=>{});return Promise.race([ne,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(te,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:te.map(Pe=>Pe.uri),forceUsingSearch:be,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Fe,xe)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Fe,xe)},ve=await(0,U.checkActivateWorkspaceContainsExtension)(ne,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:Ee}=this._initData.environment;if(!te||!Ee)throw new Error(a.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new I.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(a.localize(1,null,Ee.toString()));return new Promise((ne,ve)=>{const Pe=(Qe,Ie)=>{Qe?ve(Qe):ne(typeof Ie=="number"&&Ie>0?1:0)},Fe=(0,M.originalFSPath)(Ee),xe=be.run(Fe,Pe);xe&&xe.then&&xe.then(()=>{ne(0)}).catch(Qe=>{ve(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,Ee){return this._resolvers[te]=Ee,(0,P.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const Ee=te.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=te.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(te,Ee){this._logService.info(`$resolveAuthority invoked for authority (${ce(te)})`);const{authorityPrefix:be,resolver:ne}=await this._activateAndGetResolver(te);if(!ne)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),b.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await ne.resolve(te,{resolveAttempt:Ee});b.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Pe={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(b.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${ce(te)})`);const{resolver:be}=await this._activateAndGetResolver(te);if(!be)return null;const ne=T.URI.revive(Ee);if(typeof be.getCanonicalURI>"u")return ne;const ve=await(0,y.asPromise)(()=>be.getCanonicalURI(ne));return ve||ne}static _applyExtensionsDelta(te,Ee,be){const ne=new o.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ne.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,u.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(A.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(A.ExtensionIdentifier.toKey(Fe));const Pe=ee(ne,ve);return{globalRegistry:ne,myExtensions:Pe}}$startExtensionHost(te){te.toAdd.forEach(ne=>ne.extensionLocation=T.URI.revive(ne.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(te,Ee){return Ee===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(te,!1))}async $activate(te,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,Ee),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Pe=>Pe.extensionLocation=T.URI.revive(Pe.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ne=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const Ee=l.VSBuffer.alloc(te),be=Math.random()%256;for(let ne=0;ne<te;ne++)Ee.writeUInt8(be,ne);return Ee}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};K=ze([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,t.IExtHostRpcService),$e(3,d.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,s.IExtensionStoragePaths),$e(8,_.IExtHostTunnelService),$e(9,p.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function H(le,te){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class O{constructor(te,Ee,be,ne,ve){L.set(this,void 0),B.set(this,void 0),F.set(this,void 0),Ye(this,L,te,"f"),Ye(this,B,Ee,"f"),Ye(this,F,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=v.normalize((0,M.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ne,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,L,"f").isActivated(Oe(this,F,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,L,"f").getExtensionExports(Oe(this,F,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,L,"f").activateByIdWithErrors(Oe(this,F,"f"),{startup:!1,extensionId:Oe(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=O,L=new WeakMap,B=new WeakMap,F=new WeakMap;function ee(le,te){return le.getAllExtensionDescriptions().filter(Ee=>te.has(A.ExtensionIdentifier.toKey(Ee.identifier)))}function ce(le){const te=le.indexOf("+");return te===-1?le:le.substring(0,te)}class oe{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=oe}),define(ye[230],De([1,0,71,2,4,32,24,27,13,28,3,33,60,15,9]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(E,i,h,r,n,s,t){this._apiFactory=E,this._extensionRegistry=i,this._instaService=h,this._extHostConfiguration=r,this._extHostExtensionService=n,this._initData=s,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const E=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,i,this._extensionRegistry,E,this._logService)),this.register(this._instaService.createInstance(g,i)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,i,this._initData.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const i of E.nodeModuleName)this._factories.set(i,E);else this._factories.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this._alternatives.push(i=>E.alternativeModuleName(i))}};d=ze([$e(2,R.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,S.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,I.ILogService)],d),e.RequireInterceptor=d;let u=class Xi{constructor(E){if(E.environment.appRoot&&Xi.aliased.size){const i=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(E.environment.appRoot.fsPath)),h="[a-z0-9_.-]",r=`@${h}+\\/${h}+|${h}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${n}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(E));if(!i)return;const[,h,r,n]=i,s=Xi.aliased.get(r);if(s!==void 0)return console.warn(`${r} as been renamed to ${s}, please update your imports`),h+s+n}forceForwardSlashes(E){return E.replace(/\\/g,"/")}};u.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=ze([$e(0,T.IExtHostInitDataService)],u);class o{constructor(E,i,h,r,n){this._apiFactory=E,this._extensionPaths=i,this._extensionRegistry=h,this._configProvider=r,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(E,i){const h=this._extensionPaths.findSubstr(i);if(h){let r=this._extApiImpl.get(P.ExtensionIdentifier.toKey(h.identifier));return r||(r=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(h.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((n,s)=>r+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(E,i,h){this._extensionPaths=E,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(b.MainContext.MainThreadTelemetry);const{environment:r}=h,n=i.getProxy(b.MainContext.MainThreadKeytar);if(r.appRoot){let s=r.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,t)=>n.$getPassword(s,t),setPassword:(s,t,c)=>n.$setPassword(s,t,c),deletePassword:(s,t)=>n.$deletePassword(s,t),findPassword:s=>n.$findPassword(s),findCredentials(s){return n.$findCredentials(s)}}}load(E,i){const h=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(E){const i=E.length;if(i<=7||!this.alternativeNames)return;const h=i-7;if((E.charAt(h)==="/"||E.charAt(h)==="\\")&&E.endsWith("keytar")&&(E=E.replace(/\\/g,"/"),this.alternativeNames.has(E)))return"keytar"}};g=ze([$e(1,w.IExtHostRpcService),$e(2,T.IExtHostInitDataService)],g);let A=class{constructor(E,i,h){this._extensionPaths=E,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(b.MainContext.MainThreadTelemetry);const r=h.getProxy(b.MainContext.MainThreadWindow);this._impl=(n,s)=>{const t=v.URI.parse(n);return s?this.callOriginal(n,s):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,n,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,n,{}):this.callOriginal(n,s)}}load(E,i,h){const r=this._extensionPaths.findSubstr(i);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=h(E),this._impl}callOriginal(E,i){return this.sendNoForwardTelemetry(),this._original(E,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=ze([$e(2,w.IExtHostRpcService)],A)}),define(ye[103],De([1,0,197,7,19,60,3,50,51,33,6,31,171,32]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(o,g,A,l,E,i,h){function r(){if(A){const n=A.activeEditor();if(n)return n.document.uri;const s=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.TextDiffTabInput||s.input instanceof R.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof R.TextTabInput||s.input instanceof R.NotebookEditorTabInput||s.input instanceof R.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:n=>{const s=i.folders.filter(t=>t.name===n);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(n,s)=>E.getConfiguration(void 0,n).get(s),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=r();if(n)return b.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const n=r();if(n){const s=g.getWorkspaceFolder(n);if(s)return b.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(A){const n=A.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(A){const n=A.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>o.getExtension(n)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(M.env))}}let d=class extends v.Disposable{constructor(o,g,A,l,E){super(),this.extensionService=o,this.workspaceService=g,this.editorService=A,this.configurationService=l,this.editorTabs=E,this._resolver=new a.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};d=ze([$e(0,T.IExtHostExtensionService),$e(1,S.IExtHostWorkspace),$e(2,P.IExtHostDocumentsAndEditors),$e(3,I.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(ye[104],De([1,0,14,5,10,2,3,4,51,33,13,6,31,164,166,32,103]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let o=class{constructor(r,n,s,t,c,_){this._workspaceService=n,this._extensionService=s,this._configurationService=t,this._editorTabs=c,this._variableResolver=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new v.Emitter,this._onDidTerminateDebugSession=new v.Emitter,this._onDidChangeActiveDebugSession=new v.Emitter,this._onDidReceiveDebugSessionCustomEvent=new v.Emitter,this._debugServiceProxy=r.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new v.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new A(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(k=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,n){const s=r;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let t=`debug:${encodeURIComponent(s.path||"")}`,c="?";return n&&(t+=`${c}session=${encodeURIComponent(n.id)}`,c="&"),t+=`${c}ref=${s.sourceReference}`,M.URI.parse(t)}else{if(s.path)return M.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const n=[];for(const s of r.getAllExtensionDescriptions())if(s.contributes){const t=s.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,f.isDebuggerMainContribution)(c)&&n.push(c.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(n=>r.push(n)),r}addBreakpoints(r){this.startBreakpoints();const n=r.filter(c=>{const _=c.id;return this._breakpoints.has(_)?!1:(this._breakpoints.set(_,c),!0)});this.fireBreakpointChanges(n,[],[]);const s=[],t=new Map;for(const c of n)if(c instanceof S.SourceBreakpoint){let _=t.get(c.location.uri.toString());_||(_={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),_),s.push(_)),_.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof S.FunctionBreakpoint&&s.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(r){this.startBreakpoints();const n=r.filter(_=>this._breakpoints.delete(_.id));this.fireBreakpointChanges([],n,[]);const s=n.filter(_=>_ instanceof S.SourceBreakpoint).map(_=>_.id),t=n.filter(_=>_ instanceof S.FunctionBreakpoint).map(_=>_.id),c=n.filter(_=>_ instanceof S.DataBreakpoint).map(_=>_.id);return this._debugServiceProxy.$unregisterBreakpoints(s,t,c)}startDebugging(r,n,s){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,n,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,n,s){if(!n)return new S.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,s,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,t),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,n,s){if(!s)return new S.Disposable(()=>{});if(!this.definesDebugType(r,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:t,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,t),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,n){if(!n)return new S.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:s,factory:n}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==n)})}async $runInTerminal(r,n){return Promise.resolve(void 0)}async $substituteVariables(r,n){let s;const t=await this.getFolder(r);return t&&(s={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,n)}createDebugAdapter(r,n){if(r.type==="implementation")return new E(r.implementation)}createSignService(){}async $startDASession(r,n){const s=this,t=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const _=this.convertToDto(c),p=this.createDebugAdapter(_,t);if(!p)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const k=p;return this._debugAdapters.set(r,k),this.getDebugAdapterTrackers(t).then(U=>(U&&this._debugAdaptersTrackers.set(r,U),k.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const x=V,D={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(x.arguments.value);D.body={signature:L},k.sendResponse(D)}else throw new Error("no signer")}catch(L){D.success=!1,D.message=L.message,k.sendResponse(D)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),s._debugServiceProxy.$acceptDAMessage(r,V)}),k.onError(V=>{U&&U.onError&&U.onError(V),this._debugServiceProxy.$acceptDAError(r,V.name,V.message,V.stack)}),k.onExit(V=>{U&&U.onExit&&U.onExit((0,b.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,b.withNullAsUndefined)(V),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),k.startSession()))})}$sendDAMessage(r,n){n=(0,f.convertToDAPaths)(n,!1);const s=this._debugAdaptersTrackers.get(r);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(n),this._debugAdapters.get(r)?.sendMessage(n)}$stopDASession(r){const n=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),n&&n.onWillStopSession&&n.onWillStopSession();const s=this._debugAdapters.get(r);return this._debugAdapters.delete(r),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const n=[],s=[],t=[];if(r.added)for(const c of r.added){const _=c.id;if(_&&!this._breakpoints.has(_)){let p;if(c.type==="function")p=new S.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")p=new S.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const k=M.URI.revive(c.uri);p=new S.SourceBreakpoint(new S.Location(k,new S.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}p._id=_,this._breakpoints.set(_,p),n.push(p)}}if(r.removed)for(const c of r.removed){const _=this._breakpoints.get(c);_&&(this._breakpoints.delete(c),s.push(_))}if(r.changed){for(const c of r.changed)if(c.id){const _=this._breakpoints.get(c.id);if(_){if(_ instanceof S.FunctionBreakpoint&&c.type==="function"){const p=_;p.enabled=c.enabled,p.condition=c.condition,p.hitCondition=c.hitCondition,p.logMessage=c.logMessage,p.functionName=c.functionName}else if(_ instanceof S.SourceBreakpoint&&c.type==="source"){const p=_;p.enabled=c.enabled,p.condition=c.condition,p.hitCondition=c.hitCondition,p.logMessage=c.logMessage,p.location=new S.Location(M.URI.revive(c.uri),new S.Position(c.line,c.character))}t.push(_)}}}this.fireBreakpointChanges(n,s,t)}$provideDebugConfigurations(r,n,s){return(0,a.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(n);return t.provideDebugConfigurations(c,s)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,n,s,t){return(0,a.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const _=await this.getFolder(n);return c.resolveDebugConfiguration(_,s,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,n,s,t){return(0,a.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const _=await this.getFolder(n);return c.resolveDebugConfigurationWithSubstitutedVariables(_,s,t)})}async $provideDebugAdapter(r,n){const s=this.getAdapterDescriptorFactoryByHandle(r);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(n);return this.getAdapterDescriptor(s,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const n=await this.getSession(r);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(r){const n=await this.getSession(r);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,n){(await this.getSession(r))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(r,n){const t={session:await this.getSession(r),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof S.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof S.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const n=this._adapterFactories.filter(s=>s.type===r);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(r){const n=this._adapterFactories.filter(s=>s.handle===r);if(n.length>0)return n[0].factory}getConfigProviderByHandle(r){const n=this._configProviders.filter(s=>s.handle===r);if(n.length>0)return n[0].provider}definesDebugType(r,n){if(r.contributes){const s=r.contributes.debuggers;if(s&&s.length>0){for(const t of s)if(t.label&&t.type&&t.type===n)return!0}}return!1}getDebugAdapterTrackers(r){const s=r.configuration.type,t=this._trackerFactories.filter(c=>c.type===s||c.type==="*").map(c=>(0,a.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(_=>_,_=>null));return Promise.race([Promise.all(t).then(c=>{const _=c.filter(p=>!!p);if(_.length>0)return new l(_)}),new Promise((c,_)=>{const p=setTimeout(()=>{clearTimeout(p),_(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(r,n){const s=n.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new S.DebugAdapterServer(s));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,c))).then(_=>{if(_)return _})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,t))}daExecutableFromPackage(r,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,n,s){(r.length>0||n.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:n,changed:s}))}async getSession(r){if(r)if(typeof r=="string"){const n=this._debugSessions.get(r);if(n)return n}else{let n=this._debugSessions.get(r.id);if(!n){const s=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;n=new g(this._debugServiceProxy,r.id,r.type,r.name,s,r.configuration,t),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(r){if(r){const n=M.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};o=ze([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,T.IExtHostExtensionService),$e(3,d.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider)],o),e.ExtHostDebugServiceBase=o;class g{constructor(r,n,s,t,c,_,p){this._debugServiceProxy=r,this._id=n,this._type=s,this._name=t,this._workspaceFolder=c,this._configuration=_,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,n)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=g;class A{constructor(r){this.value=Object.freeze({append(n){r.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=A;class l{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(n=>n.onError?n.onError(r):void 0)}onExit(r,n){this.trackers.forEach(s=>s.onExit?s.onExit(r,n):void 0)}}class E extends I.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends o{constructor(r,n,s,t,c,_){super(r,n,s,t,c,_)}};i=ze([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,T.IExtHostExtensionService),$e(3,d.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[231],De([1,0,11,71,2,4,222,15,57,59,28,148,13,46,33]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{constructor(o,g,A,l,E){this._hostUtils=A,this._rpcProtocol=new y.RPCProtocol(o,null,l),g=d._transform(g,this._rpcProtocol);const i=new T.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());i.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:E}),i.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),i.set(I.IURITransformerService,new I.URITransformerService(l)),i.set(f.IHostUtils,A);const h=new S.InstantiationService(i,!0);this._logService=h.invokeFunction(t=>t.get(P.ILogService)),v.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=h.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,_)=>{let p="",k,U;for(const V of _)p+=`
	at ${V.toString()}`,U=V.getFileName(),!k&&U&&(k=t.findSubstr(b.URI.file(U)));return r.set(c,k),`${c.name||"Error"}: ${c.message||""}${p}`}});const n=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(t=>{const c=a.transformErrorForSerialization(t),_=r.get(t);_?n.$onExtensionRuntimeError(_.identifier,c):s.$onUnexpectedError(c)})}async asBrowserUri(o){const g=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return b.URI.revive(await g.$asBrowserUri(o))}terminate(o){this._extensionService.terminate(o)}static _transform(o,g){o.allExtensions.forEach(l=>{l.extensionLocation=b.URI.revive(g.transformIncomingURIs(l.extensionLocation));const E={};l.browserNlsBundleUris&&(Object.keys(l.browserNlsBundleUris).forEach(i=>E[i]=b.URI.revive(g.transformIncomingURIs(l.browserNlsBundleUris[i]))),l.browserNlsBundleUris=E)}),o.environment.appRoot=b.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const A=o.environment.extensionDevelopmentLocationURI;return A&&(o.environment.extensionDevelopmentLocationURI=A.map(l=>b.URI.revive(g.transformIncomingURIs(l)))),o.environment.extensionTestsLocationURI=b.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=b.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=b.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=b.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=b.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=d}),define(ye[232],De([1,0,16,14,20,43,12,19,22,2,41]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(g,A,l,E){this.query=g,this.provider=A,this.fileUtils=l,this.processType=E,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,A){const l=this.query.folderQueries||[],E=new b.CancellationTokenSource;return A.onCancellationRequested(()=>E.cancel()),new Promise((i,h)=>{this.collector=new I(g);let r=!1;const n=(s,t)=>{if(!r&&!this.isLimitHit){const c=this.resultSize(s);d(s)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,r=!0,E.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const _=this.resultSize(s);this.resultCount+=_,(_>0||!d(s))&&this.collector.add(s,t)}};Promise.all(l.map((s,t)=>this.searchInFolder(s,c=>n(c,t),E.token))).then(s=>{E.dispose(),this.collector.flush();const t=s.some(c=>!!c&&!!c.limitHit);i({limitHit:this.isLimitHit||t,messages:(0,a.flatten)(s.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},s=>{E.dispose();const t=(0,M.toErrorMessage)(s);h(new Error(t))})})}resultSize(g){return d(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,A){const l=Array.isArray(g.ranges)?g.ranges:[g.ranges],E=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:l.slice(0,A),preview:{matches:E.slice(0,A),text:g.preview.text},uri:g.uri}}async searchInFolder(g,A,l){const E=new R.QueryGlobTester(this.query,g),i=[],h={report:s=>{if(!this.validateProviderResult(s))return;const t=g.folder.scheme===y.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(s.uri))):void 0,c=w.relativePath(g.folder,s.uri);if(c){const _=E.includedInQuery(c,P.basename(c),t);(0,v.isThenable)(_)?i.push(_.then(p=>{p&&A(s)})):_&&A(s)}}},r=this.getSearchOptionsForFolder(g),n=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,h,l);return i.length&&await Promise.all(i),n}validateProviderResult(g){if(d(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const A=(0,R.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),l=(0,R.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),E={folder:T.URI.from(g.folder),excludes:l,includes:A,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return E.usePCRE2=this.query.usePCRE2,E}}e.TextSearchManager=S;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class I{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new u(512,A=>this.sendItems(A))}add(g,A){this._currentFileMatch&&(this._currentFolderIdx!==A||!w.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=A,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(f(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=I;function f(o){return d(o)?{preview:{matches:(0,a.mapArrayOrNot)(o.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:o.preview.text},ranges:(0,a.mapArrayOrNot)(o.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function d(o){return!!o.preview}e.extensionResultIsMatch=d;class u{constructor(g,A){this.maxBatchSize=g,this.cb=A,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,A){!g||this.addItemToBatch(g,A)}addItems(g,A){!g||this.addItemsToBatch(g,A)}addItemToBatch(g,A){this.batch.push(g),this.batchSize+=A,this.onUpdate()}addItemsToBatch(g,A){this.batch=this.batch.concat(g),this.batchSize+=A,this.onUpdate()}onUpdate(){this.totalNumberCompleted<u.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},u.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=u,u.TIMEOUT=4e3,u.START_BATCH_AFTER_COUNT=50}),define(ye[105],De([1,0,7,4,3,227,13,46,15,2,232]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let S=class{constructor(d,u,o){this.extHostRpc=d,this._uriTransformer=u,this._logService=o,this._proxy=this.extHostRpc.getProxy(v.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,u){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const o=this._handlePool++;return this._textSearchProvider.set(o,u),this._proxy.$registerTextSearchProvider(o,this._transformScheme(d)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(d,u){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const o=this._handlePool++;return this._fileSearchProvider.set(o,u),this._proxy.$registerFileSearchProvider(o,this._transformScheme(d)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(d,u,o,g){const A=m(o),l=this._fileSearchProvider.get(d);if(l)return this._fileSearchManager.fileSearch(A,l,E=>{this._proxy.$handleFileMatch(d,u,E.map(i=>i.resource))},g);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,u,o,g){const A=this._textSearchProvider.get(d);if(!A||!A.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const l=m(o);return this.createTextSearchManager(l,A).search(i=>this._proxy.$handleTextMatch(d,u,i),g)}$enableExtensionHostSearch(){}createTextSearchManager(d,u){return new R.TextSearchManager(d,u,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};S=ze([$e(0,y.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,w.ILogService)],S),e.ExtHostSearch=S;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(I),extraFileResources:f.extraFileResources&&f.extraFileResources.map(d=>T.URI.revive(d))}}e.reviveQuery=m;function I(f){return{...f,folder:T.URI.revive(f.folder)}}}),define(ye[233],De([1,0,57,100,31,96,32,36,50,53,102,104,105,69,63,67,99,52,35,68,86,51,205,15,181,103,98]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l,E,i,h,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(h.ILoggerService,i.ExtHostLoggerService,!1),(0,a.registerSingleton)(h.ILogService,r.ExtHostLogService,!1),(0,a.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,!1),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,!1),(0,a.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,a.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,!1),(0,a.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,!1),(0,a.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,!1),(0,a.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,!1),(0,a.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,!1),(0,a.registerSingleton)(v.IExtHostOutputService,v.ExtHostOutputService,!1),(0,a.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,a.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,!1),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,a.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,!1),(0,a.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,!1),(0,a.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow,!1),(0,a.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace,!1),(0,a.registerSingleton)(A.IExtHostSecretState,A.ExtHostSecretState,!1),(0,a.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry,!1),(0,a.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,a.registerSingleton)(E.IExtHostEditorTabs,E.ExtHostEditorTabs,!1),(0,a.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(ye[234],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const M=this._dragOperations.get(b);return this._dragOperations.delete(b),M}}addDragOperationTransfer(b,M){this._dragOperations.set(b,M)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,M){this._renderedElements.set(b,M)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=a}),define(ye[235],De([1,0,135,6,22,2,5,7,14,6,10,16,8,20,234,24]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(A,l){if((0,R.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let E;return Array.isArray(A.highlights)&&(E=A.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),E=E.length?E:void 0),{label:A.label,highlights:E}}}class o{constructor(l,E,i){this._proxy=l,this.commands=E,this.logService=i,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function h(r){return r&&r.$treeViewId&&r.$treeItemHandle}E.registerArgumentProcessor({processArgument:r=>h(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(n=>h(n)?this.convertArgument(n):n):r})}registerTreeDataProvider(l,E,i){const h=this.createTreeView(l,{treeDataProvider:E},i);return{dispose:()=>h.dispose()}}createTreeView(l,E,i){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=E.dragAndDropController?.dropMimeTypes??[],r=E.dragAndDropController?.dragMimeTypes??[],n=!!E.dragAndDropController?.handleDrag,s=!!E.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,dropMimeTypes:h,dragMimeTypes:r,hasHandleDrag:n,hasHandleDrop:s}),c=this.createExtHostTreeView(l,E,i);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(_){c.message=_},get title(){return c.title},set title(_){c.title=_},get description(){return c.description},set description(_){c.description=_},get badge(){return(0,d.checkProposedApiEnabled)(i,"badges"),c.badge},set badge(_){(0,d.checkProposedApiEnabled)(i,"badges"),c.badge=_},reveal:(_,p)=>c.reveal(_,p),dispose:async()=>{await t,this.treeViews.delete(l),c.dispose()}}}$getChildren(l,E){const i=this.treeViews.get(l);return i?i.getChildren(E):Promise.reject(new Error((0,a.localize)(0,null,l)))}async $handleDrop(l,E,i,h,r,n,s,t){const c=this.treeViews.get(l);if(!c)return Promise.reject(new Error((0,a.localize)(1,null,l)));const _=m.DataTransfer.toDataTransfer(i,async p=>(await this._proxy.$resolveDropFileData(l,E,p)).buffer);return s===l&&t&&await this.addAdditionalTransferItems(_,c,t,r,n),c.onDrop(_,h,r)}async addAdditionalTransferItems(l,E,i,h,r){const n=this.treeDragAndDropService.removeDragOperationTransfer(r);if(n)(await n)?.forEach((s,t)=>{s&&l.set(t,s)});else if(r&&E.handleDrag){const s=E.handleDrag(i,l,h);this.treeDragAndDropService.addDragOperationTransfer(r,s),await s}return l}async $handleDrag(l,E,i,h){const r=this.treeViews.get(l);if(!r)return Promise.reject(new Error((0,a.localize)(2,null,l)));const n=await this.addAdditionalTransferItems(new v.DataTransfer,r,E,h,i);if(!!n)return m.DataTransfer.toDataTransferDTO(n)}async $hasResolve(l){const E=this.treeViews.get(l);if(!E)throw new Error((0,a.localize)(3,null,l));return E.hasResolve}$resolve(l,E,i){const h=this.treeViews.get(l);if(!h)throw new Error((0,a.localize)(4,null,l));return h.resolveTreeItem(E,i)}$setExpanded(l,E,i){const h=this.treeViews.get(l);if(!h)throw new Error((0,a.localize)(5,null,l));h.setExpanded(E,i)}$setSelection(l,E){const i=this.treeViews.get(l);if(!i)throw new Error((0,a.localize)(6,null,l));i.setSelection(E)}$setVisible(l,E){const i=this.treeViews.get(l);if(!i)throw new Error((0,a.localize)(7,null,l));i.setVisible(E)}createExtHostTreeView(l,E,i){const h=new g(l,E,this._proxy,this.commands.converter,this.logService,i);return this.treeViews.set(l,h),h}convertArgument(l){const E=this.treeViews.get(l.$treeViewId);return E?E.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=o;class g extends P.Disposable{constructor(l,E,i,h,r,n){if(super(),this.viewId=l,this.proxy=i,this.commands=h,this.logService=r,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,n.contributes&&n.contributes.views)for(const c in n.contributes.views)for(const _ of n.contributes.views[c])_.id===l&&(this._title=_.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let s,t;this._register(y.Event.debounce(this._onDidChangeData.event,(c,_)=>(c||(c={message:!1,elements:[]}),_.element!==!1&&(s||(s=new Promise(p=>t=p),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(_.element)?c.elements.push(..._.element):c.elements.push(_.element)),_.message&&(c.message=!0),c),200,!0)(({message:c,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=t;return s=null,this.refresh(_).then(()=>p())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,R.isUndefinedOrNull)(l))}async getChildren(l){const E=l?this.getExtensionElement(l):void 0;if(l&&!E)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let i=this.getChildrenNodes(l);return i||(i=await this.fetchChildrenNodes(E)),i?i.map(h=>h.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,E){E=E||{select:!0,focus:!1};const i=(0,R.isUndefinedOrNull)(E.select)?!0:E.select,h=(0,R.isUndefinedOrNull)(E.focus)?!1:E.focus,r=(0,R.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(n=>this.resolveTreeNode(l,n[n.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:n.map(t=>t.item)},{select:i,focus:h,expand:r})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:i,focus:h,expand:r})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=m.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,E){const i=this.getExtensionElement(l);i&&(E?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelection(l){(0,S.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,E,i){const h=[];for(const r of l){const n=this.getExtensionElement(r);n&&h.push(n)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,E,i),E}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,E,i){const h=E?this.getExtensionElement(E):void 0;if(!(!h&&E||!this.dndController?.handleDrop))return(0,w.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,l,i):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,E){if(!this.dataProvider.resolveTreeItem)return;const i=this.elements.get(l);if(i){const h=this.nodes.get(i);if(h){const r=await this.dataProvider.resolveTreeItem(h.extensionItem,i,E)??h.extensionItem;return this.validateTreeItem(r),h.item.tooltip=this.getTooltip(r.tooltip),h.item.command=this.getCommand(h.disposableStore,r.command),h.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(E=>E?this.resolveUnknownParentChain(E).then(i=>this.resolveTreeNode(E,i[i.length-1]).then(h=>(i.push(h),i))):Promise.resolve([]))}resolveParent(l){const E=this.nodes.get(l);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,w.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,E){const i=this.nodes.get(l);return i?Promise.resolve(i):(0,w.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(h=>this.createHandle(l,h,E,!0)).then(h=>this.getChildren(E?E.item.handle:void 0).then(()=>{const r=this.getExtensionElement(h);if(r){const n=this.nodes.get(r);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(l){if(l){let E;if(typeof l=="string"){const i=this.getExtensionElement(l);E=i?this.nodes.get(i):void 0}else E=l;return E&&E.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const E=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const i=l?this.nodes.get(l):void 0,h=await this.dataProvider.getChildren(l);if(E.token.isCancellationRequested)return;const r=await Promise.all((0,S.coalesce)(h||[]).map(async n=>{const s=await this.dataProvider.getTreeItem(n);return s&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(n,s,i):null}));return E.token.isCancellationRequested?void 0:(0,S.coalesce)(r)}finally{E.dispose()}}refresh(l){if(l.some(i=>!i))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const i=this.getHandlesToRefresh(l);if(i.length)return this.refreshHandles(i)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const E=new Set,i=l.map(r=>this.nodes.get(r));for(const r of i)if(r&&!E.has(r.item.handle)){let n=r;for(;n&&n.parent&&i.findIndex(s=>n&&n.parent&&s&&s.item.handle===n.parent.item.handle)===-1;){const s=this.elements.get(n.parent.item.handle);n=s?this.nodes.get(s):void 0}n&&!n.parent&&E.add(r.item.handle)}const h=[];return E.forEach(r=>{const n=this.elements.get(r);if(n){const s=this.nodes.get(n);s&&(!s.parent||!E.has(s.parent.item.handle))&&h.push(r)}}),h}refreshHandles(l){const E={};return Promise.all(l.map(i=>this.refreshNode(i).then(h=>{h&&(E[i]=h.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(l){const E=this.getExtensionElement(l);if(E){const i=this.nodes.get(E);if(i)return this.clearChildren(E),(0,w.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(h=>{if(h){const r=this.createTreeNode(E,h,i.parent);return this.updateNodeCache(E,r,i,i.parent),i.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,E,i){const h=this.createTreeNode(l,E,i);if(E.id&&this.elements.has(h.item.handle))throw new Error((0,a.localize)(8,null,E.id));return this.addNodeToCache(l,h),this.addNodeToParentCache(h,i),h}getTooltip(l){return T.MarkdownString.isMarkdownString(l)?m.MarkdownString.from(l):l}getCommand(l,E){return E?{...this.commands.toInternal(E,l),originalId:E.command}:void 0}validateTreeItem(l){if(!T.TreeItem.isTreeItem(l))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,E,i){this.validateTreeItem(E);const h=new P.DisposableStore,r=this.createHandle(l,E,i),n=this.getLightIconPath(E);return{item:{handle:r,parentHandle:i?i.item.handle:void 0,label:u(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(h,E.command),contextValue:E.contextValue,icon:n,iconDark:this.getDarkIconPath(E)||n,themeIcon:this.getThemeIcon(E),collapsibleState:(0,R.isUndefinedOrNull)(E.collapsibleState)?T.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:i,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(l){return l.iconPath instanceof T.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:E,label:i,resourceUri:h},r,n){if(E)return`${g.ID_HANDLE_PREFIX}/${E}`;const s=u(i,this.extension),t=r?r.item.handle:g.LABEL_HANDLE_PREFIX;let c=s?s.label:h?(0,b.basename)(h):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const _=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,p=this.getChildrenNodes(r)||[];let k,U=0;do{if(k=`${t}/${U}:${c}`,n||!this.elements.has(k)||_===k)break;U++}while(U<=p.length);return k}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof T.ThemeIcon))return typeof l.iconPath=="string"||M.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof T.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return M.URI.isUri(l)?l:M.URI.file(l)}addNodeToCache(l,E){this.elements.set(E.item.handle,l),this.nodes.set(l,E)}updateNodeCache(l,E,i,h){this.elements.delete(E.item.handle),this.nodes.delete(l),E.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(l,E);const r=this.getChildrenNodes(h)||[],n=r.filter(s=>s.item.handle===i.item.handle)[0];n&&r.splice(r.indexOf(n),1,E)}addNodeToParentCache(l,E){E?(E.children||(E.children=[]),E.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const E=this.nodes.get(l);if(E){if(E.children)for(const i of E.children){const h=this.elements.get(i.item.handle);h&&this.clear(h)}E.children=void 0}}else this.clearAll()}clear(l){const E=this.nodes.get(l);if(E){if(E.children)for(const i of E.children){const h=this.elements.get(i.item.handle);h&&this.clear(h)}this.nodes.delete(l),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(ye[236],De([1,0,20,11,5,29,2,122,246,111,120,39,4,95,190,189,36,191,32,193,194,195,174,196,50,33,198,199,202,204,206,100,177,210,211,212,69,53,214,235,8,6,217,54,99,31,163,201,85,96,102,104,105,15,46,13,28,207,161,63,67,187,215,70,52,220,218,219,188,35,213,216,68,51,86,208,101,209,12,81,176,159,200,7,24,165,9,98]),function(ie,e,a,v,b,M,y,P,w,T,R,S,m,I,f,d,u,o,g,A,l,E,i,h,r,n,s,t,c,_,p,k,U,V,x,D,L,B,F,K,H,O,ee,ce,oe,le,te,Ee,be,ne,ve,Pe,Fe,xe,Qe,Ie,Se,Te,ae,ue,X,Y,C,z,W,j,se,de,Z,pe,ge,Ne,Be,Je,Ge,ke,rt,G,Q,fe,Ue,He,Ze,qe,We,nt,ot,ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function kt(it){const ut=it.get(Se.IExtHostInitDataService),Rt=it.get(pe.IExtHostFileSystemInfo),$t=it.get(W.IExtHostConsumerFileSystem),yt=it.get(n.IExtHostExtensionService),ft=it.get(le.IExtHostWorkspace),Dt=it.get(Ge.IExtHostTelemetry),Mt=it.get(g.IExtHostConfiguration),Ot=it.get(Qe.IURITransformerService),Ve=it.get(Ie.IExtHostRpcService),Ft=it.get(L.IExtHostStorage),Pt=it.get(z.IExtensionStoragePaths),Ut=it.get(xe.ILoggerService),vt=it.get(xe.ILogService),we=it.get(ue.IExtHostTunnelService),Ce=it.get(ht.IExtHostTelemetryLogService),me=it.get(X.IExtHostApiDeprecationService),q=it.get(oe.IExtHostWindow),Ae=it.get(Be.IExtHostSecretState),Le=it.get(Je.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,Rt),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ve.set(m.ExtHostContext.ExtHostWorkspace,ft),Ve.set(m.ExtHostContext.ExtHostConfiguration,Mt),Ve.set(m.ExtHostContext.ExtHostExtensionService,yt),Ve.set(m.ExtHostContext.ExtHostStorage,Ft),Ve.set(m.ExtHostContext.ExtHostTunnelService,we),Ve.set(m.ExtHostContext.ExtHostWindow,q),Ve.set(m.ExtHostContext.ExtHostSecretState,Ae),Ve.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ve.set(m.ExtHostContext.ExtHostEditorTabs,Le);const tt=Ve.set(m.ExtHostContext.ExtHostDecorations,it.get(ne.IExtHostDecorations)),Xe=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,it.get(r.IExtHostDocumentsAndEditors)),je=Ve.set(m.ExtHostContext.ExtHostCommands,it.get(u.IExtHostCommands)),ct=Ve.set(m.ExtHostContext.ExtHostTerminalService,it.get(B.IExtHostTerminalService)),gt=Ve.set(m.ExtHostContext.ExtHostDebugService,it.get(Pe.IExtHostDebugService)),St=Ve.set(m.ExtHostContext.ExtHostSearch,it.get(Fe.IExtHostSearch)),pt=Ve.set(m.ExtHostContext.ExtHostTask,it.get(ve.IExtHostTask)),_t=Ve.set(m.ExtHostContext.ExtHostOutputService,it.get(k.IExtHostOutputService)),Tt=Ve.set(m.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(Ve)),mt=Ve.set(m.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Ve,Xe)),Qt=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new E.ExtHostDocumentContentProvider(Ve,Xe,vt)),Yt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(vt,mt,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),bt=Ve.set(m.ExtHostContext.ExtHostNotebook,new Te.ExtHostNotebookController(Ve,je,Xe,mt,Pt)),Wt=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(bt)),Bt=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(vt,bt)),si=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(Ve,ut,bt,je,vt)),Ti=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(Ve,bt)),Ct=Ve.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ve,Xe)),qt=Ve.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),je,vt)),mi=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),Ct,ut.remote)),Jt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new A.ExtHostDiagnostics(Ve,vt,Rt)),Zt=Ve.set(m.ExtHostContext.ExtHostLanguages,new _.ExtHostLanguages(Ve,mt,je.converter,Ot)),lt=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ve,Ot,mt,je,Jt,vt,me)),gi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ve,lt)),zt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ve,vt,Xe)),Kt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(Ve,ft,je)),oi=Ve.set(m.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Ve,je,vt)),Pi=Ve.set(m.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ve,je,mt)),yi=Ve.set(m.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),pi=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(Ve)),ai=Ve.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ve)),ei=Ve.set(m.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Ve)),vi=Ve.set(m.ExtHostContext.ExtHostTimeline,new C.ExtHostTimeline(Ve,je)),Ei=Ve.set(m.ExtHostContext.ExtHostWebviews,new ce.ExtHostWebviews(Ve,ut.remote,ft,vt,me)),ti=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new de.ExtHostWebviewPanels(Ve,Ei,ft)),bi=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(Ve,mt,Pt,Ei,ti)),Ai=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(Ve,Ei)),ii=Ve.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Ve,je)),Ri=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(Ve,bt,Xe,je,vt));const Oi=Object.values(m.ExtHostContext);Ve.assertRegistered(Oi);const Fi=new Z.ExtHostBulkEdits(Ve,Xe),Ni=new d.ExtHostClipboard(Ve),ni=new p.ExtHostMessageService(Ve,vt),li=new l.ExtHostDialogs(Ve),Di=new D.ExtHostStatusBar(Ve,je.converter);return f.ExtHostApiCommands.register(je),function(Me,Ht,ri){const Et=function(){let re=!Me.isUnderDevelopment;function he(){re||(vt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),Mi={getSession(re,he,Re){return ei.getSession(Me,re,he,Re)},async hasSession(re,he){return(0,We.checkProposedApiEnabled)(Me,"authSession"),!!await ei.getSession(Me,re,he,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,st){return ei.registerAuthenticationProvider(re,he,Re,st)}},Li={registerCommand(re,he,Re){return je.registerCommand(!0,re,he,Re,void 0,Me)},registerTextEditorCommand(re,he,Re){return je.registerCommand(!0,re,(...st)=>{const wt=Ct.getActiveTextEditor();if(!wt){vt.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(It=>{he.apply(Re,[wt,It,...st])}).then(It=>{It||vt.warn("Edits from command "+re+" were not applied.")},It=>{vt.warn("An error occurred while running command "+re,It)})},void 0,void 0,Me)},registerDiffInformationCommand:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"diffCommand"),je.registerCommand(!0,re,async(...st)=>{const wt=Xe.activeEditor(!0);if(!wt){vt.warn("Cannot execute "+re+" because there is no active text editor.");return}const It=await Ct.getDiffInformation(wt.id);he.apply(Re,[It,...st])},void 0,void 0,Me)),executeCommand(re,...he){return je.executeCommand(re,...he)},getCommands(re=!1){return je.getCommands(re)}},Ci={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Ni.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const re=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,he){return q.openUri(re,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ut.environment.appUriScheme)return Tt.createAppUri(re);try{return await q.asExternalUri(re,{allowTunneling:!!ut.remote.authority})}catch(he){if((0,fe.matchesScheme)(re,Q.Schemas.http)||(0,fe.matchesScheme)(re,Q.Schemas.https))return re;throw he}},get remoteName(){return(0,be.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(Ci);const wi={createTestController(re,he,Re){return ii.createTestController(re,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ii.createTestObserver()},runTests(re){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ii.runTests(re)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ii.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ii.results}},ci=ut.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Vt={getExtension(re,he){(0,ot.equalsIgnoreCase)(re,"ms-vscode.references-view")&&(me.report("The extension 'ms-vscode.references-view' has been renamed.",Me,"Use 'vscode.references-view' instead."),re="vscode.references-view"),(0,We.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Ht.mine.getExtensionDescription(re);if(Re)return new n.Extension(yt,Me.identifier,Re,ci,!1);if(he){const st=Ht.all.getExtensionDescription(re);if(st)return new n.Extension(yt,Me.identifier,st,ci,!0)}},get all(){const re=[];for(const he of Ht.mine.getAllExtensionDescriptions())re.push(new n.Extension(yt,Me.identifier,he,ci,!1));return re},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Me,"extensionsAny");const re=new We.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Ht.all.getAllExtensionDescriptions()){const st=!re.has(Re.identifier);he.push(new n.Extension(yt,Me.identifier,Re,ci,st))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Me,"extensionsAny")?b.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},ui={createDiagnosticCollection(re){return Jt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:re=>Jt.getDiagnostics(re),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(re,he){return Zt.changeLanguage(re.uri,he)},match(re,he){const Re=mt.getDocumentData(he.uri)?.notebook;return(0,R.score)(H.LanguageSelector.from(re),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,he,Re){return lt.registerCodeActionProvider(Me,Et(re),he,Re)},registerDocumentPasteEditProvider(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"documentPaste"),lt.registerDocumentPasteEditProvider(Me,Et(re),he,Re)},registerCodeLensProvider(re,he){return lt.registerCodeLensProvider(Me,Et(re),he)},registerDefinitionProvider(re,he){return lt.registerDefinitionProvider(Me,Et(re),he)},registerDeclarationProvider(re,he){return lt.registerDeclarationProvider(Me,Et(re),he)},registerImplementationProvider(re,he){return lt.registerImplementationProvider(Me,Et(re),he)},registerTypeDefinitionProvider(re,he){return lt.registerTypeDefinitionProvider(Me,Et(re),he)},registerHoverProvider(re,he){return lt.registerHoverProvider(Me,Et(re),he,Me.identifier)},registerEvaluatableExpressionProvider(re,he){return lt.registerEvaluatableExpressionProvider(Me,Et(re),he,Me.identifier)},registerInlineValuesProvider(re,he){return lt.registerInlineValuesProvider(Me,Et(re),he,Me.identifier)},registerDocumentHighlightProvider(re,he){return lt.registerDocumentHighlightProvider(Me,Et(re),he)},registerLinkedEditingRangeProvider(re,he){return lt.registerLinkedEditingRangeProvider(Me,Et(re),he)},registerReferenceProvider(re,he){return lt.registerReferenceProvider(Me,Et(re),he)},registerRenameProvider(re,he){return lt.registerRenameProvider(Me,Et(re),he)},registerDocumentSymbolProvider(re,he,Re){return lt.registerDocumentSymbolProvider(Me,Et(re),he,Re)},registerWorkspaceSymbolProvider(re){return lt.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,he){return lt.registerDocumentFormattingEditProvider(Me,Et(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return lt.registerDocumentRangeFormattingEditProvider(Me,Et(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...st){return lt.registerOnTypeFormattingEditProvider(Me,Et(re),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(re,he,Re){return lt.registerDocumentSemanticTokensProvider(Me,Et(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return lt.registerDocumentRangeSemanticTokensProvider(Me,Et(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...st){return typeof Re=="object"?lt.registerSignatureHelpProvider(Me,Et(re),he,Re):lt.registerSignatureHelpProvider(Me,Et(re),he,typeof Re>"u"?[]:[Re,...st])},registerCompletionItemProvider(re,he,...Re){return lt.registerCompletionItemProvider(Me,Et(re),he,Re)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Me,Et(re),he)},registerInlineCompletionItemProviderNew(re,he){if((0,We.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,We.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return lt.registerInlineCompletionsProviderNew(Me,Et(re),he)},registerDocumentLinkProvider(re,he){return lt.registerDocumentLinkProvider(Me,Et(re),he)},registerColorProvider(re,he){return lt.registerColorProvider(Me,Et(re),he)},registerFoldingRangeProvider(re,he){return lt.registerFoldingRangeProvider(Me,Et(re),he)},registerSelectionRangeProvider(re,he){return lt.registerSelectionRangeProvider(Me,re,he)},registerCallHierarchyProvider(re,he){return lt.registerCallHierarchyProvider(Me,re,he)},registerTypeHierarchyProvider(re,he){return lt.registerTypeHierarchyProvider(Me,re,he)},setLanguageConfiguration:(re,he)=>lt.setLanguageConfiguration(Me,re,he),getTokenInformationAtPosition(re,he){return(0,We.checkProposedApiEnabled)(Me,"tokenInformation"),Zt.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return lt.registerInlayHintsProvider(Me,re,he)},createLanguageStatusItem(re,he){return Zt.createLanguageStatusItem(Me,re,he)},registerDocumentDropEditProvider(re,he){return lt.registerDocumentOnDropEditProvider(Me,re,he)}},Ui={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(re,he,Re){const st=await(y.URI.isUri(re)?Promise.resolve(Nt.openTextDocument(re)):Promise.resolve(re));return Ct.showTextDocument(st,he,Re)},createTextEditorDecorationType(re){return Ct.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,he,Re){return Ct.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return Ct.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return Ct.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return Ct.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return Ct.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return Ct.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return ct.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return ct.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return ct.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDimensions"),ct.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return ct.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ct.onDidWriteTerminalData(re,he,Re)},get state(){return q.state},onDidChangeWindowState(re,he,Re){return q.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return ni.showMessage(Me,M.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return ni.showMessage(Me,M.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return ni.showMessage(Me,M.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Kt.showQuickPick(re,he,Re)},showWorkspaceFolderPick(re){return Kt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Kt.showInput(re,he)},showOpenDialog(re){return li.showOpenDialog(re)},showSaveDialog(re){return li.showSaveDialog(re)},createStatusBarItem(re,he,Re){let st,wt,It;return typeof re=="string"?(st=re,wt=he,It=Re):(wt=re,It=he),Di.createStatusBarEntry(Me,st,wt,It)},setStatusBarMessage(re,he){return Di.setStatusBarMessage(re,he)},withScmProgress(re){return me.report("window.withScmProgress",Me,"Use 'withProgress' instead."),yi.withProgress(Me,{location:O.ProgressLocation.SourceControl},(he,Re)=>re({report(st){}}))},withProgress(re,he){return yi.withProgress(Me,re,he)},createOutputChannel(re,he){return _t.createOutputChannel(re,he,Me)},createWebviewPanel(re,he,Re,st){return ti.createWebviewPanel(Me,re,he,Re,st)},createWebviewTextEditorInset(re,he,Re,st){return(0,We.checkProposedApiEnabled)(Me,"editorInsets"),mi.createWebviewEditorInset(re,he,Re,st,Me)},createTerminal(re,he,Re){return typeof re=="object"?"pty"in re?ct.createExtensionTerminal(re):ct.createTerminalFromOptions(re):ct.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return ct.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return ct.registerProfileProvider(Me,re,he)},registerTreeDataProvider(re,he){return qt.registerTreeDataProvider(re,he,Me)},createTreeView(re,he){return qt.createTreeView(re,he,Me)},registerWebviewPanelSerializer:(re,he)=>ti.registerWebviewPanelSerializer(Me,re,he),registerCustomEditorProvider:(re,he,Re={})=>bi.registerCustomEditorProvider(Me,re,he,Re),registerFileDecorationProvider(re){return tt.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return Tt.registerUriHandler(Me.identifier,re)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return ai.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return ai.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return Ai.registerWebviewViewProvider(Me,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return bt.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return Bt.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return Bt.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return y.URI.isUri(re)&&me.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"externalUriOpener"),Ri.registerExternalUriOpener(Me.identifier,re,he,Re)},get tabGroups(){return Le.tabGroups},logTelemetryToOutputChannel(re,he){(0,We.checkProposedApiEnabled)(Me,"telemetryLog"),Ce.logToTelemetryOutputChannel(Me,re,he)}},Nt={get rootPath(){return me.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw v.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw v.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw v.readonly()},updateWorkspaceFolders:(re,he,...Re)=>ft.updateWorkspaceFolders(Me,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return ft.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>ft.getRelativePath(re,he),findFiles:(re,he,Re,st)=>ft.findFiles(re,he,Re,Me.identifier,st),findTextInFiles:(re,he,Re,st)=>{(0,We.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,It;return typeof he=="object"?(wt=he,It=Re):(wt={},It=he,st=Re),ft.findTextInFiles(re,wt||{},It,Me.identifier,st)},saveAll:re=>ft.saveAll(re),applyEdit(re){return Fi.applyWorkspaceEdit(re,Me)},createFileSystemWatcher:(re,he,Re,st)=>zt.createFileSystemWatcher(ft,Me,re,he,Re,st),get textDocuments(){return mt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw v.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(y.URI.file(re));else if(y.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=mt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>mt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Re)=>mt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>mt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>mt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>mt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>Yt.getOnWillSaveTextDocumentEvent(Me)(re,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(y.URI.isUri(re))Re=re,await bt.openNotebookDocument(re);else if(typeof re=="string")Re=y.URI.revive(await bt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,he,Re){return Wt.onDidSaveNotebookDocument(re,he,Re)},onDidChangeNotebookDocument(re,he,Re){return Wt.onDidChangeNotebookDocument(re,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,st){return bt.registerNotebookSerializer(Me,re,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},registerNotebookContentProvider:(re,he,Re,st)=>((0,We.checkProposedApiEnabled)(Me,"notebookContentProvider"),me.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Me,re,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)),onDidChangeConfiguration:(re,he,Re)=>ri.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,ri.getConfiguration(re,he,Me)},registerTextDocumentContentProvider(re,he){return Qt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(me.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Me,re,he)),registerFileSystemProvider(re,he,Re){return(0,qe.combinedDisposable)(gi.registerFileSystemProvider(Me,re,he,Re),$t.addFileSystemProvider(re,he))},get fs(){return $t.value},registerFileSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"fileSearchProvider"),St.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"textSearchProvider"),St.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),yt.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),pi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>zt.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>zt.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>zt.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>zt.getOnWillCreateFileEvent(Me)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>zt.getOnWillDeleteFileEvent(Me)(re,he,Re),onWillRenameFiles:(re,he,Re)=>zt.getOnWillRenameFileEvent(Me)(re,he,Re),openTunnel:re=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),we.openTunnel(Me,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),we.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),we.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"portsAttributes"),we.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"timeline"),vi.registerTimelineProvider(re,he,Me.identifier,je.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,We.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>ft.onDidGrantWorkspaceTrust(re,he,Re),registerEditSessionIdentityProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(re,he))},di={get inputBox(){return me.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Me)},createSourceControl(re,he,Re){return oi.createSourceControl(Me,re,he,Re)}},Bi={createCommentController(re,he){return Pi.createCommentController(Me,re,he)}},zi={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},onDidStartDebugSession(re,he,Re){return gt.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return gt.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return gt.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return gt.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return gt.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return gt.registerDebugConfigurationProvider(re,he,Re||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return gt.registerDebugAdapterDescriptorFactory(Me,re,he)},registerDebugAdapterTrackerFactory(re,he){return gt.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?gt.startDebugging(re,he,{parentSession:Re}):gt.startDebugging(re,he,Re||{})},stopDebugging(re){return gt.stopDebugging(re)},addBreakpoints(re){return gt.addBreakpoints(re)},removeBreakpoints(re){return gt.removeBreakpoints(re)},asDebugSourceUri(re,he){return gt.asDebugSourceUri(re,he)}},xi={registerTaskProvider:(re,he)=>pt.registerTaskProvider(Me,re,he),fetchTasks:re=>pt.fetchTasks(re),executeTask:re=>pt.executeTask(Me,re),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(re,he,Re)=>pt.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>pt.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>pt.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>pt.onDidEndTaskProcess(re,he,Re)},$i={createNotebookController(re,he,Re,st,wt){return si.createNotebookController(Me,re,he,Re,st,(0,We.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>bt.registerNotebookCellStatusBarItemProvider(Me,re,he),createRendererMessaging(re){return Ti.createRendererMessaging(Me,re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(re,he,Re)}};return{version:ut.version,authentication:Mi,commands:Li,comments:Bi,debug:zi,env:Ci,extensions:Vt,languages:ui,notebooks:$i,scm:di,tasks:xi,tests:wi,window:Ui,workspace:Nt,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:v.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:O.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionItemNew:O.InlineSuggestionNew,InlineCompletionList:O.InlineSuggestionList,InlineCompletionListNew:O.InlineSuggestionsNew,Hover:O.Hover,IndentAction:T.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:I.UIKind,Uri:y.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,DocumentDropEdit:O.DocumentDropEdit,DocumentPasteEdit:O.DocumentPasteEdit,InlayHint:O.InlayHint,InlayHintLabelPart:O.InlayHintLabelPart,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookEdit:O.NotebookEdit,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:O.DataTransfer,DataTransferItem:O.DataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.TextTabInput,TabInputTextDiff:O.TextDiffTabInput,TabInputTextMerge:O.TextMergeTabInput,TabInputCustom:O.CustomEditorTabInput,TabInputNotebook:O.NotebookEditorTabInput,TabInputNotebookDiff:O.NotebookDiffEditorTabInput,TabInputWebview:O.WebviewEditorTabInput,TabInputTerminal:O.TerminalEditorTabInput,TabInputInteractiveWindow:O.InteractiveWindowInput,TerminalExitReason:O.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=kt}),define(ye[237],De([1,0,236,33,2,230,6,14,221,21]),function(ie,e,a,v,b,M,y,P,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends M.RequireInterceptor{_installInterceptor(){}getModule(f,d){for(const u of this._alternatives){const o=u(f);if(o){f=o;break}}if(this._factories.has(f))return this._factories.get(f).load(f,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class S extends v.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(w.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,d,u){d=d.with({path:m(d.path,".js")});const o=f?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const g=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(d)),A=await fetch(g.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),A.status!==200)throw new Error(A.statusText);const l=await A.text(),E=`${d.toString(!0)}#vscode-extension`,i=`${l}
//# sourceURL=${E}`;let h;try{h=new Function("module","exports","require",i)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${d.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const r=await this.fetchTranslatedStrings(f),n={},s={exports:n},t=c=>{if(c==="vscode-nls-web-data")return r;const _=this._fakeModules.getModule(c,d);if(_===void 0)throw new Error(`Cannot load module '${c}'`);return _};try{return u.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),h(s,n,t),s.exports!==n?s.exports:n}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),u.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+f;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}async fetchTranslatedStrings(f){let d={};if(!f)return{};const u=T.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[T.Language.value()]??f.browserNlsBundleUris?.en;if(f&&u)try{const o=await fetch(u.toString(!0));if(!o.ok)throw new Error(await o.text());d=await o.json()}catch(o){try{console.error(`Failed to load translations for ${f.identifier.value} from ${u}: ${o.message}`);const g=f.browserNlsBundleUris?.en;if(g){const A=await fetch(g.toString(!0));if(!A.ok)throw new Error(await A.text());d=await A.json()}throw new Error("No English strings found")}catch(g){console.error(g)}}return d}}e.ExtHostExtensionService=S;function m(I,f){return I.endsWith(f)?I:I+f}}),define(ye[238],De([1,0,57,33,70,237]),function(ie,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(v.IExtHostExtensionService,M.ExtHostExtensionService,!1),(0,a.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths,!1)}),define(ye[247],De([1,0,23,5,95,231,223,19,71,12,2,233,238]),function(ie,e,a,v,b,M,y,P,w,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function I(i){return/^(file|vscode-remote):/i.test(i)}const f=fetch.bind(self);function d(i){self.fetch=async function(h,r){return h instanceof Request||I(String(h))&&(h=(await i(R.URI.parse(String(h)))).toString(!0)),f(h,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,r,n,s,t){(async()=>(I(r.toString())&&(r=(await i(R.URI.parse(r.toString()))).toString(!0)),super.open(h,r,n??!0,s,t)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(h,r){if(/^file:/i.test(h.toString()))h=T.FileAccess.asBrowserUri(R.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(p){function k(x){return typeof x=="string"||x instanceof URL?String(x).replace(/^file:\/\//i,"vscode-file://vscode-app"):x}const U=fetch.bind(self);self.fetch=function(x,D){return x instanceof Request?U(x,D):U(k(x),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(x,D,L,B,F){return super.open(x,k(D),L??!0,B,F)}};const V=importScripts.bind(self);self.importScripts=(...x)=>{V(...x.map(k))},V(p)}.toString()}('${h}'))`;r=r||{},r.name=r.name||P.basename(h.toString());const t=new Blob([s],{type:"application/javascript"}),c=URL.createObjectURL(t);return new i(c,r)}}else self.Worker=class extends y.NestedWorker{constructor(i,h){super(m,i,{name:P.basename(i.toString()),...h})}};const u=new class{constructor(){this.pid=void 0}exit(i){S()}async exists(i){return!0}async realpath(i){return i}};class o{constructor(){const h=new MessageChannel,r=new v.Emitter;let n=!1;m(h.port2,[h.port2]),h.port1.onmessage=s=>{const{data:t}=s;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const c=a.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(c,2)){n=!0,A("received terminate message from renderer");return}r.fire(c)},this.protocol={onMessage:r.event,send:s=>{if(!n){const t=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);h.port1.postMessage(t,[t])}}}}}function g(i){return new Promise(h=>{const r=i.onMessage(n=>{r.dispose();const s=JSON.parse(n.toString());i.send((0,b.createMessageOfType)(0)),h({protocol:i,initData:s})});i.send((0,b.createMessageOfType)(1))})}let A=i=>S();function l(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function E(){w.mark("code/extHost/willConnectToRenderer");const i=new o;return{onmessage(h){!l(h)||g(i.protocol).then(r=>{w.mark("code/extHost/didWaitForInitData");const n=new M.ExtensionHostMain(r.protocol,r.initData,u,null,h.data);d(s=>n.asBrowserUri(s)),A=s=>n.terminate(s)})}}}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/eec059902f85f5031b4ebd8ba90f9602076be512/core/vs/workbench/api/worker/extensionHostWorker.js.map
